# This file was automatically generated by SWIG (http://www.swig.org).
# Version 4.0.2
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.

"""

PyTrilinos.Amesos is the python interface to the Trilinos direct
linear solver package Amesos:

    https://trilinos.org/docs/dev/packages/amesos/doc/html/index.html

The purpose of Amesos is to provide a common interface to a variety of
third-party direct solvers, made compatible with PyTrilinos.Epetra.
Note that the C++ version of Amesos uses the prefix 'Amesos_', which
has been stripped from the python implementation.

The most important classes of the Amesos module are:

    * Factory      - Factory class
    * Lapack       - LAPACK interface
    * Klu          - KLU interface
    * Umfpack      - UMFPACK interface
    * Scalapack    - SCALAPACK interface
    * Superlu      - SuperLU interface
    * Superludist  - SuperLU_DIST interface
    * Dscpack      - DSCPACK interface
    * Mumps        - MUMPS interface

Use dir(Amesos) to see what specific interfaces have been enabled on
your platform.  For examples of usage, please consult the examples
subdirectory of the PyTrilinos package, scripts exAmesos_Simple.py and
exAmesos_Factory.py.

"""

from sys import version_info as _swig_python_version_info
if _swig_python_version_info < (2, 7, 0):
    raise RuntimeError("Python 2.7 or later required")

# Import the low-level C/C++ module
if __package__ or "." in __name__:
    from . import _Amesos
else:
    import _Amesos

try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)


def _swig_setattr_nondynamic_instance_variable(set):
    def set_instance_attr(self, name, value):
        if name == "thisown":
            self.this.own(value)
        elif name == "this":
            set(self, name, value)
        elif hasattr(self, name) and isinstance(getattr(type(self), name), property):
            set(self, name, value)
        else:
            raise AttributeError("You cannot add instance attributes to %s" % self)
    return set_instance_attr


def _swig_setattr_nondynamic_class_variable(set):
    def set_class_attr(cls, name, value):
        if hasattr(cls, name) and not isinstance(getattr(cls, name), property):
            set(cls, name, value)
        else:
            raise AttributeError("You cannot add class attributes to %s" % cls)
    return set_class_attr


def _swig_add_metaclass(metaclass):
    """Class decorator for adding a metaclass to a SWIG wrapped class - a slimmed down version of six.add_metaclass"""
    def wrapper(cls):
        return metaclass(cls.__name__, cls.__bases__, cls.__dict__.copy())
    return wrapper


class _SwigNonDynamicMeta(type):
    """Meta class to enforce nondynamic attributes (no new attributes) for a class"""
    __setattr__ = _swig_setattr_nondynamic_class_variable(type.__setattr__)


import weakref

class SwigPyIterator(object):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Amesos.delete_SwigPyIterator

    def value(self) -> "PyObject *":
        return _Amesos.SwigPyIterator_value(self)

    def incr(self, n: "size_t"=1) -> "swig::SwigPyIterator *":
        return _Amesos.SwigPyIterator_incr(self, n)

    def decr(self, n: "size_t"=1) -> "swig::SwigPyIterator *":
        return _Amesos.SwigPyIterator_decr(self, n)

    def distance(self, x: "SwigPyIterator") -> "ptrdiff_t":
        return _Amesos.SwigPyIterator_distance(self, x)

    def equal(self, x: "SwigPyIterator") -> "bool":
        return _Amesos.SwigPyIterator_equal(self, x)

    def copy(self) -> "swig::SwigPyIterator *":
        return _Amesos.SwigPyIterator_copy(self)

    def next(self) -> "PyObject *":
        return _Amesos.SwigPyIterator_next(self)

    def __next__(self) -> "PyObject *":
        return _Amesos.SwigPyIterator___next__(self)

    def previous(self) -> "PyObject *":
        return _Amesos.SwigPyIterator_previous(self)

    def advance(self, n: "ptrdiff_t") -> "swig::SwigPyIterator *":
        return _Amesos.SwigPyIterator_advance(self, n)

    def __eq__(self, x: "SwigPyIterator") -> "bool":
        return _Amesos.SwigPyIterator___eq__(self, x)

    def __ne__(self, x: "SwigPyIterator") -> "bool":
        return _Amesos.SwigPyIterator___ne__(self, x)

    def __iadd__(self, n: "ptrdiff_t") -> "swig::SwigPyIterator &":
        return _Amesos.SwigPyIterator___iadd__(self, n)

    def __isub__(self, n: "ptrdiff_t") -> "swig::SwigPyIterator &":
        return _Amesos.SwigPyIterator___isub__(self, n)

    def __add__(self, n: "ptrdiff_t") -> "swig::SwigPyIterator *":
        return _Amesos.SwigPyIterator___add__(self, n)

    def __sub__(self, *args) -> "ptrdiff_t":
        return _Amesos.SwigPyIterator___sub__(self, *args)
    def __iter__(self):
        return self

# Register SwigPyIterator in _Amesos:
_Amesos.SwigPyIterator_swigregister(SwigPyIterator)

from . import Teuchos
from .Teuchos import Base
from . import Epetra
class Factory(object):
    r"""
     Factory for binding a third party direct solver to an
    Epetra_LinearProblem.

    Amesos creates an instance of a solver, binding a third party direct solver
    to an Epetra_LinearProblem, allowing access to the specified third party
    solver through the Amesos interface (i.e. Numeric Factorization
    SymbolicFactrozation(), Solve() and support functions.)
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def Create(self, *args) -> "Amesos_BaseSolver *":
        r"""
        *Overload 1:*
         Amesos Create method.

        Creates an instance of the Amesos_BaseSolver class specified by
        ClassType.


         \Preconditions:
        * ClassType must be one of the recognized class types.
        Return 0 on failure.
        * ClassType must specify a third party solver that has been
        linked with this particular implementation.  Return 0 on failure.
        * Epetra_LinearProblem may be empty.  Although the linear problem is
        not checked at the time of construction, the operator must be an
        Epetra_RowMatrix, or derived from an Epetra_RowMatrix.



         \Postconditions:
        * If Create() returns a non-null pointer, that pointer points to an
        Amesos solver.


        |

        *Overload 2:*
         Creation method for string input.
        """
        return _Amesos.Factory_Create(self, *args)

    def Query(self, *args) -> "bool":
        r"""
        *Overload 1:*
        Queries whether a given interface is available or not.

        |

        *Overload 2:*
        Queries whether a given interface is available or not.
        """
        return _Amesos.Factory_Query(self, *args)

    @staticmethod
    def GetValidParameters(*args) -> "Teuchos::ParameterList":
        r""" Get the list of valid parameters."""
        return _Amesos.Factory_GetValidParameters(*args)

    def __init__(self, *args):
        _Amesos.Factory_swiginit(self, _Amesos.new_Factory(*args))
    __swig_destroy__ = _Amesos.delete_Factory

# Register Factory in _Amesos:
_Amesos.Factory_swigregister(Factory)

def Factory_GetValidParameters(*args) -> "Teuchos::ParameterList":
    r""" Get the list of valid parameters."""
    return _Amesos.Factory_GetValidParameters(*args)

class BaseSolver(Teuchos.Base.ParameterListAcceptor):
    r"""
     Amesos_BaseSolver: A pure virtual class for direct solution of real-valued double-precision operators.

    The Amesos_BaseSolver class is a pure virtual class (that is, it specifies
    interface only) that enables the use of real-valued
    double-precision direct sparse solvers.  Every Amesos class named
    Amesos_*SolverName* derives from Amesos_BaseSolver.

    # Usage Examples

    ## Basic calling sequence The basic
    calling sequence solves A x = b or A T x = b without
    specifying how A has changed between each call to Solve().

    .. code-block:: c++

            Epetra_LinearProblem Problem(A,X,B);
            Amesos_SolverName Solver(Problem);
            Problem.SetUseTranspose(false);
            while( ... ) {

              <Here code which may change A or B>

              Solver.SymbolicFactorization();
              Solver.NumericFactorization();
              Solver.Solve();
            }


    ## Re-using the symbolic factorization The following
    calling sequence performs multiple solves of A x = b or A T x = b
    in cases where the non-zero structure of A remains unchanged
    between each call to Solve().

    .. code-block:: c++

            Epetra_LinearProblem Problem(A,X,B);
            Amesos_SolverName Solver(Problem);
            Problem.SetUseTranspose(false);
            Solver.SymbolicFactorization();
            while( ... ) {

              <Here code which may change B or the non-zero values
              (but not the non-zero structure) of A>

              Solver.NumericFactorization() ;
              Solver.Solve() ;
            }



    ## Re-using the numeric factorization The following
    calling sequence performs multiple solves of A x = b or A T x = b
    provided that A remains unchanged between each call to Solve().

    .. code-block:: c++

            Epetra_LinearProblem Problem(A,X,B);
            Amesos_SolverName Solver(Problem);
            Problem.SetUseTranspose( false );
            Solver.NumericFactorization();
            while( ... ) {

              <Here code which may change B but not A>

              Solver.Solve();
            }


    ## Constructor requirements
     Every Amesos_SolverName class should accept an Epetra_LinearProblem


    ## Mathematical methods Four mathematical methods are
    defined in the base class Amesos_BaseSolver:
    SymbolicFactorization(), NumericFactorization(),
    and Solve().


    ## Switching concrete classes
    Different concrete
    classes, each based on a different third party solver, will have
    different performance characteristics and will accept different
    parameters.


    ## Changing the values of the underlying matrix operator.


    Any changes to the values of a matrix must be accompanied by a call to
    NumericFactorization() before the next call to Solve() or the behavior
    of Solve() is undefined.  Any changes to the numerical structure of
    the matrix must be followed by a call to SymbolicFactorization() and
    NumericalFactorization() before the next call to Solve().


    Once SymbolicFactorization() has been called, classes implementing
    this interface may assume that any change made to the non-zero
    structure of the underlying matrix will be accompanied by a call
    to SymbolicFactorization() prior to a subsequent call to
    NumericFactorization or Solve().


    ## Named Parameters

    Parameters can be changed or added at any time by calling
    SetParameters(ParamList) with the new parameters specified in ParamList.


    It is left to the user to be sure that changes made to the
    parameters are appropriate for the concrete class that they are
    using.

    Examples of appropriate changes in parameters include:

    * **Changing iterative refinement rules between calls to Solve()**
    * **Changing drop tolerance rules between calls to NumericFactorization()**


    Examples of inappropriate changes in parameters include:
    * **Changing drop tolerance rules between solve steps.**
     Solver.NumericFactorization();
    Solver.getList()->set("DropTolerance",.001);
    Solver.Solve();   Results of making inappropriate
    changes in parameters is unpredictable and could include an error
    return, a bogus result or ignoring the parameter change.

    ## Transpose solve Any class implementing Amesos_BaseSolver
    should handle calls to SetUseTranspose() at any point.  However, the
    result of a call to SetUseTranspose() which is not followed by a call
    to SymbolicFactorization() and NumericFactorization() is
    implementation dependent.  Some third party libraries are able to
    solve A T x = b and Ax = b using the same factorization.
    Others will require a new factorization anytime that a call to
    SetUseTranspose() changes the intended solve from A T x = b
    to Ax = b or vice-versa.


    # Performance expectations

    The following is a list of performance guidelines that classes
    which implement the Amesos_BaseSolver class are expected to maintain.


    # Memory usage:
    For serial codes, no more than one extra copy of the original matrix
    should be required.  Except that some codes require matrix transpostion
    which requires additional copies of the input matrix.

    For distributed memory codes, no serial copies of the original matrix
    should be required.


    # Robustness requirements


    Failures should be caught by AMESOS_CHK_ERR().
       The following error codes should be used:
         - 1: Singular matrix
         - 2: Non-symmetric matrix
         - 3: Matrix is not positive definite
         - 4: Insufficient memory


    Because we do not check to see if a matrix has changed
    between the call to SymbolicFactorization() and the call to
    NumericFactorization(), it is possible that a change to the
    matrix will cause a potentially catastrophic error.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr

    def getParameterList(self, *args) -> "Teuchos::RCP< Teuchos::ParameterList const >":
        r"""
         Get const version of the parameter list that was set
           using setParameterList().

        The default implementation returns:

           .. code-block:: c++

               return const_cast<ParameterListAcceptor*>(this)->getParameterList();
        """
        return _Amesos.BaseSolver_getParameterList(self, *args)
    __swig_destroy__ = _Amesos.delete_BaseSolver

    def SymbolicFactorization(self, *args) -> "int":
        r"""
        Performs SymbolicFactorization on the matrix A.
             In addition to performing symbolic factorization on the matrix A,
             the call to SymbolicFactorization() implies that no change will
             be made to the non-zero structure of the underlying matrix without
             a subsequent call to SymbolicFactorization().


        \Preconditions:
             * GetProblem().GetOperator() != 0 (return -1)
             * MatrixShapeOk(GetProblem().GetOperator()) == true (return -6)



        \Postconditions:
             * Symbolic Factorization will be performed (or marked to be performed)
             allowing NumericFactorization() and Solve() to be called.


           :rtype: int
           :return: Integer error code, set to 0 if successful.
        """
        return _Amesos.BaseSolver_SymbolicFactorization(self, *args)

    def NumericFactorization(self, *args) -> "int":
        r"""
        Performs NumericFactorization on the matrix A.  In addition to performing numeric factorization on the
             matrix A, the call to
             NumericFactorization() implies that no change will be made to
             the underlying matrix without a subsequent call to
             NumericFactorization().


        \Preconditions:
             * GetProblem().GetOperator() != 0 (return -1)
             * MatrixShapeOk(GetProblem().GetOperator()) == true (return -6)
             * The non-zero structure of the matrix should not have changed
                 since the last call to SymbolicFactorization().
                 (return -2 if the number of non-zeros changes)
                 Other changes can have arbitrary consequences.
             * The distribution of the matrix should not have changed
                 since the last call to SymbolicFactorization()
             * The matrix should be indexed from 0 to n-1, unless the parameter "Reindex"
                 was set to "true" prior to the call to SymbolicFactorization().
                 (return -3 - if caught)
             * The paremeter "Reindex" should not be set to "true" except on CrsMatrices.
                 (return -4)
             * The paremeter "Reindex" should not be set to "true" unless Amesos was built
                 with EpetraExt, i.e. with --enable-epetraext on the configure line.
                 (return -4)
             * Internal errors retur -5.



        \Postconditions:
             * Numeric Factorization will be performed (or marked to be performed)
             allowing Solve() to be performed correctly despite a potential change in
             in the matrix values (though not in the non-zero structure).


            :rtype: int
            :return: Integer error code, set to 0 if successful.
        """
        return _Amesos.BaseSolver_NumericFactorization(self, *args)

    def Solve(self, *args) -> "int":
        r"""
        Solves A X = B (or A T x = B)


        \Preconditions:
             * GetProblem().GetOperator() != 0 (return -1)
             * MatrixShapeOk(GetProblem().GetOperator()) == true (return -6)
             * GetProblem()->CheckInput (see Epetra_LinearProblem::CheckInput() for return values)
             * The non-zero structure of the matrix should not have changed
                 since the last call to SymbolicFactorization().
             * The distribution of the matrix should not have changed
                 since the last call to SymbolicFactorization()
             * The matrix should not have changed
                 since the last call to NumericFactorization().



        \Postconditions:
             * X will be set such that A X = B (or
             A T X = B), within the limits of the accuracy of the
             underlying solver.


            :rtype: int
            :return: Integer error code, set to 0 if successful.
        """
        return _Amesos.BaseSolver_Solve(self, *args)

    def SetUseTranspose(self, *args) -> "int":
        r"""
        If set true, X will be set to the solution of A T X = B (not A X = B)  If the implementation of this interface does not support
                  transpose use, this method should return a value of -1.


        \Preconditions:
             * SetUseTranspose() should be called prior to the call to SymbolicFactorization() If NumericFactorization() or Solve() is called after SetUseTranspose() without an intervening call to SymbolicFactorization() the result is implementation dependent.



        \Postconditions:
             * The next factorization and solve will be performed with
             the new value of UseTranspose.


           :type UseTranspose: boolean
           :param UseTranspose: -- (In) If true, solve A T X = B, otherwise
           	   solve A X = B.

           :rtype: int
           :return: Integer error code, set to 0 if successful.  Set to -1 if
                      this implementation does not support transpose.
        """
        return _Amesos.BaseSolver_SetUseTranspose(self, *args)

    def UseTranspose(self, *args) -> "bool":
        r""" Returns the current UseTranspose setting."""
        return _Amesos.BaseSolver_UseTranspose(self, *args)

    def SetParameters(self, *args) -> "int":
        r"""
          Updates internal variables.

         \Preconditions:
              * None.



         \Postconditions:
              * Internal variables controlling the factorization and solve will
              be updated and take effect on all subseuent calls to NumericFactorization()
              and Solve().
              * All parameters whose value are to differ from the default values must
        be included in ParameterList.  Parameters not specified in ParameterList
        revert to their default values.


            :rtype: int
            :return: Integer error code, set to 0 if successful.
        """
        return _Amesos.BaseSolver_SetParameters(self, *args)

    def GetProblem(self, *args) -> "Epetra_LinearProblem const *":
        r"""
         Returns the Epetra_LinearProblem.

        **Warning!** Do not call return->SetOperator(...) to attempt
        to change the Epetra_Operator object (even if the new matrix has
        the same structure).  This new operator matrix will be ignored!
        """
        return _Amesos.BaseSolver_GetProblem(self, *args)

    def MatrixShapeOK(self, *args) -> "bool":
        r"""
        Returns true if the solver can handle this matrix shape  Returns true if the matrix shape is one that the underlying
           sparse direct solver can handle. Classes that work only on square
           matrices should return false for rectangular matrices.  Classes
           that work only on symmetric matrices whould return false for
           non-symmetric matrices.
        """
        return _Amesos.BaseSolver_MatrixShapeOK(self, *args)

    def Comm(self, *args) -> "Epetra_Comm const &":
        r""" Returns a pointer to the Epetra_Comm communicator associated with this operator."""
        return _Amesos.BaseSolver_Comm(self, *args)

    def NumSymbolicFact(self, *args) -> "int":
        r""" Returns the number of symbolic factorizations performed by this object."""
        return _Amesos.BaseSolver_NumSymbolicFact(self, *args)

    def NumNumericFact(self, *args) -> "int":
        r""" Returns the number of numeric factorizations performed by this object."""
        return _Amesos.BaseSolver_NumNumericFact(self, *args)

    def NumSolve(self, *args) -> "int":
        r""" Returns the number of solves performed by this object."""
        return _Amesos.BaseSolver_NumSolve(self, *args)

    def PrintStatus(self, *args) -> "void":
        r""" Prints status information about the current solver."""
        return _Amesos.BaseSolver_PrintStatus(self, *args)

    def PrintTiming(self, *args) -> "void":
        r""" Prints timing information about the current solver."""
        return _Amesos.BaseSolver_PrintTiming(self, *args)

    def setParameterList(self, *args) -> "void":
        r""" Redefined from Teuchos::ParameterListAcceptor (Does Not Work)"""
        return _Amesos.BaseSolver_setParameterList(self, *args)

    def getNonconstParameterList(self, *args) -> "Teuchos::RCP< Teuchos::ParameterList >":
        r"""  This is an empty stub"""
        return _Amesos.BaseSolver_getNonconstParameterList(self, *args)

    def unsetParameterList(self, *args) -> "Teuchos::RCP< Teuchos::ParameterList >":
        r"""  This is an empty stub"""
        return _Amesos.BaseSolver_unsetParameterList(self, *args)

    def GetTiming(self, *args) -> "void":
        r""" Extracts timing information from the current solver and places it in the parameter list. (Does Not Work)"""
        return _Amesos.BaseSolver_GetTiming(self, *args)

# Register BaseSolver in _Amesos:
_Amesos.BaseSolver_swigregister(BaseSolver)
cvar = _Amesos.cvar
StructurallySingularMatrixError = cvar.StructurallySingularMatrixError
NumericallySingularMatrixError = cvar.NumericallySingularMatrixError

class Lapack(BaseSolver):
    r"""
     Amesos_Lapack: an interface to LAPACK.
    Class Amesos_Lapack enables the solution of the distributed linear
    system, defined by an Epetra_LinearProblem, using LAPACK.

    Amesos_Lapack stores the lineaar system matrix as an
    Epetra_SerialDensMatrix. The linear problem is an Epetra_SerialDenseProblem.
    Amesos_Lapack factorizes the matrix using DGETRF().

    Last updated on 16-Mar-05.

    Author: Marzio Sala, 9214.

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        Amesos_Lapack Constructor. Creates an Amesos_Lapack instance, using an Epetra_LinearProblem,
             passing in an already-defined Epetra_LinearProblem object.

             Note: The operator in LinearProblem must be an
             Epetra_RowMatrix.
        """
        _Amesos.Lapack_swiginit(self, _Amesos.new_Lapack(*args))
    __swig_destroy__ = _Amesos.delete_Lapack

    def SymbolicFactorization(self, *args) -> "int":
        return _Amesos.Lapack_SymbolicFactorization(self, *args)

    def NumericFactorization(self, *args) -> "int":
        return _Amesos.Lapack_NumericFactorization(self, *args)

    def Solve(self, *args) -> "int":
        return _Amesos.Lapack_Solve(self, *args)

    def GetProblem(self, *args) -> "Epetra_LinearProblem const *":
        return _Amesos.Lapack_GetProblem(self, *args)

    def MatrixShapeOK(self, *args) -> "bool":
        return _Amesos.Lapack_MatrixShapeOK(self, *args)

    def SetUseTranspose(self, *args) -> "int":
        return _Amesos.Lapack_SetUseTranspose(self, *args)

    def UseTranspose(self, *args) -> "bool":
        return _Amesos.Lapack_UseTranspose(self, *args)

    def Comm(self, *args) -> "Epetra_Comm const &":
        return _Amesos.Lapack_Comm(self, *args)

    def setParameterList(self, *args) -> "void":
        r"""  Use this parameter list to read values from    Redefined from Teuchos::ParameterListAcceptor"""
        return _Amesos.Lapack_setParameterList(self, *args)

    def unsetParameterList(self, *args) -> "Teuchos::RCP< Teuchos::ParameterList >":
        return _Amesos.Lapack_unsetParameterList(self, *args)

    def SetParameters(self, *args) -> "int":
        r"""  Deprecated - Sets parameters"""
        return _Amesos.Lapack_SetParameters(self, *args)

    def GEEV(self, *args) -> "int":
        r"""
        Computes the eigenvalues of the linear system matrix using DGEEV.
           :type Er: :py:class:`Epetra_Vector`
           :param Er: - (Out) On processor zero only, it will contain the
                                 real component of the eigenvalues.

           :type Ei: :py:class:`Epetra_Vector`
           :param Ei: - (Out) On processor zero only, it will contain the
                                 imaginary component of the eigenvalues.

           Notes: Er and Ei must have been allocated so that the local
           length on processor 0 equals the global size of the matrix.
        """
        return _Amesos.Lapack_GEEV(self, *args)

    def NumSymbolicFact(self, *args) -> "int":
        r""" Returns the number of symbolic factorizations performed by this object."""
        return _Amesos.Lapack_NumSymbolicFact(self, *args)

    def NumNumericFact(self, *args) -> "int":
        r""" Returns the number of numeric factorizations performed by this object."""
        return _Amesos.Lapack_NumNumericFact(self, *args)

    def NumSolve(self, *args) -> "int":
        r""" Returns the number of solves performed by this object."""
        return _Amesos.Lapack_NumSolve(self, *args)

    def PrintTiming(self, *args) -> "void":
        r""" Print timing information"""
        return _Amesos.Lapack_PrintTiming(self, *args)

    def PrintStatus(self, *args) -> "void":
        r""" Print information about the factorization and solution phases."""
        return _Amesos.Lapack_PrintStatus(self, *args)

    def GetTiming(self, *args) -> "void":
        r""" Extracts timing information from the current solver and places it in the parameter list."""
        return _Amesos.Lapack_GetTiming(self, *args)

# Register Lapack in _Amesos:
_Amesos.Lapack_swigregister(Lapack)

class Klu(BaseSolver):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        Amesos_Klu Constructor. Creates an Amesos_Klu instance, using an Epetra_LinearProblem,
             passing in an already-defined Epetra_LinearProblem object.

             Note: The operator in LinearProblem must be an
             Epetra_RowMatrix.
        """
        _Amesos.Klu_swiginit(self, _Amesos.new_Klu(*args))
    __swig_destroy__ = _Amesos.delete_Klu

    def SymbolicFactorization(self, *args) -> "int":
        return _Amesos.Klu_SymbolicFactorization(self, *args)

    def NumericFactorization(self, *args) -> "int":
        return _Amesos.Klu_NumericFactorization(self, *args)

    def Solve(self, *args) -> "int":
        return _Amesos.Klu_Solve(self, *args)

    def GetProblem(self, *args) -> "Epetra_LinearProblem const *":
        r""" Get a pointer to the Problem."""
        return _Amesos.Klu_GetProblem(self, *args)

    def MatrixShapeOK(self, *args) -> "bool":
        r"""
        Returns true if KLU can handle this matrix shape Returns true if the matrix shape is one that KLU can
           handle. KLU only works with square matrices.
        """
        return _Amesos.Klu_MatrixShapeOK(self, *args)

    def SetUseTranspose(self, *args) -> "int":
        r"""
        SetUseTranpose(true) is more efficient in Amesos_Klu
           If SetUseTranspose() is set to true,
           :math:`A^T X = B` is computed.
        """
        return _Amesos.Klu_SetUseTranspose(self, *args)

    def UseTranspose(self, *args) -> "bool":
        return _Amesos.Klu_UseTranspose(self, *args)

    def Comm(self, *args) -> "Epetra_Comm const &":
        return _Amesos.Klu_Comm(self, *args)

    def SetParameters(self, *args) -> "int":
        return _Amesos.Klu_SetParameters(self, *args)

    def NumSymbolicFact(self, *args) -> "int":
        r""" Returns the number of symbolic factorizations performed by this object."""
        return _Amesos.Klu_NumSymbolicFact(self, *args)

    def NumNumericFact(self, *args) -> "int":
        r""" Returns the number of numeric factorizations performed by this object."""
        return _Amesos.Klu_NumNumericFact(self, *args)

    def NumSolve(self, *args) -> "int":
        r""" Returns the number of solves performed by this object."""
        return _Amesos.Klu_NumSolve(self, *args)

    def PrintTiming(self, *args) -> "void":
        r""" Prints timing information"""
        return _Amesos.Klu_PrintTiming(self, *args)

    def PrintStatus(self, *args) -> "void":
        r""" Prints information about the factorization and solution phases."""
        return _Amesos.Klu_PrintStatus(self, *args)

    def GetTiming(self, *args) -> "void":
        r""" Extracts timing information and places in parameter list."""
        return _Amesos.Klu_GetTiming(self, *args)

# Register Klu in _Amesos:
_Amesos.Klu_swigregister(Klu)

class Umfpack(BaseSolver):
    r"""
    Class Amesos_Umfpack:  An object-oriented wrapper for UMFPACK.  Amesos_Umfpack will solve a linear systems of equations: A X = B
      using Epetra objects and the UMFPACK solver library, where
     A is an Epetra_RowMatrix and X and B are
     Epetra_MultiVector objects.


    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        Amesos_Umfpack Constructor. Creates an Amesos_Umfpack instance, using an Epetra_LinearProblem,
             passing in an already-defined Epetra_LinearProblem object.

             Note: The operator in LinearProblem must be an
             Epetra_RowMatrix.
        """
        _Amesos.Umfpack_swiginit(self, _Amesos.new_Umfpack(*args))
    __swig_destroy__ = _Amesos.delete_Umfpack

    def SymbolicFactorization(self, *args) -> "int":
        return _Amesos.Umfpack_SymbolicFactorization(self, *args)

    def NumericFactorization(self, *args) -> "int":
        return _Amesos.Umfpack_NumericFactorization(self, *args)

    def Solve(self, *args) -> "int":
        return _Amesos.Umfpack_Solve(self, *args)

    def GetProblem(self, *args) -> "Epetra_LinearProblem const *":
        return _Amesos.Umfpack_GetProblem(self, *args)

    def MatrixShapeOK(self, *args) -> "bool":
        r"""
        Returns true if UMFPACK can handle this matrix shape  Returns true if the matrix shape is one that UMFPACK can
           handle. UMFPACK only works with square matrices.
        """
        return _Amesos.Umfpack_MatrixShapeOK(self, *args)

    def SetUseTranspose(self, *args) -> "int":
        return _Amesos.Umfpack_SetUseTranspose(self, *args)

    def UseTranspose(self, *args) -> "bool":
        return _Amesos.Umfpack_UseTranspose(self, *args)

    def Comm(self, *args) -> "Epetra_Comm const &":
        return _Amesos.Umfpack_Comm(self, *args)

    def GetRcond(self, *args) -> "double":
        r""" Returns an estimate of the reciprocal of the condition number"""
        return _Amesos.Umfpack_GetRcond(self, *args)

    def SetParameters(self, *args) -> "int":
        return _Amesos.Umfpack_SetParameters(self, *args)

    def NumSymbolicFact(self, *args) -> "int":
        r""" Returns the number of symbolic factorizations performed by this object."""
        return _Amesos.Umfpack_NumSymbolicFact(self, *args)

    def NumNumericFact(self, *args) -> "int":
        r""" Returns the number of numeric factorizations performed by this object."""
        return _Amesos.Umfpack_NumNumericFact(self, *args)

    def NumSolve(self, *args) -> "int":
        r""" Returns the number of solves performed by this object."""
        return _Amesos.Umfpack_NumSolve(self, *args)

    def PrintTiming(self, *args) -> "void":
        r""" Prints timing information"""
        return _Amesos.Umfpack_PrintTiming(self, *args)

    def PrintStatus(self, *args) -> "void":
        r""" Prints information about the factorization and solution phases."""
        return _Amesos.Umfpack_PrintStatus(self, *args)

    def GetTiming(self, *args) -> "void":
        r""" Extracts timing information from the current solver and places it in the parameter list."""
        return _Amesos.Umfpack_GetTiming(self, *args)

# Register Umfpack in _Amesos:
_Amesos.Umfpack_swigregister(Umfpack)

class Superlu(BaseSolver):
    r"""
     Amesos_Superlu:  Amesos interface to Xioye Li's SuperLU 3.0 serial code.
    Class Amesos_Superlu solves the linear systems of equations A X = B,
    where A is defined as an Epetra_RowMatrix, and X and B are two
    Epetra_MultiVector's.

    Last updated on 28-Apr-05.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        Amesos_Superlu Constructor. Creates an Amesos_Superlu instance, using an Epetra_LinearProblem,
             passing in an already-defined Epetra_LinearProblem object.

             Note: The operator in LinearProblem must be an
             Epetra_RowMatrix.
        """
        _Amesos.Superlu_swiginit(self, _Amesos.new_Superlu(*args))
    __swig_destroy__ = _Amesos.delete_Superlu

    def SymbolicFactorization(self, *args) -> "int":
        return _Amesos.Superlu_SymbolicFactorization(self, *args)

    def NumericFactorization(self, *args) -> "int":
        return _Amesos.Superlu_NumericFactorization(self, *args)

    def Solve(self, *args) -> "int":
        return _Amesos.Superlu_Solve(self, *args)

    def GetProblem(self, *args) -> "Epetra_LinearProblem const *":
        return _Amesos.Superlu_GetProblem(self, *args)

    def MatrixShapeOK(self, *args) -> "bool":
        return _Amesos.Superlu_MatrixShapeOK(self, *args)

    def SetUseTranspose(self, *args) -> "int":
        return _Amesos.Superlu_SetUseTranspose(self, *args)

    def UseTranspose(self, *args) -> "bool":
        return _Amesos.Superlu_UseTranspose(self, *args)

    def Comm(self, *args) -> "Epetra_Comm const &":
        return _Amesos.Superlu_Comm(self, *args)

    def SetParameters(self, *args) -> "int":
        return _Amesos.Superlu_SetParameters(self, *args)

    def NumSymbolicFact(self, *args) -> "int":
        r""" Returns the number of symbolic factorizations performed by this object."""
        return _Amesos.Superlu_NumSymbolicFact(self, *args)

    def NumNumericFact(self, *args) -> "int":
        r""" Returns the number of numeric factorizations performed by this object."""
        return _Amesos.Superlu_NumNumericFact(self, *args)

    def NumSolve(self, *args) -> "int":
        r""" Returns the number of solves performed by this object."""
        return _Amesos.Superlu_NumSolve(self, *args)

    def PrintTiming(self, *args) -> "void":
        r""" Prints timing information."""
        return _Amesos.Superlu_PrintTiming(self, *args)

    def PrintStatus(self, *args) -> "void":
        r""" Prints status information."""
        return _Amesos.Superlu_PrintStatus(self, *args)

    def GetTiming(self, *args) -> "void":
        r""" Extracts timing information from the current solver and places it in the parameter list."""
        return _Amesos.Superlu_GetTiming(self, *args)

# Register Superlu in _Amesos:
_Amesos.Superlu_swigregister(Superlu)



