# This file was automatically generated by SWIG (http://www.swig.org).
# Version 4.0.2
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.

"""

PyTrilinos.Domi is the python interface to the Trilinos structured,
multi-dimensional, distrivuted linear algebra servise package Domi:

    https://trilinos.org/docs/dev/packages/domi/doc/html/index.html

Domi supports the structured decomposition of structured vectors
(arrays), maps, and communicators.  It also supports the conversion of
these objects to Epetra and Tpetra Vectors, MultiVectors, and Maps
(including as views where possible), so that they can be used with
other Trilinos solver technologies.

"""

from sys import version_info as _swig_python_version_info
if _swig_python_version_info < (2, 7, 0):
    raise RuntimeError("Python 2.7 or later required")

# Import the low-level C/C++ module
if __package__ or "." in __name__:
    from . import _Domi
else:
    import _Domi

try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)


def _swig_setattr_nondynamic_instance_variable(set):
    def set_instance_attr(self, name, value):
        if name == "thisown":
            self.this.own(value)
        elif name == "this":
            set(self, name, value)
        elif hasattr(self, name) and isinstance(getattr(type(self), name), property):
            set(self, name, value)
        else:
            raise AttributeError("You cannot add instance attributes to %s" % self)
    return set_instance_attr


def _swig_setattr_nondynamic_class_variable(set):
    def set_class_attr(cls, name, value):
        if hasattr(cls, name) and not isinstance(getattr(cls, name), property):
            set(cls, name, value)
        else:
            raise AttributeError("You cannot add class attributes to %s" % cls)
    return set_class_attr


def _swig_add_metaclass(metaclass):
    """Class decorator for adding a metaclass to a SWIG wrapped class - a slimmed down version of six.add_metaclass"""
    def wrapper(cls):
        return metaclass(cls.__name__, cls.__bases__, cls.__dict__.copy())
    return wrapper


class _SwigNonDynamicMeta(type):
    """Meta class to enforce nondynamic attributes (no new attributes) for a class"""
    __setattr__ = _swig_setattr_nondynamic_class_variable(type.__setattr__)


import weakref

class SwigPyIterator(object):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Domi.delete_SwigPyIterator

    def value(self) -> "PyObject *":
        return _Domi.SwigPyIterator_value(self)

    def incr(self, n: "size_t"=1) -> "swig::SwigPyIterator *":
        return _Domi.SwigPyIterator_incr(self, n)

    def decr(self, n: "size_t"=1) -> "swig::SwigPyIterator *":
        return _Domi.SwigPyIterator_decr(self, n)

    def distance(self, x: "SwigPyIterator") -> "ptrdiff_t":
        return _Domi.SwigPyIterator_distance(self, x)

    def equal(self, x: "SwigPyIterator") -> "bool":
        return _Domi.SwigPyIterator_equal(self, x)

    def copy(self) -> "swig::SwigPyIterator *":
        return _Domi.SwigPyIterator_copy(self)

    def next(self) -> "PyObject *":
        return _Domi.SwigPyIterator_next(self)

    def __next__(self) -> "PyObject *":
        return _Domi.SwigPyIterator___next__(self)

    def previous(self) -> "PyObject *":
        return _Domi.SwigPyIterator_previous(self)

    def advance(self, n: "ptrdiff_t") -> "swig::SwigPyIterator *":
        return _Domi.SwigPyIterator_advance(self, n)

    def __eq__(self, x: "SwigPyIterator") -> "bool":
        return _Domi.SwigPyIterator___eq__(self, x)

    def __ne__(self, x: "SwigPyIterator") -> "bool":
        return _Domi.SwigPyIterator___ne__(self, x)

    def __iadd__(self, n: "ptrdiff_t") -> "swig::SwigPyIterator &":
        return _Domi.SwigPyIterator___iadd__(self, n)

    def __isub__(self, n: "ptrdiff_t") -> "swig::SwigPyIterator &":
        return _Domi.SwigPyIterator___isub__(self, n)

    def __add__(self, n: "ptrdiff_t") -> "swig::SwigPyIterator *":
        return _Domi.SwigPyIterator___add__(self, n)

    def __sub__(self, *args) -> "ptrdiff_t":
        return _Domi.SwigPyIterator___sub__(self, *args)
    def __iter__(self):
        return self

# Register SwigPyIterator in _Domi:
_Domi.SwigPyIterator_swigregister(SwigPyIterator)


import numpy

from . import Teuchos
from .Teuchos import Base
from . import Epetra
from . import Tpetra
C_ORDER = _Domi.C_ORDER
r""" C order, in which the last index varies fastest"""
FORTRAN_ORDER = _Domi.FORTRAN_ORDER
r""" Fortran order, in which the first index varies fastest"""
ROW_MAJOR = _Domi.ROW_MAJOR
r""" Row-major order, in which the last index varies fastest"""
COLUMN_MAJOR = _Domi.COLUMN_MAJOR
r""" Column-major order, in which the first index varies fastest"""
LAST_INDEX_FASTEST = _Domi.LAST_INDEX_FASTEST
r""" Last index fastest order"""
FIRST_INDEX_FASTEST = _Domi.FIRST_INDEX_FASTEST
r""" First index fastest order"""
DEFAULT_ORDER = _Domi.DEFAULT_ORDER
r""" Default order, currently first index fastest"""

def factor(*args) -> "Teuchos::Array< int >":
    r"""
     Return and array of integers that represent the prime
            factors of the input argument

    :type n: int
    :param n: [in] integer to be factored
    """
    return _Domi.factor(*args)

def indexOfMax(*args) -> "int":
    r"""
     Return the index of the maximum value in the provided
            sequence of floating point values

    :type seq: Teuchos::ArrayView< float const >
    :param seq: [in] a sequence of floating point values
    """
    return _Domi.indexOfMax(*args)

def decomposeProcs(*args) -> "Teuchos::Array< int >":
    r"""
     Return a decomposition of processors, given on the total
            number of processors and the dimensions of the field that
            will be decomposed. The size of the dimensions input
            argument determines the size of the output
            decomposition. The product of the output decomposition will
            equal the total number of processors. The decomposition
            values will be as close to the relative sizes of the
            dimensions as the algorithm can get.

    :type nprocs: int
    :param nprocs: [in] total number of processors

    :type dimensions: Teuchos::ArrayView< Domi::dim_type >
    :param dimensions: [in] an array of dimensions of the field that
                               will be decomposed
    """
    return _Domi.decomposeProcs(*args)

def createArrayOfInts(*args) -> "Teuchos::Array< int >":
    r"""
     Compute an array of integers, given the user input.

    If the input array is shorter than the number of dimensions, fill
    the remainder of the result with zeros.

    :type numDims: int
    :param numDims: [in] the number of dimensions

    :type source: Teuchos::ArrayView< int const >
    :param source: [in] the source array of ints
    """
    return _Domi.createArrayOfInts(*args)

def class_array_inplace_op(self, op_str, other):
  in_op = getattr(self.array, "__i"+op_str+"__")
  in_op(other.array)
  return self

def class_array_math_op(self, op_str, other):
# Initialize the result by calling the copy constructor
  result = self.__class__(self)
# Get the equivalent in-place operator for the result
  in_op = getattr(result.array, "__i"+op_str+"__")
  try:
    in_op(other.array)
  except AttributeError:
    in_op(other)
  return result

def class_array_rmath_op(self, op_str, other):
# Initialize the result by calling the copy constructor
  result = self.__class__(self)
  indices = (slice(None),) * len(self.array.shape)
  result.array[indices] = other
  in_op = getattr(result.array, "__i"+op_str+"__")
  in_op(self.array)
  return result

def class_array_add_math_ops(cls, op_str):
  setattr(cls,
          "__i"+op_str+"__",
          lambda self, other: class_array_inplace_op(self, op_str, other))
  setattr(cls,
          "__"+op_str+"__",
          lambda self, other: class_array_math_op(self, op_str, other))
  setattr(cls,
          "__r"+op_str+"__",
          lambda self, other: class_array_rmath_op(self, op_str, other))

def class_array_add_math(cls):
  class_array_add_math_ops(cls, "add")
  class_array_add_math_ops(cls, "sub")
  class_array_add_math_ops(cls, "mul")
  class_array_add_math_ops(cls, "add")

def class_array_comp_op(self, op_str, other):
  comp_op = getattr(self.array, "__"+op_str+"__")
  try:
    return comp_op(other.array)
  except AttributeError:
    return comp_op(other)

def class_array_add_comp_op(cls, op_str):
  setattr(cls,
          "__"+op_str+"__",
          lambda self, other: class_array_comp_op(self, op_str, other))

def class_array_add_comp(cls):
  class_array_add_comp_op(cls, "lt")
  class_array_add_comp_op(cls, "le")
  class_array_add_comp_op(cls, "eq")
  class_array_add_comp_op(cls, "ne")
  class_array_add_comp_op(cls, "gt")
  class_array_add_comp_op(cls, "ge")



def Version(*args) -> "std::string":
    return _Domi.Version(*args)

__version__ = Version().split()[2]


def getValidParameters(*args) -> "Teuchos::RCP< Teuchos::ParameterList const >":
    return _Domi.getValidParameters(*args)
class MDComm(object):
    r"""
     Multi-dimensional communicator object

    The MDComm is a relatively simple class that contains a
    Teuchos::RCP<const Teuchos::Comm<int> > and arranges the
    processor ranks of that communicator in a multi-dimensional grid
    suitable for decomposing a multi-dimensional data structure.

    To construct an MDComm, the user provides the number of
    dimensions, an array of sizes along each axis, or both.  The user
    can request the constructor to compute some of the decomposition by
    making the axis sizes list shorter than the number of dimensions,
    or by providing axis sizes that are negative.  Currently, the
    algorithm assigns all remaining processors to the first unspecified
    axis size, and assigns all the rest to be one.

    An MDComm can also be constructed that is a slice of a
    parent MDComm.  Such an object is constructed by providing
    an RCP of the parent and an array of Slices that define the
    sub-communicator.  When you construct a sub-communicator, you run
    the risk of calling methods of the MDComm object or of
    objects built on top of the MDComm object from processors
    that are not a part of the sub-communicator.  You can always check
    whether this is safe with the

        .. code-block:: c++

            bool onSubcommunicator() const;

    method.

    The MDComm class provides two methods that return the
    processor rank of neighboring processors in the grid of arrays:

        .. code-block:: c++

            int getLowerNeighbor(int axis) const;
            int getUpperNeighbor(int axis) const;

    This should be sufficient to provide the necessary processor ranks
    for conducting communication padding updates.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        *Overload 1:*
         Constructor with default Teuchos comm and axis sizes

        :type commDims: Teuchos::ArrayView< int const >
        :param commDims: [in] An array containing the sizes of the
                   MDComm along each axis.  The size of
                   commDims determines the number of dimensions.
                   Negative values will be converted to positive such that
                   the product of the resulting axis sizes will equal the
                   number of processors in the Teuchos communicator.

        :type periodic: Teuchos::ArrayView< int const >, optional
        :param periodic: [in] An array of ints which are simple flags
                   denoting whether each axis is periodic.  If this array is
                   shorter than the size of commDims, the unspecified axes
                   are assumed to be zero (false).

        This constructor uses the Teuchos::DefaultComm communicator

        |

        *Overload 2:*
         Constructor with Teuchos Comm and axis sizes

        :type teuchosComm: Teuchos::Comm< int >
        :param teuchosComm: [in] The Teuchos Communicator

        :type commDims: Teuchos::ArrayView< int const >
        :param commDims: [in] An array containing the sizes of the
                   MDComm along each axis.  The size of
                   commDims determines the number of dimensions.
                   Negative values will be converted to positive such that
                   the product of the resulting axis sizes will equal the
                   number of processors in the Teuchos communicator.

        :type periodic: Teuchos::ArrayView< int const >, optional
        :param periodic: [in] An array of ints which are simple flags
                   denoting whether each axis is periodic.  If this array is
                   shorter than the size of commDims, the unspecified axes
                   are assumed to be zero (false).

        |

        *Overload 3:*
         Constructor with ParameterList

        :type plist: :py:class:`ParameterList`
        :param plist: [in] ParameterList with construction information

                   <iframe src="domi.xml" width="100%" scrolling="no" frameborder="0">
                   </iframe>
                   <hr />


        This constructor uses the Teuchos::DefaultComm

        |

        *Overload 4:*
         Constructor with Teuchos Comm and ParameterList

        :type teuchosComm: Teuchos::Comm< int >
        :param teuchosComm: [in] The Teuchos Communicator

        :type plist: :py:class:`ParameterList`
        :param plist: [in] ParameterList with construction information

                   <iframe src="domi.xml" width="100%" scrolling="no" frameborder="0">
                   </iframe>
                   <hr />


        |

        *Overload 5:*
         Constructor with number of dimensions

        :type numDims: int
        :param numDims: [in] The number of dimensions in the
                   MDComm.  Currently, all of the processors are
                   allocated to the first axis, and the other axes are
                   assigned a size of one.

        This constructor uses the Teuchos::DefaultComm

        |

        *Overload 6:*
         Constructor with number of dimensions

        :type teuchosComm: Teuchos::Comm< int >
        :param teuchosComm: [in] The Teuchos Communicator

        :type numDims: int
        :param numDims: [in] The number of dimensions in the
                   MDComm.  Currently, all of the processors are
                   allocated to the first axis, and the other axes are
                   assigned a size of one.

        |

        *Overload 7:*
         Constructor with number of dimensions and axis sizes

        :type numDims: int
        :param numDims: [in] The number of dimensions in the
                   MDComm.

        :type commDims: Teuchos::ArrayView< int const >
        :param commDims: [in] An array containing the sizes of the
                   MDComm along each axis.  If the size of
                   commDims is less than numDims, then the
                   missing values are treated as unspecified.  Negative
                   values will also be treated as unspecified.  Unspecified
                   values will be converted to positive such that the product
                   of the resulting axis sizes will equal the number of
                   processors in the Teuchos communicator.

        :type periodic: Teuchos::ArrayView< int const >, optional
        :param periodic: [in] An array of ints which are simple flags
                   denoting whether each axis is periodic.  If this array is
                   shorter than numDims, the unspecified axes are assumed to
                   be zero (false).

        This constructor uses the Teuchos::DefaultComm

        |

        *Overload 8:*
         Constructor with Teuchos Comm, number of dimensions and axis sizes

        :type teuchosComm: Teuchos::Comm< int >
        :param teuchosComm: [in] The Teuchos Communicator

        :type numDims: int
        :param numDims: [in] The number of dimensions in the
                   MDComm.

        :type commDims: Teuchos::ArrayView< int const >
        :param commDims: [in] An array containing the sizes of the
                   MDComm along each axis.  If the size of
                   commDims is less than numDims, then the
                   missing values are treated as unspecified.  Negative
                   values will also be treated as unspecified.  Unspecified
                   values will be converted to positive such that the product
                   of the resulting axis sizes will equal the number of
                   processors in the Teuchos communicator.

        :type periodic: Teuchos::ArrayView< int const >, optional
        :param periodic: [in] An array of ints which are simple flags
                   denoting whether each axis is periodic.  If this array is
                   shorter than numDims, the unspecified axes are assumed to
                   be zero (false).

        |

        *Overload 9:*
         Axis rank sub-communicator constructor

        :type parent: :py:class:`MDComm`
        :param parent: [in] The parent MDComm object.

        :type axis: int
        :param axis: [in] The axis to which the axisRank argument applies

        :type axisRank: int
        :param axisRank: [in] The value of the rank along the given axis

        This constructor will return an MDComm that is one dimension less
        than the parent MDComm (unless the parent MDComm is already
        one-dimensional), equivalent to a slice of the parent at the
        given axis rank value.

        |

        *Overload 10:*
         Slice sub-communicator constructor

        :type parent: :py:class:`MDComm`
        :param parent: [in] The parent MDComm object.

        :type axis: int
        :param axis: [in] The axis to which the slice argument applies

        :type slice: :py:class:`Slice`
        :param slice: [in] A Slice object that defines what
                   portion of the parent will be translated to the
                   sub-communicator along the given axis axis.

        |

        *Overload 11:*
         Array of Slices sub-communicator constructor

        :type parent: :py:class:`MDComm`
        :param parent: [in] The parent MDComm object.

        :type slices: Teuchos::ArrayView< Domi::Slice >
        :param slices: [in] An array of Slice objects that
                   defines what portions of the parent will be translated to
                   the sub-communicator along each axis.

        |

        *Overload 12:*
         Copy constructor

        :type source: :py:class:`MDComm`
        :param source: [in] Source MDComm to be copied
        """
        _Domi.MDComm_swiginit(self, _Domi.new_MDComm(*args))
    __swig_destroy__ = _Domi.delete_MDComm

    def onSubcommunicator(self, *args) -> "bool":
        r"""
         Query whether this processor is on the sub-communicator.

        Sub-communicators are formed when a parent MDComm is sliced by
        using the (parent,slices) constructor.  For a full communicator,
        this method will always return true.
        """
        return _Domi.MDComm_onSubcommunicator(self, *args)

    def getTeuchosComm(self, *args) -> "Teuchos::RCP< Teuchos::Comm< int > const >":
        r"""
         Get the Teuchos communicator

        Note that if the communicator is not a full communicator, i.e. a
        sub-communicator, that the underlying Comm pointer may be NULL,
        depending on this processor's rank.
        """
        return _Domi.MDComm_getTeuchosComm(self, *args)

    def getEpetraComm(self, *args) -> "Teuchos::RCP< Epetra_Comm const >":
        r"""
         Get an equivalent Epetra communicator

        Note that if the communicator is not a full communicator, i.e. a
        sub-communicator, that the underlying Comm pointer may be NULL,
        depending on this processor's rank.
        """
        return _Domi.MDComm_getEpetraComm(self, *args)

    def numDims(self, *args) -> "int":
        r"""
         Get the number of dimensions

        This method will return 0 if the communicator is a
        sub-communicator and this processor does not belong to the
        sub-communicator.
        """
        return _Domi.MDComm_numDims(self, *args)

    def getCommDims(self, *args) -> "Teuchos::Array< int >":
        r"""
         Get the communicator sizes along each axis

        This method will throw a Domi::SubcommunicatorError if the
        communicator is a sub-communicator and this processor does not
        belong to the sub-communicator.
        """
        return _Domi.MDComm_getCommDims(self, *args)

    def getCommDim(self, *args) -> "int":
        r"""
         Get the communicator size along the given axis

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        This method will throw a Domi::SubcommunicatorError if the
        communicator is a sub-communicator and this processor does not
        belong to the sub-communicator.
        """
        return _Domi.MDComm_getCommDim(self, *args)

    def isPeriodic(self, *args) -> "bool":
        r"""
         Return the periodic flag for the given axis.

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        This method will throw a Domi::SubcommunicatorError if the
        communicator is a sub-communicator and this processor does not
        belong to the sub-communicator.
        """
        return _Domi.MDComm_isPeriodic(self, *args)

    def getCommIndex(self, *args) -> "int":
        r"""
         Get the comm index along the given axis

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        This method will throw a Domi::SubcommunicatorError if the
        communicator is a sub-communicator and this processor does not
        belong to the sub-communicator.
        """
        return _Domi.MDComm_getCommIndex(self, *args)

    def getLowerNeighbor(self, *args) -> "int":
        r"""
         Get the rank of the lower neighbor

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        This method will throw a Domi::SubcommunicatorError if the
        communicator is a sub-communicator and this processor does not
        belong to the sub-communicator.

        If the periodic flag for the given axis is off, and the axis rank
        of the calling processor is zero, then this method returns -1.

        If the periodic flag for the given axis is on, and the axis rank
        of the calling processor is zero, then the returned lower
        neighbor will be the highest axis rank processor along this axis.
        """
        return _Domi.MDComm_getLowerNeighbor(self, *args)

    def getUpperNeighbor(self, *args) -> "int":
        r"""
         Get the rank of the upper neighbor

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        This method will throw a Domi::SubcommunicatorError if the
        communicator is a sub-communicator and this processor does not
        belong to the sub-communicator.

        If the periodic flag for the given axis is off, and the axis rank
        of the calling processor is the highest axis rank along the axis,
        then this method returns -1.

        If the periodic flag for the given axis is on, and the axis rank
        of the calling processor is the highest axis rank along the axis,
        then this method will return axis rank zero.
        """
        return _Domi.MDComm_getUpperNeighbor(self, *args)

    def getAxisComms(self, *args) -> "Teuchos::ArrayView< Teuchos::RCP< Domi::MDComm const > >":
        r"""
         Return array of all axis communicators

        An axis communicator is a 1D MDComm sub-communicator that
        represents the comms on a given axis. Further, this
        sub-communicator will always be valid for the processor on which
        it was constructed.
        """
        return _Domi.MDComm_getAxisComms(self, *args)

    def getAxisComm(self, *args) -> "Teuchos::RCP< Domi::MDComm const >":
        r"""
         Return an axis communicator for the given axis

        :type axis: int
        :param axis: [in]  The axis of the requested axis communicator

        An axis communicator is a 1D MDComm sub-communicator that
        represents the comms on a given axis. Further, this
        sub-communicator will always be valid for the processor on which
        it was constructed.
        """
        return _Domi.MDComm_getAxisComm(self, *args)

    def __getitem__(self, *args) -> "Domi::MDComm":
        return _Domi.MDComm___getitem__(self, *args)

# Register MDComm in _Domi:
_Domi.MDComm_swigregister(MDComm)
cvar = _Domi.cvar
MDComm.commLayout = _Domi.cvar.MDComm_commLayout

class MDMap(object):
    r"""
     Multi-dimensional map

    The MDMap class is intended to perform the functions of
    Epetra or Tpetra maps, except that the data is multi-dimensional.
    Rather than taking a Teuchos::Comm object in its
    constructor, an MDMap object takes a Domi::MDComm
    object.  An MDComm object is ordered in a structured way,
    with processors assigned to each axis, whose product of lengths is
    the total number of processors of its underlying communicator.

    At a bare minimum, an MDMap constructor requires an
    MDComm and an array of dimensions indicating the size and
    shape of the data structure(s) the MDMap will describe.
    Each dimension will be decomposed along each axis, according to the
    number of processors along that axis in the MDComm, in as
    even a fashion as is possible.

    Each axis may be flagged as periodic when constructing the
    MDComm.  This attribute is transferred to the
    MDMap at construction.

    There are two distinct buffer padding concepts employed by
    MDMaps, communication padding and boundary padding.
    Communication padding refers to local extensions of the data
    structure used to receive communication from neighboring
    processors.  Boundary padding refers to points added to the
    exterior of the global domain that are useful, for example, in
    certain finite differencing algorithms.  They are treated
    separately from the dimensions so that the decomposition will be
    performed relative to the dimensions only, and not influenced by
    the size of the boundary padding.

    From a global perspective, the only padding points that are visible
    are boundary padding points.  Communication padding is internal and
    essentially invisible from this perspective.  From a local
    perspective, a local buffer can have padding on all sides.  Some of
    this padding could be boundary padding, some could be communication
    padding, and some could be both.

    The sizes of boundary and communication padding can be different
    along each axis, and the sizes of boundary and communication
    padding on any given axis can be different from each other.

    When you want to loop over the elements of a data structure
    described by an MDMap, you can obtain the local looping
    bounds along a given axis with the getLocalBounds(int
    axis) method.  This returns a Slice object, whose
    start() and stop() methods return the loop bounds
    (stop() is non-inclusive).  This method also takes a
    boolean flag indicating whether the bounds should include the
    communication padding, which defaults to false.

    There are two methods for obtaining global loop bounds,
    getGlobalBounds(int axis) and getGlobalRankBounds(int
    axis).  The first returns the global bounds for the full data
    structure and the second returns the bounds on this processor.

    Note that all indexes start at zero, whether global or local,
    whether unique 1D IDs or multidimensional indexes, whether boundary
    or communication padding is present.  This allows negative indexes
    to represent reverse indexing from the end of a dimension.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        *Overload 1:*
         Main constructor

        :type mdComm: :py:class:`MDComm`
        :param mdComm: [in] an RCP of an MDComm (multi-dimensional
                   communicator), on which this MDMap will be built.

        :type dimensions: Teuchos::ArrayView< Domi::dim_type const >
        :param dimensions: [in] the dimensions of the map along each axis.
                   This array must be the same number of dimensions as the
                   MDComm.

        :type commPad: Teuchos::ArrayView< int const >, optional
        :param commPad: [in] the number of indexes in the communication
                   padding along each axis.  If this array is less than the
                   number of dimensions, unspecified communication padding
                   will be set to zero.

        :type bndryPad: Teuchos::ArrayView< int const >, optional
        :param bndryPad: [in] the number of indexes in the boundary
                   padding along each axis.  If this array is less than the
                   number of dimensions, unspecified unspecified boundary
                   padding sizes will be set to zero.

        :type replicatedBoundary: Teuchos::ArrayView< int const >, optional
        :param replicatedBoundary: [in] An array of ints which are simple
                   flags denoting whether each axis contains replicated
                   boundary points (RBPs). RBPs pertain only to periodic
                   axes. As an example, consider a map that describes the
                   decomposition of a longitude coordinate. If the global
                   lower boundary of this domain is longitude = 0 degrees,
                   and the global upper boundary of this domain is longitude
                   = 360 degrees, then this axis has a replicated
                   boundary. Note that communication of the boundary padding
                   will skip these boundary points, and it is up to the user
                   to ensure that their values are equal or compatible.

        :type layout: int, optional
        :param layout: [in] the storage order of the map

        |

        *Overload 2:*
         Constructor with ParameterList

        :type plist: :py:class:`ParameterList`
        :param plist: [in] ParameterList with construction information

                   <iframe src="domi.xml" width="100%" scroling="no" frameborder="no">
                   </iframe>
                   <hr />


        This constructor uses the Teuchos::DefaultComm

        |

        *Overload 3:*
         Constructor with Teuchos::Comm and ParameterList

        :type teuchosComm: Teuchos::Comm< int >
        :param teuchosComm: [in] The Teuchos Communicator.  Note that an
                   MDComm will be constructed from the information in plist.

        :type plist: :py:class:`ParameterList`
        :param plist: [in] ParameterList with construction information

                   <iframe src="domi.xml" width="100%" scrolling="no" frameborder="0">
                   </iframe>
                   <hr />


        |

        *Overload 4:*
         Constructor with MDComm and ParameterList

        :type mdComm: :py:class:`MDComm`
        :param mdComm: [in] an RCP of an MDComm (multi-dimensional
                   communicator), on which this MDMap will be built.

        :type plist: :py:class:`ParameterList`
        :param plist: [in] ParameterList with construction information

                   <iframe src="domi.xml" width="100%" scrolling="no" frameborder="0">
                   </iframe>
                   <hr />


        |

        *Overload 5:*
         Constructor with global bounds for this processor

        :type mdComm: :py:class:`MDComm`
        :param mdComm: [in] an RCP of an MDComm (multi-dimensional
                   communicator), on which the MDMap will be built

        :type myGlobalBounds: Teuchos::ArrayView< Domi::Slice >
        :param myGlobalBounds: [in] an array of Slices, one for each axis,
                   that represent the global indexes of the bounds on this
                   processor, excluding padding

        :type padding: Teuchos::ArrayView< Domi::padding_type >, optional
        :param padding: [in] an array of padding_type (a 2-tuple of
                   integers) specifying the local padding along each
                   axis. Since this is local, the MDMap constructor can
                   determine from context whether each pad refers to
                   communication padding or boundary padding.

        :type replicatedBoundary: Teuchos::ArrayView< int const >, optional
        :param replicatedBoundary: [in] An array of ints which are simple
                   flags denoting whether each axis contains replicated
                   boundary points (RBPs). RBPs pertain only to periodic
                   axes. As an example, consider a map that describes the
                   decomposition of a longitude coordinate. If the global
                   lower boundary of this domain is longitude = 0 degrees,
                   and the global upper boundary of this domain is longitude
                   = 360 degrees, then this axis has a replicated
                   boundary. Note that communication of the boundary padding
                   will skip these boundary points, and it is up to the user
                   to ensure that their values are equal or compatible.

        :type layout: int, optional
        :param layout: [in] the storage order of the map

        |

        *Overload 6:*
         Copy constructor

        :type source: :py:class:`MDMap`
        :param source: [in] the source MDMap to be copied

        |

        *Overload 7:*
         Parent/single global ordinal sub-map constructor

        :type parent: :py:class:`MDMap`
        :param parent: [in] an MDMap, from which this sub-map will be
                   derived.

        :type axis: int
        :param axis: [in] the axis to which the slice argument applies

        :type index: int
        :param index: [in] a global ordinal that defines the sub-map.

        This constructor will return an MDMap that is one dimension less
        than the dimensions of the parent MDMap (unless the parent MDMap
        is already one dimension).

        |

        *Overload 8:*
         Parent/single slice sub-map constructor

        :type parent: :py:class:`MDMap`
        :param parent: [in] an MDMap, from which this sub-map will be
                   derived.

        :type axis: int
        :param axis: [in] the axis to which the slice argument applies

        :type slice: :py:class:`Slice`
        :param slice: [in] a Slice of global axis indexes that
                   defines the sub-map.  This slice must not include
                   indexes from the boundary padding along each axis.

        :type bndryPad: int, optional
        :param bndryPad: [in] The size of the boundary padding along the
                   altered axis of the new sub-map.  This may include indexes
                   from the boundary padding of the parent MDMap, but it does
                   not have to.

        This constructor will return an MDMap that is the same number of
        dimensions as the parent MDMap, but with a smaller dimension
        along the given axis (unless the given Slice represents the
        entire axis).

        |

        *Overload 9:*
         Parent/array of slices sub-map constructor

        :type parent: :py:class:`MDMap`
        :param parent: [in] an MDMap, from which this sub-map will be
                   derived.

        :type slices: Teuchos::ArrayView< Domi::Slice >
        :param slices: [in] an array of Slices of global axis indexes that
                   defines the sub-map.  These slices must not include
                   indexes from the boundary padding along each axis.

        :type bndryPad: Teuchos::ArrayView< int >, optional
        :param bndryPad: [in] The boundary padding of the new sub-map.
                   These may include indexes from the boundary padding of the
                   parent MDMap, but they do not have to.
        """
        _Domi.MDMap_swiginit(self, _Domi.new_MDMap(*args))
    __swig_destroy__ = _Domi.delete_MDMap

    def getTeuchosComm(self, *args) -> "Teuchos::RCP< Teuchos::Comm< int > const >":
        r"""
         Get the Teuchos communicator

        Note that if the communicator is not a full communicator, i.e. a
        sub-communicator, that the underlying Comm pointer may be NULL,
        depending on this processor's rank.
        """
        return _Domi.MDMap_getTeuchosComm(self, *args)

    def getMDComm(self, *args) -> "Teuchos::RCP< Domi::MDComm const >":
        r"""
         Access the underlying MDComm object

        Return a reference counted pointer to the Domi::MDComm object
        upon which this MDMap is built.
        """
        return _Domi.MDMap_getMDComm(self, *args)

    def onSubcommunicator(self, *args) -> "bool":
        r"""
         Query whether this processor is on the sub-communicator

        Sub-communicators are formed when a parent MDComm is sliced by
        using the (parent,ordinal) or (parent,slices) constructor.  For a
        full communicator, this method will always return true.
        """
        return _Domi.MDMap_onSubcommunicator(self, *args)

    def numDims(self, *args) -> "int":
        r"""
         Get the number of dimensions

        This method will return 0 if the communicator is a
        sub-communicator and this processor does not belong to the
        sub-communicator.
        """
        return _Domi.MDMap_numDims(self, *args)

    def getCommDims(self, *args) -> "Teuchos::Array< int >":
        r"""
         Get the communicator sizes along each axis

        This method will throw a Domi::SubcommunicatorError if the
        communicator is a sub-communicator and this processor does not
        belong to the sub-communicator.
        """
        return _Domi.MDMap_getCommDims(self, *args)

    def getCommDim(self, *args) -> "int":
        r"""
         Get the communicator size along the given axis

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        This method will throw a Domi::SubcommunicatorError if the
        communicator is a sub-communicator and this processor does not
        belong to the sub-communicator.
        """
        return _Domi.MDMap_getCommDim(self, *args)

    def isPeriodic(self, *args) -> "bool":
        r"""
         Return the periodic flag for the given axis.

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        This method will throw a Domi::SubcommunicatorError if the
        communicator is a sub-communicator and this processor does not
        belong to the sub-communicator.
        """
        return _Domi.MDMap_isPeriodic(self, *args)

    def getCommIndex(self, *args) -> "int":
        r"""
         Get the axis rank of this processor

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        This method will throw a Domi::SubcommunicatorError if the
        communicator is a sub-communicator and this processor does not
        belong to the sub-communicator.
        """
        return _Domi.MDMap_getCommIndex(self, *args)

    def getLowerNeighbor(self, *args) -> "int":
        r"""
         Get the rank of the lower neighbor

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        This method will throw a Domi::SubcommunicatorError if the
        communicator is a sub-communicator and this processor does not
        belong to the sub-communicator.

        If the periodic flag for the given axis is off, and the axis rank
        of the calling processor is zero, then this method returns -1.

        If the periodic flag for the given axis is on, and the axis rank
        of the calling processor is the highest axis rank processor along
        this axis, then the returned lower neighbor will be zero.
        """
        return _Domi.MDMap_getLowerNeighbor(self, *args)

    def getUpperNeighbor(self, *args) -> "int":
        r"""
         Get the rank of the upper neighbor

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        This method will throw a Domi::SubcommunicatorError if the
        communicator is a sub-communicator and this processor does not
        belong to the sub-communicator.

        If the periodic flag for the given axis is off, and the axis rank
        of the calling processor is the highest axis rank processor along
        this axis, then this method returns -1.

        If the periodic flag for the given axis is on, and the axis rank
        of the calling processor is zero, then the returned lower
        neighbor will be the highest axis rank processor along this axis.
        """
        return _Domi.MDMap_getUpperNeighbor(self, *args)

    def getGlobalDims(self, *args) -> "Teuchos::Array< Domi::dim_type >":
        r"""
        Get an array of the the global dimensions, including
               boundary padding
        """
        return _Domi.MDMap_getGlobalDims(self, *args)

    def getGlobalDim(self, *args) -> "Domi::dim_type":
        r"""
         Get the global dimension along the specified axis

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        :type withBndryPad: boolean, optional
        :param withBndryPad: [in] specify whether the dimension should
                   include boundary padding or not
        """
        return _Domi.MDMap_getGlobalDim(self, *args)

    def getGlobalBounds(self, *args) -> "Domi::Slice":
        r"""
         Get the bounds of the global problem

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        :type withBndryPad: boolean, optional
        :param withBndryPad: [in] specify whether the bounds should
                   include boundary padding or not
        """
        return _Domi.MDMap_getGlobalBounds(self, *args)

    def getGlobalRankBounds(self, *args) -> "Domi::Slice":
        r"""
         Get the global loop bounds along the specified axis

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        :type withBndryPad: boolean, optional
        :param withBndryPad: [in] specify whether the dimension should
                   include boundary padding or not

        The loop bounds are returned in the form of a Slice, in
        which the start() method returns the loop begin value,
        and the stop() method returns the non-inclusive end
        value.
        """
        return _Domi.MDMap_getGlobalRankBounds(self, *args)

    def getLocalDims(self, *args) -> "Teuchos::Array< Domi::dim_type >":
        r""" Get an array of the local dimensions, including padding"""
        return _Domi.MDMap_getLocalDims(self, *args)

    def getLocalDim(self, *args) -> "Domi::dim_type":
        r"""
         Get the local dimension along the specified axis

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        :type withPad: boolean, optional
        :param withPad: [in] specify whether the dimension should include
                   padding or not
        """
        return _Domi.MDMap_getLocalDim(self, *args)

    def getLocalBounds(self, *args) -> "Domi::Slice":
        r"""
        *Overload 1:*
         Get the local loop bounds along every axis

        The loop bounds are returned in the form of a Slice, in
        which the start() method returns the loop begin value,
        and the stop() method returns the non-inclusive end
        value.  For this method, padding is included in the bounds.

        |

        *Overload 2:*
         Get the local loop bounds along the specified axis

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        :type withPad: boolean, optional
        :param withPad: [in] specify whether the dimension should include
                   padding or not

        The loop bounds are returned in the form of a Slice, in
        which the start() method returns the loop begin value,
        and the stop() method returns the non-inclusive end
        value.
        """
        return _Domi.MDMap_getLocalBounds(self, *args)

    def getLocalInteriorBounds(self, *args) -> "Domi::Slice":
        r"""
         Get the local interior loop bounds along the specified
                axis

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        Local interior loop bounds are the same as local loop bounds
        without padding, except that for non-periodic axes the global end
        points of the given axis are excluded. For periodic axes, the
        local interior loop bounds are exactly the same as local loop
        bounds without padding.

        The loop bounds are returned in the form of a Slice, in
        which the start() method returns the loop begin value,
        and the stop() method returns the non-inclusive end
        value.
        """
        return _Domi.MDMap_getLocalInteriorBounds(self, *args)

    def hasPadding(self, *args) -> "bool":
        r"""
         Return true if there is any padding stored locally

        Note that it is not as simple as whether there were communication
        padding specified in the constructor.  Suppose non-zero
        communication padding was specified, but the problem is on one
        processor and no boundary padding was specified: this method will
        return false.  Similarly, if no communication padding was
        specified but boundary padding was, then boundary processors will
        have padding and this method will return true.
        """
        return _Domi.MDMap_hasPadding(self, *args)

    def getLowerPadSize(self, *args) -> "int":
        r"""
         Get the size of the lower padding along the given axis

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        Note that the returned padding can be either communication
        padding or boundary padding as appropriate.
        """
        return _Domi.MDMap_getLowerPadSize(self, *args)

    def getUpperPadSize(self, *args) -> "int":
        r"""
         Get the size of the upper padding along the given axis

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        Note that the returned padding can be either communication
        padding or boundary padding as appropriate.
        """
        return _Domi.MDMap_getUpperPadSize(self, *args)

    def getCommPadSize(self, *args) -> "int":
        r"""
         Get the communication padding size along the given axis

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        This returns the value of the communication padding along the
        given axis at the time of construction, regardless of the
        processor's position relative to the domain boundary.
        """
        return _Domi.MDMap_getCommPadSize(self, *args)

    def getLowerBndryPad(self, *args) -> "int":
        r"""
         Get the size of the lower boundary padding along the
                given axis

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)
        """
        return _Domi.MDMap_getLowerBndryPad(self, *args)

    def getUpperBndryPad(self, *args) -> "int":
        r"""
         Get the size of the upper boundary padding along the
                given axis

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)
        """
        return _Domi.MDMap_getUpperBndryPad(self, *args)

    def getBndryPadSizes(self, *args) -> "Teuchos::Array< int >":
        r"""
         Get the boundary padding sizes along each axis

        This returns an array of the boundary padding along each axis at
        the time of construction, regardless of whether a subsequent
        sub-map reduced these values.
        """
        return _Domi.MDMap_getBndryPadSizes(self, *args)

    def getBndryPadSize(self, *args) -> "int":
        r"""
         Get the boundary padding size along the given axis

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        This returns the value of the boundary padding along the given
        axis at the time of construction, regardless of whether a sub-map
        reduced these values.
        """
        return _Domi.MDMap_getBndryPadSize(self, *args)

    def isPad(self, *args) -> "bool":
        return _Domi.MDMap_isPad(self, *args)

    def isCommPad(self, *args) -> "bool":
        return _Domi.MDMap_isCommPad(self, *args)

    def isBndryPad(self, *args) -> "bool":
        return _Domi.MDMap_isBndryPad(self, *args)

    def isReplicatedBoundary(self, *args) -> "bool":
        r""" Return whether the given axis supports a replicated boundary"""
        return _Domi.MDMap_isReplicatedBoundary(self, *args)

    def getLayout(self, *args) -> "Domi::Layout":
        r""" Get the storage order"""
        return _Domi.MDMap_getLayout(self, *args)

    def getAxisMaps(self, *args) -> "Teuchos::ArrayView< Teuchos::RCP< Domi::MDMap const > >":
        r"""
         Return an array of axis maps

        An axis map is a 1D map along a given axis.
        """
        return _Domi.MDMap_getAxisMaps(self, *args)

    def getAxisMap(self, *args) -> "Teuchos::RCP< Domi::MDMap const >":
        r"""
         Return an axis map for the given axis

        An axis map is a 1D map along a given axis.
        """
        return _Domi.MDMap_getAxisMap(self, *args)

    def getAugmentedMDMap(self, *args) -> "Teuchos::RCP< Domi::MDMap const >":
        r"""
         Return an RCP to a new MDMap that is a simple
                augmentation of this MDMap

        :type leadingDim: int
        :param leadingDim: [in] If this value is greater than 0, then add
                   a dimension to the new MDMap that comes before the
                   existing dimensions and has this many degrees of freedom.

        :type trailingDim: int, optional
        :param trailingDim: [in] If this value is greater than 0, then
                   add a dimension to the new MDMap that comes after the
                   existing dimensions and has this many degrees of freedom.

        Note that the new dimension(s) will not be distributed; i.e. the
        commDim for the new leading dimension (if requested) will be 1
        and the commDim for the trailing dimension (if requested) will be
        1.
        """
        return _Domi.MDMap_getAugmentedMDMap(self, *args)

    def getEpetraMap(self, *args) -> "Teuchos::RCP< Epetra_Map const >":
        r"""
         Return an RCP to an Epetra_Map that is equivalent to this
                MDMap

        :type withCommPad: boolean, optional
        :param withCommPad: [in] flag whether to include the communication
                   padding in the map

        Note that the boundary padding is always included in the map
        """
        return _Domi.MDMap_getEpetraMap(self, *args)

    def getEpetraAxisMap(self, *args) -> "Teuchos::RCP< Epetra_Map const >":
        r"""
         Return an RCP to an Epetra_Map that represents the
                decomposition of this MDMap along the given axis

        :type axis: int
        :param axis: [in] the requested axis

        :type withCommPad: boolean, optional
        :param withCommPad: [in] flag whether to include the communication
                   padding in the map

        Note that the boundary padding is always included in the map
        """
        return _Domi.MDMap_getEpetraAxisMap(self, *args)

    def getGlobalIndex(self, *args) -> "Teuchos::Array< Domi::dim_type >":
        r"""
         Convert a global ID to a global index

        :type globalID: Domi::size_type
        :param globalID: [in] a unique 1D global identifier
        """
        return _Domi.MDMap_getGlobalIndex(self, *args)

    def getLocalIndex(self, *args) -> "Teuchos::Array< Domi::dim_type >":
        r"""
         Convert a local ID to a local index

        :type localID: Domi::size_type
        :param localID: [in] a unique 1D local identifier
        """
        return _Domi.MDMap_getLocalIndex(self, *args)

    def getGlobalID(self, *args) -> "Domi::size_type":
        r"""
        *Overload 1:*
         Convert a local ID to a global ID

        :type localID: Domi::size_type
        :param localID: [in] a unique 1D local identifier

        |

        *Overload 2:*
         convert a global index to a global ID

        :type globalIndex: Teuchos::ArrayView< Domi::dim_type >
        :param globalIndex: [in] a global index
        """
        return _Domi.MDMap_getGlobalID(self, *args)

    def getLocalID(self, *args) -> "Domi::size_type":
        r"""
        *Overload 1:*
         Convert a global ID to a local ID

        :type globalID: Domi::size_type
        :param globalID: [in] a unique 1D global identifier

        This method can throw a Domi::RangeError if the global ID is
        not on the current processor.

        |

        *Overload 2:*
         Convert a local index to a local ID

        :type localIndex: Teuchos::ArrayView< Domi::dim_type >
        :param localIndex: [in] a local index
        """
        return _Domi.MDMap_getLocalID(self, *args)

    def isCompatible(self, *args) -> "bool":
        r"""
         True if two MDMaps are "compatible"

        :type mdMap: :py:class:`MDMap`
        :param mdMap: [in] MDMap to compare against

        Two MDMaps are considered "compatible" if all of the following
        are true:

          *  The commDims of their underlying MDComms are
               identical.
          *  Their global dimensions are identical.
          *  Their local dimensions, not including padding, are
               identical.
        """
        return _Domi.MDMap_isCompatible(self, *args)

    def isSameAs(self, *args) -> "bool":
        r"""
         True if two MDMaps are "identical"

        :type mdMap: :py:class:`MDMap`
        :param mdMap: [in] MDMap to compare against

        :type verbose: int, optional
        :param verbose: [in] set to one to print why MDMaps are not the
                   same

        Two MDMaps are considered "identical" if all of the following
        are true:

          *  They are compatible.
          *  Their underlying communicators are *congruent* (have
               the same number of processes, in the same order: this
               corresponds to the ``MPI_IDENT`` or ``MPI_CONGRUENT`` return
               values of MPI_Comm_compare).
          *  Both are distributed or not distributed.
          *  Their global bounds identical on each process.
          *  Their local dimensions, including padding, are
               identical.
        """
        return _Domi.MDMap_isSameAs(self, *args)

    def isContiguous(self, *args) -> "bool":
        r"""
         True if there are no stride gaps on any processor

        An MDMap constructed from a communicator and dimensions will
        always be contiguous.  An MDMap that is a slice of a parent MDMap
        will generally be non-contiguous, with some exceptions.  There
        are cases where some local data is contiguous and some is not,
        but this method returns True only if all processes' local data is
        contiguous.
        """
        return _Domi.MDMap_isContiguous(self, *args)

    def __getitem__(self, *args) -> "Domi::MDMap":
        return _Domi.MDMap___getitem__(self, *args)

    def getTpetraMap(self, *args) -> "Teuchos::RCP< Tpetra::Map< int,int,DefaultNodeType > const >":
        return _Domi.MDMap_getTpetraMap(self, *args)

    def getTpetraAxisMap(self, *args) -> "Teuchos::RCP< Tpetra::Map< int,int,DefaultNodeType > const >":
        return _Domi.MDMap_getTpetraAxisMap(self, *args)

# Register MDMap in _Domi:
_Domi.MDMap_swigregister(MDMap)


def MDVector_getattr(self, name):
    if name == "array":
        a = self.getData()
        self.__dict__["array"] = a
        return a
    elif name == "shape":
        return self.array.shape
    elif name == "dtype":
        return self.array.dtype
    else:
        raise AttributeError("'%s' not an attribute of MDVector" % name)
def MDVector_setattr(self, name, value):
    if name in ("array", "shape", "dtype"):
        raise AttributeError("Cannot change MDVector '%s' attribute", name)
    else:
        self.__dict__[name] = value
def upgradeMDVectorClass(cls):
    cls.__getattr__ = MDVector_getattr
    cls.__setattr__ = MDVector_setattr
    cls.__setitem__ = lambda self, i, v: self.array.__setitem__(i,v)
    cls.__len__     = lambda self: self.array.__len__()
    cls.__str__     = lambda self: self.array.__str__()
    cls.copy        = lambda self: cls(self)
    class_array_add_math(cls)
    class_array_add_comp(cls)


class MDVector_int(Teuchos.Base.Describable):
    r"""
     Multi-dimensional distributed vector

    The MDVector class is intended to perform the functions of
    Epetra or Tpetra MultiVectors (or Vectors), with the additional
    capability that the data can be multi-dimensional.  (Note that
    Epetra and Tpetra MultiVectors are 2 dimensional and distributed in
    an unstructured manner along only one of those dimensions.
    MDVectors can be any number of dimensions, and can be
    distributed in a structured fashion along all of them.)

    Where Epetra and Tpetra MultiVectors are built on top of
    Epetra_Maps and Tpetra::Maps, respectively, the
    MDVector is built on top of an MDMap.  As such,
    they support boundary padding, communication padding, and
    periodicity.

    The basic MDVector constructor takes an MDMap and an
    optional boolean flag providing instruction whether to zero out the
    data or not.  A slightly more advanced constructor takes an MDMap,
    a leading dimension, an optional trailing dimension, and an
    optional zero-out flag.  This allows the user to augment the given
    MDMap with an undistributed dimension.  This can be
    helpful when the user wants to store an array of quantities at each
    grid point.  These quantities can be clustered or strided in memory
    depending on whether a leading or trailing dimension is specified,
    and what the data Layout is.

    There are additional constructors as well, based on copying data,
    using Teuchos::ParameterLists to specify the
    MDVector layout, and parent/slice constructors, where
    slicing of the parent can be performed with an ordinal or a Slice.

    The ability to slice a parent MDVector and obtain a
    sub-vector is an important feature of the MDVector class.
    When you take a slice of a parent MDVector, the resulting
    sub-vector may have a new, reduced communicator (both a new
    MDComm and Teuchos::Comm).  When accessing a
    sub-vector, you should always use the onSubcommunicator() method to
    determine that the sub-vector exists on the current processor.

    Like the Teuchos::MultiVector, the user cannot index
    directly into an MDVector.  Rather, he or she must use the
    getData() and getDataNonConst() methods to obtain
    an MDArrayView of the data for manipulation.  This is a
    little different than the Tpetra behavior, where an
    ArrayRCP is returned to the user.  For MDVector,
    and MDArrayView is returned, as this supports the slicing
    semantics of the class.  Note that each MDVector stores an
    internal MDArrayRCP of either its original data or its
    parent's data, and then it also stores an MDArrayView that
    is a view into the MDArrayRCP.  So the
    MDArrayView passed to the user will be valid as long as
    the reference count of its MDArrayRCP is greater than
    zero.  Looping bounds for this data can be obtained using the
    getLocalBounds() method, which returns a concrete
    Slice object, and takes a boolean that specifies whether
    padding should be included in the start and stop indexes.

    There are a variety of methods for converting MDVectors to
    Epetra or Tpetra MultiVectors or Vectors, using
    either view or copy semantics.  The view semantic is only available
    when the MDVector is contiguous in memory, meaning there
    are no stride gaps due to slicing.  The copy semantic is always
    available.  True Epetra or Tpetra MultiVectors, in which
    the number of vectors is greater than 1, are only available when
    there is a non-distributed leading dimension and the layout is
    C-order, or there is a non-distributed trailing dimension and the
    layout is Fortran-order.

    If the MDVector was built with communication padding, then
    the user may use the updateCommPad() method to communicate
    via message passing data from the owning processors into the
    communication padding buffers.  If communication along a single
    axis is desired, then the overloaded updateCommPad(int
    axis) method can be called instead.  If asynchronous
    communication is desired, where computations can be performed
    between posting and receiving messages, then the
    startUpdateCommPad(int axis) and endUpdateCommPad(int
    axis) methods can be called.  Note that the message data
    structures needed to coordinate these methods are stored
    internally.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        *Overload 1:*
         Main constructor

        :type mdMap: :py:class:`MDMap`
        :param mdMap: [in] MDMap that describes the domain decomposition
                   of this MDVector

        :type zeroOut: boolean, optional
        :param zeroOut: [in] flag to initialize all data to zero

        |

        *Overload 2:*
         Augmented constructor

        :type mdMap: :py:class:`MDMap`
        :param mdMap: [in] MDMap that describes the domain decomposition
                   of this MDVector

        :type leadingDim: int
        :param leadingDim: [in] leading augmentation dimension, typically
                   used to provide additional degrees of freedom at each
                   index defined by the MDMap

        :type trailingDim: int, optional
        :param trailingDim: [in] trailing augmentation dimension, typically
                   used to provide additional degrees of freedom at each
                   index defined by the MDMap

        :type zeroOut: boolean, optional
        :param zeroOut: [in] flag to initialize all data to zero

        If leadingDim or trailingDim is less than 2, then the MDMap will
        not be augmented with a leading dimension or trailing dimension,
        respectively.  Note that this constructor takes the given MDMap
        and computes a new, augmented MDComm and a new MDMap for this
        MDVector.

        |

        *Overload 3:*
         Constructor with initialization values (copy)

        :type mdMap: :py:class:`MDMap`
        :param mdMap: [in] MDMap that describes the domain decomposition
                   of this MDVector

        :type source: Domi::MDArrayView< int >
        :param source: [in] initialization values

        |

        *Overload 4:*
         Constructor with managed array object (view)

        :type mdMap: :py:class:`MDMap`
        :param mdMap: [in] MDMap that describes the domain decomposition
                   of this MDVector

        :type source: Domi::MDArrayRCP< int >
        :param source: [in] memory-managed multi-dimensional array

        |

        *Overload 5:*
         Copy constructor with view or copy semantics

        :type source: Domi::MDVector< int >
        :param source: [in] source MDVector

        :type access: int, optional
        :param access: [in] enumeration specifying view or copy
                   construction

        Create a new MDVector with the same structure of the source
        MDVector and either perform a deep copy or take a view of the
        source MDVector data for the new MDVector.  Default behavior is
        to use view semantics.

        |

        *Overload 6:*
         Constructor with Teuchos::Comm and ParameterList

        :type teuchosComm: Teuchos::Comm< int >
        :param teuchosComm: [in] The Teuchos Communicator.  Note that an
                   MDComm and MDMap will be constructed from the information
                   in plist.

        :type plist: :py:class:`ParameterList`
        :param plist: [in] ParameterList with construction information

                   <iframe src="domi.xml" width="100%" scrolling="no" frameborder="0">
                   </iframe>
                   <hr />


        |

        *Overload 7:*
         Constructor with MDComm and ParameterList

        :type mdComm: :py:class:`MDComm`
        :param mdComm: [in] an RCP of an MDComm (multi-dimensional
                   communicator), on which this MDMap will be built.

        :type plist: :py:class:`ParameterList`
        :param plist: [in] ParameterList with construction information

                   <iframe src="domi.xml" width="100%" scrolling="no" frameborder="0">
                   </iframe>
                   <hr />


        |

        *Overload 8:*
         Parent/single global ordinal sub-vector constructor

        :type parent: Domi::MDVector< int >
        :param parent: [in] an MDVector, from which this MDVector will be
                   derived

        :type axis: int
        :param axis: [in] the axis to which this index ordinal applies

        :type index: int
        :param index: [in] the global ordinal that defines the sub-vector

        |

        *Overload 9:*
         Parent/single slice sub-vector constructor

        :type parent: Domi::MDVector< int >
        :param parent: [in] an MDVector, from which this MDVector will be
                   derived

        :type axis: int
        :param axis: [in] the axis to which this slice applies

        :type slice: :py:class:`Slice`
        :param slice: [in] a slice of global ordinals describing the
                   sub-vector

        :type bndryPad: int, optional
        :param bndryPad: [in] the boundary padding along the altered axis
                   of the new sub-vector.  This may include indexes from the
                   boundary padding of the parent MDVector, but it does not
                   have to.

        |

        *Overload 10:*
         Parent/array of slices sub-vector constructor

        :type parent: Domi::MDVector< int >
        :param parent: [in] an MDVector, from which this sub-vector will
                   be derived.

        :type slices: Teuchos::ArrayView< Domi::Slice >
        :param slices: [in] an array of Slices of global axis indexes that
                   defines the sub-vector.  These slices must not include
                   indexes from the boundary padding along each axis.

        :type bndryPad: Teuchos::ArrayView< int >, optional
        :param bndryPad: [in] The boundary padding of the new sub-vector.
                   These may include indexes from the boundary padding of the
                   parent MDVector, but they do not have to.
        """
        _Domi.MDVector_int_swiginit(self, _Domi.new_MDVector_int(*args))
    __swig_destroy__ = _Domi.delete_MDVector_int

    def getMDMap(self, *args) -> "Teuchos::RCP< Domi::MDMap const > const":
        r""" MDMap accessor method"""
        return _Domi.MDVector_int_getMDMap(self, *args)

    def onSubcommunicator(self, *args) -> "bool":
        r"""
         Query whether this processor is on the sub-communicator

        Sub-communicators are formed when a parent MDVector is sliced by
        using the (parent,ordinal) or (parent,slice) constructors.  For a
        full communicator, this method will always return true.
        """
        return _Domi.MDVector_int_onSubcommunicator(self, *args)

    def getTeuchosComm(self, *args) -> "Teuchos::RCP< Teuchos::Comm< int > const >":
        r"""
         Get the Teuchos communicator

        Note that if the communicator is not a full communicator, i.e. a
        sub-communicator, that the underlying Comm pointer may be NULL,
        depending on this processor's rank.
        """
        return _Domi.MDVector_int_getTeuchosComm(self, *args)

    def numDims(self, *args) -> "int":
        r"""
         Get the number of dimensions

        This method will return 0 if the communicator is a
        sub-communicator and this processor does not belong to the
        sub-communicator.
        """
        return _Domi.MDVector_int_numDims(self, *args)

    def getCommDim(self, *args) -> "int":
        r"""
         Get the communicator size along the given axis

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        This method will throw a Domi::SubcommunicatorError if the
        communicator is a sub-communicator and this processor does not
        belong to the sub-communicator.
        """
        return _Domi.MDVector_int_getCommDim(self, *args)

    def isPeriodic(self, *args) -> "bool":
        r"""
         Return the periodic flag for the given axis.

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        This method will throw a Domi::SubcommunicatorError if the
        communicator is a sub-communicator and this processor does not
        belong to the sub-communicator.
        """
        return _Domi.MDVector_int_isPeriodic(self, *args)

    def getCommIndex(self, *args) -> "int":
        r"""
         Get the axis rank of this processor

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        This method will throw a Domi::SubcommunicatorError if the
        communicator is a sub-communicator and this processor does not
        belong to the sub-communicator.
        """
        return _Domi.MDVector_int_getCommIndex(self, *args)

    def getLowerNeighbor(self, *args) -> "int":
        r"""
         Get the rank of the lower neighbor

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        This method will throw a Domi::SubcommunicatorError if the
        communicator is a sub-communicator and this processor does not
        belong to the sub-communicator.

        If the periodic flag for the given axis is off, and the axis rank
        of the calling processor is zero, then this method returns -1.

        If the periodic flag for the given axis is on, and the axis rank
        of the calling processor is the highest axis rank processor along
        this axis, then the returned lower neighbor will be zero.
        """
        return _Domi.MDVector_int_getLowerNeighbor(self, *args)

    def getUpperNeighbor(self, *args) -> "int":
        r"""
         Get the rank of the upper neighbor

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        This method will throw a Domi::SubcommunicatorError if the
        communicator is a sub-communicator and this processor does not
        belong to the sub-communicator.

        If the periodic flag for the given axis is off, and the axis rank
        of the calling processor is the highest axis rank processor along
        this axis, then this method returns -1.

        If the periodic flag for the given axis is on, and the axis rank
        of the calling processor is zero, then the returned lower
        neighbor will be the highest axis rank processor along this axis.
        """
        return _Domi.MDVector_int_getUpperNeighbor(self, *args)

    def getGlobalDim(self, *args) -> "Domi::dim_type":
        r"""
         Get the global dimension along the specified axis

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        :type withBndryPad: boolean, optional
        :param withBndryPad: [in] specify whether the dimension should
                   include boundary padding or not
        """
        return _Domi.MDVector_int_getGlobalDim(self, *args)

    def getGlobalBounds(self, *args) -> "Domi::Slice":
        r"""
         Get the bounds of the global problem

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        :param withBndryPad: [in] specify whether the bounds should
                   include boundary padding or not
        """
        return _Domi.MDVector_int_getGlobalBounds(self, *args)

    def getGlobalRankBounds(self, *args) -> "Domi::Slice":
        r"""
         Get the global loop bounds on this processor along the
                specified axis

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        :param withBndryPadding: [in] specify whether the dimension should
                   include boundary padding or not

        The loop bounds are returned in the form of a Slice, in
        which the start() method returns the loop begin value,
        and the stop() method returns the non-inclusive end
        value.
        """
        return _Domi.MDVector_int_getGlobalRankBounds(self, *args)

    def getLocalDim(self, *args) -> "Domi::dim_type":
        r"""
         Get the local dimension along the specified axis

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        :type withCommPad: boolean, optional
        :param withCommPad: [in] specify whether the dimension should
                   include communication padding or not
        """
        return _Domi.MDVector_int_getLocalDim(self, *args)

    def getLocalBounds(self, *args) -> "Domi::Slice":
        r"""
        *Overload 1:*
         Get the local loop bounds along every axis

        The loop bounds are returned in the form of a Slice, in
        which the start() method returns the loop begin value,
        and the stop() method returns the non-inclusive end
        value.  For this method, padding is included in the bounds.

        |

        *Overload 2:*
         Get the local looping bounds along the specified axis

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        :type withPad: boolean, optional
        :param withPad: [in] specify whether the dimension should include
                   padding or not

        The loop bounds are returned in the form of a Slice, in
        which the start() method returns the loop begin value,
        and the stop() method returns the non-inclusive end
        value.
        """
        return _Domi.MDVector_int_getLocalBounds(self, *args)

    def getLocalInteriorBounds(self, *args) -> "Domi::Slice":
        r"""
         Get the local interior looping bounds along the specified
                axis

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        Local interior loop bounds are the same as local loop bounds
        without padding, except that for non-periodic axes the global end
        points of the given axis are excluded. For periodic axes, the
        local interior loop bounds are exactly the same as local loop
        bounds without padding.

        The loop bounds are returned in the form of a Slice, in
        which the start() method returns the loop begin value,
        and the stop() method returns the non-inclusive end
        value.
        """
        return _Domi.MDVector_int_getLocalInteriorBounds(self, *args)

    def hasPadding(self, *args) -> "bool":
        r"""
         Return true if there is any padding stored locally

        Note that it is not as simple as whether there were communication
        padding specified in the constructor.  Suppose non-zero
        communication padding was specified, but the problem is on one
        processor and no boundary padding was specified: this method will
        return false.  Similarly, if no communication padding was
        specified but boundary padding was, then boundary processors will
        have padding and this method will return true.
        """
        return _Domi.MDVector_int_hasPadding(self, *args)

    def getLowerPadSize(self, *args) -> "int":
        r"""
         Get the size of the lower padding along the given axis

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        Note that the returned padding can be either communication
        padding or boundary padding as appropriate.
        """
        return _Domi.MDVector_int_getLowerPadSize(self, *args)

    def getUpperPadSize(self, *args) -> "int":
        r"""
         Get the size of the upper padding along the given axis

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        Note that the returned padding can be either communication
        padding or boundary padding as appropriate.
        """
        return _Domi.MDVector_int_getUpperPadSize(self, *args)

    def getCommPadSize(self, *args) -> "int":
        r"""
         Get the communication padding size along the given axis

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        This returns the value of the communication padding along the
        given axis at the time of construction, regardless of the
        processor's position relative to the domain boundary.
        """
        return _Domi.MDVector_int_getCommPadSize(self, *args)

    def getLowerBndryPad(self, *args) -> "int":
        r"""
         Get the size of the lower boundary padding along the
                given axis

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)
        """
        return _Domi.MDVector_int_getLowerBndryPad(self, *args)

    def getUpperBndryPad(self, *args) -> "int":
        r"""
         Get the size of the upper boundary padding along the
                given axis

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)
        """
        return _Domi.MDVector_int_getUpperBndryPad(self, *args)

    def getBndryPadSize(self, *args) -> "int":
        r"""
         Get the boundary padding size along the given axis

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        This returns the value of the boundary padding along the given
        axis at the time of construction, regardless of whether a sub-map
        reduced these values.
        """
        return _Domi.MDVector_int_getBndryPadSize(self, *args)

    def setLowerPad(self, *args) -> "void":
        r"""
         Assign all elements of the lower pad a constant value

        :type axis: int
        :param axis: [in] the axis along which the lower padding is chosen

        :type value: int
        :param value: [in] the value to be assigned to all elements of the
                   lower padding
        """
        return _Domi.MDVector_int_setLowerPad(self, *args)

    def setUpperPad(self, *args) -> "void":
        r"""
         Assign all elements of the upper pad a constant value

        :type axis: int
        :param axis: [in] the axis along which the upper padding is chosen

        :type value: int
        :param value: [in] the value to be assigned to all elements of the
                   upper padding
        """
        return _Domi.MDVector_int_setUpperPad(self, *args)

    def isReplicatedBoundary(self, *args) -> "bool":
        r""" Return whether the given axis supports a replicated boundary"""
        return _Domi.MDVector_int_isReplicatedBoundary(self, *args)

    def getLayout(self, *args) -> "Domi::Layout":
        r""" Get the storage order"""
        return _Domi.MDVector_int_getLayout(self, *args)

    def isContiguous(self, *args) -> "bool":
        r"""
         True if there are no stride gaps on any processor

        An MDVector constructed from a communicator and dimensions will
        always be contiguous.  An MDVector that is a slice of a parent
        MDMVector will generally be non-contiguous, with some exceptions.
        There are cases where some local data is contiguous and some is
        not, but this method returns True only if all processes' local
        data is contiguous.
        """
        return _Domi.MDVector_int_isContiguous(self, *args)

    def getEpetraIntVectorView(self, *args) -> "Teuchos::RCP< Epetra_IntVector >":
        r"""
         Return a view of this MDVector as an Epetra_IntVector

        The multiple dimensions of the MDVector will be flattened in
        order to be expressed as an Epetra_IntVector.  Currently, if the
        MDVector is non-contiguous, a Domi::MDMapNoncontiguous exception
        will be thrown, as Epetra_IntVectors are contiguous, and this is
        a view transform.  Non-contiguous data is the result of slicing a
        parent MDVector.  In this case, getEpetraIntVectorView() should
        be called on the parent, or getEpetraIntVectorCopy() should be
        called on this non-contiguous MDVector.

        The MDVector Scalar template must be the same type as an
        Epetra_IntVector, i.e. int, or a Domi::TypeError exception will
        be thrown.
        """
        return _Domi.MDVector_int_getEpetraIntVectorView(self, *args)

    def getEpetraVectorView(self, *args) -> "Teuchos::RCP< Epetra_Vector >":
        r"""
         Return a view of this MDVector as an Epetra_Vector

        The multiple dimensions of the MDVector will be flattened in
        order to be expressed as an Epetra_Vector.  Currently, if the
        MDVector is non-contiguous, a Domi::MDMapNoncontiguous exception
        will be thrown, as Epetra_Vectors are contiguous, and this is a
        view transform.  Non-contiguous data is the result of slicing a
        parent MDVector.  In this case, getEpetraVectorView() should be
        called on the parent, or getEpetraVectorCopy() should be called
        on this non-contiguous MDVector.

        The MDVector Scalar template must be the same type as an
        Epetra_Vector, i.e. double, or a Domi::TypeError exception will
        be thrown.
        """
        return _Domi.MDVector_int_getEpetraVectorView(self, *args)

    def getEpetraMultiVectorView(self, *args) -> "Teuchos::RCP< Epetra_MultiVector >":
        r"""
         Return a view of this MDVector as an Epetra_MultiVector

        This method will attempt to utilize either the leading dimension
        (if the layout is C-order) or the trailing dimension (if the
        layout is Fortran-order) to serve as the Epetra_MultiVector
        vector index.  This dimension must be non-distributed (i.e., the
        corresponding commDim must be 1) in order for this mapping to
        work.  There must also be no padding associated with this axis.
        If these requirements are not met, then the entire MDVector will
        be treated as a single vector, that is the number of vectors will
        equal 1.

        Currently, if the MDVector is non-contiguous, a
        Domi::MDMapNoncontiguous exception will be thrown, as
        Epetra_MultiVectors are contiguous, and this is a view transform.

        The MDVector Scalar template must be the same type as an
        Epetra_MultiVector, i.e. double, or a Domi::TypeError exception
        will be thrown.
        """
        return _Domi.MDVector_int_getEpetraMultiVectorView(self, *args)

    def getEpetraIntVectorCopy(self, *args) -> "Teuchos::RCP< Epetra_IntVector >":
        r"""
         Return a copy of this MDVector as an Epetra_IntVector

        The multiple dimensions of the MDVector will be flattened in
        order to be expressed as an Epetra_IntVector.

        The MDVector Scalar template must be the same type as an
        Epetra_IntVector, i.e. int, or a Domi::TypeError exception will
        be thrown.
        """
        return _Domi.MDVector_int_getEpetraIntVectorCopy(self, *args)

    def getEpetraVectorCopy(self, *args) -> "Teuchos::RCP< Epetra_Vector >":
        r"""
         Return a copy of this MDVector as an Epetra_Vector

        The multiple dimensions of the MDVector will be flattened in
        order to be expressed as an Epetra_Vector.

        The MDVector Scalar template must be the same type as an
        Epetra_Vector, i.e. double, or a Domi::TypeError exception will
        be thrown.
        """
        return _Domi.MDVector_int_getEpetraVectorCopy(self, *args)

    def getEpetraMultiVectorCopy(self, *args) -> "Teuchos::RCP< Epetra_MultiVector >":
        r"""
         Return a copy of this MDVector as an Epetra_MultiVector

        This method will attempt to utilize either the leading dimension
        (if the layout is C-order) or the trailing dimension (if the
        layout is Fortran-order) to serve as the Epetra_MultiVector
        vector index.  This dimension must be non-distributed (i.e., the
        corresponding commDim must be 1) in order for this mapping to
        work.  There must also be no padding associated with this axis.
        If these requirements are not met, then the entire MDVector will
        be treated as a single vector, that is the number of vectors will
        equal 1.

        The MDVector Scalar template must be the same type as an
        Epetra_MultiVector, i.e. double, or a Domi::TypeError exception
        will be thrown.
        """
        return _Domi.MDVector_int_getEpetraMultiVectorCopy(self, *args)

    def getLowerPadDataNonConst(self, *args) -> "Domi::MDArrayView< int >":
        r"""
         Get a non-const view of the lower padding data along the
                given axis as an MDArrayView

        :type axis: int
        :param axis: [in] the axis from which to extract the lower padding
        """
        return _Domi.MDVector_int_getLowerPadDataNonConst(self, *args)

    def getLowerPadData(self, *args) -> "Domi::MDArrayView< int const >":
        r"""
         Get a const view of the lower padding data along the
                given axis as an MDArrayView

        :type axis: int
        :param axis: [in] the axis from which to extract the lower padding
        """
        return _Domi.MDVector_int_getLowerPadData(self, *args)

    def getUpperPadDataNonConst(self, *args) -> "Domi::MDArrayView< int >":
        r"""
         Get a non-const view of the upper padding data along the
                given axis as an MDArrayView

        :type axis: int
        :param axis: [in] the axis from which to extract the upper padding
        """
        return _Domi.MDVector_int_getUpperPadDataNonConst(self, *args)

    def getUpperPadData(self, *args) -> "Domi::MDArrayView< int const >":
        r"""
         Get a const view of the upper padding data along the
                given axis as an MDArrayView

        :type axis: int
        :param axis: [in] the axis from which to extract the upper padding
        """
        return _Domi.MDVector_int_getUpperPadData(self, *args)

    def dot(self, *args) -> "int":
        r"""
         Compute the dot product of this MDVector and MDVector a

        :type a: Domi::MDVector< int >
        :param a: [in] partner MDVector for performing dot product
        """
        return _Domi.MDVector_int_dot(self, *args)

    def norm1(self, *args) -> "Teuchos::ScalarTraits< int >::magnitudeType":
        r""" Compute the 1-norm of this MDVector"""
        return _Domi.MDVector_int_norm1(self, *args)

    def norm2(self, *args) -> "Teuchos::ScalarTraits< int >::magnitudeType":
        r""" Compute the 2-norm of this MDVector"""
        return _Domi.MDVector_int_norm2(self, *args)

    def normInf(self, *args) -> "Teuchos::ScalarTraits< int >::magnitudeType":
        r""" Compute the infinity-norm of this MDVector"""
        return _Domi.MDVector_int_normInf(self, *args)

    def normWeighted(self, *args) -> "Teuchos::ScalarTraits< int >::magnitudeType":
        r"""
         Compute the weighted norm of this

        :type weights: Domi::MDVector< int >
        :param weights: [in] MDVector of weights for weighted norm
        """
        return _Domi.MDVector_int_normWeighted(self, *args)

    def meanValue(self, *args) -> "int":
        r""" Compute the mean (average) value of this MDVector"""
        return _Domi.MDVector_int_meanValue(self, *args)

    def description(self, *args) -> "std::string":
        r""" A simple one-line description of this MDVector"""
        return _Domi.MDVector_int_description(self, *args)

    def describe(self, *args) -> "void":
        r"""
         Print the object with some verbosity level to a
                FancyOStream

        :type out: Teuchos::FancyOStream
        :param out: [in] output stream

        :type verbLevel: int, optional
        :param verbLevel: [in] verbosity level
        """
        return _Domi.MDVector_int_describe(self, *args)

    def putScalar(self, *args) -> "void":
        r"""
         Set all values in the multivector with the given value.

        :type value: int
        :param value: [in] assignment value

        :type includePadding: boolean, optional
        :param includePadding: [in] if true, assign values to the boundary
                   and communication padding as well
        """
        return _Domi.MDVector_int_putScalar(self, *args)

    def randomize(self, *args) -> "void":
        r""" Set all values in the multivector to pseudorandom numbers."""
        return _Domi.MDVector_int_randomize(self, *args)

    def updateCommPad(self, *args) -> "void":
        return _Domi.MDVector_int_updateCommPad(self, *args)

    def startUpdateCommPad(self, *args) -> "void":
        r"""
         Start an asyncronous update of the communication padding

        :type axis: int
        :param axis: [in] the axis along which communication will be
                   performed

        Post the non-blocking sends and receives for the communication
        padding along the given axis
        """
        return _Domi.MDVector_int_startUpdateCommPad(self, *args)

    def endUpdateCommPad(self, *args) -> "void":
        r"""
         Complete an asyncronous update of the communication padding

        :type axis: int
        :param axis: [in] the axis along which communication will be
                   performed

        Wait for all of the non-blocking updates for the communication
        padding along the given axis to complete
        """
        return _Domi.MDVector_int_endUpdateCommPad(self, *args)

    def writeBinary(self, *args) -> "void":
        r"""
         Write the MDVector to a binary file

        :type filename: string
        :param filename: [in] name of the output file

        :type includeBndryPad: boolean, optional
        :param includeBndryPad: [in] if true, include the boundary pad
                   with the output data
        """
        return _Domi.MDVector_int_writeBinary(self, *args)

    def readBinary(self, *args) -> "void":
        r"""
         Read the MDVector from a binary file

        :type filename: string
        :param filename: [in] name of the input file

        :type includeBndryPad: boolean, optional
        :param includeBndryPad: [in] if true, include the boundary pad
                   with the input data
        """
        return _Domi.MDVector_int_readBinary(self, *args)

    def __getitem__(self, *args) -> "Domi::MDVector< int >":
        return _Domi.MDVector_int___getitem__(self, *args)

    def getData(self, *args) -> "Domi::MDArrayView< int >":
        return _Domi.MDVector_int_getData(self, *args)

    def __distarray__(self, *args) -> "PyObject *":
        return _Domi.MDVector_int___distarray__(self, *args)

# Register MDVector_int in _Domi:
_Domi.MDVector_int_swigregister(MDVector_int)


upgradeMDVectorClass(MDVector_int)

class MDVector_long(Teuchos.Base.Describable):
    r"""
     Multi-dimensional distributed vector

    The MDVector class is intended to perform the functions of
    Epetra or Tpetra MultiVectors (or Vectors), with the additional
    capability that the data can be multi-dimensional.  (Note that
    Epetra and Tpetra MultiVectors are 2 dimensional and distributed in
    an unstructured manner along only one of those dimensions.
    MDVectors can be any number of dimensions, and can be
    distributed in a structured fashion along all of them.)

    Where Epetra and Tpetra MultiVectors are built on top of
    Epetra_Maps and Tpetra::Maps, respectively, the
    MDVector is built on top of an MDMap.  As such,
    they support boundary padding, communication padding, and
    periodicity.

    The basic MDVector constructor takes an MDMap and an
    optional boolean flag providing instruction whether to zero out the
    data or not.  A slightly more advanced constructor takes an MDMap,
    a leading dimension, an optional trailing dimension, and an
    optional zero-out flag.  This allows the user to augment the given
    MDMap with an undistributed dimension.  This can be
    helpful when the user wants to store an array of quantities at each
    grid point.  These quantities can be clustered or strided in memory
    depending on whether a leading or trailing dimension is specified,
    and what the data Layout is.

    There are additional constructors as well, based on copying data,
    using Teuchos::ParameterLists to specify the
    MDVector layout, and parent/slice constructors, where
    slicing of the parent can be performed with an ordinal or a Slice.

    The ability to slice a parent MDVector and obtain a
    sub-vector is an important feature of the MDVector class.
    When you take a slice of a parent MDVector, the resulting
    sub-vector may have a new, reduced communicator (both a new
    MDComm and Teuchos::Comm).  When accessing a
    sub-vector, you should always use the onSubcommunicator() method to
    determine that the sub-vector exists on the current processor.

    Like the Teuchos::MultiVector, the user cannot index
    directly into an MDVector.  Rather, he or she must use the
    getData() and getDataNonConst() methods to obtain
    an MDArrayView of the data for manipulation.  This is a
    little different than the Tpetra behavior, where an
    ArrayRCP is returned to the user.  For MDVector,
    and MDArrayView is returned, as this supports the slicing
    semantics of the class.  Note that each MDVector stores an
    internal MDArrayRCP of either its original data or its
    parent's data, and then it also stores an MDArrayView that
    is a view into the MDArrayRCP.  So the
    MDArrayView passed to the user will be valid as long as
    the reference count of its MDArrayRCP is greater than
    zero.  Looping bounds for this data can be obtained using the
    getLocalBounds() method, which returns a concrete
    Slice object, and takes a boolean that specifies whether
    padding should be included in the start and stop indexes.

    There are a variety of methods for converting MDVectors to
    Epetra or Tpetra MultiVectors or Vectors, using
    either view or copy semantics.  The view semantic is only available
    when the MDVector is contiguous in memory, meaning there
    are no stride gaps due to slicing.  The copy semantic is always
    available.  True Epetra or Tpetra MultiVectors, in which
    the number of vectors is greater than 1, are only available when
    there is a non-distributed leading dimension and the layout is
    C-order, or there is a non-distributed trailing dimension and the
    layout is Fortran-order.

    If the MDVector was built with communication padding, then
    the user may use the updateCommPad() method to communicate
    via message passing data from the owning processors into the
    communication padding buffers.  If communication along a single
    axis is desired, then the overloaded updateCommPad(int
    axis) method can be called instead.  If asynchronous
    communication is desired, where computations can be performed
    between posting and receiving messages, then the
    startUpdateCommPad(int axis) and endUpdateCommPad(int
    axis) methods can be called.  Note that the message data
    structures needed to coordinate these methods are stored
    internally.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        *Overload 1:*
         Main constructor

        :type mdMap: :py:class:`MDMap`
        :param mdMap: [in] MDMap that describes the domain decomposition
                   of this MDVector

        :type zeroOut: boolean, optional
        :param zeroOut: [in] flag to initialize all data to zero

        |

        *Overload 2:*
         Augmented constructor

        :type mdMap: :py:class:`MDMap`
        :param mdMap: [in] MDMap that describes the domain decomposition
                   of this MDVector

        :type leadingDim: int
        :param leadingDim: [in] leading augmentation dimension, typically
                   used to provide additional degrees of freedom at each
                   index defined by the MDMap

        :type trailingDim: int, optional
        :param trailingDim: [in] trailing augmentation dimension, typically
                   used to provide additional degrees of freedom at each
                   index defined by the MDMap

        :type zeroOut: boolean, optional
        :param zeroOut: [in] flag to initialize all data to zero

        If leadingDim or trailingDim is less than 2, then the MDMap will
        not be augmented with a leading dimension or trailing dimension,
        respectively.  Note that this constructor takes the given MDMap
        and computes a new, augmented MDComm and a new MDMap for this
        MDVector.

        |

        *Overload 3:*
         Constructor with initialization values (copy)

        :type mdMap: :py:class:`MDMap`
        :param mdMap: [in] MDMap that describes the domain decomposition
                   of this MDVector

        :type source: Domi::MDArrayView< long long >
        :param source: [in] initialization values

        |

        *Overload 4:*
         Constructor with managed array object (view)

        :type mdMap: :py:class:`MDMap`
        :param mdMap: [in] MDMap that describes the domain decomposition
                   of this MDVector

        :type source: Domi::MDArrayRCP< long long >
        :param source: [in] memory-managed multi-dimensional array

        |

        *Overload 5:*
         Copy constructor with view or copy semantics

        :type source: Domi::MDVector< long long >
        :param source: [in] source MDVector

        :type access: int, optional
        :param access: [in] enumeration specifying view or copy
                   construction

        Create a new MDVector with the same structure of the source
        MDVector and either perform a deep copy or take a view of the
        source MDVector data for the new MDVector.  Default behavior is
        to use view semantics.

        |

        *Overload 6:*
         Constructor with Teuchos::Comm and ParameterList

        :type teuchosComm: Teuchos::Comm< int >
        :param teuchosComm: [in] The Teuchos Communicator.  Note that an
                   MDComm and MDMap will be constructed from the information
                   in plist.

        :type plist: :py:class:`ParameterList`
        :param plist: [in] ParameterList with construction information

                   <iframe src="domi.xml" width="100%" scrolling="no" frameborder="0">
                   </iframe>
                   <hr />


        |

        *Overload 7:*
         Constructor with MDComm and ParameterList

        :type mdComm: :py:class:`MDComm`
        :param mdComm: [in] an RCP of an MDComm (multi-dimensional
                   communicator), on which this MDMap will be built.

        :type plist: :py:class:`ParameterList`
        :param plist: [in] ParameterList with construction information

                   <iframe src="domi.xml" width="100%" scrolling="no" frameborder="0">
                   </iframe>
                   <hr />


        |

        *Overload 8:*
         Parent/single global ordinal sub-vector constructor

        :type parent: Domi::MDVector< long long >
        :param parent: [in] an MDVector, from which this MDVector will be
                   derived

        :type axis: int
        :param axis: [in] the axis to which this index ordinal applies

        :type index: int
        :param index: [in] the global ordinal that defines the sub-vector

        |

        *Overload 9:*
         Parent/single slice sub-vector constructor

        :type parent: Domi::MDVector< long long >
        :param parent: [in] an MDVector, from which this MDVector will be
                   derived

        :type axis: int
        :param axis: [in] the axis to which this slice applies

        :type slice: :py:class:`Slice`
        :param slice: [in] a slice of global ordinals describing the
                   sub-vector

        :type bndryPad: int, optional
        :param bndryPad: [in] the boundary padding along the altered axis
                   of the new sub-vector.  This may include indexes from the
                   boundary padding of the parent MDVector, but it does not
                   have to.

        |

        *Overload 10:*
         Parent/array of slices sub-vector constructor

        :type parent: Domi::MDVector< long long >
        :param parent: [in] an MDVector, from which this sub-vector will
                   be derived.

        :type slices: Teuchos::ArrayView< Domi::Slice >
        :param slices: [in] an array of Slices of global axis indexes that
                   defines the sub-vector.  These slices must not include
                   indexes from the boundary padding along each axis.

        :type bndryPad: Teuchos::ArrayView< int >, optional
        :param bndryPad: [in] The boundary padding of the new sub-vector.
                   These may include indexes from the boundary padding of the
                   parent MDVector, but they do not have to.
        """
        _Domi.MDVector_long_swiginit(self, _Domi.new_MDVector_long(*args))
    __swig_destroy__ = _Domi.delete_MDVector_long

    def getMDMap(self, *args) -> "Teuchos::RCP< Domi::MDMap const > const":
        r""" MDMap accessor method"""
        return _Domi.MDVector_long_getMDMap(self, *args)

    def onSubcommunicator(self, *args) -> "bool":
        r"""
         Query whether this processor is on the sub-communicator

        Sub-communicators are formed when a parent MDVector is sliced by
        using the (parent,ordinal) or (parent,slice) constructors.  For a
        full communicator, this method will always return true.
        """
        return _Domi.MDVector_long_onSubcommunicator(self, *args)

    def getTeuchosComm(self, *args) -> "Teuchos::RCP< Teuchos::Comm< int > const >":
        r"""
         Get the Teuchos communicator

        Note that if the communicator is not a full communicator, i.e. a
        sub-communicator, that the underlying Comm pointer may be NULL,
        depending on this processor's rank.
        """
        return _Domi.MDVector_long_getTeuchosComm(self, *args)

    def numDims(self, *args) -> "int":
        r"""
         Get the number of dimensions

        This method will return 0 if the communicator is a
        sub-communicator and this processor does not belong to the
        sub-communicator.
        """
        return _Domi.MDVector_long_numDims(self, *args)

    def getCommDim(self, *args) -> "int":
        r"""
         Get the communicator size along the given axis

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        This method will throw a Domi::SubcommunicatorError if the
        communicator is a sub-communicator and this processor does not
        belong to the sub-communicator.
        """
        return _Domi.MDVector_long_getCommDim(self, *args)

    def isPeriodic(self, *args) -> "bool":
        r"""
         Return the periodic flag for the given axis.

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        This method will throw a Domi::SubcommunicatorError if the
        communicator is a sub-communicator and this processor does not
        belong to the sub-communicator.
        """
        return _Domi.MDVector_long_isPeriodic(self, *args)

    def getCommIndex(self, *args) -> "int":
        r"""
         Get the axis rank of this processor

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        This method will throw a Domi::SubcommunicatorError if the
        communicator is a sub-communicator and this processor does not
        belong to the sub-communicator.
        """
        return _Domi.MDVector_long_getCommIndex(self, *args)

    def getLowerNeighbor(self, *args) -> "int":
        r"""
         Get the rank of the lower neighbor

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        This method will throw a Domi::SubcommunicatorError if the
        communicator is a sub-communicator and this processor does not
        belong to the sub-communicator.

        If the periodic flag for the given axis is off, and the axis rank
        of the calling processor is zero, then this method returns -1.

        If the periodic flag for the given axis is on, and the axis rank
        of the calling processor is the highest axis rank processor along
        this axis, then the returned lower neighbor will be zero.
        """
        return _Domi.MDVector_long_getLowerNeighbor(self, *args)

    def getUpperNeighbor(self, *args) -> "int":
        r"""
         Get the rank of the upper neighbor

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        This method will throw a Domi::SubcommunicatorError if the
        communicator is a sub-communicator and this processor does not
        belong to the sub-communicator.

        If the periodic flag for the given axis is off, and the axis rank
        of the calling processor is the highest axis rank processor along
        this axis, then this method returns -1.

        If the periodic flag for the given axis is on, and the axis rank
        of the calling processor is zero, then the returned lower
        neighbor will be the highest axis rank processor along this axis.
        """
        return _Domi.MDVector_long_getUpperNeighbor(self, *args)

    def getGlobalDim(self, *args) -> "Domi::dim_type":
        r"""
         Get the global dimension along the specified axis

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        :type withBndryPad: boolean, optional
        :param withBndryPad: [in] specify whether the dimension should
                   include boundary padding or not
        """
        return _Domi.MDVector_long_getGlobalDim(self, *args)

    def getGlobalBounds(self, *args) -> "Domi::Slice":
        r"""
         Get the bounds of the global problem

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        :param withBndryPad: [in] specify whether the bounds should
                   include boundary padding or not
        """
        return _Domi.MDVector_long_getGlobalBounds(self, *args)

    def getGlobalRankBounds(self, *args) -> "Domi::Slice":
        r"""
         Get the global loop bounds on this processor along the
                specified axis

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        :param withBndryPadding: [in] specify whether the dimension should
                   include boundary padding or not

        The loop bounds are returned in the form of a Slice, in
        which the start() method returns the loop begin value,
        and the stop() method returns the non-inclusive end
        value.
        """
        return _Domi.MDVector_long_getGlobalRankBounds(self, *args)

    def getLocalDim(self, *args) -> "Domi::dim_type":
        r"""
         Get the local dimension along the specified axis

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        :type withCommPad: boolean, optional
        :param withCommPad: [in] specify whether the dimension should
                   include communication padding or not
        """
        return _Domi.MDVector_long_getLocalDim(self, *args)

    def getLocalBounds(self, *args) -> "Domi::Slice":
        r"""
        *Overload 1:*
         Get the local loop bounds along every axis

        The loop bounds are returned in the form of a Slice, in
        which the start() method returns the loop begin value,
        and the stop() method returns the non-inclusive end
        value.  For this method, padding is included in the bounds.

        |

        *Overload 2:*
         Get the local looping bounds along the specified axis

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        :type withPad: boolean, optional
        :param withPad: [in] specify whether the dimension should include
                   padding or not

        The loop bounds are returned in the form of a Slice, in
        which the start() method returns the loop begin value,
        and the stop() method returns the non-inclusive end
        value.
        """
        return _Domi.MDVector_long_getLocalBounds(self, *args)

    def getLocalInteriorBounds(self, *args) -> "Domi::Slice":
        r"""
         Get the local interior looping bounds along the specified
                axis

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        Local interior loop bounds are the same as local loop bounds
        without padding, except that for non-periodic axes the global end
        points of the given axis are excluded. For periodic axes, the
        local interior loop bounds are exactly the same as local loop
        bounds without padding.

        The loop bounds are returned in the form of a Slice, in
        which the start() method returns the loop begin value,
        and the stop() method returns the non-inclusive end
        value.
        """
        return _Domi.MDVector_long_getLocalInteriorBounds(self, *args)

    def hasPadding(self, *args) -> "bool":
        r"""
         Return true if there is any padding stored locally

        Note that it is not as simple as whether there were communication
        padding specified in the constructor.  Suppose non-zero
        communication padding was specified, but the problem is on one
        processor and no boundary padding was specified: this method will
        return false.  Similarly, if no communication padding was
        specified but boundary padding was, then boundary processors will
        have padding and this method will return true.
        """
        return _Domi.MDVector_long_hasPadding(self, *args)

    def getLowerPadSize(self, *args) -> "int":
        r"""
         Get the size of the lower padding along the given axis

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        Note that the returned padding can be either communication
        padding or boundary padding as appropriate.
        """
        return _Domi.MDVector_long_getLowerPadSize(self, *args)

    def getUpperPadSize(self, *args) -> "int":
        r"""
         Get the size of the upper padding along the given axis

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        Note that the returned padding can be either communication
        padding or boundary padding as appropriate.
        """
        return _Domi.MDVector_long_getUpperPadSize(self, *args)

    def getCommPadSize(self, *args) -> "int":
        r"""
         Get the communication padding size along the given axis

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        This returns the value of the communication padding along the
        given axis at the time of construction, regardless of the
        processor's position relative to the domain boundary.
        """
        return _Domi.MDVector_long_getCommPadSize(self, *args)

    def getLowerBndryPad(self, *args) -> "int":
        r"""
         Get the size of the lower boundary padding along the
                given axis

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)
        """
        return _Domi.MDVector_long_getLowerBndryPad(self, *args)

    def getUpperBndryPad(self, *args) -> "int":
        r"""
         Get the size of the upper boundary padding along the
                given axis

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)
        """
        return _Domi.MDVector_long_getUpperBndryPad(self, *args)

    def getBndryPadSize(self, *args) -> "int":
        r"""
         Get the boundary padding size along the given axis

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        This returns the value of the boundary padding along the given
        axis at the time of construction, regardless of whether a sub-map
        reduced these values.
        """
        return _Domi.MDVector_long_getBndryPadSize(self, *args)

    def setLowerPad(self, *args) -> "void":
        r"""
         Assign all elements of the lower pad a constant value

        :type axis: int
        :param axis: [in] the axis along which the lower padding is chosen

        :type value: int
        :param value: [in] the value to be assigned to all elements of the
                   lower padding
        """
        return _Domi.MDVector_long_setLowerPad(self, *args)

    def setUpperPad(self, *args) -> "void":
        r"""
         Assign all elements of the upper pad a constant value

        :type axis: int
        :param axis: [in] the axis along which the upper padding is chosen

        :type value: int
        :param value: [in] the value to be assigned to all elements of the
                   upper padding
        """
        return _Domi.MDVector_long_setUpperPad(self, *args)

    def isReplicatedBoundary(self, *args) -> "bool":
        r""" Return whether the given axis supports a replicated boundary"""
        return _Domi.MDVector_long_isReplicatedBoundary(self, *args)

    def getLayout(self, *args) -> "Domi::Layout":
        r""" Get the storage order"""
        return _Domi.MDVector_long_getLayout(self, *args)

    def isContiguous(self, *args) -> "bool":
        r"""
         True if there are no stride gaps on any processor

        An MDVector constructed from a communicator and dimensions will
        always be contiguous.  An MDVector that is a slice of a parent
        MDMVector will generally be non-contiguous, with some exceptions.
        There are cases where some local data is contiguous and some is
        not, but this method returns True only if all processes' local
        data is contiguous.
        """
        return _Domi.MDVector_long_isContiguous(self, *args)

    def getEpetraIntVectorView(self, *args) -> "Teuchos::RCP< Epetra_IntVector >":
        r"""
         Return a view of this MDVector as an Epetra_IntVector

        The multiple dimensions of the MDVector will be flattened in
        order to be expressed as an Epetra_IntVector.  Currently, if the
        MDVector is non-contiguous, a Domi::MDMapNoncontiguous exception
        will be thrown, as Epetra_IntVectors are contiguous, and this is
        a view transform.  Non-contiguous data is the result of slicing a
        parent MDVector.  In this case, getEpetraIntVectorView() should
        be called on the parent, or getEpetraIntVectorCopy() should be
        called on this non-contiguous MDVector.

        The MDVector Scalar template must be the same type as an
        Epetra_IntVector, i.e. int, or a Domi::TypeError exception will
        be thrown.
        """
        return _Domi.MDVector_long_getEpetraIntVectorView(self, *args)

    def getEpetraVectorView(self, *args) -> "Teuchos::RCP< Epetra_Vector >":
        r"""
         Return a view of this MDVector as an Epetra_Vector

        The multiple dimensions of the MDVector will be flattened in
        order to be expressed as an Epetra_Vector.  Currently, if the
        MDVector is non-contiguous, a Domi::MDMapNoncontiguous exception
        will be thrown, as Epetra_Vectors are contiguous, and this is a
        view transform.  Non-contiguous data is the result of slicing a
        parent MDVector.  In this case, getEpetraVectorView() should be
        called on the parent, or getEpetraVectorCopy() should be called
        on this non-contiguous MDVector.

        The MDVector Scalar template must be the same type as an
        Epetra_Vector, i.e. double, or a Domi::TypeError exception will
        be thrown.
        """
        return _Domi.MDVector_long_getEpetraVectorView(self, *args)

    def getEpetraMultiVectorView(self, *args) -> "Teuchos::RCP< Epetra_MultiVector >":
        r"""
         Return a view of this MDVector as an Epetra_MultiVector

        This method will attempt to utilize either the leading dimension
        (if the layout is C-order) or the trailing dimension (if the
        layout is Fortran-order) to serve as the Epetra_MultiVector
        vector index.  This dimension must be non-distributed (i.e., the
        corresponding commDim must be 1) in order for this mapping to
        work.  There must also be no padding associated with this axis.
        If these requirements are not met, then the entire MDVector will
        be treated as a single vector, that is the number of vectors will
        equal 1.

        Currently, if the MDVector is non-contiguous, a
        Domi::MDMapNoncontiguous exception will be thrown, as
        Epetra_MultiVectors are contiguous, and this is a view transform.

        The MDVector Scalar template must be the same type as an
        Epetra_MultiVector, i.e. double, or a Domi::TypeError exception
        will be thrown.
        """
        return _Domi.MDVector_long_getEpetraMultiVectorView(self, *args)

    def getEpetraIntVectorCopy(self, *args) -> "Teuchos::RCP< Epetra_IntVector >":
        r"""
         Return a copy of this MDVector as an Epetra_IntVector

        The multiple dimensions of the MDVector will be flattened in
        order to be expressed as an Epetra_IntVector.

        The MDVector Scalar template must be the same type as an
        Epetra_IntVector, i.e. int, or a Domi::TypeError exception will
        be thrown.
        """
        return _Domi.MDVector_long_getEpetraIntVectorCopy(self, *args)

    def getEpetraVectorCopy(self, *args) -> "Teuchos::RCP< Epetra_Vector >":
        r"""
         Return a copy of this MDVector as an Epetra_Vector

        The multiple dimensions of the MDVector will be flattened in
        order to be expressed as an Epetra_Vector.

        The MDVector Scalar template must be the same type as an
        Epetra_Vector, i.e. double, or a Domi::TypeError exception will
        be thrown.
        """
        return _Domi.MDVector_long_getEpetraVectorCopy(self, *args)

    def getEpetraMultiVectorCopy(self, *args) -> "Teuchos::RCP< Epetra_MultiVector >":
        r"""
         Return a copy of this MDVector as an Epetra_MultiVector

        This method will attempt to utilize either the leading dimension
        (if the layout is C-order) or the trailing dimension (if the
        layout is Fortran-order) to serve as the Epetra_MultiVector
        vector index.  This dimension must be non-distributed (i.e., the
        corresponding commDim must be 1) in order for this mapping to
        work.  There must also be no padding associated with this axis.
        If these requirements are not met, then the entire MDVector will
        be treated as a single vector, that is the number of vectors will
        equal 1.

        The MDVector Scalar template must be the same type as an
        Epetra_MultiVector, i.e. double, or a Domi::TypeError exception
        will be thrown.
        """
        return _Domi.MDVector_long_getEpetraMultiVectorCopy(self, *args)

    def getLowerPadDataNonConst(self, *args) -> "Domi::MDArrayView< long long >":
        r"""
         Get a non-const view of the lower padding data along the
                given axis as an MDArrayView

        :type axis: int
        :param axis: [in] the axis from which to extract the lower padding
        """
        return _Domi.MDVector_long_getLowerPadDataNonConst(self, *args)

    def getLowerPadData(self, *args) -> "Domi::MDArrayView< long long const >":
        r"""
         Get a const view of the lower padding data along the
                given axis as an MDArrayView

        :type axis: int
        :param axis: [in] the axis from which to extract the lower padding
        """
        return _Domi.MDVector_long_getLowerPadData(self, *args)

    def getUpperPadDataNonConst(self, *args) -> "Domi::MDArrayView< long long >":
        r"""
         Get a non-const view of the upper padding data along the
                given axis as an MDArrayView

        :type axis: int
        :param axis: [in] the axis from which to extract the upper padding
        """
        return _Domi.MDVector_long_getUpperPadDataNonConst(self, *args)

    def getUpperPadData(self, *args) -> "Domi::MDArrayView< long long const >":
        r"""
         Get a const view of the upper padding data along the
                given axis as an MDArrayView

        :type axis: int
        :param axis: [in] the axis from which to extract the upper padding
        """
        return _Domi.MDVector_long_getUpperPadData(self, *args)

    def dot(self, *args) -> "long long":
        r"""
         Compute the dot product of this MDVector and MDVector a

        :type a: Domi::MDVector< long long >
        :param a: [in] partner MDVector for performing dot product
        """
        return _Domi.MDVector_long_dot(self, *args)

    def norm1(self, *args) -> "Teuchos::ScalarTraits< long long >::magnitudeType":
        r""" Compute the 1-norm of this MDVector"""
        return _Domi.MDVector_long_norm1(self, *args)

    def norm2(self, *args) -> "Teuchos::ScalarTraits< long long >::magnitudeType":
        r""" Compute the 2-norm of this MDVector"""
        return _Domi.MDVector_long_norm2(self, *args)

    def normInf(self, *args) -> "Teuchos::ScalarTraits< long long >::magnitudeType":
        r""" Compute the infinity-norm of this MDVector"""
        return _Domi.MDVector_long_normInf(self, *args)

    def normWeighted(self, *args) -> "Teuchos::ScalarTraits< long long >::magnitudeType":
        r"""
         Compute the weighted norm of this

        :type weights: Domi::MDVector< long long >
        :param weights: [in] MDVector of weights for weighted norm
        """
        return _Domi.MDVector_long_normWeighted(self, *args)

    def meanValue(self, *args) -> "long long":
        r""" Compute the mean (average) value of this MDVector"""
        return _Domi.MDVector_long_meanValue(self, *args)

    def description(self, *args) -> "std::string":
        r""" A simple one-line description of this MDVector"""
        return _Domi.MDVector_long_description(self, *args)

    def describe(self, *args) -> "void":
        r"""
         Print the object with some verbosity level to a
                FancyOStream

        :type out: Teuchos::FancyOStream
        :param out: [in] output stream

        :type verbLevel: int, optional
        :param verbLevel: [in] verbosity level
        """
        return _Domi.MDVector_long_describe(self, *args)

    def putScalar(self, *args) -> "void":
        r"""
         Set all values in the multivector with the given value.

        :type value: int
        :param value: [in] assignment value

        :type includePadding: boolean, optional
        :param includePadding: [in] if true, assign values to the boundary
                   and communication padding as well
        """
        return _Domi.MDVector_long_putScalar(self, *args)

    def randomize(self, *args) -> "void":
        r""" Set all values in the multivector to pseudorandom numbers."""
        return _Domi.MDVector_long_randomize(self, *args)

    def updateCommPad(self, *args) -> "void":
        return _Domi.MDVector_long_updateCommPad(self, *args)

    def startUpdateCommPad(self, *args) -> "void":
        r"""
         Start an asyncronous update of the communication padding

        :type axis: int
        :param axis: [in] the axis along which communication will be
                   performed

        Post the non-blocking sends and receives for the communication
        padding along the given axis
        """
        return _Domi.MDVector_long_startUpdateCommPad(self, *args)

    def endUpdateCommPad(self, *args) -> "void":
        r"""
         Complete an asyncronous update of the communication padding

        :type axis: int
        :param axis: [in] the axis along which communication will be
                   performed

        Wait for all of the non-blocking updates for the communication
        padding along the given axis to complete
        """
        return _Domi.MDVector_long_endUpdateCommPad(self, *args)

    def writeBinary(self, *args) -> "void":
        r"""
         Write the MDVector to a binary file

        :type filename: string
        :param filename: [in] name of the output file

        :type includeBndryPad: boolean, optional
        :param includeBndryPad: [in] if true, include the boundary pad
                   with the output data
        """
        return _Domi.MDVector_long_writeBinary(self, *args)

    def readBinary(self, *args) -> "void":
        r"""
         Read the MDVector from a binary file

        :type filename: string
        :param filename: [in] name of the input file

        :type includeBndryPad: boolean, optional
        :param includeBndryPad: [in] if true, include the boundary pad
                   with the input data
        """
        return _Domi.MDVector_long_readBinary(self, *args)

    def __getitem__(self, *args) -> "Domi::MDVector< long long >":
        return _Domi.MDVector_long___getitem__(self, *args)

    def getData(self, *args) -> "Domi::MDArrayView< long long >":
        return _Domi.MDVector_long_getData(self, *args)

    def __distarray__(self, *args) -> "PyObject *":
        return _Domi.MDVector_long___distarray__(self, *args)

# Register MDVector_long in _Domi:
_Domi.MDVector_long_swigregister(MDVector_long)


upgradeMDVectorClass(MDVector_long)

class MDVector_double(Teuchos.Base.Describable):
    r"""
     Multi-dimensional distributed vector

    The MDVector class is intended to perform the functions of
    Epetra or Tpetra MultiVectors (or Vectors), with the additional
    capability that the data can be multi-dimensional.  (Note that
    Epetra and Tpetra MultiVectors are 2 dimensional and distributed in
    an unstructured manner along only one of those dimensions.
    MDVectors can be any number of dimensions, and can be
    distributed in a structured fashion along all of them.)

    Where Epetra and Tpetra MultiVectors are built on top of
    Epetra_Maps and Tpetra::Maps, respectively, the
    MDVector is built on top of an MDMap.  As such,
    they support boundary padding, communication padding, and
    periodicity.

    The basic MDVector constructor takes an MDMap and an
    optional boolean flag providing instruction whether to zero out the
    data or not.  A slightly more advanced constructor takes an MDMap,
    a leading dimension, an optional trailing dimension, and an
    optional zero-out flag.  This allows the user to augment the given
    MDMap with an undistributed dimension.  This can be
    helpful when the user wants to store an array of quantities at each
    grid point.  These quantities can be clustered or strided in memory
    depending on whether a leading or trailing dimension is specified,
    and what the data Layout is.

    There are additional constructors as well, based on copying data,
    using Teuchos::ParameterLists to specify the
    MDVector layout, and parent/slice constructors, where
    slicing of the parent can be performed with an ordinal or a Slice.

    The ability to slice a parent MDVector and obtain a
    sub-vector is an important feature of the MDVector class.
    When you take a slice of a parent MDVector, the resulting
    sub-vector may have a new, reduced communicator (both a new
    MDComm and Teuchos::Comm).  When accessing a
    sub-vector, you should always use the onSubcommunicator() method to
    determine that the sub-vector exists on the current processor.

    Like the Teuchos::MultiVector, the user cannot index
    directly into an MDVector.  Rather, he or she must use the
    getData() and getDataNonConst() methods to obtain
    an MDArrayView of the data for manipulation.  This is a
    little different than the Tpetra behavior, where an
    ArrayRCP is returned to the user.  For MDVector,
    and MDArrayView is returned, as this supports the slicing
    semantics of the class.  Note that each MDVector stores an
    internal MDArrayRCP of either its original data or its
    parent's data, and then it also stores an MDArrayView that
    is a view into the MDArrayRCP.  So the
    MDArrayView passed to the user will be valid as long as
    the reference count of its MDArrayRCP is greater than
    zero.  Looping bounds for this data can be obtained using the
    getLocalBounds() method, which returns a concrete
    Slice object, and takes a boolean that specifies whether
    padding should be included in the start and stop indexes.

    There are a variety of methods for converting MDVectors to
    Epetra or Tpetra MultiVectors or Vectors, using
    either view or copy semantics.  The view semantic is only available
    when the MDVector is contiguous in memory, meaning there
    are no stride gaps due to slicing.  The copy semantic is always
    available.  True Epetra or Tpetra MultiVectors, in which
    the number of vectors is greater than 1, are only available when
    there is a non-distributed leading dimension and the layout is
    C-order, or there is a non-distributed trailing dimension and the
    layout is Fortran-order.

    If the MDVector was built with communication padding, then
    the user may use the updateCommPad() method to communicate
    via message passing data from the owning processors into the
    communication padding buffers.  If communication along a single
    axis is desired, then the overloaded updateCommPad(int
    axis) method can be called instead.  If asynchronous
    communication is desired, where computations can be performed
    between posting and receiving messages, then the
    startUpdateCommPad(int axis) and endUpdateCommPad(int
    axis) methods can be called.  Note that the message data
    structures needed to coordinate these methods are stored
    internally.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        *Overload 1:*
         Main constructor

        :type mdMap: :py:class:`MDMap`
        :param mdMap: [in] MDMap that describes the domain decomposition
                   of this MDVector

        :type zeroOut: boolean, optional
        :param zeroOut: [in] flag to initialize all data to zero

        |

        *Overload 2:*
         Augmented constructor

        :type mdMap: :py:class:`MDMap`
        :param mdMap: [in] MDMap that describes the domain decomposition
                   of this MDVector

        :type leadingDim: int
        :param leadingDim: [in] leading augmentation dimension, typically
                   used to provide additional degrees of freedom at each
                   index defined by the MDMap

        :type trailingDim: int, optional
        :param trailingDim: [in] trailing augmentation dimension, typically
                   used to provide additional degrees of freedom at each
                   index defined by the MDMap

        :type zeroOut: boolean, optional
        :param zeroOut: [in] flag to initialize all data to zero

        If leadingDim or trailingDim is less than 2, then the MDMap will
        not be augmented with a leading dimension or trailing dimension,
        respectively.  Note that this constructor takes the given MDMap
        and computes a new, augmented MDComm and a new MDMap for this
        MDVector.

        |

        *Overload 3:*
         Constructor with initialization values (copy)

        :type mdMap: :py:class:`MDMap`
        :param mdMap: [in] MDMap that describes the domain decomposition
                   of this MDVector

        :type source: Domi::MDArrayView< double >
        :param source: [in] initialization values

        |

        *Overload 4:*
         Constructor with managed array object (view)

        :type mdMap: :py:class:`MDMap`
        :param mdMap: [in] MDMap that describes the domain decomposition
                   of this MDVector

        :type source: Domi::MDArrayRCP< double >
        :param source: [in] memory-managed multi-dimensional array

        |

        *Overload 5:*
         Copy constructor with view or copy semantics

        :type source: Domi::MDVector< double >
        :param source: [in] source MDVector

        :type access: int, optional
        :param access: [in] enumeration specifying view or copy
                   construction

        Create a new MDVector with the same structure of the source
        MDVector and either perform a deep copy or take a view of the
        source MDVector data for the new MDVector.  Default behavior is
        to use view semantics.

        |

        *Overload 6:*
         Constructor with Teuchos::Comm and ParameterList

        :type teuchosComm: Teuchos::Comm< int >
        :param teuchosComm: [in] The Teuchos Communicator.  Note that an
                   MDComm and MDMap will be constructed from the information
                   in plist.

        :type plist: :py:class:`ParameterList`
        :param plist: [in] ParameterList with construction information

                   <iframe src="domi.xml" width="100%" scrolling="no" frameborder="0">
                   </iframe>
                   <hr />


        |

        *Overload 7:*
         Constructor with MDComm and ParameterList

        :type mdComm: :py:class:`MDComm`
        :param mdComm: [in] an RCP of an MDComm (multi-dimensional
                   communicator), on which this MDMap will be built.

        :type plist: :py:class:`ParameterList`
        :param plist: [in] ParameterList with construction information

                   <iframe src="domi.xml" width="100%" scrolling="no" frameborder="0">
                   </iframe>
                   <hr />


        |

        *Overload 8:*
         Parent/single global ordinal sub-vector constructor

        :type parent: Domi::MDVector< double >
        :param parent: [in] an MDVector, from which this MDVector will be
                   derived

        :type axis: int
        :param axis: [in] the axis to which this index ordinal applies

        :type index: int
        :param index: [in] the global ordinal that defines the sub-vector

        |

        *Overload 9:*
         Parent/single slice sub-vector constructor

        :type parent: Domi::MDVector< double >
        :param parent: [in] an MDVector, from which this MDVector will be
                   derived

        :type axis: int
        :param axis: [in] the axis to which this slice applies

        :type slice: :py:class:`Slice`
        :param slice: [in] a slice of global ordinals describing the
                   sub-vector

        :type bndryPad: int, optional
        :param bndryPad: [in] the boundary padding along the altered axis
                   of the new sub-vector.  This may include indexes from the
                   boundary padding of the parent MDVector, but it does not
                   have to.

        |

        *Overload 10:*
         Parent/array of slices sub-vector constructor

        :type parent: Domi::MDVector< double >
        :param parent: [in] an MDVector, from which this sub-vector will
                   be derived.

        :type slices: Teuchos::ArrayView< Domi::Slice >
        :param slices: [in] an array of Slices of global axis indexes that
                   defines the sub-vector.  These slices must not include
                   indexes from the boundary padding along each axis.

        :type bndryPad: Teuchos::ArrayView< int >, optional
        :param bndryPad: [in] The boundary padding of the new sub-vector.
                   These may include indexes from the boundary padding of the
                   parent MDVector, but they do not have to.
        """
        _Domi.MDVector_double_swiginit(self, _Domi.new_MDVector_double(*args))
    __swig_destroy__ = _Domi.delete_MDVector_double

    def getMDMap(self, *args) -> "Teuchos::RCP< Domi::MDMap const > const":
        r""" MDMap accessor method"""
        return _Domi.MDVector_double_getMDMap(self, *args)

    def onSubcommunicator(self, *args) -> "bool":
        r"""
         Query whether this processor is on the sub-communicator

        Sub-communicators are formed when a parent MDVector is sliced by
        using the (parent,ordinal) or (parent,slice) constructors.  For a
        full communicator, this method will always return true.
        """
        return _Domi.MDVector_double_onSubcommunicator(self, *args)

    def getTeuchosComm(self, *args) -> "Teuchos::RCP< Teuchos::Comm< int > const >":
        r"""
         Get the Teuchos communicator

        Note that if the communicator is not a full communicator, i.e. a
        sub-communicator, that the underlying Comm pointer may be NULL,
        depending on this processor's rank.
        """
        return _Domi.MDVector_double_getTeuchosComm(self, *args)

    def numDims(self, *args) -> "int":
        r"""
         Get the number of dimensions

        This method will return 0 if the communicator is a
        sub-communicator and this processor does not belong to the
        sub-communicator.
        """
        return _Domi.MDVector_double_numDims(self, *args)

    def getCommDim(self, *args) -> "int":
        r"""
         Get the communicator size along the given axis

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        This method will throw a Domi::SubcommunicatorError if the
        communicator is a sub-communicator and this processor does not
        belong to the sub-communicator.
        """
        return _Domi.MDVector_double_getCommDim(self, *args)

    def isPeriodic(self, *args) -> "bool":
        r"""
         Return the periodic flag for the given axis.

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        This method will throw a Domi::SubcommunicatorError if the
        communicator is a sub-communicator and this processor does not
        belong to the sub-communicator.
        """
        return _Domi.MDVector_double_isPeriodic(self, *args)

    def getCommIndex(self, *args) -> "int":
        r"""
         Get the axis rank of this processor

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        This method will throw a Domi::SubcommunicatorError if the
        communicator is a sub-communicator and this processor does not
        belong to the sub-communicator.
        """
        return _Domi.MDVector_double_getCommIndex(self, *args)

    def getLowerNeighbor(self, *args) -> "int":
        r"""
         Get the rank of the lower neighbor

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        This method will throw a Domi::SubcommunicatorError if the
        communicator is a sub-communicator and this processor does not
        belong to the sub-communicator.

        If the periodic flag for the given axis is off, and the axis rank
        of the calling processor is zero, then this method returns -1.

        If the periodic flag for the given axis is on, and the axis rank
        of the calling processor is the highest axis rank processor along
        this axis, then the returned lower neighbor will be zero.
        """
        return _Domi.MDVector_double_getLowerNeighbor(self, *args)

    def getUpperNeighbor(self, *args) -> "int":
        r"""
         Get the rank of the upper neighbor

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        This method will throw a Domi::SubcommunicatorError if the
        communicator is a sub-communicator and this processor does not
        belong to the sub-communicator.

        If the periodic flag for the given axis is off, and the axis rank
        of the calling processor is the highest axis rank processor along
        this axis, then this method returns -1.

        If the periodic flag for the given axis is on, and the axis rank
        of the calling processor is zero, then the returned lower
        neighbor will be the highest axis rank processor along this axis.
        """
        return _Domi.MDVector_double_getUpperNeighbor(self, *args)

    def getGlobalDim(self, *args) -> "Domi::dim_type":
        r"""
         Get the global dimension along the specified axis

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        :type withBndryPad: boolean, optional
        :param withBndryPad: [in] specify whether the dimension should
                   include boundary padding or not
        """
        return _Domi.MDVector_double_getGlobalDim(self, *args)

    def getGlobalBounds(self, *args) -> "Domi::Slice":
        r"""
         Get the bounds of the global problem

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        :param withBndryPad: [in] specify whether the bounds should
                   include boundary padding or not
        """
        return _Domi.MDVector_double_getGlobalBounds(self, *args)

    def getGlobalRankBounds(self, *args) -> "Domi::Slice":
        r"""
         Get the global loop bounds on this processor along the
                specified axis

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        :param withBndryPadding: [in] specify whether the dimension should
                   include boundary padding or not

        The loop bounds are returned in the form of a Slice, in
        which the start() method returns the loop begin value,
        and the stop() method returns the non-inclusive end
        value.
        """
        return _Domi.MDVector_double_getGlobalRankBounds(self, *args)

    def getLocalDim(self, *args) -> "Domi::dim_type":
        r"""
         Get the local dimension along the specified axis

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        :type withCommPad: boolean, optional
        :param withCommPad: [in] specify whether the dimension should
                   include communication padding or not
        """
        return _Domi.MDVector_double_getLocalDim(self, *args)

    def getLocalBounds(self, *args) -> "Domi::Slice":
        r"""
        *Overload 1:*
         Get the local loop bounds along every axis

        The loop bounds are returned in the form of a Slice, in
        which the start() method returns the loop begin value,
        and the stop() method returns the non-inclusive end
        value.  For this method, padding is included in the bounds.

        |

        *Overload 2:*
         Get the local looping bounds along the specified axis

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        :type withPad: boolean, optional
        :param withPad: [in] specify whether the dimension should include
                   padding or not

        The loop bounds are returned in the form of a Slice, in
        which the start() method returns the loop begin value,
        and the stop() method returns the non-inclusive end
        value.
        """
        return _Domi.MDVector_double_getLocalBounds(self, *args)

    def getLocalInteriorBounds(self, *args) -> "Domi::Slice":
        r"""
         Get the local interior looping bounds along the specified
                axis

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        Local interior loop bounds are the same as local loop bounds
        without padding, except that for non-periodic axes the global end
        points of the given axis are excluded. For periodic axes, the
        local interior loop bounds are exactly the same as local loop
        bounds without padding.

        The loop bounds are returned in the form of a Slice, in
        which the start() method returns the loop begin value,
        and the stop() method returns the non-inclusive end
        value.
        """
        return _Domi.MDVector_double_getLocalInteriorBounds(self, *args)

    def hasPadding(self, *args) -> "bool":
        r"""
         Return true if there is any padding stored locally

        Note that it is not as simple as whether there were communication
        padding specified in the constructor.  Suppose non-zero
        communication padding was specified, but the problem is on one
        processor and no boundary padding was specified: this method will
        return false.  Similarly, if no communication padding was
        specified but boundary padding was, then boundary processors will
        have padding and this method will return true.
        """
        return _Domi.MDVector_double_hasPadding(self, *args)

    def getLowerPadSize(self, *args) -> "int":
        r"""
         Get the size of the lower padding along the given axis

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        Note that the returned padding can be either communication
        padding or boundary padding as appropriate.
        """
        return _Domi.MDVector_double_getLowerPadSize(self, *args)

    def getUpperPadSize(self, *args) -> "int":
        r"""
         Get the size of the upper padding along the given axis

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        Note that the returned padding can be either communication
        padding or boundary padding as appropriate.
        """
        return _Domi.MDVector_double_getUpperPadSize(self, *args)

    def getCommPadSize(self, *args) -> "int":
        r"""
         Get the communication padding size along the given axis

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        This returns the value of the communication padding along the
        given axis at the time of construction, regardless of the
        processor's position relative to the domain boundary.
        """
        return _Domi.MDVector_double_getCommPadSize(self, *args)

    def getLowerBndryPad(self, *args) -> "int":
        r"""
         Get the size of the lower boundary padding along the
                given axis

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)
        """
        return _Domi.MDVector_double_getLowerBndryPad(self, *args)

    def getUpperBndryPad(self, *args) -> "int":
        r"""
         Get the size of the upper boundary padding along the
                given axis

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)
        """
        return _Domi.MDVector_double_getUpperBndryPad(self, *args)

    def getBndryPadSize(self, *args) -> "int":
        r"""
         Get the boundary padding size along the given axis

        :type axis: int
        :param axis: [in] the index of the axis (from zero to the number
                   of dimensions - 1)

        This returns the value of the boundary padding along the given
        axis at the time of construction, regardless of whether a sub-map
        reduced these values.
        """
        return _Domi.MDVector_double_getBndryPadSize(self, *args)

    def setLowerPad(self, *args) -> "void":
        r"""
         Assign all elements of the lower pad a constant value

        :type axis: int
        :param axis: [in] the axis along which the lower padding is chosen

        :type value: float
        :param value: [in] the value to be assigned to all elements of the
                   lower padding
        """
        return _Domi.MDVector_double_setLowerPad(self, *args)

    def setUpperPad(self, *args) -> "void":
        r"""
         Assign all elements of the upper pad a constant value

        :type axis: int
        :param axis: [in] the axis along which the upper padding is chosen

        :type value: float
        :param value: [in] the value to be assigned to all elements of the
                   upper padding
        """
        return _Domi.MDVector_double_setUpperPad(self, *args)

    def isReplicatedBoundary(self, *args) -> "bool":
        r""" Return whether the given axis supports a replicated boundary"""
        return _Domi.MDVector_double_isReplicatedBoundary(self, *args)

    def getLayout(self, *args) -> "Domi::Layout":
        r""" Get the storage order"""
        return _Domi.MDVector_double_getLayout(self, *args)

    def isContiguous(self, *args) -> "bool":
        r"""
         True if there are no stride gaps on any processor

        An MDVector constructed from a communicator and dimensions will
        always be contiguous.  An MDVector that is a slice of a parent
        MDMVector will generally be non-contiguous, with some exceptions.
        There are cases where some local data is contiguous and some is
        not, but this method returns True only if all processes' local
        data is contiguous.
        """
        return _Domi.MDVector_double_isContiguous(self, *args)

    def getEpetraIntVectorView(self, *args) -> "Teuchos::RCP< Epetra_IntVector >":
        r"""
         Return a view of this MDVector as an Epetra_IntVector

        The multiple dimensions of the MDVector will be flattened in
        order to be expressed as an Epetra_IntVector.  Currently, if the
        MDVector is non-contiguous, a Domi::MDMapNoncontiguous exception
        will be thrown, as Epetra_IntVectors are contiguous, and this is
        a view transform.  Non-contiguous data is the result of slicing a
        parent MDVector.  In this case, getEpetraIntVectorView() should
        be called on the parent, or getEpetraIntVectorCopy() should be
        called on this non-contiguous MDVector.

        The MDVector Scalar template must be the same type as an
        Epetra_IntVector, i.e. int, or a Domi::TypeError exception will
        be thrown.
        """
        return _Domi.MDVector_double_getEpetraIntVectorView(self, *args)

    def getEpetraVectorView(self, *args) -> "Teuchos::RCP< Epetra_Vector >":
        r"""
         Return a view of this MDVector as an Epetra_Vector

        The multiple dimensions of the MDVector will be flattened in
        order to be expressed as an Epetra_Vector.  Currently, if the
        MDVector is non-contiguous, a Domi::MDMapNoncontiguous exception
        will be thrown, as Epetra_Vectors are contiguous, and this is a
        view transform.  Non-contiguous data is the result of slicing a
        parent MDVector.  In this case, getEpetraVectorView() should be
        called on the parent, or getEpetraVectorCopy() should be called
        on this non-contiguous MDVector.

        The MDVector Scalar template must be the same type as an
        Epetra_Vector, i.e. double, or a Domi::TypeError exception will
        be thrown.
        """
        return _Domi.MDVector_double_getEpetraVectorView(self, *args)

    def getEpetraMultiVectorView(self, *args) -> "Teuchos::RCP< Epetra_MultiVector >":
        r"""
         Return a view of this MDVector as an Epetra_MultiVector

        This method will attempt to utilize either the leading dimension
        (if the layout is C-order) or the trailing dimension (if the
        layout is Fortran-order) to serve as the Epetra_MultiVector
        vector index.  This dimension must be non-distributed (i.e., the
        corresponding commDim must be 1) in order for this mapping to
        work.  There must also be no padding associated with this axis.
        If these requirements are not met, then the entire MDVector will
        be treated as a single vector, that is the number of vectors will
        equal 1.

        Currently, if the MDVector is non-contiguous, a
        Domi::MDMapNoncontiguous exception will be thrown, as
        Epetra_MultiVectors are contiguous, and this is a view transform.

        The MDVector Scalar template must be the same type as an
        Epetra_MultiVector, i.e. double, or a Domi::TypeError exception
        will be thrown.
        """
        return _Domi.MDVector_double_getEpetraMultiVectorView(self, *args)

    def getEpetraIntVectorCopy(self, *args) -> "Teuchos::RCP< Epetra_IntVector >":
        r"""
         Return a copy of this MDVector as an Epetra_IntVector

        The multiple dimensions of the MDVector will be flattened in
        order to be expressed as an Epetra_IntVector.

        The MDVector Scalar template must be the same type as an
        Epetra_IntVector, i.e. int, or a Domi::TypeError exception will
        be thrown.
        """
        return _Domi.MDVector_double_getEpetraIntVectorCopy(self, *args)

    def getEpetraVectorCopy(self, *args) -> "Teuchos::RCP< Epetra_Vector >":
        r"""
         Return a copy of this MDVector as an Epetra_Vector

        The multiple dimensions of the MDVector will be flattened in
        order to be expressed as an Epetra_Vector.

        The MDVector Scalar template must be the same type as an
        Epetra_Vector, i.e. double, or a Domi::TypeError exception will
        be thrown.
        """
        return _Domi.MDVector_double_getEpetraVectorCopy(self, *args)

    def getEpetraMultiVectorCopy(self, *args) -> "Teuchos::RCP< Epetra_MultiVector >":
        r"""
         Return a copy of this MDVector as an Epetra_MultiVector

        This method will attempt to utilize either the leading dimension
        (if the layout is C-order) or the trailing dimension (if the
        layout is Fortran-order) to serve as the Epetra_MultiVector
        vector index.  This dimension must be non-distributed (i.e., the
        corresponding commDim must be 1) in order for this mapping to
        work.  There must also be no padding associated with this axis.
        If these requirements are not met, then the entire MDVector will
        be treated as a single vector, that is the number of vectors will
        equal 1.

        The MDVector Scalar template must be the same type as an
        Epetra_MultiVector, i.e. double, or a Domi::TypeError exception
        will be thrown.
        """
        return _Domi.MDVector_double_getEpetraMultiVectorCopy(self, *args)

    def getLowerPadDataNonConst(self, *args) -> "Domi::MDArrayView< double >":
        r"""
         Get a non-const view of the lower padding data along the
                given axis as an MDArrayView

        :type axis: int
        :param axis: [in] the axis from which to extract the lower padding
        """
        return _Domi.MDVector_double_getLowerPadDataNonConst(self, *args)

    def getLowerPadData(self, *args) -> "Domi::MDArrayView< double const >":
        r"""
         Get a const view of the lower padding data along the
                given axis as an MDArrayView

        :type axis: int
        :param axis: [in] the axis from which to extract the lower padding
        """
        return _Domi.MDVector_double_getLowerPadData(self, *args)

    def getUpperPadDataNonConst(self, *args) -> "Domi::MDArrayView< double >":
        r"""
         Get a non-const view of the upper padding data along the
                given axis as an MDArrayView

        :type axis: int
        :param axis: [in] the axis from which to extract the upper padding
        """
        return _Domi.MDVector_double_getUpperPadDataNonConst(self, *args)

    def getUpperPadData(self, *args) -> "Domi::MDArrayView< double const >":
        r"""
         Get a const view of the upper padding data along the
                given axis as an MDArrayView

        :type axis: int
        :param axis: [in] the axis from which to extract the upper padding
        """
        return _Domi.MDVector_double_getUpperPadData(self, *args)

    def dot(self, *args) -> "double":
        r"""
         Compute the dot product of this MDVector and MDVector a

        :type a: Domi::MDVector< double >
        :param a: [in] partner MDVector for performing dot product
        """
        return _Domi.MDVector_double_dot(self, *args)

    def norm1(self, *args) -> "Teuchos::ScalarTraits< double >::magnitudeType":
        r""" Compute the 1-norm of this MDVector"""
        return _Domi.MDVector_double_norm1(self, *args)

    def norm2(self, *args) -> "Teuchos::ScalarTraits< double >::magnitudeType":
        r""" Compute the 2-norm of this MDVector"""
        return _Domi.MDVector_double_norm2(self, *args)

    def normInf(self, *args) -> "Teuchos::ScalarTraits< double >::magnitudeType":
        r""" Compute the infinity-norm of this MDVector"""
        return _Domi.MDVector_double_normInf(self, *args)

    def normWeighted(self, *args) -> "Teuchos::ScalarTraits< double >::magnitudeType":
        r"""
         Compute the weighted norm of this

        :type weights: Domi::MDVector< double >
        :param weights: [in] MDVector of weights for weighted norm
        """
        return _Domi.MDVector_double_normWeighted(self, *args)

    def meanValue(self, *args) -> "double":
        r""" Compute the mean (average) value of this MDVector"""
        return _Domi.MDVector_double_meanValue(self, *args)

    def description(self, *args) -> "std::string":
        r""" A simple one-line description of this MDVector"""
        return _Domi.MDVector_double_description(self, *args)

    def describe(self, *args) -> "void":
        r"""
         Print the object with some verbosity level to a
                FancyOStream

        :type out: Teuchos::FancyOStream
        :param out: [in] output stream

        :type verbLevel: int, optional
        :param verbLevel: [in] verbosity level
        """
        return _Domi.MDVector_double_describe(self, *args)

    def putScalar(self, *args) -> "void":
        r"""
         Set all values in the multivector with the given value.

        :type value: float
        :param value: [in] assignment value

        :type includePadding: boolean, optional
        :param includePadding: [in] if true, assign values to the boundary
                   and communication padding as well
        """
        return _Domi.MDVector_double_putScalar(self, *args)

    def randomize(self, *args) -> "void":
        r""" Set all values in the multivector to pseudorandom numbers."""
        return _Domi.MDVector_double_randomize(self, *args)

    def updateCommPad(self, *args) -> "void":
        return _Domi.MDVector_double_updateCommPad(self, *args)

    def startUpdateCommPad(self, *args) -> "void":
        r"""
         Start an asyncronous update of the communication padding

        :type axis: int
        :param axis: [in] the axis along which communication will be
                   performed

        Post the non-blocking sends and receives for the communication
        padding along the given axis
        """
        return _Domi.MDVector_double_startUpdateCommPad(self, *args)

    def endUpdateCommPad(self, *args) -> "void":
        r"""
         Complete an asyncronous update of the communication padding

        :type axis: int
        :param axis: [in] the axis along which communication will be
                   performed

        Wait for all of the non-blocking updates for the communication
        padding along the given axis to complete
        """
        return _Domi.MDVector_double_endUpdateCommPad(self, *args)

    def writeBinary(self, *args) -> "void":
        r"""
         Write the MDVector to a binary file

        :type filename: string
        :param filename: [in] name of the output file

        :type includeBndryPad: boolean, optional
        :param includeBndryPad: [in] if true, include the boundary pad
                   with the output data
        """
        return _Domi.MDVector_double_writeBinary(self, *args)

    def readBinary(self, *args) -> "void":
        r"""
         Read the MDVector from a binary file

        :type filename: string
        :param filename: [in] name of the input file

        :type includeBndryPad: boolean, optional
        :param includeBndryPad: [in] if true, include the boundary pad
                   with the input data
        """
        return _Domi.MDVector_double_readBinary(self, *args)

    def __getitem__(self, *args) -> "Domi::MDVector< double >":
        return _Domi.MDVector_double___getitem__(self, *args)

    def getData(self, *args) -> "Domi::MDArrayView< double >":
        return _Domi.MDVector_double_getData(self, *args)

    def __distarray__(self, *args) -> "PyObject *":
        return _Domi.MDVector_double___distarray__(self, *args)

# Register MDVector_double in _Domi:
_Domi.MDVector_double_swigregister(MDVector_double)


upgradeMDVectorClass(MDVector_double)


def from_DistArray_int(*args) -> "Teuchos::RCP< Domi::MDVector< int > >":
    return _Domi.from_DistArray_int(*args)

def from_DistArray_long(*args) -> "Teuchos::RCP< Domi::MDVector< long long > >":
    return _Domi.from_DistArray_long(*args)

def from_DistArray_double(*args) -> "Teuchos::RCP< Domi::MDVector< double > >":
    return _Domi.from_DistArray_double(*args)

def from_DistArray(comm, distarray):
    protocol = distarray.__distarray__()
    dtype = protocol["buffer"].dtype
    if dtype.type is numpy.int32:
        return from_DistArray_int(comm, protocol)
    elif dtype.type is numpy.int64:
        return from_DistArray_long(comm, protocol)
#elif dtype.type is numpy.float32:
#    return from_DistArray_float(comm, protocol)
    elif dtype.type is numpy.float64:
        return from_DistArray_double(comm, protocol)
    else:
        raise TypeError("Unsupported or unrecognized dtype = %s" % str(dtype))


# My first cut at MDVector was to make it a wrapper class.  I now prefer the
# idea of MDVector being a factory function.  There is a bit of non-trivial work
# that went into the wrapper class, though, so I comment it out rather than
# delete it.  Who knows, I may want to go back to it some day...

# class MDVector(object):
#     def __init__(self, *args, **kwargs):
#         dtype       = kwargs.get("dtype"      , "int64")
#         zeroOut     = kwargs.get("zeroOut"    , False  )
#         leadingDim  = kwargs.get("leadingDim" , 0      )
#         trailingDim = kwargs.get("trailingDim", 0      )
#         if type(dtype) == str:
#             dtype = numpy.dtype(dtype)
#
#         # Factory for arg is MDMap
#         if isinstance(args[0], MDMap):
#             if dtype.type is numpy.int32:
#                 self._vector = MDVector_int(args[0],
#                                             leadingDim,
#                                             trailingDim,
#                                             zeroOut)
#             elif dtype.type is numpy.int64:
#                 self._vector = MDVector_long(args[0],
#                                              leadingDim,
#                                              trailingDim,
#                                              zeroOut)
#             elif dtype.type is numpy.float32:
#                 self._vector = MDVector_float(args[0],
#                                               leadingDim,
#                                               trailingDim,
#                                               zeroOut)
#             elif dtype.type is numpy.float64:
#                 self._vector = MDVector_double(args[0],
#                                                leadingDim,
#                                                trailingDim,
#                                                zeroOut)
#             else:
#                 raise TypeError("Unsupported or unrecognized dtype = %s" %
#                                 str(dtype))
#
#         # Factory for arg is DistArray
#         elif hasattr(arg, '__distarray__'):
#             self._vector = from_DistArray(*args)
#
#         self.dtype = dtype
#
#     def __getattribute__(self, name):
#         if name in ('__class__', '__dir__', '__getitem__', '_vector', 'dtype'):
#             return object.__getattribute__(self, name)
#         return getattr(object.__getattribute__(self, '_vector'), name)
#
#     def __dir__(self):
#         return sorted(set(dir(self._vector) + dir(MDVector)))
#
#     def __getitem__(self, args):
#         return self._vector.__getitem__(args)

def MDVector(*args, **kwargs):
    dtype = None
    if len(args) > 0:
        try:
            dtype = str(args[0].dtype())
            if dtype == "int": dtype = "i"
        except AttributeError:
            pass
    dtype = kwargs.get("dtype", dtype)
    if dtype is None: dtype = "int64"
    if type(dtype) == str:
        dtype = numpy.dtype(dtype)
    if dtype.type is numpy.int32:
        result = MDVector_int(*args)
    elif dtype.type is numpy.int64:
        result = MDVector_long(*args)
#elif dtype.type is numpy.float32:
#    result = MDVector_float(*args)
    elif dtype.type is numpy.float64:
        result = MDVector_double(*args)
    else:
        raise TypeError("Unsupported or unrecognized dtype = %s" %
                        str(dtype))
    return result




