# This file was automatically generated by SWIG (http://www.swig.org).
# Version 4.0.2
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.

"""

PyTrilinos.EpetraExt is the python interface to the Trilinos linear
algebra services extension package EpetraExt:

    https://trilinos.org/docs/dev/packages/epetraext/doc/html/index.html

The purpose of EpetraExt is to provide various extensions to Epetra
that were not considered appropriate for the Epetra package.  These
extensions include I/O, matrix-matrix operations and graph coloring.

Currently, only a subset of EpetraExt classes and functions have
python interfaces, including the following user-level classes:

    * XMLReader                      - Read Epetra data from an XML file
    * XMLWriter                      - Write Epetra data as an XML file
    * CrsGraph_MapColoring           - Compute a graph coloring
    * CrsGraph_MapColoringIndex      - Compute indexes for a graph coloring

and functions:

    * MatrixMarketFileToBlockMap     - Read a BlockMap from an MM file
    * MatrixMarketFileToBlockMaps    - Read BlockMaps from an MM file
    * MatrixMarketFileToMap          - Read a Map from an MM file
    * MatrixMarketFileToMultiVector  - Read a MultiVector from an MM file
    * MatrixMarketFileToCrsMatrix    - Read a CrsMatrix from an MM file
    * MatlabFileToCrsMatrix          - Read a CrsMatrix from an ML file
    * BlockMapToMatrixMarketFile     - Write a BlockMap to an MM file
    * MultiVectorToMatrixMarketFile  - Write a MultiVector to an MM file
    * MultiVectorToMatlabFile        - Write a MultiVector to an ML file
    * RowMatrixToMatrixMarketFile    - Write a RowMatrix to an MM file
    * RowMatrixToMatlabFile          - Write a RowMatrix to an ML file
    * Add                            - Add two CrsMatrix objects
    * Multiply                       - Multiply two CrsMatrix objects

For examples of usage, please consult the following scripts in the
example subdirectory of the PyTrilinos package:

    * exEpetraExt_IO_MatrixMarket.py
    * exEpetraExt_IO_XML.py
    * exEpetraExt_MatrixMatrix.py

"""

from sys import version_info as _swig_python_version_info
if _swig_python_version_info < (2, 7, 0):
    raise RuntimeError("Python 2.7 or later required")

# Import the low-level C/C++ module
if __package__ or "." in __name__:
    from . import _EpetraExt
else:
    import _EpetraExt

try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)


def _swig_setattr_nondynamic_instance_variable(set):
    def set_instance_attr(self, name, value):
        if name == "thisown":
            self.this.own(value)
        elif name == "this":
            set(self, name, value)
        elif hasattr(self, name) and isinstance(getattr(type(self), name), property):
            set(self, name, value)
        else:
            raise AttributeError("You cannot add instance attributes to %s" % self)
    return set_instance_attr


def _swig_setattr_nondynamic_class_variable(set):
    def set_class_attr(cls, name, value):
        if hasattr(cls, name) and not isinstance(getattr(cls, name), property):
            set(cls, name, value)
        else:
            raise AttributeError("You cannot add class attributes to %s" % cls)
    return set_class_attr


def _swig_add_metaclass(metaclass):
    """Class decorator for adding a metaclass to a SWIG wrapped class - a slimmed down version of six.add_metaclass"""
    def wrapper(cls):
        return metaclass(cls.__name__, cls.__bases__, cls.__dict__.copy())
    return wrapper


class _SwigNonDynamicMeta(type):
    """Meta class to enforce nondynamic attributes (no new attributes) for a class"""
    __setattr__ = _swig_setattr_nondynamic_class_variable(type.__setattr__)


import weakref

class SwigPyIterator(object):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _EpetraExt.delete_SwigPyIterator

    def value(self) -> "PyObject *":
        return _EpetraExt.SwigPyIterator_value(self)

    def incr(self, n: "size_t"=1) -> "swig::SwigPyIterator *":
        return _EpetraExt.SwigPyIterator_incr(self, n)

    def decr(self, n: "size_t"=1) -> "swig::SwigPyIterator *":
        return _EpetraExt.SwigPyIterator_decr(self, n)

    def distance(self, x: "SwigPyIterator") -> "ptrdiff_t":
        return _EpetraExt.SwigPyIterator_distance(self, x)

    def equal(self, x: "SwigPyIterator") -> "bool":
        return _EpetraExt.SwigPyIterator_equal(self, x)

    def copy(self) -> "swig::SwigPyIterator *":
        return _EpetraExt.SwigPyIterator_copy(self)

    def next(self) -> "PyObject *":
        return _EpetraExt.SwigPyIterator_next(self)

    def __next__(self) -> "PyObject *":
        return _EpetraExt.SwigPyIterator___next__(self)

    def previous(self) -> "PyObject *":
        return _EpetraExt.SwigPyIterator_previous(self)

    def advance(self, n: "ptrdiff_t") -> "swig::SwigPyIterator *":
        return _EpetraExt.SwigPyIterator_advance(self, n)

    def __eq__(self, x: "SwigPyIterator") -> "bool":
        return _EpetraExt.SwigPyIterator___eq__(self, x)

    def __ne__(self, x: "SwigPyIterator") -> "bool":
        return _EpetraExt.SwigPyIterator___ne__(self, x)

    def __iadd__(self, n: "ptrdiff_t") -> "swig::SwigPyIterator &":
        return _EpetraExt.SwigPyIterator___iadd__(self, n)

    def __isub__(self, n: "ptrdiff_t") -> "swig::SwigPyIterator &":
        return _EpetraExt.SwigPyIterator___isub__(self, n)

    def __add__(self, n: "ptrdiff_t") -> "swig::SwigPyIterator *":
        return _EpetraExt.SwigPyIterator___add__(self, n)

    def __sub__(self, *args) -> "ptrdiff_t":
        return _EpetraExt.SwigPyIterator___sub__(self, *args)
    def __iter__(self):
        return self

# Register SwigPyIterator in _EpetraExt:
_EpetraExt.SwigPyIterator_swigregister(SwigPyIterator)

from . import Teuchos
from .Teuchos import Base
from . import Epetra

def EpetraExt_Version(*args) -> "std::string":
    return _EpetraExt.EpetraExt_Version(*args)

__version__ = EpetraExt_Version().split()[2]

class XMLReader(object):
    r"""
    class XMLReader: A class for reading Epetra objects stored in XML files.

    Class EpetraExt::XMLReader allows to read several Trilinos objects stored in
    XML files. The XML data format is specified in the documentation of class
    EpetraExt::XMLWriter, which also contains a MATLAB script. A typical usage of
    this class is reported in file epetraext/example/inout/XML_IO.cpp.

    This class requires Teuchos to be configured with the option ``--enable-teuchos-expat``.

    Reading objects from a file requires the following steps. First, we define an XMLReader object,

    .. code-block:: c++

        EpetraExt::XMLReader XMLReader(Comm, "data.xml");
    Then, we define a set of pointers,

    .. code-block:: c++

        Epetra_Map* MyMap;
        Epetra_CrsMatrix* MyMatrix;
        Epetra_MultiVector* MyLHS;
        Epetra_MultiVector* MyRHS;
        Teuchos::ParameterList MyParameters;
        std::vector<std::string> Author;
        std::vector<std::string> Date;
        std::vector<std::string> MyContent;
    Reading simply goes as follows:

    .. code-block:: c++

        XMLReader.Read("Author", Author);
        XMLReader.Read("Date", Date);
        XMLReader.Read("MyMap", MyMap);
        XMLReader.Read("MyMatrix", MyMatrix);
        XMLReader.Read("MyLHS", MyLHS);
        XMLReader.Read("MyRHS", MyRHS);
        XMLReader.Read("MyContent", MyContent);
        XMLReader.Read("MyParameters", MyParameters);
    In distributed environments, Epetra_MultiVector, Epetra_CrsGraph and
    Epetra_CrsMatrix objects have a linear distribution. Epetra_Map objects can be
    read only when  using the same number of processors used for writing.

    Warning: All the created objects must be deleted from the user using ``delete``.

    Author: Marzio Sala, D-INFK/ETHZ

    Last updated on 10-May-06.

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r""" ctor"""
        _EpetraExt.XMLReader_swiginit(self, _EpetraExt.new_XMLReader(*args))
    __swig_destroy__ = _EpetraExt.delete_XMLReader

    def ReadMap(self, *args) -> "Epetra_Map *":
        r"""

        Return a Map read from an XML file specified by filename 'name'.

        """
        return _EpetraExt.XMLReader_ReadMap(self, *args)

    def ReadMultiVector(self, *args) -> "Epetra_MultiVector *":
        r"""

        Return a MultiVector read from an XML file specified by filename
        'name'.

        """
        return _EpetraExt.XMLReader_ReadMultiVector(self, *args)

    def ReadCrsGraph(self, *args) -> "Epetra_CrsGraph *":
        r"""

        Return a CrsGraph read from an XML file specified by filename 'name'.

        """
        return _EpetraExt.XMLReader_ReadCrsGraph(self, *args)

    def ReadCrsMatrix(self, *args) -> "Epetra_CrsMatrix *":
        r"""

        Return a CrsMatrix read from an XML file specified by filename 'name'.

        """
        return _EpetraExt.XMLReader_ReadCrsMatrix(self, *args)

    def Read64Map(self, *args) -> "Epetra_Map *":
        return _EpetraExt.XMLReader_Read64Map(self, *args)

    def Read64MultiVector(self, *args) -> "Epetra_MultiVector *":
        return _EpetraExt.XMLReader_Read64MultiVector(self, *args)

    def Read64CrsGraph(self, *args) -> "Epetra_CrsGraph *":
        return _EpetraExt.XMLReader_Read64CrsGraph(self, *args)

    def Read64CrsMatrix(self, *args) -> "Epetra_CrsMatrix *":
        return _EpetraExt.XMLReader_Read64CrsMatrix(self, *args)

# Register XMLReader in _EpetraExt:
_EpetraExt.XMLReader_swigregister(XMLReader)

class XMLWriter(object):
    r"""
    class XMLWriter: A class for writing Trilinos objects to XML files.

    Class EpetraExt::XMLWriter writes several Trilinos objects in an XML-compatible format.
    The list of supported objects contains:
    - Epetra_Map;
    - Epetra_MultiVector;
    - Epetra_CrsGraph;
    - Epetra_CrsMatrix;
    - Epetra_RowMatrix;
    - Teuchos::ParameterList.

    All objects can be read and written, with the std::exception of Epetra_RowMatrix
    objects, that can only be written to files.

    An example of usage is reported in file epetraext/example/inout/XML_IO.cpp.

    Writing objects goes as follows. Let ``Map``, ``Matrix``, ``LHS`` and ``RHS`` an
    Epetra_Map, Epetra_CrsMatrix, and two Epetra_MultiVector's, respectively. First, we define an XMLWriter object

    .. code-block:: c++

        EpetraExt::XMLWriter XMLWriter(Comm, "data.xml");
    and we open the file using ``MyProblem`` label:

    .. code-block:: c++

        XMLWriter.Create("MyProblem");
    Writing objects simply goes as

    .. code-block:: c++

        XMLWriter.Write("MyMap", Map);
        XMLWriter.Write("MyMatrix", Matrix);
        XMLWriter.Write("MyLHS", LHS);
        XMLWriter.Write("MyRHS", RHS);
    A ``Teuchos::ParameterList`` (List), a ``std::string``, and a ``std::vector``<std::string> can be written as

    .. code-block:: c++

        XMLWriter.Write("MyParameters", List);
        XMLWriter.Write("Author", "myself and others");
        XMLWriter.Write("Date", "May 2006");
    Finally, we close the file

    .. code-block:: c++

        XMLWriter.Close();
    Note that only processor 0 writes the Teuchos::ParameterList, ``std::string``, and ``std::vector``<std::string>.

    The written file is as follows:

    .. code-block:: c++

        <ObjectCollection Label="MyProblem">
        <Text Label="Author">
        myself and others
        </Text>
        <Text Label="Date">
        May 2006
        </Text>
        <Map Label="MyMap" NumElements="4" IndexBase="0" NumProc="1" ElementsOnProc0="4">
        <Proc ID="0">
        0
        1
        2
        3
        </Proc>
        </Map>
        <PointMatrix Label="MyMatrix" Rows="4" Columns="4" Nonzeros="4" Type="double" StartingIndex="0">
        0 0 1
        1 1 1
        2 2 1
        3 3 1
        </PointMatrix>
        <MultiVector Label="MyLHS" Length="4" NumVectors="2" Type="double">
        -0.232996 -0.893077
        0.0388327 0.0594004
        0.661931 0.342299
        -0.930856 -0.984604
        </MultiVector>
        <MultiVector Label="MyRHS" Length="4" NumVectors="2" Type="double">
        0 0
        0 0
        0 0
        0 0
        </MultiVector>
        <Text Label="MyContent">
        This is an example of description
        The description is as long as desired,
        just put it in a std::vector of strings.
        </Text>
        <List Label="MyParameters">
        <ParameterList>
        <Parameter name="double parameter" type="double" value="10"/>
        <Parameter name="int parameter" type="int" value="10"/>
        <Parameter name="std::string parameter" type="std::string" value="std::string"/>
        </ParameterList>
        </List>
        </ObjectCollection>

    This class requires Teuchos to be configured with the option ``--enable-teuchos-expat``.

    Author: Marzio Sala, D-INFK/ETHZ

    Last updated on 10-May-06.

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r""" ctor"""
        _EpetraExt.XMLWriter_swiginit(self, _EpetraExt.new_XMLWriter(*args))
    __swig_destroy__ = _EpetraExt.delete_XMLWriter

    def Create(self, *args) -> "void":
        r""" Creates the file, giving ``Label`` to the whole object."""
        return _EpetraExt.XMLWriter_Create(self, *args)

    def Close(self, *args) -> "void":
        r""" Closes the file. No Write operations can follow."""
        return _EpetraExt.XMLWriter_Close(self, *args)

    def Write(self, *args) -> "void":
        r"""
        *Overload 1:*
        Writes an Epetra_Map using label ``Label``.

        |

        *Overload 2:*
        Writes an Epetra_RowMatrix using label ``Label``.

        |

        *Overload 3:*
        Writes an Epetra_MultiVector using label ``Label``.

        |

        *Overload 4:*
        Writes the std::vector of std::string's using label ``Label``.

        |

        *Overload 5:*
        Writes input std::string using label ``Label``.

        |

        *Overload 6:*
        Writes a Teuchos::ParameterList using label ``Label``.
        """
        return _EpetraExt.XMLWriter_Write(self, *args)

# Register XMLWriter in _EpetraExt:
_EpetraExt.XMLWriter_swigregister(XMLWriter)

class Xform_CrsGraph_MapColoring(object):
    r"""
      Base Class for all Epetra Transform Operators.

    This is the abstract definition for all Epetra Transform Operators.
    Depending on the type of Transform, several specializations are
    available: Structural, SameType, InPlace, View.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _EpetraExt.delete_Xform_CrsGraph_MapColoring

    def __call__(self, *args) -> "EpetraExt::Transform< Epetra_CrsGraph,Epetra_MapColoring >::NewTypeRef":
        r"""
          Analysis of transform operation on original object and construction
        of new object.

        Preconditions:


        Invariants:


        Postconditions:


        :rtype: :py:class:`Epetra_MapColoring`
        :return: Returns a pointer to the newly created object of type
            NewTypeRef.  The Transform object maintains ownership of this
            new object and deletes as a part of it's destruction.
        """
        return _EpetraExt.Xform_CrsGraph_MapColoring___call__(self, *args)

    def fwd(self, *args) -> "bool":
        r"""
          Forward transfer of data from orig object input in the
        operator() method call to the new object created in this
        same call.  Returns true is
        operation is successful.

        Preconditions:


        Invariants:


        Postconditions:

        """
        return _EpetraExt.Xform_CrsGraph_MapColoring_fwd(self, *args)

    def rvs(self, *args) -> "bool":
        r"""
          Reverse transfer of data from new object created in the
        operator() method call to the orig object input
        to this same method. Returns true if operation is successful.

        Preconditions:


        Invariants:


        Postconditions:

        """
        return _EpetraExt.Xform_CrsGraph_MapColoring_rvs(self, *args)

    def analyze(self, *args) -> "bool":
        r"""
          Initial analysis phase of transform.  Returns true if
        the transform is possible allowing methods construct(),
        fwd() and rvs() to be successfully utilized.

        Preconditions:


        Invariants:


        Postconditions:


        The default implementation calls method operator()
        and stores the resulting object in an internal attribute newObj_.
        """
        return _EpetraExt.Xform_CrsGraph_MapColoring_analyze(self, *args)

    def construct(self, *args) -> "EpetraExt::Transform< Epetra_CrsGraph,Epetra_MapColoring >::NewTypeRef":
        r"""
          Construction of new object as a result of the transform.

        Preconditions:


        Invariants:


        Postconditions:


        The default implementation returns internal attribute newObj_.
        """
        return _EpetraExt.Xform_CrsGraph_MapColoring_construct(self, *args)

    def isConstructed(self, *args) -> "bool":
        r"""
          Check for whether transformed object has been constructed

        Preconditions:


        Invariants:


        Postconditions:


        The default implementation returns true if
        newObj_ != 0.
        """
        return _EpetraExt.Xform_CrsGraph_MapColoring_isConstructed(self, *args)

# Register Xform_CrsGraph_MapColoring in _EpetraExt:
_EpetraExt.Xform_CrsGraph_MapColoring_swigregister(Xform_CrsGraph_MapColoring)

class Xform_CrsGraph_vecIntVector(object):
    r"""
      Base Class for all Epetra Transform Operators.

    This is the abstract definition for all Epetra Transform Operators.
    Depending on the type of Transform, several specializations are
    available: Structural, SameType, InPlace, View.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _EpetraExt.delete_Xform_CrsGraph_vecIntVector

    def __call__(self, *args) -> "EpetraExt::Transform< Epetra_CrsGraph,std::vector< Epetra_GIDTypeVector< int >::impl,std::allocator< Epetra_GIDTypeVector< int >::impl > > >::NewTypeRef":
        r"""
          Analysis of transform operation on original object and construction
        of new object.

        Preconditions:


        Invariants:


        Postconditions:


        :rtype: std::vector< Epetra_GIDTypeVector< int >::impl,std::allocator< Epetra_GIDTypeVector< int >::impl > >
        :return: Returns a pointer to the newly created object of type
            NewTypeRef.  The Transform object maintains ownership of this
            new object and deletes as a part of it's destruction.
        """
        return _EpetraExt.Xform_CrsGraph_vecIntVector___call__(self, *args)

    def fwd(self, *args) -> "bool":
        r"""
          Forward transfer of data from orig object input in the
        operator() method call to the new object created in this
        same call.  Returns true is
        operation is successful.

        Preconditions:


        Invariants:


        Postconditions:

        """
        return _EpetraExt.Xform_CrsGraph_vecIntVector_fwd(self, *args)

    def rvs(self, *args) -> "bool":
        r"""
          Reverse transfer of data from new object created in the
        operator() method call to the orig object input
        to this same method. Returns true if operation is successful.

        Preconditions:


        Invariants:


        Postconditions:

        """
        return _EpetraExt.Xform_CrsGraph_vecIntVector_rvs(self, *args)

    def analyze(self, *args) -> "bool":
        r"""
          Initial analysis phase of transform.  Returns true if
        the transform is possible allowing methods construct(),
        fwd() and rvs() to be successfully utilized.

        Preconditions:


        Invariants:


        Postconditions:


        The default implementation calls method operator()
        and stores the resulting object in an internal attribute newObj_.
        """
        return _EpetraExt.Xform_CrsGraph_vecIntVector_analyze(self, *args)

    def construct(self, *args) -> "EpetraExt::Transform< Epetra_CrsGraph,std::vector< Epetra_GIDTypeVector< int >::impl,std::allocator< Epetra_GIDTypeVector< int >::impl > > >::NewTypeRef":
        r"""
          Construction of new object as a result of the transform.

        Preconditions:


        Invariants:


        Postconditions:


        The default implementation returns internal attribute newObj_.
        """
        return _EpetraExt.Xform_CrsGraph_vecIntVector_construct(self, *args)

    def isConstructed(self, *args) -> "bool":
        r"""
          Check for whether transformed object has been constructed

        Preconditions:


        Invariants:


        Postconditions:


        The default implementation returns true if
        newObj_ != 0.
        """
        return _EpetraExt.Xform_CrsGraph_vecIntVector_isConstructed(self, *args)

# Register Xform_CrsGraph_vecIntVector in _EpetraExt:
_EpetraExt.Xform_CrsGraph_vecIntVector_swigregister(Xform_CrsGraph_vecIntVector)

class Xform_CrsGraph_vecLongVector(object):
    r"""
      Base Class for all Epetra Transform Operators.

    This is the abstract definition for all Epetra Transform Operators.
    Depending on the type of Transform, several specializations are
    available: Structural, SameType, InPlace, View.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _EpetraExt.delete_Xform_CrsGraph_vecLongVector

    def __call__(self, *args) -> "EpetraExt::Transform< Epetra_CrsGraph,std::vector< Epetra_GIDTypeVector< long long >::impl,std::allocator< Epetra_GIDTypeVector< long long >::impl > > >::NewTypeRef":
        r"""
          Analysis of transform operation on original object and construction
        of new object.

        Preconditions:


        Invariants:


        Postconditions:


        :rtype: std::vector< Epetra_GIDTypeVector< long long >::impl,std::allocator< Epetra_GIDTypeVector< long long >::impl > >
        :return: Returns a pointer to the newly created object of type
            NewTypeRef.  The Transform object maintains ownership of this
            new object and deletes as a part of it's destruction.
        """
        return _EpetraExt.Xform_CrsGraph_vecLongVector___call__(self, *args)

    def fwd(self, *args) -> "bool":
        r"""
          Forward transfer of data from orig object input in the
        operator() method call to the new object created in this
        same call.  Returns true is
        operation is successful.

        Preconditions:


        Invariants:


        Postconditions:

        """
        return _EpetraExt.Xform_CrsGraph_vecLongVector_fwd(self, *args)

    def rvs(self, *args) -> "bool":
        r"""
          Reverse transfer of data from new object created in the
        operator() method call to the orig object input
        to this same method. Returns true if operation is successful.

        Preconditions:


        Invariants:


        Postconditions:

        """
        return _EpetraExt.Xform_CrsGraph_vecLongVector_rvs(self, *args)

    def analyze(self, *args) -> "bool":
        r"""
          Initial analysis phase of transform.  Returns true if
        the transform is possible allowing methods construct(),
        fwd() and rvs() to be successfully utilized.

        Preconditions:


        Invariants:


        Postconditions:


        The default implementation calls method operator()
        and stores the resulting object in an internal attribute newObj_.
        """
        return _EpetraExt.Xform_CrsGraph_vecLongVector_analyze(self, *args)

    def construct(self, *args) -> "EpetraExt::Transform< Epetra_CrsGraph,std::vector< Epetra_GIDTypeVector< long long >::impl,std::allocator< Epetra_GIDTypeVector< long long >::impl > > >::NewTypeRef":
        r"""
          Construction of new object as a result of the transform.

        Preconditions:


        Invariants:


        Postconditions:


        The default implementation returns internal attribute newObj_.
        """
        return _EpetraExt.Xform_CrsGraph_vecLongVector_construct(self, *args)

    def isConstructed(self, *args) -> "bool":
        r"""
          Check for whether transformed object has been constructed

        Preconditions:


        Invariants:


        Postconditions:


        The default implementation returns true if
        newObj_ != 0.
        """
        return _EpetraExt.Xform_CrsGraph_vecLongVector_isConstructed(self, *args)

# Register Xform_CrsGraph_vecLongVector in _EpetraExt:
_EpetraExt.Xform_CrsGraph_vecLongVector_swigregister(Xform_CrsGraph_vecLongVector)

class Xform_CrsMatrix_CrsMatrix(object):
    r"""
      Base Class for all Epetra Transform Operators.

    This is the abstract definition for all Epetra Transform Operators.
    Depending on the type of Transform, several specializations are
    available: Structural, SameType, InPlace, View.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _EpetraExt.delete_Xform_CrsMatrix_CrsMatrix

    def __call__(self, *args) -> "EpetraExt::Transform< Epetra_CrsMatrix,Epetra_CrsMatrix >::NewTypeRef":
        r"""
          Analysis of transform operation on original object and construction
        of new object.

        Preconditions:


        Invariants:


        Postconditions:


        :rtype: :py:class:`Epetra_CrsMatrix`
        :return: Returns a pointer to the newly created object of type
            NewTypeRef.  The Transform object maintains ownership of this
            new object and deletes as a part of it's destruction.
        """
        return _EpetraExt.Xform_CrsMatrix_CrsMatrix___call__(self, *args)

    def fwd(self, *args) -> "bool":
        r"""
          Forward transfer of data from orig object input in the
        operator() method call to the new object created in this
        same call.  Returns true is
        operation is successful.

        Preconditions:


        Invariants:


        Postconditions:

        """
        return _EpetraExt.Xform_CrsMatrix_CrsMatrix_fwd(self, *args)

    def rvs(self, *args) -> "bool":
        r"""
          Reverse transfer of data from new object created in the
        operator() method call to the orig object input
        to this same method. Returns true if operation is successful.

        Preconditions:


        Invariants:


        Postconditions:

        """
        return _EpetraExt.Xform_CrsMatrix_CrsMatrix_rvs(self, *args)

    def analyze(self, *args) -> "bool":
        r"""
          Initial analysis phase of transform.  Returns true if
        the transform is possible allowing methods construct(),
        fwd() and rvs() to be successfully utilized.

        Preconditions:


        Invariants:


        Postconditions:


        The default implementation calls method operator()
        and stores the resulting object in an internal attribute newObj_.
        """
        return _EpetraExt.Xform_CrsMatrix_CrsMatrix_analyze(self, *args)

    def construct(self, *args) -> "EpetraExt::Transform< Epetra_CrsMatrix,Epetra_CrsMatrix >::NewTypeRef":
        r"""
          Construction of new object as a result of the transform.

        Preconditions:


        Invariants:


        Postconditions:


        The default implementation returns internal attribute newObj_.
        """
        return _EpetraExt.Xform_CrsMatrix_CrsMatrix_construct(self, *args)

    def isConstructed(self, *args) -> "bool":
        r"""
          Check for whether transformed object has been constructed

        Preconditions:


        Invariants:


        Postconditions:


        The default implementation returns true if
        newObj_ != 0.
        """
        return _EpetraExt.Xform_CrsMatrix_CrsMatrix_isConstructed(self, *args)

# Register Xform_CrsMatrix_CrsMatrix in _EpetraExt:
_EpetraExt.Xform_CrsMatrix_CrsMatrix_swigregister(Xform_CrsMatrix_CrsMatrix)

class SXform_CrsGraph_MapColoring(Xform_CrsGraph_MapColoring):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr

    def fwd(self, *args) -> "bool":
        return _EpetraExt.SXform_CrsGraph_MapColoring_fwd(self, *args)

    def rvs(self, *args) -> "bool":
        return _EpetraExt.SXform_CrsGraph_MapColoring_rvs(self, *args)
    __swig_destroy__ = _EpetraExt.delete_SXform_CrsGraph_MapColoring

# Register SXform_CrsGraph_MapColoring in _EpetraExt:
_EpetraExt.SXform_CrsGraph_MapColoring_swigregister(SXform_CrsGraph_MapColoring)

class SXform_CrsGraph_vecIntVector(Xform_CrsGraph_vecIntVector):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr

    def fwd(self, *args) -> "bool":
        return _EpetraExt.SXform_CrsGraph_vecIntVector_fwd(self, *args)

    def rvs(self, *args) -> "bool":
        return _EpetraExt.SXform_CrsGraph_vecIntVector_rvs(self, *args)
    __swig_destroy__ = _EpetraExt.delete_SXform_CrsGraph_vecIntVector

# Register SXform_CrsGraph_vecIntVector in _EpetraExt:
_EpetraExt.SXform_CrsGraph_vecIntVector_swigregister(SXform_CrsGraph_vecIntVector)

class SXform_CrsGraph_vecLongVector(Xform_CrsGraph_vecLongVector):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr

    def fwd(self, *args) -> "bool":
        return _EpetraExt.SXform_CrsGraph_vecLongVector_fwd(self, *args)

    def rvs(self, *args) -> "bool":
        return _EpetraExt.SXform_CrsGraph_vecLongVector_rvs(self, *args)
    __swig_destroy__ = _EpetraExt.delete_SXform_CrsGraph_vecLongVector

# Register SXform_CrsGraph_vecLongVector in _EpetraExt:
_EpetraExt.SXform_CrsGraph_vecLongVector_swigregister(SXform_CrsGraph_vecLongVector)

class SameXform_CrsMatrix(Xform_CrsMatrix_CrsMatrix):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _EpetraExt.delete_SameXform_CrsMatrix

# Register SameXform_CrsMatrix in _EpetraExt:
_EpetraExt.SameXform_CrsMatrix_swigregister(SameXform_CrsMatrix)

class CrsGraph_MapColoring(SXform_CrsGraph_MapColoring):
    r"""
      Map Coloring of independent columns in a Graph

    Generates a Epetra_MapColoring object for which all column indices form
    independent sets.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    GREEDY = _EpetraExt.CrsGraph_MapColoring_GREEDY
    LUBY = _EpetraExt.CrsGraph_MapColoring_LUBY
    JONES_PLASSMAN = _EpetraExt.CrsGraph_MapColoring_JONES_PLASSMAN
    PSEUDO_PARALLEL = _EpetraExt.CrsGraph_MapColoring_PSEUDO_PARALLEL
    __swig_destroy__ = _EpetraExt.delete_CrsGraph_MapColoring

    def __init__(self, *args):
        r"""  Constructor"""
        _EpetraExt.CrsGraph_MapColoring_swiginit(self, _EpetraExt.new_CrsGraph_MapColoring(*args))

    def __call__(self, *args) -> "EpetraExt::CrsGraph_MapColoring::NewTypeRef":
        r"""  Generates the Epetra_MapColoring object from an input Epetra_CrsGraph"""
        return _EpetraExt.CrsGraph_MapColoring___call__(self, *args)

# Register CrsGraph_MapColoring in _EpetraExt:
_EpetraExt.CrsGraph_MapColoring_swigregister(CrsGraph_MapColoring)

class TCrsGraph_MapColoringIndex_int(SXform_CrsGraph_vecIntVector):
    r"""
      Generates a std::vector of Epetra_IntVector's to be used to map perturbation
    contributions to a CrsGraph/CrsMatrix from a perturbed vector.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined")
    __repr__ = _swig_repr

# Register TCrsGraph_MapColoringIndex_int in _EpetraExt:
_EpetraExt.TCrsGraph_MapColoringIndex_int_swigregister(TCrsGraph_MapColoringIndex_int)

class TCrsGraph_MapColoringIndex_long(SXform_CrsGraph_vecLongVector):
    r"""
      Generates a std::vector of Epetra_IntVector's to be used to map perturbation
    contributions to a CrsGraph/CrsMatrix from a perturbed vector.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined")
    __repr__ = _swig_repr

# Register TCrsGraph_MapColoringIndex_long in _EpetraExt:
_EpetraExt.TCrsGraph_MapColoringIndex_long_swigregister(TCrsGraph_MapColoringIndex_long)

class CrsGraph_MapColoringIndex(TCrsGraph_MapColoringIndex_int):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    __swig_destroy__ = _EpetraExt.delete_CrsGraph_MapColoringIndex

    def __init__(self, *args):
        r"""
          Constructor
        input param ColorMap defines the perturbation coloring
        """
        _EpetraExt.CrsGraph_MapColoringIndex_swiginit(self, _EpetraExt.new_CrsGraph_MapColoringIndex(*args))

    def __call__(self, *args) -> "std::vector< Epetra_IntVector,std::allocator< Epetra_IntVector > > &":
        return _EpetraExt.CrsGraph_MapColoringIndex___call__(self, *args)

# Register CrsGraph_MapColoringIndex in _EpetraExt:
_EpetraExt.CrsGraph_MapColoringIndex_swigregister(CrsGraph_MapColoringIndex)

class CrsGraph_MapColoringIndex64(TCrsGraph_MapColoringIndex_long):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    __swig_destroy__ = _EpetraExt.delete_CrsGraph_MapColoringIndex64

    def __init__(self, *args):
        r"""
          Constructor
        input param ColorMap defines the perturbation coloring
        """
        _EpetraExt.CrsGraph_MapColoringIndex64_swiginit(self, _EpetraExt.new_CrsGraph_MapColoringIndex64(*args))

    def __call__(self, *args) -> "std::vector< Epetra_LongLongVector,std::allocator< Epetra_LongLongVector > > &":
        return _EpetraExt.CrsGraph_MapColoringIndex64___call__(self, *args)

# Register CrsGraph_MapColoringIndex64 in _EpetraExt:
_EpetraExt.CrsGraph_MapColoringIndex64_swigregister(CrsGraph_MapColoringIndex64)


def MatrixMarketFileToMultiVector(*args) -> "Epetra_MultiVector *&":
    r"""
    MatrixMarketFileToMultiVector(str filename, Epetra.BlockMap) ->
        Epetra.MultiVector

    Return a MultiVector read from a matix market file.
    """
    return _EpetraExt.MatrixMarketFileToMultiVector(*args)

def MultiVectorToMatrixMarketFile(*args) -> "int":
    r"""
    Writes an Epetra_MultiVector object to a Matrix Market format file This function takes an Epetra_MultiVector object and writes it
         to the specified file.  The multivector can be distributed or serial.  The user can provide
         a strings containing the object name, a description, and specify that header information
         should or should not be printed to the file.

         :type filename: string
         :param filename: (In) A filename, including path if desired.  If a file with this name already exists,
                             it will be deleted.  On exit, this file will contained any requested header information
       		      followed by the matrix coefficients.  The file will contain a row for each entry.  All entries
       		      for a column are listed before going to the next column.
         :type A: :py:class:`Epetra_MultiVector`
         :param A: (In) An Epetra_MultiVector Object containing the user matrix to be dumped to file.
         :type matrixName: string, optional
         :param matrixName: (In) A C-style string pointer to a name that will be stored in the comment field of the file.
                                This is not a required argument.  Note that it is possible to pass in the method A.Label().
         :type matrixDescription: string, optional
         :param matrixDescription: (In) A C-style string pointer to a matrix description that will be stored in the comment
                                           field of the file.
         :type writeHeader: boolean, optional
         :param writeHeader: (In) If true, the header will be written, otherwise only the matrix entries will be written.

         :rtype: int
         :return: Returns 0 if no error, -1 if any problems with file system.
    """
    return _EpetraExt.MultiVectorToMatrixMarketFile(*args)

def MultiVectorToMatlabFile(*args) -> "int":
    r"""
    Writes an Epetra_MultiVector object to a file that is compatible with Matlab. This function takes any matrix that implements the Epetra_MultiVector interface and writes it
         to the specified file.  The matrix can be distributed or serial.  This function is a convenience wrapper
         around MultiVectorToMatrixMarketFile.  The following Matlab commands can be used to read the resulting file
         and convert to it to a Matlab sparse matrix:

         *  load *filename;*

         For example:

         *  load A.dat;

         The above produces a dense matrix A with each vector in the multivector as a column in A.

         :type filename: string
         :param filename: (In) A filename, including path if desired.  If a file with this name already exists,
                             it will be deleted.  On exit, this file will contain a row for each row of the multivector.
         :type A: :py:class:`Epetra_MultiVector`
         :param A: (In) An Epetra_MultiVector Object containing the user matrix to be dumped to file.

         :rtype: int
         :return: Returns 0 if no error, -1 if any problems with file system.
    """
    return _EpetraExt.MultiVectorToMatlabFile(*args)

def MultiVectorToMatrixMarketHandle(*args) -> "int":
    r"""
    Writes an Epetra_MultiVector object that is compatible with Matrix Market array format to a file handle. This function takes an Epetra_MultiVector and writes it
         to the specified file handle.

         :type handle: std::FILE
         :param handle: (In) A C-style file handle, already opened.  On exit, the file associated with this handle will
                             have appended to it a row for each multivector row.
         :type A: :py:class:`Epetra_MultiVector`
         :param A: (In) An Epetra_MultiVector Object containing the user object to be dumped to file.

         :rtype: int
         :return: Returns 0 if no error, -1 if any problems with file system.
    """
    return _EpetraExt.MultiVectorToMatrixMarketHandle(*args)

def MultiVectorToMatlabHandle(*args) -> "int":
    r"""
    Writes an Epetra_MultiVector object that is compatible with Matlab to a file handle. This function takes an Epetra_MultiVector and writes it
         to the specified file handle.

         :type handle: std::FILE
         :param handle: (In) A C-style file handle, already opened.  On exit, the file associated with this handle will
                             have appended to it a row for each multivector row.
         :type A: :py:class:`Epetra_MultiVector`
         :param A: (In) An Epetra_MultiVector Object containing the user object to be dumped to file.

         :rtype: int
         :return: Returns 0 if no error, -1 if any problems with file system.
    """
    return _EpetraExt.MultiVectorToMatlabHandle(*args)

def MultiVectorToHandle(*args) -> "int":
    return _EpetraExt.MultiVectorToHandle(*args)

def writeMultiVector(*args) -> "int":
    return _EpetraExt.writeMultiVector(*args)

def MatlabFileToCrsMatrix(*args) -> "Epetra_CrsMatrix *&":
    r"""
    MatlabFileToCrsMatrix(str filename, Epetra.Comm) -> Epetra.CrsMatrix

    Return a CrsMatrix read from a matlab file.
    """
    return _EpetraExt.MatlabFileToCrsMatrix(*args)

def MatrixMarketFileToCrsMatrix(*args) -> "Epetra_CrsMatrix *&":
    r"""
    MatrixMarketFileToCrsMatrix(str filename, Epetra.Map rowMap, Epetra.Map
        colMap=None, Epetra.Map rangeMap=None, Epetra.Map domainMap=None) ->
        Epetra.CrsMatrix

    Return a CrsMatrix read from a matrix market file.MatrixMarketFileToCrsMatrix(str filename, Epetra.Map rowMap, Epetra.Map
        colMap=None, Epetra.Map rangeMap=None, Epetra.Map domainMap=None) ->
        Epetra.CrsMatrix

    Return a CrsMatrix read from a matrix market file.MatrixMarketFileToCrsMatrix(str filename, Epetra.Map rowMap, Epetra.Map
        colMap=None, Epetra.Map rangeMap=None, Epetra.Map domainMap=None) ->
        Epetra.CrsMatrix

    Return a CrsMatrix read from a matrix market file.MatrixMarketFileToCrsMatrix(str filename, Epetra.Map rowMap, Epetra.Map
        colMap=None, Epetra.Map rangeMap=None, Epetra.Map domainMap=None) ->
        Epetra.CrsMatrix

    Return a CrsMatrix read from a matrix market file.MatrixMarketFileToCrsMatrix(str filename, Epetra.Map rowMap, Epetra.Map
        colMap=None, Epetra.Map rangeMap=None, Epetra.Map domainMap=None) ->
        Epetra.CrsMatrix

    Return a CrsMatrix read from a matrix market file.
    """
    return _EpetraExt.MatrixMarketFileToCrsMatrix(*args)

def HypreFileToCrsMatrix(*args) -> "Epetra_CrsMatrix *&":
    r"""
    Constructs an Epetra_CrsMatrix object from a Hypre Matrix Print command, the row map is specified. Reads an Epetra_CrsMatrix object from a Hypre Matrix Printout, the matrix should be square.

         :type filename: string
         :param filename: (In) A filename not including the processor id extension, including path if desired.

         :type comm: :py:class:`Epetra_Comm`
         :param comm: (In) An Epetra_Comm object describing the communication among processors.

         :type A: :py:class:`Epetra_CrsMatrix`
         :param A: (Out) An Epetra_CrsMatrix object constructed from file contents.
         Warning: User must delete!!.

         :rtype: int
         :return: Returns 0 if no error, -1 if any problems with file system.
    """
    return _EpetraExt.HypreFileToCrsMatrix(*args)

def MatrixMarketFileToCrsMatrixHandle(*args) -> "Epetra_CrsMatrix *&":
    return _EpetraExt.MatrixMarketFileToCrsMatrixHandle(*args)

def MatlabFileToCrsMatrix64(*args) -> "Epetra_CrsMatrix *&":
    return _EpetraExt.MatlabFileToCrsMatrix64(*args)

def MatrixMarketFileToCrsMatrix64(*args) -> "Epetra_CrsMatrix *&":
    return _EpetraExt.MatrixMarketFileToCrsMatrix64(*args)

def HypreFileToCrsMatrix64(*args) -> "Epetra_CrsMatrix *&":
    return _EpetraExt.HypreFileToCrsMatrix64(*args)

def MatrixMarketFileToCrsMatrixHandle64(*args) -> "Epetra_CrsMatrix *&":
    return _EpetraExt.MatrixMarketFileToCrsMatrixHandle64(*args)

def RowMatrixToMatrixMarketFile(*args) -> "int":
    r"""
    Writes an Epetra_RowMatrix object to a Matrix Market format file This function takes any matrix that implements the Epetra_RowMatrix interface and writes it
         to the specified file.  The matrix can be distributed or serial.  The user can provide
         a strings containing the matrix name, a matrix description, and specify that header information
         should or should not be printed to the file.

         :type filename: string
         :param filename: (In) A filename, including path if desired.  If a file with this name already exists,
                             it will be deleted.  On exit, this file will contained any requested header information
       		      followed by the matrix coefficients.  The file will contain a row for each matrix entry
       		      The first column is the global row index, using base 1, the second column is the global
       		      column index of the entry, the third value is the matrix value for that entry.
         :type A: :py:class:`Epetra_RowMatrix`
         :param A: (In) An Epetra_RowMatrix Object containing the user matrix to be dumped to file.  Any object
                           that implements the Epetra_RowMatrix interface can be passed in.  In particular, the
       		    Epetra_CrsMatrix, Epetra_VbrMatrix, Epetra_FECrsMatrix, Epetra_FEVbrMatrix and Epetra_MsrMatrix
       		    classes are compatible with this interface.
         :type matrixName: string, optional
         :param matrixName: (In) A C-style std::string pointer to a name that will be stored in the comment field of the file.
                                This is not a required argument.  Note that it is possible to pass in the method A.Label() if
       			 the matrix is one of the four types: Epetra_CrsMatrix, Epetra_VbrMatrix, Epetra_FECrsMatrix,
       			 Epetra_FEVbrMatrix.
         :type matrixDescription: string, optional
         :param matrixDescription: (In) A C-style std::string pointer to a matrix description that will be stored in the comment
                                           field of the file.
         :type writeHeader: boolean, optional
         :param writeHeader: (In) If true, the header will be written, otherwise only the matrix entries will be written.

         :rtype: int
         :return: Returns 0 if no error, -1 if any problems with file system.
    """
    return _EpetraExt.RowMatrixToMatrixMarketFile(*args)

def RowMatrixToMatlabFile(*args) -> "int":
    r"""
    Writes an Epetra_RowMatrix object to a file that is compatible with Matlab. This function takes any matrix that implements the Epetra_RowMatrix interface and writes it
         to the specified file.  The matrix can be distributed or serial.  This function is a convenience wrapper
         around RowMatrixToMatrixMarketFile.  The following Matlab commands can be used to read the resulting file
         and convert to it to a Matlab sparse matrix:

         *  load *filename;*
         *  matrix_name = spconvert(filename_root);

         For example:

         *  load A.dat;
         *  A = spconvert(filename_root);

         The above produces a sparse matrix A.

         :type filename: string
         :param filename: (In) A filename, including path if desired.  If a file with this name already exists,
                             it will be deleted.  On exit, this file will contain a row for each matrix entry
       		      The first column is the global row index, using base 1, the second column is the global
       		      column index of the entry, the third value is the matrix value for that entry.
         :type A: :py:class:`Epetra_RowMatrix`
         :param A: (In) An Epetra_RowMatrix Object containing the user matrix to be dumped to file.  Any object
                           that implements the Epetra_RowMatrix interface can be passed in.  In particular, the
       		    Epetra_CrsMatrix, Epetra_VbrMatrix, Epetra_FECrsMatrix, Epetra_FEVbrMatrix and Epetra_MsrMatrix
       		    classes are compatible with this interface.

         :rtype: int
         :return: Returns 0 if no error, -1 if any problems with file system.
    """
    return _EpetraExt.RowMatrixToMatlabFile(*args)

def RowMatrixToHandle(*args) -> "int":
    r"""
    Writes an Epetra_RowMatrix object to a format file that is compatible with Matlab. This function takes any matrix that implements the Epetra_RowMatrix interface and writes it
         to the specified file handle.  The matrix can be distributed or serial.  This function is a convenience wrapper
         around RowMatrixToMatrixMarketFile.

         :type handle: std::FILE
         :param handle: (In) A C-style file handle, already opened.  On exit, the file associated with this handle will
                             have appended to it a row for each matrix entry
       		      The first column is the global row index, using base 1, the second column is the global
       		      column index of the entry, the third value is the matrix value for that entry.
         :type A: :py:class:`Epetra_RowMatrix`
         :param A: (In) An Epetra_RowMatrix Object containing the user matrix to be dumped to file.  Any object
                           that implements the Epetra_RowMatrix interface can be passed in.  In particular, the
       		    Epetra_CrsMatrix, Epetra_VbrMatrix, Epetra_FECrsMatrix, Epetra_FEVbrMatrix and Epetra_MsrMatrix
       		    classes are compatible with this interface.

         :rtype: int
         :return: Returns 0 if no error, -1 if any problems with file system.
    """
    return _EpetraExt.RowMatrixToHandle(*args)

def writeRowMatrix(*args) -> "int":
    return _EpetraExt.writeRowMatrix(*args)

def MatrixMarketFileToBlockMap(*args) -> "Epetra_BlockMap *&":
    r"""
    MatrixMarketFileToBlockMap(str filename, Epetra.Comm) -> Epetra.BlockMap

    Return a BlockMap read from a matrix market file.
    """
    return _EpetraExt.MatrixMarketFileToBlockMap(*args)

def MatrixMarketFileToBlockMap64(*args) -> "Epetra_BlockMap *&":
    return _EpetraExt.MatrixMarketFileToBlockMap64(*args)

def MatrixMarketFileToMap(*args) -> "Epetra_Map *&":
    r"""
    MatrixMarketFileToMap(str filename, Epetra.Comm) -> Epetra.Map

    Return a Map read from a matrix market file.
    """
    return _EpetraExt.MatrixMarketFileToMap(*args)

def MatrixMarketFileToMap64(*args) -> "Epetra_Map *&":
    return _EpetraExt.MatrixMarketFileToMap64(*args)

def MatrixMarketFileToBlockMaps(*args) -> "Epetra_BlockMap *&, Epetra_BlockMap *&, Epetra_BlockMap *&, Epetra_BlockMap *&":
    r"""
    MatrixMarketFileToBlockMaps(str filename, Epetra.Comm) ->
        (Epetra.BlockMap rowMap, Epetra.BlockMap colMap, Epetra.BlockMap rangeMap,
         Epetra.BlockMap domainMap)

    Return a tuple of BlockMaps read from a matrix market file.  The
    BlockMaps, listed in order, are the row map, the column map, the range
    map and the domain map.
    """
    return _EpetraExt.MatrixMarketFileToBlockMaps(*args)

def MatrixMarketFileToBlockMaps64(*args) -> "Epetra_BlockMap *&, Epetra_BlockMap *&, Epetra_BlockMap *&, Epetra_BlockMap *&":
    r""" Constructs row,col,range and domain maps from a matrix-market matrix file."""
    return _EpetraExt.MatrixMarketFileToBlockMaps64(*args)

def BlockMapToMatrixMarketFile(*args) -> "int":
    r"""
    Writes an Epetra_BlockMap or Epetra_Map object to a Matrix Market format file This function takes an Epetra_BlockMap or Epetra_Map object and writes it
         to the specified file.  The map can be distributed or serial.  The user can provide
         a strings containing the object name, a description, and specify that header information
         should or should not be printed to the file.

         Special information is encoded in the comment field of this map that allows for identical reproduction
         of the map, including distribution across processors and element size information.

         The first column of the output file will be the list of GIDs in the map.
         If the block map has non-uniform sizes, a second column will be generated containing the element sizes.

         :type filename: string
         :param filename: (In) A filename, including path if desired.  If a file with this name already exists,
                             it will be deleted.  On exit, this file will contained any requested header information
       		      followed by the map GIDs. A second column may be present if the BlockMap has nonuniform sizes.
         :type blockMap: :py:class:`Epetra_BlockMap`
         :param blockMap: (In) An Epetra_BlockMap Object containing the user map to be dumped to file.
         :type mapName: string, optional
         :param mapName: (In) A C-style string pointer to a name that will be stored in the comment field of the file.
                                This is not a required argument.  Note that it is possible to pass in the method A.Label().
         :type mapDescription: string, optional
         :param mapDescription: (In) A C-style string pointer to a map description that will be stored in the comment
                                           field of the file.
         :type writeHeader: boolean, optional
         :param writeHeader: (In) If true, the header will be written, otherwise only the map entries will be written.

         :rtype: int
         :return: Returns 0 if no error, -1 if any problems with file system.
    """
    return _EpetraExt.BlockMapToMatrixMarketFile(*args)

def BlockMapToHandle(*args) -> "int":
    r"""
    Writes an Epetra_BlockMap or Epetra_Map object to a file handle. This function takes an Epetra_BlockMap or Epetra_Map object and writes it
         to the specified file handle.

         :type handle: std::FILE
         :param handle: (In) A C-style file handle, already opened.  On exit, the file associated with this handle will
                             have appended to it a row for each multivector row.
         :type blockMap: :py:class:`Epetra_BlockMap`
         :param blockMap: (In) An Epetra_BlockMap object containing the user object to be dumped to file.

         :rtype: int
         :return: Returns 0 if no error, -1 if any problems with file system.
    """
    return _EpetraExt.BlockMapToHandle(*args)

def writeBlockMap(*args) -> "int":
    return _EpetraExt.writeBlockMap(*args)
class CrsMatrix_SubCopy(SameXform_CrsMatrix):
    r""" Generates a sub-block view of a Epetra_CrsMatrix"""

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    __swig_destroy__ = _EpetraExt.delete_CrsMatrix_SubCopy

    def __init__(self, *args):
        r"""
        *Overload 1:*
        Constructor

        |

        *Overload 2:*
        Constructor
        """
        _EpetraExt.CrsMatrix_SubCopy_swiginit(self, _EpetraExt.new_CrsMatrix_SubCopy(*args))

    def __call__(self, *args) -> "EpetraExt::Transform< Epetra_CrsMatrix,Epetra_CrsMatrix >::NewTypeRef":
        r""" Transformation Operator"""
        return _EpetraExt.CrsMatrix_SubCopy___call__(self, *args)

    def fwd(self, *args) -> "bool":
        
        return _EpetraExt.CrsMatrix_SubCopy_fwd(self, *args)

    def rvs(self, *args) -> "bool":
        
        return _EpetraExt.CrsMatrix_SubCopy_rvs(self, *args)

# Register CrsMatrix_SubCopy in _EpetraExt:
_EpetraExt.CrsMatrix_SubCopy_swigregister(CrsMatrix_SubCopy)


def Add(*args) -> "int":
    r"""
    Add(Epetra.CrsMatrix A, bool flag, float valA, Epetra.CrsMatrix B,
        float valB) -> int

    Compute B <- valA * A + valB * B.  If flag is True, use the transpose
    of A.  B must either have the structure of A+B or not yet have
    FillComplete() called on it.
    """
    return _EpetraExt.Add(*args)

def Multiply(*args) -> "int":
    r"""
    Multiply(Epetra.CrsMatrix A, bool transposeA, Epetra.CrsMatrix B, bool
        transposeB, Epetra.CrsMatrix C) -> int

    Compute C <- A * B, where transposeA and transposeB control the
    transposition of A and B respectively.  C must have the structure of A
    * B, or not yet have FillComplete() called on it.
    """
    return _EpetraExt.Multiply(*args)

from PyTrilinos import Epetra
from PyTrilinos import PropertyBase
from PyTrilinos import typed_tuple
from PyTrilinos import tuple_of_int
from PyTrilinos import tuple_of_str
tuple_of_Vector = typed_tuple(Epetra.Vector)



class InArgs(PropertyBase):
    """
    InArgs proxy class.

    This is a 'Property' class restricted to specific attributes that are
    type-checked. These properties are:

    description  - string description of associated ModelEvaluation
    x            - bool or Epetra.Vector: solution vector support.  If True, the
                   solver should allocate the vector.  If False, x is not
                   supported.  If a vector, the solver should use the
                   user-provided data.  (default False)
    x_dot        - bool or Epetra.Vector: time derivative of solution vector
                   support.  If True, the solver should allocate the vector.  If
                   False, x_dot is not supported.  If a vector, the solver
                   should use the user- provided data.  (default False)
    p            - int or tuple_of_Vector: VARIABLE P support.  If an int, the
                   solver should allocate an array of the given number of
                   vectors.  If 0, p is not supported.  If a tuple_of_Vector,
                   the solver should use the user-provided data.  (default 0)
    t            - float: time (default None)
    alpha        - float: VARIABLE ALPHA (default None)
    beta         - float: VARIABLE BETA (default None)
    """
    props = {'description' : str,
             'x'           : (bool, Epetra.Vector),
#'x_poly'      : Teuchos.Polynomial,
             'x_dot'       : (bool, Epetra.Vector),
#'x_dot_poly'  : Teuchos.Polynomial,
             'p'           : (int, tuple_of_Vector),
             't'           : float,
             'alpha'       : float,
             'beta'        : float
             }
    defaults = {'description' : 'WARNING!  THIS INARGS OBJECT IS UNINITALIZED!',
                'x'           : False,
                'x_dot'       : False,
                'p'           : 0
                }
    def __init__(self, **kwargs):
        PropertyBase.__init__(self, **kwargs)



class Evaluation(PropertyBase):
    """
    Evaluation< RCP<Epetra_Vector> > proxy class

    This is a 'Property' class restricted to specific attributes that are
    type-checked. These properties are:

    vector  - Epetra.Vector: (default None)
    type    - str: an enumeration limited to 'exact', 'approx_deriv', and
              'very_approx_deriv' (default None)
    """
    props = {'vector' : Epetra.Vector,
             'type'   : ('exact', 'approx_deriv', 'very_approx_deriv')
             }
    def __init__(self, **kwargs):
        PropertyBase.__init__(self, **kwargs)

tuple_of_Evaluation = typed_tuple(Evaluation)



class DerivativeSupport(PropertyBase):
    """
    DerivativeSupport proxy class

    This is a 'Property' class restricted to specific attributes that are
    type-checked. These properties are:

    linearOp      - bool: True indicates that derivative is a linear operator
                    (default False)
    mVByCol       - bool: True indicates that derivative is a MultiVector stored
                    by column (defualt False)
    transMVByRow  - bool: True indicates that derivative is a transpose
                    MultiVector stored by row (default False)
    """
    props = {'linearOp'     : bool,
             'mVByCol'      : bool,
             'transMVByRow' : bool
             }
    defaults = {'linearOp'     : False,
                'mVByCol'      : False,
                'transMVByRow' : False
                }
    def __init__(self, **kwargs):
        PropertyBase.__init__(self, **kwargs)
    def none(self):
        noTrue = [True] * len(self.props)
        return (props.values() == noTrue)

tuple_of_DerivativeSupport = typed_tuple(DerivativeSupport)



class DerivativeProperties(PropertyBase):
    """
    DerivativeProperties proxy class

    This is a 'Property' class restricted to specific attributes that are
    type-checked. These properties are:

    linearity        - str: an enumeration limited to 'unknown', 'const' and
                       'nonconst' (default 'unknown')
    rank             - str: an enumeration limited to 'unknown', 'full' and
                       'deficient' (default 'unknown')
    supportsAdjoint  - bool: True indicates that the adjoint is supported
                       (default False)
    """
    props = {'linearity'       : ('unknown', 'const', 'nonconst'),
             'rank'            : ('unknown', 'full', 'deficient'),
             'supportsAdjoint' : bool}
    defaults = {'linearity'       : 'unknown',
                'rank'            : 'unknown',
                'supportsAdjoint' : False}
    def __init__(self, **kwargs):
        PropertyBase.__init__(self, **kwargs)

tuple_of_DerivativeProperties = typed_tuple(DerivativeProperties)



class DerivativeMultiVector(PropertyBase):
    """
    DerivativeMultiVector proxy class

    This is a 'Property' class restricted to specific attributes that are
    type-checked. These properties are:

    multiVector   - Epetra.MultiVector: (default None)
    orientation   - str: an enumeration limited to 'mv_by_col', and
                    'trans_mv_by_row' (default None)
    paramIndexes  - tuple_of_int: (default None)
    """
    props = {'multiVector'  : Epetra.MultiVector,
             'orientation'  : ('mv_by_col', 'trans_mv_by_row'),
             'paramIndexes' : tuple_of_int
             }
    def __init__(self, **kwargs):
        PropertyBase.__init__(self, **kwargs)



class Derivative(PropertyBase):
    """
    Derivative proxy class

    This is a 'Property' class restricted to specific attributes that are
    type-checked. These properties are:

    operator               - Epetra.Operator (default None)
    derivativeMultiVector  - DerivativeMultiVector (default None)

    Only one or the other of these two attributes should be set, to indicate the
    nature of the derivitive evaluation.
    """
    props = {'operator'              : Epetra.Operator,
             'derivativeMultiVector' : DerivativeMultiVector
             }
    def __init__(self, **kwargs):
        PropertyBase.__init__(self, **kwargs)
    def isEmpty(self):
        return (self.operator is None) and (self.derivativeMultiVector is None)

tuple_of_Derivative = typed_tuple(Derivative)



class OutArgs(PropertyBase):
    """
    OutArgs proxy class

    This is a 'Property' class restricted to specific attributes that are
    type-checked. These properties are:

    description          - string description of associated ModelEvaluation
    g                    - (int, tuple_of_Evaluation): VARIABLE G support.  If
                           an int, the solver should allocate an array of the
                           given number of Evaluations.  If 0, g is not
                           supported.  If a tuple_of_Evaluation, the solver
                           should use the user-provided data.  (default 0)
    f                    - (bool, Evaluation): VARIABLE F support.  If True, the
                           solver should allocate the Evaluation.  If False, f
                           is not supported.  If an Evaluation, the solver
                           should use the user-supplied data.  (default False)
    W                    - (bool, Epetra.Operator): VARIABLE W support.  If True, the
                           solver should allocate the operator.  If False, W
                           is not supported.  If an operator, the solver
                           should use the user-supplied data.  (default False)
    W_properties         - DerivativeProperties: derivative properties for
                           VARIABLE W.  (default None)
    DfDp                 - (int, tuple_of_Derivative): VARIABLE DFDP support.  If
                           an int, the solver should allocate an array of the
                           given number of Derivatives.  If 0, DfDp is not
                           supported.  If a tuple_of_Derivative, the solver
                           should use the user-provided data.  (default 0)
    DfDp_properties      - tuple_of_DerivativeProperties: derivative properties
                           for VARIABLE DFDP.  (default None)
    DgDx                 - (int, tuple_of_Derivative): VARIABLE DGDX support.  If
                           an int, the solver should allocate an array of the
                           given number of Derivatives.  If 0, DgDx is not
                           supported.  If a tuple_of_Derivative, the solver
                           should use the user-provided data.  (default 0)
    DgDx_properties      - tuple_of_DerivativeProperties: derivative properties
                           for VARIABLE DGDX.  (default None)
    DgDx_dot             - (int, tuple_of_Derivative): VARIABLE DGDX_DOT support.
                           If an int, the solver should allocate an array of the
                           given number of Derivatives.  If 0, DgDx_dot is not
                           supported.  If a tuple_of_Derivative, the solver
                           should use the user-provided data.  (default 0)
    DgDx_dot_properties  - tuple_of_DerivativeProperties: derivative properties
                           for VARIABLE DGDX_DOT.  (default None)
    DgDp                 - (int, tuple_of_Derivative): VARIABLE DGDP support.  If
                           an int, the solver should allocate an array of the
                           given number of Derivatives.  If 0, DgDp is not
                           supported.  If a tuple_of_Derivative, the solver
                           should use the user-provided data.  (default 0)
    DgDp_properties      - tuple_of_DerivativeProperties: derivative properties
                           for VARIABLE DGDP.  (default None)
    """
    props = {'description'         : str,
             'g'                   : (int, tuple_of_Evaluation),
             'f'                   : (bool, Evaluation),
             'W'                   : (bool, Epetra.Operator),
             'W_properties'        : DerivativeProperties,
#'f_poly'              : Teuchos.Polynomial,
             'DfDp'                : (int, tuple_of_Derivative),
             'DfDp_properties'     : tuple_of_DerivativeProperties,
             'DgDx'                : (int, tuple_of_Derivative),
             'DgDx_properties'     : tuple_of_DerivativeProperties,
             'DgDx_dot'            : (int, tuple_of_Derivative),
             'DgDx_dot_properties' : tuple_of_DerivativeProperties,
             'DgDp'                : (int, tuple_of_Derivative),
             'DgDp_properties'     : tuple_of_DerivativeProperties
             }
    defaults = {'description' : 'WARNING!  THIS OUTARGS OBJECT IS UNINITALIZED!',
                'g'           : 0,
                'f'           : False,
                'W'           : False,
                'DfDp'        : 0,
                'DgDx'        : 0,
                'DgDx_dot'    : 0,
                'DgDp'        : 0
                }
    def __init__(self, **kwargs):
        PropertyBase.__init__(self, **kwargs)


class ModelEvaluator(Teuchos.Base.Describable):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    __swig_destroy__ = _EpetraExt.delete_ModelEvaluator

    def get_x_map(self, *args) -> "Teuchos::RCP< Epetra_Map const >":
        return _EpetraExt.ModelEvaluator_get_x_map(self, *args)

    def get_f_map(self, *args) -> "Teuchos::RCP< Epetra_Map const >":
        return _EpetraExt.ModelEvaluator_get_f_map(self, *args)

    def get_p_map(self, *args) -> "Teuchos::RCP< Epetra_Map const >":
        return _EpetraExt.ModelEvaluator_get_p_map(self, *args)

    def get_p_names(self, *args) -> "Teuchos::RCP< Teuchos::Array< std::string > const >":
        return _EpetraExt.ModelEvaluator_get_p_names(self, *args)

    def get_g_map(self, *args) -> "Teuchos::RCP< Epetra_Map const >":
        return _EpetraExt.ModelEvaluator_get_g_map(self, *args)

    def get_x_init(self, *args) -> "Teuchos::RCP< Epetra_Vector const >":
        return _EpetraExt.ModelEvaluator_get_x_init(self, *args)

    def get_x_dot_init(self, *args) -> "Teuchos::RCP< Epetra_Vector const >":
        return _EpetraExt.ModelEvaluator_get_x_dot_init(self, *args)

    def get_p_init(self, *args) -> "Teuchos::RCP< Epetra_Vector const >":
        return _EpetraExt.ModelEvaluator_get_p_init(self, *args)

    def get_t_init(self, *args) -> "double":
        return _EpetraExt.ModelEvaluator_get_t_init(self, *args)

    def getInfBound(self, *args) -> "double":
        return _EpetraExt.ModelEvaluator_getInfBound(self, *args)

    def get_x_lower_bounds(self, *args) -> "Teuchos::RCP< Epetra_Vector const >":
        return _EpetraExt.ModelEvaluator_get_x_lower_bounds(self, *args)

    def get_x_upper_bounds(self, *args) -> "Teuchos::RCP< Epetra_Vector const >":
        return _EpetraExt.ModelEvaluator_get_x_upper_bounds(self, *args)

    def get_p_lower_bounds(self, *args) -> "Teuchos::RCP< Epetra_Vector const >":
        return _EpetraExt.ModelEvaluator_get_p_lower_bounds(self, *args)

    def get_p_upper_bounds(self, *args) -> "Teuchos::RCP< Epetra_Vector const >":
        return _EpetraExt.ModelEvaluator_get_p_upper_bounds(self, *args)

    def get_t_lower_bound(self, *args) -> "double":
        return _EpetraExt.ModelEvaluator_get_t_lower_bound(self, *args)

    def get_t_upper_bound(self, *args) -> "double":
        return _EpetraExt.ModelEvaluator_get_t_upper_bound(self, *args)

    def create_W(self, *args) -> "Teuchos::RCP< Epetra_Operator >":
        return _EpetraExt.ModelEvaluator_create_W(self, *args)

    def create_DfDp_op(self, *args) -> "Teuchos::RCP< Epetra_Operator >":
        return _EpetraExt.ModelEvaluator_create_DfDp_op(self, *args)

    def create_DgDx_dot_op(self, *args) -> "Teuchos::RCP< Epetra_Operator >":
        return _EpetraExt.ModelEvaluator_create_DgDx_dot_op(self, *args)

    def create_DgDx_op(self, *args) -> "Teuchos::RCP< Epetra_Operator >":
        return _EpetraExt.ModelEvaluator_create_DgDx_op(self, *args)

    def create_DgDp_op(self, *args) -> "Teuchos::RCP< Epetra_Operator >":
        return _EpetraExt.ModelEvaluator_create_DgDp_op(self, *args)

    def createInArgs(self, *args) -> "EpetraExt::ModelEvaluator::InArgs":
        return _EpetraExt.ModelEvaluator_createInArgs(self, *args)

    def createOutArgs(self, *args) -> "EpetraExt::ModelEvaluator::OutArgs":
        return _EpetraExt.ModelEvaluator_createOutArgs(self, *args)

    def evalModel(self, *args) -> "void":
        return _EpetraExt.ModelEvaluator_evalModel(self, *args)

    def __init__(self, *args):
        if self.__class__ == ModelEvaluator:
            _self = None
        else:
            _self = self
        _EpetraExt.ModelEvaluator_swiginit(self, _EpetraExt.new_ModelEvaluator(_self, *args))
    def __disown__(self):
        self.this.disown()
        _EpetraExt.disown_ModelEvaluator(self)
        return weakref.proxy(self)

# Register ModelEvaluator in _EpetraExt:
_EpetraExt.ModelEvaluator_swigregister(ModelEvaluator)



