# This file was automatically generated by SWIG (http://www.swig.org).
# Version 4.0.2
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.

"""

PyTrilinos.IFPACK is the python interface to the Trilinos
preconditioner package IFPACK:

    https://trilinos.org/docs/dev/packages/ifpack/doc/html/index.html

The purpose of IFPACK is to provide incomplete foctorization
preconditioners to Trilinos.  Note that the C++ version of IFPACK uses
the prefix 'Ifpack_' which has been stripped from the python version.

IFPACK provides the following user-level classes:

    * Factory         - A factory for creating IFPACK preconditioners
    * Preconditioner  - Pure virtual base class for defining interface
    * IC              - Incomplete Cholesky preconditioner
    * ICT             - Incomplete Cholesky preconditioner w/threshold
    * ILU             - Incomplete lower/upper preconditioner
    * ILUT            - Incomplete lower/upper preconditioner w/threshold
    * PointRelaxation - Point relaxation predonditioner
    * Amesos          - Use Amesos factorizations as preconditioners

and functions:

    * AnalyzeMatrix          - Analyze the basic properties of a matrix
    * AnalyzeMatrixElements  - Analyze the distribution of values of a matrix
    * AnalyzeVectorElements  - Analyze the distribution of values of a vector
    * PrintSparsity          - Create PS file with sparsity pattern of matrix

For examples of usage, please consult the following scripts in the
example subdirectory of the PyTrilinos package:

    * exIFPACK.py

"""

from sys import version_info as _swig_python_version_info
if _swig_python_version_info < (2, 7, 0):
    raise RuntimeError("Python 2.7 or later required")

# Import the low-level C/C++ module
if __package__ or "." in __name__:
    from . import _IFPACK
else:
    import _IFPACK

try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)


def _swig_setattr_nondynamic_instance_variable(set):
    def set_instance_attr(self, name, value):
        if name == "thisown":
            self.this.own(value)
        elif name == "this":
            set(self, name, value)
        elif hasattr(self, name) and isinstance(getattr(type(self), name), property):
            set(self, name, value)
        else:
            raise AttributeError("You cannot add instance attributes to %s" % self)
    return set_instance_attr


def _swig_setattr_nondynamic_class_variable(set):
    def set_class_attr(cls, name, value):
        if hasattr(cls, name) and not isinstance(getattr(cls, name), property):
            set(cls, name, value)
        else:
            raise AttributeError("You cannot add class attributes to %s" % cls)
    return set_class_attr


def _swig_add_metaclass(metaclass):
    """Class decorator for adding a metaclass to a SWIG wrapped class - a slimmed down version of six.add_metaclass"""
    def wrapper(cls):
        return metaclass(cls.__name__, cls.__bases__, cls.__dict__.copy())
    return wrapper


class _SwigNonDynamicMeta(type):
    """Meta class to enforce nondynamic attributes (no new attributes) for a class"""
    __setattr__ = _swig_setattr_nondynamic_class_variable(type.__setattr__)


import weakref

from . import Teuchos
from .Teuchos import Base
from . import Epetra

def Ifpack_Version(*args) -> "std::string":
    return _IFPACK.Ifpack_Version(*args)

Version = Ifpack_Version
__version__ = Version().split()[3]


def Ifpack_PrintLine(*args) -> "void":
    r""" Prints a line of `=' on cout"""
    return _IFPACK.Ifpack_PrintLine(*args)

def Ifpack_BreakForDebugger(*args) -> "void":
    r""" Stops the execution of code, so that a debugger can be attached."""
    return _IFPACK.Ifpack_BreakForDebugger(*args)

def Ifpack_CreateOverlappingCrsMatrix(*args) -> "Epetra_CrsGraph *":
    r"""
    *Overload 1:*
    Creates an overlapping Epetra_CrsMatrix. Returns 0 if OverlappingLevel is 0.

    |

    *Overload 2:*
    Creates an overlapping Epetra_CrsGraph. Returns 0 if OverlappingLevel is 0.
    """
    return _IFPACK.Ifpack_CreateOverlappingCrsMatrix(*args)

def Ifpack_toString(*args) -> "std::string":
    r"""
    *Overload 1:*
    Converts an integer to std::string.

    |

    *Overload 2:*
    Converts a double to std::string.
    """
    return _IFPACK.Ifpack_toString(*args)

def Ifpack_PrintResidual(*args) -> "int":
    return _IFPACK.Ifpack_PrintResidual(*args)

def Ifpack_PrintSparsity_Simple(*args) -> "void":
    return _IFPACK.Ifpack_PrintSparsity_Simple(*args)

def AnalyzeMatrix(*args) -> "int":
    r""" Analyzes the basic properties of the input matrix A; see 'ifp_analyze'."""
    return _IFPACK.AnalyzeMatrix(*args)

def AnalyzeMatrixElements(*args) -> "int":
    r"""
    Analyzes the distribution of values of the input matrix A.
    :type A: :py:class:`Epetra_RowMatrix`
    :param A: - (In) matrix to be analyzed.
    :type abs: boolean, optional
    :param abs: - (In) if ``true``, the function will analyze matrix
                     B, whose elements are defined as :math:`B_{i,i} = | A_{i,i}|`.
    :type steps: int, optional
    :param steps: - (In) number of intervals for the analysis.

    An example of output is reported 'ifp_matrix'.
    """
    return _IFPACK.AnalyzeMatrixElements(*args)

def AnalyzeVectorElements(*args) -> "int":
    r"""
    Analyzes the distribution of values of the input vector Diagonal.
    :type Diagonal: :py:class:`Epetra_Vector`
    :param Diagonal: - (In) Vector to be analyzed.
    :type abs: boolean, optional
    :param abs: - (In) if ``true``, the function will analyze vector
                     B, whose elements are defined as :math:`B_{i} = | D_{i}|`.
    :type steps: int, optional
    :param steps: - (In) number of intervals for the analysis.

    An example of output is reported 'ifp_vector'.
    """
    return _IFPACK.AnalyzeVectorElements(*args)

def PrintSparsity(*args) -> "int":
    r"""
    Plots the sparsity pattern of an Epetra_RowMatrix into a PS file.
    :type A: :py:class:`Epetra_RowMatrix`
    :param A: (In) - Epetra_RowMatrix whose sparsity pattern will be plotted.

    :type FileName: string, optional
    :param FileName: (In) - char std::string containing the filename.
                               If 0, then the matrix label is used as file name,
                               after appending .ps.

    :type NumPDEEqns: int, optional
    :param NumPDEEqns: (In) - number of PDE equations. The function will plot
                      the block structure of the matrix if NumPDEEqns > 1


    """
    return _IFPACK.PrintSparsity(*args)
class Ifpack_Element(object):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        _IFPACK.Ifpack_Element_swiginit(self, _IFPACK.new_Ifpack_Element(*args))

    def Index(self, *args) -> "int":
        return _IFPACK.Ifpack_Element_Index(self, *args)

    def Value(self, *args) -> "double":
        return _IFPACK.Ifpack_Element_Value(self, *args)

    def AbsValue(self, *args) -> "double":
        return _IFPACK.Ifpack_Element_AbsValue(self, *args)

    def SetIndex(self, *args) -> "void":
        return _IFPACK.Ifpack_Element_SetIndex(self, *args)

    def SetValue(self, *args) -> "void":
        return _IFPACK.Ifpack_Element_SetValue(self, *args)

    def __lt__(self, *args) -> "bool":
        return _IFPACK.Ifpack_Element___lt__(self, *args)
    __swig_destroy__ = _IFPACK.delete_Ifpack_Element

# Register Ifpack_Element in _IFPACK:
_IFPACK.Ifpack_Element_swigregister(Ifpack_Element)

class Preconditioner(Epetra.Operator):
    r"""
     Ifpack_Preconditioner: basic class for preconditioning in Ifpack
      Class Ifpack_Preconditioner is a pure virtual class, and it defines
      the structure of all Ifpack preconditioners.

      This class is a simple extension to Epetra_Operator. It provides
      the following additional methods:
      - Initialize() performs all operations based on the graph
        of the matrix (without considering the numerical values);
      - IsInitialized() returns true if the preconditioner
        has been successfully initialized;
      - Compute() computes all is required to apply the
        preconditioner, using matrix values  (and assuming that the
        sparsity of the matrix has not been changed);
      - IsComputed() should return true if the preconditioner
        has been successfully computed, false otherwise.
      - Condest() returns an estimation of the condition number, or -1.0
        if not available
      - Matrix() returns a reference to the matrix to be preconditioned.

    It is required that Compute() call Initialize() if IsInitialized()
    returns false. The preconditioner is applied by ApplyInverse()
    (which returns if IsComputed() is false). Every time that Initialize()
    is called, the object destroys all the previously allocated
    information, and re-initialize the preconditioner. Every time
    Compute() is called, the object re-computed the actual values of
    the preconditioner.

    **Estimating Preconditioner Condition Numbers**

    The condition of a matrix :math:`B`, called :math:`cond_p(B)`, is defined as
    :math:`cond_p(B) = \|B\|_p\|B^{-1}\|_p` in some appropriate norm :math:`p`.  :math:`cond_p(B)`
    gives some indication of how many accurate floating point
    digits can be expected from operations involving the matrix and its
    inverse.  A condition number approaching the accuracy of a given
    floating point number system, about 15 decimal digits in IEEE double
    precision, means that any results involving :math:`B` or :math:`B^{-1}` may be
    meaningless.

    Method Compute() can be use to estimate of the condition number.
    Compute() requires one parameter, of type Ifpack_CondestType
    (default value is Ifpack_Cheap; other valid choices are Ifpack_CG and
    Ifpack_GMRES).

    While Ifpack_CG and Ifpack_GMRES construct and AztecOO solver, and
    use methods AZ_cg_condnum and AZ_gmres_condnum to evaluate an
    accurate (but very expensive) estimate of the condition number,
    Ifpack_Cheap computes :math:`\|(P)^{-1}e\|_\infty`, which is
    only a very crude estimation of the actual condition number. Note that
    this estimated number can be less than 1.0.
    However, this approach has the following advantages:
    - since finding :math:`z` such that :math:`P z = y`
    is a basic kernel for applying the preconditioner, computing this
    estimate of :math:`cond_\infty(P^{-1})` is performed by setting :math:`y = e`, calling
    the solve kernel to compute :math:`z` and then
    computing :math:`\|z\|_\infty`;
    - the only cost is one application of the preconditioner.

    If this estimate is very large, the application of the computed
    preconditioner may generate large numerical errors. Hence, the user
    may check this number, and decide to recompute the preconditioner is
    the computed estimate is larger than a given threshold. This is particularly useful in ICT and RILUK factorizations, as for
    ill-conditioned matrices, we often have difficulty computing usable incomplete
    factorizations.  The most common source of problems is that the factorization may encounter a small or zero pivot,
    in which case the factorization can fail, or even if the factorization
    succeeds, the factors may be so poorly conditioned that use of them in
    the iterative phase produces meaningless results.  Before we can fix
    this problem, we must be able to detect it.


    Notes: 
      If IFPACK is configured with Teuchos support, method SetParameters()
      should be adopted. Otherwise, users can set parameters (one at-a-time),
      using methods SetParameter(), for integers and doubles.
      Sep-04

      Ifpack_Preconditioner objects overload the << operator. Derived
      classes should specify a Print() method, that will be used in
      operator <<.

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr

    def SetParameters(self, *args) -> "int":
        r""" Sets all parameters for the preconditioner."""
        return _IFPACK.Preconditioner_SetParameters(self, *args)

    def Initialize(self, *args) -> "int":
        r""" Computes all it is necessary to initialize the preconditioner."""
        return _IFPACK.Preconditioner_Initialize(self, *args)

    def IsInitialized(self, *args) -> "bool":
        r""" Returns true if the  preconditioner has been successfully initialized, false otherwise."""
        return _IFPACK.Preconditioner_IsInitialized(self, *args)

    def Compute(self, *args) -> "int":
        r""" Computes all it is necessary to apply the preconditioner."""
        return _IFPACK.Preconditioner_Compute(self, *args)

    def IsComputed(self, *args) -> "bool":
        r""" Returns true if the  preconditioner has been successfully computed, false otherwise."""
        return _IFPACK.Preconditioner_IsComputed(self, *args)

    def Condest(self, *args) -> "double":
        r""" Computes the condition number estimate, returns its value."""
        return _IFPACK.Preconditioner_Condest(self, *args)

    def ApplyInverse(self, *args) -> "int":
        r"""
        ApplyInverse(self, MultiVector x, MultiVector y) -> int

        In C++, the ApplyInverse() method is pure virtual, thus intended to be
        overridden by derived classes.  In python, cross-language polymorphism
        is supported, and you are expected to derive classes from this base
        class and redefine the ApplyInverse() method.  C++ code (e.g., AztecOO
        solvers) can call back to your ApplyInverse() method as needed.  You
        must support two arguments, labeled here MultiVector x and MultiVector
        y.  These will be converted from Epetra_MultiVector C++ objects to
        numpy-hybrid Epetra.MultiVector objects before they are passed to you.
        Thus, it is legal to use slice indexing and other numpy features to
        compute y from x.

        If application of your operator is successful, return 0; else return
        some non-zero error code.

        It is strongly suggested that you prevent ApplyInverse() from raising
        any exceptions.  Accidental errors can be prevented by wrapping your
        code in a try block:

            try:
                # Your code goes here...
            except Exception, e:
                print 'A python exception was raised by method ApplyInverse:'
                print e
                return -1

        By returning a -1, you inform the calling routine that ApplyInverse()
        was unsuccessful.

        """
        return _IFPACK.Preconditioner_ApplyInverse(self, *args)

    def Matrix(self, *args) -> "Epetra_RowMatrix const &":
        r""" Returns a pointer to the matrix to be preconditioned."""
        return _IFPACK.Preconditioner_Matrix(self, *args)

    def NumInitialize(self, *args) -> "int":
        r""" Returns the number of calls to Initialize()."""
        return _IFPACK.Preconditioner_NumInitialize(self, *args)

    def NumCompute(self, *args) -> "int":
        r""" Returns the number of calls to Compute()."""
        return _IFPACK.Preconditioner_NumCompute(self, *args)

    def NumApplyInverse(self, *args) -> "int":
        r""" Returns the number of calls to ApplyInverse()."""
        return _IFPACK.Preconditioner_NumApplyInverse(self, *args)

    def InitializeTime(self, *args) -> "double":
        r""" Returns the time spent in Initialize()."""
        return _IFPACK.Preconditioner_InitializeTime(self, *args)

    def ComputeTime(self, *args) -> "double":
        r""" Returns the time spent in Compute()."""
        return _IFPACK.Preconditioner_ComputeTime(self, *args)

    def ApplyInverseTime(self, *args) -> "double":
        r""" Returns the time spent in ApplyInverse()."""
        return _IFPACK.Preconditioner_ApplyInverseTime(self, *args)

    def InitializeFlops(self, *args) -> "double":
        r""" Returns the number of flops in the initialization phase."""
        return _IFPACK.Preconditioner_InitializeFlops(self, *args)

    def ComputeFlops(self, *args) -> "double":
        r""" Returns the number of flops in the computation phase."""
        return _IFPACK.Preconditioner_ComputeFlops(self, *args)

    def ApplyInverseFlops(self, *args) -> "double":
        r""" Returns the number of flops in the application of the preconditioner."""
        return _IFPACK.Preconditioner_ApplyInverseFlops(self, *args)

    def __str__(self, *args) -> "std::string":
        return _IFPACK.Preconditioner___str__(self, *args)
    __swig_destroy__ = _IFPACK.delete_Preconditioner

# Register Preconditioner in _IFPACK:
_IFPACK.Preconditioner_swigregister(Preconditioner)

class IC(Preconditioner):
    r"""
    Ifpack_IC: A class for constructing and using an incomplete Cholesky factorization of a given Epetra_RowMatrix. The Ifpack_IC class computes a threshold (not level) based incomplete
    LDL^T factorization of a given Epetra_RowMatrix.  The factorization
    that is produced is a function of several parameters:

     *  Level of fill ratio. This defines the maximum number of entries per row/column in the factor, relative to the average number of nonzeros per row/col in A. The default value of 1.0 keeps the IC factor as sparse as A.

     *  Diagonal perturbation - Prior to computing the factorization, it is possible to modify the diagonal entries of the matrix
          for which the factorization will be computing.  If the absolute and relative perturbation values are zero and one,
          respectively, the
          factorization will be compute for the original user matrix A.  Otherwise, the factorization
          will computed for a matrix that differs from the original user matrix in the diagonal values only. Details can be found in 'ifp_diag_pert'.


    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        Ifpack_IC constuctor with variable number of indices per row. Creates a Ifpack_IC object and allocates storage.

           :param In:
                      A - User matrix to be factored.
           :param In:
                      Graph - Graph generated by Ifpack_IlukGraph.
        """
        _IFPACK.IC_swiginit(self, _IFPACK.new_IC(*args))
    __swig_destroy__ = _IFPACK.delete_IC

    def SetAbsoluteThreshold(self, *args) -> "void":
        r""" Set absolute threshold value"""
        return _IFPACK.IC_SetAbsoluteThreshold(self, *args)

    def SetRelativeThreshold(self, *args) -> "void":
        r""" Set relative threshold value"""
        return _IFPACK.IC_SetRelativeThreshold(self, *args)

    def SetParameters(self, *args) -> "int":
        r""" Set parameters using a Teuchos::ParameterList object."""
        return _IFPACK.IC_SetParameters(self, *args)

    def SetParameter(self, *args) -> "int":
        return _IFPACK.IC_SetParameter(self, *args)

    def Matrix(self, *args) -> "Epetra_RowMatrix &":
        return _IFPACK.IC_Matrix(self, *args)

    def IsInitialized(self, *args) -> "bool":
        return _IFPACK.IC_IsInitialized(self, *args)

    def Initialize(self, *args) -> "int":
        r"""
        Initialize L and U with values from user matrix A. Copies values from the user's matrix into the nonzero pattern of L and U.
           :param In:
                      A - User matrix to be factored.
           Warning: The graph of A must be identical to the graph passed in to Ifpack_IlukGraph constructor.
        """
        return _IFPACK.IC_Initialize(self, *args)

    def Compute(self, *args) -> "int":
        r"""
        Compute IC factor U using the specified graph, diagonal perturbation thresholds and relaxation parameters. This function computes the RILU(k) factors L and U using the current:

           *  Ifpack_IlukGraph specifying the structure of L and U.
           *  Value for the RILU(k) relaxation parameter.
           *  Value for the *a* *priori* diagonal threshold values.

           InitValues() must be called before the factorization can proceed.
        """
        return _IFPACK.IC_Compute(self, *args)

    def ComputeSetup(self, *args) -> "int":
        return _IFPACK.IC_ComputeSetup(self, *args)

    def IsComputed(self, *args) -> "bool":
        r""" If factor is completed, this query returns true, otherwise it returns false."""
        return _IFPACK.IC_IsComputed(self, *args)

    def ApplyInverse(self, *args) -> "int":
        r"""
        ApplyInverse(self, MultiVector x, MultiVector y) -> int

        In C++, the ApplyInverse() method is pure virtual, thus intended to be
        overridden by derived classes.  In python, cross-language polymorphism
        is supported, and you are expected to derive classes from this base
        class and redefine the ApplyInverse() method.  C++ code (e.g., AztecOO
        solvers) can call back to your ApplyInverse() method as needed.  You
        must support two arguments, labeled here MultiVector x and MultiVector
        y.  These will be converted from Epetra_MultiVector C++ objects to
        numpy-hybrid Epetra.MultiVector objects before they are passed to you.
        Thus, it is legal to use slice indexing and other numpy features to
        compute y from x.

        If application of your operator is successful, return 0; else return
        some non-zero error code.

        It is strongly suggested that you prevent ApplyInverse() from raising
        any exceptions.  Accidental errors can be prevented by wrapping your
        code in a try block:

            try:
                # Your code goes here...
            except Exception, e:
                print 'A python exception was raised by method ApplyInverse:'
                print e
                return -1

        By returning a -1, you inform the calling routine that ApplyInverse()
        was unsuccessful.

        """
        return _IFPACK.IC_ApplyInverse(self, *args)

    def Apply(self, *args) -> "int":
        r"""
        Apply(self, MultiVector x, MultiVector y) -> int

        In C++, the Apply() method is pure virtual, thus intended to be
        overridden by derived classes.  In python, cross-language polymorphism
        is supported, and you are expected to derive classes from this base
        class and redefine the Apply() method.  C++ code (e.g., AztecOO
        solvers) can call back to your Apply() method as needed.  You must
        support two arguments, labeled here MultiVector x and MultiVector y.
        These will be converted from Epetra_MultiVector C++ objects to
        numpy-hybrid Epetra.MultiVector objects before they are passed to you.
        Thus, it is legal to use slice indexing and other numpy features to
        compute y from x.

        If application of your operator is successful, return 0; else return
        some non-zero error code.

        It is strongly suggested that you prevent Apply() from raising any
        exceptions.  Accidental errors can be prevented by wrapping your code
        in a try block:

            try:
                # Your code goes here...
            except Exception, e:
                print 'A python exception was raised by method Apply:'
                print e
                return -1

        By returning a -1, you inform the calling routine that Apply() was
        unsuccessful.

        """
        return _IFPACK.IC_Apply(self, *args)

    def Condest(self, *args) -> "double":
        r"""
        Returns the maximum over all the condition number estimate for each local ILU set of factors. This functions computes a local condition number estimate on each processor and return the
             maximum over all processor of the estimate.
          :param In:
               Trans -If true, solve transpose problem.
           :param Out:
               ConditionNumberEstimate - The maximum across all processors of
               the infinity-norm estimate of the condition number of the inverse of LDU.
        """
        return _IFPACK.IC_Condest(self, *args)

    def GetAbsoluteThreshold(self, *args) -> "double":
        r""" Get absolute threshold value"""
        return _IFPACK.IC_GetAbsoluteThreshold(self, *args)

    def GetRelativeThreshold(self, *args) -> "double":
        r""" Get relative threshold value"""
        return _IFPACK.IC_GetRelativeThreshold(self, *args)

    def NumGlobalNonzeros(self, *args) -> "int":
        r""" Returns the number of nonzero entries in the global graph."""
        return _IFPACK.IC_NumGlobalNonzeros(self, *args)

    def NumGlobalNonzeros64(self, *args) -> "long long":
        return _IFPACK.IC_NumGlobalNonzeros64(self, *args)

    def NumMyNonzeros(self, *args) -> "int":
        r""" Returns the number of nonzero entries in the local graph."""
        return _IFPACK.IC_NumMyNonzeros(self, *args)

    def D(self, *args) -> "Epetra_Vector const &":
        r""" Returns the address of the D factor associated with this factored matrix."""
        return _IFPACK.IC_D(self, *args)

    def U(self, *args) -> "Epetra_CrsMatrix const &":
        r""" Returns the address of the U factor associated with this factored matrix."""
        return _IFPACK.IC_U(self, *args)

    def SetUseTranspose(self, *args) -> "int":
        r"""
        If set true, transpose of this operator will be applied. This flag allows the transpose of the given operator to be used implicitly.  Setting this flag
               affects only the Apply() and ApplyInverse() methods.  If the implementation of this interface
               does not support transpose use, this method should return a value of -1.

           :param In:
                      UseTranspose_in -If true, multiply by the transpose of operator, otherwise just use operator.

           :rtype: int
           :return: Always returns 0.
        """
        return _IFPACK.IC_SetUseTranspose(self, *args)

    def NormInf(self, *args) -> "double":
        r""" Returns 0.0 because this class cannot compute Inf-norm."""
        return _IFPACK.IC_NormInf(self, *args)

    def HasNormInf(self, *args) -> "bool":
        r""" Returns false because this class cannot compute an Inf-norm."""
        return _IFPACK.IC_HasNormInf(self, *args)

    def UseTranspose(self, *args) -> "bool":
        r""" Returns the current UseTranspose setting."""
        return _IFPACK.IC_UseTranspose(self, *args)

    def OperatorDomainMap(self, *args) -> "Epetra_Map const &":
        r""" Returns the Epetra_Map object associated with the domain of this operator."""
        return _IFPACK.IC_OperatorDomainMap(self, *args)

    def OperatorRangeMap(self, *args) -> "Epetra_Map const &":
        r""" Returns the Epetra_Map object associated with the range of this operator."""
        return _IFPACK.IC_OperatorRangeMap(self, *args)

    def Comm(self, *args) -> "Epetra_Comm const &":
        r""" Returns the Epetra_BlockMap object associated with the range of this matrix operator."""
        return _IFPACK.IC_Comm(self, *args)

    def Label(self, *args) -> "char const *":
        return _IFPACK.IC_Label(self, *args)

    def SetLabel(self, *args) -> "int":
        return _IFPACK.IC_SetLabel(self, *args)

    def NumInitialize(self, *args) -> "int":
        r""" Returns the number of calls to Initialize()."""
        return _IFPACK.IC_NumInitialize(self, *args)

    def NumCompute(self, *args) -> "int":
        r""" Returns the number of calls to Compute()."""
        return _IFPACK.IC_NumCompute(self, *args)

    def NumApplyInverse(self, *args) -> "int":
        r""" Returns the number of calls to ApplyInverse()."""
        return _IFPACK.IC_NumApplyInverse(self, *args)

    def InitializeTime(self, *args) -> "double":
        r""" Returns the time spent in Initialize()."""
        return _IFPACK.IC_InitializeTime(self, *args)

    def ComputeTime(self, *args) -> "double":
        r""" Returns the time spent in Compute()."""
        return _IFPACK.IC_ComputeTime(self, *args)

    def ApplyInverseTime(self, *args) -> "double":
        r""" Returns the time spent in ApplyInverse()."""
        return _IFPACK.IC_ApplyInverseTime(self, *args)

    def InitializeFlops(self, *args) -> "double":
        r""" Returns the number of flops in the initialization phase."""
        return _IFPACK.IC_InitializeFlops(self, *args)

    def ComputeFlops(self, *args) -> "double":
        return _IFPACK.IC_ComputeFlops(self, *args)

    def ApplyInverseFlops(self, *args) -> "double":
        return _IFPACK.IC_ApplyInverseFlops(self, *args)

# Register IC in _IFPACK:
_IFPACK.IC_swigregister(IC)

class ICT(Preconditioner):
    r"""
    Ifpack_ICT: A class for constructing and using an incomplete Cholesky factorization of a given Epetra_RowMatrix. The Ifpack_ICT class computes a threshold based incomplete
    LDL^T factorization of a given Epetra_RowMatrix.  The factorization
    that is produced is a function of several parameters:

     *  Maximum number of entries per row/column in factor - The factorization will contain at most this number of nonzero
          terms in each row/column of the factorization.

     *  Diagonal perturbation - Prior to computing the factorization, it is possible to modify the diagonal entries of the matrix
          for which the factorization will be computing.  If the absolute and relative perturbation values are zero and one,
          respectively, the
          factorization will be compute for the original user matrix A.  Otherwise, the factorization
          will computed for a matrix that differs from the original user matrix in the diagonal values only. Details can be found in 'ifp_diag_pert'.


    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        Ifpack_ICT constuctor with variable number of indices per row. Creates a Ifpack_ICT object and allocates storage.

           :param In:
                      A - User matrix to be factored.
           :param In:
                      Graph - Graph generated by Ifpack_IlukGraph.
        """
        _IFPACK.ICT_swiginit(self, _IFPACK.new_ICT(*args))
    __swig_destroy__ = _IFPACK.delete_ICT

    def SetParameters(self, *args) -> "int":
        r""" Set parameters using a Teuchos::ParameterList object."""
        return _IFPACK.ICT_SetParameters(self, *args)

    def Matrix(self, *args) -> "Epetra_RowMatrix const &":
        r""" Returns a reference to the matrix to be preconditioned."""
        return _IFPACK.ICT_Matrix(self, *args)

    def IsInitialized(self, *args) -> "bool":
        r""" Returns ``true`` is the preconditioner has been successfully initialized."""
        return _IFPACK.ICT_IsInitialized(self, *args)

    def Initialize(self, *args) -> "int":
        r"""
        Initialize L and U with values from user matrix A. Copies values from the user's matrix into the nonzero pattern of L and U.
           :param In:
                      A - User matrix to be factored.
           Warning: The graph of A must be identical to the graph passed in to Ifpack_IlukGraph constructor.
        """
        return _IFPACK.ICT_Initialize(self, *args)

    def Compute(self, *args) -> "int":
        r"""
        Compute IC factor U using the specified graph, diagonal perturbation thresholds and relaxation parameters. This function computes the RILU(k) factors L and U using the current:

           *  Ifpack_IlukGraph specifying the structure of L and U.
           *  Value for the RILU(k) relaxation parameter.
           *  Value for the *a* *priori* diagonal threshold values.

           InitValues() must be called before the factorization can proceed.
        """
        return _IFPACK.ICT_Compute(self, *args)

    def IsComputed(self, *args) -> "bool":
        r""" If factor is completed, this query returns true, otherwise it returns false."""
        return _IFPACK.ICT_IsComputed(self, *args)

    def ApplyInverse(self, *args) -> "int":
        r"""
        ApplyInverse(self, MultiVector x, MultiVector y) -> int

        In C++, the ApplyInverse() method is pure virtual, thus intended to be
        overridden by derived classes.  In python, cross-language polymorphism
        is supported, and you are expected to derive classes from this base
        class and redefine the ApplyInverse() method.  C++ code (e.g., AztecOO
        solvers) can call back to your ApplyInverse() method as needed.  You
        must support two arguments, labeled here MultiVector x and MultiVector
        y.  These will be converted from Epetra_MultiVector C++ objects to
        numpy-hybrid Epetra.MultiVector objects before they are passed to you.
        Thus, it is legal to use slice indexing and other numpy features to
        compute y from x.

        If application of your operator is successful, return 0; else return
        some non-zero error code.

        It is strongly suggested that you prevent ApplyInverse() from raising
        any exceptions.  Accidental errors can be prevented by wrapping your
        code in a try block:

            try:
                # Your code goes here...
            except Exception, e:
                print 'A python exception was raised by method ApplyInverse:'
                print e
                return -1

        By returning a -1, you inform the calling routine that ApplyInverse()
        was unsuccessful.

        """
        return _IFPACK.ICT_ApplyInverse(self, *args)

    def Apply(self, *args) -> "int":
        r"""
        Apply(self, MultiVector x, MultiVector y) -> int

        In C++, the Apply() method is pure virtual, thus intended to be
        overridden by derived classes.  In python, cross-language polymorphism
        is supported, and you are expected to derive classes from this base
        class and redefine the Apply() method.  C++ code (e.g., AztecOO
        solvers) can call back to your Apply() method as needed.  You must
        support two arguments, labeled here MultiVector x and MultiVector y.
        These will be converted from Epetra_MultiVector C++ objects to
        numpy-hybrid Epetra.MultiVector objects before they are passed to you.
        Thus, it is legal to use slice indexing and other numpy features to
        compute y from x.

        If application of your operator is successful, return 0; else return
        some non-zero error code.

        It is strongly suggested that you prevent Apply() from raising any
        exceptions.  Accidental errors can be prevented by wrapping your code
        in a try block:

            try:
                # Your code goes here...
            except Exception, e:
                print 'A python exception was raised by method Apply:'
                print e
                return -1

        By returning a -1, you inform the calling routine that Apply() was
        unsuccessful.

        """
        return _IFPACK.ICT_Apply(self, *args)

    def Condest(self, *args) -> "double":
        r"""
        Returns the maximum over all the condition number estimate for each local ILU set of factors. This functions computes a local condition number estimate on each processor and return the
             maximum over all processor of the estimate.
          :param In:
               Trans -If true, solve transpose problem.
           :param Out:
               ConditionNumberEstimate - The maximum across all processors of
               the infinity-norm estimate of the condition number of the inverse of LDU.
        """
        return _IFPACK.ICT_Condest(self, *args)

    def NumGlobalNonzeros(self, *args) -> "int":
        r""" Returns the number of nonzero entries in the global graph."""
        return _IFPACK.ICT_NumGlobalNonzeros(self, *args)

    def NumGlobalNonzeros64(self, *args) -> "long long":
        return _IFPACK.ICT_NumGlobalNonzeros64(self, *args)

    def NumMyNonzeros(self, *args) -> "int":
        r""" Returns the number of nonzero entries in the local graph."""
        return _IFPACK.ICT_NumMyNonzeros(self, *args)

    def H(self, *args) -> "Epetra_CrsMatrix const &":
        r""" Returns the address of the D factor associated with this factored matrix."""
        return _IFPACK.ICT_H(self, *args)

    def SetUseTranspose(self, *args) -> "int":
        r"""
        If set true, transpose of this operator will be applied. This flag allows the transpose of the given operator to be used implicitly.  Setting this flag
               affects only the Apply() and ApplyInverse() methods.  If the implementation of this interface
               does not support transpose use, this method should return a value of -1.

           :param In:
                      UseTranspose_in -If true, multiply by the transpose of operator, otherwise just use operator.

           :rtype: int
           :return: Always returns 0.
        """
        return _IFPACK.ICT_SetUseTranspose(self, *args)

    def NormInf(self, *args) -> "double":
        r""" Returns 0.0 because this class cannot compute Inf-norm."""
        return _IFPACK.ICT_NormInf(self, *args)

    def HasNormInf(self, *args) -> "bool":
        r""" Returns false because this class cannot compute an Inf-norm."""
        return _IFPACK.ICT_HasNormInf(self, *args)

    def UseTranspose(self, *args) -> "bool":
        r""" Returns the current UseTranspose setting."""
        return _IFPACK.ICT_UseTranspose(self, *args)

    def OperatorDomainMap(self, *args) -> "Epetra_Map const &":
        r""" Returns the Epetra_Map object associated with the domain of this operator."""
        return _IFPACK.ICT_OperatorDomainMap(self, *args)

    def OperatorRangeMap(self, *args) -> "Epetra_Map const &":
        r""" Returns the Epetra_Map object associated with the range of this operator."""
        return _IFPACK.ICT_OperatorRangeMap(self, *args)

    def Comm(self, *args) -> "Epetra_Comm const &":
        r""" Returns the Epetra_BlockMap object associated with the range of this matrix operator."""
        return _IFPACK.ICT_Comm(self, *args)

    def Label(self, *args) -> "char const *":
        return _IFPACK.ICT_Label(self, *args)

    def SetLabel(self, *args) -> "int":
        return _IFPACK.ICT_SetLabel(self, *args)

    def NumInitialize(self, *args) -> "int":
        r""" Returns the number of calls to Initialize()."""
        return _IFPACK.ICT_NumInitialize(self, *args)

    def NumCompute(self, *args) -> "int":
        r""" Returns the number of calls to Compute()."""
        return _IFPACK.ICT_NumCompute(self, *args)

    def NumApplyInverse(self, *args) -> "int":
        r""" Returns the number of calls to ApplyInverse()."""
        return _IFPACK.ICT_NumApplyInverse(self, *args)

    def InitializeTime(self, *args) -> "double":
        r""" Returns the time spent in Initialize()."""
        return _IFPACK.ICT_InitializeTime(self, *args)

    def ComputeTime(self, *args) -> "double":
        r""" Returns the time spent in Compute()."""
        return _IFPACK.ICT_ComputeTime(self, *args)

    def ApplyInverseTime(self, *args) -> "double":
        r""" Returns the time spent in ApplyInverse()."""
        return _IFPACK.ICT_ApplyInverseTime(self, *args)

    def InitializeFlops(self, *args) -> "double":
        r""" Returns the number of flops in the initialization phase."""
        return _IFPACK.ICT_InitializeFlops(self, *args)

    def ComputeFlops(self, *args) -> "double":
        r""" Returns the number of flops in all applications of Compute()."""
        return _IFPACK.ICT_ComputeFlops(self, *args)

    def ApplyInverseFlops(self, *args) -> "double":
        r""" Returns the number of flops in all applications of ApplyInverse()."""
        return _IFPACK.ICT_ApplyInverseFlops(self, *args)

    def LevelOfFill(self, *args) -> "double":
        r"""
        Returns the level-of-fill Notes: : if 1.0, then the factored matrix
             contains approximatively the same number of elements of A.
        """
        return _IFPACK.ICT_LevelOfFill(self, *args)

    def AbsoluteThreshold(self, *args) -> "double":
        r""" Returns the absolute threshold."""
        return _IFPACK.ICT_AbsoluteThreshold(self, *args)

    def RelativeThreshold(self, *args) -> "double":
        r""" Returns the relative threshold."""
        return _IFPACK.ICT_RelativeThreshold(self, *args)

    def RelaxValue(self, *args) -> "double":
        r""" Returns the relaxation value."""
        return _IFPACK.ICT_RelaxValue(self, *args)

    def DropTolerance(self, *args) -> "double":
        r""" Returns the drop threshold."""
        return _IFPACK.ICT_DropTolerance(self, *args)

# Register ICT in _IFPACK:
_IFPACK.ICT_swigregister(ICT)

class ILU(Preconditioner):
    r"""
     Ifpack_ILU: A class for constructing and using an incomplete lower/upper (ILU) factorization of a given Epetra_RowMatrix. The Ifpack_ILU class computes a "relaxed" ILU factorization with level k fill
        of a given Epetra_RowMatrix.  The notion of relaxation is the same as described
        in "Experimental study of ILU preconditioners for indefinite matrices" by Chow and Saad.


     Please refer to 'ifp_ilu' for a general description of the ILU algorithm.


    The complete list of supported parameters is reported in page 'ifp_params'.

        Author: Mike Heroux, Marzio Sala, SNL 9214.

        Last modified on 22-Jan-05.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r""" Constructor"""
        _IFPACK.ILU_swiginit(self, _IFPACK.new_ILU(*args))
    __swig_destroy__ = _IFPACK.delete_ILU

    def Initialize(self, *args) -> "int":
        r""" Initialize the preconditioner, does not touch matrix values."""
        return _IFPACK.ILU_Initialize(self, *args)

    def IsInitialized(self, *args) -> "bool":
        r""" Returns ``true`` if the preconditioner has been successfully initialized."""
        return _IFPACK.ILU_IsInitialized(self, *args)

    def Compute(self, *args) -> "int":
        r"""
        Compute ILU factors L and U using the specified graph, diagonal perturbation thresholds and relaxation parameters. This function computes the ILU(k) factors L and U using the current:

           *  Ifpack_IlukGraph specifying the structure of L and U.
           *  Value for the ILU(k) relaxation parameter.
           *  Value for the *a* *priori* diagonal threshold values.

           InitValues() must be called before the factorization can proceed.
        """
        return _IFPACK.ILU_Compute(self, *args)

    def IsComputed(self, *args) -> "bool":
        r""" If factor is completed, this query returns true, otherwise it returns false."""
        return _IFPACK.ILU_IsComputed(self, *args)

    def SetParameters(self, *args) -> "int":
        r""" Set parameters using a Teuchos::ParameterList object."""
        return _IFPACK.ILU_SetParameters(self, *args)

    def SetUseTranspose(self, *args) -> "int":
        r"""
        If set true, transpose of this operator will be applied. This flag allows the transpose of the given operator to be used implicitly.  Setting this flag
             affects only the Apply() and ApplyInverse() methods.  If the implementation of this interface
             does not support transpose use, this method should return a value of -1.

             :type UseTranspose_in: boolean
             :param UseTranspose_in: - (In) If true, multiply by the transpose of operator, otherwise just use operator.

             :rtype: int
             :return: Always returns 0.
        """
        return _IFPACK.ILU_SetUseTranspose(self, *args)

    def Apply(self, *args) -> "int":
        r"""
        Apply(self, MultiVector x, MultiVector y) -> int

        In C++, the Apply() method is pure virtual, thus intended to be
        overridden by derived classes.  In python, cross-language polymorphism
        is supported, and you are expected to derive classes from this base
        class and redefine the Apply() method.  C++ code (e.g., AztecOO
        solvers) can call back to your Apply() method as needed.  You must
        support two arguments, labeled here MultiVector x and MultiVector y.
        These will be converted from Epetra_MultiVector C++ objects to
        numpy-hybrid Epetra.MultiVector objects before they are passed to you.
        Thus, it is legal to use slice indexing and other numpy features to
        compute y from x.

        If application of your operator is successful, return 0; else return
        some non-zero error code.

        It is strongly suggested that you prevent Apply() from raising any
        exceptions.  Accidental errors can be prevented by wrapping your code
        in a try block:

            try:
                # Your code goes here...
            except Exception, e:
                print 'A python exception was raised by method Apply:'
                print e
                return -1

        By returning a -1, you inform the calling routine that Apply() was
        unsuccessful.

        """
        return _IFPACK.ILU_Apply(self, *args)

    def Multiply(self, *args) -> "int":
        return _IFPACK.ILU_Multiply(self, *args)

    def ApplyInverse(self, *args) -> "int":
        r"""
        ApplyInverse(self, MultiVector x, MultiVector y) -> int

        In C++, the ApplyInverse() method is pure virtual, thus intended to be
        overridden by derived classes.  In python, cross-language polymorphism
        is supported, and you are expected to derive classes from this base
        class and redefine the ApplyInverse() method.  C++ code (e.g., AztecOO
        solvers) can call back to your ApplyInverse() method as needed.  You
        must support two arguments, labeled here MultiVector x and MultiVector
        y.  These will be converted from Epetra_MultiVector C++ objects to
        numpy-hybrid Epetra.MultiVector objects before they are passed to you.
        Thus, it is legal to use slice indexing and other numpy features to
        compute y from x.

        If application of your operator is successful, return 0; else return
        some non-zero error code.

        It is strongly suggested that you prevent ApplyInverse() from raising
        any exceptions.  Accidental errors can be prevented by wrapping your
        code in a try block:

            try:
                # Your code goes here...
            except Exception, e:
                print 'A python exception was raised by method ApplyInverse:'
                print e
                return -1

        By returning a -1, you inform the calling routine that ApplyInverse()
        was unsuccessful.

        """
        return _IFPACK.ILU_ApplyInverse(self, *args)

    def Condest(self, *args) -> "double":
        r""" Computes the estimated condition number and returns the value."""
        return _IFPACK.ILU_Condest(self, *args)

    def L(self, *args) -> "Epetra_CrsMatrix const &":
        r""" Returns the address of the L factor associated with this factored matrix."""
        return _IFPACK.ILU_L(self, *args)

    def D(self, *args) -> "Epetra_Vector const &":
        r""" Returns the address of the D factor associated with this factored matrix."""
        return _IFPACK.ILU_D(self, *args)

    def U(self, *args) -> "Epetra_CrsMatrix const &":
        r""" Returns the address of the L factor associated with this factored matrix."""
        return _IFPACK.ILU_U(self, *args)

    def Label(self, *args) -> "char const *":
        r""" Returns a character string describing the operator"""
        return _IFPACK.ILU_Label(self, *args)

    def SetLabel(self, *args) -> "int":
        r""" Sets label for ``this`` object."""
        return _IFPACK.ILU_SetLabel(self, *args)

    def NormInf(self, *args) -> "double":
        r""" Returns 0.0 because this class cannot compute Inf-norm."""
        return _IFPACK.ILU_NormInf(self, *args)

    def HasNormInf(self, *args) -> "bool":
        r""" Returns false because this class cannot compute an Inf-norm."""
        return _IFPACK.ILU_HasNormInf(self, *args)

    def UseTranspose(self, *args) -> "bool":
        r""" Returns the current UseTranspose setting."""
        return _IFPACK.ILU_UseTranspose(self, *args)

    def OperatorDomainMap(self, *args) -> "Epetra_Map const &":
        r""" Returns the Epetra_Map object associated with the domain of this operator."""
        return _IFPACK.ILU_OperatorDomainMap(self, *args)

    def OperatorRangeMap(self, *args) -> "Epetra_Map const &":
        r""" Returns the Epetra_Map object associated with the range of this operator."""
        return _IFPACK.ILU_OperatorRangeMap(self, *args)

    def Comm(self, *args) -> "Epetra_Comm const &":
        r""" Returns the Epetra_BlockMap object associated with the range of this matrix operator."""
        return _IFPACK.ILU_Comm(self, *args)

    def Matrix(self, *args) -> "Epetra_RowMatrix const &":
        r""" Returns a reference to the matrix to be preconditioned."""
        return _IFPACK.ILU_Matrix(self, *args)

    def NumInitialize(self, *args) -> "int":
        r""" Returns the number of calls to Initialize()."""
        return _IFPACK.ILU_NumInitialize(self, *args)

    def NumCompute(self, *args) -> "int":
        r""" Returns the number of calls to Compute()."""
        return _IFPACK.ILU_NumCompute(self, *args)

    def NumApplyInverse(self, *args) -> "int":
        r""" Returns the number of calls to ApplyInverse()."""
        return _IFPACK.ILU_NumApplyInverse(self, *args)

    def InitializeTime(self, *args) -> "double":
        r""" Returns the time spent in Initialize()."""
        return _IFPACK.ILU_InitializeTime(self, *args)

    def ComputeTime(self, *args) -> "double":
        r""" Returns the time spent in Compute()."""
        return _IFPACK.ILU_ComputeTime(self, *args)

    def ApplyInverseTime(self, *args) -> "double":
        r""" Returns the time spent in ApplyInverse()."""
        return _IFPACK.ILU_ApplyInverseTime(self, *args)

    def InitializeFlops(self, *args) -> "double":
        r""" Returns the number of flops in the initialization phase."""
        return _IFPACK.ILU_InitializeFlops(self, *args)

    def ComputeFlops(self, *args) -> "double":
        return _IFPACK.ILU_ComputeFlops(self, *args)

    def ApplyInverseFlops(self, *args) -> "double":
        return _IFPACK.ILU_ApplyInverseFlops(self, *args)

# Register ILU in _IFPACK:
_IFPACK.ILU_swigregister(ILU)

class ILUT(Preconditioner):
    r"""
     Ifpack_ILUT: A class for constructing and using an incomplete LU factorization of a given Epetra_RowMatrix. The Ifpack_ILUT class computes a "Relaxed" ILUT factorization with dual threshold dropping of small elements of a given Epetra_RowMatrix.


     This implementation does not use the algorithm that is described
        in 'ifp_ilu'. The algorithm drops entries in a row (i) of matrix A that
        are smaller than drop_tolerance even before the factorization of row i
        then computes the factorization for that row. This is different than the
        usual algorithm where the drop tolerance is applied to the factored rows.


    The complete list of supported parameters is reported in page 'ifp_params'.

        Author: Marzio Sala, SNL 9214.

        Last modified on 22-Jan-05.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r""" Ifpack_ILUT constuctor with variable number of indices per row."""
        _IFPACK.ILUT_swiginit(self, _IFPACK.new_ILUT(*args))
    __swig_destroy__ = _IFPACK.delete_ILUT

    def SetParameters(self, *args) -> "int":
        r""" Set parameters using a Teuchos::ParameterList object."""
        return _IFPACK.ILUT_SetParameters(self, *args)

    def Initialize(self, *args) -> "int":
        r"""
        Initialize L and U with values from user matrix A. Copies values from the user's matrix into the nonzero pattern of L and U.
           :param In:
                      A - User matrix to be factored.
           Warning: The graph of A must be identical to the graph passed in to Ifpack_IlukGraph constructor.
        """
        return _IFPACK.ILUT_Initialize(self, *args)

    def IsInitialized(self, *args) -> "bool":
        r""" Returns ``true`` if the preconditioner has been successfully initialized."""
        return _IFPACK.ILUT_IsInitialized(self, *args)

    def Compute(self, *args) -> "int":
        r"""
        Compute IC factor U using the specified graph, diagonal perturbation thresholds and relaxation parameters. This function computes the RILU(k) factors L and U using the current:

           *  Ifpack_IlukGraph specifying the structure of L and U.
           *  Value for the RILU(k) relaxation parameter.
           *  Value for the *a* *priori* diagonal threshold values.

           InitValues() must be called before the factorization can proceed.
        """
        return _IFPACK.ILUT_Compute(self, *args)

    def IsComputed(self, *args) -> "bool":
        r""" If factor is completed, this query returns true, otherwise it returns false."""
        return _IFPACK.ILUT_IsComputed(self, *args)

    def ApplyInverse(self, *args) -> "int":
        r"""
        ApplyInverse(self, MultiVector x, MultiVector y) -> int

        In C++, the ApplyInverse() method is pure virtual, thus intended to be
        overridden by derived classes.  In python, cross-language polymorphism
        is supported, and you are expected to derive classes from this base
        class and redefine the ApplyInverse() method.  C++ code (e.g., AztecOO
        solvers) can call back to your ApplyInverse() method as needed.  You
        must support two arguments, labeled here MultiVector x and MultiVector
        y.  These will be converted from Epetra_MultiVector C++ objects to
        numpy-hybrid Epetra.MultiVector objects before they are passed to you.
        Thus, it is legal to use slice indexing and other numpy features to
        compute y from x.

        If application of your operator is successful, return 0; else return
        some non-zero error code.

        It is strongly suggested that you prevent ApplyInverse() from raising
        any exceptions.  Accidental errors can be prevented by wrapping your
        code in a try block:

            try:
                # Your code goes here...
            except Exception, e:
                print 'A python exception was raised by method ApplyInverse:'
                print e
                return -1

        By returning a -1, you inform the calling routine that ApplyInverse()
        was unsuccessful.

        """
        return _IFPACK.ILUT_ApplyInverse(self, *args)

    def Apply(self, *args) -> "int":
        r"""
        Apply(self, MultiVector x, MultiVector y) -> int

        In C++, the Apply() method is pure virtual, thus intended to be
        overridden by derived classes.  In python, cross-language polymorphism
        is supported, and you are expected to derive classes from this base
        class and redefine the Apply() method.  C++ code (e.g., AztecOO
        solvers) can call back to your Apply() method as needed.  You must
        support two arguments, labeled here MultiVector x and MultiVector y.
        These will be converted from Epetra_MultiVector C++ objects to
        numpy-hybrid Epetra.MultiVector objects before they are passed to you.
        Thus, it is legal to use slice indexing and other numpy features to
        compute y from x.

        If application of your operator is successful, return 0; else return
        some non-zero error code.

        It is strongly suggested that you prevent Apply() from raising any
        exceptions.  Accidental errors can be prevented by wrapping your code
        in a try block:

            try:
                # Your code goes here...
            except Exception, e:
                print 'A python exception was raised by method Apply:'
                print e
                return -1

        By returning a -1, you inform the calling routine that Apply() was
        unsuccessful.

        """
        return _IFPACK.ILUT_Apply(self, *args)

    def Condest(self, *args) -> "double":
        r""" Computed the estimated condition number and returns the value."""
        return _IFPACK.ILUT_Condest(self, *args)

    def SetUseTranspose(self, *args) -> "int":
        r"""
        If set true, transpose of this operator will be applied. This flag allows the transpose of the given operator to be used implicitly.  Setting this flag
             affects only the Apply() and ApplyInverse() methods.  If the implementation of this interface
             does not support transpose use, this method should return a value of -1.

            :type UseTranspose_in: boolean
            :param UseTranspose_in: - (In) If true, multiply by the transpose of operator, otherwise just use operator.

            :rtype: int
            :return: Always returns 0.
        """
        return _IFPACK.ILUT_SetUseTranspose(self, *args)

    def NormInf(self, *args) -> "double":
        r""" Returns 0.0 because this class cannot compute Inf-norm."""
        return _IFPACK.ILUT_NormInf(self, *args)

    def HasNormInf(self, *args) -> "bool":
        r""" Returns false because this class cannot compute an Inf-norm."""
        return _IFPACK.ILUT_HasNormInf(self, *args)

    def UseTranspose(self, *args) -> "bool":
        r""" Returns the current UseTranspose setting."""
        return _IFPACK.ILUT_UseTranspose(self, *args)

    def OperatorDomainMap(self, *args) -> "Epetra_Map const &":
        r""" Returns the Epetra_Map object associated with the domain of this operator."""
        return _IFPACK.ILUT_OperatorDomainMap(self, *args)

    def OperatorRangeMap(self, *args) -> "Epetra_Map const &":
        r""" Returns the Epetra_Map object associated with the range of this operator."""
        return _IFPACK.ILUT_OperatorRangeMap(self, *args)

    def Comm(self, *args) -> "Epetra_Comm const &":
        r""" Returns the Epetra_BlockMap object associated with the range of this matrix operator."""
        return _IFPACK.ILUT_Comm(self, *args)

    def Matrix(self, *args) -> "Epetra_RowMatrix const &":
        r""" Returns a reference to the matrix to be preconditioned."""
        return _IFPACK.ILUT_Matrix(self, *args)

    def L(self, *args) -> "Epetra_CrsMatrix const &":
        r""" Returns a reference to the L factor."""
        return _IFPACK.ILUT_L(self, *args)

    def U(self, *args) -> "Epetra_CrsMatrix const &":
        r""" Returns a reference to the U factor."""
        return _IFPACK.ILUT_U(self, *args)

    def Label(self, *args) -> "char const *":
        r""" Returns the label of ``this`` object."""
        return _IFPACK.ILUT_Label(self, *args)

    def SetLabel(self, *args) -> "int":
        r""" Sets the label for ``this`` object"""
        return _IFPACK.ILUT_SetLabel(self, *args)

    def NumInitialize(self, *args) -> "int":
        r""" Returns the number of calls to Initialize()."""
        return _IFPACK.ILUT_NumInitialize(self, *args)

    def NumCompute(self, *args) -> "int":
        r""" Returns the number of calls to Compute()."""
        return _IFPACK.ILUT_NumCompute(self, *args)

    def NumApplyInverse(self, *args) -> "int":
        r""" Returns the number of calls to ApplyInverse()."""
        return _IFPACK.ILUT_NumApplyInverse(self, *args)

    def InitializeTime(self, *args) -> "double":
        r""" Returns the time spent in Initialize()."""
        return _IFPACK.ILUT_InitializeTime(self, *args)

    def ComputeTime(self, *args) -> "double":
        r""" Returns the time spent in Compute()."""
        return _IFPACK.ILUT_ComputeTime(self, *args)

    def ApplyInverseTime(self, *args) -> "double":
        r""" Returns the time spent in ApplyInverse()."""
        return _IFPACK.ILUT_ApplyInverseTime(self, *args)

    def InitializeFlops(self, *args) -> "double":
        r""" Returns the number of flops in the initialization phase."""
        return _IFPACK.ILUT_InitializeFlops(self, *args)

    def ComputeFlops(self, *args) -> "double":
        return _IFPACK.ILUT_ComputeFlops(self, *args)

    def ApplyInverseFlops(self, *args) -> "double":
        return _IFPACK.ILUT_ApplyInverseFlops(self, *args)

    def LevelOfFill(self, *args) -> "double":
        return _IFPACK.ILUT_LevelOfFill(self, *args)

    def RelaxValue(self, *args) -> "double":
        r""" Set relative threshold value"""
        return _IFPACK.ILUT_RelaxValue(self, *args)

    def AbsoluteThreshold(self, *args) -> "double":
        r""" Get absolute threshold value"""
        return _IFPACK.ILUT_AbsoluteThreshold(self, *args)

    def RelativeThreshold(self, *args) -> "double":
        r""" Get relative threshold value"""
        return _IFPACK.ILUT_RelativeThreshold(self, *args)

    def DropTolerance(self, *args) -> "double":
        r""" Gets the dropping tolerance"""
        return _IFPACK.ILUT_DropTolerance(self, *args)

    def NumGlobalNonzeros(self, *args) -> "int":
        r""" Returns the number of nonzero entries in the global graph."""
        return _IFPACK.ILUT_NumGlobalNonzeros(self, *args)

    def NumGlobalNonzeros64(self, *args) -> "long long":
        return _IFPACK.ILUT_NumGlobalNonzeros64(self, *args)

    def NumMyNonzeros(self, *args) -> "int":
        r""" Returns the number of nonzero entries in the local graph."""
        return _IFPACK.ILUT_NumMyNonzeros(self, *args)

# Register ILUT in _IFPACK:
_IFPACK.ILUT_swigregister(ILUT)

class PointRelaxation(Preconditioner):
    r"""
     Ifpack_PointRelaxation: a class to define point relaxation preconditioners of for Epetra_RowMatrix's.
      The Ifpack_PointRelaxation class enables the construction of point
      relaxation
      preconditioners of an Epetra_RowMatrix. Ifpack_PointRelaxation
      is derived from
      the Ifpack_Preconditioner class, which is itself derived from Epetra_Operator.
      Therefore this object can be used as preconditioner everywhere an
      ApplyInverse() method is required in the preconditioning step.

    This class enables the construction of the following simple preconditioners:
    - Jacobi;
    - Gauss-Seidel;
    - symmetric Gauss-Seidel.


    We now briefly describe the main features of the above preconditioners.
    Consider a linear system of type

    .. math::

        A x = b,
    where :math:`A` is a square, real matrix, and :math:`x, b` are two real
    vectors. We begin with the decomposition

    .. math::

        A = D - E - F
    where :math:`D` is the diagonal of A, :math:`-E` is the strict lower part, and
    :math:`-F` is the strict upper part. It is assumed that the diagonal entries
    of :math:`A` are different from zero.


    Given an starting solution :math:`x_0`, an iteration of the (damped) Jacobi
    method can be written in matrix form as follows:

    .. math::

        x_{k+1} = \omega D^{-1}(E + F) x_k + D_{-1}b,
    for :math:`k < k_{max}`, and :math:`\omega` a damping parameter.

    Using Ifpack_Jacobi, the user can apply the specified number of sweeps
    (:math:`k_{max}`), and the damping parameter. If only one sweep is used, then
    the class simply applies the inverse of the diagonal of A to the input
    vector.


    Given an starting solution :math:`x_0`, an iteration of the (damped) GaussSeidel
    method can be written in matrix form as follows:

    .. math::

        (D - E) x_{k+1} = \omega F x_k + b,
    for :math:`k < k_{max}`, and :math:`\omega` a damping parameter. Equivalently,
    the Gauss-Seidel preconditioner can be defined as

    .. math::

        P_{GS}^{-1} = (D - E)^{-1}.
    Clearly, the role of E and F can be interchanged. However,
    Ifpack_GaussSeidel does not consider backward Gauss-Seidel methods.


    For a list of supported parameters, please refer to page 'ifp_params'.


    The complete list of supported parameters is reported in page 'ifp_params'. For a presentation of basic relaxation schemes, please refer to page
    'Ifpack_PointRelaxation'.

    Author: Marzio Sala, SNL 9214.

    Last modified on 22-Jan-05.

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
         Ifpack_PointRelaxation constructor with given Epetra_RowMatrix. Creates an instance of Ifpack_PointRelaxation class.

        :type Matrix: :py:class:`Epetra_RowMatrix`
        :param Matrix: - (In) Pointer to matrix to precondition.
        """
        _IFPACK.PointRelaxation_swiginit(self, _IFPACK.new_PointRelaxation(*args))
    __swig_destroy__ = _IFPACK.delete_PointRelaxation

    def SetUseTranspose(self, *args) -> "int":
        r"""
         This flag can be used to apply the preconditioner to the transpose of
        the input operator.

        :rtype: int
        :return: Integer error code, set to 0 if successful.
            Set to -1 if this implementation does not support transpose.
        """
        return _IFPACK.PointRelaxation_SetUseTranspose(self, *args)

    def Apply(self, *args) -> "int":
        r"""
        Apply(self, MultiVector x, MultiVector y) -> int

        In C++, the Apply() method is pure virtual, thus intended to be
        overridden by derived classes.  In python, cross-language polymorphism
        is supported, and you are expected to derive classes from this base
        class and redefine the Apply() method.  C++ code (e.g., AztecOO
        solvers) can call back to your Apply() method as needed.  You must
        support two arguments, labeled here MultiVector x and MultiVector y.
        These will be converted from Epetra_MultiVector C++ objects to
        numpy-hybrid Epetra.MultiVector objects before they are passed to you.
        Thus, it is legal to use slice indexing and other numpy features to
        compute y from x.

        If application of your operator is successful, return 0; else return
        some non-zero error code.

        It is strongly suggested that you prevent Apply() from raising any
        exceptions.  Accidental errors can be prevented by wrapping your code
        in a try block:

            try:
                # Your code goes here...
            except Exception, e:
                print 'A python exception was raised by method Apply:'
                print e
                return -1

        By returning a -1, you inform the calling routine that Apply() was
        unsuccessful.

        """
        return _IFPACK.PointRelaxation_Apply(self, *args)

    def ApplyInverse(self, *args) -> "int":
        r"""
        ApplyInverse(self, MultiVector x, MultiVector y) -> int

        In C++, the ApplyInverse() method is pure virtual, thus intended to be
        overridden by derived classes.  In python, cross-language polymorphism
        is supported, and you are expected to derive classes from this base
        class and redefine the ApplyInverse() method.  C++ code (e.g., AztecOO
        solvers) can call back to your ApplyInverse() method as needed.  You
        must support two arguments, labeled here MultiVector x and MultiVector
        y.  These will be converted from Epetra_MultiVector C++ objects to
        numpy-hybrid Epetra.MultiVector objects before they are passed to you.
        Thus, it is legal to use slice indexing and other numpy features to
        compute y from x.

        If application of your operator is successful, return 0; else return
        some non-zero error code.

        It is strongly suggested that you prevent ApplyInverse() from raising
        any exceptions.  Accidental errors can be prevented by wrapping your
        code in a try block:

            try:
                # Your code goes here...
            except Exception, e:
                print 'A python exception was raised by method ApplyInverse:'
                print e
                return -1

        By returning a -1, you inform the calling routine that ApplyInverse()
        was unsuccessful.

        """
        return _IFPACK.PointRelaxation_ApplyInverse(self, *args)

    def NormInf(self, *args) -> "double":
        r""" Returns the infinity norm of the global matrix (not implemented)"""
        return _IFPACK.PointRelaxation_NormInf(self, *args)

    def Label(self, *args) -> "char const *":
        return _IFPACK.PointRelaxation_Label(self, *args)

    def UseTranspose(self, *args) -> "bool":
        r""" Returns the current UseTranspose setting."""
        return _IFPACK.PointRelaxation_UseTranspose(self, *args)

    def HasNormInf(self, *args) -> "bool":
        r""" Returns true if the *this* object can provide an approximate Inf-norm, false otherwise."""
        return _IFPACK.PointRelaxation_HasNormInf(self, *args)

    def Comm(self, *args) -> "Epetra_Comm const &":
        r""" Returns a pointer to the Epetra_Comm communicator associated with this operator."""
        return _IFPACK.PointRelaxation_Comm(self, *args)

    def OperatorDomainMap(self, *args) -> "Epetra_Map const &":
        r""" Returns the Epetra_Map object associated with the domain of this operator."""
        return _IFPACK.PointRelaxation_OperatorDomainMap(self, *args)

    def OperatorRangeMap(self, *args) -> "Epetra_Map const &":
        r""" Returns the Epetra_Map object associated with the range of this operator."""
        return _IFPACK.PointRelaxation_OperatorRangeMap(self, *args)

    def Initialize(self, *args) -> "int":
        return _IFPACK.PointRelaxation_Initialize(self, *args)

    def IsInitialized(self, *args) -> "bool":
        return _IFPACK.PointRelaxation_IsInitialized(self, *args)

    def IsComputed(self, *args) -> "bool":
        r""" Returns ``true`` if the preconditioner has been successfully computed."""
        return _IFPACK.PointRelaxation_IsComputed(self, *args)

    def Compute(self, *args) -> "int":
        r""" Computes the preconditioners."""
        return _IFPACK.PointRelaxation_Compute(self, *args)

    def Matrix(self, *args) -> "Epetra_RowMatrix const &":
        return _IFPACK.PointRelaxation_Matrix(self, *args)

    def Condest(self, *args) -> "double":
        r""" Computes the condition number estimates and returns the value."""
        return _IFPACK.PointRelaxation_Condest(self, *args)

    def SetParameters(self, *args) -> "int":
        r""" Sets all the parameters for the preconditioner"""
        return _IFPACK.PointRelaxation_SetParameters(self, *args)

    def NumInitialize(self, *args) -> "int":
        r""" Returns the number of calls to Initialize()."""
        return _IFPACK.PointRelaxation_NumInitialize(self, *args)

    def NumCompute(self, *args) -> "int":
        r""" Returns the number of calls to Compute()."""
        return _IFPACK.PointRelaxation_NumCompute(self, *args)

    def NumApplyInverse(self, *args) -> "int":
        r""" Returns the number of calls to ApplyInverse()."""
        return _IFPACK.PointRelaxation_NumApplyInverse(self, *args)

    def InitializeTime(self, *args) -> "double":
        r""" Returns the time spent in Initialize()."""
        return _IFPACK.PointRelaxation_InitializeTime(self, *args)

    def ComputeTime(self, *args) -> "double":
        r""" Returns the time spent in Compute()."""
        return _IFPACK.PointRelaxation_ComputeTime(self, *args)

    def ApplyInverseTime(self, *args) -> "double":
        r""" Returns the time spent in ApplyInverse()."""
        return _IFPACK.PointRelaxation_ApplyInverseTime(self, *args)

    def InitializeFlops(self, *args) -> "double":
        r""" Returns the number of flops in the initialization phase."""
        return _IFPACK.PointRelaxation_InitializeFlops(self, *args)

    def ComputeFlops(self, *args) -> "double":
        r""" Returns the number of flops in the computation phase."""
        return _IFPACK.PointRelaxation_ComputeFlops(self, *args)

    def ApplyInverseFlops(self, *args) -> "double":
        r""" Returns the number of flops for the application of the preconditioner."""
        return _IFPACK.PointRelaxation_ApplyInverseFlops(self, *args)

# Register PointRelaxation in _IFPACK:
_IFPACK.PointRelaxation_swigregister(PointRelaxation)

class Amesos(Preconditioner):
    r"""
     Ifpack_Amesos: a class to use Amesos' factorizations as preconditioners.
    Class Ifpack_Amesos enables the use of Amesos' factorizations as
    Ifpack_Preconditioners.

    Ifpack_Amesos is just a bare-bone wrap to Amesos. Currently, the
    only parameter required recognized by SetParameters() is
    ``"amesos: solver type"`` (defaulted to
    ``"Amesos_Klu"``), which defined the Amesos solver. The Teuchos list
    in input to SetParameters() is copied, then the copied list is
    used to set the parameters of the Amesos object.

    This class works with matrices whose communicator contains only one
    process, that is, either serial matrices, or Ifpack_LocalFilter'd matrices.

    Warning: The number of flops is NOT updated.

    Author: Marzio Sala, SNL 9214.

    Last update Oct-04.

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        *Overload 1:*
        Constructor.

        |

        *Overload 2:*
        Copy constructor.
        """
        _IFPACK.Amesos_swiginit(self, _IFPACK.new_Amesos(*args))
    __swig_destroy__ = _IFPACK.delete_Amesos

    def SetUseTranspose(self, *args) -> "int":
        r"""
         If set true, transpose of this operator will be applied (not implemented). This flag allows the transpose of the given operator to be used
        implicitly.

            :type UseTranspose_in: boolean
            :param UseTranspose_in: - (In) If true, multiply by the transpose of operator,
                       otherwise just use operator.

            :rtype: int
            :return: Integer error code, set to 0 if successful.  Set to -1 if this implementation does not support transpose.
        """
        return _IFPACK.Amesos_SetUseTranspose(self, *args)

    def Apply(self, *args) -> "int":
        r"""
        Apply(self, MultiVector x, MultiVector y) -> int

        In C++, the Apply() method is pure virtual, thus intended to be
        overridden by derived classes.  In python, cross-language polymorphism
        is supported, and you are expected to derive classes from this base
        class and redefine the Apply() method.  C++ code (e.g., AztecOO
        solvers) can call back to your Apply() method as needed.  You must
        support two arguments, labeled here MultiVector x and MultiVector y.
        These will be converted from Epetra_MultiVector C++ objects to
        numpy-hybrid Epetra.MultiVector objects before they are passed to you.
        Thus, it is legal to use slice indexing and other numpy features to
        compute y from x.

        If application of your operator is successful, return 0; else return
        some non-zero error code.

        It is strongly suggested that you prevent Apply() from raising any
        exceptions.  Accidental errors can be prevented by wrapping your code
        in a try block:

            try:
                # Your code goes here...
            except Exception, e:
                print 'A python exception was raised by method Apply:'
                print e
                return -1

        By returning a -1, you inform the calling routine that Apply() was
        unsuccessful.

        """
        return _IFPACK.Amesos_Apply(self, *args)

    def ApplyInverse(self, *args) -> "int":
        r"""
        ApplyInverse(self, MultiVector x, MultiVector y) -> int

        In C++, the ApplyInverse() method is pure virtual, thus intended to be
        overridden by derived classes.  In python, cross-language polymorphism
        is supported, and you are expected to derive classes from this base
        class and redefine the ApplyInverse() method.  C++ code (e.g., AztecOO
        solvers) can call back to your ApplyInverse() method as needed.  You
        must support two arguments, labeled here MultiVector x and MultiVector
        y.  These will be converted from Epetra_MultiVector C++ objects to
        numpy-hybrid Epetra.MultiVector objects before they are passed to you.
        Thus, it is legal to use slice indexing and other numpy features to
        compute y from x.

        If application of your operator is successful, return 0; else return
        some non-zero error code.

        It is strongly suggested that you prevent ApplyInverse() from raising
        any exceptions.  Accidental errors can be prevented by wrapping your
        code in a try block:

            try:
                # Your code goes here...
            except Exception, e:
                print 'A python exception was raised by method ApplyInverse:'
                print e
                return -1

        By returning a -1, you inform the calling routine that ApplyInverse()
        was unsuccessful.

        """
        return _IFPACK.Amesos_ApplyInverse(self, *args)

    def NormInf(self, *args) -> "double":
        r""" Returns the infinity norm of the global matrix (not implemented)"""
        return _IFPACK.Amesos_NormInf(self, *args)

    def Label(self, *args) -> "char const *":
        r""" Returns a character string describing the operator"""
        return _IFPACK.Amesos_Label(self, *args)

    def UseTranspose(self, *args) -> "bool":
        r""" Returns the current UseTranspose setting."""
        return _IFPACK.Amesos_UseTranspose(self, *args)

    def HasNormInf(self, *args) -> "bool":
        r""" Returns true if the *this* object can provide an approximate Inf-norm, false otherwise."""
        return _IFPACK.Amesos_HasNormInf(self, *args)

    def Comm(self, *args) -> "Epetra_Comm const &":
        r""" Returns a pointer to the Epetra_Comm communicator associated with this operator."""
        return _IFPACK.Amesos_Comm(self, *args)

    def OperatorDomainMap(self, *args) -> "Epetra_Map const &":
        r""" Returns the Epetra_Map object associated with the domain of this operator."""
        return _IFPACK.Amesos_OperatorDomainMap(self, *args)

    def OperatorRangeMap(self, *args) -> "Epetra_Map const &":
        r""" Returns the Epetra_Map object associated with the range of this operator."""
        return _IFPACK.Amesos_OperatorRangeMap(self, *args)

    def IsInitialized(self, *args) -> "bool":
        r""" Returns ``true`` is the preconditioner has been successfully initialized."""
        return _IFPACK.Amesos_IsInitialized(self, *args)

    def Initialize(self, *args) -> "int":
        r"""
         Initializes the preconditioners. :rtype: int
        :return: 
            0 if successful, 1 if problems occurred.
        """
        return _IFPACK.Amesos_Initialize(self, *args)

    def IsComputed(self, *args) -> "bool":
        r""" Returns ``true`` if the preconditioner has been successfully computed."""
        return _IFPACK.Amesos_IsComputed(self, *args)

    def Compute(self, *args) -> "int":
        r"""
         Computes the preconditioners. :rtype: int
        :return: 
            0 if successful, 1 if problems occurred.
        """
        return _IFPACK.Amesos_Compute(self, *args)

    def SetParameters(self, *args) -> "int":
        r"""
         Sets all the parameters for the preconditioner. Parameters currently supported:
        - ``"amesos: solver type"`` : Specifies the solver type
          for Amesos. Default: ``Amesos_Klu``.

        The input list will be copied, then passed to the Amesos
        object through Amesos::SetParameters().
        """
        return _IFPACK.Amesos_SetParameters(self, *args)

    def Matrix(self, *args) -> "Epetra_RowMatrix const &":
        r""" Returns a const reference to the internally stored matrix."""
        return _IFPACK.Amesos_Matrix(self, *args)

    def Condest(self, *args) -> "double":
        r""" Returns the estimated condition number, computes it if necessary."""
        return _IFPACK.Amesos_Condest(self, *args)

    def NumInitialize(self, *args) -> "int":
        r""" Returns the number of calls to Initialize()."""
        return _IFPACK.Amesos_NumInitialize(self, *args)

    def NumCompute(self, *args) -> "int":
        r""" Returns the number of calls to Compute()."""
        return _IFPACK.Amesos_NumCompute(self, *args)

    def NumApplyInverse(self, *args) -> "int":
        r""" Returns the number of calls to ApplyInverse()."""
        return _IFPACK.Amesos_NumApplyInverse(self, *args)

    def InitializeTime(self, *args) -> "double":
        r""" Returns the total time spent in Initialize()."""
        return _IFPACK.Amesos_InitializeTime(self, *args)

    def ComputeTime(self, *args) -> "double":
        r""" Returns the total time spent in Compute()."""
        return _IFPACK.Amesos_ComputeTime(self, *args)

    def ApplyInverseTime(self, *args) -> "double":
        r""" Returns the total time spent in ApplyInverse()."""
        return _IFPACK.Amesos_ApplyInverseTime(self, *args)

    def InitializeFlops(self, *args) -> "double":
        r""" Returns the number of flops in the initialization phase."""
        return _IFPACK.Amesos_InitializeFlops(self, *args)

    def ComputeFlops(self, *args) -> "double":
        r""" Returns the total number of flops to computate the preconditioner."""
        return _IFPACK.Amesos_ComputeFlops(self, *args)

    def ApplyInverseFlops(self, *args) -> "double":
        r""" Returns the total number of flops to apply the preconditioner."""
        return _IFPACK.Amesos_ApplyInverseFlops(self, *args)

    def List(self, *args) -> "Teuchos::ParameterList const &":
        return _IFPACK.Amesos_List(self, *args)

# Register Amesos in _IFPACK:
_IFPACK.Amesos_swigregister(Amesos)

class Factory(object):
    r"""
     Ifpack: a function class to define Ifpack preconditioners.
    Class Ifpack is a function class, that contains just one method:
    Create(). Using Create(), users can easily define a variety of
    IFPACK preconditioners.

    Create requires 3 arguments:
    - a std::string, indicating the preconditioner to be built;
    - a pointer to an Epetra_RowMatrix, representing the matrix
      to be used to define the preconditioner;
    - an interger (defaulted to 0), that specifies the amount of
      overlap among the processes.

    The first argument can assume the following values:
    - ``"point relaxation"`` : returns an instance of Ifpack_AdditiveSchwarz<Ifpack_PointRelaxation> (no Additive Schwarz in serial)
    - ``"point relaxation stand-alone"`` : returns an instance of Ifpack_PointRelaxation (value of overlap is ignored).
    - ``"block relaxation"`` : returns an instance of Ifpack_AdditiveSchwarz<Ifpack_BlockRelaxation> (no Additive Schwarz in serial)
    - ``"block relaxation stand-alone)"`` : returns an instance of Ifpack_BlockRelaxation.
    - ``"Amesos"`` : returns an instance of Ifpack_AdditiveSchwarz<Ifpack_Amesos> (no Additive Schwarz in serial)
    - ``"Amesos stand-alone"`` : returns an instance of Ifpack_Amesos.
    - ``"IC"`` : returns an instance of Ifpack_AdditiveSchwarz<Ifpack_IC> (no Additive Schwarz in serial)
    - ``"IC stand-alone"`` : returns an instance of Ifpack_IC.
    - ``"ICT"`` : returns an instance of Ifpack_AdditiveSchwarz<Ifpack_ICT> (no Additive Schwarz in serial)
    - ``"ICT stand-alone"`` : returns an instance of Ifpack_ICT.
    - ``"ILU"`` : returns an instance of Ifpack_AdditiveSchwarz<Ifpack_ILU> (no Additive Schwarz in serial)
    - ``"ILU stand-alone"`` : returns an instance of Ifpack_ILU.
    - ``"ILUT"`` : returns an instance of Ifpack_AdditiveSchwarz<Ifpack_ILUT> (no Additive Schwarz in serial)
    - ``"ILUT stand-alone"`` : returns an instance of Ifpack_ILUT.
    - otherwise, Create() returns 0.

    Notes: Objects in stand-alone mode cannot use reordering, variable overlap, and singleton filters.
    However, their construction can be slightly faster than the non stand-alone counterpart.


     The following fragment of code shows the
    basic usage of this class.

    .. code-block:: c++

        #include "Ifpack.h"

        ...

        Ifpack Factory;

        Epetra_RowMatrix* A; // A is FillComplete()'d.
        std::string PrecType = "ILU"; // use incomplete LU on each process
        int OverlapLevel = 1; // one row of overlap among the processes
        Ifpack_Preconditioner* Prec = Factory.Create(PrecType, A, OverlapLevel);
        assert (Prec != 0);

        Teuchos::ParameterList List;
        List.set("fact: level-of-fill", 5); // use ILU(5)

        IFPACK_CHK_ERR(Prec->SetParameters(List));
        IFPACK_CHK_ERR(Prec->Initialize());
        IFPACK_CHK_ERR(Prec->Compute());

        now Prec can be used as AztecOO preconditioner
        like for instance
        AztecOO AztecOOSolver(*Problem);

        specify solver
        AztecOOSolver.SetAztecOption(AZ_solver,AZ_gmres);
        AztecOOSolver.SetAztecOption(AZ_output,32);

        Set Prec as preconditioning operator
        AztecOOSolver.SetPrecOperator(Prec);

        Call the solver
        AztecOOSolver.Iterate(1550,1e-8);

        print information on stdout
        cout << *Prec;

        delete the preconditioner
        delete Prec;

    Author: Marzio Sala, (formally) SNL org. 1414

    Last updated on 25-Jan-05.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    POINT_RELAXATION = _IFPACK.Factory_POINT_RELAXATION
    POINT_RELAXATION_STAND_ALONE = _IFPACK.Factory_POINT_RELAXATION_STAND_ALONE
    BLOCK_RELAXATION = _IFPACK.Factory_BLOCK_RELAXATION
    BLOCK_RELAXATION_STAND_ALONE = _IFPACK.Factory_BLOCK_RELAXATION_STAND_ALONE
    BLOCK_RELAXATION_STAND_ALONE_ILU = _IFPACK.Factory_BLOCK_RELAXATION_STAND_ALONE_ILU
    BLOCK_RELAXATION_STAND_ALONE_ILUT = _IFPACK.Factory_BLOCK_RELAXATION_STAND_ALONE_ILUT
    BLOCK_RELAXATION_STAND_ALONE_IC = _IFPACK.Factory_BLOCK_RELAXATION_STAND_ALONE_IC
    BLOCK_RELAXATION_STAND_ALONE_SILU = _IFPACK.Factory_BLOCK_RELAXATION_STAND_ALONE_SILU
    BLOCK_RELAXATION_STAND_ALONE_AMESOS = _IFPACK.Factory_BLOCK_RELAXATION_STAND_ALONE_AMESOS
    BLOCK_RELAXATION_AMESOS = _IFPACK.Factory_BLOCK_RELAXATION_AMESOS
    AMESOS = _IFPACK.Factory_AMESOS
    AMESOS_STAND_ALONE = _IFPACK.Factory_AMESOS_STAND_ALONE
    IC = _IFPACK.Factory_IC
    IC_STAND_ALONE = _IFPACK.Factory_IC_STAND_ALONE
    ICT = _IFPACK.Factory_ICT
    ICT_STAND_ALONE = _IFPACK.Factory_ICT_STAND_ALONE
    ILU = _IFPACK.Factory_ILU
    ILU_STAND_ALONE = _IFPACK.Factory_ILU_STAND_ALONE
    ILUT = _IFPACK.Factory_ILUT
    ILUT_STAND_ALONE = _IFPACK.Factory_ILUT_STAND_ALONE
    SILU = _IFPACK.Factory_SILU
    CHEBYSHEV = _IFPACK.Factory_CHEBYSHEV
    POLYNOMIAL = _IFPACK.Factory_POLYNOMIAL
    KRYLOV = _IFPACK.Factory_KRYLOV
    IHSS = _IFPACK.Factory_IHSS
    SORA = _IFPACK.Factory_SORA
    TRIDI_RELAXATION = _IFPACK.Factory_TRIDI_RELAXATION
    TRIDI_RELAXATION_STAND_ALONE = _IFPACK.Factory_TRIDI_RELAXATION_STAND_ALONE
    numPrecTypes = _IFPACK.Factory_numPrecTypes
    r""" ."""
    precTypeNames = property(_IFPACK.Factory_precTypeNames_get, _IFPACK.Factory_precTypeNames_set, doc=r""" List of preconditioner types as std::string values.""")

    @staticmethod
    def toString(*args) -> "char const *":
        r"""
         Function that gives the std::string name for preconditioner given its
        enumerication value.
        """
        return _IFPACK.Factory_toString(*args)

    def Create(self, *args) -> "Ifpack_Preconditioner *":
        r"""
        *Overload 1:*
         Creates an instance of Ifpack_Preconditioner given the enum value
        of the preconditioner type (can not fail, no bad input possible).

        :type PrecType: int
        :param PrecType: (In) - Enum value of preconditioner type to be created.

        :type Matrix: :py:class:`Epetra_RowMatrix`
        :param Matrix: (In) - Matrix used to define the preconditioner

        :type overlap: int, optional
        :param overlap: (In) - specified overlap, defaulted to 0.

        |

        *Overload 2:*
         Creates an instance of Ifpack_Preconditioner given the std::string
        name of the preconditioner type (can fail with bad input).

        :type PrecType: string
        :param PrecType: (In) - String name of preconditioner type to be created.

        :type Matrix: :py:class:`Epetra_RowMatrix`
        :param Matrix: (In) - Matrix used to define the preconditioner

        :type overlap: int, optional
        :param overlap: (In) - specified overlap, defaulted to 0.

        Returns 0 if the preconditioner with that input name does not
        exist.  Otherwise, return a newly created preconditioner object.  Note
        that the client is responsible for calling delete on the
        returned object once it is finished using it!
        """
        return _IFPACK.Factory_Create(self, *args)

    def SetParameters(self, *args) -> "int":
        r"""
         Sets the options in List from the command line.

        Note: If you want full support for all parameters, consider reading in a
        parameter list from an XML file as supported by the Teuchos helper
        function Teuchos::updateParametersFromXmlFile() or
        Teuchos::updateParametersFromXmlStream().
        """
        return _IFPACK.Factory_SetParameters(self, *args)

    def __init__(self, *args):
        _IFPACK.Factory_swiginit(self, _IFPACK.new_Factory(*args))
    __swig_destroy__ = _IFPACK.delete_Factory

# Register Factory in _IFPACK:
_IFPACK.Factory_swigregister(Factory)
cvar = _IFPACK.cvar
Factory.precTypeValues = _IFPACK.cvar.Factory_precTypeValues
Factory.supportsUnsymmetric = _IFPACK.cvar.Factory_supportsUnsymmetric

def Factory_toString(*args) -> "char const *":
    r"""
     Function that gives the std::string name for preconditioner given its
    enumerication value.
    """
    return _IFPACK.Factory_toString(*args)



