# This file was automatically generated by SWIG (http://www.swig.org).
# Version 4.0.2
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.

"""

PyTrilinos.Isorropia.Epetra is the python interface to namespace Epetra for
the Trilinos package Isorropia:

    https://trilinos.org/docs/dev/packages/isorropia/doc/html/index.html

The purpose of Isorropia.Epetra is to ....

"""

from sys import version_info as _swig_python_version_info
if _swig_python_version_info < (2, 7, 0):
    raise RuntimeError("Python 2.7 or later required")


from . import _Epetra


try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)


def _swig_setattr_nondynamic_instance_variable(set):
    def set_instance_attr(self, name, value):
        if name == "thisown":
            self.this.own(value)
        elif name == "this":
            set(self, name, value)
        elif hasattr(self, name) and isinstance(getattr(type(self), name), property):
            set(self, name, value)
        else:
            raise AttributeError("You cannot add instance attributes to %s" % self)
    return set_instance_attr


def _swig_setattr_nondynamic_class_variable(set):
    def set_class_attr(cls, name, value):
        if hasattr(cls, name) and not isinstance(getattr(cls, name), property):
            set(cls, name, value)
        else:
            raise AttributeError("You cannot add class attributes to %s" % cls)
    return set_class_attr


def _swig_add_metaclass(metaclass):
    """Class decorator for adding a metaclass to a SWIG wrapped class - a slimmed down version of six.add_metaclass"""
    def wrapper(cls):
        return metaclass(cls.__name__, cls.__bases__, cls.__dict__.copy())
    return wrapper


class _SwigNonDynamicMeta(type):
    """Meta class to enforce nondynamic attributes (no new attributes) for a class"""
    __setattr__ = _swig_setattr_nondynamic_class_variable(type.__setattr__)


import weakref

import PyTrilinos.Teuchos.Base
import PyTrilinos.Epetra

import sys, os.path as op
thisDir = op.dirname(op.abspath(__file__))
if not thisDir in sys.path: sys.path.append(thisDir)
del sys, op

import Base
class Operator(Base.Operator):
    r"""
    An implementation of the Partitioner interface that operates on
       Epetra matrices and linear systems.

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Epetra.delete_Operator

    def setParameters(self, *args) -> "void":
        r"""
        setParameters() is an internal method which handles
             the parameters from a Teuchos::ParameterList object.
        """
        return _Epetra.Operator_setParameters(self, *args)

    def getCosts(self, *args) -> "Teuchos::RCP< Isorropia::Epetra::CostDescriber > &":
        r""" Get the cost object"""
        return _Epetra.Operator_getCosts(self, *args)

    def compute(self, *args) -> "void":
        return _Epetra.Operator_compute(self, *args)

    def alreadyComputed(self, *args) -> "bool":
        r""" Query whether compute_operation() has already been called."""
        return _Epetra.Operator_alreadyComputed(self, *args)

    def numProperties(self, *args) -> "int":
        return _Epetra.Operator_numProperties(self, *args)

    def numLocalProperties(self, *args) -> "int":
        return _Epetra.Operator_numLocalProperties(self, *args)

    def numElemsWithProperty(self, *args) -> "int":
        r""" Return the number of elements in a given partition."""
        return _Epetra.Operator_numElemsWithProperty(self, *args)

    def elemsWithProperty(self, *args) -> "void":
        r"""
        Fill user-allocated list (of length len) with the
             global element ids to be located in the given partition.
        """
        return _Epetra.Operator_elemsWithProperty(self, *args)

    def extractPropertiesCopy(self, *args) -> "int":
        return _Epetra.Operator_extractPropertiesCopy(self, *args)

    def extractPropertiesView(self, *args) -> "int":
        return _Epetra.Operator_extractPropertiesView(self, *args)

# Register Operator in _Epetra:
_Epetra.Operator_swigregister(Operator)

class Colorer(Base.Colorer, Operator):
    r"""
    An implementation of the Colorer interface that operates on
       Epetra matrices and linear systems.


    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        *Overload 1:*
        Constructor

           :type input_graph: :py:class:`Epetra_CrsGraph`
           :param input_graph: (in) the graph which is to have colors assigned to its rows
           :type paramlist: :py:class:`ParameterList`, optional
           :param paramlist: (in) this parameter list may be used to pass parameters to Zoltan
           :type compute_now: boolean, optional
           :param compute_now: (in) if ``true``, the coloring is computed in the constructor, otherwise call Isorropia::Epetra::Colorer::color when you want to compute the coloring, defaults to ``true``



        |

        *Overload 2:*
        Constructor

           :type input_matrix: :py:class:`Epetra_RowMatrix`
           :param input_matrix: (in) the matrix which is to have colors assigned to its rows
           :type paramlist: :py:class:`ParameterList`, optional
           :param paramlist: (in) this parameter list may be used to pass parameters to Zoltan
           :type compute_now: boolean, optional
           :param compute_now: (in) if ``true``, the coloring is computed in the constructor, otherwise call Isorropia::Epetra::Colorer::color when you want to compute the coloring, defaults to ``true``

        """
        _Epetra.Colorer_swiginit(self, _Epetra.new_Colorer(*args))
    __swig_destroy__ = _Epetra.delete_Colorer

    def color(self, *args) -> "void":
        r"""
        Compute the coloring if it has not already been computed, same effect as
              Isorropia::Epetra::Colorer::compute

           :type force_coloring: boolean, optional
           :param force_coloring: (in) if ``true`` recompute the coloring even if it has already been computed, defaults to ``false``

        """
        return _Epetra.Colorer_color(self, *args)

    def compute(self, *args) -> "void":
        r"""
        Compute the coloring if it has not already been computed, same effect as
              Isorropia::Epetra::Colorer::color

           :type force_compute: boolean, optional
           :param force_compute: (in) if ``true`` recompute the coloring even if it has already been computed, defaults to ``false``

        """
        return _Epetra.Colorer_compute(self, *args)

    def generateMapColoring(self, *args) -> "Teuchos::RCP< Epetra_MapColoring >":
        r"""
        Generate an ``Epetra_MapColoring`` object.

         Provide access on the coloring thru the EpetraEXT color class ``Epetra_MapColoring``.
         This methods requires EpetraEXT support.

         Deprecated: It's recommended to use See also: generateRowMapColoring() to this.
        """

        raise DeprecationWarning("Isorropia.Epetra.Colorer.generateMapColoring() " +
                                 "is deprecated. Use generateRowMapColoring()")


        return _Epetra.Colorer_generateMapColoring(self, *args)


    def generateRowMapColoring(self, *args) -> "Teuchos::RCP< Epetra_MapColoring >":
        r"""
        Generate an ``Epetra_MapColoring`` object corresponding of rows color.

         Provide access on the coloring thru the EpetraEXT color class ``Epetra_MapColoring``.
         This methods requires EpetraEXT support.

        """
        return _Epetra.Colorer_generateRowMapColoring(self, *args)

    def generateColMapColoring(self, *args) -> "Teuchos::RCP< Epetra_MapColoring >":
        r"""
        Generate an ``Epetra_MapColoring`` object corresponding of columns color.

         Provide access on the coloring thru the EpetraEXT color class ``Epetra_MapColoring``.
         This methods requires EpetraEXT support.

        """
        return _Epetra.Colorer_generateColMapColoring(self, *args)

# Register Colorer in _Epetra:
_Epetra.Colorer_swigregister(Colorer)

class Partitioner(Base.Partitioner, Operator):
    r"""
    An implementation of the Partitioner interface that operates on
       Epetra matrices and linear systems.


    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        *Overload 1:*


        |

        *Overload 2:*



        |

        *Overload 3:*



        |

        *Overload 4:*



        |

        *Overload 5:*



        |

        *Overload 6:*



        |

        *Overload 7:*



        |

        *Overload 8:*



        |

        *Overload 9:*



        |

        *Overload 10:*


        |

        *Overload 11:*


        |

        *Overload 12:*


        |

        *Overload 13:*


        |

        *Overload 14:*


        |

        *Overload 15:*


        |

        *Overload 16:*


        |

        *Overload 17:*


        |

        *Overload 18:*


        |

        *Overload 19:*
        """
        _Epetra.Partitioner_swiginit(self, _Epetra.new_Partitioner(*args))
    __swig_destroy__ = _Epetra.delete_Partitioner

    def setPartSizes(self, *args) -> "void":
        return _Epetra.Partitioner_setPartSizes(self, *args)

    def clearPartSizes(self, *args) -> "void":
        return _Epetra.Partitioner_clearPartSizes(self, *args)

    def partition(self, *args) -> "void":
        r"""
        partition is the method that computes
         a rebalanced partitioning for the data in the object
        that this class was constructed with.

        :type force_repartitioning: boolean, optional
        :param force_repartitioning: Optional argument defaults to false. By
               default, compute_partitioning() only does anything the first time
               it is called, and subsequent repeated calls are no-ops. If the user's
               intent is to re-compute the partitioning (e.g., if parameters
               or other inputs have been changed), then setting this flag to
               true will force a new partitioning to be computed.
        """
        return _Epetra.Partitioner_partition(self, *args)

    def compute(self, *args) -> "void":
        
        return _Epetra.Partitioner_compute(self, *args)

    def numElemsInPart(self, *args) -> "int":
        
        return _Epetra.Partitioner_numElemsInPart(self, *args)

    def elemsInPart(self, *args) -> "void":
        
        return _Epetra.Partitioner_elemsInPart(self, *args)

    def createNewMap(self, *args) -> "Teuchos::RCP< Epetra_Map >":
        r"""
        Create a new ``Epetra_Map`` corresponding to the new partition.

        This method is essentially used by the
        Isorropia::Epetra::Redistributor object.

        :rtype: :py:class:`Epetra_Map`
        :return: ``Epetra_Map`` that contains the new distribution of elements.


        """
        return _Epetra.Partitioner_createNewMap(self, *args)

    def printZoltanMetrics(self, *args) -> "int":
        return _Epetra.Partitioner_printZoltanMetrics(self, *args)

# Register Partitioner in _Epetra:
_Epetra.Partitioner_swigregister(Partitioner)

class Redistributor(Base.Redistributor):
    r"""
    Class which is constructed with a Partitioner instance, and
    provides several methods for redistributing Epetra objects
    given the partitioning computed by the Partitioner object.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        *Overload 1:*

        This constructor calls the Isorropia::Epetra::Partitioner::partition
        method on the ``partitioner`` if it has not already been called.

        :type partitioner: :py:class:`Partitioner`
        :param partitioner: (in) this input partitioner determines the new partitioning
                  to be created when Isorropia::Epetra::Redistributor::redistribute is called

        |

        *Overload 2:*

        This constructor sets the target map for the redistribution.

        :type target_map: :py:class:`Epetra_Map`
        :param target_map: (in) this input map determines the new matrices/vectors
            to be created when Isorropia::Epetra::Redistributor::redistribute is
            called
        """
        _Epetra.Redistributor_swiginit(self, _Epetra.new_Redistributor(*args))
    __swig_destroy__ = _Epetra.delete_Redistributor

    def redistribute(self, *args) -> "Teuchos::RCP< Epetra_MultiVector >":
        r"""
        *Overload 1:*

        Method to redistribute a Epetra_SrcDistObject into a
        Epetra_DistObject. The caller is required to have constructed
        the target object using the correct target map.

        |

        *Overload 2:*

        Method to accept a Epetra_CrsGraph object, and
        return a redistributed Epetra_CrsGraph object.

        :type input_graph: :py:class:`Epetra_CrsGraph`
        :param input_graph: (in) the graph for which we want a new graph that is distributed
                            according to the partitioner with which this Redistributor was
                            created.

        :type callFillComplete: boolean, optional
        :param callFillComplete: (in) The new graph is FillComplete'd if callFillComplete is ``true``.
            In that case, the range map is set to equal the row map.
            The domain map will equal the range map, unless the
            input_graph has different domain and range maps, in which case
            the original domain map is preserved.  By default callFillComplete is ``true``.

        :rtype: :py:class:`Epetra_CrsGraph`
        :return: a reference counted pointer to the new redistributed graph

        |

        *Overload 3:*

        Method to accept a Epetra_CrsGraph object, and
        return a redistributed Epetra_CrsGraph object.

        :type input_graph: :py:class:`Epetra_CrsGraph`
        :param input_graph: (in) the graph for which we want a new graph that is distributed
                            according to the partitioner with which this Redistributor was
                            created.

        :type outputGraphPtr: :py:class:`Epetra_CrsGraph`
        :param outputGraphPtr: (out) pointer to the new redistributed graph

        :type callFillComplete: boolean, optional
        :param callFillComplete: (in) The new graph is FillComplete'd if callFillComplete is ``true``.
            In that case, the range map is set to equal the row map.
            The domain map will equal the range map, unless the
            input_graph has different domain and range maps, in which case
            the original domain map is preserved.  By default callFillComplete is ``true``.


        |

        *Overload 4:*

        Method to accept a Epetra_CrsMatrix object, and
        return a redistributed Epetra_CrsMatrix object.

        :type input_matrix: :py:class:`Epetra_CrsMatrix`
        :param input_matrix: (in) the matrix for which we want a new matrix that is distributed
                            according to the partitioner with which this Redistributor was
                            created.

        :type callFillComplete: boolean, optional
        :param callFillComplete: (in) The new matrix is FillComplete'd if callFillComplete is ``true``.
            In that case, the range map is set to equal the row map.
            The domain map will equal the range map, unless the
            input_matrix has different domain and range maps, in which case
            the original domain map is preserved.  By default callFillComplete is ``true``.

        :rtype: :py:class:`Epetra_CrsMatrix`
        :return: a reference counted pointer to the new redistributed matrix

        |

        *Overload 5:*

        Method to accept a Epetra_RowMatrix object, and
        return a redistributed Epetra_CrsMatrix object.

        :type input_matrix: :py:class:`Epetra_RowMatrix`
        :param input_matrix: (in) the row matrix for which we want a new matrix that is distributed
                            according to the partitioner with which this Redistributor was
                            created.

        :type callFillComplete: boolean, optional
        :param callFillComplete: (in) The new matrix is FillComplete'd if callFillComplete is ``true``.
            In that case, the range map is set to equal the row map.
            The domain map will equal the range map, unless the
            input_matrix has different domain and range maps, in which case
            the original domain map is preserved.  By default callFillComplete is ``true``.

        :rtype: :py:class:`Epetra_CrsMatrix`
        :return: a reference counted pointer to the new redistributed matrix

        |

        *Overload 6:*

        Method to accept a Epetra_Vector object, and
        return a redistributed Epetra_Vector object.

        :type input_vector: :py:class:`Epetra_Vector`
        :param input_vector: (in) the vector for which we want a new vector that is distributed
                            according to the partitioner with which this Redistributor was
                            created.

        :rtype: Teuchos::RCP< Epetra_Vector >
        :return: a reference counted pointer to the new redistributed vector

        |

        *Overload 7:*

        Method to accept a Epetra_MultiVector object, and
        return a redistributed Epetra_MultiVector object.

        :type input_vector: :py:class:`Epetra_MultiVector`
        :param input_vector: (in) the multi vector for which we want a new multi vector that is distributed
                            according to the partitioner with which this Redistributor was
                            created.

        :rtype: Teuchos::RCP< Epetra_MultiVector >
        :return: a reference counted pointer to the new redistributed multi vector
        """
        return _Epetra.Redistributor_redistribute(self, *args)

    def redistribute_reverse(self, *args) -> "void":
        r"""
        *Overload 1:*

        Reverse redistribute an Epetra_Vector.

        :type input_vector: :py:class:`Epetra_Vector`
        :param input_vector: (in) a vector that is distributed according to the partitioner that was used to create this Redistributor

        :type output_vector: :py:class:`Epetra_Vector`
        :param output_vector: (out) a copy of the ``input_vector`` which has been redistributed according
                          to the reverse of the partitioner that was used to create this Redistributor


        |

        *Overload 2:*

        Reverse redistribute an Epetra_MultiVector.

        :type input_vector: :py:class:`Epetra_MultiVector`
        :param input_vector: (in) a multi vector that is distributed according to the partitioner that was used to create this Redistributor

        :type output_vector: :py:class:`Epetra_MultiVector`
        :param output_vector: (out) a copy of the ``input_vector`` which has been redistributed according
                          to the reverse of the partitioner that was used to create this Redistributor
        """
        return _Epetra.Redistributor_redistribute_reverse(self, *args)

    def get_importer(self, *args) -> "Epetra_Import &":
        return _Epetra.Redistributor_get_importer(self, *args)

# Register Redistributor in _Epetra:
_Epetra.Redistributor_swigregister(Redistributor)

class CostDescriber(Base.CostDescriber):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    __swig_destroy__ = _Epetra.delete_CostDescriber

    def __init__(self, *args):
        r"""
        *Overload 1:*
        Constructor

        |

        *Overload 2:*
        Copy constructor
        """
        _Epetra.CostDescriber_swiginit(self, _Epetra.new_CostDescriber(*args))

    def setVertexWeights(self, *args) -> "void":
        r"""
        setVertexWeights is called by a process to supply the
             weight of each vertex (row) in the graph or hypergraph.
             If the object to be partitioned is instead an Epetra_MultiVector
             representing real
             coordinates, then the weights represent the weight assigned to each coordinate.

             :type vwgts: Teuchos::RCP< Epetra_Vector const >
             :param vwgts: [in]  vector of weights, one for each vertex
        """
        return _Epetra.CostDescriber_setVertexWeights(self, *args)

    def setGraphEdgeWeights(self, *args) -> "void":
        r"""
        setGraphEdgeWeights is called by a process to supply the weights for
             each of the edges of its vertices.  An edge corresponds to a non-zero
             in the row representing the vertex.

             This method is called only when performing graph partitioning with a
             square symmetric matrix.  For hypergraph partitioning call the equivalent
             hypergraph method.

             :type gewts: :py:class:`Epetra_CrsMatrix`
             :param gewts: an Epetra_CrsMatrix supplied by the application, each non-zero
                        represents a weight for an edge
        """
        return _Epetra.CostDescriber_setGraphEdgeWeights(self, *args)

    def setHypergraphEdgeWeights(self, *args) -> "void":
        r"""
        *Overload 1:*
        setHypergraphEdgeWeights is called by processes in an application to
             supply weights for the hyperedges, which are represented by the columns
             of the matrix.  (A hyperedge can in general link more than one vertex.)

             Matrices that represent hypergraphs are not in general square.
             There may be more or fewer hyperedges (columns) than vertices (rows).

             :type hgewts: Teuchos::RCP< Epetra_Vector const >
             :param hgewts:  an Epetra_Vector containing the weights for each hyperedge.

        |

        *Overload 2:*
        setHypergraphEdgeWeights is called by processes in an application to
             supply weights for the hyperedges, which are represented by the columns
             of the matrix.  (A hyperedge can in general link more than one vertex.)

             Matrices that represent hypergraphs are not in general square.
             There may be more or fewer hyperedges (columns) than vertices (rows).

             More than one process can supply a weight for the same column.  (So
             there is no concept of a process owning a hyperedge.)  Zoltan
             combines these weights according to the setting of the
             PHG_EDGE_WEIGHT_OPERATION parameter.

              :type numHGedges: int
              :param numHGedges:  the length of the hgGIDs and heEwgts arrays
              :type hgGIDs: int
              :param hgGIDs:      the global ID for each hyperedge this process will supply a weight for
              :type hgEwgts: float
              :param hgEwgts:   the hyperedge weight corresponding to each hyperedge listed in hgGIDs

        |

        *Overload 3:*
         numHGedges, const int *hgGIDs, const float *hgEwgts)
        """
        return _Epetra.CostDescriber_setHypergraphEdgeWeights(self, *args)

    def getCosts(self, *args) -> "void":
        r"""
        Get the contents of this CostDescriber

             :type vertexWeights: std::map< int,float,std::less< int >,std::allocator< std::pair< int const,float > > >
             :param vertexWeights: is set to a mapping from vertex global IDs to their weights
             :type graphEdgeWeights: std::map< int,std::map< int,float,std::less< int >,std::allocator< std::pair< int const,float > > >,std::less< int >,std::allocator< std::pair< int const,std::map< int,float,std::less< int >,std::allocator< std::pair< int const,float > > > > > >
             :param graphEdgeWeights: is a mapping from vertex global IDs to a map from neighboring
                            IDs to edge weights
             :type hypergraphEdgeWeights: std::map< int,float,std::less< int >,std::allocator< std::pair< int const,float > > >
             :param hypergraphEdgeWeights: is a mapping from hyperedge (column) global IDs to hyperedge weights
        """
        return _Epetra.CostDescriber_getCosts(self, *args)

    def show_cd(self, *args) -> "void":
        r""" Print out the contents of this CostDescriber"""
        return _Epetra.CostDescriber_show_cd(self, *args)

# Register CostDescriber in _Epetra:
_Epetra.CostDescriber_swigregister(CostDescriber)

class Orderer(Base.Orderer, Operator):
    r"""
    An implementation of the Orderer interface that operates on
       Epetra matrices and linear systems.

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        _Epetra.Orderer_swiginit(self, _Epetra.new_Orderer(*args))
    __swig_destroy__ = _Epetra.delete_Orderer

    def order(self, *args) -> "void":
        r"""
        Method which does the work of computing a new ordering.

            :type force_ordering: boolean, optional
            :param force_ordering: Optional argument defaults to false.

        """
        return _Epetra.Orderer_order(self, *args)

    def compute(self, *args) -> "void":
        return _Epetra.Orderer_compute(self, *args)

# Register Orderer in _Epetra:
_Epetra.Orderer_swigregister(Orderer)

class LevelScheduler(Base.LevelScheduler, Operator):
    r"""
    An implementation of the LevelScheduler interface that operates on
       and Epetra_CrsGraph, representing the non-zeros in a matrix.  The
       elements to be partitioned into levels are matrix rows.  Assumption
       is that matrix is lower triangular or upper triangular.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        Constructor

           :type input_graph: :py:class:`Epetra_CrsGraph`
           :param input_graph: (in) the graph representing the non-zeros of the matrix
           :type paramlist: :py:class:`ParameterList`, optional
           :param paramlist: (in) list of parameters
           :type compute_now: boolean, optional
           :param compute_now: (in) if ``true``, the scheduling is computed in the constructor, otherwise call Isorropia::Epetra::LevelScheduler::schedule when you want to compute the scheduling, defaults to ``false``
        """
        _Epetra.LevelScheduler_swiginit(self, _Epetra.new_LevelScheduler(*args))
    __swig_destroy__ = _Epetra.delete_LevelScheduler

    def schedule(self, *args) -> "void":
        r"""
        Compute the scheduling if it has not already been computed, same effect as
              Isorropia::Epetra::LevelScheduler::compute

           :type force_scheduling: boolean, optional
           :param force_scheduling: (in) if ``true`` recompute the scheduling even if it has already been computed, defaults to ``false``
        """
        return _Epetra.LevelScheduler_schedule(self, *args)

    def compute(self, *args) -> "void":
        r"""
        Compute the scheduling if it has not already been computed, same effect as
              Isorropia::Epetra::LevelScheduler::schedule

           :type force_compute: boolean, optional
           :param force_compute: (in) if ``true`` recompute the scheduling even if it has already been computed, defaults to ``false``
        """
        return _Epetra.LevelScheduler_compute(self, *args)

# Register LevelScheduler in _Epetra:
_Epetra.LevelScheduler_swigregister(LevelScheduler)


try:
    import sys
    import random
    import colorsys
    import math

    try:
        from PIL import Image, ImageDraw
    except ImportError:
        import Image, ImageDraw

    Image_loaded = True
except ImportError:
    Image_loaded = False 

class Visualizer:
    """
    The Visualizer class provides a means of simply visualizing partitions
    formed by Isorropia.Epetra.Partitioner or Partitioner2D. It can also draw
    Epetra.CrsMatrix objects directly.

    The Visualizer relies on the Python Imaging Library and ImageMagick.

    To generate images of multiple sizes given the same partitioner, you'll
    need to call generateImage() several times, calling getPILImage() after
    each call and saving the result. You can then save or show those images as
    necessary.

    """

    data     = None  # The matrix/partition we are visualizing. After
# redistribution this will always be a CrsMatrix.
    dataType = None  # The type of the original data passed in.
# Currently supported: CrsMatrix, Partitioner,
# Partitioner2D

    numProcs        = 0
    verbosity       = 0
    iAmRoot         = False
    loadThreshold   = 0

    img             = None

    background      = 0x000000
    matrixHeight    = -1
    matrixWidth     = -1
    imageHeight     = -1
    imageWidth      = -1

    pointTL         = (0,0)
    pointBR         = (-1,-1)
    regionHeight    = -1
    regionWidth     = -1

    def __init__(self, data, numParts=-1, loadThreshold=0, verbosity=0):
        """
        Visualizer constructor.
        Inputs: data      - CrsMatrix or Partitioner
                numParts  - The number of parts to distribute into.
                            Defaults to the number of processes in MPI.
                loadThreshold - The threshold ratio that must be exceeded
                            for the visualizer to display something in that
                            pixel. Zero is a safe choice.
                verbosity - Print debugging output. High number increases
                            quantity of output.

       The initialization first reassigns the values in the matrix to represent
       the processor they reside on (or have been partitioned to), then
       redistributes the matrix onto the root processor for use in show().
        """

        if Image_loaded == False:
            print("Python Imaging Library, ImageMagick and colorsys libraries "
                  "required for Visualizer function")
            sys.exit(1)

        if isinstance(data, PyTrilinos.Epetra.CrsMatrix):
            self.comm = data.Comm()
        elif isinstance(data, PyTrilinos.Isorropia.Epetra.Partitioner) or isinstance(data, PyTrilinos.Isorropia.Epetra.Partitioner2D):
            self.comm = data.InputMatrix().Comm()
        else:
            sys.exit(1)

        iAmRoot = self.iAmRoot = self.comm.MyPID() == 0

        if numParts == -1:
            self.numProcs = comm.NumProc()
        else:
            self.numProcs = numParts

        self.verbosity = verbosity
        self.data = data
        self.loadThreshold = loadThreshold

        if isinstance(data, PyTrilinos.Epetra.CrsMatrix):
            if iAmRoot and verbosity > 1: print("Proceeding with CrsMatrix")

            self.dataType = "CrsMatrix"

            if iAmRoot and verbosity > 2: print("Redistributing for visualization")

# Reset the values of the matrix to their respective processors
            self.centralizeMatrix()

        elif isinstance(data, PyTrilinos.Isorropia.Epetra.Partitioner):
            if iAmRoot and verbosity > 1: print("Proceeding with Partitioner")

            self.dataType = "Partitioner"

            if iAmRoot and verbosity > 2: print("Redistributing for visualization")

# Reset the values of the matrix to their partitioned processors
            self.centralizePartitioner()

        elif isinstance(data, PyTrilinos.Isorropia.Epetra.Partitioner2D):
            if iAmRoot and verbosity > 1: print("Proceeding with Partitioner2D")

            self.dataType = "Partitioner2D"

            if iAmRoot and verbosity > 2: print("Redistributing for visualization")

# Reset the values of the matrix to their partitioned processors
            self.centralizePartitioner2D()

# Only support CrsMatrix and Partitioner objects currently
        else:
            sys.exit(1)


    def processRow(self, row, draw):
        """
        processRow() is a private helper to draw an individual row of pixels of
        the image when simpleGenerate() can't be used.

        """

        if not self.iAmRoot: return

        if self.verbosity > 3: print("Processing row " + str(row))

        widthRatio = float(self.regionWidth) / float(self.imageWidth)
        heightRatio = float(self.regionHeight) / float(self.imageHeight)

# Calculate starting and ending positions in the matrix which will be 
# drawn into this row of pixels
        startY = int(math.ceil(row * heightRatio)) + self.pointTL[1]
        endY = min(int(math.floor((row + 1) * heightRatio)) + self.pointTL[1], self.matrixHeight - 1)
#startY = int(math.ceil(row * heightRatio))
#endY = min(int(math.floor((row + 1) * heightRatio)), self.matrixHeight - 1)

# Extract the rows to be represented
        nonZeroes = []
        for j in range(startY, endY + 1):
            nonZeroes += [self.data.ExtractGlobalRowCopy(j)]

# procCount: List of lists. One list per pixel, whose values represent
# the number of nonzeroes for the i-th processor found in this pixel so far
        procCount = [[0]*(self.numProcs + 1) for i in range(self.imageWidth)]
        for k in range(len(nonZeroes)):
# x = arbitrary id. Ideally would be dictionary.
            procNums = nonZeroes[k][0]          # Maps x -> processor ID
            colIndices = nonZeroes[k][1]        # Maps x -> column index.

# Go through the nonzeroes in this row and increment the appropriate
# counter
            for l in range(len(procNums)): # (len(colIndices) would be the same)
# Only show the columns we care about
                if colIndices[l] < self.pointTL[0]:
                    continue
                if colIndices[l] >= self.pointBR[0]:
                    break

# Take the matrix column and show us which pixel column it should go into
                pixelColumn = int((colIndices[l] - self.pointTL[0]) / widthRatio)
                if (pixelColumn >= len(procCount)):
                    print("Invalid value found for pixelColumn. Quitting.")
                    print(str(pixelColumn) + " " + str(len(procCount)))
                    sys.exit(1)

# Increment the counter for whomever owns that nonzero
                if (int(procNums[l]) >= len(procCount[pixelColumn])) or (int(procNums[l]) < 0):
                    print("Invalid value found for part value. Quitting.")
                    sys.exit(1)
                else:
                    procCount[pixelColumn][int(procNums[l])] += 1

# Draw each pixel in the row, once we have counted up the nonzeroes
        for col in range(self.imageWidth):
# Ensure there were enough nonzeroes in this pixel to warrant drawing.
# Currently the threshold is 0, so any nonzero is displayed, but it
# supports change.
            numElementsInPixel = int(widthRatio * (endY - startY))
            if numElementsInPixel == 0: loadRatio = 0
            else: loadRatio = float(sum(procCount[col])) / numElementsInPixel
            if(max(procCount[col]) != 0 and loadRatio > self.loadThreshold):
                draw.rectangle([col, row,
                                col + 1,
                                row + 1],
                               fill=self.fillColors[procCount[col].index(max(procCount[col])) - 1])


    def generateImage(self):
        """
        Opens an image window representing the matrix stored in this object's
        data field. This opened window allows saving the image.

        The colors chosen to represent each processor are evenly distributed
        along the hue and presently can not be customized.

        """

        if not self.iAmRoot: return

        if self.dataType != "CrsMatrix" and self.dataType != "Partitioner" and self.dataType != "Partitioner2D":
            raise "Error: Only CrsMatrix and Partitioner[2D] data formats supported at present"
            return

        self.matrixHeight = self.data.NumGlobalRows()
        self.matrixWidth  = self.data.NumGlobalCols()

        if self.pointBR[0] == -1 or self.pointBR[1] == -1:
            self.pointBR = (self.matrixWidth, self.matrixHeight)

        self.regionHeight = self.pointBR[1] - self.pointTL[1]
        self.regionWidth  = self.pointBR[0] - self.pointTL[0]

# Generate an image that maintains aspect ratio if we have not been given a height.
        if self.imageHeight == -1:
            self.imageHeight = int(float(self.regionHeight) / self.regionWidth * self.imageWidth)
            if self.verbosity > 3: print("Defining height as " +
                                         str(self.imageHeight))

# Create Image and ImageDraw objects
        im = Image.new("RGB", (self.imageWidth, self.imageHeight), self.background)
        draw = ImageDraw.Draw(im)


        if (self.pointBR[0] > self.matrixWidth or
            self.pointBR[1] > self.matrixWidth or
            self.pointBR[0] < self.pointTL[0] or
            self.pointBR[1] < self.pointTL[1] or
            self.pointTL[0] < 0 or
            self.pointTL[1] < 0 or
            self.regionHeight <= 0 or
            self.regionWidth <= 0):
            raise Exception("Invalid region of interest")

        cellWidth = self.imageWidth / self.regionWidth
        cellHeight = self.imageHeight / self.regionHeight

        self.fillColors = self.fillColorArray(self.numProcs)

        """ If we have more matrix rows or columns than we have pixels, can't use simpleGenerate() """
        if cellWidth == 0 and cellHeight == 0:    
            if self.verbosity > 2: print("NOT using simpleGenerate()")
            for i in range(self.imageHeight): # Go through the rows
                self.processRow(i, draw)
        elif cellWidth == 0 or cellHeight == 0:
            sys.stderr.write("""
                ERROR: There exists a known bug where nothing prints if you try to
                print part of your matrix such that you have more rows in your
                image than in your matrix but fewer columns than in your
                matrix. Or vice versa. We're working on fixing this. In the
                meantime, please re-size your print region, your image output,
                or both!
                """)
        else:
            if self.verbosity > 2: print("Using simpleGenerate()")
            self.simpleGenerate(draw)


        self.img = im

    def show(self):
        """
        Shows the pre-generated image. Must be preceded by a call to generateImage().
        """
        if not self.iAmRoot: return

        if self.img == None:
            print("Image must be computed before call to show(). Call "
                  "generateImage() first.")
            return

        self.img.show()

    def save(self, filename):
        """
        Saves the pre-generated image to the given file. The format is derived
        from the filename. Must be preceded by a call to generateImage().

        """
        if not self.iAmRoot: return

        if self.img == None:
            print("Image must be computed before call to save(). Call "
                  "generateImage() first.")
            return

        self.img.save(filename)

    def getPILImage(self):
        """
        Returns the PIL Image object generated by generateImage(). Returns None
        if no image has yet been generated.
        """
        return self.img

    def simpleGenerate(self, draw):
        """
        Draws the matrix to the provided image object, provided that the width
        and height of the image exceed the number of columns and rows of the matrix.

        Used by generateImage().
        """
        if not self.iAmRoot: return

        regionWidth = self.pointBR[0] - self.pointTL[0]
        regionHeight = self.pointBR[1] - self.pointTL[1]

        fillColors = self.fillColorArray(self.numProcs)

        cellWidth = float(self.imageWidth) / regionWidth
        cellHeight = float(self.imageHeight) / regionHeight

# Loop through rows of matrix
        for i in range(self.pointTL[1], self.pointBR[1]):
            nonZeroes = self.data.ExtractGlobalRowCopy(i)

            procNums = nonZeroes[0]
            colIndices = nonZeroes[1]

            startY = (i - self.pointTL[1]) * cellHeight

# Loop through nonzeroes, drawing appropriate rectangles
            for j in range(len(colIndices)):
                if colIndices[j] < self.pointTL[0]: continue
                elif colIndices[j] >= self.pointBR[0]: break
                startX = (colIndices[j] - self.pointTL[0]) * cellWidth
                draw.rectangle([int(startX), int(startY),
                                int(startX + cellWidth),
                                int(startY + cellHeight)],
                               fill=fillColors[int(procNums[j]) - 1])

    def setBgColor(self, background):
        self.background = background

    def setImageHeight(self, height):
        self.imageHeight = height

    def setImageWidth(self, width):
        self.imageWidth = width

    def setViewingWindow(self, pointTL, pointBR=(-1,-1)):
        self.pointTL = pointTL
        self.pointBR = pointBR

    def setVerbosity(self, verbosity):
        self.verbosity = verbosity

    def fillColorArray(self, numParts):
        """
        Given the number of partitions, returns an array of at least that many
        distinct color values
        """

        HSV_tuples = [(x*1.0/numParts, 0.9, 0.8) for x in range(numParts)]
        RGB_tuples = map(lambda x: colorsys.hsv_to_rgb(*x), HSV_tuples)
        hex_tuples = map(lambda x: (int(255*x[2]) << 16)+(int(255*x[1]) << 8)+(int(255*x[0])), RGB_tuples)

        random.shuffle(hex_tuples)

        return hex_tuples


    def centralizeMatrix(self):
        """
        Performs two operations:
            1. Replaces all non-zero values in the matrix with a value
               representing that non-zero's global part ID
            2. Repartitions such that all elements in the matrix are owned by
               the main process.
        """

        """ Reset the values in each row of the matrix to this processor's ID """
        for i in range(self.data.NumMyRows()):
            rowView = self.data.ExtractMyRowCopy(i) # Values first, indices second
            self.data.ReplaceMyValues(i, [self.comm.MyPID() + 1]*len(rowView[1]), rowView[1])

        globalNumRows = self.data.NumGlobalRows()

# Create a map to move all rows to the root processor
        if self.iAmRoot:
            localNumRows = globalNumRows
        else:
            localNumRows = 0

        targetMap = PyTrilinos.Epetra.Map(globalNumRows, localNumRows, 0, self.comm)
        redist = PyTrilinos.Isorropia.Epetra.Redistributor(targetMap)
# Redistribute to root processor
        self.data = redist.redistribute(self.data)

    def centralizePartitioner(self):
        """
        Performs three operations:
            1. Replaces the partitioner with a new CrsMatrix, maintaining
               non-zero distribution (with the same RowMap).
            1. Replaces all non-zero values in the matrix with a value
               representing that non-zero's global part ID
            2. Repartitions such that all elements in the matrix are owned by
               the main process.

        """

        rowMatrix = self.data.InputMatrix()
        map = rowMatrix.RowMatrixRowMap()

# Get information needed to create a duplicate CrsMatrix
        rowLengths = []
        rows = []
        for i in range(rowMatrix.NumMyRows()):
            rowView = rowMatrix.ExtractMyRowCopy(i) # Values first, indices second
            rows += [rowView[1]]
            rowLengths += [len(rowView[1])]

# Create a new CrsMatrix to duplicate the Partitioner's RowMatrix
        crsm = PyTrilinos.Epetra.CrsMatrix(PyTrilinos.Epetra.Copy, map, rowMatrix.RowMatrixColMap(), rowLengths)
        for gid in range(map.MaxLID()+1):
            values = [1]*len(rows[gid])
            crsm.InsertMyValues(gid, values, rows[gid])
        crsm.FillComplete()

# Reassign the CrsMatrix's values to their mapped processor IDs
        newMap = self.data.createNewMap()

        matrixHeight = rowMatrix.NumGlobalRows()

        for i in range(crsm.NumMyRows()):
            rowView = rowMatrix.ExtractMyRowCopy(i) # Values first, indices second
            gid = map.GID(i)
            newLoc = self.data.index(i) ###########################################################
            if newLoc < 0 or newLoc > matrixHeight:
                print("newLoc is wrong, quitting " + str(newLoc))
                sys.exit(1)
            crsm.ReplaceMyValues(i, [newLoc + 1]*len(rowView[1]), rowView[1])
        crsm.FillComplete()

# Set self.data to the CrsMatrix representation
        self.data = crsm

        globalNumRows = self.data.NumGlobalRows()

# Create a map to move all rows to the root processor
        if self.iAmRoot:
            localNumRows = globalNumRows
        else:
            localNumRows = 0

        targetMap = PyTrilinos.Epetra.Map(globalNumRows, localNumRows, 0, self.comm)
        redist = PyTrilinos.Isorropia.Epetra.Redistributor(targetMap)
# Redistribute to root processor
        self.data = redist.redistribute(self.data)

    def centralizePartitioner2D(self):
        """
        Exactly the same as centralizePartitioner(), but accepting a Partitioner2D.

        Creates a new CrsMatrix to represent the Partitioner2D's matrix
        structure. This new CrsMatrix has the same distribution as the
        Partitioner2D's matrix, but the values of the nonzeroes represent their
        'destination' processors in the Partitioner's new Map
        """

        rowMatrix = self.data.InputMatrix()
        map = rowMatrix.RowMatrixRowMap()

# Get information needed to create a duplicate CrsMatrix
        rowLengths = []
        rows = []
        for i in range(rowMatrix.NumMyRows()):
            rowView = rowMatrix.ExtractMyRowCopy(i) # Values first, indices second
            rows += [rowView[1]]
            rowLengths += [len(rowView[1])]

# Create a new CrsMatrix to duplicate the Partitioner's RowMatrix
        crsm = PyTrilinos.Epetra.CrsMatrix(PyTrilinos.Epetra.Copy, map, rowMatrix.RowMatrixColMap(), rowLengths)
        for gid in range(map.MaxLID()+1):
            values = [0]*len(rows[gid])
            crsm.InsertMyValues(gid, values, rows[gid])
        crsm.FillComplete()

# Reassign the CrsMatrix's values to their mapped processor IDs
        matrixHeight = rowMatrix.NumGlobalRows()

        numMyNZs = rowMatrix.NumMyNonzeros()
        counter = 0

        for i in range(crsm.NumMyRows()):
            rowView = rowMatrix.ExtractMyRowCopy(i) # Values first, indices second
            gid = map.GID(i)
            newProcs = [0] * len(rowView[1])
            for j in range(len(newProcs)):
                newProcs[j] = self.data.index(counter)
                counter += 1
            crsm.SumIntoMyValues(i, newProcs, rowView[1])

        crsm.FillComplete()

# Set self.data to the CrsMatrix representation
        self.data = crsm

        globalNumRows = self.data.NumGlobalRows()

# Create a map to move all rows to the root processor
        if self.iAmRoot:
            localNumRows = globalNumRows
        else:
            localNumRows = 0

        targetMap = PyTrilinos.Epetra.Map(globalNumRows, localNumRows, 0, self.comm)
        redist = PyTrilinos.Isorropia.Epetra.Redistributor(targetMap)
# Redistribute to root processor
        self.data = redist.redistribute(self.data)




