# This file was automatically generated by SWIG (http://www.swig.org).
# Version 4.0.2
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.

"""

PyTrilinos.Komplex is the python interface to the Trilinos complex
linear algebra package Komplex:

    https://trilinos.org/docs/dev/packages/komplex/doc/html/index.html

The purpose of Komplex is to define complex (real + imaginary) linear
algebra problems using real-valued Epetra vectors and matrix
operators.  The python version of the Komplex package supports the
following class:

    * LinearProblem - Encapsulate all elements of a complex linear
                      algebra problem

"""

from sys import version_info as _swig_python_version_info
if _swig_python_version_info < (2, 7, 0):
    raise RuntimeError("Python 2.7 or later required")

# Import the low-level C/C++ module
if __package__ or "." in __name__:
    from . import _Komplex
else:
    import _Komplex

try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)


def _swig_setattr_nondynamic_instance_variable(set):
    def set_instance_attr(self, name, value):
        if name == "thisown":
            self.this.own(value)
        elif name == "this":
            set(self, name, value)
        elif hasattr(self, name) and isinstance(getattr(type(self), name), property):
            set(self, name, value)
        else:
            raise AttributeError("You cannot add instance attributes to %s" % self)
    return set_instance_attr


def _swig_setattr_nondynamic_class_variable(set):
    def set_class_attr(cls, name, value):
        if hasattr(cls, name) and not isinstance(getattr(cls, name), property):
            set(cls, name, value)
        else:
            raise AttributeError("You cannot add class attributes to %s" % cls)
    return set_class_attr


def _swig_add_metaclass(metaclass):
    """Class decorator for adding a metaclass to a SWIG wrapped class - a slimmed down version of six.add_metaclass"""
    def wrapper(cls):
        return metaclass(cls.__name__, cls.__bases__, cls.__dict__.copy())
    return wrapper


class _SwigNonDynamicMeta(type):
    """Meta class to enforce nondynamic attributes (no new attributes) for a class"""
    __setattr__ = _swig_setattr_nondynamic_class_variable(type.__setattr__)


import weakref

class SwigPyIterator(object):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Komplex.delete_SwigPyIterator

    def value(self) -> "PyObject *":
        return _Komplex.SwigPyIterator_value(self)

    def incr(self, n: "size_t"=1) -> "swig::SwigPyIterator *":
        return _Komplex.SwigPyIterator_incr(self, n)

    def decr(self, n: "size_t"=1) -> "swig::SwigPyIterator *":
        return _Komplex.SwigPyIterator_decr(self, n)

    def distance(self, x: "SwigPyIterator") -> "ptrdiff_t":
        return _Komplex.SwigPyIterator_distance(self, x)

    def equal(self, x: "SwigPyIterator") -> "bool":
        return _Komplex.SwigPyIterator_equal(self, x)

    def copy(self) -> "swig::SwigPyIterator *":
        return _Komplex.SwigPyIterator_copy(self)

    def next(self) -> "PyObject *":
        return _Komplex.SwigPyIterator_next(self)

    def __next__(self) -> "PyObject *":
        return _Komplex.SwigPyIterator___next__(self)

    def previous(self) -> "PyObject *":
        return _Komplex.SwigPyIterator_previous(self)

    def advance(self, n: "ptrdiff_t") -> "swig::SwigPyIterator *":
        return _Komplex.SwigPyIterator_advance(self, n)

    def __eq__(self, x: "SwigPyIterator") -> "bool":
        return _Komplex.SwigPyIterator___eq__(self, x)

    def __ne__(self, x: "SwigPyIterator") -> "bool":
        return _Komplex.SwigPyIterator___ne__(self, x)

    def __iadd__(self, n: "ptrdiff_t") -> "swig::SwigPyIterator &":
        return _Komplex.SwigPyIterator___iadd__(self, n)

    def __isub__(self, n: "ptrdiff_t") -> "swig::SwigPyIterator &":
        return _Komplex.SwigPyIterator___isub__(self, n)

    def __add__(self, n: "ptrdiff_t") -> "swig::SwigPyIterator *":
        return _Komplex.SwigPyIterator___add__(self, n)

    def __sub__(self, *args) -> "ptrdiff_t":
        return _Komplex.SwigPyIterator___sub__(self, *args)
    def __iter__(self):
        return self

# Register SwigPyIterator in _Komplex:
_Komplex.SwigPyIterator_swigregister(SwigPyIterator)

from . import Epetra

def Version(*args) -> "std::string":
    return _Komplex.Version(*args)

__version__ = Version().split()[2]

class Komplex_LinearProblem(object):
    r"""
     Komplex_LinearProblem: A class for forming an equivalent real formulation of a complex valued problem. The Komplex_LinearProblem class takes a complex linear problem, separated into real and imaginary parts,
        and forms an equivalent real valued system of twice the dimension.  The resulting system can then be
        solved with any Trilinos solver that understands Epetra objects.

    KOMPLEX solves a complex-valued linear system Ax = b by solving
    an equivalent real-valued system of twice the dimension.  Specifically,
    writing in terms of real and imaginary parts, we have

     .. math::

         (A_r + i*A_i)*(x_r + i*x_i) = (b_r + i*b_i)

      or by separating into real and imaginary equations we have

    .. math::

        \left( \begin{array}{rr}
                                            A_r & -A_i\\
                                            A_i &  A_r
                                     \end{array}
           \right)
           \left( \begin{array}{r}
                                            x_r\\
                                            x_i
                                     \end{array}
           \right)
           =
           \left( \begin{array}{r}
                                            b_r\\
                                            b_i
                                     \end{array}
           \right)
      which is a real-valued system of twice the size.  If we find xr and xi, we
      can form the solution to the original system as x = xr +i*xi.


    KOMPLEX accepts the user linear system as two real-valued matrices with no assumption
    about the structure of the matrices, except that they have compatible RowMap, DomainMap
    and RangeMap distributions.  Each matrix is multiplied by
    user-supplied complex constants.

    Although formally the system is a 2-by-2 block system, we actually apply the interleaving at the matrix entry level
    such that the real part of the first complex equation is followed by the imaginary part of the first complex equation,
    and so on.  This approach is documented in:

     David Day and Michael A. Heroux. Solving complex-valued linear systems via equivalent real formulations.
     SIAM J. Sci. Comput., 23(2):480--498, 2001.


    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        Komplex_LinearProblem constructor. Constructs the Komplex operator from the user definition
             of the complex-valued matrix C = (c0r+i*c0i)*A0 +(c1r+i*c1i)*A1.
             Using this general expression for the complex matrix allows easy formulation of a variety of common
             complex problems.

             :type c0r: float
             :param c0r: (In) The real part of the complex coefficient multiplying A0.
             :type c0i: float
             :param c0i: (In) The imag part of the complex coefficient multiplying A0.
             :type A0: :py:class:`Epetra_RowMatrix`
             :param A0: (In) An Epetra_RowMatrix that is one of the matrices used to define the true complex operator.
             :type c1r: float
             :param c1r: (In) The real part of the complex coefficient multiplying A1.
             :type c1i: float
             :param c1i: (In) The imag part of the complex coefficient multiplying A1.
             :type A1: :py:class:`Epetra_RowMatrix`
             :param A1: (In) An Epetra_RowMatrix that is the second of the matrices used to define the true complex operator.
             :type Xr: :py:class:`Epetra_MultiVector`
             :param Xr: (In) The real part of the complex valued LHS.
             :type Xi: :py:class:`Epetra_MultiVector`
             :param Xi: (In) The imag part of the complex valued LHS.
             :type Br: :py:class:`Epetra_MultiVector`
             :param Br: (In) The real part of the complex valued RHS.
             :type Bi: :py:class:`Epetra_MultiVector`
             :param Bi: (In) The imag part of the complex valued RHS.
        """
        _Komplex.Komplex_LinearProblem_swiginit(self, _Komplex.new_Komplex_LinearProblem(*args))
    __swig_destroy__ = _Komplex.delete_Komplex_LinearProblem

    def UpdateValues(self, *args) -> "int":
        r"""
        Update the values of the equivalent real valued system. This method allows the values of an existing Komplex_LinearProblem object to be updated.  Note that
             the update that there is no change to the pattern of the matrices.

           :rtype: int
           :return: Error code, set to 0 if no error.
        """
        return _Komplex.Komplex_LinearProblem_UpdateValues(self, *args)

    def ExtractSolution(self, *args) -> "int":
        r"""
        Extrac a solution for the original complex-valued problem using the solution of the Komplex problem. After solving the komplex linear system, this method can be called to extract the
             solution of the original problem, assuming the solution for the komplex system is valid.
           :type Xr: :py:class:`Epetra_MultiVector`
           :param Xr: (Out) An existing Epetra_MultiVector.  On exit it will contain the real part of the complex valued solution.
           :type Xi: :py:class:`Epetra_MultiVector`
           :param Xi: (Out) An existing Epetra_MultiVector.  On exit it will contain the imag part of the complex valued solution.
        """
        return _Komplex.Komplex_LinearProblem_ExtractSolution(self, *args)

    def KomplexProblem(self, *args) -> "Epetra_LinearProblem *":
        r"""
        Returns pointer to the Epetra_LinearProblem object that defines the Komplex formulation. The pointer returned from this method will contain the address of a fully-constructed Epetra_LinearProblem
             instance that can be used with any Trilinos preconditioner or solver.
        """
        return _Komplex.Komplex_LinearProblem_KomplexProblem(self, *args)

# Register Komplex_LinearProblem in _Komplex:
_Komplex.Komplex_LinearProblem_swigregister(Komplex_LinearProblem)


LinearProblem = Komplex_LinearProblem



