# This file was automatically generated by SWIG (http://www.swig.org).
# Version 4.0.2
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.

"""

PyTrilinos.LOCA.Bifurcation is the python interface to namespace Bifurcation
of the Trilinos continuation algorithm package LOCA:

    https://trilinos.org/docs/dev/packages/nox/doc/html/index.html

The purpose of LOCA.Bifurcation is to provide strategies for creating
bifurcation objects.  The python version of LOCA.Bifurcation supports
the following classes:

    * Factory  - Factory for creating bifurcation strategy objects

"""

from sys import version_info as _swig_python_version_info
if _swig_python_version_info < (2, 7, 0):
    raise RuntimeError("Python 2.7 or later required")

# Import the low-level C/C++ module
if __package__ or "." in __name__:
    from . import _Bifurcation
else:
    import _Bifurcation

try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)


def _swig_setattr_nondynamic_instance_variable(set):
    def set_instance_attr(self, name, value):
        if name == "thisown":
            self.this.own(value)
        elif name == "this":
            set(self, name, value)
        elif hasattr(self, name) and isinstance(getattr(type(self), name), property):
            set(self, name, value)
        else:
            raise AttributeError("You cannot add instance attributes to %s" % self)
    return set_instance_attr


def _swig_setattr_nondynamic_class_variable(set):
    def set_class_attr(cls, name, value):
        if hasattr(cls, name) and not isinstance(getattr(cls, name), property):
            set(cls, name, value)
        else:
            raise AttributeError("You cannot add class attributes to %s" % cls)
    return set_class_attr


def _swig_add_metaclass(metaclass):
    """Class decorator for adding a metaclass to a SWIG wrapped class - a slimmed down version of six.add_metaclass"""
    def wrapper(cls):
        return metaclass(cls.__name__, cls.__bases__, cls.__dict__.copy())
    return wrapper


class _SwigNonDynamicMeta(type):
    """Meta class to enforce nondynamic attributes (no new attributes) for a class"""
    __setattr__ = _swig_setattr_nondynamic_class_variable(type.__setattr__)


import weakref

import PyTrilinos.Teuchos.Base
from . import MultiContinuation
import PyTrilinos.NOX.Abstract
import PyTrilinos.Epetra
import Extended
from . import Parameter
class Factory(object):
    r"""
     Factory for creating bifurcation strategy objects
    The parameters passed to the create() through the ``bifurcationParams``
    argument method should specify the "Type" and "Formulation" as
    described below, as well as any additional parameters for the
    particular strategy.

    *  "Type" - Name of the bifurcation type. Valid choices are

         *  "None" - No bifurcation [Default]
         *  "Turning Point" Turning point bifurations
         *  "Pitchfork" Pitchfork bifurcations
         *  "Hopf" Hopf bifurcations
         *  "Phase Transition" Phase Transition points
         *  "User-Defined" User defined bifurcation.  Set
              "User-Defined Name" to be the parameter list name containing
              user-defined strategy, which must be of type
              Teuchos::RCP<LOCA::MultiContinuation::AbstractGroup>.

    *  "Formulation" - Name of the bifurcation formulation. Valid
         choices are

         *  For turning point bifurcations:

             *  "Moore-Spence" [Default]
                  (LOCA::TurningPoint::MooreSpence::ExtendedGroup)
             *  "Minimally Augmented"
                  (LOCA::TurningPoint::MinimallyAugmented::ExtendedGroup)

         *  For pitchfork bifurcations:

              *  "Moore-Spence" [Default]
                   (LOCA::Pitchfork::MooreSpence::ExtendedGroup)
              *  "Minimally Augmented"
                  (LOCA::Pitchfork::MinimallyAugmented::ExtendedGroup)

         *  For Hopf bifurcations:

              *  "Moore-Spence" [Default]
                   (LOCA::Hopf::MooreSpence::ExtendedGroup)
              *  "Minimally Augmented"
                  (LOCA::Hopf::MinimallyAugmented::ExtendedGroup)


    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r""" Constructor"""
        _Bifurcation.Factory_swiginit(self, _Bifurcation.new_Factory(*args))
    __swig_destroy__ = _Bifurcation.delete_Factory

    def create(self, *args) -> "Teuchos::RCP< LOCA::MultiContinuation::AbstractGroup >":
        r"""
         Create bifurcation strategy
        :type topParams: Teuchos::RCP< LOCA::Parameter::SublistParser >
        :param topParams: [in] Parsed top-level parameter list.
        :type bifurcationParams: :py:class:`ParameterList`
        :param bifurcationParams: [in] Bifurcation parameters as described above
        :type grp: :py:class:`AbstractGroup`
        :param grp: [in] Underlying group
        """
        return _Bifurcation.Factory_create(self, *args)

    def strategyName(self, *args) -> "std::string":
        r""" Return strategy name given by ``bifurcationParams``"""
        return _Bifurcation.Factory_strategyName(self, *args)

# Register Factory in _Bifurcation:
_Bifurcation.Factory_swigregister(Factory)



