# This file was automatically generated by SWIG (http://www.swig.org).
# Version 4.0.2
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.

"""

PyTrilinos.LOCA.BorderedSolver is the python interface to namespace
BorderedSolver of the Trilinos continuation algorithm package LOCA:

    https://trilinos.org/docs/dev/packages/nox/doc/html/index.html

The purpose of LOCA.BorderedSolver is to provide strategies for
solving bordered systems of equations.  The python version of
LOCA.BorderedSolver supports the following classes:

    * Factory  - Factory for creating BorderedSolver strategy objects

"""

from sys import version_info as _swig_python_version_info
if _swig_python_version_info < (2, 7, 0):
    raise RuntimeError("Python 2.7 or later required")

# Import the low-level C/C++ module
if __package__ or "." in __name__:
    from . import _BorderedSolver
else:
    import _BorderedSolver

try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)


def _swig_setattr_nondynamic_instance_variable(set):
    def set_instance_attr(self, name, value):
        if name == "thisown":
            self.this.own(value)
        elif name == "this":
            set(self, name, value)
        elif hasattr(self, name) and isinstance(getattr(type(self), name), property):
            set(self, name, value)
        else:
            raise AttributeError("You cannot add instance attributes to %s" % self)
    return set_instance_attr


def _swig_setattr_nondynamic_class_variable(set):
    def set_class_attr(cls, name, value):
        if hasattr(cls, name) and not isinstance(getattr(cls, name), property):
            set(cls, name, value)
        else:
            raise AttributeError("You cannot add class attributes to %s" % cls)
    return set_class_attr


def _swig_add_metaclass(metaclass):
    """Class decorator for adding a metaclass to a SWIG wrapped class - a slimmed down version of six.add_metaclass"""
    def wrapper(cls):
        return metaclass(cls.__name__, cls.__bases__, cls.__dict__.copy())
    return wrapper


class _SwigNonDynamicMeta(type):
    """Meta class to enforce nondynamic attributes (no new attributes) for a class"""
    __setattr__ = _swig_setattr_nondynamic_class_variable(type.__setattr__)


import weakref

import PyTrilinos.Teuchos.Base
class Factory(object):
    r"""
     Factory for creating %BorderedSolver strategy objects
    The parameters passed to the create() through the ``solverParams``
    argument method should specify the "Bordered Solver Method"
    as described below, as well as any additional parameters
    for the particular strategy.

    *  "Bordered Solver Method" - Name of the method. Valid choices are

      *  "Bordering" (LOCA::BorderedSolver::Bordering) [Default]
      *  "Nested" (LOCA::BorderedSolver::Nested)



    There are also %Epetra and %LAPACK specific strategies that can
    be instantiated by the LOCA::Epetra::Factory and LOCA::LAPACK::Factory.
    See LOCA::BorderedSolver::LAPACKDirectSolve,
    LOCA::BorderedSolver::EpetraHouseholder and
    LOCA::BorderedSolver::Epetra::Augmented.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r""" Constructor"""
        _BorderedSolver.Factory_swiginit(self, _BorderedSolver.new_Factory(*args))
    __swig_destroy__ = _BorderedSolver.delete_Factory

    def create(self, *args) -> "Teuchos::RCP< LOCA::BorderedSolver::AbstractStrategy >":
        r"""
         Create bordered system solver strategy
        :type topParams: Teuchos::RCP< LOCA::Parameter::SublistParser >
        :param topParams: [in] Parsed top-level parameter list.
        :type solverParams: :py:class:`ParameterList`
        :param solverParams: [in] Solver parameters as described above
        """
        return _BorderedSolver.Factory_create(self, *args)

    def strategyName(self, *args) -> "std::string const &":
        r""" Return strategy name given by ``solverParams``"""
        return _BorderedSolver.Factory_strategyName(self, *args)

# Register Factory in _BorderedSolver:
_BorderedSolver.Factory_swigregister(Factory)



