# This file was automatically generated by SWIG (http://www.swig.org).
# Version 4.0.2
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.

"""

PyTrilinos.LOCA.BorderedSystem is the python interface to namespace
BorderedSystem of the Trilinos continuation algorithm package LOCA:

    https://trilinos.org/docs/dev/packages/nox/doc/html/index.html

The purpose of LOCA.BorderedSystem is to provide an interface for
groups that are bordered systems.  The python version of
LOCA.BorderedSystem supports the following classes:

    * AbstractGroup  - Interface for groups that are bordered systems

"""

from sys import version_info as _swig_python_version_info
if _swig_python_version_info < (2, 7, 0):
    raise RuntimeError("Python 2.7 or later required")

# Import the low-level C/C++ module
if __package__ or "." in __name__:
    from . import _BorderedSystem
else:
    import _BorderedSystem

try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)


def _swig_setattr_nondynamic_instance_variable(set):
    def set_instance_attr(self, name, value):
        if name == "thisown":
            self.this.own(value)
        elif name == "this":
            set(self, name, value)
        elif hasattr(self, name) and isinstance(getattr(type(self), name), property):
            set(self, name, value)
        else:
            raise AttributeError("You cannot add instance attributes to %s" % self)
    return set_instance_attr


def _swig_setattr_nondynamic_class_variable(set):
    def set_class_attr(cls, name, value):
        if hasattr(cls, name) and not isinstance(getattr(cls, name), property):
            set(cls, name, value)
        else:
            raise AttributeError("You cannot add class attributes to %s" % cls)
    return set_class_attr


def _swig_add_metaclass(metaclass):
    """Class decorator for adding a metaclass to a SWIG wrapped class - a slimmed down version of six.add_metaclass"""
    def wrapper(cls):
        return metaclass(cls.__name__, cls.__bases__, cls.__dict__.copy())
    return wrapper


class _SwigNonDynamicMeta(type):
    """Meta class to enforce nondynamic attributes (no new attributes) for a class"""
    __setattr__ = _swig_setattr_nondynamic_class_variable(type.__setattr__)


import weakref

import PyTrilinos.Teuchos.Base
import PyTrilinos.NOX.Abstract
import PyTrilinos.Epetra
class AbstractGroup(PyTrilinos.NOX.Abstract.Group):
    r"""
    An interface for groups that are bordered systems

    This class provides an interface for groups whose Jacobian is of
    the form

    .. math::

        \begin{bmatrix}
                 J & A    \\
               B^T & C
            \end{bmatrix}
    where :math:`A` and :math:`B` are multivectors and :math:`C` is a dense
    matrix.  It provides methods for determining the width of the bordered
    rows/columns and for extracting these components.  It is intended
    to be a recusive interface, in that if the group representing
    :math:`J` also has this form, the extracted rows/columns should be
    the combined rows/columns of this group and the underlying group
    (and so on).
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _BorderedSystem.delete_AbstractGroup

    def getBorderedWidth(self, *args) -> "int":
        r""" Return the total width of the bordered rows/columns"""
        return _BorderedSystem.AbstractGroup_getBorderedWidth(self, *args)

    def getUnborderedGroup(self, *args) -> "Teuchos::RCP< NOX::Abstract::Group const >":
        r""" Get bottom-level unbordered group"""
        return _BorderedSystem.AbstractGroup_getUnborderedGroup(self, *args)

    def isCombinedAZero(self, *args) -> "bool":
        r""" Indicates whether combined A block is zero"""
        return _BorderedSystem.AbstractGroup_isCombinedAZero(self, *args)

    def isCombinedBZero(self, *args) -> "bool":
        r""" Indicates whether combined B block is zero"""
        return _BorderedSystem.AbstractGroup_isCombinedBZero(self, *args)

    def isCombinedCZero(self, *args) -> "bool":
        r""" Indicates whether combined C block is zero"""
        return _BorderedSystem.AbstractGroup_isCombinedCZero(self, *args)

    def extractSolutionComponent(self, *args) -> "void":
        r"""
        Given the vector ``v``, extract the underlying solution component
        corresponding to the unbordered group.
        """
        return _BorderedSystem.AbstractGroup_extractSolutionComponent(self, *args)

    def extractParameterComponent(self, *args) -> "void":
        r"""
        Given the vector ``v``, extract the parameter components of all
        of the nested subvectors in ``v`` down to the solution component
        for the unbordered group.
        """
        return _BorderedSystem.AbstractGroup_extractParameterComponent(self, *args)

    def loadNestedComponents(self, *args) -> "void":
        r"""
        Given the solution component ``v_x`` and combined parameter
        components ``v_p``, distribute these components through the nested
        sub-vectors in ``v``.
        """
        return _BorderedSystem.AbstractGroup_loadNestedComponents(self, *args)

    def fillA(self, *args) -> "void":
        r""" Fill the combined A block as described above"""
        return _BorderedSystem.AbstractGroup_fillA(self, *args)

    def fillB(self, *args) -> "void":
        r""" Fill the combined B block as described above"""
        return _BorderedSystem.AbstractGroup_fillB(self, *args)

    def fillC(self, *args) -> "void":
        r""" Fill the combined C block as described above"""
        return _BorderedSystem.AbstractGroup_fillC(self, *args)

# Register AbstractGroup in _BorderedSystem:
_BorderedSystem.AbstractGroup_swigregister(AbstractGroup)



