# This file was automatically generated by SWIG (http://www.swig.org).
# Version 4.0.2
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.

"""

PyTrilinos.LOCA.Epetra.Interface is the python interface to namespace
Epetra::Interface of the Trilinos continuation algorithm package LOCA:

    https://trilinos.org/docs/dev/packages/nox/doc/html/index.html

The purpose of LOCA.Epetra.Interface is to provide a concrete Epetra
implementation of LOCA interfaces.  The python version of
LOCA.Epetra.Interface supports the following classes:

    * Required                 - Provides a set of interfaces for users to
                                 provide information about the nonlinear
                                 problem to LOCA
    * MassMatrix               - Used by LOCA.Epetra.Group to provide a link
                                 to the external code for the coefficients of
                                 time dependent terms
    * TimeDependent            - Used by LOCA.Epetra.Group to provide a link
                                 to the external code for computing the shifted
                                 matrix
    * TimeDependentMatrixFree  - Used by LOCA.Epetra.Group to provide a link
                                 to the external code for applying the shifted
                                 matrix in a matrix-free setting

"""

from sys import version_info as _swig_python_version_info
if _swig_python_version_info < (2, 7, 0):
    raise RuntimeError("Python 2.7 or later required")

# Import the low-level C/C++ module
if __package__ or "." in __name__:
    from . import _Interface
else:
    import _Interface

try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)


def _swig_setattr_nondynamic_instance_variable(set):
    def set_instance_attr(self, name, value):
        if name == "thisown":
            self.this.own(value)
        elif name == "this":
            set(self, name, value)
        elif hasattr(self, name) and isinstance(getattr(type(self), name), property):
            set(self, name, value)
        else:
            raise AttributeError("You cannot add instance attributes to %s" % self)
    return set_instance_attr


def _swig_setattr_nondynamic_class_variable(set):
    def set_class_attr(cls, name, value):
        if hasattr(cls, name) and not isinstance(getattr(cls, name), property):
            set(cls, name, value)
        else:
            raise AttributeError("You cannot add class attributes to %s" % cls)
    return set_class_attr


def _swig_add_metaclass(metaclass):
    """Class decorator for adding a metaclass to a SWIG wrapped class - a slimmed down version of six.add_metaclass"""
    def wrapper(cls):
        return metaclass(cls.__name__, cls.__bases__, cls.__dict__.copy())
    return wrapper


class _SwigNonDynamicMeta(type):
    """Meta class to enforce nondynamic attributes (no new attributes) for a class"""
    __setattr__ = _swig_setattr_nondynamic_class_variable(type.__setattr__)


import weakref

class SwigPyIterator(object):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Interface.delete_SwigPyIterator

    def value(self) -> "PyObject *":
        return _Interface.SwigPyIterator_value(self)

    def incr(self, n: "size_t"=1) -> "swig::SwigPyIterator *":
        return _Interface.SwigPyIterator_incr(self, n)

    def decr(self, n: "size_t"=1) -> "swig::SwigPyIterator *":
        return _Interface.SwigPyIterator_decr(self, n)

    def distance(self, x: "SwigPyIterator") -> "ptrdiff_t":
        return _Interface.SwigPyIterator_distance(self, x)

    def equal(self, x: "SwigPyIterator") -> "bool":
        return _Interface.SwigPyIterator_equal(self, x)

    def copy(self) -> "swig::SwigPyIterator *":
        return _Interface.SwigPyIterator_copy(self)

    def next(self) -> "PyObject *":
        return _Interface.SwigPyIterator_next(self)

    def __next__(self) -> "PyObject *":
        return _Interface.SwigPyIterator___next__(self)

    def previous(self) -> "PyObject *":
        return _Interface.SwigPyIterator_previous(self)

    def advance(self, n: "ptrdiff_t") -> "swig::SwigPyIterator *":
        return _Interface.SwigPyIterator_advance(self, n)

    def __eq__(self, x: "SwigPyIterator") -> "bool":
        return _Interface.SwigPyIterator___eq__(self, x)

    def __ne__(self, x: "SwigPyIterator") -> "bool":
        return _Interface.SwigPyIterator___ne__(self, x)

    def __iadd__(self, n: "ptrdiff_t") -> "swig::SwigPyIterator &":
        return _Interface.SwigPyIterator___iadd__(self, n)

    def __isub__(self, n: "ptrdiff_t") -> "swig::SwigPyIterator &":
        return _Interface.SwigPyIterator___isub__(self, n)

    def __add__(self, n: "ptrdiff_t") -> "swig::SwigPyIterator *":
        return _Interface.SwigPyIterator___add__(self, n)

    def __sub__(self, *args) -> "ptrdiff_t":
        return _Interface.SwigPyIterator___sub__(self, *args)
    def __iter__(self):
        return self

# Register SwigPyIterator in _Interface:
_Interface.SwigPyIterator_swigregister(SwigPyIterator)

import PyTrilinos.Teuchos.Base
import PyTrilinos.NOX.Epetra.Interface
import Abstract
import PyTrilinos.Epetra
class Required(PyTrilinos.NOX.Epetra.Interface.Required):
    r"""
        Used by LOCA::Epetra::Group to provide a link to the
    external code for setting problem parameters.

        This interface is derived from the NOX::Epetra::Interface::Required
        and additionally provides a method for setting problem parameters.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r""" Constructor"""
        if self.__class__ == Required:
            _self = None
        else:
            _self = self
        _Interface.Required_swiginit(self, _Interface.new_Required(_self, *args))
    __swig_destroy__ = _Interface.delete_Required

    def setParameters(self, *args) -> "void":
        r"""
        Set parameters in the user's application.

        Should be called prior to calling one of the compute functions.
        """
        return _Interface.Required_setParameters(self, *args)

    def printSolution(self, *args) -> "void":
        r""" Call user's own print routine for vector-parameter pair"""
        return _Interface.Required_printSolution(self, *args)

    def dataForPrintSolution(self, *args) -> "void":
        r"""
        Provides data to application for output files.

        This routine is called from Interface::xyzt::printSolution() just
        before the call to Interface::Required::printSolution(x,param),
        and gives the application some indices that can be used for
        creating a unique name/index for the output files.
        """
        return _Interface.Required_dataForPrintSolution(self, *args)

    def setMultiPointParameter(self, *args) -> "void":
        r"""
        Set multipoint parameter in the user's application.

        Should be called prior to calling one of the compute functions.
        """
        return _Interface.Required_setMultiPointParameter(self, *args)

    def preProcessContinuationStep(self, *args) -> "void":
        r"""
         Perform any preprocessing before a continuation step starts.
        The ``stepStatus`` argument indicates whether the previous step was
        successful.  The default implementation here is empty.
        """
        return _Interface.Required_preProcessContinuationStep(self, *args)

    def postProcessContinuationStep(self, *args) -> "void":
        r"""
         Perform any postprocessing after a continuation step finishes.
        The ``stepStatus`` argument indicates whether the step was
        successful. The default implementation here is empty.
        """
        return _Interface.Required_postProcessContinuationStep(self, *args)

    def projectToDraw(self, *args) -> "void":
        r"""
        Projects solution to a few scalars for
        multiparameter continuation

        Default implementation is the max norm.
        """
        return _Interface.Required_projectToDraw(self, *args)

    def projectToDrawDimension(self, *args) -> "int":
        r""" Returns the dimension of the projection to draw array"""
        return _Interface.Required_projectToDrawDimension(self, *args)
    def __disown__(self):
        self.this.disown()
        _Interface.disown_Required(self)
        return weakref.proxy(self)

# Register Required in _Interface:
_Interface.Required_swigregister(Required)

class MassMatrix(object):
    r"""

    Used by LOCA::Epetra::Group to provide a link to the external code
    for the MassMatrix (coefficients of time dependent terms).

    This is used for Hopf bifurcation tracking, linear stability analysis,
    and space-time solutions (xyzt).
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r""" Constructor"""
        if self.__class__ == MassMatrix:
            _self = None
        else:
            _self = self
        _Interface.MassMatrix_swiginit(self, _Interface.new_MassMatrix(_self, *args))
    __swig_destroy__ = _Interface.delete_MassMatrix

    def computeMassMatrix(self, *args) -> "bool":
        r"""

        Compute MassMatrix given the specified input vector x.
        Returns true if computation was successful.
        """
        return _Interface.MassMatrix_computeMassMatrix(self, *args)

    def setOldSolution(self, *args) -> "void":
        r"""
        Routines used in XYZT to set the old solution,
        the one from the previous time step.

        There is a different routine for first step,
        where the old solution is set by the user and not part of the
        solution vector. These routines are used by space-time (xyzt)
        problems, where the residual vector is a function of the previous
        solution, which is also being solved for, and where the MassMatrix
        is calculated as a function of a different solution vector then
        the Jacobian (that is, the previous time step).
        The  timeStep  argument is sent so the use can set the global time,
        for cases when computeF, computeJacobian, computeMassMatrix fills
        are functions of time (nonautonomous systems).
        """
        return _Interface.MassMatrix_setOldSolution(self, *args)

    def setOldSolutionFirstStep(self, *args) -> "void":
        r""" See setOldSolution description."""
        return _Interface.MassMatrix_setOldSolutionFirstStep(self, *args)

    def dataForPrintSolution(self, *args) -> "void":
        r"""
        Provides data to application for output files.

        This routine is called from Interface::xyzt::printSolution() just
        before the call to Interface::Required::printSolution(x,param),
        and gives the application some indices that can be used for
        creating a unique name/index for the output files.
        """
        return _Interface.MassMatrix_dataForPrintSolution(self, *args)
    def __disown__(self):
        self.this.disown()
        _Interface.disown_MassMatrix(self)
        return weakref.proxy(self)

# Register MassMatrix in _Interface:
_Interface.MassMatrix_swigregister(MassMatrix)

class TimeDependent(Required):
    r"""
    Used by LOCA::Epetra::Group to provide a link to the
    external code for computing the shifted matrix.

    This interface is derived from the
    NOX::Epetra::Interface::Jacobian and additionally provides a
    method for computing the shifted matrix :math:`\alpha J + \beta M` .
    This is needed for linear stability analysis and Hopf tracking.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r""" Constructor"""
        if self.__class__ == TimeDependent:
            _self = None
        else:
            _self = self
        _Interface.TimeDependent_swiginit(self, _Interface.new_TimeDependent(_self, *args))
    __swig_destroy__ = _Interface.delete_TimeDependent

    def computeShiftedMatrix(self, *args) -> "bool":
        r"""
        Call user routine for computing the shifted matrix
        :math:`\alpha J + \beta M` where :math:`J` is the Jacobian matrix
        and :math:`M` is the mass matrix.
        """
        return _Interface.TimeDependent_computeShiftedMatrix(self, *args)

    def setXdot(self, *args) -> "void":
        r"""
        Routine used in XYZT to set x_dot and time in the interface.

        The computeF() routine for XYZT problems needs to be a function
        of x_dot, but th NOX/LOCA computeF() does not take x_dot as an
        argument. This is used to set x_dot in the application interface
        so the subsequent call to computeF has the correct x_dot value.
        The  timeStep  argument is sent so the use can set the global time,
        for cases when computeF, computeJacobian, computeMassMatrix fills
        are functions of time (nonautonomous systems).
        """
        return _Interface.TimeDependent_setXdot(self, *args)
    def __disown__(self):
        self.this.disown()
        _Interface.disown_TimeDependent(self)
        return weakref.proxy(self)

# Register TimeDependent in _Interface:
_Interface.TimeDependent_swigregister(TimeDependent)

class TimeDependentMatrixFree(Required):
    r"""
    Used by LOCA::Epetra::Group to provide a link to the
    external code for applying the shifted matrix in a matrix-free
    setting.

    This interface is derived from the
    NOX::Epetra::Interface::Required and additionally provides a
    method for applying the shifted matrix :math:`\alpha J + \beta M`.
    This is needed for linear stability analysis and Hopf tracking.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r""" Constructor"""
        if self.__class__ == TimeDependentMatrixFree:
            _self = None
        else:
            _self = self
        _Interface.TimeDependentMatrixFree_swiginit(self, _Interface.new_TimeDependentMatrixFree(_self, *args))
    __swig_destroy__ = _Interface.delete_TimeDependentMatrixFree

    def applyShiftedMatrix(self, *args) -> "bool":
        r"""
        Call user routine for applying the shifted matrix
        :math:`\alpha J + \beta M` where :math:`J` is the Jacobian matrix
        and :math:`M` is the mass matrix.
        """
        return _Interface.TimeDependentMatrixFree_applyShiftedMatrix(self, *args)
    def __disown__(self):
        self.this.disown()
        _Interface.disown_TimeDependentMatrixFree(self)
        return weakref.proxy(self)

# Register TimeDependentMatrixFree in _Interface:
_Interface.TimeDependentMatrixFree_swigregister(TimeDependentMatrixFree)



