# This file was automatically generated by SWIG (http://www.swig.org).
# Version 4.0.2
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.

"""

PyTrilinos.LOCA.Homotopy is the python interface to namespace Homotopy
of the Trilinos continuation algorithm package LOCA:

    https://trilinos.org/docs/dev/packages/nox/doc/html/index.html

The purpose of LOCA.Homotopy is to provide groups that allow for
Homotopy to be applied.  The python version of LOCA.Homotopy supports
the following classes:

    * Group          - LOCA's Homotopy algorithm
    * AbstractGroup  - Interface to underlying groups for homotopy calculations
    * DeflatedGroup  - LOCA's deflated Homotopy algorithm

"""

from sys import version_info as _swig_python_version_info
if _swig_python_version_info < (2, 7, 0):
    raise RuntimeError("Python 2.7 or later required")

# Import the low-level C/C++ module
if __package__ or "." in __name__:
    from . import _Homotopy
else:
    import _Homotopy

try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)


def _swig_setattr_nondynamic_instance_variable(set):
    def set_instance_attr(self, name, value):
        if name == "thisown":
            self.this.own(value)
        elif name == "this":
            set(self, name, value)
        elif hasattr(self, name) and isinstance(getattr(type(self), name), property):
            set(self, name, value)
        else:
            raise AttributeError("You cannot add instance attributes to %s" % self)
    return set_instance_attr


def _swig_setattr_nondynamic_class_variable(set):
    def set_class_attr(cls, name, value):
        if hasattr(cls, name) and not isinstance(getattr(cls, name), property):
            set(cls, name, value)
        else:
            raise AttributeError("You cannot add class attributes to %s" % cls)
    return set_class_attr


def _swig_add_metaclass(metaclass):
    """Class decorator for adding a metaclass to a SWIG wrapped class - a slimmed down version of six.add_metaclass"""
    def wrapper(cls):
        return metaclass(cls.__name__, cls.__bases__, cls.__dict__.copy())
    return wrapper


class _SwigNonDynamicMeta(type):
    """Meta class to enforce nondynamic attributes (no new attributes) for a class"""
    __setattr__ = _swig_setattr_nondynamic_class_variable(type.__setattr__)


import weakref

import PyTrilinos.Teuchos.Base
import PyTrilinos.NOX.Abstract
import PyTrilinos.Epetra
import MultiContinuation
import Extended
import BorderedSystem
class Group(MultiContinuation.AbstractGroup, Extended.MultiAbstractGroup):
    r"""
    %LOCA's Homotopy Algorithm.

    The %HomotopyGroup is a concrete implementation of the
    LOCA::Continuation::AbstractGroup that modifies the set of nonlinear
    equations to be solved to allow for Homotopy to be applied to the
    system.  This object should be used in conjunction with the
    LOCA::Stepper object to drive the continuation.  This algorithm solves
    a system of nonlinear equations supplied by the user (:math:`F(x)`)
    through continuation.  An artificial parameter :math:`\lambda` is used
    to control the continuation.  The idea is to solve a simple equation
    starting at :math:`\lambda` = 0 and, using the solution from the
    previous step, solve systems of equations that gets progressively
    closer to the true system of interest ( at :math:`\lambda` = 1.0 we
    recover the original equations :math:`F(x)`).  By constraining the
    definition of :math:`g(x, \lambda)` and using artificial parameter
    contiuation, the continuation branch should be free of multiplicity and
    bifurcation phenomena.

    The modified system of equations, :math:`g(x, \lambda)`, supplied by
    the HomotopyGroup is defined as:

    .. math::

        g(x, \lambda) = \lambda F(x) + (1.0 - \lambda)(x - a)

    where :math:`x` is the solution vector, :math:`\lambda` is an artificial
    parameter, :math:`F(x)` is the set of nonlinear equations the user
    supplies, :math:`g(x)` is the corresponding set of
    homotopy equations that LOCA will solve, and :math:`a` is a random
    vector.

    This group requires the loca Stepper for continuation
    from :math:`\lambda` = 0.0 (a simple set of equations to solve) to
    :math:`\lambda` = 1.0 (the set of equations requested by the user,
    :math:`F(x)`).  The Homotopy::Group will generate the Stepper parameter
    sublist in the parameter list that is passed in to the constructor.
    The user is free to modify this list (it sets default values) before
    passing it into the stepper object but should NOT change the starting
    and stopping values for the continuation parameter.

    References:

    - ALGORITHM 652 HOMPACK: A Suite of Codes for Globally Convergent
    Homotopy Algorithms, Watson, L.T., Billups, S.C, and Morgan, A.P.,
    ACM Transactions on Mathematical Software, Vol. 13, No. 3, September
    1987, pp281-310.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        *Overload 1:*

        Constructor to set the base group and generate the "%Stepper"
        sublist for homotopy continuation.

        The locaSublist variable is the "LOCA" sublist (of type
        Teuchos::ParameterList) that will be used in loca continuation runs.

        The variables scalarRandomVector and scalarInitialGuess are used to
        give some control over the generation of the random vector.  In
        certain instances we have seen the random vector force the solution
        to a set of variables that are unphysical and could break the
        function evaluations (cause them to return nan).  For example, in
        heat transfer problems, the temperature could be the dependent
        variable.  If the solution vector has an unphysical temperature (
        the random vector could force the temperature to negative or near
        zero values for the solution at :math:`\lambda = 0`) then property
        evaluations could break.  The random vector can be modified to keep
        the values near the initial guess based on values supplied to the
        constructor of the HomotopyGroup:

        .. math::

            a = abs(r) * \mbox{scalarRandom} + x_o * \mbox{scalarInitialGuess}

        where :math:`r` is the random vector generated by a call to
        NOX::Abstract::Vector::random(), :math:`\mbox{scalarRandom}` is a
        scalar value, :math:`x_o` is the initial guess to the solution
        vector, and :math:`\mbox{scalarInitialGuess}` is a scalar value.
        The defualt values force the random vector to be calculated as:

        .. math::

            a = abs(r)

        IMPORTANT: For homotopy to work correctly you should not change the
        starting and stopping parameter values (0.0 and 1.0 respectively) set
        in the "%Stepper" sublist.

        |

        *Overload 2:*
         Constructor with a user supplied random vector.

        |

        *Overload 3:*
         Copy constructor.
        """
        _Homotopy.Group_swiginit(self, _Homotopy.new_Group(*args))
    __swig_destroy__ = _Homotopy.delete_Group

    def clone(self, *args) -> "Teuchos::RCP< NOX::Abstract::Group >":
        r""" Cloning function"""
        return _Homotopy.Group_clone(self, *args)

    def setX(self, *args) -> "void":
        r""" Set the solution vector, x, to y."""
        return _Homotopy.Group_setX(self, *args)

    def computeX(self, *args) -> "void":
        r""" Compute this.x = grp.x + step * d."""
        return _Homotopy.Group_computeX(self, *args)

    def computeF(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r""" Compute the homotopy residual $g$"""
        return _Homotopy.Group_computeF(self, *args)

    def computeJacobian(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r""" Compute the Jacobian derivative of the homotopy residual $g$"""
        return _Homotopy.Group_computeJacobian(self, *args)

    def computeGradient(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r""" Compute gradient of homotopy residual $g$"""
        return _Homotopy.Group_computeGradient(self, *args)

    def computeNewton(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r""" Compute %Newton direction using applyJacobianInverse"""
        return _Homotopy.Group_computeNewton(self, *args)

    def applyJacobian(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r""" Computes the homotopy Jacobian vector product"""
        return _Homotopy.Group_applyJacobian(self, *args)

    def applyJacobianTranspose(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r""" Computes the homotopy Jacobian-transpose vector product"""
        return _Homotopy.Group_applyJacobianTranspose(self, *args)

    def applyJacobianInverse(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r""" Applies the inverse of the homotopy Jacobian matrix"""
        return _Homotopy.Group_applyJacobianInverse(self, *args)

    def applyJacobianMultiVector(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r""" Applies Jacobian for homotopy system"""
        return _Homotopy.Group_applyJacobianMultiVector(self, *args)

    def applyJacobianTransposeMultiVector(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r""" Applies Jacobian-transpose for homotopy system"""
        return _Homotopy.Group_applyJacobianTransposeMultiVector(self, *args)

    def applyJacobianInverseMultiVector(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r""" Applies Jacobian inverse for homotopy system"""
        return _Homotopy.Group_applyJacobianInverseMultiVector(self, *args)

    def isF(self, *args) -> "bool":
        r""" Return ``true`` if the homotopy residual :math:`g` is valid."""
        return _Homotopy.Group_isF(self, *args)

    def isJacobian(self, *args) -> "bool":
        r""" Return ``true`` if the homotopy Jacobian is valid."""
        return _Homotopy.Group_isJacobian(self, *args)

    def isGradient(self, *args) -> "bool":
        r"""  Return ``true`` if the homotopy gradient is valid."""
        return _Homotopy.Group_isGradient(self, *args)

    def isNewton(self, *args) -> "bool":
        r""" Return ``true`` if the homotopy Newton direction is valid."""
        return _Homotopy.Group_isNewton(self, *args)

    def getX(self, *args) -> "NOX::Abstract::Vector const &":
        r""" Return homotopy solution vector :math:`x`."""
        return _Homotopy.Group_getX(self, *args)

    def getF(self, *args) -> "NOX::Abstract::Vector const &":
        r""" Return homotopy residual :math:`g`"""
        return _Homotopy.Group_getF(self, *args)

    def getNormF(self, *args) -> "double":
        r""" Return 2-norm of :math:`g`."""
        return _Homotopy.Group_getNormF(self, *args)

    def getGradient(self, *args) -> "NOX::Abstract::Vector const &":
        r""" Return homotopy gradient"""
        return _Homotopy.Group_getGradient(self, *args)

    def getNewton(self, *args) -> "NOX::Abstract::Vector const &":
        r""" Return homotopy Newton direction."""
        return _Homotopy.Group_getNewton(self, *args)

    def getUnderlyingGroup(self, *args) -> "Teuchos::RCP< LOCA::MultiContinuation::AbstractGroup >":
        r"""
        *Overload 1:*
        Return underlying group

        |

        *Overload 2:*
        Return underlying group
        """
        return _Homotopy.Group_getUnderlyingGroup(self, *args)

    def copy(self, *args) -> "void":
        r""" Assignment"""
        return _Homotopy.Group_copy(self, *args)

    def setParamsMulti(self, *args) -> "void":
        r""" Set parameters indexed by (integer) paramIDs"""
        return _Homotopy.Group_setParamsMulti(self, *args)

    def setParams(self, *args) -> "void":
        r""" Set the parameter vector in the group to p."""
        return _Homotopy.Group_setParams(self, *args)

    def setParam(self, *args) -> "void":
        r"""
        *Overload 1:*
        Set parameter indexed by paramID

        |

        *Overload 2:*
        Set parameter indexed by paramID
        """
        return _Homotopy.Group_setParam(self, *args)

    def getParams(self, *args) -> "LOCA::ParameterVector const &":
        r""" Return a const reference to the paramter vector owned by the group."""
        return _Homotopy.Group_getParams(self, *args)

    def getParam(self, *args) -> "double":
        r"""
        *Overload 1:*
        Return copy of parameter indexed by paramID

        |

        *Overload 2:*
        Return copy of parameter indexed by paramID
        """
        return _Homotopy.Group_getParam(self, *args)

    def computeDfDpMulti(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r"""
        Compute :math:`\partial F/\partial p` for each parameter :math:`p`
        indexed by paramIDs.  The first column of *dfdp* holds F,
        which is valid if *isValidF* is true.  Otherwise F must be
        computed.
        """
        return _Homotopy.Group_computeDfDpMulti(self, *args)

    def preProcessContinuationStep(self, *args) -> "void":
        r"""
         Perform any preprocessing before a continuation step starts.
        The ``stepStatus`` argument indicates whether the previous step was
        successful.
        """
        return _Homotopy.Group_preProcessContinuationStep(self, *args)

    def postProcessContinuationStep(self, *args) -> "void":
        r"""
         Perform any postprocessing after a continuation step finishes.
        The ``stepStatus`` argument indicates whether the step was
        successful.
        """
        return _Homotopy.Group_postProcessContinuationStep(self, *args)

    def projectToDraw(self, *args) -> "void":
        r""" Projects solution to a few scalars for multiparameter continuation"""
        return _Homotopy.Group_projectToDraw(self, *args)

    def projectToDrawDimension(self, *args) -> "int":
        r""" Returns the dimension of the project to draw array"""
        return _Homotopy.Group_projectToDrawDimension(self, *args)

    def printSolution(self, *args) -> "void":
        r"""
        *Overload 1:*

        Function to print out solution and continuation
        parameter after successful continuation step.

        |

        *Overload 2:*

        Function to print out solution and continuation
        parameter after successful continuation step.
        """
        return _Homotopy.Group_printSolution(self, *args)

# Register Group in _Homotopy:
_Homotopy.Group_swigregister(Group)

class AbstractGroup(MultiContinuation.AbstractGroup):
    r"""
    Interface to underlying groups for homotopy calculations

    This abstract class provides an interface for a homotopy technique
    for solving nonlinear equations.  See LOCA::Homotopy::Group for a
    description of the technique used.  This class provides a single
    pure virtual method, augmentJacobianForHomotopy(), which scales the
    diagonal of the Jacobian by a constant times the identity matrix.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Homotopy.delete_AbstractGroup

    def augmentJacobianForHomotopy(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r"""
        Replace Jacobian :math:`J` by :math:`aJ+bI` where :math:`I` is
        the identity matrix
        """
        return _Homotopy.AbstractGroup_augmentJacobianForHomotopy(self, *args)

# Register AbstractGroup in _Homotopy:
_Homotopy.AbstractGroup_swigregister(AbstractGroup)

class DeflatedGroup(Extended.MultiAbstractGroup, MultiContinuation.AbstractGroup, BorderedSystem.AbstractGroup):
    r"""
    %LOCA's Homotopy Algorithm.

    The %HomotopyGroup is a concrete implementation of the
    LOCA::Continuation::AbstractGroup that modifies the set of nonlinear
    equations to be solved to allow for Homotopy to be applied to the
    system.  This object should be used in conjunction with the
    LOCA::Stepper object to drive the continuation.  This algorithm solves
    a system of nonlinear equations supplied by the user (:math:`F(x)`)
    through continuation.  An artificial parameter :math:`\lambda` is used
    to control the continuation.  The idea is to solve a simple equation
    starting at :math:`\lambda` = 0 and, using the solution from the
    previous step, solve systems of equations that gets progressively
    closer to the true system of interest ( at :math:`\lambda` = 1.0 we
    recover the original equations :math:`F(x)`).  By constraining the
    definition of :math:`g(x, \lambda)` and using artificial parameter
    contiuation, the continuation branch should be free of multiplicity and
    bifurcation phenomena.

    The modified system of equations, :math:`g(x, \lambda)`, supplied by
    the HomotopyGroup is defined as:

    .. math::

        g(x, \lambda) = \lambda F(x) + (1.0 - \lambda)(x - a)(S)

    where :math:`x` is the solution vector, :math:`\lambda` is an artificial
    parameter, :math:`F(x)` is the set of nonlinear equations the user
    supplies, :math:`g(x)` is the corresponding set of
    homotopy equations that LOCA will solve, :math:`a` is a random
    vector, and  :math:`S` is a scaling factor used to switch sign of
    the last term (typically valued 1.0 or -1.0).

    This group requires the loca Stepper for continuation
    from :math:`\lambda` = 0.0 (a simple set of equations to solve) to
    :math:`\lambda` = 1.0 (the set of equations requested by the user,
    :math:`F(x)`).  The Homotopy::Group will generate the Stepper parameter
    sublist in the parameter list that is passed in to the constructor.
    The user is free to modify this list (it sets default values) before
    passing it into the stepper object but should NOT change the starting
    and stopping values for the continuation parameter.

    References:

    - ALGORITHM 652 HOMPACK: A Suite of Codes for Globally Convergent
    Homotopy Algorithms, Watson, L.T., Billups, S.C, and Morgan, A.P.,
    ACM Transactions on Mathematical Software, Vol. 13, No. 3, September
    1987, pp281-310.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        *Overload 1:*
         Constructor
        :type global_data: Teuchos::RCP< LOCA::GlobalData >
        :param global_data: [in] Global data object
        :type topParams: :py:class:`ParameterList`
        :param topParams: [in] Parsed top-level parameter list.
        :type hParams: :py:class:`ParameterList`
        :param hParams: [in] Homotopy parameters
        :type grp: :py:class:`AbstractGroup`
        :param grp: [in] Group representing :math:`f`.

        |

        *Overload 2:*
         Copy constructor
        """
        _Homotopy.DeflatedGroup_swiginit(self, _Homotopy.new_DeflatedGroup(*args))
    __swig_destroy__ = _Homotopy.delete_DeflatedGroup

    def getHomotopyParam(self, *args) -> "double":
        r""" Get homotopy parameter"""
        return _Homotopy.DeflatedGroup_getHomotopyParam(self, *args)

    def clone(self, *args) -> "Teuchos::RCP< NOX::Abstract::Group >":
        r""" Clone function"""
        return _Homotopy.DeflatedGroup_clone(self, *args)

    def setX(self, *args) -> "void":
        r""" Set the solution vector to y."""
        return _Homotopy.DeflatedGroup_setX(self, *args)

    def computeX(self, *args) -> "void":
        r"""
        Compute and return solution vector, x, where
        this.x = grp.x + step * d.
        """
        return _Homotopy.DeflatedGroup_computeX(self, *args)

    def computeF(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r""" Compute extended continuation equations"""
        return _Homotopy.DeflatedGroup_computeF(self, *args)

    def computeJacobian(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r""" Compute extended continuation jacobian"""
        return _Homotopy.DeflatedGroup_computeJacobian(self, *args)

    def computeGradient(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r""" Gradient is not defined for this system"""
        return _Homotopy.DeflatedGroup_computeGradient(self, *args)

    def computeNewton(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r""" Compute Newton direction for extended continuation system"""
        return _Homotopy.DeflatedGroup_computeNewton(self, *args)

    def applyJacobian(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r""" Applies Jacobian for extended system"""
        return _Homotopy.DeflatedGroup_applyJacobian(self, *args)

    def applyJacobianTranspose(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r""" Jacobian transpose not defined for this system"""
        return _Homotopy.DeflatedGroup_applyJacobianTranspose(self, *args)

    def applyJacobianInverse(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r""" Applies Jacobian inverse for extended system"""
        return _Homotopy.DeflatedGroup_applyJacobianInverse(self, *args)

    def applyJacobianMultiVector(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r""" Applies Jacobian for extended system"""
        return _Homotopy.DeflatedGroup_applyJacobianMultiVector(self, *args)

    def applyJacobianTransposeMultiVector(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r""" Jacobian transpose not defined for this system"""
        return _Homotopy.DeflatedGroup_applyJacobianTransposeMultiVector(self, *args)

    def applyJacobianInverseMultiVector(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r""" Applies Jacobian inverse for extended system"""
        return _Homotopy.DeflatedGroup_applyJacobianInverseMultiVector(self, *args)

    def isF(self, *args) -> "bool":
        r""" Return ``true`` if extended residual is valid."""
        return _Homotopy.DeflatedGroup_isF(self, *args)

    def isJacobian(self, *args) -> "bool":
        r""" Return ``true`` if the extended Jacobian is valid."""
        return _Homotopy.DeflatedGroup_isJacobian(self, *args)

    def isGradient(self, *args) -> "bool":
        r""" Always returns false"""
        return _Homotopy.DeflatedGroup_isGradient(self, *args)

    def isNewton(self, *args) -> "bool":
        r""" Return ``true`` if the extended Newton direction is valid"""
        return _Homotopy.DeflatedGroup_isNewton(self, *args)

    def getX(self, *args) -> "NOX::Abstract::Vector const &":
        r""" Return extended solution vector."""
        return _Homotopy.DeflatedGroup_getX(self, *args)

    def getF(self, *args) -> "NOX::Abstract::Vector const &":
        r""" Return extended residual"""
        return _Homotopy.DeflatedGroup_getF(self, *args)

    def getNormF(self, *args) -> "double":
        r""" Return 2-norm of extended residual."""
        return _Homotopy.DeflatedGroup_getNormF(self, *args)

    def getGradient(self, *args) -> "NOX::Abstract::Vector const &":
        r""" Gradient is never valid"""
        return _Homotopy.DeflatedGroup_getGradient(self, *args)

    def getNewton(self, *args) -> "NOX::Abstract::Vector const &":
        r""" Return extended Newton direction."""
        return _Homotopy.DeflatedGroup_getNewton(self, *args)

    def getNormNewtonSolveResidual(self, *args) -> "double":
        r""" Returns 2-norm of extended Newton solve residual"""
        return _Homotopy.DeflatedGroup_getNormNewtonSolveResidual(self, *args)

    def getUnderlyingGroup(self, *args) -> "Teuchos::RCP< LOCA::MultiContinuation::AbstractGroup >":
        r"""
        *Overload 1:*
        Return underlying group

        |

        *Overload 2:*
        Return underlying group
        """
        return _Homotopy.DeflatedGroup_getUnderlyingGroup(self, *args)

    def copy(self, *args) -> "void":
        r""" Assignment operator"""
        return _Homotopy.DeflatedGroup_copy(self, *args)

    def setParamsMulti(self, *args) -> "void":
        r""" Set parameters indexed by (integer) paramIDs"""
        return _Homotopy.DeflatedGroup_setParamsMulti(self, *args)

    def setParams(self, *args) -> "void":
        r""" Set the parameter vector in the group to p (pVector = p)."""
        return _Homotopy.DeflatedGroup_setParams(self, *args)

    def setParam(self, *args) -> "void":
        r"""
        *Overload 1:*
        Set parameter indexed by (integer) paramID

        |

        *Overload 2:*
        Set parameter indexed by (std::string) paramID
        """
        return _Homotopy.DeflatedGroup_setParam(self, *args)

    def getParams(self, *args) -> "LOCA::ParameterVector const &":
        r""" Return a const reference to the ParameterVector owned by the group."""
        return _Homotopy.DeflatedGroup_getParams(self, *args)

    def getParam(self, *args) -> "double":
        r"""
        *Overload 1:*
        Return copy of parameter indexed by (integer) paramID

        |

        *Overload 2:*
        Return copy of parameter indexed by (std::string) paramID
        """
        return _Homotopy.DeflatedGroup_getParam(self, *args)

    def computeDfDpMulti(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r"""
        Compute :math:`\partial F/\partial p` for each parameter :math:`p`
        indexed by paramIDs.  The first column of *dfdp* holds F,
        which is valid if *isValidF* is true.  Otherwise F must be
        computed.
        """
        return _Homotopy.DeflatedGroup_computeDfDpMulti(self, *args)

    def preProcessContinuationStep(self, *args) -> "void":
        r"""
         Perform any preprocessing before a continuation step starts.
        The ``stepStatus`` argument indicates whether the previous step was
        successful.
        """
        return _Homotopy.DeflatedGroup_preProcessContinuationStep(self, *args)

    def postProcessContinuationStep(self, *args) -> "void":
        r"""
         Perform any postprocessing after a continuation step finishes.
        The ``stepStatus`` argument indicates whether the step was
        successful.
        """
        return _Homotopy.DeflatedGroup_postProcessContinuationStep(self, *args)

    def projectToDraw(self, *args) -> "void":
        r""" Projects solution to a few scalars for multiparameter continuation"""
        return _Homotopy.DeflatedGroup_projectToDraw(self, *args)

    def projectToDrawDimension(self, *args) -> "int":
        r""" Returns the dimension of the project to draw array"""
        return _Homotopy.DeflatedGroup_projectToDrawDimension(self, *args)

    def computeScaledDotProduct(self, *args) -> "double":
        r""" Compute a scaled dot product"""
        return _Homotopy.DeflatedGroup_computeScaledDotProduct(self, *args)

    def printSolution(self, *args) -> "void":
        r"""
        *Overload 1:*
        Function to print out solution and parameter after successful step

        |

        *Overload 2:*
        Function to print out a vector and parameter after successful step
        """
        return _Homotopy.DeflatedGroup_printSolution(self, *args)

    def scaleVector(self, *args) -> "void":
        r""" Scales a vector using scaling vector"""
        return _Homotopy.DeflatedGroup_scaleVector(self, *args)

    def getBorderedWidth(self, *args) -> "int":
        r""" Return the total width of the bordered rows/columns"""
        return _Homotopy.DeflatedGroup_getBorderedWidth(self, *args)

    def getUnborderedGroup(self, *args) -> "Teuchos::RCP< NOX::Abstract::Group const >":
        r""" Get bottom-level unbordered group"""
        return _Homotopy.DeflatedGroup_getUnborderedGroup(self, *args)

    def isCombinedAZero(self, *args) -> "bool":
        r""" Indicates whether combined A block is zero"""
        return _Homotopy.DeflatedGroup_isCombinedAZero(self, *args)

    def isCombinedBZero(self, *args) -> "bool":
        r""" Indicates whether combined B block is zero"""
        return _Homotopy.DeflatedGroup_isCombinedBZero(self, *args)

    def isCombinedCZero(self, *args) -> "bool":
        r""" Indicates whether combined C block is zero"""
        return _Homotopy.DeflatedGroup_isCombinedCZero(self, *args)

    def extractSolutionComponent(self, *args) -> "void":
        r"""
        Given the vector ``v``, extract the underlying solution component
        corresponding to the unbordered group.
        """
        return _Homotopy.DeflatedGroup_extractSolutionComponent(self, *args)

    def extractParameterComponent(self, *args) -> "void":
        r"""
        Given the vector ``v``, extract the parameter components of all
        of the nested subvectors in ``v`` down to the solution component
        for the unbordered group.
        """
        return _Homotopy.DeflatedGroup_extractParameterComponent(self, *args)

    def loadNestedComponents(self, *args) -> "void":
        r"""
        Given the solution component ``v_x`` and combined parameter
        components ``v_p``, distribute these components through the nested
        sub-vectors in ``v``.
        """
        return _Homotopy.DeflatedGroup_loadNestedComponents(self, *args)

    def fillA(self, *args) -> "void":
        r""" Fill the combined A block as described above"""
        return _Homotopy.DeflatedGroup_fillA(self, *args)

    def fillB(self, *args) -> "void":
        r""" Fill the combined B block as described above"""
        return _Homotopy.DeflatedGroup_fillB(self, *args)

    def fillC(self, *args) -> "void":
        r""" Fill the combined C block as described above"""
        return _Homotopy.DeflatedGroup_fillC(self, *args)

# Register DeflatedGroup in _Homotopy:
_Homotopy.DeflatedGroup_swigregister(DeflatedGroup)



