# This file was automatically generated by SWIG (http://www.swig.org).
# Version 4.0.2
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.

from sys import version_info as _swig_python_version_info
if _swig_python_version_info < (2, 7, 0):
    raise RuntimeError("Python 2.7 or later required")


from . import _Base
import PyTrilinos.Teuchos.Base
import PyTrilinos.NOX.Abstract
import PyTrilinos.Epetra
from PyTrilinos.LOCA import Extended


try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)


def _swig_setattr_nondynamic_instance_variable(set):
    def set_instance_attr(self, name, value):
        if name == "thisown":
            self.this.own(value)
        elif name == "this":
            set(self, name, value)
        elif hasattr(self, name) and isinstance(getattr(type(self), name), property):
            set(self, name, value)
        else:
            raise AttributeError("You cannot add instance attributes to %s" % self)
    return set_instance_attr


def _swig_setattr_nondynamic_class_variable(set):
    def set_class_attr(cls, name, value):
        if hasattr(cls, name) and not isinstance(getattr(cls, name), property):
            set(cls, name, value)
        else:
            raise AttributeError("You cannot add class attributes to %s" % cls)
    return set_class_attr


def _swig_add_metaclass(metaclass):
    """Class decorator for adding a metaclass to a SWIG wrapped class - a slimmed down version of six.add_metaclass"""
    def wrapper(cls):
        return metaclass(cls.__name__, cls.__bases__, cls.__dict__.copy())
    return wrapper


class _SwigNonDynamicMeta(type):
    """Meta class to enforce nondynamic attributes (no new attributes) for a class"""
    __setattr__ = _swig_setattr_nondynamic_class_variable(type.__setattr__)


import weakref

import PyTrilinos.Teuchos.Base
import PyTrilinos.NOX.Abstract
import PyTrilinos.Epetra
import Extended
class ComplexMultiVector(Extended.MultiVector):
    r"""
    Multi-vector class to hold two multi-vectors to represent a
    complex multi-vector.

    This is not a true complex multi-vector.  Operations like dot()
    and multiply() are not correct for complex vectors.  This class
    exists to make some aspects of the real-equivalent formulation of
    complex linear algebra simpler to implement.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        *Overload 1:*
         Constructor.
        Generates a multivector with *nColumns* columns from *cloneVec*

        |

        *Overload 2:*
         Constructor.

        |

        *Overload 3:*
         Copy constructor.

        |

        *Overload 4:*

        Copy constructor that creates a new multivector with
        *nColumns* columns.

        |

        *Overload 5:*

        Copy constructor that creates a sub copy or view of the
        given multivector
        """
        _Base.ComplexMultiVector_swiginit(self, _Base.new_ComplexMultiVector(*args))
    __swig_destroy__ = _Base.delete_ComplexMultiVector

    def clone(self, *args) -> "Teuchos::RCP< NOX::Abstract::MultiVector >":
        r"""
        Create a new multi-vector of the same underlying type by
        cloning "this", and return a pointer to the new vector.
        """
        return _Base.ComplexMultiVector_clone(self, *args)

    def subCopy(self, *args) -> "Teuchos::RCP< NOX::Abstract::MultiVector >":
        r"""
        Creates a new multi-vector with ``index.size()`` columns
        whose columns are copies of the columns of ``*this`` given by
        ``index``.
        """
        return _Base.ComplexMultiVector_subCopy(self, *args)

    def subView(self, *args) -> "Teuchos::RCP< NOX::Abstract::MultiVector >":
        r"""
        Creates a new multi-vector with ``index.size()`` columns that
        shares the columns of ``*this`` given by ``index``.
        """
        return _Base.ComplexMultiVector_subView(self, *args)

    def getRealMultiVec(self, *args) -> "Teuchos::RCP< NOX::Abstract::MultiVector >":
        r"""
        *Overload 1:*
        Returns the real component of extended multivector

        |

        *Overload 2:*
        Returns the real component of extended multivector
        """
        return _Base.ComplexMultiVector_getRealMultiVec(self, *args)

    def getImagMultiVec(self, *args) -> "Teuchos::RCP< NOX::Abstract::MultiVector >":
        r"""
        *Overload 1:*
        Returns the imaginary component of extended multivector

        |

        *Overload 2:*
        Returns the imaginary component of extended multivector
        """
        return _Base.ComplexMultiVector_getImagMultiVec(self, *args)

    def getColumn(self, *args) -> "Teuchos::RCP< LOCA::Hopf::ComplexVector const >":
        r"""
        *Overload 1:*
        Returns ith column as an extended vector

        |

        *Overload 2:*
        Returns ith column as an extended vector
        """
        return _Base.ComplexMultiVector_getColumn(self, *args)

# Register ComplexMultiVector in _Base:
_Base.ComplexMultiVector_swigregister(ComplexMultiVector)

class ComplexVector(Extended.Vector):
    r"""
    %Vector class to hold two vectors to represent a complex vector.

    This is not a true complex vector.  Operations like innerProduct()
    are not correct for complex vectors.  This class
    exists to make some aspects of the real-equivalent formulation of
    complex linear algebra simpler to implement.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        *Overload 1:*
        Constructor.

        |

        *Overload 2:*
        Copy constructor.
        """
        _Base.ComplexVector_swiginit(self, _Base.new_ComplexVector(*args))
    __swig_destroy__ = _Base.delete_ComplexVector

    def clone(self, *args) -> "Teuchos::RCP< NOX::Abstract::Vector >":
        r""" Cloning function"""
        return _Base.ComplexVector_clone(self, *args)

    def setVec(self, *args) -> "void":
        r""" Sets the vector by setting its components"""
        return _Base.ComplexVector_setVec(self, *args)

    def getRealVec(self, *args) -> "Teuchos::RCP< NOX::Abstract::Vector >":
        r"""
        *Overload 1:*
        Returns the real component of extended vector

        |

        *Overload 2:*
        Returns the real component of extended vector
        """
        return _Base.ComplexVector_getRealVec(self, *args)

    def getImagVec(self, *args) -> "Teuchos::RCP< NOX::Abstract::Vector >":
        r"""
        *Overload 1:*
        Returns the imaginary component of extended vector

        |

        *Overload 2:*
        Returns the imaginary component of extended vector
        """
        return _Base.ComplexVector_getImagVec(self, *args)

# Register ComplexVector in _Base:
_Base.ComplexVector_swigregister(ComplexVector)



