# This file was automatically generated by SWIG (http://www.swig.org).
# Version 4.0.2
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.

"""

PyTrilinos.LOCA.Hopf.MinimallyAugmented is the python interface to
namespace Hopf::MinimallyAugmented of the Trilinos continuation
algorithm package LOCA:

    https://trilinos.org/docs/dev/packages/nox/doc/html/index.html

The purpose of LOCA.Hopf.MinimallyAugmented is to provide groups and
vectors for locating Hopf bifurcations using the minimally augmented
Hopf formulation.  The python version of LOCA.Hopf.MinimallyAugmented
supports the following classes:

    * Constraint             - Implementation of LOCA.MultiContinuation.-
                               ConstraintInterfaceMVDX for computing Hopf
                               bifurcations for the minimally augmented Hopf
                               formulation
    * AbstractGroup          - Interface to underlying groups for Hopf
                               calculations using the minimally augmented
                               formulation
    * FiniteDifferenceGroup  - Concrete class that provides concrete
                               implementations of the derivative computation
                               methods of the LOCA.Hopf.MinimallyAugmented.-
                               AbstractGroup using first-order finite
                               differencing
    * ExtendedGroup          - Group representing the minimally augemented Hopf
                               equations

"""

from sys import version_info as _swig_python_version_info
if _swig_python_version_info < (2, 7, 0):
    raise RuntimeError("Python 2.7 or later required")


from . import _MinimallyAugmented
import PyTrilinos.Teuchos.Base
import PyTrilinos.NOX.Abstract
import PyTrilinos.Epetra
from PyTrilinos.LOCA import BorderedSystem
from PyTrilinos.LOCA import Extended
from PyTrilinos.LOCA import MultiContinuation
from PyTrilinos.LOCA import TimeDependent
from PyTrilinos.LOCA import TurningPoint
from . import MooreSpence


try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)


def _swig_setattr_nondynamic_instance_variable(set):
    def set_instance_attr(self, name, value):
        if name == "thisown":
            self.this.own(value)
        elif name == "this":
            set(self, name, value)
        elif hasattr(self, name) and isinstance(getattr(type(self), name), property):
            set(self, name, value)
        else:
            raise AttributeError("You cannot add instance attributes to %s" % self)
    return set_instance_attr


def _swig_setattr_nondynamic_class_variable(set):
    def set_class_attr(cls, name, value):
        if hasattr(cls, name) and not isinstance(getattr(cls, name), property):
            set(cls, name, value)
        else:
            raise AttributeError("You cannot add class attributes to %s" % cls)
    return set_class_attr


def _swig_add_metaclass(metaclass):
    """Class decorator for adding a metaclass to a SWIG wrapped class - a slimmed down version of six.add_metaclass"""
    def wrapper(cls):
        return metaclass(cls.__name__, cls.__bases__, cls.__dict__.copy())
    return wrapper


class _SwigNonDynamicMeta(type):
    """Meta class to enforce nondynamic attributes (no new attributes) for a class"""
    __setattr__ = _swig_setattr_nondynamic_class_variable(type.__setattr__)


import weakref

import PyTrilinos.Teuchos.Base
import PyTrilinos.NOX.Abstract
import PyTrilinos.Epetra
import BorderedSystem
import Extended
import MultiContinuation
import TimeDependent
import TurningPoint.MooreSpence
import MooreSpence
class Constraint(MultiContinuation.ConstraintInterfaceMVDX):
    r"""
    Implementation of
    LOCA::MultiContinuation::ConstraintInterfaceMVDX for computing
    Hopf bifurcations for the minimally augmented Hopf formulation.

    This class implements the turning point constraint equation
    :math:`\sigma(x,p,\omega) = 0` for the minimally augmented Hopf
    formulation where :math:`\sigma` is defined via

    .. math::

        \begin{bmatrix}
              J+i\omega M & a \\
              b^H         & 0
            \end{bmatrix}
            \begin{bmatrix}
              v \\
              \sigma_1
            \end{bmatrix} =
            \begin{bmatrix}
              0 \\
              n
            \end{bmatrix},

    .. math::

        \begin{bmatrix}
              J^T-i\omega M^T & b \\
              a^H             & 0
            \end{bmatrix}
            \begin{bmatrix}
              w \\
              \sigma_2
            \end{bmatrix} =
            \begin{bmatrix}
              0 \\
              n
            \end{bmatrix},

    .. math::

        \sigma = w^H J+i\omega M v/n
    for any vectors :math:`a` and :math:`b` in :math:`\mathbb{C}^n`.  Using
    these relationships, it is easy to show

    .. math::

        \begin{split}
               \sigma_x &= (w^H(J+i\omega M)v)_x/n = w^H(J+i\omega M)_x v/n \\
               \sigma_p &= (w^H(J+i\omega M)v)_p/n = w^H(J+i\omega M)_p v/n
            \end{split}

    The class is intialized via the ``hpfParams`` parameter list argument
    to the constructor.  The parameters this class recognizes are:

    *  "Update Null Vectors Every Continuation Step"  --
       [bool] (default: true) -
       Flag indicating whether to update :math:`a` and :math:`b` vectors via
       :math:`a = w` and :math:`b = v` every continuation step
    *  "Update Null Vectors Every Nonlinear Iteration"  --
       [bool] (default: false) -
       Flag indicating whether to update :math:`a` and :math:`b` vectors via
       :math:`a = w` and :math:`b = v` every nonlinear iteration
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        *Overload 1:*
        Constructor

        |

        *Overload 2:*
        Copy constructor
        """
        if self.__class__ == Constraint:
            _self = None
        else:
            _self = self
        _MinimallyAugmented.Constraint_swiginit(self, _MinimallyAugmented.new_Constraint(_self, *args))
    __swig_destroy__ = _MinimallyAugmented.delete_Constraint

    def setGroup(self, *args) -> "void":
        r"""
         Set the group pointer
        This method should be called when ever the constrained group
        is copied, since we don't explicitly copy the underlying group
        here.
        """
        return _MinimallyAugmented.Constraint_setGroup(self, *args)

    def setFrequency(self, *args) -> "void":
        r""" Set Hopf frequency"""
        return _MinimallyAugmented.Constraint_setFrequency(self, *args)

    def getLeftNullVecReal(self, *args) -> "Teuchos::RCP< NOX::Abstract::Vector const >":
        r""" Returns real component of left null vector w"""
        return _MinimallyAugmented.Constraint_getLeftNullVecReal(self, *args)

    def getLeftNullVecImag(self, *args) -> "Teuchos::RCP< NOX::Abstract::Vector const >":
        r""" Returns imaginary component of left null vector w"""
        return _MinimallyAugmented.Constraint_getLeftNullVecImag(self, *args)

    def getRightNullVecReal(self, *args) -> "Teuchos::RCP< NOX::Abstract::Vector const >":
        r""" Returns real component of right null vector v"""
        return _MinimallyAugmented.Constraint_getRightNullVecReal(self, *args)

    def getRightNullVecImag(self, *args) -> "Teuchos::RCP< NOX::Abstract::Vector const >":
        r""" Returns imaginary component of right null vector v"""
        return _MinimallyAugmented.Constraint_getRightNullVecImag(self, *args)

    def getSigmaReal(self, *args) -> "double":
        r""" Returns real component of sigma"""
        return _MinimallyAugmented.Constraint_getSigmaReal(self, *args)

    def getSigmaImag(self, *args) -> "double":
        r""" Returns imaginary component of sigma"""
        return _MinimallyAugmented.Constraint_getSigmaImag(self, *args)

    def copy(self, *args) -> "void":
        r""" Copy"""
        return _MinimallyAugmented.Constraint_copy(self, *args)

    def clone(self, *args) -> "Teuchos::RCP< LOCA::MultiContinuation::ConstraintInterface >":
        r""" Cloning function"""
        return _MinimallyAugmented.Constraint_clone(self, *args)

    def numConstraints(self, *args) -> "int":
        r""" Return number of constraints"""
        return _MinimallyAugmented.Constraint_numConstraints(self, *args)

    def setX(self, *args) -> "void":
        r""" Set the solution vector to y."""
        return _MinimallyAugmented.Constraint_setX(self, *args)

    def setParam(self, *args) -> "void":
        r""" Sets parameter indexed by paramID"""
        return _MinimallyAugmented.Constraint_setParam(self, *args)

    def setParams(self, *args) -> "void":
        r""" Sets parameters indexed by paramIDs"""
        return _MinimallyAugmented.Constraint_setParams(self, *args)

    def computeConstraints(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r""" Compute continuation constraint equations"""
        return _MinimallyAugmented.Constraint_computeConstraints(self, *args)

    def computeDX(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r""" Compute derivative of constraints w.r.t. solution vector x"""
        return _MinimallyAugmented.Constraint_computeDX(self, *args)

    def computeDP(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r"""
         Compute derivative of constraints w.r.t. supplied parameters.
        The first column of ``dgdp`` should be filled with the constraint
        residuals :math:`g` if ``isValidG`` is ``false``.  If ``isValidG`` is
        ``true``, then the ``dgdp`` contains :math:`g` on input.
        """
        return _MinimallyAugmented.Constraint_computeDP(self, *args)

    def isConstraints(self, *args) -> "bool":
        r""" Return ``true`` if constraint residuals are valid"""
        return _MinimallyAugmented.Constraint_isConstraints(self, *args)

    def isDX(self, *args) -> "bool":
        r""" Return ``true`` if derivatives of constraints w.r.t. x are valid"""
        return _MinimallyAugmented.Constraint_isDX(self, *args)

    def getConstraints(self, *args) -> "NOX::Abstract::MultiVector::DenseMatrix const &":
        r""" Return constraint residuals"""
        return _MinimallyAugmented.Constraint_getConstraints(self, *args)

    def getDX(self, *args) -> "NOX::Abstract::MultiVector const *":
        r""" Return solution component of constraint derivatives"""
        return _MinimallyAugmented.Constraint_getDX(self, *args)

    def isDXZero(self, *args) -> "bool":
        r"""
        Return ``true`` if solution component of constraint
        derivatives is zero
        """
        return _MinimallyAugmented.Constraint_isDXZero(self, *args)

    def postProcessContinuationStep(self, *args) -> "void":
        r"""
         Perform any postprocessing after a continuation step finishes.
        The ``stepStatus`` argument indicates whether the step was
        successful.  Here we update the :math:`a` and :math:`b` vectors to
        :math:`w` and :math:`v` respectively if requested.
        """
        return _MinimallyAugmented.Constraint_postProcessContinuationStep(self, *args)

    def computeDOmega(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r""" Compute derivative of sigma w.r.t. frequency omega"""
        return _MinimallyAugmented.Constraint_computeDOmega(self, *args)
    def __disown__(self):
        self.this.disown()
        _MinimallyAugmented.disown_Constraint(self)
        return weakref.proxy(self)

# Register Constraint in _MinimallyAugmented:
_MinimallyAugmented.Constraint_swigregister(Constraint)

class AbstractGroup(MooreSpence.AbstractGroup):
    r"""
    Interface to underlying groups for Hopf calculations
    using the minimally augmented formulation.

    This abstract class provides the required interface for underlying
    groups to locate Hopfs using the minimally augmented Hopf (see
    LOCA::Hopf::MinimallyAugmented::ExtendedGroup for a
    description of the governing equations).

    This class is derived from the
    LOCA::Hopf::MooreSpence::AbstractGroup
    and declares several pure virtual methods to compute various
    derivatives of :math:`w^H C e` for a given :math:`w = w_1 + i w_2` and
    :math:`e = y + i z` where :math:`C = J + i \omega M`.  Default
    implementations for the derivatives using finite differencing are
    implemented in the
    LOCA::Hopf::MinimallyAugmented::FiniteDifferenceGroup.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r""" Default constructor."""
        if self.__class__ == AbstractGroup:
            _self = None
        else:
            _self = self
        _MinimallyAugmented.AbstractGroup_swiginit(self, _MinimallyAugmented.new_AbstractGroup(_self, *args))
    __swig_destroy__ = _MinimallyAugmented.delete_AbstractGroup

    def applyComplexTranspose(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r"""
        Computes conjugate-tranpose matrix vector product
        :math:`(J+i\omega M)^H (x + iy)`.
        """
        return _MinimallyAugmented.AbstractGroup_applyComplexTranspose(self, *args)

    def applyComplexTransposeMultiVector(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r"""
        Computes conjugate-tranpose matrix vector product
        :math:`(J+i\omega M)^H (x + iy)`.
        """
        return _MinimallyAugmented.AbstractGroup_applyComplexTransposeMultiVector(self, *args)

    def applyComplexTransposeInverseMultiVector(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r""" Solve :math:`(J+i\omega M)^H (x + iy) = a+ib`"""
        return _MinimallyAugmented.AbstractGroup_applyComplexTransposeInverseMultiVector(self, *args)

    def computeDwtCeDp(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r"""
        Computes the derivative :math:`\partial w^H C e/\partial p`,
        :math:`w = w_1 + i w_2`, :math:`e = y + i z`, :math:`C = J + i \omega M`.
        """
        return _MinimallyAugmented.AbstractGroup_computeDwtCeDp(self, *args)

    def computeDwtCeDx(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r"""
        Computes the derivative
        :math:`\frac{\partial w^H C e}{\partial x}`,
        :math:`w = w_1 + i w_2`, :math:`e = y + i z`, :math:`C = J + i \omega M`.
        """
        return _MinimallyAugmented.AbstractGroup_computeDwtCeDx(self, *args)
    def __disown__(self):
        self.this.disown()
        _MinimallyAugmented.disown_AbstractGroup(self)
        return weakref.proxy(self)

# Register AbstractGroup in _MinimallyAugmented:
_MinimallyAugmented.AbstractGroup_swigregister(AbstractGroup)

class FiniteDifferenceGroup(AbstractGroup, MooreSpence.FiniteDifferenceGroup):
    r"""
    Concrete class that provides concrete implementations of the
    derivative computation methods of the
    LOCA::Hopf::MinimallyAugmented::AbstractGroup using
    first-order finite differencing.

    The finite-differencing calculations are actually implemented by
    the LOCA::DerivUtils class, and a custom DerivUtils object can be
    passed through the constructor of this class.  However, in the future
    the calculations encapsulated in the DerivUtils class may be
    incorporated directly into this class and other finite-differencing
    child classes.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        *Overload 1:*
        Constructor.

        |

        *Overload 2:*
        Copy constructor
        """
        if self.__class__ == FiniteDifferenceGroup:
            _self = None
        else:
            _self = self
        _MinimallyAugmented.FiniteDifferenceGroup_swiginit(self, _MinimallyAugmented.new_FiniteDifferenceGroup(_self, *args))
    __swig_destroy__ = _MinimallyAugmented.delete_FiniteDifferenceGroup

    def computeDwtCeDp(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r"""
        Computes the derivative :math:`\partial w^TCe/\partial p`

        The calculation is implemented by calling the corresponding
        LOCA::DerivUtils::computeDwtCeDp() method of the passed
        LOCA::DerivUtils object.
        """
        return _MinimallyAugmented.FiniteDifferenceGroup_computeDwtCeDp(self, *args)

    def computeDwtCeDx(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r"""
        Computes the derivative
        :math:`\frac{\partial w^TCe}{\partial x}`.

        The calculation is implemented by calling the corresponding
        LOCA::DerivUtils::computeDwtCeDx() method of the passed
        LOCA::DerivUtils object.
        """
        return _MinimallyAugmented.FiniteDifferenceGroup_computeDwtCeDx(self, *args)
    def __disown__(self):
        self.this.disown()
        _MinimallyAugmented.disown_FiniteDifferenceGroup(self)
        return weakref.proxy(self)

# Register FiniteDifferenceGroup in _MinimallyAugmented:
_MinimallyAugmented.FiniteDifferenceGroup_swigregister(FiniteDifferenceGroup)

class ExtendedGroup(Extended.MultiAbstractGroup, MultiContinuation.AbstractGroup, BorderedSystem.AbstractGroup):
    r"""
    A group representing the minimally augemented Hopf
    equations.

    The LOCA::Hopf::MinimallyAugmented::ExtendedGroup is a
    concrete implementation of the NOX::Abstract::Group,
    LOCA::MultiContinuation::AbstractGroup and
    LOCA::Extended::MultiAbstractGroup that defines the following
    extended set of equations that are regular at a generic Hopf:

    .. math::

        G(z) = \left[
             \begin{array}{c}
                F(x,p)\\
                \sigma
             \end{array}
             \right] = 0
    where :math:`z = [x, p, \omega]\in\Re^{n+2}`, :math:`x` is the
    solution vector, :math:`p` is the bifurcation parameter, :math:`\omega`
    is the Hopf frequency and :math:`\sigma\in\Re` is a measure of the
    singularity of :math:`J+i\omega M` and is defined via

    .. math::

        \begin{bmatrix}
              J+i\omega M & a \\
              b^H         & 0
            \end{bmatrix}
            \begin{bmatrix}
              v \\
              \sigma_1
            \end{bmatrix} =
            \begin{bmatrix}
              0 \\
              n
            \end{bmatrix},

    .. math::

        \begin{bmatrix}
              J^T-i\omega M^T & b \\
              a^H             & 0
            \end{bmatrix}
            \begin{bmatrix}
              w \\
              \sigma_2
            \end{bmatrix} =
            \begin{bmatrix}
              0 \\
              n
            \end{bmatrix},

    .. math::

        \sigma = w^H J+i\omega M v/n
    for any vectors :math:`a` and :math:`b` in :math:`\mathbb{C}^n`.  Using
    these relationships, it is easy to show

    .. math::

        \begin{split}
               \sigma_x &= (w^H(J+i\omega M)v)_x/n = w^H(J+i\omega M)_x v/n \\
               \sigma_p &= (w^H(J+i\omega M)v)_p/n = w^H(J+i\omega M)_p v/n
            \end{split}

    The group stores an underlying group of type
    LOCA::Hopf::MinimallyAugmented::AbstractGroup to represent
    the equations :math:`F(x,p) = 0` and to manipulate the underlying
    complex matrix :math:`C = J+i\omega M`.  This interface defines methods
    for computing the derivatives :math:`(w^H C v)_x` and :math:`(w^H C v)_p`.
    Since %LOCA is not able to deal with complex vectors and matrices
    directly, the real-equivalent formulation is used for all complex
    calculations.

    This class implements all of the NOX::Abstract::Group,
    LOCA::MultiContinuation::AbstractGroup, and
    LOCA::Extended::MultiAbstractGroup
    methods for this extended set of equations and therefore is a complete
    group which can be passed to most %NOX solvers to locate a single
    pitchfork or to the LOCA::Stepper to compute a family of
    pitchforks in a second parameter.

    The class is intialized via the ``hpfParams`` parameter list argument
    to the constructor.  The parameters this class recognizes are:

    *  "Bifurcation Parameter" -- [string] (Must be supplied) -
       Name of the bifurcation parameter :math:`p`
    *  "Initial Frequency" -- [double] (Must be supplied)
         Initial guess for the Hopf frequency :math:`\omega`.
    *  "Bordered Solver Method" -- [string] (default "Bordering")
         Method for solving bordered systems of equations.  See
         LOCA::BorderedSolver::Factory for a description.
    *  "Symmetric Jacobian"  -- [bool] (default: false) -
       Flag indicating whether Jacobian matrix :math:`J` is symmetric,
       in which case we force :math:`a = b` and therefore the second
       tranpose solve for :math:`w` is unnecessary
    *  "Initial Null Vector Compuation" -- [string]
         (default: "User Provided") - Method to compute initial :math:`a`
         and :math:`b` vectors.  Valid choices are:

         *  "User Provided" - Initial vectors are provided in the
              parameter list, in which case the following parameters
              are relevant:

              *  "Initial Real A Vector"  --
                   [Teuchos::RCP<NOX::Abstract::Vector>]
                   (Must be supplied) -
                    Vector storing initial value for the real component
                    of the :math:`a` vector
              *  "Initial Imaginary A Vector"  --
                   [Teuchos::RCP<NOX::Abstract::Vector>]
                   (Must be supplied) -
                    Vector storing initial value for the imaginary
                    component of the :math:`a` vector
              *  "Initial Real B Vector"  --
                    [Teuchos::RCP<NOX::Abstract::Vector>]
                    (Must be supplied for nonsymmetric Jacobians) -
                    Vector storing initial value for the real component
                    of the :math:`b` vector
              *  "Initial Imaginary B Vector"  --
                   [Teuchos::RCP<NOX::Abstract::Vector>]
                   (Must be supplied) -
                    Vector storing initial value for the imaginary
                    component of the :math:`b` vector

         *  "Solve df/dp" - Compute :math:`a = J^{-T}df/dp` and
              :math:`b = J^{-1} df/dp` where :math:`p` is the bifurcation
              parameter.

    *  "Update Null Vectors Every Continuation Step"  --
       [bool] (default: true) -
       Flag indicating whether to update :math:`a` and :math:`b` vectors via
       :math:`a = w` and :math:`b = v` every continuation step
    *  "Update Null Vectors Every Nonlinear Iteration"  --
       [bool] (default: false) -
       Flag indicating whether to update :math:`a` and :math:`b` vectors via
       :math:`a = w` and :math:`b = v` every nonlinear iteration
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        *Overload 1:*
         Constructor
        :type global_data: Teuchos::RCP< LOCA::GlobalData >
        :param global_data: [in] Global data object
        :type topParams: Teuchos::RCP< LOCA::Parameter::SublistParser >
        :param topParams: [in] Parsed top-level parameter list.
        :type hpfParams: :py:class:`ParameterList`
        :param hpfParams: [in] Parameter list determining the
            bordered solver method.
        :type grp: :py:class:`AbstractGroup`
        :param grp: [in] Group representing :math:`f`.

        |

        *Overload 2:*
         Copy constructor
        """
        _MinimallyAugmented.ExtendedGroup_swiginit(self, _MinimallyAugmented.new_ExtendedGroup(*args))
    __swig_destroy__ = _MinimallyAugmented.delete_ExtendedGroup

    def getBifParam(self, *args) -> "double":
        r""" Get bifurcation parameter"""
        return _MinimallyAugmented.ExtendedGroup_getBifParam(self, *args)

    def clone(self, *args) -> "Teuchos::RCP< NOX::Abstract::Group >":
        r""" Clone function"""
        return _MinimallyAugmented.ExtendedGroup_clone(self, *args)

    def setX(self, *args) -> "void":
        r""" Set the solution vector to y."""
        return _MinimallyAugmented.ExtendedGroup_setX(self, *args)

    def computeX(self, *args) -> "void":
        r"""
        Compute and return solution vector, x, where
        this.x = grp.x + step * d.
        """
        return _MinimallyAugmented.ExtendedGroup_computeX(self, *args)

    def computeF(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r""" Compute extended continuation equations"""
        return _MinimallyAugmented.ExtendedGroup_computeF(self, *args)

    def computeJacobian(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r""" Compute extended continuation jacobian"""
        return _MinimallyAugmented.ExtendedGroup_computeJacobian(self, *args)

    def computeGradient(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r""" Gradient is not defined for this system"""
        return _MinimallyAugmented.ExtendedGroup_computeGradient(self, *args)

    def computeNewton(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r""" Compute Newton direction for extended continuation system"""
        return _MinimallyAugmented.ExtendedGroup_computeNewton(self, *args)

    def applyJacobian(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r""" Applies Jacobian for extended system"""
        return _MinimallyAugmented.ExtendedGroup_applyJacobian(self, *args)

    def applyJacobianTranspose(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r""" Jacobian transpose not defined for this system"""
        return _MinimallyAugmented.ExtendedGroup_applyJacobianTranspose(self, *args)

    def applyJacobianInverse(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r""" Applies Jacobian inverse for extended system"""
        return _MinimallyAugmented.ExtendedGroup_applyJacobianInverse(self, *args)

    def applyJacobianMultiVector(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r""" Applies Jacobian for extended system"""
        return _MinimallyAugmented.ExtendedGroup_applyJacobianMultiVector(self, *args)

    def applyJacobianTransposeMultiVector(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r""" Jacobian transpose not defined for this system"""
        return _MinimallyAugmented.ExtendedGroup_applyJacobianTransposeMultiVector(self, *args)

    def applyJacobianInverseMultiVector(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r""" Applies Jacobian inverse for extended system"""
        return _MinimallyAugmented.ExtendedGroup_applyJacobianInverseMultiVector(self, *args)

    def isF(self, *args) -> "bool":
        r""" Return ``true`` if extended residual is valid."""
        return _MinimallyAugmented.ExtendedGroup_isF(self, *args)

    def isJacobian(self, *args) -> "bool":
        r""" Return ``true`` if the extended Jacobian is valid."""
        return _MinimallyAugmented.ExtendedGroup_isJacobian(self, *args)

    def isGradient(self, *args) -> "bool":
        r""" Always returns false"""
        return _MinimallyAugmented.ExtendedGroup_isGradient(self, *args)

    def isNewton(self, *args) -> "bool":
        r""" Return ``true`` if the extended Newton direction is valid"""
        return _MinimallyAugmented.ExtendedGroup_isNewton(self, *args)

    def getX(self, *args) -> "NOX::Abstract::Vector const &":
        r""" Return extended solution vector."""
        return _MinimallyAugmented.ExtendedGroup_getX(self, *args)

    def getF(self, *args) -> "NOX::Abstract::Vector const &":
        r""" Return extended residual"""
        return _MinimallyAugmented.ExtendedGroup_getF(self, *args)

    def getNormF(self, *args) -> "double":
        r""" Return 2-norm of extended residual."""
        return _MinimallyAugmented.ExtendedGroup_getNormF(self, *args)

    def getGradient(self, *args) -> "NOX::Abstract::Vector const &":
        r""" Gradient is never valid"""
        return _MinimallyAugmented.ExtendedGroup_getGradient(self, *args)

    def getNewton(self, *args) -> "NOX::Abstract::Vector const &":
        r""" Return extended Newton direction."""
        return _MinimallyAugmented.ExtendedGroup_getNewton(self, *args)

    def getNormNewtonSolveResidual(self, *args) -> "double":
        r""" Returns 2-norm of extended Newton solve residual"""
        return _MinimallyAugmented.ExtendedGroup_getNormNewtonSolveResidual(self, *args)

    def getUnderlyingGroup(self, *args) -> "Teuchos::RCP< LOCA::MultiContinuation::AbstractGroup >":
        r"""
        *Overload 1:*
        Return underlying group

        |

        *Overload 2:*
        Return underlying group
        """
        return _MinimallyAugmented.ExtendedGroup_getUnderlyingGroup(self, *args)

    def copy(self, *args) -> "void":
        r""" Assignment operator"""
        return _MinimallyAugmented.ExtendedGroup_copy(self, *args)

    def setParamsMulti(self, *args) -> "void":
        r""" Set parameters indexed by (integer) paramIDs"""
        return _MinimallyAugmented.ExtendedGroup_setParamsMulti(self, *args)

    def setParams(self, *args) -> "void":
        r""" Set the parameter vector in the group to p (pVector = p)."""
        return _MinimallyAugmented.ExtendedGroup_setParams(self, *args)

    def setParam(self, *args) -> "void":
        r"""
        *Overload 1:*
        Set parameter indexed by (integer) paramID

        |

        *Overload 2:*
        Set parameter indexed by (std::string) paramID
        """
        return _MinimallyAugmented.ExtendedGroup_setParam(self, *args)

    def getParams(self, *args) -> "LOCA::ParameterVector const &":
        r""" Return a const reference to the ParameterVector owned by the group."""
        return _MinimallyAugmented.ExtendedGroup_getParams(self, *args)

    def getParam(self, *args) -> "double":
        r"""
        *Overload 1:*
        Return copy of parameter indexed by (integer) paramID

        |

        *Overload 2:*
        Return copy of parameter indexed by (std::string) paramID
        """
        return _MinimallyAugmented.ExtendedGroup_getParam(self, *args)

    def computeDfDpMulti(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r"""
        Compute :math:`\partial F/\partial p` for each parameter :math:`p`
        indexed by paramIDs.  The first column of *dfdp* holds F,
        which is valid if *isValidF* is true.  Otherwise F must be
        computed.
        """
        return _MinimallyAugmented.ExtendedGroup_computeDfDpMulti(self, *args)

    def preProcessContinuationStep(self, *args) -> "void":
        r"""
         Perform any preprocessing before a continuation step starts.
        The ``stepStatus`` argument indicates whether the previous step was
        successful.
        """
        return _MinimallyAugmented.ExtendedGroup_preProcessContinuationStep(self, *args)

    def postProcessContinuationStep(self, *args) -> "void":
        r"""
         Perform any postprocessing after a continuation step finishes.
        The ``stepStatus`` argument indicates whether the step was
        successful.
        """
        return _MinimallyAugmented.ExtendedGroup_postProcessContinuationStep(self, *args)

    def projectToDraw(self, *args) -> "void":
        r""" Projects solution to a few scalars for multiparameter continuation"""
        return _MinimallyAugmented.ExtendedGroup_projectToDraw(self, *args)

    def projectToDrawDimension(self, *args) -> "int":
        r""" Returns the dimension of the project to draw array"""
        return _MinimallyAugmented.ExtendedGroup_projectToDrawDimension(self, *args)

    def computeScaledDotProduct(self, *args) -> "double":
        r""" Compute a scaled dot product"""
        return _MinimallyAugmented.ExtendedGroup_computeScaledDotProduct(self, *args)

    def printSolution(self, *args) -> "void":
        r"""
        *Overload 1:*
        Function to print out solution and parameter after successful step

        |

        *Overload 2:*
        Function to print out a vector and parameter after successful step
        """
        return _MinimallyAugmented.ExtendedGroup_printSolution(self, *args)

    def scaleVector(self, *args) -> "void":
        r""" Scales a vector using scaling vector"""
        return _MinimallyAugmented.ExtendedGroup_scaleVector(self, *args)

    def getBorderedWidth(self, *args) -> "int":
        r""" Return the total width of the bordered rows/columns"""
        return _MinimallyAugmented.ExtendedGroup_getBorderedWidth(self, *args)

    def getUnborderedGroup(self, *args) -> "Teuchos::RCP< NOX::Abstract::Group const >":
        r""" Get bottom-level unbordered group"""
        return _MinimallyAugmented.ExtendedGroup_getUnborderedGroup(self, *args)

    def isCombinedAZero(self, *args) -> "bool":
        r""" Indicates whether combined A block is zero"""
        return _MinimallyAugmented.ExtendedGroup_isCombinedAZero(self, *args)

    def isCombinedBZero(self, *args) -> "bool":
        r""" Indicates whether combined B block is zero"""
        return _MinimallyAugmented.ExtendedGroup_isCombinedBZero(self, *args)

    def isCombinedCZero(self, *args) -> "bool":
        r""" Indicates whether combined C block is zero"""
        return _MinimallyAugmented.ExtendedGroup_isCombinedCZero(self, *args)

    def extractSolutionComponent(self, *args) -> "void":
        r"""
        Given the vector ``v``, extract the underlying solution component
        corresponding to the unbordered group.
        """
        return _MinimallyAugmented.ExtendedGroup_extractSolutionComponent(self, *args)

    def extractParameterComponent(self, *args) -> "void":
        r"""
        Given the vector ``v``, extract the parameter components of all
        of the nested subvectors in ``v`` down to the solution component
        for the unbordered group.
        """
        return _MinimallyAugmented.ExtendedGroup_extractParameterComponent(self, *args)

    def loadNestedComponents(self, *args) -> "void":
        r"""
        Given the solution component ``v_x`` and combined parameter
        components ``v_p``, distribute these components through the nested
        sub-vectors in ``v``.
        """
        return _MinimallyAugmented.ExtendedGroup_loadNestedComponents(self, *args)

    def fillA(self, *args) -> "void":
        r""" Fill the combined A block as described above"""
        return _MinimallyAugmented.ExtendedGroup_fillA(self, *args)

    def fillB(self, *args) -> "void":
        r""" Fill the combined B block as described above"""
        return _MinimallyAugmented.ExtendedGroup_fillB(self, *args)

    def fillC(self, *args) -> "void":
        r""" Fill the combined C block as described above"""
        return _MinimallyAugmented.ExtendedGroup_fillC(self, *args)

# Register ExtendedGroup in _MinimallyAugmented:
_MinimallyAugmented.ExtendedGroup_swigregister(ExtendedGroup)



