# This file was automatically generated by SWIG (http://www.swig.org).
# Version 4.0.2
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.

"""

PyTrilinos.LOCA.Hopf.MooreSpence is the python interface to namespace
Hopf::MooreSpence of the Trilinos continuation algorithm package LOCA:

    https://trilinos.org/docs/dev/packages/nox/doc/html/index.html

The purpose of LOCA.Hopf.MooreSpence is to provide ***.  The python
version of LOCA.Hopf.MooreSpence supports the following classes:

    * AbstractGroup          - Interface to underlying groups for Hopf point
                               calculations using the Moore-Spence formulation
    * ExtendedGroup          - A group representing the Moore-Spence Hopf
                               equations
    * ExtendedMultiVector    - Multi-vector class to hold solution vectors,
                               Newton vectors, etc.for the Moore-Spence Hopf
                               eqautions
    * ExtendedVector         - Vector class to hold solution vectors, Newton
                               vectors, etc. for Moore-Spence Hopf equations
    * FiniteDifferenceGroup  - Concrete class that provides concrete
                               implementations of the derivative computation
                               methods of the LOCA.Hopf.MooreSpence.-
                               AbstractGroup using first-order finite
                               differencing
    * SolverFactory          - Factory for creating solver objects for solving
                               Moore-Spence Hopf equations
    * SolverStrategy         - Abstract strategy for solving the Moore-Spence
                               Hopf equations
    * SalingerBordering      - Moore-Spence Hopf solver strategy based on
                               'Salinger' bordering.  This is the classic 5-
                               solve Hopf bordering method

"""

from sys import version_info as _swig_python_version_info
if _swig_python_version_info < (2, 7, 0):
    raise RuntimeError("Python 2.7 or later required")


from . import _MooreSpence
import PyTrilinos.Teuchos.Base
import PyTrilinos.NOX.Abstract
import PyTrilinos.Epetra
from PyTrilinos.LOCA import Extended
from PyTrilinos.LOCA import MultiContinuation
from PyTrilinos.LOCA import TimeDependent
from PyTrilinos.LOCA import TurningPoint


try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)


def _swig_setattr_nondynamic_instance_variable(set):
    def set_instance_attr(self, name, value):
        if name == "thisown":
            self.this.own(value)
        elif name == "this":
            set(self, name, value)
        elif hasattr(self, name) and isinstance(getattr(type(self), name), property):
            set(self, name, value)
        else:
            raise AttributeError("You cannot add instance attributes to %s" % self)
    return set_instance_attr


def _swig_setattr_nondynamic_class_variable(set):
    def set_class_attr(cls, name, value):
        if hasattr(cls, name) and not isinstance(getattr(cls, name), property):
            set(cls, name, value)
        else:
            raise AttributeError("You cannot add class attributes to %s" % cls)
    return set_class_attr


def _swig_add_metaclass(metaclass):
    """Class decorator for adding a metaclass to a SWIG wrapped class - a slimmed down version of six.add_metaclass"""
    def wrapper(cls):
        return metaclass(cls.__name__, cls.__bases__, cls.__dict__.copy())
    return wrapper


class _SwigNonDynamicMeta(type):
    """Meta class to enforce nondynamic attributes (no new attributes) for a class"""
    __setattr__ = _swig_setattr_nondynamic_class_variable(type.__setattr__)


import weakref

import PyTrilinos.Teuchos.Base
import PyTrilinos.NOX.Abstract
import PyTrilinos.Epetra
import Extended
import MultiContinuation
import TimeDependent
import TurningPoint.MooreSpence
class AbstractGroup(TurningPoint.MooreSpence.AbstractGroup, TimeDependent.AbstractGroup):
    r"""
    Interface to underlying groups for Hopf point calculations
    using the Moore-Spence formulation.

    This abstract class provides the required interface for underlying
    groups to locate Hopf bifurcations using the bordering
    algorithm for the Moore-Spence Hopf fomulation (see
    LOCA::Hopf::MooreSpence::ExtendedGroup for a description of the
    governing equations).

    This class is derived from the
    LOCA::TurningPoint::MooreSpence::AbstractGroup and
    LOCa::TimeDependent::AbstractGroup and declares several
    pure virtual methods for applying, solving, and computing derivatives
    of the complex matrix :math:`J+i\omega B` where :math:`J` is the Jacobian
    matrix, :math:`B` is the mass matrix, and :math:`\omega` is a (real)
    scalar.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _MooreSpence.delete_AbstractGroup

    def isComplex(self, *args) -> "bool":
        r""" Is  :math:`J+i\omega B` valid"""
        return _MooreSpence.AbstractGroup_isComplex(self, *args)

    def computeComplex(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r"""
         Compute :math:`J+i\omega B`
        The argument **frequency** stores :math:`\omega`.
        """
        return _MooreSpence.AbstractGroup_computeComplex(self, *args)

    def applyComplex(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r""" Compute :math:`(J+i\omega B)(y+iz)`"""
        return _MooreSpence.AbstractGroup_applyComplex(self, *args)

    def applyComplexMultiVector(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r""" Compute :math:`(J+i\omega B)(y+iz)`"""
        return _MooreSpence.AbstractGroup_applyComplexMultiVector(self, *args)

    def applyComplexInverseMultiVector(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r""" Solve :math:`(J+i\omega B)(y+iz) = a+ib`"""
        return _MooreSpence.AbstractGroup_applyComplexInverseMultiVector(self, *args)

    def computeDCeDp(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r"""
        Computes the derivative
        :math:`\frac{\partial (J+i\omega B)(y+iz)}{\partial p}`
        where :math:`p` is the parameter indexed by **paramIDs**.
        """
        return _MooreSpence.AbstractGroup_computeDCeDp(self, *args)

    def computeDCeDxa(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r"""
        *Overload 1:*

        Computes the directional derivative
        :math:`\frac{\partial (J+i\omega B)(y+iz)}{\partial x} a` for the
        given direction :math:`a`.

        |

        *Overload 2:*

        Computes the directional derivative
        :math:`\frac{\partial (J+i\omega B)(y+iz)}{\partial x} a` for the
        given direction :math:`a`. The
        arguments **Ce_real** and **Ce_imag** hold the real and imaginary
        components of :math:`(J+i\omega B)(y+iz)`.
        """
        return _MooreSpence.AbstractGroup_computeDCeDxa(self, *args)

# Register AbstractGroup in _MooreSpence:
_MooreSpence.AbstractGroup_swigregister(AbstractGroup)

class ExtendedGroup(Extended.MultiAbstractGroup, MultiContinuation.AbstractGroup):
    r"""
    A group representing the Moore-Spence Hopf equations.

    The LOCA::Hopf::MooreSpence::ExtendedGroup is a concrete
    implementation of the NOX::Abstract::Group,
    LOCA::MultiContinuation::AbstractGroup and
    LOCA::Extended::MultiAbstractGroup that defines the following
    extended set of equations that are regular at a generic Hopf point:

    .. math::

        G(z) = \left[
            \begin{array}{c}
                F(x,p) \\
                Jy-\omega Bz \\
                Jz+\omega By \\
                l^Ty-1 \\
                l^Tz
             \end{array}
             \right] = 0
    where :math:`z = [x, y, z, \omega, p]\in\Re^{3n+2}`, :math:`x` is the
    solution vector, :math:`y+i\omega z` is the complex eigenvector of
    :math:`J` with corresponding eigenvalues :math:`\pm i\omega`, :math:`l`
    is the length normalization vector and :math:`J` is the Jacobian of F
    w.r.t :math:`x`.

    The group stores an underlying group of type
    LOCA::Hopf::MooreSpence AbstractGroup to represent the equations
    :math:`F(x,p) = 0` and to manipulate the underlying Jacobian :math:`J`.
    Note that the entire extended Jacobian :math:`D_z G` is not stored in
    memory, rather a block-elimination algorithm (bordering algorithm) is
    used to compute linear solves of the extended Jacobian (see
    LOCA::Hopf::MooreSpence::SolverFactory() for more details).

    This class implements all of the NOX::Abstract::Group,
    LOCA::MultiContinuation::AbstractGroup, and
    LOCA::Extended::MultiAbstractGroup
    methods for this extended set of equations and therefore is a complete
    group which can be passed to most %NOX solvers to locate a single
    Hopf point or to the LOCA::Stepper to compute a family of Hopf
    points in a second parameter.

    However, Jacobian-tranpose operations and gradient calculations
    cannot be implemented efficiently and therefore gradient-base
    nonlinear solvers such as steepest descent and Trust region methods
    cannot be used to solve the extended Hopf point equations.

    The class is intialized via the ``hopfParams`` parameter list argument
    to the constructor.  The parameters this class recognizes are:

    *  "Bifurcation Parameter" -- [string] (Must be supplied) Name of
         the bifurcation parameter :math:`p`
    *  "Length Normalization Vector" --
         [Teuchos::RCP<NOX::Abstract::Vector>] (Must be supplied)
        Vector storing length normalization vector :math:`l`
    *  "Initial Real Eigenvector"  --
         [Teuchos::RCP<NOX::Abstract::Vector>] (Must be supplied)
        Vector storing initial guess for the real component of the
        eigenvector :math:`y`
    *  "Initial Imaginary Eigenvector"  --
         [Teuchos::RCP<NOX::Abstract::Vector>] (Must be supplied)
        Vector storing initial guess for the imaginary component of the
        eigenvector :math:`z`
    *  "Initial Frequency" -- [double] (Must be supplied)
         Initial guess for the Hopf frequency :math:`\omega`.
    *  "Perturb Initial Solution" -- [bool] (default: false) Flag
         indicating whether to perturb the initial solution
    *  "Relative Perturbation Size" -- [double] (default: 1.0e-3)
         Relative perturbation size if perturbing the initial solution
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        *Overload 1:*

        Constructor with initial data passed through parameter lists.

        |

        *Overload 2:*
         Copy constructor.
        """
        _MooreSpence.ExtendedGroup_swiginit(self, _MooreSpence.new_ExtendedGroup(*args))
    __swig_destroy__ = _MooreSpence.delete_ExtendedGroup

    def clone(self, *args) -> "Teuchos::RCP< NOX::Abstract::Group >":
        r""" Cloning function"""
        return _MooreSpence.ExtendedGroup_clone(self, *args)

    def setX(self, *args) -> "void":
        r""" Set the solution vector, x, to y."""
        return _MooreSpence.ExtendedGroup_setX(self, *args)

    def computeX(self, *args) -> "void":
        r""" Compute this.x = grp.x + step * d."""
        return _MooreSpence.ExtendedGroup_computeX(self, *args)

    def computeF(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r""" Compute the Hopf point equation residual :math:`G`."""
        return _MooreSpence.ExtendedGroup_computeF(self, *args)

    def computeJacobian(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r""" Compute the blocks of the Jacobian derivative of :math:`G`"""
        return _MooreSpence.ExtendedGroup_computeJacobian(self, *args)

    def computeGradient(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r""" Gradient computation is not defined for this group"""
        return _MooreSpence.ExtendedGroup_computeGradient(self, *args)

    def computeNewton(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r""" Compute %Newton direction using applyJacobianInverse()."""
        return _MooreSpence.ExtendedGroup_computeNewton(self, *args)

    def applyJacobian(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r""" Computes the extended Jacobian vector product"""
        return _MooreSpence.ExtendedGroup_applyJacobian(self, *args)

    def applyJacobianTranspose(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r""" Jacobian transpose product is not defined by this group"""
        return _MooreSpence.ExtendedGroup_applyJacobianTranspose(self, *args)

    def applyJacobianInverse(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r"""
        Applies the inverse of the extended Jacobian matrix using
        the bordering algorithm.

        This method is a special case of applyJacobianInverseMultiVector()
        for a single right-hand-side.
        """
        return _MooreSpence.ExtendedGroup_applyJacobianInverse(self, *args)

    def applyJacobianMultiVector(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r""" Applies Jacobian for extended system"""
        return _MooreSpence.ExtendedGroup_applyJacobianMultiVector(self, *args)

    def applyJacobianTransposeMultiVector(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r""" Jacobian transpose not defined for this system"""
        return _MooreSpence.ExtendedGroup_applyJacobianTransposeMultiVector(self, *args)

    def applyJacobianInverseMultiVector(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r"""
         Applies Jacobian inverse for extended system
        Uses a LOCA::Hopf::MooreSpence::SolverStrategy instantiated
        by the LOCA::Hopf::MooreSpence::SolverFactory to
        implement the solve.
        """
        return _MooreSpence.ExtendedGroup_applyJacobianInverseMultiVector(self, *args)

    def isF(self, *args) -> "bool":
        r""" Return ``true`` if the extended residual :math:`G` is valid."""
        return _MooreSpence.ExtendedGroup_isF(self, *args)

    def isJacobian(self, *args) -> "bool":
        r""" Return ``true`` if the extended Jacobian is valid."""
        return _MooreSpence.ExtendedGroup_isJacobian(self, *args)

    def isGradient(self, *args) -> "bool":
        r""" Always returns false."""
        return _MooreSpence.ExtendedGroup_isGradient(self, *args)

    def isNewton(self, *args) -> "bool":
        r""" Return ``true`` if the extended Newton direction is valid."""
        return _MooreSpence.ExtendedGroup_isNewton(self, *args)

    def getX(self, *args) -> "NOX::Abstract::Vector const &":
        r""" Return extended solution vector :math:`z`."""
        return _MooreSpence.ExtendedGroup_getX(self, *args)

    def getF(self, *args) -> "NOX::Abstract::Vector const &":
        r""" Return extended equation residual :math:`G(z)`"""
        return _MooreSpence.ExtendedGroup_getF(self, *args)

    def getNormF(self, *args) -> "double":
        r""" Return 2-norm of :math:`G(z)`."""
        return _MooreSpence.ExtendedGroup_getNormF(self, *args)

    def getGradient(self, *args) -> "NOX::Abstract::Vector const &":
        r""" Vector returned is not valid."""
        return _MooreSpence.ExtendedGroup_getGradient(self, *args)

    def getNewton(self, *args) -> "NOX::Abstract::Vector const &":
        r""" Return extended Newton direction."""
        return _MooreSpence.ExtendedGroup_getNewton(self, *args)

    def getNormNewtonSolveResidual(self, *args) -> "double":
        r""" Return the norm of the %Newton solve residual."""
        return _MooreSpence.ExtendedGroup_getNormNewtonSolveResidual(self, *args)

    def getUnderlyingGroup(self, *args) -> "Teuchos::RCP< LOCA::MultiContinuation::AbstractGroup >":
        r"""
        *Overload 1:*
        Return underlying group

        |

        *Overload 2:*
        Return underlying group
        """
        return _MooreSpence.ExtendedGroup_getUnderlyingGroup(self, *args)

    def copy(self, *args) -> "void":
        r""" Assignment operator"""
        return _MooreSpence.ExtendedGroup_copy(self, *args)

    def setParamsMulti(self, *args) -> "void":
        r""" Set parameters indexed by (integer) paramIDs"""
        return _MooreSpence.ExtendedGroup_setParamsMulti(self, *args)

    def setParams(self, *args) -> "void":
        r""" Set the parameter vector in the group to p."""
        return _MooreSpence.ExtendedGroup_setParams(self, *args)

    def setParam(self, *args) -> "void":
        r"""
        *Overload 1:*
        Set parameter indexed by paramID

        |

        *Overload 2:*
        Set parameter indexed by paramID
        """
        return _MooreSpence.ExtendedGroup_setParam(self, *args)

    def getParams(self, *args) -> "LOCA::ParameterVector const &":
        r""" Return a const reference to the paramter vector owned by the group."""
        return _MooreSpence.ExtendedGroup_getParams(self, *args)

    def getParam(self, *args) -> "double":
        r"""
        *Overload 1:*
        Return copy of parameter indexed by paramID

        |

        *Overload 2:*
        Return copy of parameter indexed by paramID
        """
        return _MooreSpence.ExtendedGroup_getParam(self, *args)

    def computeDfDpMulti(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r"""
        Compute :math:`\partial F/\partial p` for each parameter :math:`p`
        indexed by paramIDs.  The first column of *dfdp* holds F,
        which is valid if *isValidF* is true.  Otherwise F must be
        computed.
        """
        return _MooreSpence.ExtendedGroup_computeDfDpMulti(self, *args)

    def preProcessContinuationStep(self, *args) -> "void":
        r"""
         Perform any preprocessing before a continuation step starts.
        The ``stepStatus`` argument indicates whether the previous step was
        successful.
        """
        return _MooreSpence.ExtendedGroup_preProcessContinuationStep(self, *args)

    def postProcessContinuationStep(self, *args) -> "void":
        r"""
         Perform any postprocessing after a continuation step finishes.
        The ``stepStatus`` argument indicates whether the step was
        successful.
        """
        return _MooreSpence.ExtendedGroup_postProcessContinuationStep(self, *args)

    def projectToDraw(self, *args) -> "void":
        r""" Projects solution to a few scalars for multiparameter continuation"""
        return _MooreSpence.ExtendedGroup_projectToDraw(self, *args)

    def projectToDrawDimension(self, *args) -> "int":
        r""" Returns the dimension of the project to draw array"""
        return _MooreSpence.ExtendedGroup_projectToDrawDimension(self, *args)

    def printSolution(self, *args) -> "void":
        r"""
        *Overload 1:*

        Function to print out extended solution and continuation
        parameter after successful continuation step.

        This method prints the solution, null-vector, and parameter
        components of the extended solution vector using the printSolution
        method of the underlying group.

        |

        *Overload 2:*

        Function to print out extended solution and continuation
        parameter after successful continuation step.

        This method prints the solution, null-vector, and parameter
        components of the extended solution vector using the printSolution
        method of the underlying group.
        """
        return _MooreSpence.ExtendedGroup_printSolution(self, *args)

    def getBifParam(self, *args) -> "double":
        r""" Get bifurcation parameter"""
        return _MooreSpence.ExtendedGroup_getBifParam(self, *args)

    def getFrequency(self, *args) -> "double":
        r""" Get bifurcation frequency"""
        return _MooreSpence.ExtendedGroup_getFrequency(self, *args)

    def lTransNorm(self, *args) -> "void":
        r"""
        *Overload 1:*
         Defines null vector normalization :math:`l^Tz` equation

        |

        *Overload 2:*
         null vector normalization for multivectors
        Note:  result should have 1 row and z.numVectors() columns.
        """
        return _MooreSpence.ExtendedGroup_lTransNorm(self, *args)

# Register ExtendedGroup in _MooreSpence:
_MooreSpence.ExtendedGroup_swigregister(ExtendedGroup)

class ExtendedMultiVector(Extended.MultiVector):
    r"""
    Multi-vector class to hold solution vectors, %Newton vectors,
    etc.for the Moore-Spence Hopf eqautions.

    This class uses the LOCA::Extended::MultiVector implementation to
    store the solution, real and imaginary eigenvector, frequency and
    parameter components of the Hopf multi vector and merely provides an
    interface for naming which components of the multivector these
    quantities correspond to.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        *Overload 1:*
         Constructor.
        Generates a multivector with *nColumns* columns from *cloneVec*

        |

        *Overload 2:*
         Constructor.

        |

        *Overload 3:*
         Copy constructor.

        |

        *Overload 4:*

        Copy constructor that creates a new multivector with
        *nColumns* columns.

        |

        *Overload 5:*

        Copy constructor that creates a sub copy or view of the
        given multivector
        """
        _MooreSpence.ExtendedMultiVector_swiginit(self, _MooreSpence.new_ExtendedMultiVector(*args))
    __swig_destroy__ = _MooreSpence.delete_ExtendedMultiVector

    def clone(self, *args) -> "Teuchos::RCP< NOX::Abstract::MultiVector >":
        r"""
        Create a new multi-vector of the same underlying type by
        cloning "this", and return a pointer to the new vector.
        """
        return _MooreSpence.ExtendedMultiVector_clone(self, *args)

    def subCopy(self, *args) -> "Teuchos::RCP< NOX::Abstract::MultiVector >":
        r"""
        Creates a new multi-vector with ``index.size()`` columns
        whose columns are copies of the columns of ``*this`` given by
        ``index``.
        """
        return _MooreSpence.ExtendedMultiVector_subCopy(self, *args)

    def subView(self, *args) -> "Teuchos::RCP< NOX::Abstract::MultiVector >":
        r"""
        Creates a new multi-vector with ``index.size()`` columns that
        shares the columns of ``*this`` given by ``index``.
        """
        return _MooreSpence.ExtendedMultiVector_subView(self, *args)

    def getXMultiVec(self, *args) -> "Teuchos::RCP< NOX::Abstract::MultiVector >":
        r"""
        *Overload 1:*
        Returns the solution vector component of extended multivector

        |

        *Overload 2:*
        Returns the solution vector component of extended multivector
        """
        return _MooreSpence.ExtendedMultiVector_getXMultiVec(self, *args)

    def getRealEigenMultiVec(self, *args) -> "Teuchos::RCP< NOX::Abstract::MultiVector >":
        r"""
        *Overload 1:*

        Returns the real part of the eigenvector component of
        extended multivector

        |

        *Overload 2:*

        Returns the real part of the eigenvector component of
        extended multivector
        """
        return _MooreSpence.ExtendedMultiVector_getRealEigenMultiVec(self, *args)

    def getImagEigenMultiVec(self, *args) -> "Teuchos::RCP< NOX::Abstract::MultiVector >":
        r"""
        *Overload 1:*

        Returns the imaginary part of the eigenvector component of
        extended multivector

        |

        *Overload 2:*

        Returns the imaginary part of the eigenvector component of
        extended multivector
        """
        return _MooreSpence.ExtendedMultiVector_getImagEigenMultiVec(self, *args)

    def getFrequencies(self, *args) -> "Teuchos::RCP< NOX::Abstract::MultiVector::DenseMatrix >":
        r"""
        *Overload 1:*
        Returns frequency component of extended multi vector

        |

        *Overload 2:*
        Returns frequency component of extended multi vector
        """
        return _MooreSpence.ExtendedMultiVector_getFrequencies(self, *args)

    def getBifParams(self, *args) -> "Teuchos::RCP< NOX::Abstract::MultiVector::DenseMatrix >":
        r"""
        *Overload 1:*
        Returns bifurcation parameter component of extended multi vector

        |

        *Overload 2:*
        Returns bifurcation parameter component of extended multi vector
        """
        return _MooreSpence.ExtendedMultiVector_getBifParams(self, *args)

    def getColumn(self, *args) -> "Teuchos::RCP< LOCA::Hopf::MooreSpence::ExtendedVector const >":
        r"""
        *Overload 1:*
        Returns ith column as an extended vector

        |

        *Overload 2:*
        Returns ith column as an extended vector
        """
        return _MooreSpence.ExtendedMultiVector_getColumn(self, *args)

# Register ExtendedMultiVector in _MooreSpence:
_MooreSpence.ExtendedMultiVector_swigregister(ExtendedMultiVector)

class ExtendedVector(Extended.Vector):
    r"""
    %Vector class to hold solution vectors, %Newton vectors, etc.
    for Moore-Spence Hopf equations.

    This class uses the LOCA::Extended::Vector implementation to store the
    solution, real and imaginary eigenvector, frequency and parameter
    components of the Hopf vector and merely provides an interface for
    naming which components of the multivector these quantities
    correspond to.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        *Overload 1:*
        Constructor.

        |

        *Overload 2:*
        Copy constructor.
        """
        _MooreSpence.ExtendedVector_swiginit(self, _MooreSpence.new_ExtendedVector(*args))
    __swig_destroy__ = _MooreSpence.delete_ExtendedVector

    def clone(self, *args) -> "Teuchos::RCP< NOX::Abstract::Vector >":
        r""" Cloning function"""
        return _MooreSpence.ExtendedVector_clone(self, *args)

    def setVec(self, *args) -> "void":
        r""" Sets the Hopf vector by setting its five components"""
        return _MooreSpence.ExtendedVector_setVec(self, *args)

    def getXVec(self, *args) -> "Teuchos::RCP< NOX::Abstract::Vector >":
        r"""
        *Overload 1:*
        Returns the solution vector component of extended vector

        |

        *Overload 2:*
        Returns the solution vector component of extended vector
        """
        return _MooreSpence.ExtendedVector_getXVec(self, *args)

    def getRealEigenVec(self, *args) -> "Teuchos::RCP< NOX::Abstract::Vector >":
        r"""
        *Overload 1:*

        Returns the real part of the eigenvector component of
        extended vector

        |

        *Overload 2:*

        Returns the real part of the eigenvector component of
        extended vector
        """
        return _MooreSpence.ExtendedVector_getRealEigenVec(self, *args)

    def getImagEigenVec(self, *args) -> "Teuchos::RCP< NOX::Abstract::Vector >":
        r"""
        *Overload 1:*

        Returns the imaginary part of the eigenvector component of
        extended vector

        |

        *Overload 2:*

        Returns the imaginary part of the eigenvector component of
        extended vector
        """
        return _MooreSpence.ExtendedVector_getImagEigenVec(self, *args)

# Register ExtendedVector in _MooreSpence:
_MooreSpence.ExtendedVector_swigregister(ExtendedVector)

class FiniteDifferenceGroup(AbstractGroup, TurningPoint.MooreSpence.FiniteDifferenceGroup):
    r"""
    Concrete class that provides concrete implementations of the
    derivative computation methods of the
    LOCA::Hopf::MooreSpence::AbstractGroup using first-order finite
    differencing.

    The finite-differencing calculations are actually implemented by
    the LOCA::DerivUtils class, and a custom DerivUtils object can be
    passed through the constructor of this class.  However, in the future
    the calculations encapsulated in the DerivUtils class may be
    incorporated directly into this class and other finite-differencing
    child classes.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _MooreSpence.delete_FiniteDifferenceGroup

    def computeDCeDp(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r"""
        Computes the derivative
        :math:`\frac{\partial (J+i\omega B)(y+iz)}{\partial p}`
        where :math:`p` is the parameter indexed by **paramIDs**.

        The calculation is implemented by calling the corresponding
        LOCA::DerivUtils::computeDCeDp() method of the passed
        LOCA::DerivUtils object.
        """
        return _MooreSpence.FiniteDifferenceGroup_computeDCeDp(self, *args)

    def computeDCeDxa(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r"""
        *Overload 1:*

        Computes the directional derivative
        :math:`\frac{\partial (J+i\omega B)(y+iz)}{\partial x} a` for the
        given direction :math:`a`.

        The calculation is implemented by calling the corresponding
        LOCA::DerivUtils::computeDCeDxa() method of the passed
        LOCA::DerivUtils object.

        |

        *Overload 2:*

        Computes the directional derivative
        :math:`\frac{\partial (J+i\omega B)(y+iz)}{\partial x} a` for the
        given direction :math:`a`. The
        arguments **Ce_real** and **Ce_imag** hold the real and imaginary
        components of :math:`(J+i\omega B)(y+iz)`.

        The calculation is implemented by calling the corresponding
        LOCA::DerivUtils::computeDCeDxa() method of the passed
        LOCA::DerivUtils object.
        """
        return _MooreSpence.FiniteDifferenceGroup_computeDCeDxa(self, *args)

# Register FiniteDifferenceGroup in _MooreSpence:
_MooreSpence.FiniteDifferenceGroup_swigregister(FiniteDifferenceGroup)

class SolverFactory(object):
    r"""
    Factory for creating solver objects for solving Moore-Spence
    Hopf equations

    The parameters passed to the create() through the ``solverParams``
    argument method should specify the "Solver Method"
    as described below, as well as any additional parameters
    for the particular strategy.

    *  "Solver Method" - Name of the method. Valid choices are

      *  "Salinger Bordering" (LOCA::Hopf::MooreSpence::SalingerBordering) [Default]

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r""" Constructor"""
        _MooreSpence.SolverFactory_swiginit(self, _MooreSpence.new_SolverFactory(*args))
    __swig_destroy__ = _MooreSpence.delete_SolverFactory

    def create(self, *args) -> "Teuchos::RCP< LOCA::Hopf::MooreSpence::SolverStrategy >":
        r"""
         Create solver strategy
        :type topParams: Teuchos::RCP< LOCA::Parameter::SublistParser >
        :param topParams: [in] Parsed top-level parameter list.
        :type solverParams: :py:class:`ParameterList`
        :param solverParams: [in] Solver parameters as described above
        """
        return _MooreSpence.SolverFactory_create(self, *args)

    def strategyName(self, *args) -> "std::string const &":
        r""" Return strategy name given by ``solverParams``"""
        return _MooreSpence.SolverFactory_strategyName(self, *args)

# Register SolverFactory in _MooreSpence:
_MooreSpence.SolverFactory_swigregister(SolverFactory)

class SolverStrategy(object):
    r"""
    Abstract strategy for solving the Moore-Spence Hopf
    equations.

    This class provides an abstract interface for solver strategies to
    solve the Moore-Spence Hopf Newton system:

    .. math::

        \begin{bmatrix}
                 J       &    0   &    0   &   0  &    f_p     \\
              (Jy-wBz)_x &    J   &  -wB   & -Bz  & (Jy-wBz)_p \\
              (Jz+wBy)_x &   wB   &    J   &  By  & (Jz+wBy)_p \\
                 0       & \phi^T &    0   &   0  &     0      \\
                 0       &    0   & \phi^T &   0  &     0
            \end{bmatrix}
            \begin{bmatrix}
               X \\
               Y \\
               Z \\
               \Omega^T \\
               \Lambda^T
            \end{bmatrix} =
            \begin{bmatrix}
               F \\
               G \\
               H \\
               U^T \\
               V^T
            \end{bmatrix}.
    After instantiating a solver (via
    LOCA::Hopf::MooreSpence::SolverFactory), the linear
    system is set up by setBlocks() and can then be solved by solve().
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _MooreSpence.delete_SolverStrategy

    def setBlocks(self, *args) -> "void":
        r"""
         Set blocks in extended linear system
        :type group: :py:class:`AbstractGroup`
        :param group: [in] Underlying group representing J
        :type hopfGroup: :py:class:`ExtendedGroup`
        :param hopfGroup: [in] Hopf group representing the Hopf equations.
        :type yVector: Teuchos::RCP< NOX::Abstract::Vector const >
        :param yVector: [in] Vector representing y
        :type zVector: Teuchos::RCP< NOX::Abstract::Vector const >
        :param zVector: [in] Vector representing z
        :type CeRealVector: Teuchos::RCP< NOX::Abstract::Vector const >
        :param CeRealVector: [in] Vector representing Jy-wBz
        :type CeImagVector: Teuchos::RCP< NOX::Abstract::Vector const >
        :param CeImagVector: [in] Vector representing Jz+wBy
        :type dfdp: Teuchos::RCP< NOX::Abstract::Vector const >
        :param dfdp: [in] Vector representing df/dp
        :type dCedpReal: Teuchos::RCP< NOX::Abstract::Vector const >
        :param dCedpReal: [in] Vector representing d(Jy-wBz)/dp
        :type dCedpImag: Teuchos::RCP< NOX::Abstract::Vector const >
        :param dCedpImag: [in] Vector representing d(Jz+wBy)/dp
        :type ByVector: Teuchos::RCP< NOX::Abstract::Vector const >
        :param ByVector: [in] Vector representing By
        :type mBzVector: Teuchos::RCP< NOX::Abstract::Vector const >
        :param mBzVector: [in] Vector representing -Bz
        :type w: float
        :param w: [in] Bifurcation frequency w
        """
        return _MooreSpence.SolverStrategy_setBlocks(self, *args)

    def solve(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r"""
        Solves the extended system as defined above

        The *params* argument is the linear solver parameters.
        """
        return _MooreSpence.SolverStrategy_solve(self, *args)

# Register SolverStrategy in _MooreSpence:
_MooreSpence.SolverStrategy_swigregister(SolverStrategy)

class SalingerBordering(SolverStrategy):
    r"""
    Moore-Spence Hopf solver strategy based on
    "Salinger" bordering.  This is the classic 5-solve Hopf bordering
    method.

    This class solves the Moore-Spence Hopf Newton equations:

    .. math::

        \begin{bmatrix}
                 J       &    0   &    0   &   0  &    f_p     \\
              (Jy-wBz)_x &    J   &  -wB   & -Bz  & (Jy-wBz)_p \\
              (Jz+wBy)_x &   wB   &    J   &  By  & (Jz+wBy)_p \\
                 0       & \phi^T &    0   &   0  &     0      \\
                 0       &    0   & \phi^T &   0  &     0
            \end{bmatrix}
            \begin{bmatrix}
               X \\
               Y \\
               Z \\
               \omega \\
               \lambda
            \end{bmatrix} =
            \begin{bmatrix}
               F \\
               G \\
               H \\
               u \\
               v
            \end{bmatrix}.
     via the following block elimination scheme:

     .. math::

         \begin{split}
               J [A \; b] &= [F \; f_p] \\
               \begin{bmatrix}
                  J & -wB \\
                 wB &  J
               \end{bmatrix}
               \begin{bmatrix}
                  C & e & g \\
                  D & f & h
               \end{bmatrix} &=
               \begin{bmatrix}
                  G - (Jy-wBz)_x A & (Jy-wBz)_p - (Jy-wBz)_x b & -Bz \\
                  H - (Jz+wBy)_x A & (Jz+wBy)_p - (Jy-wBz)_x b &  By
               \end{bmatrix} \\
               \lambda &= \frac{(\phi^T h)(\phi^T C-u)-(\phi^T g)(\phi^T D-v)}
                               {(\phi^T h)(\phi^T e)-(\phi^T g)(\phi^T f)} \\
               \omega &= \frac{\phi^T D - v - (\phi^T f)\lambda}{\phi^T h} \\
               X &= A - b \lambda \\
               \begin{bmatrix}
                  Y \\
                  Z
               \end{bmatrix} &=
               \begin{bmatrix}
                  C \\
                  D
               \end{bmatrix} -
               \begin{bmatrix}
                  e \\
                  f
               \end{bmatrix}\lambda -
               \begin{bmatrix}
                  g \\
                  h
               \end{bmatrix}\omega
            \end{split}
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
         Constructor.
        :type global_data: Teuchos::RCP< LOCA::GlobalData >
        :param global_data: [in] Global data object
        :type topParams: Teuchos::RCP< LOCA::Parameter::SublistParser >
        :param topParams: [in] Parsed top-level parameter list
        :type solverParams: :py:class:`ParameterList`
        :param solverParams: [in] Bordered solver parameters.  Currently none
            are referenced.
        """
        _MooreSpence.SalingerBordering_swiginit(self, _MooreSpence.new_SalingerBordering(*args))
    __swig_destroy__ = _MooreSpence.delete_SalingerBordering

    def setBlocks(self, *args) -> "void":
        r"""
         Set blocks in extended linear system
        :type group: :py:class:`AbstractGroup`
        :param group: [in] Underlying group representing J
        :type hopfGroup: :py:class:`ExtendedGroup`
        :param hopfGroup: [in] Hopf group representing the Hopf equations.
        :type yVector: Teuchos::RCP< NOX::Abstract::Vector const >
        :param yVector: [in] Vector representing y
        :type zVector: Teuchos::RCP< NOX::Abstract::Vector const >
        :param zVector: [in] Vector representing z
        :type CeRealVector: Teuchos::RCP< NOX::Abstract::Vector const >
        :param CeRealVector: [in] Vector representing Jy-wBz
        :type CeImagVector: Teuchos::RCP< NOX::Abstract::Vector const >
        :param CeImagVector: [in] Vector representing Jz+wBy
        :type dfdp: Teuchos::RCP< NOX::Abstract::Vector const >
        :param dfdp: [in] Vector representing df/dp
        :type dCedpReal: Teuchos::RCP< NOX::Abstract::Vector const >
        :param dCedpReal: [in] Vector representing d(Jy-wBz)/dp
        :type dCedpImag: Teuchos::RCP< NOX::Abstract::Vector const >
        :param dCedpImag: [in] Vector representing d(Jz+wBy)/dp
        :type ByVector: Teuchos::RCP< NOX::Abstract::Vector const >
        :param ByVector: [in] Vector representing By
        :type mBzVector: Teuchos::RCP< NOX::Abstract::Vector const >
        :param mBzVector: [in] Vector representing -Bz
        :type w: float
        :param w: [in] Bifurcation frequency w
        """
        return _MooreSpence.SalingerBordering_setBlocks(self, *args)

    def solve(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r"""
        Solves the extended system as defined above

        The *params* argument is the linear solver parameters.
        """
        return _MooreSpence.SalingerBordering_solve(self, *args)

# Register SalingerBordering in _MooreSpence:
_MooreSpence.SalingerBordering_swigregister(SalingerBordering)



