# This file was automatically generated by SWIG (http://www.swig.org).
# Version 4.0.2
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.

"""

PyTrilinos.LOCA.MultiContinuation is the python interface to namespace
MultiContinuation of the Trilinos continuation algorithm package LOCA:

    https://trilinos.org/docs/dev/packages/nox/doc/html/index.html

The purpose of LOCA.MultiContinuation is to provide groups and vectors
for multi-parameter continuation.  The python version of
LOCA.MultiContinuation supports the following classes:

    * AbstractGroup            - LOCA abstract interface for continuation,
                                 derived from the NOX.Abstract.Group.  This
                                 abstract class provides the interface
                                 necessary to perform continuation, i.e.,
                                 compute families of solutions to F(x,p) = 0
    * FiniteDifferenceGroup    - Concrete class that provides a concrete
                                 implementation of the computeDfDp() method of
                                 the LOCA.Continuation.AbstractGroup using
                                 first-order finite differencing
    * ConstraintInterface      - Abstract interface for the constraint portion
                                 of a constrained nonlinear system
    * ConstraintInterfaceMVDX  - Abstract interface for the constraint portion
                                 of a constrained nonlinear system for
                                 constraints that support computing a solution
                                 component derivative as a multi-vector
    * ExtendedMultiVector      - MultiVector class to hold solution vectors,
                                 Newton vectors, etc. for continuation equations
    * ExtendedVector           - Vector class to hold solution vectors, Newton
                                 vectors, etc. for continuation equations
    * Factory                  - Factory for creating continuation strategy
                                 objects

"""

from sys import version_info as _swig_python_version_info
if _swig_python_version_info < (2, 7, 0):
    raise RuntimeError("Python 2.7 or later required")


if not __package__:
    __package__ = 'PyTrilinos.LOCA'
from . import _MultiContinuation
import PyTrilinos.Teuchos.Base
import PyTrilinos.NOX.Abstract
import PyTrilinos.Epetra
from PyTrilinos.LOCA import Extended


try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)


def _swig_setattr_nondynamic_instance_variable(set):
    def set_instance_attr(self, name, value):
        if name == "thisown":
            self.this.own(value)
        elif name == "this":
            set(self, name, value)
        elif hasattr(self, name) and isinstance(getattr(type(self), name), property):
            set(self, name, value)
        else:
            raise AttributeError("You cannot add instance attributes to %s" % self)
    return set_instance_attr


def _swig_setattr_nondynamic_class_variable(set):
    def set_class_attr(cls, name, value):
        if hasattr(cls, name) and not isinstance(getattr(cls, name), property):
            set(cls, name, value)
        else:
            raise AttributeError("You cannot add class attributes to %s" % cls)
    return set_class_attr


def _swig_add_metaclass(metaclass):
    """Class decorator for adding a metaclass to a SWIG wrapped class - a slimmed down version of six.add_metaclass"""
    def wrapper(cls):
        return metaclass(cls.__name__, cls.__bases__, cls.__dict__.copy())
    return wrapper


class _SwigNonDynamicMeta(type):
    """Meta class to enforce nondynamic attributes (no new attributes) for a class"""
    __setattr__ = _swig_setattr_nondynamic_class_variable(type.__setattr__)


import weakref

import PyTrilinos.Teuchos.Base

import sys, os.path as op
thisDir = op.dirname(op.abspath(__file__))
if not thisDir in sys.path: sys.path.append(thisDir)
del sys, op

import PyTrilinos.NOX.Abstract
import PyTrilinos.Epetra
import Extended
class AbstractGroup(PyTrilinos.NOX.Abstract.Group):
    r"""
    %LOCA abstract interface for continuation, derived from the
    NOX::Abstract::Group.  This abstract class provides
    the interface necessary to perform continuation, i.e., compute
    families of solutions to :math:`F(x,p) = 0`.

    Concrete implemenations of this interface must provide implementations
    of all of the methods in the NOX::Abstract::Group interface as well as
    the additional interface defined here.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _MultiContinuation.delete_AbstractGroup

    def copy(self, *args) -> "void":
        r""" Copy the group (replaces operator = )"""
        return _MultiContinuation.AbstractGroup_copy(self, *args)

    def setParamsMulti(self, *args) -> "void":
        r""" Set parameters indexed by (integer) paramIDs"""
        return _MultiContinuation.AbstractGroup_setParamsMulti(self, *args)

    def setParams(self, *args) -> "void":
        r""" Set the parameter vector in the group to p (pVector = p)."""
        return _MultiContinuation.AbstractGroup_setParams(self, *args)

    def setParam(self, *args) -> "void":
        r"""
        *Overload 1:*
        Set parameter indexed by (integer) paramID

        |

        *Overload 2:*
        Set parameter indexed by (std::string) paramID
        """
        return _MultiContinuation.AbstractGroup_setParam(self, *args)

    def getParams(self, *args) -> "LOCA::ParameterVector const &":
        r""" Return a const reference to the ParameterVector owned by the group."""
        return _MultiContinuation.AbstractGroup_getParams(self, *args)

    def getParam(self, *args) -> "double":
        r"""
        *Overload 1:*
        Return copy of parameter indexed by (integer) paramID

        |

        *Overload 2:*
        Return copy of parameter indexed by (std::string) paramID
        """
        return _MultiContinuation.AbstractGroup_getParam(self, *args)

    def computeDfDpMulti(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r"""
        Compute :math:`\partial F/\partial p` for each parameter :math:`p`
        indexed by paramIDs.  The first column of *dfdp* holds F,
        which is valid if *isValidF* is true.  Otherwise F must be
        computed.
        """
        return _MultiContinuation.AbstractGroup_computeDfDpMulti(self, *args)

    def preProcessContinuationStep(self, *args) -> "void":
        r"""
         Perform any preprocessing before a continuation step starts.
        The ``stepStatus`` argument indicates whether the previous step was
        successful.  The default implementation to empty.
        """
        return _MultiContinuation.AbstractGroup_preProcessContinuationStep(self, *args)

    def postProcessContinuationStep(self, *args) -> "void":
        r"""
         Perform any postprocessing after a continuation step finishes.
        The ``stepStatus`` argument indicates whether the step was
        successful.  The default implementation to empty.
        """
        return _MultiContinuation.AbstractGroup_postProcessContinuationStep(self, *args)

    def projectToDraw(self, *args) -> "void":
        r"""
         Projects solution to a few scalars for multiparameter continuation
        This method is called every time a solution is saved by the
        multiparameter continuation code MF for later visualization
        and should project the solution vector down to a few scalars.
        The array ``px`` will be preallocated to the proper length
        given by projectToDrawDimension().

        The default implementation is the max norm of the vector.
        """
        return _MultiContinuation.AbstractGroup_projectToDraw(self, *args)

    def projectToDrawDimension(self, *args) -> "int":
        r"""
         Returns the dimension of the project to draw array
        The default implementation is to return 1 since the default
        projection is the max norm of the vector (a scalar).
        """
        return _MultiContinuation.AbstractGroup_projectToDrawDimension(self, *args)

    def computeScaledDotProduct(self, *args) -> "double":
        r"""
         Compute a scaled dot product
        The default implementation here just computes a.dot(b) but should
        be overloaded for any problem that his difficult scaling.
        """
        return _MultiContinuation.AbstractGroup_computeScaledDotProduct(self, *args)

    def printSolution(self, *args) -> "void":
        r"""
        *Overload 1:*
         Function to print out solution and parameter after successful step
        Empty default definition.

        |

        *Overload 2:*
         Function to print out a vector and parameter after successful step
        Empty default definition.
        """
        return _MultiContinuation.AbstractGroup_printSolution(self, *args)

    def scaleVector(self, *args) -> "void":
        r"""
         Scales a vector using scaling vector
        The default definition here is to do nothing, i.e., no scaling
        """
        return _MultiContinuation.AbstractGroup_scaleVector(self, *args)

# Register AbstractGroup in _MultiContinuation:
_MultiContinuation.AbstractGroup_swigregister(AbstractGroup)

class FiniteDifferenceGroup(AbstractGroup):
    r"""
    Concrete class that provides a concrete implementation of the
    computeDfDp() method of the LOCA::Continuation::AbstractGroup using
    first-order finite differencing.

    The finite-differencing calculations are actually implemented by
    the LOCA::DerivUtils class, and a custom DerivUtils object can be
    set by the setDerivUtils() method.  However, in the future
    the calculations encapsulated in the DerivUtils class may be
    incorporated directly into this class and other finite-differencing
    child classes.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _MultiContinuation.delete_FiniteDifferenceGroup

    def copy(self, *args) -> "void":
        r""" Copy"""
        return _MultiContinuation.FiniteDifferenceGroup_copy(self, *args)

    def setDerivUtils(self, *args) -> "void":
        r""" Set the LOCA::DerivUtils object"""
        return _MultiContinuation.FiniteDifferenceGroup_setDerivUtils(self, *args)

    def computeDfDpMulti(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r"""
        Compute :math:`\partial F/\partial p` for each parameter :math:`p`
        indexed by paramIDs.  The first column of *dfdp* holds F,
        which is valid if *isValidF* is true.  Otherwise F must be
        computed.

        The calculation is implemented by calling the corresponding
        LOCA::DerivUtils::computeDfDp() method of the passed
        LOCA::DerivUtils object.
        """
        return _MultiContinuation.FiniteDifferenceGroup_computeDfDpMulti(self, *args)

# Register FiniteDifferenceGroup in _MultiContinuation:
_MultiContinuation.FiniteDifferenceGroup_swigregister(FiniteDifferenceGroup)

class ConstraintInterface(object):
    r"""
    Abstract interface for the constraint portion of a constrained
    nonlinear system.

    This class is used in conjunction with
    LOCA::MultiContinuation::ConstrainedGroup to represent a constrained
    nonlinear system:

    .. math::

        f(x,y) = 0
             g(x,y) = 0
    where :math:`f(x,y)` is represented by a concrete implementation of
    a LOCA::MultiContinuation::AbstractGroup and :math:`g(x,y)` (the
    constraint) is represented by an implementation of this class.  Here
    it is assumed the resulting system is square, i.e., :math:`x\in\Re^n`,
    :math:`y\in\Re^m`, :math:`f(x,y)\in\Re^n` and :math:`g(x,y)\in\Re^m`.

    This class provides an interface to evaluate :math:`g(x,y)`, compute
    the derivatives :math:`g_x` and :math:`g_y`, and apply the derivative
    :math:`g_x` to arbitrary multi-vectors (the implementation is never
    required to explicitly store :math:`g_x` which is impractical in
    many situations).
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r""" Constructor"""
        if self.__class__ == ConstraintInterface:
            _self = None
        else:
            _self = self
        _MultiContinuation.ConstraintInterface_swiginit(self, _MultiContinuation.new_ConstraintInterface(_self, *args))
    __swig_destroy__ = _MultiContinuation.delete_ConstraintInterface

    def copy(self, *args) -> "void":
        r""" Copy"""
        return _MultiContinuation.ConstraintInterface_copy(self, *args)

    def clone(self, *args) -> "Teuchos::RCP< LOCA::MultiContinuation::ConstraintInterface >":
        r""" Cloning function"""
        return _MultiContinuation.ConstraintInterface_clone(self, *args)

    def numConstraints(self, *args) -> "int":
        r""" Return number of constraints"""
        return _MultiContinuation.ConstraintInterface_numConstraints(self, *args)

    def setX(self, *args) -> "void":
        r""" Set the solution vector to x."""
        return _MultiContinuation.ConstraintInterface_setX(self, *args)

    def setParam(self, *args) -> "void":
        r""" Sets parameter indexed by paramID"""
        return _MultiContinuation.ConstraintInterface_setParam(self, *args)

    def setParams(self, *args) -> "void":
        r""" Sets parameters indexed by paramIDs"""
        return _MultiContinuation.ConstraintInterface_setParams(self, *args)

    def computeConstraints(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r""" Compute constraint residuals"""
        return _MultiContinuation.ConstraintInterface_computeConstraints(self, *args)

    def computeDX(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r""" Compute derivative of constraints w.r.t. solution vector x"""
        return _MultiContinuation.ConstraintInterface_computeDX(self, *args)

    def computeDP(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r"""
         Compute derivative of constraints w.r.t. supplied parameters.
        The first column of ``dgdp`` should be filled with the constraint
        residuals :math:`g` if ``isValidG`` is ``false``.  If ``isValidG`` is
        ``true``, then the ``dgdp`` contains :math:`g` on input.
        """
        return _MultiContinuation.ConstraintInterface_computeDP(self, *args)

    def isConstraints(self, *args) -> "bool":
        r""" Return ``true`` if constraint residuals are valid"""
        return _MultiContinuation.ConstraintInterface_isConstraints(self, *args)

    def isDX(self, *args) -> "bool":
        r""" Return ``true`` if derivative of constraint w.r.t. x is valid"""
        return _MultiContinuation.ConstraintInterface_isDX(self, *args)

    def getConstraints(self, *args) -> "NOX::Abstract::MultiVector::DenseMatrix const &":
        r""" Return constraint residuals"""
        return _MultiContinuation.ConstraintInterface_getConstraints(self, *args)

    def multiplyDX(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r"""
         Compute result_p = alpha * dg/dx * input_x
        Note that if there are n constraints and input_x has m columns,
        result_p should be a n by m matrix and is equivalent to

        .. code-block:: c++

               input_x.multiply(alpha, dgdx, result_p).
        """
        return _MultiContinuation.ConstraintInterface_multiplyDX(self, *args)

    def addDX(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r"""
         Compute result_x = alpha * dg/dx^T * op(b) + beta * result_x
        Note that this should be equivalent to

        .. code-block:: c++

               result_x.update(transb, alpha, dgdx, b, beta);
        """
        return _MultiContinuation.ConstraintInterface_addDX(self, *args)

    def isDXZero(self, *args) -> "bool":
        r"""
        Return ``true`` if solution component of constraint
        derivatives is zero
        """
        return _MultiContinuation.ConstraintInterface_isDXZero(self, *args)

    def preProcessContinuationStep(self, *args) -> "void":
        r"""
         Perform any preprocessing before a continuation step starts.
        The ``stepStatus`` argument indicates whether the previous step was
        successful.  The default implementation is empty.
        """
        return _MultiContinuation.ConstraintInterface_preProcessContinuationStep(self, *args)

    def postProcessContinuationStep(self, *args) -> "void":
        r"""
         Perform any postprocessing after a continuation step finishes.
        The ``stepStatus`` argument indicates whether the step was
        successful.  The default implementation is empty.
        """
        return _MultiContinuation.ConstraintInterface_postProcessContinuationStep(self, *args)
    def __disown__(self):
        self.this.disown()
        _MultiContinuation.disown_ConstraintInterface(self)
        return weakref.proxy(self)

# Register ConstraintInterface in _MultiContinuation:
_MultiContinuation.ConstraintInterface_swigregister(ConstraintInterface)

class ConstraintInterfaceMVDX(ConstraintInterface):
    r"""
    Abstract interface for the constraint portion of a constrained
    nonlinear system for constraints that support computing a solution
    component derivative as a multi-vector.

    This class extends the LOCA::MultiContinuation::ConstraintInterface
    to support constraints that support computing the entire derivative
    with respect to the solution components (x) and storing the resulting
    derivative as a multivector.  This interface adds one additional
    method, getConstraintDerivativesX(), that returns this derivative.
    Additionally, it implements the applyConstraintDerivativesX() methods
    using standard multi-vector operations.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r""" Constructor"""
        if self.__class__ == ConstraintInterfaceMVDX:
            _self = None
        else:
            _self = self
        _MultiContinuation.ConstraintInterfaceMVDX_swiginit(self, _MultiContinuation.new_ConstraintInterfaceMVDX(_self, *args))
    __swig_destroy__ = _MultiContinuation.delete_ConstraintInterfaceMVDX

    def getDX(self, *args) -> "NOX::Abstract::MultiVector const *":
        r"""
         Return solution component of constraint derivatives
        May return NULL if constraint derivative is zero
        """
        return _MultiContinuation.ConstraintInterfaceMVDX_getDX(self, *args)

    def multiplyDX(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r"""
         Compute result_p = alpha * dg/dx * input_x
        This method is implemented using getConstraintDerivativesX()
        and the NOX::Abstract::MultiVector::multiply() method.
        """
        return _MultiContinuation.ConstraintInterfaceMVDX_multiplyDX(self, *args)

    def addDX(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r"""
         Compute result_x = alpha * dg/dx^T * op(b) + beta * result_x
        This method is implemented using getConstraintDerivativesX()
        and the NOX::Abstract::MultiVector::update() method.
        """
        return _MultiContinuation.ConstraintInterfaceMVDX_addDX(self, *args)
    def __disown__(self):
        self.this.disown()
        _MultiContinuation.disown_ConstraintInterfaceMVDX(self)
        return weakref.proxy(self)

# Register ConstraintInterfaceMVDX in _MultiContinuation:
_MultiContinuation.ConstraintInterfaceMVDX_swigregister(ConstraintInterfaceMVDX)

class ExtendedMultiVector(Extended.MultiVector):
    r"""
          %MultiVector class to hold solution vectors, %Newton vectors, etc.
          for continuation equations.

    This class uses the LOCA::Extended::MultiVector implementation to
    store the solution and parameter components of the continuation vector
    and merely provides an interface for naming which components of the
    multivector these quantities correspond to.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        *Overload 1:*
         Constructor.
        Generates a multivector with nColumns from *xVec* amd
        *nScalarRows* of zeros.

        |

        *Overload 2:*
         Constructor.
        Initializes the scalar matrix to *nScalarRows* rows and
        *xVec.numVectors()* columns of zeros

        |

        *Overload 3:*
         Constructor.
        Sets the scalar matrix explicitly

        |

        *Overload 4:*
         Copy constructor.

        |

        *Overload 5:*

        Copy constructor that creates a new multivector with
        *nColumns* columns.

        |

        *Overload 6:*

        Copy constructor that creates a sub copy or view of the
        given multivector
        """
        _MultiContinuation.ExtendedMultiVector_swiginit(self, _MultiContinuation.new_ExtendedMultiVector(*args))
    __swig_destroy__ = _MultiContinuation.delete_ExtendedMultiVector

    def clone(self, *args) -> "Teuchos::RCP< NOX::Abstract::MultiVector >":
        r"""
        Create a new multi-vector of the same underlying type by
        cloning "this", and return a pointer to the new vector.
        """
        return _MultiContinuation.ExtendedMultiVector_clone(self, *args)

    def subCopy(self, *args) -> "Teuchos::RCP< NOX::Abstract::MultiVector >":
        r"""
        Creates a new multi-vector with ``index.size()`` columns whose
        columns are copies of the columns of ``*this`` given by ``index``.
        """
        return _MultiContinuation.ExtendedMultiVector_subCopy(self, *args)

    def subView(self, *args) -> "Teuchos::RCP< NOX::Abstract::MultiVector >":
        r"""
        Creates a new multi-vector with ``index.size()`` columns that
        shares the columns of ``*this`` given by ``index``.
        """
        return _MultiContinuation.ExtendedMultiVector_subView(self, *args)

    def getXMultiVec(self, *args) -> "Teuchos::RCP< NOX::Abstract::MultiVector >":
        r"""
        *Overload 1:*
        Returns the solution vector component of extended multivector

        |

        *Overload 2:*
        Returns the solution vector component of extended multivector
        """
        return _MultiContinuation.ExtendedMultiVector_getXMultiVec(self, *args)

# Register ExtendedMultiVector in _MultiContinuation:
_MultiContinuation.ExtendedMultiVector_swigregister(ExtendedMultiVector)

class ExtendedVector(Extended.Vector):
    r"""
    %Vector class to hold solution vectors, %Newton vectors, etc.
    for continuation equations.

     This class uses the LOCA::Extended::Vector implementation to store the
     solution and parameter components of the continuation vector
     and merely provides an interface for naming which components of the
     multivector these quantities correspond to.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        *Overload 1:*
        Constructor.

        |

        *Overload 2:*
        Copy constructor.
        """
        _MultiContinuation.ExtendedVector_swiginit(self, _MultiContinuation.new_ExtendedVector(*args))
    __swig_destroy__ = _MultiContinuation.delete_ExtendedVector

    def clone(self, *args) -> "Teuchos::RCP< NOX::Abstract::Vector >":
        r""" Assignment operator"""
        return _MultiContinuation.ExtendedVector_clone(self, *args)

    def getXVec(self, *args) -> "Teuchos::RCP< NOX::Abstract::Vector >":
        r"""
        *Overload 1:*
        Returns the solution vector component of extended vector

        |

        *Overload 2:*
        Returns the solution vector component of extended vector
        """
        return _MultiContinuation.ExtendedVector_getXVec(self, *args)

# Register ExtendedVector in _MultiContinuation:
_MultiContinuation.ExtendedVector_swigregister(ExtendedVector)

class Factory(object):
    r"""
     Factory for creating continuation strategy objects
    The parameters passed to the create() through the ``stepperParams``
    argument method should specify the "Continuation Method" as described
    below, as well as any additional parameters for the particular strategy.

    *  "Continuation Method" - Name of the continuation method. Valid
         choices are

      *  "Arc Length" (LOCA::MultiContinuation::ArcLengthGroup) [Default]
      *  "Natural" (LOCA::MultiContinuation::NaturalGroup)

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r""" Constructor"""
        _MultiContinuation.Factory_swiginit(self, _MultiContinuation.new_Factory(*args))
    __swig_destroy__ = _MultiContinuation.delete_Factory

    def create(self, *args) -> "Teuchos::RCP< LOCA::MultiContinuation::AbstractStrategy >":
        r"""
         Create continuation strategy
        :type topParams: Teuchos::RCP< LOCA::Parameter::SublistParser >
        :param topParams: [in] Parsed top-level parameter list.
        :type stepperParams: :py:class:`ParameterList`
        :param stepperParams: [in] Stepper parameters as described above
        :type grp: :py:class:`AbstractGroup`
        :param grp: [in] Underlying group
        :type pred: Teuchos::RCP< LOCA::MultiPredictor::AbstractStrategy >
        :param pred: [in] Predictor strategy
        :type paramIDs: std::vector< int,std::allocator< int > >
        :param paramIDs: [in] Indicies of continuation parameters
        """
        return _MultiContinuation.Factory_create(self, *args)

    def strategyName(self, *args) -> "std::string const &":
        r""" Return strategy name given by ``stepperParams``"""
        return _MultiContinuation.Factory_strategyName(self, *args)

# Register Factory in _MultiContinuation:
_MultiContinuation.Factory_swigregister(Factory)



