# This file was automatically generated by SWIG (http://www.swig.org).
# Version 4.0.2
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.

"""

PyTrilinos.LOCA.Parameter is the python interface to namespace
Parameter of the Trilinos continuation algorithm package LOCA:

    https://trilinos.org/docs/dev/packages/nox/doc/html/index.html

The purpose of LOCA.Parameter is to provide a centralized library for
setting/retrieving numerical parameter values in application codes.
The python version of LOCA.Parameter supports the following classes:

    * Library  - Class to provide a centralized library for setting/retrieving
                 numerical parameter values in application codes

"""

from sys import version_info as _swig_python_version_info
if _swig_python_version_info < (2, 7, 0):
    raise RuntimeError("Python 2.7 or later required")

# Import the low-level C/C++ module
if __package__ or "." in __name__:
    from . import _Parameter
else:
    import _Parameter

try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)


def _swig_setattr_nondynamic_instance_variable(set):
    def set_instance_attr(self, name, value):
        if name == "thisown":
            self.this.own(value)
        elif name == "this":
            set(self, name, value)
        elif hasattr(self, name) and isinstance(getattr(type(self), name), property):
            set(self, name, value)
        else:
            raise AttributeError("You cannot add instance attributes to %s" % self)
    return set_instance_attr


def _swig_setattr_nondynamic_class_variable(set):
    def set_class_attr(cls, name, value):
        if hasattr(cls, name) and not isinstance(getattr(cls, name), property):
            set(cls, name, value)
        else:
            raise AttributeError("You cannot add class attributes to %s" % cls)
    return set_class_attr


def _swig_add_metaclass(metaclass):
    """Class decorator for adding a metaclass to a SWIG wrapped class - a slimmed down version of six.add_metaclass"""
    def wrapper(cls):
        return metaclass(cls.__name__, cls.__bases__, cls.__dict__.copy())
    return wrapper


class _SwigNonDynamicMeta(type):
    """Meta class to enforce nondynamic attributes (no new attributes) for a class"""
    __setattr__ = _swig_setattr_nondynamic_class_variable(type.__setattr__)


import weakref

import PyTrilinos.Teuchos.Base
class Library(object):
    r"""
    Class to provide a centralized library for setting/retrieving
    numerical parameter values in application codes.

    This class provides a mechanism for setting and retrieving arbitrary
    numerical parameter values throughout an application code.  Parameters
    can be
    material properties, coefficients in source functions, etc.  The
    purpose of this class is to allow external libraries to set and
    retrieve parameters values to perform, for example, numerical
    continuation and optimization.

    This class in currently under development and is far from complete.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r""" Default constructor"""
        _Parameter.Library_swiginit(self, _Parameter.new_Library(*args))
    __swig_destroy__ = _Parameter.delete_Library

# Register Library in _Parameter:
_Parameter.Library_swigregister(Library)

class ParameterVector(object):
    r"""
    %LOCA's container for holding a set of parameters that are
    used by the LOCA continuation routines.

    Author: Roger Pawlowski (SNL 9233)
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        *Overload 1:*
        Constructor.

        |

        *Overload 2:*
        Copy constructor
        """
        _Parameter.ParameterVector_swiginit(self, _Parameter.new_ParameterVector(*args))

    def clone(self, *args) -> "LOCA::ParameterVector *":
        r""" Clone"""
        return _Parameter.ParameterVector_clone(self, *args)
    __swig_destroy__ = _Parameter.delete_ParameterVector

    def addParameter(self, *args) -> "int":
        r""" Adds a parameter to the list.  Returns the index value assigned to the parameter."""
        return _Parameter.ParameterVector_addParameter(self, *args)

    def init(self, *args) -> "bool":
        r""" Initialize the vector.  Returns true if successful."""
        return _Parameter.ParameterVector_init(self, *args)

    def scale(self, *args) -> "bool":
        r"""
        *Overload 1:*
        Scales the entire vector by value.  Returns true if successful.

        |

        *Overload 2:*
        Scales the vactor with another vector (element-wise multiply).  Returns true if successful.
        """
        return _Parameter.ParameterVector_scale(self, *args)

    def update(self, *args) -> "bool":
        r""" Updates the parameter vector: this = alpha * alphaVector + b * this.  Returns true if successful."""
        return _Parameter.ParameterVector_update(self, *args)

    def setValue(self, *args) -> "void":
        r"""
        *Overload 1:*
        Set the value of the parameter with index i.  Will throw an error if index is out of range.

        |

        *Overload 2:*
        Set the value of the parameter with the corresponding label.  Will throw an error if "label" is not valid.
        """
        return _Parameter.ParameterVector_setValue(self, *args)

    def getValue(self, *args) -> "double":
        r"""
        *Overload 1:*
        Returns the value of the parameter with index i.  Will throw an error if index is out of range.

        |

        *Overload 2:*
        Returns the value of the parameter with the corresponding label.  Will throw an error if "label" is not valid.
        """
        return _Parameter.ParameterVector_getValue(self, *args)

    def getIndex(self, *args) -> "int":
        r""" Returns the index of the parameter with the corresponding label.  Returns a -1 if "label" is not found."""
        return _Parameter.ParameterVector_getIndex(self, *args)

    def getDoubleArrayPointer(self, *args) -> "double *":
        r""" Returns a pointer to a C-style array of the parameter values."""
        return _Parameter.ParameterVector_getDoubleArrayPointer(self, *args)

    def isParameter(self, *args) -> "bool":
        r""" Returns true if the parameter std::string "label" corresponds to a parameter label in the object."""
        return _Parameter.ParameterVector_isParameter(self, *args)

    def getLabel(self, *args) -> "std::string":
        r""" Returns the label of the parameter with index i."""
        return _Parameter.ParameterVector_getLabel(self, *args)

    def length(self, *args) -> "int":
        r""" Returns the length of parameter vector."""
        return _Parameter.ParameterVector_length(self, *args)

    def getValuesVector(self, *args) -> "std::vector< double,std::allocator< double > > const &":
        r""" Accessor to get the underlying stl vector with all parameter values"""
        return _Parameter.ParameterVector_getValuesVector(self, *args)

    def getNamesVector(self, *args) -> "std::vector< std::string,std::allocator< std::string > > const &":
        r""" Accessor to get the underlying stl vector with all parameter names"""
        return _Parameter.ParameterVector_getNamesVector(self, *args)

# Register ParameterVector in _Parameter:
_Parameter.ParameterVector_swigregister(ParameterVector)


def __lshift__(*args) -> "std::ostream &":
    r""" Overload the operator<< to print ParameterVector objects."""
    return _Parameter.__lshift__(*args)


