# This file was automatically generated by SWIG (http://www.swig.org).
# Version 4.0.2
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.

"""

PyTrilinos.LOCA.Pitchfork.MinimallyAugmented is the python interface
to namespace Pitchfork::MinimallyAugmented of the Trilinos
continuation algorithm package LOCA:

    https://trilinos.org/docs/dev/packages/nox/doc/html/index.html

The purpose of LOCA.Pitchfork.MinimallyAugmented is to provide ***.
The python version of LOCA.Pitchfork.MinimallyAugmented supports the
following classes:

    * AbstractGroup  - Interface to underlying groups for pitchfork
                       calculations using the minimally augmented formulation

"""

from sys import version_info as _swig_python_version_info
if _swig_python_version_info < (2, 7, 0):
    raise RuntimeError("Python 2.7 or later required")


from . import _MinimallyAugmented
import PyTrilinos.Teuchos.Base
import PyTrilinos.NOX.Abstract
import PyTrilinos.Epetra
from PyTrilinos.LOCA import MultiContinuation
from PyTrilinos.LOCA import TurningPoint
from . import MooreSpence


try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)


def _swig_setattr_nondynamic_instance_variable(set):
    def set_instance_attr(self, name, value):
        if name == "thisown":
            self.this.own(value)
        elif name == "this":
            set(self, name, value)
        elif hasattr(self, name) and isinstance(getattr(type(self), name), property):
            set(self, name, value)
        else:
            raise AttributeError("You cannot add instance attributes to %s" % self)
    return set_instance_attr


def _swig_setattr_nondynamic_class_variable(set):
    def set_class_attr(cls, name, value):
        if hasattr(cls, name) and not isinstance(getattr(cls, name), property):
            set(cls, name, value)
        else:
            raise AttributeError("You cannot add class attributes to %s" % cls)
    return set_class_attr


def _swig_add_metaclass(metaclass):
    """Class decorator for adding a metaclass to a SWIG wrapped class - a slimmed down version of six.add_metaclass"""
    def wrapper(cls):
        return metaclass(cls.__name__, cls.__bases__, cls.__dict__.copy())
    return wrapper


class _SwigNonDynamicMeta(type):
    """Meta class to enforce nondynamic attributes (no new attributes) for a class"""
    __setattr__ = _swig_setattr_nondynamic_class_variable(type.__setattr__)


import weakref

import PyTrilinos.Teuchos.Base
import PyTrilinos.NOX.Abstract
import PyTrilinos.Epetra
import MultiContinuation
import TurningPoint.MooreSpence
import TurningPoint.MinimallyAugmented
import MooreSpence
class AbstractGroup(TurningPoint.MinimallyAugmented.AbstractGroup, MooreSpence.AbstractGroup):
    r"""
    Interface to underlying groups for pitchfork calculations
    using the minimally augmented formulation.

    This abstract class provides the required interface for underlying
    groups to locate pitchforks using the minimally augmented pitchfork
    formulation (see
    LOCA::Pitchfork::MinimallyAugmented::ExtendedGroup for a
    description of the governing equations).

    This class is derived from the
    LOCA::Pitchfork::MooreSpence::AbstractGroup and
    LOCA::TurningPoint::MinimallyAugmented::AbstractGroup and does not
    declare any new virtual methods.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _MinimallyAugmented.delete_AbstractGroup

# Register AbstractGroup in _MinimallyAugmented:
_MinimallyAugmented.AbstractGroup_swigregister(AbstractGroup)



