# This file was automatically generated by SWIG (http://www.swig.org).
# Version 4.0.2
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.

"""

PyTrilinos.LOCA.Pitchfork.MooreSpence is the python interface to
namespace Pitchfork::MooreSpence of the Trilinos continuation
algorithm package LOCA:

    https://trilinos.org/docs/dev/packages/nox/doc/html/index.html

The purpose of LOCA.Pitchfork.MooreSpence is to provide groups and
vectors for locating pitchfork bifurcations using the Moore-Spence
formulation.  The python version of LOCA.Pitchfork.MooreSpence
supports the following classes:

    * AbstractGroup  - Interface to underlying groups for pitchfork
                       calculations using the Moore-Spence formulation
    * SolverFactory  - Factory for creating solver objects for solving Moore-
                       Spence pitchfork equations

"""

from sys import version_info as _swig_python_version_info
if _swig_python_version_info < (2, 7, 0):
    raise RuntimeError("Python 2.7 or later required")

# Import the low-level C/C++ module
if __package__ or "." in __name__:
    from . import _MooreSpence
else:
    import _MooreSpence

try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)


def _swig_setattr_nondynamic_instance_variable(set):
    def set_instance_attr(self, name, value):
        if name == "thisown":
            self.this.own(value)
        elif name == "this":
            set(self, name, value)
        elif hasattr(self, name) and isinstance(getattr(type(self), name), property):
            set(self, name, value)
        else:
            raise AttributeError("You cannot add instance attributes to %s" % self)
    return set_instance_attr


def _swig_setattr_nondynamic_class_variable(set):
    def set_class_attr(cls, name, value):
        if hasattr(cls, name) and not isinstance(getattr(cls, name), property):
            set(cls, name, value)
        else:
            raise AttributeError("You cannot add class attributes to %s" % cls)
    return set_class_attr


def _swig_add_metaclass(metaclass):
    """Class decorator for adding a metaclass to a SWIG wrapped class - a slimmed down version of six.add_metaclass"""
    def wrapper(cls):
        return metaclass(cls.__name__, cls.__bases__, cls.__dict__.copy())
    return wrapper


class _SwigNonDynamicMeta(type):
    """Meta class to enforce nondynamic attributes (no new attributes) for a class"""
    __setattr__ = _swig_setattr_nondynamic_class_variable(type.__setattr__)


import weakref

import PyTrilinos.Teuchos.Base
import PyTrilinos.NOX.Abstract
import PyTrilinos.Epetra
import MultiContinuation
import TurningPoint.MooreSpence
class AbstractGroup(TurningPoint.MooreSpence.AbstractGroup):
    r"""
    Interface to underlying groups for pitchfork calculations
    using the Moore-Spence formulation.

    This abstract class provides the required interface for underlying
    groups to locate pitchforks using the bordering algorithms for the
    Moore-Spence pitchfork formulation (see
    LOCA::Pitchfork::MooreSpence::ExtendedGroup for a description of the
    governing equations).

    This class is derived from the
    LOCA::TurningPoint::MooreSpence::AbstractGroup and declares a single
    virtual method, innerProduct(), to compute the inner product of a
    vector with the asymmetry vector.  It has a default implementation
    given by the dot product, but should be overloaded for any
    problem that has a different definition for the inner product.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _MooreSpence.delete_AbstractGroup

    def innerProduct(self, *args) -> "void":
        r"""
        *Overload 1:*
         Compute the inner product of ``a`` and ``b``.
        The default implementation is given by the dot product of
        ``a`` and ``b``.

        |

        *Overload 2:*
         Compute the inner product of ``a`` and ``b``.
        The default implementation is given by the dot product of
        ``a`` and ``b``.
        """
        return _MooreSpence.AbstractGroup_innerProduct(self, *args)

# Register AbstractGroup in _MooreSpence:
_MooreSpence.AbstractGroup_swigregister(AbstractGroup)

class SolverFactory(object):
    r"""
    Factory for creating solver objects for solving Moore-Spence
    pitchfork equations

    The parameters passed to the create() through the ``solverParams``
    argument method should specify the "Solver Method"
    as described below, as well as any additional parameters
    for the particular strategy.

    *  "Solver Method" - Name of the method. Valid choices are

      *  "Salinger Bordering" (LOCA::Pitchfork::MooreSpence::SalingerBordering) [Default]
      *  "Phipps Bordering" (LOCA::Pitchfork::MooreSpence::PhippsBordering)

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r""" Constructor"""
        _MooreSpence.SolverFactory_swiginit(self, _MooreSpence.new_SolverFactory(*args))
    __swig_destroy__ = _MooreSpence.delete_SolverFactory

    def create(self, *args) -> "Teuchos::RCP< LOCA::Pitchfork::MooreSpence::SolverStrategy >":
        r"""
         Create solver strategy
        :type topParams: Teuchos::RCP< LOCA::Parameter::SublistParser >
        :param topParams: [in] Parsed top-level parameter list.
        :type solverParams: :py:class:`ParameterList`
        :param solverParams: [in] Solver parameters as described above
        """
        return _MooreSpence.SolverFactory_create(self, *args)

    def strategyName(self, *args) -> "std::string const &":
        r""" Return strategy name given by ``solverParams``"""
        return _MooreSpence.SolverFactory_strategyName(self, *args)

# Register SolverFactory in _MooreSpence:
_MooreSpence.SolverFactory_swigregister(SolverFactory)



