# This file was automatically generated by SWIG (http://www.swig.org).
# Version 4.0.2
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.

"""

PyTrilinos.LOCA.TimeDependent is the python interface to namespace
TimeDependent of the Trilinos continuation algorithm package LOCA:

    https://trilinos.org/docs/dev/packages/nox/doc/html/index.html

The purpose of LOCA.TimeDependent is to provide an abstract group for
time dependent problems with a mass matrix.  The python version of
LOCA.TimeDependent supports the following classes:

    * AbstractGroup  - Interface to underlying groups for time dependent
                       systems

"""

from sys import version_info as _swig_python_version_info
if _swig_python_version_info < (2, 7, 0):
    raise RuntimeError("Python 2.7 or later required")

# Import the low-level C/C++ module
if __package__ or "." in __name__:
    from . import _TimeDependent
else:
    import _TimeDependent

try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)


def _swig_setattr_nondynamic_instance_variable(set):
    def set_instance_attr(self, name, value):
        if name == "thisown":
            self.this.own(value)
        elif name == "this":
            set(self, name, value)
        elif hasattr(self, name) and isinstance(getattr(type(self), name), property):
            set(self, name, value)
        else:
            raise AttributeError("You cannot add instance attributes to %s" % self)
    return set_instance_attr


def _swig_setattr_nondynamic_class_variable(set):
    def set_class_attr(cls, name, value):
        if hasattr(cls, name) and not isinstance(getattr(cls, name), property):
            set(cls, name, value)
        else:
            raise AttributeError("You cannot add class attributes to %s" % cls)
    return set_class_attr


def _swig_add_metaclass(metaclass):
    """Class decorator for adding a metaclass to a SWIG wrapped class - a slimmed down version of six.add_metaclass"""
    def wrapper(cls):
        return metaclass(cls.__name__, cls.__bases__, cls.__dict__.copy())
    return wrapper


class _SwigNonDynamicMeta(type):
    """Meta class to enforce nondynamic attributes (no new attributes) for a class"""
    __setattr__ = _swig_setattr_nondynamic_class_variable(type.__setattr__)


import weakref

import PyTrilinos.Teuchos.Base
import PyTrilinos.NOX.Abstract
import PyTrilinos.Epetra
import MultiContinuation
class AbstractGroup(MultiContinuation.AbstractGroup):
    r"""
    Interface to underlying groups for time dependent systems

    This abstract class provides an interface for time dependent problems,
    i.e., problems with a mass matrix (typically used in eignvalue or
    Hopf calculations).  It provides pure virtual methods for computing
    and manipulating the shifted matrix :math:`\alpha J + \beta M` where
    :math:`J` is the Jacobian matrix and :math:`M` is the mass matrix.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _TimeDependent.delete_AbstractGroup

    def computeShiftedMatrix(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r""" Compute the shifted matrix"""
        return _TimeDependent.AbstractGroup_computeShiftedMatrix(self, *args)

    def applyShiftedMatrix(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r""" Multiply the shifted matrix by a vector."""
        return _TimeDependent.AbstractGroup_applyShiftedMatrix(self, *args)

    def applyShiftedMatrixMultiVector(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r""" Multiply the shifted matrix by a multi-vector."""
        return _TimeDependent.AbstractGroup_applyShiftedMatrixMultiVector(self, *args)

    def applyShiftedMatrixInverseMultiVector(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r"""
        Apply the inverse of the shifted matrix by a multi-vector, as
        needed by the shift-and-invert and generalized Cayley transformations.
        """
        return _TimeDependent.AbstractGroup_applyShiftedMatrixInverseMultiVector(self, *args)

    def computeSecondShiftedMatrix(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r"""
         Compute the second shifted matrix. Can avoid recomputing if two are stored.
        Implementation here prints an error message and returns
        NOX::Abstract::Group::NotDefined.
        """
        return _TimeDependent.AbstractGroup_computeSecondShiftedMatrix(self, *args)

    def applySecondShiftedMatrix(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r"""
         Multiply the shifted matrix by a vector.
        Implementation here prints an error message and returns
        NOX::Abstract::Group::NotDefined.
        """
        return _TimeDependent.AbstractGroup_applySecondShiftedMatrix(self, *args)

    def applySecondShiftedMatrixMultiVector(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r"""
         Multiply the shifted matrix by a multi-vector.
        Implementation here prints an error message and returns
        NOX::Abstract::Group::NotDefined.
        """
        return _TimeDependent.AbstractGroup_applySecondShiftedMatrixMultiVector(self, *args)

# Register AbstractGroup in _TimeDependent:
_TimeDependent.AbstractGroup_swigregister(AbstractGroup)



