# This file was automatically generated by SWIG (http://www.swig.org).
# Version 4.0.2
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.

"""

PyTrilinos.LOCA.TurningPoint.MinimallyAugmented is the python
interface to namespace TurningPoint::MinimallyAugmented of the
Trilinos continuation algorithm package LOCA:

    https://trilinos.org/docs/dev/packages/nox/doc/html/index.html

The purpose of LOCA.TurningPoint.MinimallyAugmented is to provide
groups and vectors for locating turning point bifurcations using the
minimally augmented turning point formulation.  The python version of
LOCA.TurningPoint.MinimallyAugmented supports the following classes:

    * AbstractGroup          - Interface to underlying groups for turning point
                               calculations using the minimally augmented
                               formulation
    * FiniteDifferenceGroup  - Concrete class that provides concrete
                               implementations of the derivative computation
                               methods of the LOCA.TurningPoint.Minimally-
                               Augmented.AbstractGroup using first-order finite
                               differencing

"""

from sys import version_info as _swig_python_version_info
if _swig_python_version_info < (2, 7, 0):
    raise RuntimeError("Python 2.7 or later required")


from . import _MinimallyAugmented
import PyTrilinos.Teuchos.Base
import PyTrilinos.NOX.Abstract
import PyTrilinos.Epetra
from PyTrilinos.LOCA import MultiContinuation
from . import MooreSpence


try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)


def _swig_setattr_nondynamic_instance_variable(set):
    def set_instance_attr(self, name, value):
        if name == "thisown":
            self.this.own(value)
        elif name == "this":
            set(self, name, value)
        elif hasattr(self, name) and isinstance(getattr(type(self), name), property):
            set(self, name, value)
        else:
            raise AttributeError("You cannot add instance attributes to %s" % self)
    return set_instance_attr


def _swig_setattr_nondynamic_class_variable(set):
    def set_class_attr(cls, name, value):
        if hasattr(cls, name) and not isinstance(getattr(cls, name), property):
            set(cls, name, value)
        else:
            raise AttributeError("You cannot add class attributes to %s" % cls)
    return set_class_attr


def _swig_add_metaclass(metaclass):
    """Class decorator for adding a metaclass to a SWIG wrapped class - a slimmed down version of six.add_metaclass"""
    def wrapper(cls):
        return metaclass(cls.__name__, cls.__bases__, cls.__dict__.copy())
    return wrapper


class _SwigNonDynamicMeta(type):
    """Meta class to enforce nondynamic attributes (no new attributes) for a class"""
    __setattr__ = _swig_setattr_nondynamic_class_variable(type.__setattr__)


import weakref

import PyTrilinos.Teuchos.Base

import sys, os.path as op
thisDir = op.dirname(op.abspath(__file__))
if not thisDir in sys.path: sys.path.append(thisDir)
del sys, op

import PyTrilinos.NOX.Abstract
import PyTrilinos.Epetra
import MultiContinuation
import MooreSpence
class AbstractGroup(MooreSpence.AbstractGroup):
    r"""
    Interface to underlying groups for turning point calculations
    using the minimally augmented formulation.

    This abstract class provides the required interface for underlying
    groups to locate turning points using the minimally augmented turning
    point formulation (see
    LOCA::TurningPoint::MinimallyAugmented::ExtendedGroup for a
    description of the governing equations).

    This class is derived from the
    LOCA::TurningPoint::MooreSpence::AbstractGroup
    and declares several pure virtual methods compute various
    derivatives of :math:`w^TJn` for a given :math:`w` and :math:`n`.  Default
    implementations for the derivatives using finite differencing are
    implemented in the
    LOCA::TurningPoint::MinimallyAugmented::FiniteDifferenceGroup.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _MinimallyAugmented.delete_AbstractGroup

    def computeDwtJnDp(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r"""Computes the derivative :math:`\partial w^TJn/\partial p`"""
        return _MinimallyAugmented.AbstractGroup_computeDwtJnDp(self, *args)

    def computeDwtJDp(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r"""Computes the derivative :math:`\partial w^TJ/\partial p`"""
        return _MinimallyAugmented.AbstractGroup_computeDwtJDp(self, *args)

    def computeDwtJnDx(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r"""
        Computes the derivative
        :math:`\frac{\partial w^TJn}{\partial x}`.
        """
        return _MinimallyAugmented.AbstractGroup_computeDwtJnDx(self, *args)

# Register AbstractGroup in _MinimallyAugmented:
_MinimallyAugmented.AbstractGroup_swigregister(AbstractGroup)

class FiniteDifferenceGroup(AbstractGroup, MooreSpence.FiniteDifferenceGroup):
    r"""
    Concrete class that provides concrete implementations of the
    derivative computation methods of the
    LOCA::TurningPoint::MinimallyAugmented::AbstractGroup using
    first-order finite differencing.

    The finite-differencing calculations are actually implemented by
    the LOCA::DerivUtils class, and a custom DerivUtils object can be
    passed through the constructor of this class.  However, in the future
    the calculations encapsulated in the DerivUtils class may be
    incorporated directly into this class and other finite-differencing
    child classes.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _MinimallyAugmented.delete_FiniteDifferenceGroup

    def computeDwtJnDp(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r"""
        Computes the derivative :math:`\partial w^TJn/\partial p`

        The calculation is implemented by calling the corresponding
        LOCA::DerivUtils::computeDwtJnDp() method of the passed
        LOCA::DerivUtils object.
        """
        return _MinimallyAugmented.FiniteDifferenceGroup_computeDwtJnDp(self, *args)

    def computeDwtJDp(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r"""
        Computes the derivative :math:`\partial w^TJ/\partial p`

        The calculation is implemented by calling the corresponding
        LOCA::DerivUtils::computeDwtJDp() method of the passed
        LOCA::DerivUtils object.
        """
        return _MinimallyAugmented.FiniteDifferenceGroup_computeDwtJDp(self, *args)

    def computeDwtJnDx(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r"""
        Computes the derivative
        :math:`\frac{\partial w^TJn}{\partial x}`.

        The calculation is implemented by calling the corresponding
        LOCA::DerivUtils::computeDwtJnDx() method of the passed
        LOCA::DerivUtils object.
        """
        return _MinimallyAugmented.FiniteDifferenceGroup_computeDwtJnDx(self, *args)

# Register FiniteDifferenceGroup in _MinimallyAugmented:
_MinimallyAugmented.FiniteDifferenceGroup_swigregister(FiniteDifferenceGroup)



