# This file was automatically generated by SWIG (http://www.swig.org).
# Version 4.0.2
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.

"""

PyTrilinos.NOX.Abstract is the python interface to namespace Abstract
of the Trilinos package NOX:

    https://trilinos.org/docs/dev/packages/nox/doc/html/index.html

The purpose of NOX.Abstract is to provide base classes from which
concrete NOX interfaces can be derived.  Currently, the only concrete
implementation is for Epetra, in the NOX.Epetra module.

NOX.Abstract provides the following user-level classes:

    * Group            - Class defining a collection of objects needed by NOX
    * PrePostOperator  - Pre- and post-iteration operators
    * MultiVector      - Multivector class
    * Vector           - Vector class

"""

from sys import version_info as _swig_python_version_info
if _swig_python_version_info < (2, 7, 0):
    raise RuntimeError("Python 2.7 or later required")

# Import the low-level C/C++ module
if __package__ or "." in __name__:
    from . import _Abstract
else:
    import _Abstract

try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)


def _swig_setattr_nondynamic_instance_variable(set):
    def set_instance_attr(self, name, value):
        if name == "thisown":
            self.this.own(value)
        elif name == "this":
            set(self, name, value)
        elif hasattr(self, name) and isinstance(getattr(type(self), name), property):
            set(self, name, value)
        else:
            raise AttributeError("You cannot add instance attributes to %s" % self)
    return set_instance_attr


def _swig_setattr_nondynamic_class_variable(set):
    def set_class_attr(cls, name, value):
        if hasattr(cls, name) and not isinstance(getattr(cls, name), property):
            set(cls, name, value)
        else:
            raise AttributeError("You cannot add class attributes to %s" % cls)
    return set_class_attr


def _swig_add_metaclass(metaclass):
    """Class decorator for adding a metaclass to a SWIG wrapped class - a slimmed down version of six.add_metaclass"""
    def wrapper(cls):
        return metaclass(cls.__name__, cls.__bases__, cls.__dict__.copy())
    return wrapper


class _SwigNonDynamicMeta(type):
    """Meta class to enforce nondynamic attributes (no new attributes) for a class"""
    __setattr__ = _swig_setattr_nondynamic_class_variable(type.__setattr__)


import weakref

import PyTrilinos.Teuchos.Base
import PyTrilinos.Epetra
class MultiVector(object):
    r"""Abstract interface for multi-vectors used by %NOX."""

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Abstract.delete_MultiVector

    def init(self, *args) -> "NOX::Abstract::MultiVector &":
        r""" Initialize every element of this multi-vector with ``gamma``."""
        return _Abstract.MultiVector_init(self, *args)

    def random(self, *args) -> "NOX::Abstract::MultiVector &":
        r""" Initialize each element of this multi-vector with a random value"""
        return _Abstract.MultiVector_random(self, *args)

    def setBlock(self, *args) -> "NOX::Abstract::MultiVector &":
        r"""
        Copy the vectors in ``source`` to a set of vectors in ``*this``.
        The ``index.size()`` vectors in ``source`` are copied to a subset of
        vectors in ``*this`` indicated by the indices given in ``index``.
        """
        return _Abstract.MultiVector_setBlock(self, *args)

    def augment(self, *args) -> "NOX::Abstract::MultiVector &":
        r""" Append the vectors in ``source`` to ``*this``"""
        return _Abstract.MultiVector_augment(self, *args)

    def scale(self, *args) -> "NOX::Abstract::MultiVector &":
        r""" Scale each element of this multivector by ``gamma``."""
        return _Abstract.MultiVector_scale(self, *args)

    def update(self, *args) -> "NOX::Abstract::MultiVector &":
        r"""
        *Overload 1:*

        Compute x = (alpha * a) + (gamma * x) where ``a`` is a
        multi-vector and ``x`` = ``*this``.

        |

        *Overload 2:*

        Compute x = (alpha * a) + (beta * b) + (gamma * x) where
        ``a`` and ``b`` are multi-vectors and ``x`` = ``*this``.

        |

        *Overload 3:*

        Compute x = (alpha * a * op(b)) + (gamma * x) where
        ``a`` is a multivector, ``b`` is a dense matrix, ``x`` = ``*this``,
        and op(b) = b if transb = Teuchos::NO_TRANS and op(b) is b transpose
        if transb = Teuchos::TRANS.
        """
        return _Abstract.MultiVector_update(self, *args)

    def clone(self, *args) -> "Teuchos::RCP< NOX::Abstract::MultiVector >":
        r"""
        Create a new %Vector of the same underlying type by
        cloning "this", and return a pointer to the new vector.

        If type is NOX::DeepCopy, then we need to create an exact replica
        of "this". Otherwise, if type is NOX::ShapeCopy, we need only
        replicate the shape of "this". Note that there is
        **no assumption** that a vector created by ShapeCopy is
        initialized to zeros.

        :rtype: Teuchos::RCP< NOX::Abstract::MultiVector >
        :return: Pointer to newly created vector or NULL if clone is not
            supported.
        """
        return _Abstract.MultiVector_clone(self, *args)

    def subCopy(self, *args) -> "Teuchos::RCP< NOX::Abstract::MultiVector >":
        r"""
        Creates a new multi-vector with ``index.size()`` columns whose
        columns are copies of the columns of ``*this`` given by ``index``.
        """
        return _Abstract.MultiVector_subCopy(self, *args)

    def subView(self, *args) -> "Teuchos::RCP< NOX::Abstract::MultiVector >":
        r"""
        Creates a new multi-vector with ``ndex.size()`` columns that
        shares the columns of ``*this`` given by ``index``.
        """
        return _Abstract.MultiVector_subView(self, *args)

    def norm(self, *args) -> "void":
        r""" Norm."""
        return _Abstract.MultiVector_norm(self, *args)

    def multiply(self, *args) -> "void":
        r"""Computes the matrix-matrix product :math:`\alpha * y^T * (*this)`"""
        return _Abstract.MultiVector_multiply(self, *args)

    def length(self, *args) -> "NOX::size_type":
        r""" Return the length of multi-vector."""
        return _Abstract.MultiVector_length(self, *args)

    def numVectors(self, *args) -> "int":
        r""" Return the number of vectors in the multi-vector."""
        return _Abstract.MultiVector_numVectors(self, *args)

    def _print(self, *args) -> "void":
        r""" Print the vector.  This is meant for debugging purposes only"""
        return _Abstract.MultiVector__print(self, *args)

# Register MultiVector in _Abstract:
_Abstract.MultiVector_swigregister(MultiVector)

DeepCopy = _Abstract.DeepCopy
r""" Copy object including all data"""
ShapeCopy = _Abstract.ShapeCopy
r""" Copy the shape of the object only"""
class Vector(object):
    r"""
    %NOX's pure abstract vector interface for vectors that are
    used by the nonlinear solver.

    This class is a member of the namespace NOX::Abstract.

    The user should implement their own concrete implementation of this
    class or use one of the implementations provided by us.

    Author: Tammy Kolda (SNL 8950), Roger Pawlowski (SNL 9233)
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    TwoNorm = _Abstract.Vector_TwoNorm
    r""" Use the 2-norm"""
    OneNorm = _Abstract.Vector_OneNorm
    r""" Use the 1-norm"""
    MaxNorm = _Abstract.Vector_MaxNorm
    r""" Use the max-norm, a.k.a. the :math:`\infty`-norm"""
    __swig_destroy__ = _Abstract.delete_Vector

    def init(self, *args) -> "NOX::Abstract::Vector &":
        r"""
        Initialize every element of this vector with ``gamma``.
           Here x represents this vector, and we update it as

           .. math::

               x_i = \gamma \quad \mbox{for } i=1,\dots,n
           :rtype: :py:class:`Vector`
           :return: Reference to this object
        """
        return _Abstract.Vector_init(self, *args)

    def random(self, *args) -> "NOX::Abstract::Vector &":
        r"""
         Initialize each element of this vector with a random value
            If ``useSeed`` is true, uses the value of ``seed`` to seed the
            random number generator before filling the entries of this
            vector. So, if two calls are made where ``useSeed`` is true and
        ``seed`` is the same, then the vectors returned should be the same.

            Default implementation throw an error. Only referenced by LOCA methods.

            :rtype: :py:class:`Vector`
            :return: Reference to this object
        """
        return _Abstract.Vector_random(self, *args)

    def abs(self, *args) -> "NOX::Abstract::Vector &":
        r"""
        Put element-wise absolute values of source vector ``y`` into this vector.
           Here x represents this vector, and we update it as

           .. math::

               x_i = | y_i | \quad \mbox{for } i=1,\dots,n

           :rtype: :py:class:`Vector`
           :return: Reference to this object
        """
        return _Abstract.Vector_abs(self, *args)

    def reciprocal(self, *args) -> "NOX::Abstract::Vector &":
        r"""
        Put element-wise reciprocal of source vector ``y`` into this vector.
           Here x represents this vector, and we update it as

           .. math::

               x_i =  \frac{1}{y_i} \quad \mbox{for } i=1,\dots,n

           :rtype: :py:class:`Vector`
           :return: Reference to this object
        """
        return _Abstract.Vector_reciprocal(self, *args)

    def scale(self, *args) -> "NOX::Abstract::Vector &":
        r"""
        *Overload 1:*
        Scale each element of this vector by ``gamma``.
           Here x represents this vector, and we update it as

           .. math::

               x_i = \gamma x_i \quad \mbox{for } i=1,\dots,n

           :rtype: :py:class:`Vector`
           :return: Reference to this object

        |

        *Overload 2:*
        Scale this vector **element-by-element** by the vector a.
           Here x represents this vector, and we update it as

           .. math::

               x_i = x_i \cdot a_i \quad \mbox{for } i=1,\dots,n

           :rtype: :py:class:`Vector`
           :return: Reference to this object
        """
        return _Abstract.Vector_scale(self, *args)

    def update(self, *args) -> "NOX::Abstract::Vector &":
        r"""
        *Overload 1:*
        Compute x = (alpha * a) + (gamma * x) where x is this vector.
           Here x represents this vector, and we update it as

           .. math::

               x_i = \alpha \; a_i + \gamma \; x_i \quad \mbox{for } i=1,\dots,n

           :rtype: :py:class:`Vector`
           :return: Reference to this object

        |

        *Overload 2:*
        Compute x = (alpha * a) + (beta * b) + (gamma * x) where x is this vector.
           Here x represents this vector, and we update it as

           .. math::

               x_i = \alpha \; a_i + \beta \; b_i + \gamma \; x_i \quad \mbox{for } i=1,\dots,n

           :rtype: :py:class:`Vector`
           :return: Reference to this object
        """
        return _Abstract.Vector_update(self, *args)

    def clone(self, *args) -> "Teuchos::RCP< NOX::Abstract::Vector >":
        r"""
        Create a new %Vector of the same underlying type by
        cloning "this", and return a pointer to the new vector.

        If type is NOX::DeepCopy, then we need to create an exact replica
        of "this". Otherwise, if type is NOX::ShapeCopy, we need only
        replicate the shape of "this" (the memory is allocated for the
        objects, but the current values are not copied into the
        vector). Note that there is **no assumption** that a vector
        created by ShapeCopy is initialized to zeros.

        :rtype: Teuchos::RCP< NOX::Abstract::Vector >
        :return: Pointer to newly created vector or NULL if clone is not supported.
        """
        return _Abstract.Vector_clone(self, *args)

    def createMultiVector(self, *args) -> "Teuchos::RCP< NOX::Abstract::MultiVector >":
        r"""
        *Overload 1:*

        Create a MultiVector with ``numVecs+1`` columns out of an array of
        Vectors.  The vector stored under ``this`` will be the first column with
        the remaining ``numVecs`` columns given by ``vecs``.

        The default implementation creates a generic NOX::MultiVector with
        either Shape or Deep copies of the supplied vectors.

        |

        *Overload 2:*

        Create a MultiVector with ``numVecs`` columns.

        The default implementation creates a generic NOX::MultiVector with
        either Shape or Deep copies of the supplied vector.
        """
        return _Abstract.Vector_createMultiVector(self, *args)

    def norm(self, *args) -> "double":
        r"""
        *Overload 1:*
        Norm.
           Here x represents this vector, and we compute its norm as follows:
           for each NOX::Abstract::Vector::NormType:

           *   NOX::Abstract::Vector::TwoNorm.. math::

           \|x\| = \sqrt{\sum_{i=1}^{n} x_i^2}
           *   NOX::Abstract::Vector::OneNorm.. math::

           \|x\| = \sum_{i=1}^{n} |x_i|
           *   NOX::Abstract::Vector::MaxNorm.. math::

           \|x\| = \max_{i} |x_i|


           :rtype: float
           :return: :math:`\|x\|`

        |

        *Overload 2:*
        Weighted 2-Norm.
           Here x represents this vector, and we compute its weighted norm as follows:

           .. math::

               \|x\|_w = \sqrt{\sum_{i=1}^{n} w_i \; x_i^2}
           :rtype: float
           :return: :math:`\|x\|_w`
        """
        return _Abstract.Vector_norm(self, *args)

    def innerProduct(self, *args) -> "double":
        r"""
        Inner product with ``y``.
           Here x represents this vector, and we compute its inner product with y as follows:

           .. math::

               \langle x,y \rangle = \sum_{i=1}^n x_i y_i
           :rtype: float
           :return: :math:`\langle x,y \rangle`
        """
        return _Abstract.Vector_innerProduct(self, *args)

    def length(self, *args) -> "NOX::size_type":
        r"""
        Return the length of vector.
           :rtype: NOX::size_type
           :return: The length of this vector
           Notes: Even if the vector is distributed across processors, this
           should return the ** global length ** of the vector.
        """
        return _Abstract.Vector_length(self, *args)

    def _print(self, *args) -> "void":
        r""" Print the vector.  To be used for debugging only."""
        return _Abstract.Vector__print(self, *args)

# Register Vector in _Abstract:
_Abstract.Vector_swigregister(Vector)

class Group(object):
    r"""
    %NOX pure abstract interface to a "group"; i.e., a
    solution vector and the corresponding F-vector, Jacobian matrix,
    gradient vector, and Newton vector.

    This class is a member of the namespace NOX::Abstract.

    The user should implement their own concrete implementation of this
    class or use one of the implementations provided by us. Typically
    the implementation is also tied to a particular
    NOX::Abstract::Vector implementation.

    Notes: The group may be implemented so that multiple groups can
    share underlying memory space. This is particularly important when
    it comes to the Jacobian, which is often to big to be replicated
    for every group. Thus, we have included instructions on how
    **shared data** should be treated for the operator=() and
    clone() functions.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    Ok = _Abstract.Group_Ok
    r""" Computation completed successfully"""
    NotDefined = _Abstract.Group_NotDefined
    r""" This function is not implemented"""
    BadDependency = _Abstract.Group_BadDependency
    r""" Data dependencies not satisfied"""
    NotConverged = _Abstract.Group_NotConverged
    r""" Unable to satisfy convergence criteria"""
    Failed = _Abstract.Group_Failed
    r""" Any other type of failure"""
    __swig_destroy__ = _Abstract.delete_Group

    def setX(self, *args) -> "void":
        r"""
        Set the solution vector x to y.
            Notes: 
            This should invalidate the function value, Jacobian,
            gradient, and Newton direction.


            Throw an error if the copy fails.

            :rtype: void
            :return: 
                Reference to this object
        """
        return _Abstract.Group_setX(self, *args)

    def computeX(self, *args) -> "void":
        r"""
        Compute x = grp.x + step * d.
            Let :math:`x` denote this group's solution vector.
            Let :math:`\hat x` denote the result of grp.getX().
            Then set

            .. math::

                x = \hat x + \mbox{step} \; d.

            Notes: 
            This should invalidate the function value, Jacobian,
            gradient, and Newton direction.


            Throw an error if the copy fails.

            :rtype: void
            :return: 
                Reference to this object
        """
        return _Abstract.Group_computeX(self, *args)

    def computeF(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r"""
        Compute and store F(x).
            Notes: 
            It's generally useful to also compute and store the 2-norm of F(x)
            at this point for later access by the getNormF() function.

            :rtype: int
            :return: 

                *  NOX::Abstract::Group::Failed - If the computation fails in any way
                *  NOX::Abstract::Group::Ok - Otherwise
        """
        return _Abstract.Group_computeF(self, *args)

    def computeJacobian(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r"""
        Compute and store Jacobian.
            Recall that

            .. math::

                F(x) = \left[ \begin{array}{c} F_1(x) \\ F_2(x) \\ \vdots \\ F_n(x) \\ \end{array} \right].

            The **Jacobian**
            is denoted by :math:`J` and defined by

            .. math::

                J_{ij} = \frac{\partial F_i}{\partial x_j} (x).

            Notes: 
            If this is a **shared object**, this group should take
            ownership of the Jacobian before it computes it.

            :rtype: int
            :return: 

                *  NOX::Abstract::Group::NotDefined - Returned by default implementation in NOX::Abstract::Group
                *  NOX::Abstract::Group::Failed - If the computation fails in any other way
                *  NOX::Abstract::Group::Ok - Otherwise
        """
        return _Abstract.Group_computeJacobian(self, *args)

    def computeGradient(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r"""
        Compute and store gradient.
            We can pose the nonlinear equation problem :math:`F(x) = 0` as an optimization problem as follows:

            .. math::

                \min f(x) \equiv \frac{1}{2} \|F(x)\|_2^2.

            In that case, the **gradient** (of :math:`f`) is defined as

            .. math::

                g \equiv J^T F.

            :rtype: int
            :return: 

                *  NOX::Abstract::Group::NotDefined - Returned by default implementation in NOX::Abstract::Group
                *  NOX::Abstract::Group::BadDependency - If either :math:`F` or :math:`J` has not been computed
                *  NOX::Abstract::Group::Failed - If the computation fails in any other way
                *  NOX::Abstract::Group::Ok - Otherwise
        """
        return _Abstract.Group_computeGradient(self, *args)

    def computeNewton(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r"""
        Compute the Newton direction, using parameters for the linear solve.
            The **Newton direction** is the solution, s, of

            .. math::

                J s = -F.

            The parameters are from the "Linear %Solver" sublist of the
            "Direction" sublist that is passed to solver during construction.

            The "Tolerance" parameter may be added/modified in the sublist of
            "Linear Solver" parameters that is passed into this function. The
            solution should be such that

            .. math::

                \frac{\| J s - (-F) \|_2}{\max \{ 1, \|F\|_2\} } < \mbox{Tolerance}

            :rtype: int
            :return: 

                *  NOX::Abstract::Group::NotDefined - Returned by default implementation in NOX::Abstract::Group
                *  NOX::Abstract::Group::BadDependency - If either :math:`F` or :math:`J` has not been computed
                *  NOX::Abstract::Group::NotConverged - If the linear solve fails to satisfy the "Tolerance"
                 specified in ``params``
                *  NOX::Abstract::Group::Failed - If the computation fails in any other way
                *  NOX::Abstract::Group::Ok - Otherwise
        """
        return _Abstract.Group_computeNewton(self, *args)

    def applyJacobian(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r"""
        Applies Jacobian to the given input vector and puts the answer in the result.
            Computes

            .. math::

                v = J u,
            where :math:`J` is the Jacobian, :math:`u` is the input vector, and :math:`v` is the result vector.

            :rtype: int
            :return: 

                *  NOX::Abstract::Group::NotDefined - Returned by default implementation in NOX::Abstract::Group
                *  NOX::Abstract::Group::BadDependency - If the Jacobian :math:`J` has not been computed
                *  NOX::Abstract::Group::Failed - If the computation fails
                *  NOX::Abstract::Group::Ok - Otherwise
        """
        return _Abstract.Group_applyJacobian(self, *args)

    def applyJacobianTranspose(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r"""
        Applies Jacobian-Transpose to the given input vector and puts the answer in the result.
            Computes

            .. math::

                v = J^T u,
             where :math:`J` is the Jacobian, :math:`u` is the input vector, and :math:`v` is the result vector.

            :rtype: int
            :return: 

                *  NOX::Abstract::Group::NotDefined - Returned by default implementation in NOX::Abstract::Group
                *  NOX::Abstract::Group::BadDependency - If :math:`J` has not been computed
                *  NOX::Abstract::Group::Failed - If the computation fails
                *  NOX::Abstract::Group::Ok - Otherwise
        """
        return _Abstract.Group_applyJacobianTranspose(self, *args)

    def applyJacobianInverse(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r"""
        Applies the inverse of the Jacobian matrix to the given
        input vector and puts the answer in result.

        Computes

        .. math::

            v = J^{-1} u,
        where :math:`J` is the Jacobian, :math:`u` is the input vector, and :math:`v` is the result vector.

        The "Tolerance" parameter specifies that the
        solution should be such that

        .. math::

            \frac{\| J v - u \|_2}{\max \{ 1, \|u\|_2\} } < \mbox{Tolerance}

        :rtype: int
        :return: 

            *  NOX::Abstract::Group::NotDefined - Returned by default implementation in NOX::Abstract::Group
            *  NOX::Abstract::Group::BadDependency - If :math:`J` has not been computed
            *  NOX::Abstract::Group::NotConverged - If the linear solve fails to satisfy the "Tolerance"
             specified in ``params``
            *  NOX::Abstract::Group::Failed - If the computation fails
            *  NOX::Abstract::Group::Ok - Otherwise


        The parameter "Tolerance" may be added/modified in the list of
        parameters - this is the ideal solution tolerance for an iterative
        linear solve.
        """
        return _Abstract.Group_applyJacobianInverse(self, *args)

    def applyRightPreconditioning(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r"""
        Apply right preconditiong to the given input vector
            Let :math:`M` be a right preconditioner for the Jacobian :math:`J`; in
            other words, :math:`M` is a matrix such that

            .. math::

                JM \approx I.

            Compute

            .. math::

                u = M^{-1} v,
            where :math:`u` is the input vector and :math:`v` is the result vector.

            If **useTranspose** is true, then the transpose of the
            preconditioner is applied:

            .. math::

                u = {M^{-1}}^T v,
            The transpose preconditioner is currently only required for
            Tensor methods.

            The "Tolerance" parameter specifies that the
            solution should be such that

            .. math::

                \frac{\| M v - u \|_2}{\max \{ 1, \|u\|_2\} } < \mbox{Tolerance}

            :rtype: int
            :return: 

                *  NOX::Abstract::Group::NotDefined - Returned by default implementation in NOX::Abstract::Group
                *  NOX::Abstract::Group::NotConverged - If the linear solve fails to satisfy the "Tolerance"
                 specified in ``params``
                *  NOX::Abstract::Group::Failed - If the computation fails
                *  NOX::Abstract::Group::Ok - Otherwise


            The parameters are from the "Linear %Solver" sublist of the
            "Direction" sublist that is passed to solver during construction.
        """
        return _Abstract.Group_applyRightPreconditioning(self, *args)

    def applyJacobianMultiVector(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r"""
         applyJacobian for multiple right-hand sides
        The default implementation here calls applyJacobian() for
        each right hand side serially but should be overloaded if a
        block method is available.
        """
        return _Abstract.Group_applyJacobianMultiVector(self, *args)

    def applyJacobianTransposeMultiVector(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r"""
         applyJacobianTranspose for multiple right-hand sides
        The default implementation here calls applyJacobianTranspose() for
        each right hand side serially but should be overloaded if a
        block method is available.
        """
        return _Abstract.Group_applyJacobianTransposeMultiVector(self, *args)

    def applyJacobianInverseMultiVector(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r"""
         applyJacobianInverse for multiple right-hand sides
        The default implementation here calls applyJacobianInverse() for
        each right hand side serially but should be overloaded if a
        block solver is available.
        """
        return _Abstract.Group_applyJacobianInverseMultiVector(self, *args)

    def applyRightPreconditioningMultiVector(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r"""
         applyRightPreconditioning for multiple right-hand sides
        The default implementation here calls applyRightPreconditioning() for
        each right hand side serially but should be overloaded if a
        block method is available.
        """
        return _Abstract.Group_applyRightPreconditioningMultiVector(self, *args)

    def isF(self, *args) -> "bool":
        r""" Return true if F is valid."""
        return _Abstract.Group_isF(self, *args)

    def isJacobian(self, *args) -> "bool":
        r""" Return true if the Jacobian is valid. Notes: Default implementation in NOX::Abstract::Group returns false."""
        return _Abstract.Group_isJacobian(self, *args)

    def isGradient(self, *args) -> "bool":
        r""" Return true if the gradient is valid. Notes: Default implementation in NOX::Abstract::Group returns false."""
        return _Abstract.Group_isGradient(self, *args)

    def isNewton(self, *args) -> "bool":
        r""" Return true if the Newton direction is valid. Notes: Default implementation in NOX::Abstract::Group returns false."""
        return _Abstract.Group_isNewton(self, *args)

    def getX(self, *args) -> "NOX::Abstract::Vector const &":
        r""" Return solution vector."""
        return _Abstract.Group_getX(self, *args)

    def getScaledX(self, *args) -> "NOX::Abstract::Vector const &":
        r""" If right scaling vector exist, return a right scaled vector. Notes: Default to getX"""
        return _Abstract.Group_getScaledX(self, *args)

    def getF(self, *args) -> "NOX::Abstract::Vector const &":
        r""" Return F(x)"""
        return _Abstract.Group_getF(self, *args)

    def getNormF(self, *args) -> "double":
        r"""
        Return 2-norm of F(x). In other words,.. math::

           \sqrt{\sum_{i=1}^n F_i^2}
        """
        return _Abstract.Group_getNormF(self, *args)

    def getGradient(self, *args) -> "NOX::Abstract::Vector const &":
        r""" Return gradient."""
        return _Abstract.Group_getGradient(self, *args)

    def getNewton(self, *args) -> "NOX::Abstract::Vector const &":
        r""" Return Newton direction."""
        return _Abstract.Group_getNewton(self, *args)

    def logLastLinearSolveStats(self, *args) -> "void":
        r"""
        Adds statistics from last linear solve to the
             SovlerStats object.
        """
        return _Abstract.Group_logLastLinearSolveStats(self, *args)

    def getNormLastLinearSolveResidual(self, *args) -> "NOX::Abstract::Group::ReturnType":
        r"""

        Return the norm of the last linear solve residual as the result of
        either a call to computeNewton() or applyJacobianInverse().

         :rtype: int
         :return: 

             *  NOX::Abstract::Group::NotDefined - Returned by default implementation in NOX::Abstract::Group
             *  NOX::Abstract::Group::BadDependency - If no linear solve has been calculated
             *  NOX::Abstract::Group::Failed - Any other type of failure
             *  NOX::Abstract::Group::Ok - Otherwise
        """
        return _Abstract.Group_getNormLastLinearSolveResidual(self, *args)

    def clone(self, *args) -> "Teuchos::RCP< NOX::Abstract::Group >":
        r"""
        Create a new %Group of the same derived type as this one by
        cloning this one, and return a ref count pointer to the new group.

        If type is NOX::DeepCopy, then we need to create an exact replica
        of "this". Otherwise, if type is NOX::ShapeCopy, we need only
        replicate the shape of "this" (only the memory is allocated, the
        values are not copied into the vectors and Jacobian). Returns NULL
        if clone is not supported.

        Notes: Any **shared data** should have its ownership transfered to this
        group from the source for a NOX::DeepCopy.
        """
        return _Abstract.Group_clone(self, *args)

# Register Group in _Abstract:
_Abstract.Group_swigregister(Group)



