# This file was automatically generated by SWIG (http://www.swig.org).
# Version 4.0.2
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.

"""

PyTrilinos.NOX.Epetra.Interface is the python interface to the
Epetra::Interface namespace of the Trilinos package NOX:

    https://trilinos.org/docs/dev/packages/nox/doc/html/index.html

The purpose of NOX.Epetra.Interface is to provide base classes the
user should derive from in order to define the nonlinear function to
be solved, and if needed, its Jacobian and the desired preconditioner.

NOX.Epetra.Interface provides the following user-level classes:

    * Required        - Required class for computing the nonlinear function
    * Jacobian        - Class for computing the Jacobian (if needed)
    * Preconditioner  - Class for computing the preconditioner (if needed)

"""

from sys import version_info as _swig_python_version_info
if _swig_python_version_info < (2, 7, 0):
    raise RuntimeError("Python 2.7 or later required")


if not __package__:
    __package__ = 'PyTrilinos.NOX.Epetra'
from . import _Interface
try:
    from .. import Abstract
except (ValueError, SystemError, ImportError):
    import Abstract


try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)


def _swig_setattr_nondynamic_instance_variable(set):
    def set_instance_attr(self, name, value):
        if name == "thisown":
            self.this.own(value)
        elif name == "this":
            set(self, name, value)
        elif hasattr(self, name) and isinstance(getattr(type(self), name), property):
            set(self, name, value)
        else:
            raise AttributeError("You cannot add instance attributes to %s" % self)
    return set_instance_attr


def _swig_setattr_nondynamic_class_variable(set):
    def set_class_attr(cls, name, value):
        if hasattr(cls, name) and not isinstance(getattr(cls, name), property):
            set(cls, name, value)
        else:
            raise AttributeError("You cannot add class attributes to %s" % cls)
    return set_class_attr


def _swig_add_metaclass(metaclass):
    """Class decorator for adding a metaclass to a SWIG wrapped class - a slimmed down version of six.add_metaclass"""
    def wrapper(cls):
        return metaclass(cls.__name__, cls.__bases__, cls.__dict__.copy())
    return wrapper


class _SwigNonDynamicMeta(type):
    """Meta class to enforce nondynamic attributes (no new attributes) for a class"""
    __setattr__ = _swig_setattr_nondynamic_class_variable(type.__setattr__)


import weakref

class SwigPyIterator(object):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Interface.delete_SwigPyIterator

    def value(self) -> "PyObject *":
        return _Interface.SwigPyIterator_value(self)

    def incr(self, n: "size_t"=1) -> "swig::SwigPyIterator *":
        return _Interface.SwigPyIterator_incr(self, n)

    def decr(self, n: "size_t"=1) -> "swig::SwigPyIterator *":
        return _Interface.SwigPyIterator_decr(self, n)

    def distance(self, x: "SwigPyIterator") -> "ptrdiff_t":
        return _Interface.SwigPyIterator_distance(self, x)

    def equal(self, x: "SwigPyIterator") -> "bool":
        return _Interface.SwigPyIterator_equal(self, x)

    def copy(self) -> "swig::SwigPyIterator *":
        return _Interface.SwigPyIterator_copy(self)

    def next(self) -> "PyObject *":
        return _Interface.SwigPyIterator_next(self)

    def __next__(self) -> "PyObject *":
        return _Interface.SwigPyIterator___next__(self)

    def previous(self) -> "PyObject *":
        return _Interface.SwigPyIterator_previous(self)

    def advance(self, n: "ptrdiff_t") -> "swig::SwigPyIterator *":
        return _Interface.SwigPyIterator_advance(self, n)

    def __eq__(self, x: "SwigPyIterator") -> "bool":
        return _Interface.SwigPyIterator___eq__(self, x)

    def __ne__(self, x: "SwigPyIterator") -> "bool":
        return _Interface.SwigPyIterator___ne__(self, x)

    def __iadd__(self, n: "ptrdiff_t") -> "swig::SwigPyIterator &":
        return _Interface.SwigPyIterator___iadd__(self, n)

    def __isub__(self, n: "ptrdiff_t") -> "swig::SwigPyIterator &":
        return _Interface.SwigPyIterator___isub__(self, n)

    def __add__(self, n: "ptrdiff_t") -> "swig::SwigPyIterator *":
        return _Interface.SwigPyIterator___add__(self, n)

    def __sub__(self, *args) -> "ptrdiff_t":
        return _Interface.SwigPyIterator___sub__(self, *args)
    def __iter__(self):
        return self

# Register SwigPyIterator in _Interface:
_Interface.SwigPyIterator_swigregister(SwigPyIterator)

import PyTrilinos.Teuchos.Base

import sys, os.path as op
parentDir = op.normpath(op.join(op.dirname(op.abspath(__file__)),".."))
if not parentDir in sys.path: sys.path.append(parentDir)
del sys, op

import Abstract
import PyTrilinos.Epetra
class Required(object):
    r"""
    Supplies NOX with the set nonlinear equations.

    This is the minimum required information to solve a nonlinear
    problem using the NOX::Epetra objects for the linear algebra
    implementation.  Used by NOX::Epetra::Group to provide a link
    to the external code for residual fills.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    Residual = _Interface.Required_Residual
    r""" The exact residual (F) is being calculated."""
    Jac = _Interface.Required_Jac
    r""" The Jacobian matrix is being estimated."""
    Prec = _Interface.Required_Prec
    r""" The preconditioner matrix is being estimated."""
    FD_Res = _Interface.Required_FD_Res
    r""" The fill context is from a FD approximation (includes FDC)"""
    MF_Res = _Interface.Required_MF_Res
    r""" The fill context is from a MF approximation"""
    MF_Jac = _Interface.Required_MF_Jac
    r""" The fill context is from a MF computeJacobian() approximation"""
    User = _Interface.Required_User
    r""" A user defined estimation is being performed."""

    def __init__(self, *args):
        r""" Constructor"""
        if self.__class__ == Required:
            _self = None
        else:
            _self = self
        _Interface.Required_swiginit(self, _Interface.new_Required(_self, *args))
    __swig_destroy__ = _Interface.delete_Required

    def computeF(self, *args) -> "bool":
        r"""
        computeF(self, Epetra.Vector x, Epetra.Vector F, FillType flag) -> bool

          Virtual method in C++ that is intended to be overridden by user.
          This method defines the nonlinear function to be solved.  Arguments
          x and F will be provided as numpy-hybrid Epetra.Vector objects.
          Return True if the computation is successful.

          It is strongly recommended that computeF() not raise any exceptions,
          accidental or otherwise.  This can be prevented by wrapping your
          algorithm in a try block:

            try:
              # Your code here...
            except Exception, e:
              print 'Python exception raised in computeF():'
              print e
              return False

          By returning False, you tell NOX that computeF() was unsuccessful.

        """
        return _Interface.Required_computeF(self, *args)
    def __disown__(self):
        self.this.disown()
        _Interface.disown_Required(self)
        return weakref.proxy(self)

# Register Required in _Interface:
_Interface.Required_swigregister(Required)

class Jacobian(object):
    r"""
    Used by NOX::Epetra to provide a link to the
       external code for Jacobian fills.

       This is only required if the user wishes to supply their own Jacobian
       operator.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r""" Constructor."""
        if self.__class__ == Jacobian:
            _self = None
        else:
            _self = self
        _Interface.Jacobian_swiginit(self, _Interface.new_Jacobian(_self, *args))
    __swig_destroy__ = _Interface.delete_Jacobian

    def computeJacobian(self, *args) -> "bool":
        r"""
        Compute Jacobian given the specified input vector x.  Returns
           true if computation was successful.
        """
        return _Interface.Jacobian_computeJacobian(self, *args)
    def __disown__(self):
        self.this.disown()
        _Interface.disown_Jacobian(self)
        return weakref.proxy(self)

# Register Jacobian in _Interface:
_Interface.Jacobian_swigregister(Jacobian)

class Preconditioner(object):
    r"""
    Used by NOX::Epetra to provide a link to the
       external code for Precondtioner fills.

       This is only required if the user wishes to supply their own
       preconditioner operator.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r""" Constructor"""
        if self.__class__ == Preconditioner:
            _self = None
        else:
            _self = self
        _Interface.Preconditioner_swiginit(self, _Interface.new_Preconditioner(_self, *args))
    __swig_destroy__ = _Interface.delete_Preconditioner

    def computePreconditioner(self, *args) -> "bool":
        r""" Computes a user defined preconditioner."""
        return _Interface.Preconditioner_computePreconditioner(self, *args)
    def __disown__(self):
        self.this.disown()
        _Interface.disown_Preconditioner(self)
        return weakref.proxy(self)

# Register Preconditioner in _Interface:
_Interface.Preconditioner_swigregister(Preconditioner)



