# This file was automatically generated by SWIG (http://www.swig.org).
# Version 4.0.2
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.

"""

PyTrilinos.NOX.Solver is the python interface to the Solver namespace
of the Trilinos package NOX:

    https://trilinos.org/docs/dev/packages/nox/doc/html/index.html

The purpose of NOX.Solver is to provide solver manager classes for
NOX.  NOX.Solver provides the following user-level classes:

    * Generic                  - Base class for solver managers
    * LineSearchBased          - Line-search-based solver manager
    * TrustRegionBased         - Trust-region-based solver manager
    * InexactTrustRegionBased  - Inexact-trust-region-based solver
                                 manager
    * TensorBased              - Tensor-based solver manager

in addition to the following factory function:

    * buildSolver              - Recommended method for creating solver
                                 managers (note that without loss of
                                 functionality, the Factory class is not
                                 currently provided).

"""

from sys import version_info as _swig_python_version_info
if _swig_python_version_info < (2, 7, 0):
    raise RuntimeError("Python 2.7 or later required")

# Import the low-level C/C++ module
if __package__ or "." in __name__:
    from . import _Solver
else:
    import _Solver

try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)


def _swig_setattr_nondynamic_instance_variable(set):
    def set_instance_attr(self, name, value):
        if name == "thisown":
            self.this.own(value)
        elif name == "this":
            set(self, name, value)
        elif hasattr(self, name) and isinstance(getattr(type(self), name), property):
            set(self, name, value)
        else:
            raise AttributeError("You cannot add instance attributes to %s" % self)
    return set_instance_attr


def _swig_setattr_nondynamic_class_variable(set):
    def set_class_attr(cls, name, value):
        if hasattr(cls, name) and not isinstance(getattr(cls, name), property):
            set(cls, name, value)
        else:
            raise AttributeError("You cannot add class attributes to %s" % cls)
    return set_class_attr


def _swig_add_metaclass(metaclass):
    """Class decorator for adding a metaclass to a SWIG wrapped class - a slimmed down version of six.add_metaclass"""
    def wrapper(cls):
        return metaclass(cls.__name__, cls.__bases__, cls.__dict__.copy())
    return wrapper


class _SwigNonDynamicMeta(type):
    """Meta class to enforce nondynamic attributes (no new attributes) for a class"""
    __setattr__ = _swig_setattr_nondynamic_class_variable(type.__setattr__)


import weakref

import PyTrilinos.Teuchos.Base
from . import Abstract
import PyTrilinos.Epetra
from . import StatusTest
class Generic(object):
    r"""
    %Abstract nonlinear solver method interface.

    Defines the type of access methods into the iterative nonlinear solvers.


    * Instantiate or reset() the solver.
    * Find the solution via solve() or perform a single iterations via iterate().
    * Get information about the current solver state via
        getSolutionGroup(), getPreviousSolutionGroup(),
        getNumIterations(), and getList() --- particularily
        useful for NOX::StatusTest methods.
    * Get the current status of the solver via getStatus().
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Solver.delete_Generic

    def reset(self, *args) -> "void":
        r"""
        *Overload 1:*
        Resets the solver for another solve. This resets the
             counters and status only. Uses the final solution from the last
             solve as the initial guess for the next solve.

             NOTE: All NOX solvers will call reset() automatically at teh
             beginning of the solve() method. We add the reset() method to
             the solver interface for the application to call in case the
             application needs to reset counters and status manually before
             the next call to solve() is made.

        |

        *Overload 2:*
        Resets the solver and sets a new initial guess.

        |

        *Overload 3:*
        Resets the solver, sets a new status test, and sets a new initial guess.
        """
        return _Solver.Generic_reset(self, *args)

    def step(self, *args) -> "NOX::StatusTest::StatusType":
        r""" Do one nonlinear step in the iteration sequence and return status."""
        return _Solver.Generic_step(self, *args)

    def solve(self, *args) -> "NOX::StatusTest::StatusType":
        r"""
        Solve the nonlinear problem and return final status.

        By "solve", we call iterate() until the NOX::StatusTest value is
        either NOX::StatusTest::Converged or NOX::StatusTest::Failed.
        """
        return _Solver.Generic_solve(self, *args)

    def getStatus(self, *args) -> "NOX::StatusTest::StatusType":
        r""" Returns the current status of the solver."""
        return _Solver.Generic_getStatus(self, *args)

    def getNumIterations(self, *args) -> "int":
        r""" Get number of iterations."""
        return _Solver.Generic_getNumIterations(self, *args)

    def getSolutionGroup(self, *args) -> "Teuchos::RCP< NOX::Abstract::Group const >":
        r""" Return a RCP to the solution group"""
        return _Solver.Generic_getSolutionGroup(self, *args)

    def getPreviousSolutionGroupPtr(self, *args) -> "Teuchos::RCP< NOX::Abstract::Group const >":
        r""" Return a RCP to the previous solution group"""
        return _Solver.Generic_getPreviousSolutionGroupPtr(self, *args)

    def getList(self, *args) -> "Teuchos::RCP< Teuchos::ParameterList const >":
        r""" Return a RCP to the solver parameters."""
        return _Solver.Generic_getList(self, *args)

    def getSolverStatistics(self, *args) -> "Teuchos::RCP< NOX::SolverStats const >":
        r""" Return a RCP to the solver statistics."""
        return _Solver.Generic_getSolverStatistics(self, *args)

# Register Generic in _Solver:
_Solver.Generic_swigregister(Generic)

class LineSearchBased(Generic):
    r"""
    Nonlinear solver based on a line search (i.e., damping)

    Solves :math:`F(x)=0` using an iterative line-search-based method.

    Each iteration, the solver does the following.


    * Compute a search direction :math:`d` via a NOX::Direction method

    * Compute a step length :math:`\lambda` and update :math:`x` as :math:`x_{\rm new}      = x_{\rm old} + \lambda d` via a NOX::LineSearch method.



    The iterations progress until the status tests (see NOX::StatusTest) determine either
    failure or convergence.

    Notes: To support several line searches and status tests, this
    version of the solver has a getStepSize() function that returns
    :math:`\lambda`.

    **Input Parameters**

    The following parameter list entries are valid for this solver:

    - "Line Search" - Sublist of the line search parameters, passed to
      the NOX::LineSearch::Manager constructor. Defaults to an empty list.

    - "Direction" - Sublist of the direction parameters, passed to
      the NOX::Direction::Manager constructor. Defaults to an empty list.

    - "Solver Options" - Sublist of general solver options.

       *  "User Defined Pre/Post Operator" is supported.  See NOX::Parameter::PrePostOperator for more details.



    **Output Parameters**

    Every time solve() is called, a sublist for output parameters called
    "Output" will be created and contain the following parameters.

    "Output":

    - "Nonlinear Iterations" - Number of nonlinear iterations

    - "2-Norm of Residual" - Two-norm of final residual

    Author: Tammy Kolda (SNL 8950), Roger Pawlowski (SNL 9233)
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        Constructor
           See reset(NOX::Abstract::Group&, NOX::StatusTest::Generic&, Teuchos::ParameterList&) for description
        """
        _Solver.LineSearchBased_swiginit(self, _Solver.new_LineSearchBased(*args))
    __swig_destroy__ = _Solver.delete_LineSearchBased

    def reset(self, *args) -> "void":
        return _Solver.LineSearchBased_reset(self, *args)

    def step(self, *args) -> "NOX::StatusTest::StatusType":
        return _Solver.LineSearchBased_step(self, *args)

    def solve(self, *args) -> "NOX::StatusTest::StatusType":
        return _Solver.LineSearchBased_solve(self, *args)

    def getStatus(self, *args) -> "NOX::StatusTest::StatusType":
        return _Solver.LineSearchBased_getStatus(self, *args)

    def getNumIterations(self, *args) -> "int":
        return _Solver.LineSearchBased_getNumIterations(self, *args)

    def getStepSize(self, *args) -> "double":
        return _Solver.LineSearchBased_getStepSize(self, *args)

    def getSolutionGroup(self, *args) -> "Teuchos::RCP< NOX::Abstract::Group const >":
        return _Solver.LineSearchBased_getSolutionGroup(self, *args)

    def getPreviousSolutionGroupPtr(self, *args) -> "Teuchos::RCP< NOX::Abstract::Group const >":
        return _Solver.LineSearchBased_getPreviousSolutionGroupPtr(self, *args)

    def getList(self, *args) -> "Teuchos::RCP< Teuchos::ParameterList const >":
        return _Solver.LineSearchBased_getList(self, *args)

    def getSolverStatistics(self, *args) -> "Teuchos::RCP< NOX::SolverStats const >":
        return _Solver.LineSearchBased_getSolverStatistics(self, *args)

# Register LineSearchBased in _Solver:
_Solver.LineSearchBased_swigregister(LineSearchBased)

class TrustRegionBased(Generic):
    r"""
      %Newton-like solver using a trust region.

    Our goal is to solve: :math:`F(x) = 0,` where :math:`F:\Re^n \rightarrow\Re^n`.  Alternatively, we might say that we wish to solve


    :math:`\min f(x) \equiv \frac{1}{2} \|F(x)\|^2_2.`

    The trust region subproblem (TRSP) at iteration :math:`k` is given by


    :math:`\min \; m_k(s) \equiv f_k + g_k^T d + \frac{1}{2} d^T B_k d,\mbox{ s.t. } \|d\| \leq \Delta_k\quad \mbox{(TRSP)}`

    where


    * :math:`f_k = f(x_k) = \frac{1}{2} \|F(x_k)\|^2_2`,
    * :math:`g_k = \nabla f(x_k) = J(x_k)^T F(x_k)`,
    * :math:`B_k =  J(x_k)^T J(x_k) \approx \nabla^2 f(x_k)`,
    * :math:`J(x_k)` is the Jacobian of :math:`F` at :math:`x_k`, and
    * :math:`\Delta_k` is the trust region radius.


    The "improvement ratio" for a given step :math:`s` is defined as


    :math:`\rho = \displaystyle\frac{ f(x_k) - f(x_k + d) } { m_k(0) - m_k(d) }`

    An iteration consists of the following steps.


    *  Compute Newton-like direction: :math:`n`

    *  Compute Cauchy-like direction: :math:`c`

    *  If this is the first iteration, initialize :math:`\Delta` as
         follows: If :math:`\|n\|_2 < \Delta_{\min}`, then :math:`\Delta = 2     \Delta_{\min}`; else, :math:`\Delta = \|n\|_2`.

    *  Initialize :math:`\rho = -1`

    *  While :math:`\rho < \rho_{\min}` and :math:`\Delta > \Delta_{\min}`, do the following.


         *  Compute the direction :math:`d` as follows:



              *  If :math:`\|n\|_2 < \Delta`, then take a Newton step by
                   setting :math:`d = n`

    	  *  Otherwise if :math:`\|c\|_2 > \Delta`, then take a Cauchy
                   step by setting :math:`d =               \displaystyle\frac{\Delta}{\|c\|_2} c`

    	  *  Otherwise, take a Dog Leg step by setting
                   :math:`d = (1-\gamma) c + \gamma n` where
    	       :math:`\gamma = \displaystyle\frac	       {-c^T a + \sqrt{ (c^Ta)^2 - (c^Tc - \Delta^2) a^Ta}}{a^Ta}`
    	       with :math:`a = n-c`.



         *  Set :math:`x_{\rm new} = x + d` and calculate :math:`f_{\rm new}`

         *  If :math:`f_{\rm new} \geq f`, then :math:`\rho = -1` Otherwise
    	  :math:`\rho = \displaystyle \frac {f - f_{\rm new}} {| d^T J F	  + \frac{1}{2} (J d)^T (J d)|}`



    *  Update the solution: :math:`x = x_{\rm new}`

    *  Update trust region:



         *  If :math:`\rho < \rho_{\rm s}` and :math:`\|n\|_2 < \Delta`,
              then shrink the trust region to the size of the Newton step:
              :math:`\Delta = \|n\|_2`.

         *  Otherwise if :math:`\rho < \rho_{\rm s}`, then shrink the
              trust region: :math:`\Delta = \max \{ \beta_{\rm s} \Delta,          \Delta_{\min} \}`.

         *  Otherwise if :math:`\rho > \rho_{\rm e}` and :math:`\|d\|_2 =          \Delta`, then expand the trust region: :math:`\Delta = \min \{          \beta_{\rm e} \Delta, \Delta_{\rm max} \}`.





    **Input Paramters**

    The following parameters should be specified in the "Trust Region"
    sublist based to the solver.

      - "Direction" - Sublist of the direction parameters for the %Newton
        point, passed to the NOX::Direction::Manager constructor. If this
        sublist does not exist, it is created by default. Furthermore, if
        "Method" is not specified in this sublist, it is added with a value of
        "Newton".

      - "Cauchy %Direction" - Sublist of the direction parameters for the
        Cauchy point, passed to the NOX::Direction::Manager
        constructor. If this sublist does not exist, it is created by
        default. Furthremore, if "Method" is not specified in this
        sublist, it is added with a value of "Steepest Descent" Finally,
        if the sub-sublist "Steepest Descent" does not exist, it is
        created and the parameter "Scaling Type" is added and set to
        "Quadratic".

    - "Minimum Trust Region Radius" (:math:`\Delta_{\min}`) - Minimum allowable trust region
      radius. Defaults to 1.0e-6.

    - "Maximum Trust Region Radius" (:math:`\Delta_{\max}`) - Maximum allowable trust region
      radius. Defaults to 1.0e+10.

    - "Minimum Improvement Ratio" (:math:`\rho_{\min}`) - Minimum improvement ratio to accept
      the step. Defaults to 1.0e-4.

    - "Contraction Trigger Ratio" (:math:`\rho_{\rm s}`) - If the improvement ratio is less than
      this value, then the trust region is contracted by the amount
      specified by the "Contraction Factor". Must be larger than "Minimum
      Improvement Ratio". Defaults to 0.1.

    - "Contraction Factor" (:math:`\beta_{\rm s}`) - See above. Defaults to 0.25.

    - "Expansion Trigger Ratio" (:math:`\rho_{\rm e}`) - If the
      improvement ratio is greater than this value, then the trust region
      is contracted by the amount specified by the "Expansion
      Factor". Defaults to 0.75.

    - "Expansion Factor"  (:math:`\beta_{\rm e}`) - See above. Defaults to 4.0.

    - "Recovery Step" - Defaults to 1.0.

    - "Use Ared/Pred Ratio Calculation" (boolean) - Defaults to false. If
      set to true, this option replaces the algorithm used to compute the
      improvement ratio, :math:`\rho`, as described above.  The improvement
      ratio is replaced by an "Ared/Pred" sufficient decrease criteria
      similar to that used in line search algorithms (see Eisenstat and
      Walker, SIAM Journal on Optimization V4 no. 2 (1994) pp 393-422):
      - :math:`\rho = \frac{\|F(x) \| - \| F(x + d) \| }                   {\| F(x) \| - \| F(x) + Jd \| }`

      - "Solver Options" - Sublist of general solver options.

         *  "User Defined Pre/Post Operator" is supported.  See NOX::Parameter::PrePostOperator for more details.



    **Output Paramters**

    A sublist for output parameters called "Output" will be created and contain the following parameters:

    - "Nonlinear Iterations" - Number of nonlinear iterations

    - "2-Norm or Residual" - Two-norm of final residual

      Author: Tammy Kolda (SNL 8950), Roger Pawlowski (SNL 9233)
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        Constructor

        See reset() for description.
        """
        _Solver.TrustRegionBased_swiginit(self, _Solver.new_TrustRegionBased(*args))
    __swig_destroy__ = _Solver.delete_TrustRegionBased

    def reset(self, *args) -> "void":
        return _Solver.TrustRegionBased_reset(self, *args)

    def step(self, *args) -> "NOX::StatusTest::StatusType":
        return _Solver.TrustRegionBased_step(self, *args)

    def solve(self, *args) -> "NOX::StatusTest::StatusType":
        return _Solver.TrustRegionBased_solve(self, *args)

    def getStatus(self, *args) -> "NOX::StatusTest::StatusType":
        return _Solver.TrustRegionBased_getStatus(self, *args)

    def getNumIterations(self, *args) -> "int":
        return _Solver.TrustRegionBased_getNumIterations(self, *args)

    def getSolutionGroup(self, *args) -> "Teuchos::RCP< NOX::Abstract::Group const >":
        return _Solver.TrustRegionBased_getSolutionGroup(self, *args)

    def getPreviousSolutionGroupPtr(self, *args) -> "Teuchos::RCP< NOX::Abstract::Group const >":
        return _Solver.TrustRegionBased_getPreviousSolutionGroupPtr(self, *args)

    def getList(self, *args) -> "Teuchos::RCP< Teuchos::ParameterList const >":
        return _Solver.TrustRegionBased_getList(self, *args)

    def getSolverStatistics(self, *args) -> "Teuchos::RCP< NOX::SolverStats const >":
        return _Solver.TrustRegionBased_getSolverStatistics(self, *args)

# Register TrustRegionBased in _Solver:
_Solver.TrustRegionBased_swigregister(TrustRegionBased)

class InexactTrustRegionBased(Generic):
    r"""
      %Newton-like solver using a trust region.

    Our goal is to solve: :math:`F(x) = 0,` where :math:`F:\Re^n \rightarrow\Re^n`.  Alternatively, we might say that we wish to solve


    :math:`\min f(x) \equiv \frac{1}{2} \|F(x)\|^2_2.`

    The trust region subproblem (TRSP) at iteration :math:`k` is given by


    :math:`\min \; m_k(s) \equiv f_k + g_k^T d + \frac{1}{2} d^T B_k d,\mbox{ s.t. } \|d\| \leq \Delta_k\quad \mbox{(TRSP)}`

    where


    * :math:`f_k = f(x_k) = \frac{1}{2} \|F(x_k)\|^2_2`,
    * :math:`g_k = \nabla f(x_k) = J(x_k)^T F(x_k)`,
    * :math:`B_k =  J(x_k)^T J(x_k) \approx \nabla^2 f(x_k)`,
    * :math:`J(x_k)` is the Jacobian of :math:`F` at :math:`x_k`, and
    * :math:`\Delta_k` is the trust region radius.


    The "improvement ratio" for a given step :math:`s` is defined as


    :math:`\rho = \displaystyle\frac{ f(x_k) - f(x_k + d) } { m_k(0) - m_k(d) }`

    An iteration consists of the following steps.


    *  Compute Newton-like direction: :math:`n`

    *  Compute Cauchy-like direction: :math:`c`

    *  If this is the first iteration, initialize :math:`\Delta` as
         follows: If :math:`\|n\|_2 < \Delta_{\min}`, then :math:`\Delta = 2     \Delta_{\min}`; else, :math:`\Delta = \|n\|_2`.

    *  Initialize :math:`\rho = -1`

    *  While :math:`\rho < \rho_{\min}` and :math:`\Delta > \Delta_{\min}`, do the following.


         *  Compute the direction :math:`d` as follows:



              *  If :math:`\|n\|_2 < \Delta`, then take a Newton step by
                   setting :math:`d = n`

          *  Otherwise if :math:`\|c\|_2 > \Delta`, then take a Cauchy
                   step by setting :math:`d =               \displaystyle\frac{\Delta}{\|c\|_2} c`

          *  Otherwise, take a Dog Leg step by setting
                   :math:`d = (1-\gamma) c + \gamma n` where
               :math:`\gamma = \displaystyle\frac           {-c^T a + \sqrt{ (c^Ta)^2 - (c^Tc - \Delta^2) a^Ta}}{a^Ta}`
               with :math:`a = n-c`.



         *  Set :math:`x_{\rm new} = x + d` and calculate :math:`f_{\rm new}`

         *  If :math:`f_{\rm new} \geq f`, then :math:`\rho = -1` Otherwise
          :math:`\rho = \displaystyle \frac {f - f_{\rm new}} {| d^T J F      + \frac{1}{2} (J d)^T (J d)|}`



    *  Update the solution: :math:`x = x_{\rm new}`

    *  Update trust region:



         *  If :math:`\rho < \rho_{\rm s}` and :math:`\|n\|_2 < \Delta`,
              then shrink the trust region to the size of the Newton step:
              :math:`\Delta = \|n\|_2`.

         *  Otherwise if :math:`\rho < \rho_{\rm s}`, then shrink the
              trust region: :math:`\Delta = \max \{ \beta_{\rm s} \Delta,          \Delta_{\min} \}`.

         *  Otherwise if :math:`\rho > \rho_{\rm e}` and :math:`\|d\|_2 =          \Delta`, then expand the trust region: :math:`\Delta = \min \{          \beta_{\rm e} \Delta, \Delta_{\rm max} \}`.





    **Input Paramters**

    The following parameters should be specified in the "Trust Region"
    sublist based to the solver.

    - "Inner Iteration Method" - Choice of trust region algorithm to use.
      Choices are:

      *  "Standard Trust Region"
      *  "Inexact Trust Region"


    - "Direction" - Sublist of the direction parameters for the %Newton
      point, passed to the NOX::Direction::Manager constructor. If this
      sublist does not exist, it is created by default. Furthermore, if
      "Method" is not specified in this sublist, it is added with a value of
      "Newton".

    - "Cauchy %Direction" - Sublist of the direction parameters for the
      Cauchy point, passed to the NOX::Direction::Manager constructor. If
      this sublist does not exist, it is created by default. Furthermore, if
      "Method" is not specified in this sublist, it is added with a value of
      "Steepest Descent" Finally, if the sub-sublist "Steepest Descent" does
      not exist, it is created and the parameter "Scaling Type" is added and
      set to "Quadratic Min Model".

    - "Minimum Trust Region Radius" (:math:`\Delta_{\min}`) - Minimum allowable trust region
      radius. Defaults to 1.0e-6.

    - "Maximum Trust Region Radius" (:math:`\Delta_{\max}`) - Minimum allowable trust region
      radius. Defaults to 1.0e+10.

    - "Minimum Improvement Ratio" (:math:`\rho_{\min}`) - Minimum improvement ratio to accept
      the step. Defaults to 1.0e-4.

    - "Contraction Trigger Ratio" (:math:`\rho_{\rm s}`) - If the improvement ratio is less than
      this value, then the trust region is contracted by the amount
      specified by the "Contraction Factor". Must be larger than "Minimum
      Improvement Ratio". Defaults to 0.1.

    - "Contraction Factor" (:math:`\beta_{\rm s}`) - See above. Defaults to 0.25.

    - "Expansion Trigger Ratio" (:math:`\rho_{\rm e}`) - If the
      improvement ratio is greater than this value, then the trust region
      is contracted by the amount specified by the "Expansion
      Factor". Defaults to 0.75.

    - "Expansion Factor"  (:math:`\beta_{\rm e}`) - See above. Defaults to 4.0.

    - "Recovery Step" - Defaults to 1.0.

    - "Use Ared/Pred Ratio Calculation" (boolean) - Defaults to false. If
      set to true, this option replaces the algorithm used to compute the
      improvement ratio, :math:`\rho`, as described above.  The improvement
      ratio is replaced by an "Ared/Pred" sufficient decrease criteria
      similar to that used in line search algorithms (see Eisenstat and
      Walker, SIAM Journal on Optimization V4 no. 2 (1994) pp 393-422):
      - :math:`\rho = \frac{\|F(x) \| - \| F(x + d) \| }                   {\| F(x) \| - \| F(x) + Jd \| }`

    - "Use Cauchy in Newton Direction" - Boolean.  Used only by the
      "Inexact Trust Region" algorithm.  If set to true, the initial guess
      for the Newton direction computation will use the Cauchy direction as
      the initial guess.  Defaults to false.

    - "Use Dogleg Segment Minimization" - Boolean.  Used only by the
      "Inexact Trust Region" algorithm.  If set to true, the :math:`\tau`
      parameter is minimized over the dogleg line segments instead of
      being computed at the trust regioin radius.  Used only by the
      "Inexact Trust Region" algorithm.  Defaults to false.

    - "Use Counters" - Boolean.  If set to true, solver statistics will be stored.  Defaults to true.

    - "Write Output Parameters" - Boolean.  If set to true, the solver statistics will be written to the relevant "Output" sublists (see Output Parameters).  Defaults to true.

    - "Solver Options" - Sublist of general solver options.

       *  "User Defined Pre/Post Operator" is supported.  See NOX::Parameter::PrePostOperator for more details.


    **Output Paramters**

    A sublist called "Output" will be created at the top level of the parameter list and contain the following general solver parameters:

    - "Nonlinear Iterations" - Number of nonlinear iterations

    - "2-Norm or Residual" - Two-norm of final residual

    A sublist called "Output" will be created in the "Trust Region" sublist and contain the following trust region specific output parameters:

    - "Number of Cauchy Steps" - Number of cauchy steps taken during the solve.

    - "Number of Newton Steps" - Number of Newton steps taken during the solve.

    - "Number of Dogleg Steps" - Number of Dogleg steps taken during the solve.

    - "Number of Trust Region Inner Iterations" - Number of inner iterations
      required to adjust the trust region radius.

    - "Dogleg Steps: Average Fraction of Newton Step Length" - Average value of the fraction a dogleg step took compared to the full Newton step.  The fractional value is computed as :math:`\mbox{frac} = \frac{\| d \|}{\| n\|}`.

    - "Dogleg Steps: Average Fraction Between Cauchy and Newton Direction" -  Average value of the fraction a dogleg step took between the Cauchy and Newton directions.  This is the :math:`\gamma` variable in the standard dogleg algorithm and the :math:`\tau` parameter in the inexact dogleg algorithm.  A value of 0.0 is a full step in the Cauchy direction and a value of 1.0 is a full step in the Newton direction.

      Author: Tammy Kolda (SNL 8950), Roger Pawlowski (SNL 9233)
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        Constructor

        See reset() for description.
        """
        _Solver.InexactTrustRegionBased_swiginit(self, _Solver.new_InexactTrustRegionBased(*args))
    __swig_destroy__ = _Solver.delete_InexactTrustRegionBased

    def reset(self, *args) -> "void":
        return _Solver.InexactTrustRegionBased_reset(self, *args)

    def step(self, *args) -> "NOX::StatusTest::StatusType":
        return _Solver.InexactTrustRegionBased_step(self, *args)

    def solve(self, *args) -> "NOX::StatusTest::StatusType":
        return _Solver.InexactTrustRegionBased_solve(self, *args)

    def getStatus(self, *args) -> "NOX::StatusTest::StatusType":
        return _Solver.InexactTrustRegionBased_getStatus(self, *args)

    def getNumIterations(self, *args) -> "int":
        return _Solver.InexactTrustRegionBased_getNumIterations(self, *args)

    def getSolutionGroup(self, *args) -> "Teuchos::RCP< NOX::Abstract::Group const >":
        return _Solver.InexactTrustRegionBased_getSolutionGroup(self, *args)

    def getPreviousSolutionGroupPtr(self, *args) -> "Teuchos::RCP< NOX::Abstract::Group const >":
        return _Solver.InexactTrustRegionBased_getPreviousSolutionGroupPtr(self, *args)

    def getList(self, *args) -> "Teuchos::RCP< Teuchos::ParameterList const >":
        return _Solver.InexactTrustRegionBased_getList(self, *args)

    def getSolverStatistics(self, *args) -> "Teuchos::RCP< NOX::SolverStats const >":
        return _Solver.InexactTrustRegionBased_getSolverStatistics(self, *args)

# Register InexactTrustRegionBased in _Solver:
_Solver.InexactTrustRegionBased_swigregister(InexactTrustRegionBased)

class TensorBased(Generic):
    r"""
      Nonlinear solver based on a rank-1 tensor method.

      Solves :math:`F(x)=0` using a rank-1 tensor method and a linesearch
      globalization.

      At the kth nonlinear iteration, the solver does the following:



      * Computes the tensor direction :math:`d_T` by finding the root or
          smallest magnitude minimizer of the local model.. math::

        M_T(x_k+d) =
              F_k + J_kd + a_k(s_k^Td)^2, where.. math::

        a_k = 2(F_{k-1} - F_k
              - J_ks_k) / (s_k^Ts_k)^2 and.. math::

        s_k = s_{k-1} - s_k.

      * Modifies the step according to a global strategy and updates
          :math:`x` as :math:`x_{k+1} = x_k + d(\lambda)` via a linesearch
          method, where :math:`d(\lambda)` is some function of :math:`\lambda`.  For instance, the curvilinear step :math:`d_{\lambda T}`
          is a function of the linesearch parameter :math:`\lambda` and is
          a parametric step that spans the directions of the tensor step
          and the Newton step.  At :math:`\lambda=1`, the curvilinear step
          equals the full tensor step, and as :math:`\lambda` nears 0, the
          curvilinear step approaches the Newton direction.  This step
          provides a monotonic decrease in the norm of the local tensor
          model as :math:`\lambda` varies from 0 to 1.



      The solver iterates until the status tests (see NOX::StatusTest)
      determine either failure or convergence.

      **Input Parameters**

      To use this solver, set the "Nonlinear Solver" parameter to be
      "Tensor Based".  Then, specify the following sublists with the
      appropriate parameters as indicated below.



      *  "Direction" - Sublist of the direction parameters, passed to
           the NOX::Direction::Factory constructor. Defaults to an empty
           list.



           *  "Method" - Name of the direction to be computed in this
           solver.  "Tensor" and "Newton" are the only two valid choices.
           A sublist by this name specifies all of the parameters to be
           passed to the linear solver.  See below under "Linear Solver".

           *  "Rescue Bad Newton Solve" (Boolean) - If the linear solve
           does not meet the tolerance specified by the forcing term, then
           use the step anyway. Defaults to true.

           *  "Linear Solver" - Sublist for the specific linear solver
           parameters that are passed to
           NOX::Abstract::Group::computeNewton() and
           NOX::Abstract::Group::applyJacobianInverse().  "Linear Solver"
           is itself a sublist of the list specified in "Method" above
           (i.e., "Tensor" or "Newton").  Below is a partial list of
           standard parameters usually available in common linear solvers.
           Check with the specific linear solver being used for other
           parameters.



            *  "Max Iterations" - Maximum number of Arnoldi
                iterations (also max Krylov space dimension)

                *  "Tolerance" - Relative tolerance for solving local
                model [default = 1e-4]

            *  "Output Frequency" - Print output at every number of
                iterations [default = 20]





      *  "Line Search" - Sublist of the line search parameters.  Because
           the tensor step is not guaranteed to be a descent direction on
           the function, not all "basic" line search approaches would be
           appropriate.  Thus, the LineSearch classes available to
           Newton's method (e.g., Polynomial, More-Thuente) are not used
           here.  Instead, this solver class approriately handles
           technical considerations for tensor methods with its own set of
           global strategies.  The following parameters specify the
           specific options for this line search:



           *  "Method" - Name of the line search available to tensor
           methods Valid choices are:



                *  "Curvilinear" - Backtrack along the "curvilinear"
            path that spans the tensor direction and the Newton
            direction and that maintains monotonicity on the tensor
            model.  Recommended because it tends to be more robust and
            efficient than the other choices.  [Default]

            *  "Standard" - Backtrack along tensor direction unless
            it is not a descent direction, in which case backtrack
            along Newton direction.

            *  "Dual" - Backtrack along both the Newton and tensor
            directions and choose the better of the two.

            *  "Full Step" - Only use the full step and do not
            backtrack along both the Newton and tensor directions and
            choose the better of the two.



           *  "Lambda selection" - Flag for how to calculate the next
           linesearch parameter lambda.  Valid choices are "Quadratic" and
           "Halving" (default).  Quadratic constructs a quadratic
           interpolating polynomial from the last trial point and uses the
           minimum of this function as the next trial lambda (bounded by
           0.1).  Halving divides the linesearch parameter by 2 before
           each trial, which is simpler but tends to generate longer steps
           than quadratic.

           *  "Default Step" - Starting value of the linesearch parameter
           (defaults to 1.0)

           *  "Minimum Step" - Minimum acceptable linesearch parameter
           before the linesearch terminates (defaults to 1.0e-12). If
           there are many linesearch failures, then lowering this value is
           one thing to try.

           *  "Recovery Step Type" - Determines the step size to take when the
           line search fails.  Choices are:



          *  "Constant" [default] - Uses a constant value set in
          "Recovery Step".

          *  "Last Computed Step" - Uses the last value computed by the
          line search algorithm.



           *  "Recovery Step" - Step parameter to take when the line
           search fails (defaults to value for "Default Step")

           *  "Max Iters" - Maximum number of iterations (i.e., backtracks)



      * "Solver Options" - Sublist of general solver options.



           *  "User Defined Pre/Post Operator" is supported.  See
           NOX::Parameter::PrePostOperator for more details.





      **Output Parameters**

      Every time solve() is called, a sublist for output parameters called
      "Output" will be created and will contain the following parameters:



      *  "Nonlinear Iterations" - Number of nonlinear iterations

      *  "2-Norm of Residual" - L-2 norm of the final residual :math:`F(x_k)`.




    **References**



      *  B. W. Bader, **Tensor-Krylov methods for solving large-scale
      systems of nonlinear equations**, Ph.D. Thesis, 2003, University
      of Colorado, Boulder, Colorado.

      *  B. W. Bader, **Tensor-Krylov methods for solving large-scale
      systems of nonlinear equations**, submitted to SIAM J. Numer. Anal.

      *  B. W. Bader and R. B. Schnabel, **Curvilinear linesearch for
      tensor methods**, SISC, 25(2):604-622.

      *  R. B. Schnabel and P. D. Frank, **Tensor methods for
      nonlinear equations**, SIAM J. Numer. Anal., 21(5):815-843.




      Author: Brett Bader (SNL 9233)

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        Constructor

        See reset() for description.
        """
        _Solver.TensorBased_swiginit(self, _Solver.new_TensorBased(*args))
    __swig_destroy__ = _Solver.delete_TensorBased

    def reset(self, *args) -> "void":
        return _Solver.TensorBased_reset(self, *args)

    def step(self, *args) -> "NOX::StatusTest::StatusType":
        return _Solver.TensorBased_step(self, *args)

    def solve(self, *args) -> "NOX::StatusTest::StatusType":
        return _Solver.TensorBased_solve(self, *args)

    def getStatus(self, *args) -> "NOX::StatusTest::StatusType":
        return _Solver.TensorBased_getStatus(self, *args)

    def getNumIterations(self, *args) -> "int":
        return _Solver.TensorBased_getNumIterations(self, *args)

    def getSolutionGroup(self, *args) -> "Teuchos::RCP< NOX::Abstract::Group const >":
        return _Solver.TensorBased_getSolutionGroup(self, *args)

    def getPreviousSolutionGroupPtr(self, *args) -> "Teuchos::RCP< NOX::Abstract::Group const >":
        return _Solver.TensorBased_getPreviousSolutionGroupPtr(self, *args)

    def getList(self, *args) -> "Teuchos::RCP< Teuchos::ParameterList const >":
        return _Solver.TensorBased_getList(self, *args)

    def getSolverStatistics(self, *args) -> "Teuchos::RCP< NOX::SolverStats const >":
        return _Solver.TensorBased_getSolverStatistics(self, *args)

# Register TensorBased in _Solver:
_Solver.TensorBased_swigregister(TensorBased)


def buildSolver(*args) -> "PyObject *":
    return _Solver.buildSolver(*args)


