# This file was automatically generated by SWIG (http://www.swig.org).
# Version 4.0.2
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.

"""

PyTrilinos.Tpetra is the python interface to the Trilinos linear
algebra services package Tpetra:

    https://trilinos.org/docs/dev/packages/tpetra/doc/html/index.html

The purpose of Tpetra is to provide fundamental linear algebra
services to the rest of Trilinos.  These services include parallel
decomposition and communication, vectors and multivectors, graphs,
operators, and dense and sparse matrices.

"""

from sys import version_info as _swig_python_version_info
if _swig_python_version_info < (2, 7, 0):
    raise RuntimeError("Python 2.7 or later required")

# Import the low-level C/C++ module
if __package__ or "." in __name__:
    from . import _Tpetra
else:
    import _Tpetra

try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)


def _swig_setattr_nondynamic_instance_variable(set):
    def set_instance_attr(self, name, value):
        if name == "thisown":
            self.this.own(value)
        elif name == "this":
            set(self, name, value)
        elif hasattr(self, name) and isinstance(getattr(type(self), name), property):
            set(self, name, value)
        else:
            raise AttributeError("You cannot add instance attributes to %s" % self)
    return set_instance_attr


def _swig_setattr_nondynamic_class_variable(set):
    def set_class_attr(cls, name, value):
        if hasattr(cls, name) and not isinstance(getattr(cls, name), property):
            set(cls, name, value)
        else:
            raise AttributeError("You cannot add class attributes to %s" % cls)
    return set_class_attr


def _swig_add_metaclass(metaclass):
    """Class decorator for adding a metaclass to a SWIG wrapped class - a slimmed down version of six.add_metaclass"""
    def wrapper(cls):
        return metaclass(cls.__name__, cls.__bases__, cls.__dict__.copy())
    return wrapper


class _SwigNonDynamicMeta(type):
    """Meta class to enforce nondynamic attributes (no new attributes) for a class"""
    __setattr__ = _swig_setattr_nondynamic_class_variable(type.__setattr__)


import weakref

class SwigPyIterator(object):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Tpetra.delete_SwigPyIterator

    def value(self) -> "PyObject *":
        return _Tpetra.SwigPyIterator_value(self)

    def incr(self, n: "size_t"=1) -> "swig::SwigPyIterator *":
        return _Tpetra.SwigPyIterator_incr(self, n)

    def decr(self, n: "size_t"=1) -> "swig::SwigPyIterator *":
        return _Tpetra.SwigPyIterator_decr(self, n)

    def distance(self, x: "SwigPyIterator") -> "ptrdiff_t":
        return _Tpetra.SwigPyIterator_distance(self, x)

    def equal(self, x: "SwigPyIterator") -> "bool":
        return _Tpetra.SwigPyIterator_equal(self, x)

    def copy(self) -> "swig::SwigPyIterator *":
        return _Tpetra.SwigPyIterator_copy(self)

    def next(self) -> "PyObject *":
        return _Tpetra.SwigPyIterator_next(self)

    def __next__(self) -> "PyObject *":
        return _Tpetra.SwigPyIterator___next__(self)

    def previous(self) -> "PyObject *":
        return _Tpetra.SwigPyIterator_previous(self)

    def advance(self, n: "ptrdiff_t") -> "swig::SwigPyIterator *":
        return _Tpetra.SwigPyIterator_advance(self, n)

    def __eq__(self, x: "SwigPyIterator") -> "bool":
        return _Tpetra.SwigPyIterator___eq__(self, x)

    def __ne__(self, x: "SwigPyIterator") -> "bool":
        return _Tpetra.SwigPyIterator___ne__(self, x)

    def __iadd__(self, n: "ptrdiff_t") -> "swig::SwigPyIterator &":
        return _Tpetra.SwigPyIterator___iadd__(self, n)

    def __isub__(self, n: "ptrdiff_t") -> "swig::SwigPyIterator &":
        return _Tpetra.SwigPyIterator___isub__(self, n)

    def __add__(self, n: "ptrdiff_t") -> "swig::SwigPyIterator *":
        return _Tpetra.SwigPyIterator___add__(self, n)

    def __sub__(self, *args) -> "ptrdiff_t":
        return _Tpetra.SwigPyIterator___sub__(self, *args)
    def __iter__(self):
        return self

# Register SwigPyIterator in _Tpetra:
_Tpetra.SwigPyIterator_swigregister(SwigPyIterator)


import numpy

from . import Teuchos
from .Teuchos import Base

def class_array_inplace_op(self, op_str, other):
  in_op = getattr(self.array, "__i"+op_str+"__")
  in_op(other.array)
  return self

def class_array_math_op(self, op_str, other):
# Initialize the result by calling the copy constructor
  result = self.__class__(self)
# Get the equivalent in-place operator for the result
  in_op = getattr(result.array, "__i"+op_str+"__")
  try:
    in_op(other.array)
  except AttributeError:
    in_op(other)
  return result

def class_array_rmath_op(self, op_str, other):
# Initialize the result by calling the copy constructor
  result = self.__class__(self)
  indices = (slice(None),) * len(self.array.shape)
  result.array[indices] = other
  in_op = getattr(result.array, "__i"+op_str+"__")
  in_op(self.array)
  return result

def class_array_add_math_ops(cls, op_str):
  setattr(cls,
          "__i"+op_str+"__",
          lambda self, other: class_array_inplace_op(self, op_str, other))
  setattr(cls,
          "__"+op_str+"__",
          lambda self, other: class_array_math_op(self, op_str, other))
  setattr(cls,
          "__r"+op_str+"__",
          lambda self, other: class_array_rmath_op(self, op_str, other))

def class_array_add_math(cls):
  class_array_add_math_ops(cls, "add")
  class_array_add_math_ops(cls, "sub")
  class_array_add_math_ops(cls, "mul")
  class_array_add_math_ops(cls, "add")

def class_array_comp_op(self, op_str, other):
  comp_op = getattr(self.array, "__"+op_str+"__")
  try:
    return comp_op(other.array)
  except AttributeError:
    return comp_op(other)

def class_array_add_comp_op(cls, op_str):
  setattr(cls,
          "__"+op_str+"__",
          lambda self, other: class_array_comp_op(self, op_str, other))

def class_array_add_comp(cls):
  class_array_add_comp_op(cls, "lt")
  class_array_add_comp_op(cls, "le")
  class_array_add_comp_op(cls, "eq")
  class_array_add_comp_op(cls, "ne")
  class_array_add_comp_op(cls, "gt")
  class_array_add_comp_op(cls, "ge")


KOKKOS_ENABLE_PRAGMA_UNROLL = _Tpetra.KOKKOS_ENABLE_PRAGMA_UNROLL
KOKKOS_ENABLE_PRAGMA_LOOPCOUNT = _Tpetra.KOKKOS_ENABLE_PRAGMA_LOOPCOUNT
KOKKOS_ENABLE_PRAGMA_VECTOR = _Tpetra.KOKKOS_ENABLE_PRAGMA_VECTOR
KOKKOS_ENABLE_PRAGMA_IVDEP = _Tpetra.KOKKOS_ENABLE_PRAGMA_IVDEP
KOKKOS_MEMORY_ALIGNMENT = _Tpetra.KOKKOS_MEMORY_ALIGNMENT
KOKKOS_ENABLE_ASM = _Tpetra.KOKKOS_ENABLE_ASM
KOKKOS_MEMORY_ALIGNMENT_THRESHOLD = _Tpetra.KOKKOS_MEMORY_ALIGNMENT_THRESHOLD
TPETRA_PRINTS_EFFICIENCY_WARNINGS = _Tpetra.TPETRA_PRINTS_EFFICIENCY_WARNINGS
TPETRA_THROWS_ABUSE_WARNINGS = _Tpetra.TPETRA_THROWS_ABUSE_WARNINGS
TPETRA_PRINTS_ABUSE_WARNINGS = _Tpetra.TPETRA_PRINTS_ABUSE_WARNINGS
LocallyReplicated = _Tpetra.LocallyReplicated
GloballyDistributed = _Tpetra.GloballyDistributed
AllIDsPresent = _Tpetra.AllIDsPresent
r""" All queried indices were present in the Map"""
IDNotPresent = _Tpetra.IDNotPresent
r""" At least one of the specified indices was not present in the Map"""
DoOptimizeStorage = _Tpetra.DoOptimizeStorage
r""" Indicates that storage should be optimized"""
DoNotOptimizeStorage = _Tpetra.DoNotOptimizeStorage
r""" Indicates that storage should not be optimized"""
COMPUTE_VIEW_CONSTRUCTOR = _Tpetra.COMPUTE_VIEW_CONSTRUCTOR
HOST_VIEW_CONSTRUCTOR = _Tpetra.HOST_VIEW_CONSTRUCTOR
Forward = _Tpetra.Forward
Backward = _Tpetra.Backward
Symmetric = _Tpetra.Symmetric
ADD = _Tpetra.ADD
r""" Sum new values"""
INSERT = _Tpetra.INSERT
r""" Insert new values that don't currently exist"""
REPLACE = _Tpetra.REPLACE
r""" Replace existing values with new values"""
ABSMAX = _Tpetra.ABSMAX
r""" Replace old value with maximum of magnitudes of old and new values"""
ZERO = _Tpetra.ZERO
r""" Replace old values with zero"""
ADD_ASSIGN = _Tpetra.ADD_ASSIGN
r""" Accumulate new values into existing values (may not be supported in all classes)"""

def setCombineModeParameter(*args) -> "void":
    r"""
    Set CombineMode parameter in a Teuchos::ParameterList.

    If you are constructing a Teuchos::ParameterList with a
    CombineMode parameter, set the parameter by using this function.
    This will use a special feature of Teuchos -- custom parameter
    list validation -- so that users can specify CombineMode values
    by string, rather than enum value.  The strings are the same as
    the enum names: "ADD", "INSERT", "REPLACE", "ABSMAX", and
    "ZERO".  They are *not* case sensitive.

    Using this function to set a CombineMode parameter will ensure
    that the XML serialization of the resulting
    Teuchos::ParameterList will refer to the CombineMode enum values
    using human-readable string names, rather than raw integers.

    :type plist: :py:class:`ParameterList`
    :param plist: [out] Teuchos::ParameterList to which you want to
          add the Tpetra::CombineMode parameter.

    :type paramName: string
    :param paramName: [in] String name to use for the parameter.  For
          example, you might wish to call the parameter "Combine Mode",
          "Tpetra::CombineMode", or "combine mode".  The parameter's
          name *is* case sensitive, even though the string values
          are *not*.
    """
    return _Tpetra.setCombineModeParameter(*args)

def combineModeToString(*args) -> "std::string":
    r""" Human-readable string representation of the given CombineMode."""
    return _Tpetra.combineModeToString(*args)

def version(*args) -> "std::string":
    return _Tpetra.version(*args)

__version__ = version()

class Map_default(Teuchos.Base.Describable):
    r"""
    A parallel distribution of indices over processes.

    :param LocalOrdinal: The type of local indices.  Currently, this
          *must* be int.  (In Epetra, this is always just
          int.)

    :param GlobalOrdinal: The type of global indices.  This
          *must* be a built-in integer type.  We allow either
          signed or unsigned types here, but prefer signed types.  Also,
          we require that GlobalOrdinal be no smaller than
          LocalOrdinal, that is:

          .. code-block:: c++

          sizeof(GlobalOrdinal) >= sizeof(LocalOrdinal);
      If LocalOrdinal is int, good models of
      GlobalOrdinal are

      *  ``int``  (if the configure-time option
           Tpetra_INST_INT_INT is set)
      *  ``long``  (if the configure-time option
           Tpetra_INST_INT_LONG is set)
      *  long long (if the configure-time option
           Tpetra_INST_INT_LONG_LONG is set)

      If the default GlobalOrdinal is int, then
      the *global* number of rows or columns in the matrix may
      be no more than ``INT_MAX``, which for typical 32-bit ``int`` is
      :math:`2^{31} - 1` (about two billion).  If you want to solve
      larger problems, you must use a 64-bit integer type here.

    :param Node: A class implementing on-node shared-memory parallel
          operations.
          The default ``Node`` type should suffice for most users.
          The actual default type depends on your Trilinos build options.
          This must be one of the following:

          *  Kokkos::Compat::KokkosCudaWrapperNode
          *  Kokkos::Compat::KokkosOpenMPWrapperNode
          *  Kokkos::Compat::KokkosThreadsWrapperNode
          *  Kokkos::Compat::KokkosSerialWrapperNode

          All of the above are just typedefs for
          Kokkos::Compat::KokkosDeviceWrapperNode<ExecutionSpaceType,
          MemorySpaceType>, where ExecutionSpaceType is a Kokkos
          execution space type, and MemorySpaceType is a Kokkos memory
          space type.  If you omit MemorySpaceType, Tpetra will use the
          execution space's default memory space.

    This class describes a distribution of data elements over one or
    more processes in a communicator.  Each element has a global
    index (of type ``GlobalOrdinal)`` uniquely associated to it.
    Each global index in the Map is "owned" by one or more processes
    in the Map's communicator.  The user gets to decide what an
    "element" means; examples include a row or column of a sparse
    matrix (as in CrsMatrix), or a row of one or more vectors (as in
    MultiVector).



    Before reading the rest of this documentation, it helps to know
    something about the following:

    *  The Kokkos shared-memory parallel programming model
    *  The Teuchos memory management classes, especially
         Teuchos::RCP, Teuchos::ArrayRCP, and Teuchos::ArrayView

    *  MPI (the Message Passing Interface for distributed-memory
         parallel programming)

    You will not need to use MPI directly to use Map, but it helps
    to be familiar with the general idea of distributed storage of
    data over a communicator.





    The distinction between local and global indices and types might
    confuse new Tpetra users.  *Global* indices represent the
    elements of a distributed object (such as rows or columns of a
    CrsMatrix, or rows of a MultiVector) uniquely over the entire
    object, which may be distributed over multiple processes.
    *Local* indices are local to the process that owns them.
    If global index G is owned by process P, then there is a unique
    local index L on process P corresponding to G.  If the local
    index L is valid on process P, then there is a unique global
    index G owned by P corresponding to the pair (L, P).  However,
    multiple processes might own the same global index (an
    "overlapping Map"), so a global index G might correspond to
    multiple (L, P) pairs.  In summary, local indices on a process
    correspond to object elements (e.g., sparse matrix rows or
    columns) owned by that process.

    Tpetra differs from Epetra in that local and global indices may
    have different types.  In Epetra, local and global indices both
    have type ``int``.  In Tpetra, you get to pick the type of each.
    For example, you can use a 64-bit integer ``GlobalOrdinal`` type
    to solve problems with more than :math:`2^{31}` unknowns, but a
    32-bit integer ``LocalOrdinal`` type to save bandwidth in sparse
    matrix-vector multiply.



    A *contiguous* Map divides an interval of global indices
    over the processes in its communicator, such that each process
    gets a contiguous interval of zero or more of those global
    indices, with the indices owned by a process p strictly greater
    than those owned by process q if :math:`p > q`.  Formally, we call
    a Map contiguous when all of the following hold:

    * the set of global indices (over all processes) forms an
      interval,
    * every global index in that interval is owned by exactly one
      process in the Map's communicator,
    * the (ordered) list of global indices on each process p in
      the Map's communicator forms a contiguous interval, and
    * if process p owns a global index :math:`g_p` and process q
      owns a global index :math:`g_q`, and if :math:`p > q`, then
      :math:`g_p > g_q`.

    Different processes may own different numbers of global indices.
    We call a Map *uniform* if it is contiguous, *and* if
    the user let the Map divide a global count of indices evenly
    over the Map's communicator's processes.  The latter happens by
    calling the version of Map's constructor that takes a global
    count of indices, rather than a local count or an arbitrary list
    of indices.

    Map optimizes for the contiguous case.  For example,
    noncontiguous Maps always require communication in order to
    figure out which process owns a particular global index.  (This
    communication happens in getRemoteIndexList().)  Contiguous but
    nonuniform Maps may also require communication in this case,
    though we may only need to perform that communication once (at
    Map setup time).  Contiguous Maps also can convert between
    global and local indices more efficiently.



    *Globally distributed* means that *all* of the
    following are true:

    *  The map's communicator has more than one process.
    * There is at least one process in the map's communicator,
        whose local number of elements does not equal the number of
        global elements.  (That is, not all the elements are
        replicated over all the processes.)

    If at least one of the above are not true, then the map is
    *locally replicated.* (The two are mutually exclusive.)

    Globally distributed objects are partitioned across multiple
    processes in a communicator.  Each process owns at least one
    element in the object's Map that is not owned by another
    process.  For locally replicated objects, each element in the
    object's Map is owned redundantly by all processes in the
    object's communicator.  Some algorithms use objects that are too
    small to be distributed across all processes.  The upper
    Hessenberg matrix in a GMRES iterative solve is a good example.
    In other cases, such as with block iterative methods, block dot
    product functions produce small dense matrices that are required
    by all images.  Replicated local objects handle these
    situations.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    __swig_destroy__ = _Tpetra.delete_Map_default

    def isOneToOne(self, *args) -> "bool":
        r"""
        Whether the Map is one to one.

        This must be called collectively over all processes in the
        Map's communicator.
        """
        return _Tpetra.Map_default_isOneToOne(self, *args)

    def getGlobalNumElements(self, *args) -> "Tpetra::global_size_t":
        r"""
        The number of elements in this Map.

        Notes: This function should be thread safe and thread scalable,
          assuming that you refer to the Map by value or reference,
          not by Teuchos::RCP.
        """
        return _Tpetra.Map_default_getGlobalNumElements(self, *args)

    def getLocalNumElements(self, *args) -> "size_t":
        r"""
        The number of elements belonging to the calling process.

        Notes: This function should be thread safe and thread scalable,
          assuming that you refer to the Map by value or reference,
          not by Teuchos::RCP.
        """
        return _Tpetra.Map_default_getLocalNumElements(self, *args)

    def getIndexBase(self, *args) -> "Tpetra::Map< int,int,Tpetra::Details::DefaultTypes::node_type >::global_ordinal_type":
        r"""
        The index base for this Map.

        Notes: This function should be thread safe and thread scalable,
          assuming that you refer to the Map by value or reference,
          not by Teuchos::RCP.
        """
        return _Tpetra.Map_default_getIndexBase(self, *args)

    def getMinLocalIndex(self, *args) -> "Tpetra::Map< int,int,Tpetra::Details::DefaultTypes::node_type >::local_ordinal_type":
        r"""
        The minimum local index.

        Notes: This function should be thread safe and thread scalable,
          assuming that you refer to the Map by value or reference,
          not by Teuchos::RCP.
        """
        return _Tpetra.Map_default_getMinLocalIndex(self, *args)

    def getMaxLocalIndex(self, *args) -> "Tpetra::Map< int,int,Tpetra::Details::DefaultTypes::node_type >::local_ordinal_type":
        r"""
        The maximum local index on the calling process.

        If this process owns no elements, that is, if
        getLocalNumElements() == 0, then this method returns
        the same value as
        Teuchos::OrdinalTraits<local_ordinal_type>::invalid().

        Notes: This function should be thread safe and thread scalable,
          assuming that you refer to the Map by value or reference,
          not by Teuchos::RCP.
        """
        return _Tpetra.Map_default_getMaxLocalIndex(self, *args)

    def getMinGlobalIndex(self, *args) -> "Tpetra::Map< int,int,Tpetra::Details::DefaultTypes::node_type >::global_ordinal_type":
        r"""
        The minimum global index owned by the calling process.

        Notes: This function should be thread safe and thread scalable,
          assuming that you refer to the Map by value or reference,
          not by Teuchos::RCP.
        """
        return _Tpetra.Map_default_getMinGlobalIndex(self, *args)

    def getMaxGlobalIndex(self, *args) -> "Tpetra::Map< int,int,Tpetra::Details::DefaultTypes::node_type >::global_ordinal_type":
        r"""
        The maximum global index owned by the calling process.

        Notes: This function should be thread safe and thread scalable,
          assuming that you refer to the Map by value or reference,
          not by Teuchos::RCP.
        """
        return _Tpetra.Map_default_getMaxGlobalIndex(self, *args)

    def getMinAllGlobalIndex(self, *args) -> "Tpetra::Map< int,int,Tpetra::Details::DefaultTypes::node_type >::global_ordinal_type":
        r"""
        The minimum global index over all processes in the communicator.

        Notes: This function should be thread safe and thread scalable,
          assuming that you refer to the Map by value or reference,
          not by Teuchos::RCP.
        """
        return _Tpetra.Map_default_getMinAllGlobalIndex(self, *args)

    def getMaxAllGlobalIndex(self, *args) -> "Tpetra::Map< int,int,Tpetra::Details::DefaultTypes::node_type >::global_ordinal_type":
        r"""
        The maximum global index over all processes in the communicator.

        Notes: This function should be thread safe and thread scalable,
          assuming that you refer to the Map by value or reference,
          not by Teuchos::RCP.
        """
        return _Tpetra.Map_default_getMaxAllGlobalIndex(self, *args)

    def getLocalMap(self, *args) -> "Tpetra::Map< int,int,Tpetra::Details::DefaultTypes::node_type >::local_map_type":
        r"""
        Get the local Map for Kokkos kernels.

        Warning: The interface of the local Map object is SUBJECT TO
          CHANGE and is for EXPERT USERS ONLY.
        """
        return _Tpetra.Map_default_getLocalMap(self, *args)

    def getLocalElementList(self, *args) -> "Teuchos::ArrayView< Tpetra::Map< int,int,Tpetra::Details::DefaultTypes::node_type >::global_ordinal_type const >":
        r"""
        Return a NONOWNING view of the global indices owned by
          this process.

        Warning: This method may be deprecated at some point.  Please
          consider using getMyGlobalIndices() (see above) instead.

        If you call this method on a contiguous Map, it will create
        and cache the list of global indices for later use.  Beware of
        calling this if the calling process owns a very large number
        of global indices.
        """
        return _Tpetra.Map_default_getLocalElementList(self, *args)

    def isNodeLocalElement(self, *args) -> "bool":
        r"""
        Whether the given local index is valid for this Map on
          the calling process.

        Notes: This function should be thread safe and thread scalable,
          assuming that you refer to the Map by value or reference,
          not by Teuchos::RCP.
        """
        return _Tpetra.Map_default_isNodeLocalElement(self, *args)

    def isNodeGlobalElement(self, *args) -> "bool":
        r"""
        Whether the given global index is owned by this Map on
          the calling process.

        Notes: This function should be thread safe and thread scalable,
          assuming that you refer to the Map by value or reference,
          not by Teuchos::RCP.
        """
        return _Tpetra.Map_default_isNodeGlobalElement(self, *args)

    def isUniform(self, *args) -> "bool":
        r"""
        Whether the range of global indices is uniform.

        This is a conservative quantity.  It need only be true if the
        Map was constructed using the first (uniform contiguous)
        constructor or a nonmember constructor that calls it.  We
        reserve the right to do more work to check this in the future.
        """
        return _Tpetra.Map_default_isUniform(self, *args)

    def isContiguous(self, *args) -> "bool":
        r"""
        True if this Map is distributed contiguously, else false.

        Currently, creating this Map using the constructor for a
        user-defined arbitrary distribution (that takes a list of
        global elements owned on each process) means that this method
        always returns false.  We currently make no effort to test
        whether the user-provided global indices are actually
        contiguous on all the processes.  Many operations may be
        faster for contiguous Maps.  Thus, if you know the indices are
        contiguous on all processes, you should consider using one of
        the constructors for contiguous elements.
        """
        return _Tpetra.Map_default_isContiguous(self, *args)

    def isDistributed(self, *args) -> "bool":
        r"""
        Whether this Map is globally distributed or locally
          replicated.

        :rtype: boolean
        :return: True if this Map is globally distributed, else false.

        "Globally distributed" means that *all* of the following
        are true:

        *  The map's communicator has more than one process.
        *  There is at least one process in the map's communicator,
           whose local number of elements does not equal the number of
           global elements.  (That is, not all the elements are
           replicated over all the processes.)


        If at least one of the above are not true, then the map is
        "locally replicated."  (The two are mutually exclusive.)

        Calling this method requires no communication or computation,
        because the result is precomputed in Map's constructors.
        """
        return _Tpetra.Map_default_isDistributed(self, *args)

    def isCompatible(self, *args) -> "bool":
        r"""
        True if and only if ``map`` is compatible with this Map.

        Two Maps are "compatible" if all of the following are true:

        *  Their communicators have the same numbers of processes.
           (This is necessary even to call this method.)
        *  They have the same global number of elements.
        *  They have the same number of local elements on each process.


        Determining #3 requires communication (a reduction over this
        Map's communicator).  This method assumes that the input Map
        is valid on all processes in this Map's communicator.

        Compatibility is useful for determining correctness of certain
        operations, like assigning one MultiVector X to another Y.  If
        X and Y have the same number of columns, and if their Maps are
        compatible, then it is legal to assign X to Y or to assign Y
        to X.

        The behavior of this method is undefined if the input Map's
        communicator and this Map's communicator have different
        numbers of processes.  This method must be called collectively
        over this Map's communicator.
        """
        return _Tpetra.Map_default_isCompatible(self, *args)

    def isSameAs(self, *args) -> "bool":
        r"""
        True if and only if ``map`` is identical to this Map.

        "Identical" is stronger than "compatible."  Two Maps are
        identical if all of the following are true:

        *  Their communicators are *congruent* (have the same
           number of processes, in the same order: this corresponds to
           the ``MPI_IDENT`` or ``MPI_CONGRUENT`` return values of
           MPI_Comm_compare).
        *  They have the same min and max global indices.
        *  They have the same global number of elements.
        *  They are either both distributed, or both not distributed.
        *  Their index bases are the same.
        *  They have the same number of local elements on each process.
        *  They have the same global indices on each process.


        "Identical" (isSameAs()) includes and is stronger than
        "compatible" (isCompatible()).

        A Map corresponds to a block permutation over process ranks
        and global element indices.  Two Maps with different numbers
        of processes in their communicators cannot be compatible, let
        alone identical.  Two identical Maps correspond to the same
        permutation.

        The behavior of this method is undefined if the input Map's
        communicator and this Map's communicator have different
        numbers of processes.  This method must be called collectively
        over this Map's communicator.
        """
        return _Tpetra.Map_default_isSameAs(self, *args)

    def locallySameAs(self, *args) -> "bool":
        r"""
        Is this Map locally the same as the input Map?

        "Locally the same" means that on the calling process, the two
        Maps' global indices are the same and occur in the same order.
        """
        return _Tpetra.Map_default_locallySameAs(self, *args)

    def isLocallyFitted(self, *args) -> "bool":
        r"""
        True if and only if ``map`` is locally fitted to this Map.

        For two maps, map1 and map2, we say that map1 is *locally
        fitted* to map2 (on the calling process), when the indices of map1
        (on the calling process) are the same and in the same order as the
        initial indices of map2.  "Fittedness" is entirely a local (per MPI
        process) property.

        The predicate "is map1 fitted to map2 ?" is *not*
        symmetric.  For example, map2 may have more entries than map1.

        Fittedness on a process can let Tpetra avoid deep copies in
        some Export or Import (communication) operations. Tpetra
        could use this, for example, in optimizing its sparse
        matrix-vector multiply.
        """
        return _Tpetra.Map_default_isLocallyFitted(self, *args)

    def getComm(self, *args) -> "Teuchos::RCP< Teuchos::Comm< int > const >":
        r""" Accessors for the Teuchos::Comm and Kokkos Node objects. Get this Map's communicator, as a Teuchos::Comm."""
        return _Tpetra.Map_default_getComm(self, *args)

    def description(self, *args) -> "std::string":
        r""" Implementation of ``Teuchos::Describable`` Return a one-line description of this object."""
        return _Tpetra.Map_default_description(self, *args)

    def describe(self, *args) -> "void":
        r"""
        Describe this object in a human-readable way to the
          given output stream.

        You must call this method as a collective over all processes
        in this object's communicator.

        :type out: Teuchos::FancyOStream
        :param out: [out] Output stream to which to write.  Only
              Process 0 in this object's communicator may write to the
              output stream.

        :type verbLevel: int, optional
        :param verbLevel: [in] Verbosity level.  This also controls
              whether this method does any communication.  At verbosity
              levels higher (greater) than Teuchos::VERB_LOW, this method
              may behave as a collective over the object's communicator.

        Teuchos::FancyOStream wraps std::ostream.  It adds features
        like tab levels.  If you just want to wrap std::cout, try
        this:

        .. code-block:: c++

            auto out = Teuchos::getFancyOStream(Teuchos::rcpFromRef(std::cout));
        """
        return _Tpetra.Map_default_describe(self, *args)

    def removeEmptyProcesses(self, *args) -> "Teuchos::RCP< Tpetra::Map< Tpetra::Map< int,int,DefaultNodeType >::local_ordinal_type,Tpetra::Map< int,int,DefaultNodeType >::global_ordinal_type,Tpetra::Details::DefaultTypes::node_type > const >":
        r"""
        Advanced methods Create a shallow copy of this Map, with a different Node type.
        Return a new Map with processes with zero elements removed.

        Warning: This method is only for expert users.  Understanding
          how to use this method correctly requires some familiarity
          with semantics of MPI communicators.

        We make no promises of backwards compatibility for
          this method.  It may go away or change at any time.

        This method first computes a new communicator, which contains
        only those processes in this Map's communicator (the "original
        communicator") that have a nonzero number of elements in this
        Map (the "original Map").  It then returns a new Map
        distributed over the new communicator.  The new Map represents
        the same distribution as the original Map, except that
        processes containing zero elements are not included in the new
        Map or its communicator.  On processes not included in the new
        Map or communicator, this method returns
        Teuchos::null.

        The returned Map always has a distinct communicator from this
        Map's original communicator.  The new communicator contains a
        subset of processes from the original communicator.  Even if
        the number of processes in the new communicator equals the
        number of processes in the original communicator, the new
        communicator is distinct.  (In an MPI implementation, the new
        communicator is created using MPI_Comm_split.)  Furthermore, a
        process may have a different rank in the new communicator, so
        be wary of classes that like to store the rank rather than
        asking the communicator for it each time.

        This method must be called collectively on the original
        communicator.  It leaves the original Map and communicator
        unchanged.

        This method was intended for applications such as algebraic
        multigrid or other multilevel preconditioners.  Construction
        of each level of the multilevel preconditioner typically
        requires constructing sparse matrices, which in turn requires
        all-reduces over all participating processes at that level.
        Matrix sizes at successively coarser levels shrink
        geometrically.  At the coarsest levels, some processes might
        be left with zero rows of the matrix, or the multigrid
        implementation might "rebalance" (redistribute the matrix) and
        intentionally leave some processes with zero rows.  Removing
        processes with zero rows makes the all-reduces and other
        communication operations cheaper.
        """
        return _Tpetra.Map_default_removeEmptyProcesses(self, *args)

    def replaceCommWithSubset(self, *args) -> "Teuchos::RCP< Tpetra::Map< Tpetra::Map< int,int,DefaultNodeType >::local_ordinal_type,Tpetra::Map< int,int,DefaultNodeType >::global_ordinal_type,Tpetra::Details::DefaultTypes::node_type > const >":
        r"""
        Replace this Map's communicator with a subset communicator.

        Warning: This method is only for expert users.  Understanding
          how to use this method correctly requires some familiarity
          with semantics of MPI communicators.

        We make no promises of backwards compatibility for
          this method.  It may go away or change at any time.

         This method must be called collectively on the original
        communicator.  It leaves the original Map and communicator
        unchanged.

        Notes: This method differs from removeEmptyProcesses(), in that
          it does not assume that excluded processes have zero
          entries.  For example, one might wish to remove empty
          processes from the row Map of a CrsGraph using
          removeEmptyProcesses(), and then apply the resulting subset
          communicator to the column, domain, and range Maps of the
          same graph.  For the latter three Maps, one would in general
          use this method instead of removeEmptyProcesses(), giving
          the new row Map's communicator to this method.
        """
        return _Tpetra.Map_default_replaceCommWithSubset(self, *args)

    def __init__(self, *args):
        _Tpetra.Map_default_swiginit(self, _Tpetra.new_Map_default(*args))

    def getLocalElement(self, *args) -> "PyObject *":
        return _Tpetra.Map_default_getLocalElement(self, *args)

    def getGlobalElement(self, *args) -> "PyObject *":
        return _Tpetra.Map_default_getGlobalElement(self, *args)

    def getRemoteIndexList(self, *args) -> "PyObject *":
        return _Tpetra.Map_default_getRemoteIndexList(self, *args)

    def __str__(self, *args) -> "std::string":
        return _Tpetra.Map_default___str__(self, *args)

# Register Map_default in _Tpetra:
_Tpetra.Map_default_swigregister(Map_default)


Map = Map_default

class Transfer_default(Teuchos.Base.Describable):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Tpetra.delete_Transfer_default

    def getNumSameIDs(self, *args) -> "size_t":
        return _Tpetra.Transfer_default_getNumSameIDs(self, *args)

    def getNumPermuteIDs(self, *args) -> "size_t":
        return _Tpetra.Transfer_default_getNumPermuteIDs(self, *args)

    def getPermuteFromLIDs(self, *args) -> "Teuchos::ArrayView< int const >":
        return _Tpetra.Transfer_default_getPermuteFromLIDs(self, *args)

    def getPermuteToLIDs(self, *args) -> "Teuchos::ArrayView< int const >":
        return _Tpetra.Transfer_default_getPermuteToLIDs(self, *args)

    def getNumRemoteIDs(self, *args) -> "size_t":
        return _Tpetra.Transfer_default_getNumRemoteIDs(self, *args)

    def getRemoteLIDs(self, *args) -> "Teuchos::ArrayView< int const >":
        return _Tpetra.Transfer_default_getRemoteLIDs(self, *args)

    def getNumExportIDs(self, *args) -> "size_t":
        return _Tpetra.Transfer_default_getNumExportIDs(self, *args)

    def getExportLIDs(self, *args) -> "Teuchos::ArrayView< int const >":
        return _Tpetra.Transfer_default_getExportLIDs(self, *args)

    def getExportPIDs(self, *args) -> "Teuchos::ArrayView< int const >":
        return _Tpetra.Transfer_default_getExportPIDs(self, *args)

    def getSourceMap(self, *args) -> "Teuchos::RCP< Tpetra::Details::Transfer< int,int,Tpetra::Details::DefaultTypes::node_type >::map_type const >":
        return _Tpetra.Transfer_default_getSourceMap(self, *args)

    def getTargetMap(self, *args) -> "Teuchos::RCP< Tpetra::Details::Transfer< int,int,Tpetra::Details::DefaultTypes::node_type >::map_type const >":
        return _Tpetra.Transfer_default_getTargetMap(self, *args)

    def getDistributor(self, *args) -> "::Tpetra::Distributor &":
        return _Tpetra.Transfer_default_getDistributor(self, *args)

# Register Transfer_default in _Tpetra:
_Tpetra.Transfer_default_swigregister(Transfer_default)

class Export_default(Transfer_default):
    r"""
    Communication plan for data redistribution from a
      (possibly) multiply-owned to a uniquely-owned distribution.

    :param LocalOrdinal: The type of local indices.  See the
          documentation of Map for requirements.
    :param GlobalOrdinal: The type of global indices.  See the
          documentation of Map for requirements.
    :param Node: The Kokkos Node type.  See the documentation of Map
          for requirements.

    Tpetra users should use this class to construct a communication
    plan between two data distributions (i.e., two Map objects).
    The plan can be called repeatedly by computational classes to
    perform communication according to the same pattern.
    Constructing the plan may be expensive, both in terms of
    communication and computation.  However, it can be reused
    inexpensively.

    Tpetra has two classes for data redistribution: Import and
    Export.  Import is for redistributing data from a uniquely-owned
    distribution to a possibly multiply-owned distribution.  Export
    is for redistributing data from a possibly multiply-owned
    distribution to a uniquely-owned distribution.

    The names "Import" and "Export" have nothing to do with the
    direction in which data moves relative to the calling process;
    any process may do both receives and sends in an Import or
    Export.  Rather, the names suggest what happens in their most
    common use case, the communication pattern for sparse
    matrix-vector multiply.  Import "brings in" remote source vector
    data (from the domain Map to the column Map) for local
    computation, and Export "pushes" the result back (from the row
    Map to the range Map).  Import and Export have other uses as
    well.

    One use case of Export is finite element assembly.  For example,
    one way to compute a distributed forcing term vector is to use
    an overlapping distribution for the basis functions' domains.
    An Export with the SUM combine mode combines each process'
    contribution to the integration into a single nonoverlapping
    distribution.

    Epetra separated Import and Export for performance reasons.  The
    implementation is different, depending on which direction is the
    uniquely-owned Map.  Tpetra retains this convention.

    This class is templated on the same template arguments as Map:
    the local ordinal type LocalOrdinal, the global ordinal
    type GlobalOrdinal, and the Kokkos Node type.

    This method accepts an optional list of parameters, either
    through the constructor or through the setParameterList()
    method.  Most users do not need to worry about these parameters;
    the default values are fine.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Tpetra.delete_Export_default

    def describe(self, *args) -> "void":
        r"""
        Describe this object in a human-readable way to the
          given output stream.

        You must call this method as a collective over all processes
        in the communicator of the source and target Map of this
        object.

        :type out: Teuchos::FancyOStream
        :param out: [out] Output stream to which to write.  Only
              Process 0 in this object's communicator may write to the
              output stream.

        :type verbLevel: int, optional
        :param verbLevel: [in] Verbosity level.  This also controls
              whether this method does any communication.  At verbosity
              levels higher (greater) than Teuchos::VERB_LOW, this method
              behaves as a collective over the object's communicator.

        Teuchos::FancyOStream wraps std::ostream.  It adds features
        like tab levels.  If you just want to wrap std::cout, try
        this:

        .. code-block:: c++

            auto out = Teuchos::getFancyOStream (Teuchos::rcpFromRef (std::out));
        """
        return _Tpetra.Export_default_describe(self, *args)

# Register Export_default in _Tpetra:
_Tpetra.Export_default_swigregister(Export_default)


Export = Export_default

class Import_default(Transfer_default):
    r"""
    Communication plan for data redistribution from a
      uniquely-owned to a (possibly) multiply-owned distribution.

    :param LocalOrdinal: The type of local indices.  See the
          documentation of Map for requirements.
    :param GlobalOrdinal: The type of global indices.  See the
          documentation of Map for requirements.
    :param Node: The Kokkos Node type.  See the documentation of Map
          for requirements.

    Tpetra users should use this class to construct a communication
    plan between two data distributions (i.e., two Map objects).
    The plan can be called repeatedly by computational classes to
    perform communication according to the same pattern.
    Constructing the plan may be expensive, both in terms of
    communication and computation.  However, it can be reused
    inexpensively.

    Tpetra has two classes for data redistribution: Import and
    Export.  Import is for redistributing data from a uniquely-owned
    distribution to a possibly multiply-owned distribution.  Export
    is for redistributing data from a possibly multiply-owned
    distribution to a uniquely-owned distribution.

    The names "Import" and "Export" have nothing to do with the
    direction in which data moves relative to the calling process;
    any process may do both receives and sends in an Import or
    Export.  Rather, the names suggest what happens in their most
    common use case, the communication pattern for sparse
    matrix-vector multiply.  Import "brings in" remote source vector
    data (from the domain Map to the column Map) for local
    computation, and Export "pushes" the result back (from the row
    Map to the range Map).  Import and Export have other uses as
    well.

    As mentioned above, one use case of Import is bringing in remote
    source vector data for a distributed sparse matrix-vector
    multiply.  The source vector itself is uniquely owned, but must
    be brought in into an overlapping distribution so that each
    process can compute its part of the target vector without
    further communication.

    Epetra separated Import and Export for performance reasons.  The
    implementation is different, depending on which direction is the
    uniquely-owned Map.  Tpetra retains this convention.

    This class is templated on the same template arguments as Map:
    the local ordinal type LocalOrdinal, the global ordinal
    type GlobalOrdinal, and the Kokkos Node type.

    This method accepts an optional list of parameters, either
    through the constructor or through the setParameterList()
    method.  Most users do not need to worry about these parameters;
    the default values are fine.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Tpetra.delete_Import_default

    def findUnionTargetGIDs(self, *args) -> "void":
        r"""
        Find the union of the target IDs from two Import objects.

        On return, the input arrays permuteGIDs[1,2] and remotePGIDs[1,2] will
        be ordered.  unionTgtGIDs are ordered as [{same}, {permute}, {remote}].
        {same} is ordered identically to the target map with most "same"
        indices.  {permute} is ordered from smallest ID to largest.  {remote} is
        ordered by remote process ID and ID, respectively.  remotePGIDs are
        ordered the same as {remote}.
        """
        return _Tpetra.Import_default_findUnionTargetGIDs(self, *args)

    def setUnion(self, *args) -> "Teuchos::RCP< Tpetra::Import< int,int,Tpetra::Details::DefaultTypes::node_type > const >":
        r"""
        *Overload 1:*
        Return the union of this Import and ``rhs``.

        The "union" of two Import objects is the Import whose source
        Map is the same as the input Imports' source Maps, and whose
        target Map is the union of the two input Imports' target Maps.
        The two input Import objects must have the same source Map.
        The union operation is symmetric in its two inputs.

        The communicator of ``rhs`` must be the same as (MPI_EQUAL) or
        congruent with (MPI_CONGRUENT) this Import's communicator.
        (That is, the two communicators must have the same number of
        processes, and each process must have the same rank in both
        communicators.)  This method must be called collectively over
        that communicator.

        The Map that results from this operation does *not*
        preserve the original order of global indices in either of the
        two input Maps.  Instead, it sorts global indices on each
        process so that owned indices occur first, in the same order
        as in the source Map, and so that remote indices are sorted in
        order of their sending process rank.  This makes communication
        operations faster.

        This primitive is useful for adding two sparse matrices
        (CrsMatrix), since its can skip over many of the steps of
        creating the result matrix's column Map from scratch.

        We have to call this method "setUnion" rather than "union,"
        because ``union`` is a reserved keyword in C++ (and C).  It
        would also be reasonable to call this operator+,
        though it would be a bit confusing for operator+ to return a
        pointer but take a reference (or to take a pointer, but have
        the left-hand side of the + expression be a reference).

        |

        *Overload 2:*
        Return the union of this Import this->getSourceMap()

        This special case of setUnion creates a new Import object
        such that the targetMap of the new object contains all local
        unknowns in the sourceMap (plus whatever remotes were contained
        in this->getSourceMap()).

        The Map that results from this operation does *not*
        preserve the input order of global indices.  All local global
        indices are ordered in the order of the sourceMap, all remotes
        are ordered as implied by the Importer for *this.

        This primitive is useful for adding or multipyling two sparse matrices
        (CrsMatrix), since its can skip over many of the steps of
        creating the result matrix's column Map from scratch.
        """
        return _Tpetra.Import_default_setUnion(self, *args)

    def createRemoteOnlyImport(self, *args) -> "Teuchos::RCP< Tpetra::Import< int,int,Tpetra::Details::DefaultTypes::node_type > const >":
        r"""
        Returns an importer that contains only the remote entries of this

        Returns an importer that contains only the remote entries of this importer.
        It is expected that remoteTarget represents such a map.
        """
        return _Tpetra.Import_default_createRemoteOnlyImport(self, *args)

    def describe(self, *args) -> "void":
        r"""
        Describe this object in a human-readable way to the
          given output stream.

        You must call this method as a collective over all processes
        in the communicator of the source and target Map of this
        object.

        :type out: Teuchos::FancyOStream
        :param out: [out] Output stream to which to write.  Only
              Process 0 in this object's communicator may write to the
              output stream.

        :type verbLevel: int, optional
        :param verbLevel: [in] Verbosity level.  This also controls
              whether this method does any communication.  At verbosity
              levels higher (greater) than Teuchos::VERB_LOW, this method
              behaves as a collective over the object's communicator.

        Teuchos::FancyOStream wraps std::ostream.  It adds features
        like tab levels.  If you just want to wrap std::cout, try
        this:

        .. code-block:: c++

            auto out = Teuchos::getFancyOStream (Teuchos::rcpFromRef (std::out));
        """
        return _Tpetra.Import_default_describe(self, *args)

# Register Import_default in _Tpetra:
_Tpetra.Import_default_swigregister(Import_default)


Import = Import_default

class SrcDistObject(object):
    r"""
    Abstract base class for objects that can be the source of
      an Import or Export operation.

    Any object that may be the source of an Import or Export data
    redistribution operation must inherit from this class.  This
    class implements no methods, other than a trivial virtual
    destructor.  If a subclass X inherits from this class, that
    indicates that the subclass can be the source of an Import or
    Export, for *some set* of subclasses of DistObject.  A
    subclass Y of DistObject which is the target of the Import or
    Export operation will attempt to cast the input source
    SrcDistObject to a subclass which it knows how to treat as a
    source object.  The target subclass Y is responsible for knowing
    what source classes to expect, and how to interpret the
    resulting source object.

    DistObject inherits from this class, since a DistObject subclass
    may be either the source or the target of an Import or Export.
    A SrcDistObject subclass which does not inherit from DistObject
    need only be a valid source of an Import or Export; it need not
    be a valid target.

    This object compares to the Epetra class Epetra_SrcDistObject.
    Unlike in Epetra, this class in Tpetra does not include
    a getMap() method.  This is for two reasons.  First, consider
    the following inheritance hierarchy: DistObject and RowGraph
    inherit from SrcDistObject, and CrsGraph inherits from
    DistObject and RowGraph.  If SrcDistObject had a virtual getMap
    method, that would make resolution of the method ambiguous.
    Second, it is not necessary for SrcDistObject to have a getMap
    method, because a SrcDistObject alone does not suffice as the
    source of an Import or Export.  Any DistObject subclass must
    cast the SrcDistObject to a subclass which it knows how to treat
    as the source of an Import or Export.  Thus, it's not necessary
    for SrcDistObject to have a getMap method, since it needs to be
    cast anyway before use.  In general, I prefer to keep interfaces
    as simple as possible.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    __swig_destroy__ = _Tpetra.delete_SrcDistObject

    def __init__(self, *args):
        _Tpetra.SrcDistObject_swiginit(self, _Tpetra.new_SrcDistObject(*args))

# Register SrcDistObject in _Tpetra:
_Tpetra.SrcDistObject_swigregister(SrcDistObject)


def MultiVector_getattr(self, name):
    if name == "array":
        a = self._extractNumPyArray()
        self.__dict__["array"] = a
        return a
    elif name == "shape":
        return self.array.shape
    elif name == "dtype":
        return self.array.dtype
    else:
        raise AttributeError("'%s' not an attribute of MultiVector" % name)
def MultiVector_setattr(self, name, value):
    if name in ("array", "shape", "dtype"):
        raise AttributeError("Cannot change MultiVector '%s' attribute", name)
    else:
        self.__dict__[name] = value
def MultiVector_getitem(self,i):
    if isinstance(i,int):
        return self.getVectorNonConst(i)
    else:
        return self.array.__getitem__(i)
def upgradeMultiVectorClass(cls):
    cls.__getattr__ = MultiVector_getattr
    cls.__setattr__ = MultiVector_setattr
    cls.__getitem__ = MultiVector_getitem
    cls.__setitem__ = lambda self, i, v: self.array.__setitem__(i,v)
    cls.__len__     = lambda self: self.array.__len__()
    cls.__str__     = lambda self: self.array.__str__()
    cls.copy        = lambda self: cls(self)
    class_array_add_math(cls)
    class_array_add_comp(cls)



def Vector_getattr(self, name):
    if name == "array":
        a = self._extractNumPyArray()
        self.__dict__["array"] = a
        return a
    elif name == "shape":
        return self.array.shape
    elif name == "dtype":
        return self.array.dtype
    else:
        raise AttributeError("'%s' not an attribute of Vector" % name)
def Vector_setattr(self, name, value):
    if name in ("array", "shape", "dtype"):
        raise AttributeError("Cannot change Vector '%s' attribute", name)
    else:
        self.__dict__[name] = value
def upgradeVectorClass(cls):
    cls.__getattr__ = Vector_getattr
    cls.__setattr__ = Vector_setattr
    cls.__getitem__ = lambda self, i: self.array.__getitem__(i)
    cls.__setitem__ = lambda self, i, v: self.array.__setitem__(i,v)
    cls.__len__     = lambda self: self.array.__len__()
    cls.__str__     = lambda self: self.array.__str__()
    cls.copy        = lambda self: cls(self)
    class_array_add_math(cls)
    class_array_add_comp(cls)


class DistObject_int(SrcDistObject, Teuchos.Base.Describable):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Tpetra.delete_DistObject_int

    def doImport(self, *args) -> "void":
        return _Tpetra.DistObject_int_doImport(self, *args)

    def doExport(self, *args) -> "void":
        return _Tpetra.DistObject_int_doExport(self, *args)

    def isDistributed(self, *args) -> "bool":
        return _Tpetra.DistObject_int_isDistributed(self, *args)

    def getMap(self, *args) -> "Teuchos::RCP< DefaultMapType const >":
        return _Tpetra.DistObject_int_getMap(self, *args)

    def description(self, *args) -> "std::string":
        return _Tpetra.DistObject_int_description(self, *args)

    def describe(self, *args) -> "void":
        return _Tpetra.DistObject_int_describe(self, *args)

    def removeEmptyProcessesInPlace(self, *args) -> "void":
        return _Tpetra.DistObject_int_removeEmptyProcessesInPlace(self, *args)

# Register DistObject_int in _Tpetra:
_Tpetra.DistObject_int_swigregister(DistObject_int)

class MultiVector_int(DistObject_int):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        _Tpetra.MultiVector_int_swiginit(self, _Tpetra.new_MultiVector_int(*args))
    __swig_destroy__ = _Tpetra.delete_MultiVector_int

    def replaceGlobalValue(self, *args) -> "void":
        return _Tpetra.MultiVector_int_replaceGlobalValue(self, *args)

    def sumIntoGlobalValue(self, *args) -> "void":
        return _Tpetra.MultiVector_int_sumIntoGlobalValue(self, *args)

    def replaceLocalValue(self, *args) -> "void":
        return _Tpetra.MultiVector_int_replaceLocalValue(self, *args)

    def sumIntoLocalValue(self, *args) -> "void":
        return _Tpetra.MultiVector_int_sumIntoLocalValue(self, *args)

    def putScalar(self, *args) -> "void":
        return _Tpetra.MultiVector_int_putScalar(self, *args)

    def randomize(self, *args) -> "void":
        return _Tpetra.MultiVector_int_randomize(self, *args)

    def replaceMap(self, *args) -> "void":
        return _Tpetra.MultiVector_int_replaceMap(self, *args)

    def reduce(self, *args) -> "void":
        return _Tpetra.MultiVector_int_reduce(self, *args)

    def subCopy(self, *args) -> "Teuchos::RCP< Tpetra::MultiVector< int,int,int,Tpetra::Details::DefaultTypes::node_type > >":
        return _Tpetra.MultiVector_int_subCopy(self, *args)

    def subView(self, *args) -> "Teuchos::RCP< Tpetra::MultiVector< int,int,int,Tpetra::Details::DefaultTypes::node_type > const >":
        return _Tpetra.MultiVector_int_subView(self, *args)

    def subViewNonConst(self, *args) -> "Teuchos::RCP< Tpetra::MultiVector< int,int,int,Tpetra::Details::DefaultTypes::node_type > >":
        return _Tpetra.MultiVector_int_subViewNonConst(self, *args)

    def offsetViewNonConst(self, *args) -> "Teuchos::RCP< Tpetra::MultiVector< int,int,int,Tpetra::Details::DefaultTypes::node_type > >":
        return _Tpetra.MultiVector_int_offsetViewNonConst(self, *args)

    def getVector(self, *args) -> "Teuchos::RCP< Tpetra::Vector< int,int,int,Tpetra::Details::DefaultTypes::node_type > const >":
        return _Tpetra.MultiVector_int_getVector(self, *args)

    def getVectorNonConst(self, *args) -> "Teuchos::RCP< Tpetra::Vector< int,int,int,Tpetra::Details::DefaultTypes::node_type > >":
        return _Tpetra.MultiVector_int_getVectorNonConst(self, *args)

    def getData(self, *args) -> "Teuchos::ArrayRCP< int const >":
        return _Tpetra.MultiVector_int_getData(self, *args)

    def getDataNonConst(self, *args) -> "Teuchos::ArrayRCP< int >":
        return _Tpetra.MultiVector_int_getDataNonConst(self, *args)

    def get1dCopy(self, *args) -> "void":
        return _Tpetra.MultiVector_int_get1dCopy(self, *args)

    def get2dCopy(self, *args) -> "void":
        return _Tpetra.MultiVector_int_get2dCopy(self, *args)

    def get1dView(self, *args) -> "Teuchos::ArrayRCP< int const >":
        return _Tpetra.MultiVector_int_get1dView(self, *args)

    def get2dView(self, *args) -> "Teuchos::ArrayRCP< Teuchos::ArrayRCP< int const > >":
        return _Tpetra.MultiVector_int_get2dView(self, *args)

    def get1dViewNonConst(self, *args) -> "Teuchos::ArrayRCP< int >":
        return _Tpetra.MultiVector_int_get1dViewNonConst(self, *args)

    def get2dViewNonConst(self, *args) -> "Teuchos::ArrayRCP< Teuchos::ArrayRCP< int > >":
        return _Tpetra.MultiVector_int_get2dViewNonConst(self, *args)

    def dot(self, *args) -> "void":
        return _Tpetra.MultiVector_int_dot(self, *args)

    def abs(self, *args) -> "void":
        return _Tpetra.MultiVector_int_abs(self, *args)

    def reciprocal(self, *args) -> "void":
        return _Tpetra.MultiVector_int_reciprocal(self, *args)

    def scale(self, *args) -> "void":
        return _Tpetra.MultiVector_int_scale(self, *args)

    def update(self, *args) -> "void":
        return _Tpetra.MultiVector_int_update(self, *args)

    def norm1(self, *args) -> "void":
        return _Tpetra.MultiVector_int_norm1(self, *args)

    def norm2(self, *args) -> "void":
        return _Tpetra.MultiVector_int_norm2(self, *args)

    def normInf(self, *args) -> "void":
        return _Tpetra.MultiVector_int_normInf(self, *args)

    def meanValue(self, *args) -> "void":
        return _Tpetra.MultiVector_int_meanValue(self, *args)

    def multiply(self, *args) -> "void":
        return _Tpetra.MultiVector_int_multiply(self, *args)

    def elementWiseMultiply(self, *args) -> "void":
        return _Tpetra.MultiVector_int_elementWiseMultiply(self, *args)

    def getNumVectors(self, *args) -> "size_t":
        return _Tpetra.MultiVector_int_getNumVectors(self, *args)

    def getLocalLength(self, *args) -> "size_t":
        return _Tpetra.MultiVector_int_getLocalLength(self, *args)

    def getGlobalLength(self, *args) -> "Tpetra::global_size_t":
        return _Tpetra.MultiVector_int_getGlobalLength(self, *args)

    def getStride(self, *args) -> "size_t":
        return _Tpetra.MultiVector_int_getStride(self, *args)

    def isConstantStride(self, *args) -> "bool":
        return _Tpetra.MultiVector_int_isConstantStride(self, *args)

    def description(self, *args) -> "std::string":
        return _Tpetra.MultiVector_int_description(self, *args)

    def describe(self, *args) -> "void":
        return _Tpetra.MultiVector_int_describe(self, *args)

    def removeEmptyProcessesInPlace(self, *args) -> "void":
        return _Tpetra.MultiVector_int_removeEmptyProcessesInPlace(self, *args)

    def setCopyOrView(self, *args) -> "void":
        return _Tpetra.MultiVector_int_setCopyOrView(self, *args)

    def getCopyOrView(self, *args) -> "Teuchos::DataAccess":
        return _Tpetra.MultiVector_int_getCopyOrView(self, *args)

    def assign(self, *args) -> "void":
        return _Tpetra.MultiVector_int_assign(self, *args)

    def _extractNumPyArray(self, *args) -> "PyObject *":
        return _Tpetra.MultiVector_int__extractNumPyArray(self, *args)

    def __distarray__(self, *args) -> "PyObject *":
        return _Tpetra.MultiVector_int___distarray__(self, *args)

# Register MultiVector_int in _Tpetra:
_Tpetra.MultiVector_int_swigregister(MultiVector_int)


upgradeMultiVectorClass(MultiVector_int)

class Vector_int(MultiVector_int):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        _Tpetra.Vector_int_swiginit(self, _Tpetra.new_Vector_int(*args))
    __swig_destroy__ = _Tpetra.delete_Vector_int

    def replaceGlobalValue(self, *args) -> "void":
        return _Tpetra.Vector_int_replaceGlobalValue(self, *args)

    def sumIntoGlobalValue(self, *args) -> "void":
        return _Tpetra.Vector_int_sumIntoGlobalValue(self, *args)

    def replaceLocalValue(self, *args) -> "void":
        return _Tpetra.Vector_int_replaceLocalValue(self, *args)

    def sumIntoLocalValue(self, *args) -> "void":
        return _Tpetra.Vector_int_sumIntoLocalValue(self, *args)

    def get1dCopy(self, *args) -> "void":
        return _Tpetra.Vector_int_get1dCopy(self, *args)

    def getDataNonConst(self, *args) -> "Teuchos::ArrayRCP< int >":
        return _Tpetra.Vector_int_getDataNonConst(self, *args)

    def getData(self, *args) -> "Teuchos::ArrayRCP< int const >":
        return _Tpetra.Vector_int_getData(self, *args)

    def norm2(self, *args) -> "Tpetra::Vector< int,int,int,Tpetra::Details::DefaultTypes::node_type >::mag_type":
        return _Tpetra.Vector_int_norm2(self, *args)

    def normInf(self, *args) -> "Tpetra::Vector< int,int,int,Tpetra::Details::DefaultTypes::node_type >::mag_type":
        return _Tpetra.Vector_int_normInf(self, *args)

    def meanValue(self, *args) -> "int":
        return _Tpetra.Vector_int_meanValue(self, *args)

    def description(self, *args) -> "std::string":
        return _Tpetra.Vector_int_description(self, *args)

    def describe(self, *args) -> "void":
        return _Tpetra.Vector_int_describe(self, *args)

    def _extractNumPyArray(self, *args) -> "PyObject *":
        return _Tpetra.Vector_int__extractNumPyArray(self, *args)

    def __distarray__(self, *args) -> "PyObject *":
        return _Tpetra.Vector_int___distarray__(self, *args)

# Register Vector_int in _Tpetra:
_Tpetra.Vector_int_swigregister(Vector_int)


upgradeVectorClass(Vector_int)

class DistObject_double(SrcDistObject, Teuchos.Base.Describable):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Tpetra.delete_DistObject_double

    def doImport(self, *args) -> "void":
        return _Tpetra.DistObject_double_doImport(self, *args)

    def doExport(self, *args) -> "void":
        return _Tpetra.DistObject_double_doExport(self, *args)

    def isDistributed(self, *args) -> "bool":
        return _Tpetra.DistObject_double_isDistributed(self, *args)

    def getMap(self, *args) -> "Teuchos::RCP< DefaultMapType const >":
        return _Tpetra.DistObject_double_getMap(self, *args)

    def description(self, *args) -> "std::string":
        return _Tpetra.DistObject_double_description(self, *args)

    def describe(self, *args) -> "void":
        return _Tpetra.DistObject_double_describe(self, *args)

    def removeEmptyProcessesInPlace(self, *args) -> "void":
        return _Tpetra.DistObject_double_removeEmptyProcessesInPlace(self, *args)

# Register DistObject_double in _Tpetra:
_Tpetra.DistObject_double_swigregister(DistObject_double)

class MultiVector_double(DistObject_double):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        _Tpetra.MultiVector_double_swiginit(self, _Tpetra.new_MultiVector_double(*args))
    __swig_destroy__ = _Tpetra.delete_MultiVector_double

    def replaceGlobalValue(self, *args) -> "void":
        return _Tpetra.MultiVector_double_replaceGlobalValue(self, *args)

    def sumIntoGlobalValue(self, *args) -> "void":
        return _Tpetra.MultiVector_double_sumIntoGlobalValue(self, *args)

    def replaceLocalValue(self, *args) -> "void":
        return _Tpetra.MultiVector_double_replaceLocalValue(self, *args)

    def sumIntoLocalValue(self, *args) -> "void":
        return _Tpetra.MultiVector_double_sumIntoLocalValue(self, *args)

    def putScalar(self, *args) -> "void":
        return _Tpetra.MultiVector_double_putScalar(self, *args)

    def randomize(self, *args) -> "void":
        return _Tpetra.MultiVector_double_randomize(self, *args)

    def replaceMap(self, *args) -> "void":
        return _Tpetra.MultiVector_double_replaceMap(self, *args)

    def reduce(self, *args) -> "void":
        return _Tpetra.MultiVector_double_reduce(self, *args)

    def subCopy(self, *args) -> "Teuchos::RCP< Tpetra::MultiVector< double,int,int,Tpetra::Details::DefaultTypes::node_type > >":
        return _Tpetra.MultiVector_double_subCopy(self, *args)

    def subView(self, *args) -> "Teuchos::RCP< Tpetra::MultiVector< double,int,int,Tpetra::Details::DefaultTypes::node_type > const >":
        return _Tpetra.MultiVector_double_subView(self, *args)

    def subViewNonConst(self, *args) -> "Teuchos::RCP< Tpetra::MultiVector< double,int,int,Tpetra::Details::DefaultTypes::node_type > >":
        return _Tpetra.MultiVector_double_subViewNonConst(self, *args)

    def offsetViewNonConst(self, *args) -> "Teuchos::RCP< Tpetra::MultiVector< double,int,int,Tpetra::Details::DefaultTypes::node_type > >":
        return _Tpetra.MultiVector_double_offsetViewNonConst(self, *args)

    def getVector(self, *args) -> "Teuchos::RCP< Tpetra::Vector< double,int,int,Tpetra::Details::DefaultTypes::node_type > const >":
        return _Tpetra.MultiVector_double_getVector(self, *args)

    def getVectorNonConst(self, *args) -> "Teuchos::RCP< Tpetra::Vector< double,int,int,Tpetra::Details::DefaultTypes::node_type > >":
        return _Tpetra.MultiVector_double_getVectorNonConst(self, *args)

    def getData(self, *args) -> "Teuchos::ArrayRCP< double const >":
        return _Tpetra.MultiVector_double_getData(self, *args)

    def getDataNonConst(self, *args) -> "Teuchos::ArrayRCP< double >":
        return _Tpetra.MultiVector_double_getDataNonConst(self, *args)

    def get1dCopy(self, *args) -> "void":
        return _Tpetra.MultiVector_double_get1dCopy(self, *args)

    def get2dCopy(self, *args) -> "void":
        return _Tpetra.MultiVector_double_get2dCopy(self, *args)

    def get1dView(self, *args) -> "Teuchos::ArrayRCP< double const >":
        return _Tpetra.MultiVector_double_get1dView(self, *args)

    def get2dView(self, *args) -> "Teuchos::ArrayRCP< Teuchos::ArrayRCP< double const > >":
        return _Tpetra.MultiVector_double_get2dView(self, *args)

    def get1dViewNonConst(self, *args) -> "Teuchos::ArrayRCP< double >":
        return _Tpetra.MultiVector_double_get1dViewNonConst(self, *args)

    def get2dViewNonConst(self, *args) -> "Teuchos::ArrayRCP< Teuchos::ArrayRCP< double > >":
        return _Tpetra.MultiVector_double_get2dViewNonConst(self, *args)

    def dot(self, *args) -> "void":
        return _Tpetra.MultiVector_double_dot(self, *args)

    def abs(self, *args) -> "void":
        return _Tpetra.MultiVector_double_abs(self, *args)

    def reciprocal(self, *args) -> "void":
        return _Tpetra.MultiVector_double_reciprocal(self, *args)

    def scale(self, *args) -> "void":
        return _Tpetra.MultiVector_double_scale(self, *args)

    def update(self, *args) -> "void":
        return _Tpetra.MultiVector_double_update(self, *args)

    def norm1(self, *args) -> "void":
        return _Tpetra.MultiVector_double_norm1(self, *args)

    def norm2(self, *args) -> "void":
        return _Tpetra.MultiVector_double_norm2(self, *args)

    def normInf(self, *args) -> "void":
        return _Tpetra.MultiVector_double_normInf(self, *args)

    def meanValue(self, *args) -> "void":
        return _Tpetra.MultiVector_double_meanValue(self, *args)

    def multiply(self, *args) -> "void":
        return _Tpetra.MultiVector_double_multiply(self, *args)

    def elementWiseMultiply(self, *args) -> "void":
        return _Tpetra.MultiVector_double_elementWiseMultiply(self, *args)

    def getNumVectors(self, *args) -> "size_t":
        return _Tpetra.MultiVector_double_getNumVectors(self, *args)

    def getLocalLength(self, *args) -> "size_t":
        return _Tpetra.MultiVector_double_getLocalLength(self, *args)

    def getGlobalLength(self, *args) -> "Tpetra::global_size_t":
        return _Tpetra.MultiVector_double_getGlobalLength(self, *args)

    def getStride(self, *args) -> "size_t":
        return _Tpetra.MultiVector_double_getStride(self, *args)

    def isConstantStride(self, *args) -> "bool":
        return _Tpetra.MultiVector_double_isConstantStride(self, *args)

    def description(self, *args) -> "std::string":
        return _Tpetra.MultiVector_double_description(self, *args)

    def describe(self, *args) -> "void":
        return _Tpetra.MultiVector_double_describe(self, *args)

    def removeEmptyProcessesInPlace(self, *args) -> "void":
        return _Tpetra.MultiVector_double_removeEmptyProcessesInPlace(self, *args)

    def setCopyOrView(self, *args) -> "void":
        return _Tpetra.MultiVector_double_setCopyOrView(self, *args)

    def getCopyOrView(self, *args) -> "Teuchos::DataAccess":
        return _Tpetra.MultiVector_double_getCopyOrView(self, *args)

    def assign(self, *args) -> "void":
        return _Tpetra.MultiVector_double_assign(self, *args)

    def _extractNumPyArray(self, *args) -> "PyObject *":
        return _Tpetra.MultiVector_double__extractNumPyArray(self, *args)

    def __distarray__(self, *args) -> "PyObject *":
        return _Tpetra.MultiVector_double___distarray__(self, *args)

# Register MultiVector_double in _Tpetra:
_Tpetra.MultiVector_double_swigregister(MultiVector_double)


upgradeMultiVectorClass(MultiVector_double)

class Vector_double(MultiVector_double):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        _Tpetra.Vector_double_swiginit(self, _Tpetra.new_Vector_double(*args))
    __swig_destroy__ = _Tpetra.delete_Vector_double

    def replaceGlobalValue(self, *args) -> "void":
        return _Tpetra.Vector_double_replaceGlobalValue(self, *args)

    def sumIntoGlobalValue(self, *args) -> "void":
        return _Tpetra.Vector_double_sumIntoGlobalValue(self, *args)

    def replaceLocalValue(self, *args) -> "void":
        return _Tpetra.Vector_double_replaceLocalValue(self, *args)

    def sumIntoLocalValue(self, *args) -> "void":
        return _Tpetra.Vector_double_sumIntoLocalValue(self, *args)

    def get1dCopy(self, *args) -> "void":
        return _Tpetra.Vector_double_get1dCopy(self, *args)

    def getDataNonConst(self, *args) -> "Teuchos::ArrayRCP< double >":
        return _Tpetra.Vector_double_getDataNonConst(self, *args)

    def getData(self, *args) -> "Teuchos::ArrayRCP< double const >":
        return _Tpetra.Vector_double_getData(self, *args)

    def norm2(self, *args) -> "Tpetra::Vector< double,int,int,Tpetra::Details::DefaultTypes::node_type >::mag_type":
        return _Tpetra.Vector_double_norm2(self, *args)

    def normInf(self, *args) -> "Tpetra::Vector< double,int,int,Tpetra::Details::DefaultTypes::node_type >::mag_type":
        return _Tpetra.Vector_double_normInf(self, *args)

    def meanValue(self, *args) -> "double":
        return _Tpetra.Vector_double_meanValue(self, *args)

    def description(self, *args) -> "std::string":
        return _Tpetra.Vector_double_description(self, *args)

    def describe(self, *args) -> "void":
        return _Tpetra.Vector_double_describe(self, *args)

    def _extractNumPyArray(self, *args) -> "PyObject *":
        return _Tpetra.Vector_double__extractNumPyArray(self, *args)

    def __distarray__(self, *args) -> "PyObject *":
        return _Tpetra.Vector_double___distarray__(self, *args)

# Register Vector_double in _Tpetra:
_Tpetra.Vector_double_swigregister(Vector_double)


upgradeVectorClass(Vector_double)


def MultiVector(*args, **kwargs):
  dtype = None
  if len(args) > 0:
    try:
      dtype = str(args[0].dtype)
    except AttributeError:
      pass
  dtype = kwargs.get("dtype", dtype)
  if dtype is None: dtype = "int64"
  if type(dtype) == str:
    dtype = numpy.dtype(dtype)
  if dtype.type is numpy.int32:
    result = MultiVector_int(*args)
  elif dtype.type is numpy.int64:
    result = MultiVector_long(*args)
#elif dtype.type is numpy.float32:
#  result = MultiVector_float(*args)
  elif dtype.type is numpy.float64:
    result = MultiVector_double(*args)
  else:
    raise TypeError("Unsupported or unrecognized dtype = %s" %
                    str(dtype))
  return result

def Vector(*args, **kwargs):
  dtype = None
  if len(args) > 0:
    try:
      dtype = str(args[0].dtype)
    except AttributeError:
      pass
  dtype = kwargs.get("dtype", dtype)
  if dtype is None: dtype = "int64"
  if type(dtype) == str:
    dtype = numpy.dtype(dtype)
  if dtype.type is numpy.int32:
    result = Vector_int(*args)
  elif dtype.type is numpy.int64:
    result = Vector_long(*args)
#elif dtype.type is numpy.float32:
#  result = Vector_float(*args)
  elif dtype.type is numpy.float64:
    result = Vector_double(*args)
  else:
    raise TypeError("Unsupported or unrecognized dtype = %s" %
                    str(dtype))
  return result



