# This file was automatically generated by SWIG (http://www.swig.org).
# Version 4.0.2
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.

"""

PyTrilinos.Epetra is the python interface to the Trilinos linear
algebra services package Epetra:

    https://trilinos.org/docs/dev/packages/epetra/doc/html/index.html

The purpose of Epetra is to provide fundamental linear algebra
services to the rest of Trilinos.  These services include parallel
decomposition and communication, vectors and multivectors, graphs,
operators, and dense and sparse matrices.  Note that the C++ version
of Epetra uses the prefix 'Epetra_' which has been stripped from the
python version.

Epetra provides the following user-level classes (by category):

    * Communicators: PyComm, SerialComm, MpiComm (if built with mpi
      support)
    * Data distribution maps: Map, BlockMap, LocalMap
    * Vectors: Vector, MultiVector, IntVector
    * Graphs: CrsGraph, FECrsGraph
    * Operators and matrices: Operator, RowMatrix, CrsMatrix,
      FECrsMatrix, VbrMatrix
    * Serial dense objects: SerialDenseVector, SerialDenseMatrix,
      SerialDenseOperator, SerialDenseSolver, IntSerialDenseVector,
      IntSerialDenseMatrix
    * Aggregates: LinearProblem
    * Utilities: Import, Export, Time, MapColoring, Util

For examples of usage, please consult the following scripts in the
example subdirectory of the PyTrilinos package:

    * exEpetra.py
    * exEpetra_Comm.py
    * exEpetra_ImportExport.py
    * exEpetra_CrsMatrix_Easy.py
    * exEpetra_CrsMatrix_Efficient.py
    * exEpetra_FECrsMatrix_Easy.py

The Epetra module has been designed to use and interoperate with the
numpy module, which provides multidimensional array support.  Epetra
class constructors or methods that expect C arrays in C++ can
typically accept numpy arrays in python (or any python sequence that
numpy can convert to an array).  Similarly, methods that return C
arrays in C++ will return numpy arrays in python.  Also, certain
Epetra classes that represent contiguous blocks of homogeneous data
have been given the attributes of numpy arrays: Vector, MultiVector,
IntVector, SerialDenseVector, SerialDenseMatrix, IntSerialDenseVector
and IntSerialDenseMatrix.

"""

from sys import version_info as _swig_python_version_info
if _swig_python_version_info < (2, 7, 0):
    raise RuntimeError("Python 2.7 or later required")

# Import the low-level C/C++ module
if __package__ or "." in __name__:
    from . import _Epetra
else:
    import _Epetra

try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)


def _swig_setattr_nondynamic_instance_variable(set):
    def set_instance_attr(self, name, value):
        if name == "thisown":
            self.this.own(value)
        elif name == "this":
            set(self, name, value)
        elif hasattr(self, name) and isinstance(getattr(type(self), name), property):
            set(self, name, value)
        else:
            raise AttributeError("You cannot add instance attributes to %s" % self)
    return set_instance_attr


def _swig_setattr_nondynamic_class_variable(set):
    def set_class_attr(cls, name, value):
        if hasattr(cls, name) and not isinstance(getattr(cls, name), property):
            set(cls, name, value)
        else:
            raise AttributeError("You cannot add class attributes to %s" % cls)
    return set_class_attr


def _swig_add_metaclass(metaclass):
    """Class decorator for adding a metaclass to a SWIG wrapped class - a slimmed down version of six.add_metaclass"""
    def wrapper(cls):
        return metaclass(cls.__name__, cls.__bases__, cls.__dict__.copy())
    return wrapper


class _SwigNonDynamicMeta(type):
    """Meta class to enforce nondynamic attributes (no new attributes) for a class"""
    __setattr__ = _swig_setattr_nondynamic_class_variable(type.__setattr__)


import weakref

class SwigPyIterator(object):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Epetra.delete_SwigPyIterator

    def value(self, *args) -> "PyObject *":
        return _Epetra.SwigPyIterator_value(self, *args)

    def incr(self, *args) -> "swig::SwigPyIterator *":
        return _Epetra.SwigPyIterator_incr(self, *args)

    def decr(self, *args) -> "swig::SwigPyIterator *":
        return _Epetra.SwigPyIterator_decr(self, *args)

    def distance(self, *args) -> "ptrdiff_t":
        return _Epetra.SwigPyIterator_distance(self, *args)

    def equal(self, *args) -> "bool":
        return _Epetra.SwigPyIterator_equal(self, *args)

    def copy(self, *args) -> "swig::SwigPyIterator *":
        return _Epetra.SwigPyIterator_copy(self, *args)

    def next(self, *args) -> "PyObject *":
        return _Epetra.SwigPyIterator_next(self, *args)

    def __next__(self, *args) -> "PyObject *":
        return _Epetra.SwigPyIterator___next__(self, *args)

    def previous(self, *args) -> "PyObject *":
        return _Epetra.SwigPyIterator_previous(self, *args)

    def advance(self, *args) -> "swig::SwigPyIterator *":
        return _Epetra.SwigPyIterator_advance(self, *args)

    def __eq__(self, *args) -> "bool":
        return _Epetra.SwigPyIterator___eq__(self, *args)

    def __ne__(self, *args) -> "bool":
        return _Epetra.SwigPyIterator___ne__(self, *args)

    def __iadd__(self, *args) -> "swig::SwigPyIterator &":
        return _Epetra.SwigPyIterator___iadd__(self, *args)

    def __isub__(self, *args) -> "swig::SwigPyIterator &":
        return _Epetra.SwigPyIterator___isub__(self, *args)

    def __add__(self, *args) -> "swig::SwigPyIterator *":
        return _Epetra.SwigPyIterator___add__(self, *args)

    def __sub__(self, *args) -> "ptrdiff_t":
        return _Epetra.SwigPyIterator___sub__(self, *args)
    def __iter__(self):
        return self

# Register SwigPyIterator in _Epetra:
_Epetra.SwigPyIterator_swigregister(SwigPyIterator)

SHARED_PTR_DISOWN = _Epetra.SHARED_PTR_DISOWN

# Much of the Epetra module is compatible with the numpy module
import numpy

Error = _Epetra.Error

def class_array_inplace_op(self, op_str, other):
  in_op = getattr(self.array, "__i"+op_str+"__")
  in_op(other.array)
  return self

def class_array_math_op(self, op_str, other):
# Initialize the result by calling the copy constructor
  result = self.__class__(self)
# Get the equivalent in-place operator for the result
  in_op = getattr(result.array, "__i"+op_str+"__")
  try:
    in_op(other.array)
  except AttributeError:
    in_op(other)
  return result

def class_array_rmath_op(self, op_str, other):
# Initialize the result by calling the copy constructor
  result = self.__class__(self)
  indices = (slice(None),) * len(self.array.shape)
  result.array[indices] = other
  in_op = getattr(result.array, "__i"+op_str+"__")
  in_op(self.array)
  return result

def class_array_add_math_ops(cls, op_str):
  setattr(cls,
          "__i"+op_str+"__",
          lambda self, other: class_array_inplace_op(self, op_str, other))
  setattr(cls,
          "__"+op_str+"__",
          lambda self, other: class_array_math_op(self, op_str, other))
  setattr(cls,
          "__r"+op_str+"__",
          lambda self, other: class_array_rmath_op(self, op_str, other))

def class_array_add_math(cls):
  class_array_add_math_ops(cls, "add")
  class_array_add_math_ops(cls, "sub")
  class_array_add_math_ops(cls, "mul")
  class_array_add_math_ops(cls, "add")

def class_array_comp_op(self, op_str, other):
  comp_op = getattr(self.array, "__"+op_str+"__")
  try:
    return comp_op(other.array)
  except AttributeError:
    return comp_op(other)

def class_array_add_comp_op(cls, op_str):
  setattr(cls,
          "__"+op_str+"__",
          lambda self, other: class_array_comp_op(self, op_str, other))

def class_array_add_comp(cls):
  class_array_add_comp_op(cls, "lt")
  class_array_add_comp_op(cls, "le")
  class_array_add_comp_op(cls, "eq")
  class_array_add_comp_op(cls, "ne")
  class_array_add_comp_op(cls, "gt")
  class_array_add_comp_op(cls, "ge")


def Epetra_Version(*args) -> "std::string":
    return _Epetra.Epetra_Version(*args)

Version = Epetra_Version
__version__ = Version().split()[2]

Add = _Epetra.Add
r"""
    Components on the receiving processor
                                        will be added together. (V,M)
    """
Zero = _Epetra.Zero
r"""
    Off-processor components will be
                                        ignored. (V,M)
    """
Insert = _Epetra.Insert
r"""
    Off-processor components will
                                        be inserted into locations on
                                        receiving processor replacing existing values. (V,M)
    """
InsertAdd = _Epetra.InsertAdd
r"""
    Off-processor components will
                                        be inserted into locations on
                                        receiving processor replacing existing values. (V,M)
    """
Average = _Epetra.Average
r"""
    Off-processor components will be
                                        averaged with existing components
                                        on the receiving processor. (V)
    """
Epetra_Max = _Epetra.Epetra_Max
r"""
    Off-processor components will be
                                        maxed with existing components
                                        on the receiving processor. (V)
    """
Epetra_Min = _Epetra.Epetra_Min
r"""
    Off-processor components will be
                                        min'ed with existing components
                                        on the receiving processor. (V)
    """
AbsMax = _Epetra.AbsMax
r"""
    Magnitudes of Off-processor components will be
                                        maxed with magnitudes of existing components
                                        on the receiving processor. (V)
    """
AbsMin = _Epetra.AbsMin
r"""
    Magnitudes of Off-processor components will be
                                        min'ed with magnitudes of existing components
                                        on the receiving processor. (V)
    """
Epetra_AddLocalAlso = _Epetra.Epetra_AddLocalAlso
r""" Like Add but local components are also added"""
Copy = _Epetra.Copy
r"""
    User data will be copied at
                                     construction.
    """
View = _Epetra.View
r"""
    User data will be encapsulated and
                                    used throughout the life of the object.
    """
class Object(object):
    r"""
    The base Epetra class.

    The Epetra_Object class provides capabilities common to all Epetra
    objects, such as a label that identifies an object instance, constant
    definitions, enum types.  In C++, it supports a ``Print()`` method
    that takes an output stream as an argument.  In the python
    implementation for this and all derived classes, this method takes an
    optional file object argument whose default value is standard out.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        The base Epetra class.

        The Epetra_Object class provides capabilities common to all Epetra
        objects, such as a label that identifies an object instance, constant
        definitions, enum types.  In C++, it supports a ``Print()`` method
        that takes an output stream as an argument.  In the python
        implementation for this and all derived classes, this method takes an
        optional file object argument whose default value is standard out.
        """
        _Epetra.Object_swiginit(self, _Epetra.new_Object(*args))
    __swig_destroy__ = _Epetra.delete_Object

    def SetLabel(self, *args) -> "void":
        r""" Epetra_Object Label definition using char *. Defines the label used to describe the *this* object."""
        return _Epetra.Object_SetLabel(self, *args)

    def Label(self, *args) -> "char const *":
        r""" Epetra_Object Label access funtion. Returns the string used to define this object."""
        return _Epetra.Object_Label(self, *args)

    @staticmethod
    def SetTracebackMode(*args) -> "void":
        r"""
        Set the value of the Epetra_Object error traceback report mode. Sets the integer error traceback behavior.
             TracebackMode controls whether or not traceback information is printed when run time
             integer errors are detected:

             <= 0 - No information report

              = 1 - Fatal (negative) values are reported

             >= 2 - All values (except zero) reported.

             Default is set to 1.
        """
        return _Epetra.Object_SetTracebackMode(*args)

    @staticmethod
    def GetTracebackMode(*args) -> "int":
        r""" Get the value of the Epetra_Object error report mode."""
        return _Epetra.Object_GetTracebackMode(*args)

    @staticmethod
    def GetTracebackStream(*args) -> "std::ostream &":
        r""" Get the output stream for error reporting"""
        return _Epetra.Object_GetTracebackStream(*args)

    def ReportError(self, *args) -> "int":
        r""" Error reporting method"""
        return _Epetra.Object_ReportError(self, *args)
    TracebackMode = property(_Epetra.Object_TracebackMode_get, _Epetra.Object_TracebackMode_set)

    def __str__(self, *args) -> "PyObject *":
        r"""
        Returns the results of ``Print()`` in a string, so that
        the python ``print`` command will work on ``Epetra`` objects.  The
        ``Print()`` methods are designed to run correctly in parallel, so do
        not execute ``print`` on an Epetra object conditionally on the
        processor number.  For example, do not do

          ``if comm.MyPID() == 0: print epetra_obj``

        or it will hang your code.
        """
        return _Epetra.Object___str__(self, *args)

    def Print(self, *args) -> "void":
        return _Epetra.Object_Print(self, *args)

# Register Object in _Epetra:
_Epetra.Object_swigregister(Object)
cvar = _Epetra.cvar
Epetra_MinDouble = cvar.Epetra_MinDouble
Epetra_MaxDouble = cvar.Epetra_MaxDouble
Epetra_Overflow = cvar.Epetra_Overflow
Epetra_Underflow = cvar.Epetra_Underflow
FormatStdout = cvar.FormatStdout
DefaultTracebackMode = cvar.DefaultTracebackMode

def Object_SetTracebackMode(*args) -> "void":
    r"""
    Set the value of the Epetra_Object error traceback report mode. Sets the integer error traceback behavior.
         TracebackMode controls whether or not traceback information is printed when run time
         integer errors are detected:

         <= 0 - No information report

          = 1 - Fatal (negative) values are reported

         >= 2 - All values (except zero) reported.

         Default is set to 1.
    """
    return _Epetra.Object_SetTracebackMode(*args)

def Object_GetTracebackMode(*args) -> "int":
    r""" Get the value of the Epetra_Object error report mode."""
    return _Epetra.Object_GetTracebackMode(*args)

def Object_GetTracebackStream(*args) -> "std::ostream &":
    r""" Get the output stream for error reporting"""
    return _Epetra.Object_GetTracebackStream(*args)

class CompObject(object):
    r"""
    Epetra_CompObject: Functionality and data that is common to all computational classes. The Epetra_CompObject is a base class for all Epetra computational objects.  It provides the basic
       mechanisms and interface specifications for floating point operations using Epetra_Flops objects.

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        *Overload 1:*
        Basic Epetra_CompObject constuctor.

        |

        *Overload 2:*
        Epetra_CompObject copy constructor.
        """
        _Epetra.CompObject_swiginit(self, _Epetra.new_CompObject(*args))
    __swig_destroy__ = _Epetra.delete_CompObject

    def SetFlopCounter(self, *args) -> "void":
        r"""
        *Overload 1:*
        Set the internal Epetra_Flops() pointer.

        |

        *Overload 2:*
        Set the internal Epetra_Flops() pointer to the flop counter of another Epetra_CompObject.
        """
        return _Epetra.CompObject_SetFlopCounter(self, *args)

    def UnsetFlopCounter(self, *args) -> "void":
        r""" Set the internal Epetra_Flops() pointer to 0 (no flops counted)."""
        return _Epetra.CompObject_UnsetFlopCounter(self, *args)

    def GetFlopCounter(self, *args) -> "Epetra_Flops *":
        r""" Get the pointer to the  Epetra_Flops() object associated with this object, returns 0 if none."""
        return _Epetra.CompObject_GetFlopCounter(self, *args)

    def ResetFlops(self, *args) -> "void":
        r""" Resets the number of floating point operations to zero for *this* multi-vector."""
        return _Epetra.CompObject_ResetFlops(self, *args)

    def Flops(self, *args) -> "double":
        r""" Returns the number of floating point operations with *this* multi-vector."""
        return _Epetra.CompObject_Flops(self, *args)

    def UpdateFlops(self, *args) -> "void":
        r"""
        *Overload 1:*
        Increment Flop count for *this* object

        |

        *Overload 2:*
        Increment Flop count for *this* object

        |

        *Overload 3:*
        Increment Flop count for *this* object
        """
        return _Epetra.CompObject_UpdateFlops(self, *args)

# Register CompObject in _Epetra:
_Epetra.CompObject_swigregister(CompObject)

class BLAS(object):
    r"""
    Epetra_BLAS:  The Epetra BLAS Wrapper Class. The Epetra_BLAS class is a wrapper that encapsulates the BLAS
       (Basic Linear Algebra Subprograms).  The BLAS provide portable, high-
       performance implementations of kernels such as dense vectoer multiplication,
       dot products, dense matrix-vector multiplication and dense matrix-matrix
       multiplication.

       The standard BLAS interface is Fortran-specific.  Unfortunately, the
       interface between C++ and Fortran is not standard across all computer
       platforms.  The Epetra_BLAS class provides C++ wrappers for the BLAS
       kernels in order to insulate the rest of Epetra from the details of C++ to Fortran
       translation.
       A Epetra_BLAS object is essentially nothing, but allows access to the BLAS wrapper
       functions.

       Epetra_BLAS is a serial interface only.  This is appropriate since the standard
       BLAS are only specified for serial execution (or shared memory parallel).
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        *Overload 1:*
        Epetra_BLAS Constructor. Builds an instance of a serial BLAS object.

        |

        *Overload 2:*
        Epetra_BLAS Copy Constructor. Makes an exact copy of an existing Epetra_BLAS instance.
        """
        _Epetra.BLAS_swiginit(self, _Epetra.new_BLAS(*args))
    __swig_destroy__ = _Epetra.delete_BLAS

    def SYRK(self, *args) -> "void":
        r"""
        *Overload 1:*
        Eperta_BLAS symetric rank k funtion (ssyrk)

        |

        *Overload 2:*
        Eperta_BLAS symetric rank k funtion (dsyrk)
        """
        return _Epetra.BLAS_SYRK(self, *args)

# Register BLAS in _Epetra:
_Epetra.BLAS_swigregister(BLAS)

class LAPACK(object):
    r"""
    Epetra_LAPACK:  The Epetra LAPACK Wrapper Class. The Epetra_LAPACK class is a wrapper that encapsulates LAPACK
       (Linear Algebra Package).  LAPACK provides portable, high-
       performance implementations of linear, eigen, SVD, etc solvers.

       The standard LAPACK interface is Fortran-specific.  Unfortunately, the
       interface between C++ and Fortran is not standard across all computer
       platforms.  The Epetra_LAPACK class provides C++ wrappers for the LAPACK
       kernels in order to insulate the rest of Epetra from the details of C++ to Fortran
       translation.
       A Epetra_LAPACK object is essentially nothing, but allows access to the LAPACK wrapper
       functions.

       Epetra_LAPACK is a serial interface only.  This is appropriate since the standard
       LAPACK are only specified for serial execution (or shared memory parallel).
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        *Overload 1:*
        Epetra_LAPACK Constructor. Builds an instance of a serial LAPACK object.

        |

        *Overload 2:*
        Epetra_LAPACK Copy Constructor. Makes an exact copy of an existing Epetra_LAPACK instance.
        """
        _Epetra.LAPACK_swiginit(self, _Epetra.new_LAPACK(*args))
    __swig_destroy__ = _Epetra.delete_LAPACK

    def TRTRS(self, *args) -> "void":
        r"""
        *Overload 1:*
        Epetra_LAPACK wrapper for TRTRS routine.

        |

        *Overload 2:*
        Epetra_LAPACK wrapper for TRTRS routine.
        """
        return _Epetra.LAPACK_TRTRS(self, *args)

# Register LAPACK in _Epetra:
_Epetra.LAPACK_swigregister(LAPACK)

class FLOPS(object):
    r"""
    Epetra_Flops:  The Epetra Floating Point Operations Class. The Epetra_Flops class provides basic support and consistent interfaces
       for counting and reporting floating point operations performed in
       the Epetra computational classes.  All classes based on the Epetra_CompObject
       can count flops by the user creating an Epetra_Flops object and calling the SetFlopCounter()
       method for an Epetra_CompObject.

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        *Overload 1:*
        Epetra_Flops Constructor. Creates a Epetra_Flops instance. This instance can be queried for
             the number of floating point operations performed for the associated
             *this* object.

        |

        *Overload 2:*
        Epetra_Flops Copy Constructor. Makes an exact copy of an existing Epetra_Flops instance.
        """
        _Epetra.FLOPS_swiginit(self, _Epetra.new_FLOPS(*args))

    def Flops(self, *args) -> "double":
        r""" Returns the number of floating point operations with *this* object and resets the count."""
        return _Epetra.FLOPS_Flops(self, *args)

    def ResetFlops(self, *args) -> "void":
        r""" Resets the number of floating point operations to zero for *this* multi-vector."""
        return _Epetra.FLOPS_ResetFlops(self, *args)
    __swig_destroy__ = _Epetra.delete_FLOPS

# Register FLOPS in _Epetra:
_Epetra.FLOPS_swigregister(FLOPS)

class Time(Object):
    r"""
    Epetra_Time:  The Epetra Timing Class. The Epetra_Time class is a wrapper that encapsulates the general
     information needed getting timing information.  Currently it return
     the elapsed time for each calling processor..
     A Epetra_Comm object is required for building all Epetra_Time objects.

     Epetra_Time support both serial execution and (via MPI) parallel
     distributed memory execution.  It is meant to insulate the user from
     the specifics of timing across a variety of platforms.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        *Overload 1:*
        Epetra_Time Constructor. Creates a Epetra_Time instance. This instance can be queried for
             elapsed time on the calling processor.  StartTime is also set
             for use with the ElapsedTime function.

        |

        *Overload 2:*
        Epetra_Time Copy Constructor. Makes an exact copy of an existing Epetra_Time instance.
        """
        _Epetra.Time_swiginit(self, _Epetra.new_Time(*args))

    def WallTime(self, *args) -> "double":
        r"""
        Epetra_Time wall-clock time function. Returns the wall-clock time in seconds.  A code section can be
             timed by putting it between two calls to WallTime and taking the
             difference of the times.
        """
        return _Epetra.Time_WallTime(self, *args)

    def ResetStartTime(self, *args) -> "void":
        r"""
        Epetra_Time function to reset the start time for a timer object. Resets the start time for the timer object to the current time
             A code section can be
             timed by putting it between a call to ResetStartTime and ElapsedTime.
        """
        return _Epetra.Time_ResetStartTime(self, *args)

    def ElapsedTime(self, *args) -> "double":
        r"""
        Epetra_Time elapsed time function. Returns the elapsed time in seconds since the timer object was
             constructed, or since the ResetStartTime function was called.
             A code section can be
             timed by putting it between the Epetra_Time constructor and a call to
             ElapsedTime, or between a call to ResetStartTime and ElapsedTime.
        """
        return _Epetra.Time_ElapsedTime(self, *args)
    __swig_destroy__ = _Epetra.delete_Time

# Register Time in _Epetra:
_Epetra.Time_swigregister(Time)


def _extractNumPyArrayFromEpetraIntSerialDenseMatrix(source: "IntSerialDenseMatrix") -> "PyObject *":
    return _Epetra._extractNumPyArrayFromEpetraIntSerialDenseMatrix(source)
class IntSerialDenseMatrix(Object):
    r"""
     Epetra_IntSerialDenseMatrix: A class for constructing and using general dense integer matrices. The Epetra_IntSerialDenseMatrix class enables the construction and use of integer-valued, general
        dense matrices.

    The Epetra_IntSerialDenseMatrix class is intended to provide very basic support for dense rectangular matrices.


    **Constructing Epetra_IntSerialDenseMatrix Objects**

    There are four Epetra_IntSerialDenseMatrix constructors.  The first constructs a zero-sized object which should be made
    to appropriate length using the Shape() or Reshape() functions and then filled with the [] or () operators.
    The second constructs an object sized to the dimensions specified, which should be filled with the [] or () operators.
    The third is a constructor that accepts user
    data as a 2D array, and the fourth is a copy constructor. The third constructor has
    two data access modes (specified by the Epetra_DataAccess argument):

      *  Copy mode - Allocates memory and makes a copy of the user-provided data. In this case, the
           user data is not needed after construction.
      *  View mode - Creates a "view" of the user data. In this case, the
           user data is required to remain intact for the life of the object.


    Warning: View mode is *extremely* dangerous from a data hiding perspective.
    Therefore, we strongly encourage users to develop code using Copy mode first and
    only use the View mode in a secondary optimization phase.

    Epetra_IntSerialDenseMatrix constructors will throw an exception if an error occurrs.
    These exceptions will alway be negative integer values as follows:

      *  -1  Invalid dimension specified.
      *  -2  Shape returned non-zero.
      *  -3  Null pointer specified for user's data.
      *  -99 Internal Epetra_IntSerialDenseMatrix error.  Contact developer.


    Other Epetra_IntSerialDenseMatrix functions that do not return an integer error code
    (such as operators () and [] ) will throw an exception if an error occurrs.
    These exceptions will be integer values as follows:

      *  -1  Invalid row specified.
      *  -2  Invalid column specified.
    	*  -5  Invalid assignment (type mismatch).
      *  -99 Internal Epetra_IntSerialDenseMatrix error.  Contact developer.



    b**Extracting Data from Epetra_IntSerialDenseMatrix Objects**

    Once a Epetra_IntSerialDenseMatrix is constructed, it is possible to view the data via access functions.

    Use of these access functions cam be *extremely* dangerous from a data hiding perspective.


    **Vector and Utility Functions**

    Once a Epetra_IntSerialDenseMatrix is constructed, several mathematical functions can be applied to
    the object.  Specifically:

      *  Multiplication.
      *  Norms.



    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    __swig_destroy__ = _Epetra.delete_IntSerialDenseMatrix

    def Shape(self, NumRows: "int", NumCols: "int") -> "int":
        r"""
        Set dimensions of a Epetra_IntSerialDenseMatrix object; init values to zero.
           :param In:
                      NumRows - Number of rows in object.
           :param In:
                      NumCols - Number of columns in object.

           Allows user to define the dimensions of a Epetra_IntSerialDenseMatrix at any point. This function can
           be called at any point after construction.  Any values that were previously in this object are
           destroyed and the resized matrix starts off with all zero values.

           :rtype: int
           :return: Integer error code, set to 0 if successful.
        """
        val = _Epetra.IntSerialDenseMatrix_Shape(self, NumRows, NumCols)

        if "array" in self.__dict__: del self.__dict__["array"]


        return val


    def Reshape(self, NumRows: "int", NumCols: "int") -> "int":
        r"""
        Reshape a Epetra_IntSerialDenseMatrix object.
           :param In:
                      NumRows - Number of rows in object.
           :param In:
                      NumCols - Number of columns in object.

           Allows user to define the dimensions of a Epetra_IntSerialDenseMatrix at any point. This function can
           be called at any point after construction.  Any values that were previously in this object are
           copied into the new shape.  If the new shape is smaller than the original, the upper left portion
           of the original matrix (the principal submatrix) is copied to the new matrix.

           :rtype: int
           :return: Integer error code, set to 0 if successful.
        """
        val = _Epetra.IntSerialDenseMatrix_Reshape(self, NumRows, NumCols)

        if "array" in self.__dict__: del self.__dict__["array"]


        return val


    def OneNorm(self) -> "int":
        r"""
        Computes the 1-Norm of the *this* matrix.
           :rtype: int
           :return: Integer error code, set to 0 if successful.
        """
        return _Epetra.IntSerialDenseMatrix_OneNorm(self)

    def InfNorm(self) -> "int":
        r""" Computes the Infinity-Norm of the *this* matrix."""
        return _Epetra.IntSerialDenseMatrix_InfNorm(self)

    def __eq__(self, rhs: "IntSerialDenseMatrix") -> "bool":
        r"""
        Comparison operator. operator== compares two Epetra_IntSerialDenseMatrix objects, returns false if sizes are different,
             or if any coefficients differ.
        """
        return _Epetra.IntSerialDenseMatrix___eq__(self, rhs)

    def __ne__(self, rhs: "IntSerialDenseMatrix") -> "bool":
        r""" Inequality operator operator!= simply returns the negation of operator==."""
        return _Epetra.IntSerialDenseMatrix___ne__(self, rhs)

    def __call__(self, RowIndex: "int", ColIndex: "int") -> "int const &":
        r"""
        Element access function.
           The parentheses operator returns the element in the ith row and jth column if A(i,j) is
           specified, the expression A[j][i] (note that i and j are reversed) will return the same element.
           Thus, A(i,j) = A[j][i] for all valid i and j.

           :rtype: int
           :return: Element from the specified row and column.

        	Warning: No bounds checking is done unless Epetra is compiled with HAVE_EPETRA_ARRAY_BOUNDS_CHECK.
        """
        return _Epetra.IntSerialDenseMatrix___call__(self, RowIndex, ColIndex)

    def Random(self) -> "int":
        r"""
        Set matrix values to random numbers.
        	IntSerialDenseMatrix uses the random number generator provided by Epetra_Util.
        	The matrix values will be set to random values on the interval (0, 2^31 - 1).

           :rtype: int
           :return: Integer error code, set to 0 if successful.
        """
        return _Epetra.IntSerialDenseMatrix_Random(self)

    def M(self) -> "int":
        r""" Returns row dimension of system."""
        return _Epetra.IntSerialDenseMatrix_M(self)

    def N(self) -> "int":
        r""" Returns column dimension of system."""
        return _Epetra.IntSerialDenseMatrix_N(self)

    def A(self) -> "int *":
        r""" Returns pointer to the *this* matrix."""
        return _Epetra.IntSerialDenseMatrix_A(self)

    def LDA(self) -> "int":
        r""" Returns the leading dimension of the *this* matrix."""
        return _Epetra.IntSerialDenseMatrix_LDA(self)

    def CV(self) -> "Epetra_DataAccess":
        r""" Returns the data access mode of the *this* matrix."""
        return _Epetra.IntSerialDenseMatrix_CV(self)

    def __init__(self, *args):
        _Epetra.IntSerialDenseMatrix_swiginit(self, _Epetra.new_IntSerialDenseMatrix(*args))

# Register IntSerialDenseMatrix in _Epetra:
_Epetra.IntSerialDenseMatrix_swigregister(IntSerialDenseMatrix)


def IntSerialDenseMatrix_getattr(self, name):
    if name == "array":
        a = _extractNumPyArrayFromEpetraIntSerialDenseMatrix(self)
#a = a.transpose()
        self.__dict__["array"] = a
        return a
    elif name == "shape":
        return self.array.shape
    elif name == "dtype":
        return self.array.dtype
    raise AttributeError("'%s' not an attribute of IntSerialDenseMatrix" % name)
def IntSerialDenseMatrix_setattr(self, name, value):
    if name == "array":
        raise AttributeError("Cannot change IntSerialDenseMatrix 'array' attribute")
    elif name == "shape":
        self.array.shape = value
    elif name == "dtype":
        raise AttributeError("Cannot change IntSerialDenseMatrix 'dtype' attribute")
    else:
        self.__dict__[name] = value
IntSerialDenseMatrix.__getattr__ = IntSerialDenseMatrix_getattr
IntSerialDenseMatrix.__setattr__ = IntSerialDenseMatrix_setattr
IntSerialDenseMatrix.__getitem__ = lambda self, i: self.array.__getitem__(i)
IntSerialDenseMatrix.__setitem__ = lambda self, i, v: self.array.__setitem__(i,v)
IntSerialDenseMatrix.__len__     = lambda self: self.array.__len__()
IntSerialDenseMatrix.__str__     = lambda self: self.array.__str__()
IntSerialDenseMatrix.A           = lambda self: self.array
class_array_add_math(IntSerialDenseMatrix)
class_array_add_comp(IntSerialDenseMatrix)


def _extractNumPyArrayFromEpetraIntSerialDenseVector(source: "IntSerialDenseVector") -> "PyObject *":
    return _Epetra._extractNumPyArrayFromEpetraIntSerialDenseVector(source)
class IntSerialDenseVector(IntSerialDenseMatrix):
    r"""
     Epetra_IntSerialDenseVector: A class for constructing and using dense vectors. The Epetra_IntSerialDenseVector class enables the construction and use of integer-valued,
        dense vectors.  It derives from the Epetra_IntSerialDenseMatrix class.

    The Epetra_IntSerialDenseVector class is intended to provide convenient vector notation but derives all signficant
    functionality from Epetra_IntSerialDenseMatrix.

    **Constructing Epetra_IntSerialDenseVector Objects**

    There are three Epetra_IntSerialDenseVector constructors.  The first constructs a zero-length object which should be made
    to appropriate length using the Size() or Resize() functions and then filled with the [] or () operators.
    The second constructs an object sized to the dimension specified, which should be filled with the [] or () operators.
    The third is a constructor that accepts user
    data as a 1D array, and the fourth is a copy constructor. The third constructor has
    two data access modes (specified by the Epetra_DataAccess argument):

      *  Copy mode - Allocates memory and makes a copy of the user-provided data. In this case, the
           user data is not needed after construction.
      *  View mode - Creates a "view" of the user data. In this case, the
           user data is required to remain intact for the life of the object.


    Warning: View mode is *extremely* dangerous from a data hiding perspective.
    Therefore, we strongly encourage users to develop code using Copy mode first and
    only use the View mode in a secondary optimization phase.

    **Extracting Data from Epetra_IntSerialDenseVector Objects**

    Once a Epetra_IntSerialDenseVector is constructed, it is possible to view the data via access functions.

    Use of these access functions cam be *extremely* dangerous from a data hiding perspective.

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def Size(self, Length_in: "int") -> "int":
        r"""
        Set length of a Epetra_IntSerialDenseVector object; init values to zero.
           :param In:
                      Length - Length of vector object.

           Allows user to define the dimension of a Epetra_IntSerialDenseVector. This function can
           be called at any point after construction.  Any values that were previously in this object are
           destroyed and the resized vector starts off with all zero values.

           :rtype: int
           :return: Integer error code, set to 0 if successful.
        """
        val = _Epetra.IntSerialDenseVector_Size(self, Length_in)

        if "array" in self.__dict__: del self.__dict__["array"]


        return val


    def Resize(self, Length_in: "int") -> "int":
        r"""
        Resize a Epetra_IntSerialDenseVector object.
           :param In:
                      Length - Length of vector object.

           Allows user to define the dimension of a Epetra_IntSerialDenseVector. This function can
           be called at any point after construction.  Any values that were previously in this object are
           copied into the new size.  If the new shape is smaller than the original, the first Length values
           are copied to the new vector.

           :rtype: int
           :return: Integer error code, set to 0 if successful.
        """
        val = _Epetra.IntSerialDenseVector_Resize(self, Length_in)

        if "array" in self.__dict__: del self.__dict__["array"]


        return val

    __swig_destroy__ = _Epetra.delete_IntSerialDenseVector

    def __call__(self, *args) -> "int const &":
        r"""
        *Overload 1:*
         Element access function.
            The parentheses operator returns the element in the ith row and jth column if A(i,j) is
            specified, the expression A[j][i] (note that i and j are reversed) will return the same element.
            Thus, A(i,j) = A[j][i] for all valid i and j.

            :rtype: int
            :return: Element from the specified row and column.

        		Warning: No bounds checking is done unless Epetra is compiled with HAVE_EPETRA_ARRAY_BOUNDS_CHECK.

        |

        *Overload 2:*
         Element access function.
            Returns the specified element of the vector.
            :rtype: int
            :return: Specified element in vector.

            Warning: No bounds checking is done unless Epetra is compiled with HAVE_EPETRA_ARRAY_BOUNDS_CHECK.
        """
        return _Epetra.IntSerialDenseVector___call__(self, *args)

    def Random(self) -> "int":
        r"""
        Set vector values to random numbers.
        	IntSerialDenseVector uses the random number generator provided by Epetra_Util.
        	The vector values will be set to random values on the interval (0, 2^31 - 1).

           :rtype: int
           :return: Integer error code, set to 0 if successful.
        """
        return _Epetra.IntSerialDenseVector_Random(self)

    def Length(self) -> "int":
        r""" Returns length of vector."""
        return _Epetra.IntSerialDenseVector_Length(self)

    def CV(self) -> "Epetra_DataAccess":
        r""" Returns the data access mode of the *this* vector."""
        return _Epetra.IntSerialDenseVector_CV(self)

    def __init__(self, *args):
        _Epetra.IntSerialDenseVector_swiginit(self, _Epetra.new_IntSerialDenseVector(*args))

# Register IntSerialDenseVector in _Epetra:
_Epetra.IntSerialDenseVector_swigregister(IntSerialDenseVector)


def IntSerialDenseVector_getattr(self, name):
    if name == "array":
        a = _extractNumPyArrayFromEpetraIntSerialDenseVector(self)
        self.__dict__["array"] = a
        return a
    elif name == "shape":
        return self.array.shape
    elif name == "dtype":
        return self.array.dtype
    raise AttributeError("'%s' not an attribute of IntSerialDenseVector" % name)
def IntSerialDenseVector_setattr(self, name, value):
    if name == "array":
        raise AttributeError("Cannot change IntSerialDenseVector 'array' attribute")
    elif name == "shape":
        self.array.shape = value
    elif name == "dtype":
        raise AttributeError("Cannot change IntSerialDenseVector 'dtype' attribute")
    else:
        self.__dict__[name] = value
IntSerialDenseVector.__getattr__ = IntSerialDenseVector_getattr
IntSerialDenseVector.__setattr__ = IntSerialDenseVector_setattr
IntSerialDenseVector.__getitem__ = lambda self, i: self.array.__getitem__(i)
IntSerialDenseVector.__setitem__ = lambda self, i, v: self.array.__setitem__(i,v)
IntSerialDenseVector.__len__     = lambda self: self.array.__len__()
IntSerialDenseVector.__str__     = lambda self: self.array.__str__()
IntSerialDenseVector.Values      = lambda self: self.array
class_array_add_math(IntSerialDenseVector)
class_array_add_comp(IntSerialDenseVector)


class SerialDenseOperator(object):
    r"""
    Epetra_SerialDenseOperator: A pure virtual class for using real-valued double-precision operators. The Epetra_SerialDenseOperator class is a pure virtual class (specifies interface only) that
       enable the use of real-valued double-precision operators. It is currently implemented by the
       Epetra_SerialDenseMatrix, Epetra_SerialDenseSolver and Epetra_SerialDenseSVD classes.


    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Epetra.delete_SerialDenseOperator

    def SetUseTranspose(self, UseTranspose: "bool") -> "int":
        r"""
        If set true, transpose of this operator will be applied. This flag allows the transpose of the given operator to be used implicitly.  Setting this flag
               affects only the Apply() and ApplyInverse() methods.  If the implementation of this interface
        does not support transpose use, this method should return a value of -1.

           :param In:
           	   UseTranspose -If true, multiply by the transpose of operator, otherwise just use operator.

           :rtype: int
           :return: Integer error code, set to 0 if successful.  Set to -1 if this implementation does not support transpose.
        """
        return _Epetra.SerialDenseOperator_SetUseTranspose(self, UseTranspose)

    def Apply(self, X: "SerialDenseMatrix", Y: "SerialDenseMatrix") -> "int":
        r"""
        Returns the result of a Epetra_SerialDenseOperator applied to a Epetra_SerialDenseMatrix X in Y.
           :param In:
           	   X - A Epetra_SerialDenseMatrix to multiply with operator.
           :param Out:
           	   Y -A Epetra_SerialDenseMatrix containing result.

           :rtype: int
           :return: Integer error code, set to 0 if successful.
        """
        return _Epetra.SerialDenseOperator_Apply(self, X, Y)

    def ApplyInverse(self, X: "SerialDenseMatrix", Y: "SerialDenseMatrix") -> "int":
        r"""
        Returns the result of a Epetra_SerialDenseOperator inverse applied to an Epetra_SerialDenseMatrix X in Y.
           :param In:
           	   X - A Epetra_SerialDenseMatrix to solve for.
           :param Out:
           	   Y -A Epetra_SerialDenseMatrix containing result.

           :rtype: int
           :return: Integer error code, set to 0 if successful.
        """
        return _Epetra.SerialDenseOperator_ApplyInverse(self, X, Y)

    def NormInf(self) -> "double":
        r""" Returns the infinity norm of the global matrix."""
        return _Epetra.SerialDenseOperator_NormInf(self)

    def Label(self) -> "char const *":
        r""" Returns a character string describing the operator"""
        return _Epetra.SerialDenseOperator_Label(self)

    def UseTranspose(self) -> "bool":
        r""" Returns the current UseTranspose setting."""
        return _Epetra.SerialDenseOperator_UseTranspose(self)

    def HasNormInf(self) -> "bool":
        r""" Returns true if the *this* object can provide an approximate Inf-norm, false otherwise."""
        return _Epetra.SerialDenseOperator_HasNormInf(self)

    def RowDim(self) -> "int":
        r""" Returns the row dimension of operator"""
        return _Epetra.SerialDenseOperator_RowDim(self)

    def ColDim(self) -> "int":
        r""" Returns the column dimension of operator"""
        return _Epetra.SerialDenseOperator_ColDim(self)

# Register SerialDenseOperator in _Epetra:
_Epetra.SerialDenseOperator_swigregister(SerialDenseOperator)


def _extractNumPyArrayFromEpetraSerialDenseMatrix(source: "SerialDenseMatrix") -> "PyObject *":
    return _Epetra._extractNumPyArrayFromEpetraSerialDenseMatrix(source)
class SerialDenseMatrix(CompObject, Object, SerialDenseOperator, BLAS):
    r"""
     Epetra_SerialDenseMatrix: A class for constructing and using real double precision general dense matrices. The Epetra_SerialDenseMatrix class enables the construction and use of real-valued, general,
        double-precision dense matrices.  It is built on the BLAS, and derives from the Epetra_BLAS.

    The Epetra_SerialDenseMatrix class is intended to provide very basic support for dense rectangular matrices.


    **Constructing Epetra_SerialDenseMatrix Objects**

    There are four Epetra_SerialDenseMatrix constructors.  The first constructs a zero-sized object which should be made
    to appropriate length using the Shape() or Reshape() functions and then filled with the [] or () operators.
    The second constructs an object sized to the dimensions specified, which should be filled with the [] or () operators.
    The third is a constructor that accepts user
    data as a 2D array, and the fourth is a copy constructor. The third constructor has
    two data access modes (specified by the Epetra_DataAccess argument):

      *  Copy mode - Allocates memory and makes a copy of the user-provided data. In this case, the
           user data is not needed after construction.
      *  View mode - Creates a "view" of the user data. In this case, the
           user data is required to remain intact for the life of the object.


    Warning: View mode is *extremely* dangerous from a data hiding perspective.
    Therefore, we strongly encourage users to develop code using Copy mode first and
    only use the View mode in a secondary optimization phase.

    **Extracting Data from Epetra_SerialDenseMatrix Objects**

    Once a Epetra_SerialDenseMatrix is constructed, it is possible to view the data via access functions.

    Use of these access functions cam be *extremely* dangerous from a data hiding perspective.


    **Vector and Utility Functions**

    Once a Epetra_SerialDenseMatrix is constructed, several mathematical functions can be applied to
    the object.  Specifically:

      *  Multiplication.
      *  Norms.


    **Counting floating point operations **
    The Epetra_SerialDenseMatrix class has Epetra_CompObject as a base class.  Thus, floating point operations
    are counted and accumulated in the Epetra_Flop object (if any) that was set using the SetFlopCounter()
    method in the Epetra_CompObject base class.

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    __swig_destroy__ = _Epetra.delete_SerialDenseMatrix

    def Shape(self, NumRows: "int", NumCols: "int") -> "int":
        r"""
        Set dimensions of a Epetra_SerialDenseMatrix object; init values to zero.
           :param In:
                      NumRows - Number of rows in object.
           :param In:
                      NumCols - Number of columns in object.

           Allows user to define the dimensions of a Epetra_SerialDenseMatrix at any point. This function can
           be called at any point after construction.  Any values that were previously in this object are
           destroyed and the resized matrix starts off with all zero values.

           :rtype: int
           :return: Integer error code, set to 0 if successful.
        """
        val = _Epetra.SerialDenseMatrix_Shape(self, NumRows, NumCols)

        if "array" in self.__dict__: del self.__dict__["array"]


        return val


    def Reshape(self, NumRows: "int", NumCols: "int") -> "int":
        r"""
        Reshape a Epetra_SerialDenseMatrix object.
           :param In:
                      NumRows - Number of rows in object.
           :param In:
                      NumCols - Number of columns in object.

           Allows user to define the dimensions of a Epetra_SerialDenseMatrix at any point. This function can
           be called at any point after construction.  Any values that were previously in this object are
           copied into the new shape.  If the new shape is smaller than the original, the upper left portion
           of the original matrix (the principal submatrix) is copied to the new matrix.

           :rtype: int
           :return: Integer error code, set to 0 if successful.
        """
        val = _Epetra.SerialDenseMatrix_Reshape(self, NumRows, NumCols)

        if "array" in self.__dict__: del self.__dict__["array"]


        return val


    def Multiply(self, *args) -> "int":
        r"""
        *Overload 1:*
         Matrix-Matrix multiplication, *this* = ScalarThis**this* + ScalarAB*A*B. This function performs a variety of matrix-matrix multiply operations.

          :param In:
                     TransA - Operate with the transpose of A if = 'T', else no transpose if = 'N'.
          :param In:
                     TransB - Operate with the transpose of B if = 'T', else no transpose if = 'N'.

          :param In:
                     ScalarAB - Scalar to multiply with A*B.
          :param In:
                     A - Dense Matrix.
          :param In:
                     B - Dense Matrix.
          :param In:
                     ScalarThis - Scalar to multiply with *this*.

            :rtype: int
            :return: Integer error code, set to 0 if successful.


        |

        *Overload 2:*
         Matrix-Vector multiplication, y = A*x, where 'this' == A.

        |

        *Overload 3:*
         Matrix-Matrix multiplication with a symmetric matrix A. If SideA = 'L', compute *this* = ScalarThis**this* + ScalarAB*A*B.
              If SideA = 'R', compute *this* = ScalarThis**this* + ScalarAB*B*A.

        This function performs a variety of matrix-matrix multiply operations.

          :param In:
                     SideA - Specifies order of A relative to B.

          :param In:
                     ScalarAB - Scalar to multiply with A*B.
          :param In:
                     A - Symmetric Dense Matrix, either upper or lower triangle will be used depending on
            	 value of A.Upper().
          :param In:
                     B - Dense Matrix.
          :param In:
                     ScalarThis - Scalar to multiply with *this*.

            :rtype: int
            :return: Integer error code, set to 0 if successful.
        """
        return _Epetra.SerialDenseMatrix_Multiply(self, *args)

    def Scale(self, ScalarA: "double") -> "int":
        r"""
        Inplace scalar-matrix product A = *a* A. Scale a matrix, entry-by-entry using the value ScalarA.


         :type ScalarA: float
         :param ScalarA: (In) Scalar to multiply with A.

          :rtype: int
          :return: Integer error code, set to 0 if successful.
        """
        return _Epetra.SerialDenseMatrix_Scale(self, ScalarA)

    def NormOne(self) -> "double":
        r"""
        Computes the 1-Norm of the *this* matrix.
           :rtype: float
           :return: Integer error code, set to 0 if successful.
        """
        return _Epetra.SerialDenseMatrix_NormOne(self)

    def NormInf(self) -> "double":
        r""" Computes the Infinity-Norm of the *this* matrix."""
        return _Epetra.SerialDenseMatrix_NormInf(self)

    def __eq__(self, rhs: "SerialDenseMatrix") -> "bool":
        r"""
        Comparison operator. operator== compares two Epetra_SerialDenseMatrix objects, returns false if sizes are different,
             or if any coefficients differ by an amount greater than Epetra_MinDouble.
        """
        return _Epetra.SerialDenseMatrix___eq__(self, rhs)

    def __ne__(self, rhs: "SerialDenseMatrix") -> "bool":
        r""" Inequality operator operator!= simply returns the negation of operator==."""
        return _Epetra.SerialDenseMatrix___ne__(self, rhs)

    def __iadd__(self, Source: "SerialDenseMatrix") -> "Epetra_SerialDenseMatrix &":
        r"""
        Add one matrix to another.
           The operator+= allows one to add the values from one existin SerialDenseMatrix to another, as
           long as there is enough room in the target to hold the source.

           :rtype: :py:class:`Epetra_SerialDenseMatrix`
           :return: Values of the left hand side matrix are modified by the addition
               of the values of the right hand side matrix.
        """
        return _Epetra.SerialDenseMatrix___iadd__(self, Source)

    def __call__(self, RowIndex: "int", ColIndex: "int") -> "double const &":
        r"""
        Element access function.
           The parentheses operator returns the element in the ith row and jth column if A(i,j) is
           specified, the expression A[j][i] (note that i and j are reversed) will return the same element.
           Thus, A(i,j) = A[j][i] for all valid i and j.

           :rtype: float
           :return: Element from the specified row and column.

        	Warning: No bounds checking is done unless Epetra is compiled with HAVE_EPETRA_ARRAY_BOUNDS_CHECK.
        """
        return _Epetra.SerialDenseMatrix___call__(self, RowIndex, ColIndex)

    def Random(self) -> "int":
        r"""
         Set matrix values to random numbers.
        		SerialDenseMatrix uses the random number generator provided by Epetra_Util.
        		The matrix values will be set to random values on the interval (-1.0, 1.0).

        		:rtype: int
        :return: Integer error code, set to 0 if successful.
        """
        return _Epetra.SerialDenseMatrix_Random(self)

    def M(self) -> "int":
        r""" Returns row dimension of system."""
        return _Epetra.SerialDenseMatrix_M(self)

    def N(self) -> "int":
        r""" Returns column dimension of system."""
        return _Epetra.SerialDenseMatrix_N(self)

    def A(self) -> "double *":
        r""" Returns pointer to the *this* matrix."""
        return _Epetra.SerialDenseMatrix_A(self)

    def LDA(self) -> "int":
        r""" Returns the leading dimension of the *this* matrix."""
        return _Epetra.SerialDenseMatrix_LDA(self)

    def CV(self) -> "Epetra_DataAccess":
        r""" Returns the data access mode of the *this* matrix."""
        return _Epetra.SerialDenseMatrix_CV(self)

    def OneNorm(self) -> "double":
        r"""
        Computes the 1-Norm of the *this* matrix (identical to NormOne() method).
           :rtype: float
           :return: Integer error code, set to 0 if successful.
        """
        return _Epetra.SerialDenseMatrix_OneNorm(self)

    def InfNorm(self) -> "double":
        r""" Computes the Infinity-Norm of the *this* matrix (identical to NormInf() method)."""
        return _Epetra.SerialDenseMatrix_InfNorm(self)

    def SetUseTranspose(self, UseTranspose_in: "bool") -> "int":
        r"""
        If set true, transpose of this operator will be applied. This flag allows the transpose of the given operator to be used implicitly.  Setting this flag
               affects only the Apply() and ApplyInverse() methods.  If the implementation of this interface
               does not support transpose use, this method should return a value of -1.

           :param In:
                      UseTranspose -If true, multiply by the transpose of operator, otherwise just use operator.

           :rtype: int
           :return: Integer error code, set to 0 if successful.  Set to -1 if this implementation does not support transpose.
        """
        return _Epetra.SerialDenseMatrix_SetUseTranspose(self, UseTranspose_in)

    def Apply(self, X: "SerialDenseMatrix", Y: "SerialDenseMatrix") -> "int":
        r"""
        Returns the result of a Epetra_SerialDenseOperator applied to a Epetra_SerialDenseMatrix X in Y.
           :param In:
                      X - A Epetra_SerialDenseMatrix to multiply with operator.
           :param Out:
                      Y -A Epetra_SerialDenseMatrix containing result.

           :rtype: int
           :return: Integer error code, set to 0 if successful.
        """
        return _Epetra.SerialDenseMatrix_Apply(self, X, Y)

    def ApplyInverse(self, X: "SerialDenseMatrix", Y: "SerialDenseMatrix") -> "int":
        r"""
        Returns the result of a Epetra_SerialDenseOperator inverse applied to an Epetra_SerialDenseMatrix X in Y.
           :param In:
                      X - A Epetra_SerialDenseMatrix to solve for.
           :param Out:
                      Y -A Epetra_SerialDenseMatrix containing result.

           :rtype: int
           :return: Integer error code, set to 0 if successful.
        """
        return _Epetra.SerialDenseMatrix_ApplyInverse(self, X, Y)

    def Label(self) -> "char const *":
        r""" Returns a character string describing the operator"""
        return _Epetra.SerialDenseMatrix_Label(self)

    def UseTranspose(self) -> "bool":
        r""" Returns the current UseTranspose setting."""
        return _Epetra.SerialDenseMatrix_UseTranspose(self)

    def HasNormInf(self) -> "bool":
        r""" Returns true if the *this* object can provide an approximate Inf-norm, false otherwise."""
        return _Epetra.SerialDenseMatrix_HasNormInf(self)

    def RowDim(self) -> "int":
        r""" Returns the row dimension of operator"""
        return _Epetra.SerialDenseMatrix_RowDim(self)

    def ColDim(self) -> "int":
        r""" Returns the column dimension of operator"""
        return _Epetra.SerialDenseMatrix_ColDim(self)

    def __init__(self, *args):
        _Epetra.SerialDenseMatrix_swiginit(self, _Epetra.new_SerialDenseMatrix(*args))

# Register SerialDenseMatrix in _Epetra:
_Epetra.SerialDenseMatrix_swigregister(SerialDenseMatrix)


def SerialDenseMatrix_getattr(self, name):
    if name == "array":
        a = _extractNumPyArrayFromEpetraSerialDenseMatrix(self)
#a = a.transpose()
        self.__dict__["array"] = a
        return a
    elif name == "shape":
        return self.array.shape
    elif name == "dtype":
        return self.array.dtype
    raise AttributeError("'%s' not an attribute of SerialDenseMatrix" % name)
def SerialDenseMatrix_setattr(self, name, value):
    if name == "array":
        raise AttributeError("Cannot change SerialDenseMatrix 'array' attribute")
    elif name == "shape":
        self.array.shape = value
    elif name == "dtype":
        raise AttributeError("Cannot change SerialDenseMatrix 'dtype' attribute")
    else:
        self.__dict__[name] = value
SerialDenseMatrix.__getattr__ = SerialDenseMatrix_getattr
SerialDenseMatrix.__setattr__ = SerialDenseMatrix_setattr
SerialDenseMatrix.__getitem__ = lambda self, i: self.array.__getitem__(i)
SerialDenseMatrix.__setitem__ = lambda self, i, v: self.array.__setitem__(i,v)
SerialDenseMatrix.__len__     = lambda self: self.array.__len__()
SerialDenseMatrix.__str__     = lambda self: self.array.__str__()
SerialDenseMatrix.A           = lambda self: self.array
class_array_add_math(SerialDenseMatrix)
class_array_add_comp(SerialDenseMatrix)


class SerialSymDenseMatrix(SerialDenseMatrix):
    r"""
     Epetra_SerialSymDenseMatrix: A class for constructing and using symmetric positive definite dense matrices. The Epetra_SerialSymDenseMatrix class enables the construction and use of
        real-valued, symmetric positive definite,
        double-precision dense matrices.  It is built on the Epetra_SerialDenseMatrix class which
        in turn is built on the
        BLAS via the Epetra_BLAS class.

    The Epetra_SerialSymDenseMatrix class is intended to provide full-featured support for solving
    linear and eigen system
    problems for symmetric positive definite matrices.  It is written on top of BLAS and LAPACK
    and thus has excellent
    performance and numerical capabilities.  Using this class, one can either perform simple
    factorizations and solves or
    apply all the tricks available in LAPACK to get the best possible solution for very
    ill-conditioned problems.

    **Epetra_SerialSymDenseMatrix vs. Epetra_LAPACK**

    The Epetra_LAPACK class provides access to most of the same functionality as
    Epetra_SerialSymDenseMatrix.
    The primary difference is that Epetra_LAPACK is a "thin" layer on top of
    LAPACK and Epetra_SerialSymDenseMatrix
    attempts to provide easy access to the more sophisticated aspects of
    solving dense linear and eigensystems.

    *  When you should use Epetra_LAPACK:  If you are simply looking for a
         convenient wrapper around the Fortran LAPACK
         routines and you have a well-conditioned problem, you should probably use Epetra_LAPACK directly.
    *  When you should use Epetra_SerialSymDenseMatrix: If you want to (or potentially want to)
         solve ill-conditioned
         problems or want to work with a more object-oriented interface, you should
         probably use Epetra_SerialSymDenseMatrix.



    **Constructing Epetra_SerialSymDenseMatrix Objects**

    There are three Epetra_DenseMatrix constructors.  The first constructs a zero-sized object
    which should be made
    to appropriate length using the Shape() or Reshape() functions and then filled with
    the [] or () operators.
    The second is a constructor that accepts user
    data as a 2D array, the third is a copy constructor. The second constructor has
    two data access modes (specified by the Epetra_DataAccess argument):

      *  Copy mode - Allocates memory and makes a copy of the user-provided data. In this case, the
           user data is not needed after construction.
      *  View mode - Creates a "view" of the user data. In this case, the
           user data is required to remain intact for the life of the object.


    Warning: View mode is *extremely* dangerous from a data hiding perspective.
    Therefore, we strongly encourage users to develop code using Copy mode first and
    only use the View mode in a secondary optimization phase.

    **Extracting Data from Epetra_SerialSymDenseMatrix Objects**

    Once a Epetra_SerialSymDenseMatrix is constructed, it is possible to view the data via access functions.

    Use of these access functions cam be *extremely* dangerous from a data hiding perspective.


    **Vector and Utility Functions**

    Once a Epetra_SerialSymDenseMatrix is constructed, several mathematical functions can be applied to
    the object.  Specifically:

      *  Multiplication.
      *  Norms.


    **Counting floating point operations **
    The Epetra_SerialSymDenseMatrix class has Epetra_CompObject as a base class.  Thus, floating
    point operations
    are counted and accumulated in the Epetra_Flop object (if any) that was set using the SetFlopCounter()
    method in the Epetra_CompObject base class.

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        *Overload 1:*
         Default constructor; defines a zero size object.
            Epetra_SerialSymDenseMatrix objects defined by the default constructor
            should be sized with the Shape()
            or Reshape() functions.
            Values should be defined by using the [] or ()operators.

            Note: By default the active part of the matrix is assumed to be in the lower triangle.
            To set the upper part as active, call SetUpper().
            See Detailed Description section for further discussion.

        |

        *Overload 2:*
         Set object values from two-dimensional array.
            :param In:
                       Epetra_DataAccess - Enumerated type set to Copy or View.
            :param In:
                       A - Pointer to an array of double precision numbers.  The first vector starts at A.
            	   The second vector starts at A+LDA, the third at A+2*LDA, and so on.
            :param In:
                       LDA - The "Leading Dimension", or stride between vectors in memory.
            :param In:
                       NumRowsCols - Number of rows and columns in object.

        	   Note: By default the active part of the matrix is assumed to be in the lower triangle.
        	   To set the upper part as active, call SetUpper().
        	   See Detailed Description section for further discussion.

        |

        *Overload 3:*
         Epetra_SerialSymDenseMatrix copy constructor.
        """
        _Epetra.SerialSymDenseMatrix_swiginit(self, _Epetra.new_SerialSymDenseMatrix(*args))
    __swig_destroy__ = _Epetra.delete_SerialSymDenseMatrix

    def Shape(self, *args) -> "int":
        r"""
        *Overload 1:*
         Set dimensions of a Epetra_SerialDenseMatrix object; init values to zero.
            :param In:
                       NumRows - Number of rows in object.
            :param In:
                       NumCols - Number of columns in object.

        	   Allows user to define the dimensions of a Epetra_SerialDenseMatrix at any point. This function can
        	   be called at any point after construction.  Any values that were previously in this object are
        	   destroyed and the resized matrix starts off with all zero values.

            :rtype: int
            :return: Integer error code, set to 0 if successful.

        |

        *Overload 2:*
         Set dimensions of a Epetra_SerialSymDenseMatrix object; init values to zero.
            :param In:
                       NumRowsCols - Number of rows and columns in object.

        	   Allows user to define the dimensions of a Epetra_DenseMatrix at any point. This function can
        	   be called at any point after construction.  Any values that were previously in this object are
        	   destroyed and the resized matrix starts off with all zero values.

            :rtype: int
            :return: Integer error code, set to 0 if successful.
        """
        val = _Epetra.SerialSymDenseMatrix_Shape(self, *args)

        if "array" in self.__dict__: del self.__dict__["array"]


        return val


    def Reshape(self, *args) -> "int":
        r"""
        *Overload 1:*
         Reshape a Epetra_SerialDenseMatrix object.
            :param In:
                       NumRows - Number of rows in object.
            :param In:
                       NumCols - Number of columns in object.

        	   Allows user to define the dimensions of a Epetra_SerialDenseMatrix at any point. This function can
        	   be called at any point after construction.  Any values that were previously in this object are
        	   copied into the new shape.  If the new shape is smaller than the original, the upper left portion
        	   of the original matrix (the principal submatrix) is copied to the new matrix.

            :rtype: int
            :return: Integer error code, set to 0 if successful.

        |

        *Overload 2:*
         Reshape a Epetra_SerialSymDenseMatrix object.
            :param In:
                       NumRowsCols - Number of rows and columns in object.

        	   Allows user to define the dimensions of a Epetra_SerialSymDenseMatrix at any point. This function can
        	   be called at any point after construction.  Any values that were previously in this object are
        	   copied into the new shape.  If the new shape is smaller than the original, the upper left portion
        	   of the original matrix (the principal submatrix) is copied to the new matrix.

            :rtype: int
            :return: Integer error code, set to 0 if successful.
        """
        val = _Epetra.SerialSymDenseMatrix_Reshape(self, *args)

        if "array" in self.__dict__: del self.__dict__["array"]


        return val


    def SetLower(self) -> "void":
        r""" Specify that the lower triangle of the *this* matrix should be used."""
        return _Epetra.SerialSymDenseMatrix_SetLower(self)

    def SetUpper(self) -> "void":
        r""" Specify that the upper triangle of the *this* matrix should be used."""
        return _Epetra.SerialSymDenseMatrix_SetUpper(self)

    def Upper(self) -> "bool":
        r""" Returns true if upper triangle of *this* matrix has and will be used."""
        return _Epetra.SerialSymDenseMatrix_Upper(self)

    def UPLO(self) -> "char":
        r""" Returns character value of UPLO used by LAPACK routines."""
        return _Epetra.SerialSymDenseMatrix_UPLO(self)

    def Scale(self, ScalarA: "double") -> "int":
        r"""
        Inplace scalar-matrix product A = *a* A. Scale a matrix, entry-by-entry using the value ScalarA.  This method is sensitive to
             the UPLO() parameter.


         :type ScalarA: float
         :param ScalarA: (In) Scalar to multiply with A.

          :rtype: int
          :return: Integer error code, set to 0 if successful.
        """
        return _Epetra.SerialSymDenseMatrix_Scale(self, ScalarA)

    def NormOne(self) -> "double":
        r"""
        Computes the 1-Norm of the *this* matrix.
           :rtype: float
           :return: Integer error code, set to 0 if successful.
        """
        return _Epetra.SerialSymDenseMatrix_NormOne(self)

    def NormInf(self) -> "double":
        r""" Computes the Infinity-Norm of the *this* matrix."""
        return _Epetra.SerialSymDenseMatrix_NormInf(self)

    def CopyUPLOMat(self, Upper: "bool", A: "double *", LDA: "int", NumRows: "int") -> "void":
        return _Epetra.SerialSymDenseMatrix_CopyUPLOMat(self, Upper, A, LDA, NumRows)

    def OneNorm(self) -> "double":
        r"""
        Computes the 1-Norm of the *this* matrix (identical to NormOne() method).
           :rtype: float
           :return: Integer error code, set to 0 if successful.
        """
        return _Epetra.SerialSymDenseMatrix_OneNorm(self)

    def InfNorm(self) -> "double":
        r""" Computes the Infinity-Norm of the *this* matrix (identical to NormInf() method)."""
        return _Epetra.SerialSymDenseMatrix_InfNorm(self)

# Register SerialSymDenseMatrix in _Epetra:
_Epetra.SerialSymDenseMatrix_swigregister(SerialSymDenseMatrix)


def _extractNumPyArrayFromEpetraSerialDenseVector(source: "SerialDenseVector") -> "PyObject *":
    return _Epetra._extractNumPyArrayFromEpetraSerialDenseVector(source)
class SerialDenseVector(SerialDenseMatrix):
    r"""
     Epetra_SerialDenseVector: A class for constructing and using dense vectors. The Epetra_SerialDenseVector class enables the construction and use of real-valued,
        double-precision dense vectors.  It is built on the BLAS and LAPACK and derives from the Epetra_SerialDenseMatrix class.

    The Epetra_SerialDenseVector class is intended to provide convenient vector notation but derives all signficant
    functionality from Epetra_SerialDenseMatrix.

    **Constructing Epetra_SerialDenseVector Objects**

    There are four Epetra_SerialDenseVector constructors.  The first constructs a zero-length object which should be made
    to appropriate length using the Size() or Resize() functions and then filled with the [] or () operators.
    The second constructs an object sized to the dimension specified, which should be filled with the [] or () operators.
    The third is a constructor that accepts user
    data as a 1D array, and the fourth is a copy constructor. The third constructor has
    two data access modes (specified by the Epetra_DataAccess argument):

      *  Copy mode - Allocates memory and makes a copy of the user-provided data. In this case, the
           user data is not needed after construction.
      *  View mode - Creates a "view" of the user data. In this case, the
           user data is required to remain intact for the life of the object.


    Warning: View mode is *extremely* dangerous from a data hiding perspective.
    Therefore, we strongly encourage users to develop code using Copy mode first and
    only use the View mode in a secondary optimization phase.

    **Extracting Data from Epetra_SerialDenseVector Objects**

    Once a Epetra_SerialDenseVector is constructed, it is possible to view the data via access functions.

    Use of these access functions cam be *extremely* dangerous from a data hiding perspective.


    The final useful function is Flops().  Each Epetra_SerialDenseVector object keep track of the number
    of *serial* floating point operations performed using the specified object as the *this* argument
    to the function.  The Flops() function returns this number as a double precision number.  Using this
    information, in conjunction with the Epetra_Time class, one can get accurate parallel performance
    numbers.


    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    __swig_destroy__ = _Epetra.delete_SerialDenseVector

    def Size(self, Length_in: "int") -> "int":
        r"""
        Set length of a Epetra_SerialDenseVector object; init values to zero.
           :param In:
                      Length - Length of vector object.

           Allows user to define the dimension of a Epetra_SerialDenseVector. This function can
           be called at any point after construction.  Any values that were previously in this object are
           destroyed and the resized vector starts off with all zero values.

           :rtype: int
           :return: Integer error code, set to 0 if successful.
        """
        val = _Epetra.SerialDenseVector_Size(self, Length_in)

        if "array" in self.__dict__: del self.__dict__["array"]


        return val


    def Resize(self, Length_in: "int") -> "int":
        r"""
        Resize a Epetra_SerialDenseVector object.
           :param In:
                      Length - Length of vector object.

           Allows user to define the dimension of a Epetra_SerialDenseVector. This function can
           be called at any point after construction.  Any values that were previously in this object are
           copied into the new size.  If the new shape is smaller than the original, the first Length values
           are copied to the new vector.

           :rtype: int
           :return: Integer error code, set to 0 if successful.
        """
        val = _Epetra.SerialDenseVector_Resize(self, Length_in)

        if "array" in self.__dict__: del self.__dict__["array"]


        return val


    def __call__(self, *args) -> "double const &":
        r"""
        *Overload 1:*
         Element access function.
            The parentheses operator returns the element in the ith row and jth column if A(i,j) is
            specified, the expression A[j][i] (note that i and j are reversed) will return the same element.
            Thus, A(i,j) = A[j][i] for all valid i and j.

            :rtype: float
            :return: Element from the specified row and column.

        		Warning: No bounds checking is done unless Epetra is compiled with HAVE_EPETRA_ARRAY_BOUNDS_CHECK.

        |

        *Overload 2:*
         Element access function.
            Returns the specified element of the vector.  Bounds checking is enforced.
            :rtype: float
            :return: Specified element in vector.

            Warning: No bounds checking is done unless Epetra is compiled with HAVE_EPETRA_ARRAY_BOUNDS_CHECK.
        """
        return _Epetra.SerialDenseVector___call__(self, *args)

    def Random(self) -> "int":
        r"""
        Set vector values to random numbers.
        	SerialDenseVector uses the random number generator provided by Epetra_Util.
        	The vector values will be set to random values on the interval (-1.0, 1.0).

           :rtype: int
           :return: Integer error code, set to 0 if successful.
        """
        return _Epetra.SerialDenseVector_Random(self)

    def Dot(self, x: "SerialDenseVector") -> "double":
        r"""
        Compute 1-norm of each vector in multi-vector.
           :type x: :py:class:`Epetra_SerialDenseVector`
           :param x: (In) Input vector x.

           :rtype: float
           :return: Dot-product of the *this* vector and x.
        """
        return _Epetra.SerialDenseVector_Dot(self, x)

    def Norm1(self) -> "double":
        r"""
        Compute 1-norm of each vector in multi-vector.
           :rtype: float
           :return: 1-norm of the vector.
        """
        return _Epetra.SerialDenseVector_Norm1(self)

    def Norm2(self) -> "double":
        r"""
        Compute 2-norm of each vector in multi-vector.
           :param Out:
           :rtype: float
           :return: 2-norm of the vector.
        """
        return _Epetra.SerialDenseVector_Norm2(self)

    def NormInf(self) -> "double":
        r"""
        Compute Inf-norm of each vector in multi-vector.
           :rtype: float
           :return: Infinity-norm of the vector.
        """
        return _Epetra.SerialDenseVector_NormInf(self)

    def Length(self) -> "int":
        r""" Returns length of vector."""
        return _Epetra.SerialDenseVector_Length(self)

    def Values(self) -> "double *":
        r""" Returns pointer to the values in vector."""
        return _Epetra.SerialDenseVector_Values(self)

    def CV(self) -> "Epetra_DataAccess":
        r""" Returns the data access mode of the *this* vector."""
        return _Epetra.SerialDenseVector_CV(self)

    def __init__(self, *args):
        _Epetra.SerialDenseVector_swiginit(self, _Epetra.new_SerialDenseVector(*args))

# Register SerialDenseVector in _Epetra:
_Epetra.SerialDenseVector_swigregister(SerialDenseVector)


def SerialDenseVector_getattr(self, name):
    if name == "array":
        a = _extractNumPyArrayFromEpetraSerialDenseVector(self)
        self.__dict__["array"] = a
        return a
    elif name == "shape":
        return self.array.shape
    elif name == "dtype":
        return self.array.dtype
    raise AttributeError("'%s' not an attribute of SerialDenseVector" % name)
def SerialDenseVector_setattr(self, name, value):
    if name == "array":
        raise AttributeError("Cannot change SerialDenseVector 'array' attribute")
    elif name == "shape":
        self.array.shape = value
    elif name == "dtype":
        raise AttributeError("Cannot change SerialDenseVector 'dtype' attribute")
    else:
        self.__dict__[name] = value
SerialDenseVector.__getattr__ = SerialDenseVector_getattr
SerialDenseVector.__setattr__ = SerialDenseVector_setattr
SerialDenseVector.__getitem__ = lambda self, i: self.array.__getitem__(i)
SerialDenseVector.__setitem__ = lambda self, i, v: self.array.__setitem__(i,v)
SerialDenseVector.__len__     = lambda self: self.array.__len__()
SerialDenseVector.__str__     = lambda self: self.array.__str__()
SerialDenseVector.Values      = lambda self: self.array
class_array_add_math(SerialDenseVector)
class_array_add_comp(SerialDenseVector)


class SerialDenseSolver(CompObject, BLAS, LAPACK, Object):
    r"""
     Epetra_SerialDenseSolver: A class for solving dense linear problems. The Epetra_SerialDenseSolver class enables the definition, in terms of Epetra_SerialDenseMatrix
        and Epetra_SerialDenseVector objects, of a dense linear problem, followed by the solution of that problem via the
        most sophisticated techniques available in LAPACK.

    The Epetra_SerialDenseSolver class is intended to provide full-featured support for solving linear
    problems for general dense rectangular (or square) matrices.  It is written on top of BLAS and LAPACK and thus has excellent
    performance and numerical capabilities.  Using this class, one can either perform simple factorizations and solves or
    apply all the tricks available in LAPACK to get the best possible solution for very ill-conditioned problems.

    **Epetra_SerialDenseSolver vs. Epetra_LAPACK**

    The Epetra_LAPACK class provides access to most of the same functionality as Epetra_SerialDenseSolver.
    The primary difference is that Epetra_LAPACK is a "thin" layer on top of LAPACK and Epetra_SerialDenseSolver
    attempts to provide easy access to the more sophisticated aspects of solving dense linear and eigensystems.

    *  When you should use Epetra_LAPACK:  If you are simply looking for a convenient wrapper around the Fortran LAPACK
         routines and you have a well-conditioned problem, you should probably use Epetra_LAPACK directly.
    *  When you should use Epetra_SerialDenseSolver: If you want to (or potentially want to) solve ill-conditioned
         problems or want to work with a more object-oriented interface, you should probably use Epetra_SerialDenseSolver.



    **Constructing Epetra_SerialDenseSolver Objects**

    There is a single Epetra_SerialDenseSolver constructor.   However, the matrix, right hand side and solution
    vectors must be set prior to executing most methods in this class.

    **Setting vectors used for linear solves**

    The matrix A, the left hand side X and the right hand side B (when solving AX = B, for X), can be set by appropriate set
    methods.  Each of these three objects must be an Epetra_SerialDenseMatrix or and Epetra_SerialDenseVector object.  The
    set methods are as follows:

    *  SetMatrix() - Sets the matrix.
    *  SetVectors() - Sets the left and right hand side vector(s).


    **Vector and Utility Functions**

    Once a Epetra_SerialDenseSolver is constructed, several mathematical functions can be applied to
    the object.  Specifically:

      *  Factorizations.
      *  Solves.
      *  Condition estimates.
      *  Equilibration.
      *  Norms.


    **Counting floating point operations **
    The Epetra_SerialDenseSolver class has Epetra_CompObject as a base class.  Thus, floating point operations
    are counted and accumulated in the Epetra_Flop object (if any) that was set using the SetFlopCounter()
    method in the Epetra_CompObject base class.

    **Strategies for Solving Linear Systems**
    In many cases, linear systems can be accurately solved by simply computing the LU factorization
    of the matrix and then performing a forward back solve with a given set of right hand side vectors.  However,
    in some instances, the factorization may be very poorly conditioned and this simple approach may not work.  In
    these situations, equilibration and iterative refinement may improve the accuracy, or prevent a breakdown in
    the factorization.

    Epetra_SerialDenseSolver will use equilibration with the factorization if, once the object
    is constructed and *before* it is factored, you call the function FactorWithEquilibration(true) to force
    equilibration to be used.  If you are uncertain if equilibration should be used, you may call the function
    ShouldEquilibrate() which will return true if equilibration could possibly help.  ShouldEquilibrate() uses
    guidelines specified in the LAPACK User Guide, namely if SCOND < 0.1 and AMAX < Underflow or AMAX > Overflow, to
    determine if equilibration *might* be useful.

    Epetra_SerialDenseSolver will use iterative refinement after a forward/back solve if you call
    SolveToRefinedSolution(true).  It will also compute forward and backward error estimates if you call
    EstimateSolutionErrors(true).  Access to the forward (back) error estimates is available via FERR() (BERR()).

    Examples using Epetra_SerialDenseSolver can be found in the Epetra test directories.

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self):
        r""" Default constructor; matrix should be set using SetMatrix(), LHS and RHS set with SetVectors()."""
        _Epetra.SerialDenseSolver_swiginit(self, _Epetra.new_SerialDenseSolver())
    __swig_destroy__ = _Epetra.delete_SerialDenseSolver

    def SetMatrix(self, A: "SerialDenseMatrix") -> "int":
        r""" Sets the pointers for coefficient matrix"""
        return _Epetra.SerialDenseSolver_SetMatrix(self, A)

    def SetVectors(self, X: "SerialDenseMatrix", B: "SerialDenseMatrix") -> "int":
        r"""
        Sets the pointers for left and right hand side vector(s). Row dimension of X must match column dimension of matrix A, row dimension of B
             must match row dimension of A.  X and B must have the same dimensions.
        """
        return _Epetra.SerialDenseSolver_SetVectors(self, X, B)

    def FactorWithEquilibration(self, Flag: "bool") -> "void":
        r""" Causes equilibration to be called just before the matrix factorization as part of the call to Factor. This function must be called before the factorization is performed."""
        return _Epetra.SerialDenseSolver_FactorWithEquilibration(self, Flag)

    def SolveWithTranspose(self, Flag: "bool") -> "void":
        r""" If Flag is true, causes all subsequent function calls to work with the transpose of *this* matrix, otherwise not."""
        return _Epetra.SerialDenseSolver_SolveWithTranspose(self, Flag)

    def SolveToRefinedSolution(self, Flag: "bool") -> "void":
        r""" Causes all solves to compute solution to best ability using iterative refinement."""
        return _Epetra.SerialDenseSolver_SolveToRefinedSolution(self, Flag)

    def EstimateSolutionErrors(self, Flag: "bool") -> "void":
        r"""
        Causes all solves to estimate the forward and backward solution error. Error estimates will be in the arrays FERR and BERR, resp, after the solve step is complete.
             These arrays are accessible via the FERR() and BERR() access functions.
        """
        return _Epetra.SerialDenseSolver_EstimateSolutionErrors(self, Flag)

    def Factor(self) -> "int":
        r"""
        Computes the in-place LU factorization of the matrix using the LAPACK routine *DGETRF*.
           :rtype: int
           :return: Integer error code, set to 0 if successful.
        """
        return _Epetra.SerialDenseSolver_Factor(self)

    def Solve(self) -> "int":
        r"""
        Computes the solution X to AX = B for the *this* matrix and the B provided to SetVectors()..
           :rtype: int
           :return: Integer error code, set to 0 if successful.
        """
        return _Epetra.SerialDenseSolver_Solve(self)

    def Invert(self) -> "int":
        r"""
        Inverts the *this* matrix.
           :rtype: int
           :return: Integer error code, set to 0 if successful. Otherwise returns the LAPACK error code INFO.
        """
        return _Epetra.SerialDenseSolver_Invert(self)

    def ComputeEquilibrateScaling(self) -> "int":
        r"""
        Computes the scaling vector S(i) = 1/sqrt(A(i,i)) of the *this* matrix.
           :rtype: int
           :return: Integer error code, set to 0 if successful. Otherwise returns the LAPACK error code INFO.
        """
        return _Epetra.SerialDenseSolver_ComputeEquilibrateScaling(self)

    def EquilibrateMatrix(self) -> "int":
        r"""
        Equilibrates the *this* matrix.
           :rtype: int
           :return: Integer error code, set to 0 if successful. Otherwise returns the LAPACK error code INFO.
        """
        return _Epetra.SerialDenseSolver_EquilibrateMatrix(self)

    def EquilibrateRHS(self) -> "int":
        r"""
        Equilibrates the current RHS.
           :rtype: int
           :return: Integer error code, set to 0 if successful. Otherwise returns the LAPACK error code INFO.
        """
        return _Epetra.SerialDenseSolver_EquilibrateRHS(self)

    def ApplyRefinement(self) -> "int":
        r"""
        Apply Iterative Refinement.
           :rtype: int
           :return: Integer error code, set to 0 if successful. Otherwise returns the LAPACK error code INFO.
        """
        return _Epetra.SerialDenseSolver_ApplyRefinement(self)

    def UnequilibrateLHS(self) -> "int":
        r"""
        Unscales the solution vectors if equilibration was used to solve the system.
           :rtype: int
           :return: Integer error code, set to 0 if successful. Otherwise returns the LAPACK error code INFO.
        """
        return _Epetra.SerialDenseSolver_UnequilibrateLHS(self)

    def Transpose(self) -> "bool":
        r""" Returns true if transpose of *this* matrix has and will be used."""
        return _Epetra.SerialDenseSolver_Transpose(self)

    def Factored(self) -> "bool":
        r""" Returns true if matrix is factored (factor available via AF() and LDAF())."""
        return _Epetra.SerialDenseSolver_Factored(self)

    def A_Equilibrated(self) -> "bool":
        r""" Returns true if factor is equilibrated (factor available via AF() and LDAF())."""
        return _Epetra.SerialDenseSolver_A_Equilibrated(self)

    def B_Equilibrated(self) -> "bool":
        r""" Returns true if RHS is equilibrated (RHS available via B() and LDB())."""
        return _Epetra.SerialDenseSolver_B_Equilibrated(self)

    def ShouldEquilibrate(self) -> "bool":
        r""" Returns true if the LAPACK general rules for equilibration suggest you should equilibrate the system."""
        return _Epetra.SerialDenseSolver_ShouldEquilibrate(self)

    def SolutionErrorsEstimated(self) -> "bool":
        r""" Returns true if forward and backward error estimated have been computed (available via FERR() and BERR())."""
        return _Epetra.SerialDenseSolver_SolutionErrorsEstimated(self)

    def Inverted(self) -> "bool":
        r""" Returns true if matrix inverse has been computed (inverse available via AF() and LDAF())."""
        return _Epetra.SerialDenseSolver_Inverted(self)

    def ReciprocalConditionEstimated(self) -> "bool":
        r""" Returns true if the condition number of the *this* matrix has been computed (value available via ReciprocalConditionEstimate())."""
        return _Epetra.SerialDenseSolver_ReciprocalConditionEstimated(self)

    def Solved(self) -> "bool":
        r""" Returns true if the current set of vectors has been solved."""
        return _Epetra.SerialDenseSolver_Solved(self)

    def SolutionRefined(self) -> "bool":
        r""" Returns true if the current set of vectors has been refined."""
        return _Epetra.SerialDenseSolver_SolutionRefined(self)

    def Matrix(self) -> "Epetra_SerialDenseMatrix *":
        r""" Returns pointer to current matrix."""
        return _Epetra.SerialDenseSolver_Matrix(self)

    def FactoredMatrix(self) -> "Epetra_SerialDenseMatrix *":
        r""" Returns pointer to factored matrix (assuming factorization has been performed)."""
        return _Epetra.SerialDenseSolver_FactoredMatrix(self)

    def LHS(self) -> "Epetra_SerialDenseMatrix *":
        r""" Returns pointer to current LHS."""
        return _Epetra.SerialDenseSolver_LHS(self)

    def RHS(self) -> "Epetra_SerialDenseMatrix *":
        r""" Returns pointer to current RHS."""
        return _Epetra.SerialDenseSolver_RHS(self)

    def M(self) -> "int":
        r""" Returns row dimension of system."""
        return _Epetra.SerialDenseSolver_M(self)

    def N(self) -> "int":
        r""" Returns column dimension of system."""
        return _Epetra.SerialDenseSolver_N(self)

    def LDA(self) -> "int":
        r""" Returns the leading dimension of the *this* matrix."""
        return _Epetra.SerialDenseSolver_LDA(self)

    def LDB(self) -> "int":
        r""" Returns the leading dimension of the RHS."""
        return _Epetra.SerialDenseSolver_LDB(self)

    def NRHS(self) -> "int":
        r""" Returns the number of current right hand sides and solution vectors."""
        return _Epetra.SerialDenseSolver_NRHS(self)

    def LDX(self) -> "int":
        r""" Returns the leading dimension of the solution."""
        return _Epetra.SerialDenseSolver_LDX(self)

    def LDAF(self) -> "int":
        r""" Returns the leading dimension of the factored matrix."""
        return _Epetra.SerialDenseSolver_LDAF(self)

    def ANORM(self) -> "double":
        r""" Returns the 1-Norm of the *this* matrix (returns -1 if not yet computed)."""
        return _Epetra.SerialDenseSolver_ANORM(self)

    def RCOND(self) -> "double":
        r""" Returns the reciprocal of the condition number of the *this* matrix (returns -1 if not yet computed)."""
        return _Epetra.SerialDenseSolver_RCOND(self)

    def ROWCND(self) -> "double":
        r""" Ratio of smallest to largest row scale factors for the *this* matrix (returns -1 if not yet computed). If ROWCND() is >= 0.1 and AMAX() is not close to overflow or underflow, then equilibration is not needed."""
        return _Epetra.SerialDenseSolver_ROWCND(self)

    def COLCND(self) -> "double":
        r""" Ratio of smallest to largest column scale factors for the *this* matrix (returns -1 if not yet computed). If COLCND() is >= 0.1 then equilibration is not needed."""
        return _Epetra.SerialDenseSolver_COLCND(self)

    def AMAX(self) -> "double":
        r""" Returns the absolute value of the largest entry of the *this* matrix (returns -1 if not yet computed)."""
        return _Epetra.SerialDenseSolver_AMAX(self)

    def IPIV(self) -> "PyObject *":
        return _Epetra.SerialDenseSolver_IPIV(self)

    def A(self) -> "PyObject *":
        return _Epetra.SerialDenseSolver_A(self)

    def B(self) -> "PyObject *":
        return _Epetra.SerialDenseSolver_B(self)

    def X(self) -> "PyObject *":
        return _Epetra.SerialDenseSolver_X(self)

    def AF(self) -> "PyObject *":
        return _Epetra.SerialDenseSolver_AF(self)

    def FERR(self) -> "PyObject *":
        return _Epetra.SerialDenseSolver_FERR(self)

    def BERR(self) -> "PyObject *":
        return _Epetra.SerialDenseSolver_BERR(self)

    def R(self) -> "PyObject *":
        return _Epetra.SerialDenseSolver_R(self)

    def C(self) -> "PyObject *":
        return _Epetra.SerialDenseSolver_C(self)

    def ReciprocalConditionEstimate(self) -> "double":
        return _Epetra.SerialDenseSolver_ReciprocalConditionEstimate(self)

# Register SerialDenseSolver in _Epetra:
_Epetra.SerialDenseSolver_swigregister(SerialDenseSolver)

class SerialDenseSVD(SerialDenseOperator, CompObject, Object, BLAS, LAPACK):
    r"""
     Epetra_SerialDenseSVD: A class for SVDing dense linear problems. The Epetra_SerialDenseSVD class enables the definition, in terms of Epetra_SerialDenseMatrix
        and Epetra_SerialDenseVector objects, of a dense linear problem, followed by the solution of that problem via the
        most sophisticated techniques available in LAPACK.

    The Epetra_SerialDenseSVD class is intended to provide full-featured support for solving linear
    problems for general dense rectangular (or square) matrices.  It is written on top of BLAS and LAPACK and thus has excellent
    performance and numerical capabilities.  Using this class, one can either perform simple factorizations and solves or
    apply all the tricks available in LAPACK to get the best possible solution for very ill-conditioned problems.

    **Epetra_SerialDenseSVD vs. Epetra_LAPACK**

    The Epetra_LAPACK class provides access to most of the same functionality as Epetra_SerialDenseSolver.
    The primary difference is that Epetra_LAPACK is a "thin" layer on top of LAPACK and Epetra_SerialDenseSolver
    attempts to provide easy access to the more sophisticated aspects of solving dense linear and eigensystems.

    *  When you should use Epetra_LAPACK:  If you are simply looking for a convenient wrapper around the Fortran LAPACK
         routines and you have a well-conditioned problem, you should probably use Epetra_LAPACK directly.
    *  When you should use Epetra_SerialDenseSolver: If you want to (or potentially want to) solve ill-conditioned
         problems or want to work with a more object-oriented interface, you should probably use Epetra_SerialDenseSolver.



    **Constructing Epetra_SerialDenseSVD Objects**

    There is a single Epetra_SerialDenseSVD constructor.   However, the matrix, right hand side and solution
    vectors must be set prior to executing most methods in this class.

    **Setting vectors used for linear solves**

    The matrix A, the left hand side X and the right hand side B (when solving AX = B, for X), can be set by appropriate set
    methods.  Each of these three objects must be an Epetra_SerialDenseMatrix or and Epetra_SerialDenseVector object.  The
    set methods are as follows:

    *  SetMatrix() - Sets the matrix.
    *  SetVectors() - Sets the left and right hand side vector(s).


    **Vector and Utility Functions**

    Once a Epetra_SerialDenseSVD is constructed, several mathematical functions can be applied to
    the object.  Specifically:

      *  Factorizations.
      *  Solves.
      *  Condition estimates.
      *  Norms.


    **Counting floating point operations **
    The Epetra_SerialDenseSVD class has Epetra_CompObject as a base class.  Thus, floating point operations
    are counted and accumulated in the Epetra_Flop object (if any) that was set using the SetFlopCounter()
    method in the Epetra_CompObject base class.

    Examples using Epetra_SerialDenseSVD can be found in the Epetra test directories.

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self):
        r""" Default constructor; matrix should be set using SetMatrix(), LHS and RHS set with SetVectors()."""
        _Epetra.SerialDenseSVD_swiginit(self, _Epetra.new_SerialDenseSVD())
    __swig_destroy__ = _Epetra.delete_SerialDenseSVD

    def SetMatrix(self, A: "SerialDenseMatrix") -> "int":
        r""" Sets the pointers for coefficient matrix"""
        return _Epetra.SerialDenseSVD_SetMatrix(self, A)

    def SetVectors(self, X: "SerialDenseMatrix", B: "SerialDenseMatrix") -> "int":
        r"""
        Sets the pointers for left and right hand side vector(s). Row dimension of X must match column dimension of matrix A, row dimension of B
             must match row dimension of A.  X and B must have the same dimensions.
        """
        return _Epetra.SerialDenseSVD_SetVectors(self, X, B)

    def SolveWithTranspose(self, Flag: "bool") -> "void":
        r"""
        Causes equilibration to be called just before the matrix factorization as part of the call to Factor. This function must be called before the factorization is performed.
           If Flag is true, causes all subsequent function calls to work with the transpose of *this* matrix, otherwise not.
        """
        return _Epetra.SerialDenseSVD_SolveWithTranspose(self, Flag)

    def Factor(self) -> "int":
        r""" Causes all solves to compute solution to best ability using iterative refinement."""
        return _Epetra.SerialDenseSVD_Factor(self)

    def Solve(self) -> "int":
        r"""
        Computes the solution X to AX = B for the *this* matrix and the B provided to SetVectors().. Inverse of Matrix must be formed
           :rtype: int
           :return: Integer error code, set to 0 if successful.
        """
        return _Epetra.SerialDenseSVD_Solve(self)

    def Invert(self, rthresh: "double"=0.0, athresh: "double"=0.0) -> "int":
        r"""
        Inverts the *this* matrix.
           :rtype: int
           :return: Integer error code, set to 0 if successful. Otherwise returns the LAPACK error code INFO.
        """
        return _Epetra.SerialDenseSVD_Invert(self, rthresh, athresh)

    def Transpose(self) -> "bool":
        r""" Returns true if transpose of *this* matrix has and will be used."""
        return _Epetra.SerialDenseSVD_Transpose(self)

    def Factored(self) -> "bool":
        r""" Returns true if matrix is factored (factor available via AF() and LDAF())."""
        return _Epetra.SerialDenseSVD_Factored(self)

    def Inverted(self) -> "bool":
        r""" Returns true if matrix inverse has been computed (inverse available via AF() and LDAF())."""
        return _Epetra.SerialDenseSVD_Inverted(self)

    def Solved(self) -> "bool":
        r""" Returns true if the current set of vectors has been solved."""
        return _Epetra.SerialDenseSVD_Solved(self)

    def Matrix(self) -> "Epetra_SerialDenseMatrix *":
        r""" Returns pointer to current matrix."""
        return _Epetra.SerialDenseSVD_Matrix(self)

    def InvertedMatrix(self) -> "Epetra_SerialDenseMatrix *":
        r""" Returns pointer to inverted matrix (assuming inverse has been performed)."""
        return _Epetra.SerialDenseSVD_InvertedMatrix(self)

    def LHS(self) -> "Epetra_SerialDenseMatrix *":
        r""" Returns pointer to current LHS."""
        return _Epetra.SerialDenseSVD_LHS(self)

    def RHS(self) -> "Epetra_SerialDenseMatrix *":
        r""" Returns pointer to current RHS."""
        return _Epetra.SerialDenseSVD_RHS(self)

    def M(self) -> "int":
        r""" Returns row dimension of system."""
        return _Epetra.SerialDenseSVD_M(self)

    def N(self) -> "int":
        r""" Returns column dimension of system."""
        return _Epetra.SerialDenseSVD_N(self)

    def A(self) -> "double *":
        r""" Returns pointer to the *this* matrix."""
        return _Epetra.SerialDenseSVD_A(self)

    def LDA(self) -> "int":
        r""" Returns the leading dimension of the *this* matrix."""
        return _Epetra.SerialDenseSVD_LDA(self)

    def B(self) -> "double *":
        r""" Returns pointer to current RHS."""
        return _Epetra.SerialDenseSVD_B(self)

    def LDB(self) -> "int":
        r""" Returns the leading dimension of the RHS."""
        return _Epetra.SerialDenseSVD_LDB(self)

    def NRHS(self) -> "int":
        r""" Returns the number of current right hand sides and solution vectors."""
        return _Epetra.SerialDenseSVD_NRHS(self)

    def X(self) -> "double *":
        r""" Returns pointer to current solution."""
        return _Epetra.SerialDenseSVD_X(self)

    def LDX(self) -> "int":
        r""" Returns the leading dimension of the solution."""
        return _Epetra.SerialDenseSVD_LDX(self)

    def S(self) -> "double *":
        return _Epetra.SerialDenseSVD_S(self)

    def AI(self) -> "double *":
        r""" Returns pointer to the inverted matrix (may be the same as A() if factorization done in place)."""
        return _Epetra.SerialDenseSVD_AI(self)

    def LDAI(self) -> "int":
        r""" Returns the leading dimension of the inverted matrix."""
        return _Epetra.SerialDenseSVD_LDAI(self)

    def ANORM(self) -> "double":
        r""" Returns the 1-Norm of the *this* matrix (returns -1 if not yet computed)."""
        return _Epetra.SerialDenseSVD_ANORM(self)

    def SetUseTranspose(self, use_transpose: "bool") -> "int":
        r"""
        If set true, transpose of this operator will be applied. This flag allows the transpose of the given operator to be used implicitly.  Setting this flag
               affects only the Apply() and ApplyInverse() methods.  If the implementation of this interface
        does not support transpose use, this method should return a value of -1.

           :param In:
           	   use_transpose -If true, multiply by the transpose of operator, otherwise just use operator.

           :rtype: int
           :return: Integer error code, set to 0 if successful.  Set to -1 if this implementation does not support transpose.
        """
        return _Epetra.SerialDenseSVD_SetUseTranspose(self, use_transpose)

    def Apply(self, Xmat: "SerialDenseMatrix", Ymat: "SerialDenseMatrix") -> "int":
        r"""
        Returns the result of a Epetra_SerialDenseOperator applied to a Epetra_SerialDenseMatrix X in Y.
           :param In:
           	   X - A Epetra_SerialDenseMatrix to multiply with operator.
           :param Out:
           	   Y -A Epetra_SerialDenseMatrix containing result.

           :rtype: int
           :return: Integer error code, set to 0 if successful.
        """
        return _Epetra.SerialDenseSVD_Apply(self, Xmat, Ymat)

    def ApplyInverse(self, Xmat: "SerialDenseMatrix", Ymat: "SerialDenseMatrix") -> "int":
        r"""
        Returns the result of a Epetra_SerialDenseOperator inverse applied to an Epetra_SerialDenseMatrix X in Y.
           :param In:
           	   X - A Epetra_SerialDenseMatrix to solve for.
           :param Out:
           	   Y -A Epetra_SerialDenseMatrix containing result.

           :rtype: int
           :return: Integer error code, set to 0 if successful.
        """
        return _Epetra.SerialDenseSVD_ApplyInverse(self, Xmat, Ymat)

    def NormInf(self) -> "double":
        r""" Returns the infinity norm of the global matrix."""
        return _Epetra.SerialDenseSVD_NormInf(self)

    def Label(self) -> "char const *":
        r""" Returns a character string describing the operator"""
        return _Epetra.SerialDenseSVD_Label(self)

    def UseTranspose(self) -> "bool":
        r""" Returns the current UseTranspose setting."""
        return _Epetra.SerialDenseSVD_UseTranspose(self)

    def HasNormInf(self) -> "bool":
        r""" Returns true if the *this* object can provide an approximate Inf-norm, false otherwise."""
        return _Epetra.SerialDenseSVD_HasNormInf(self)

    def RowDim(self) -> "int":
        r""" Returns the row dimension of operator"""
        return _Epetra.SerialDenseSVD_RowDim(self)

    def ColDim(self) -> "int":
        r""" Returns the column dimension of operator"""
        return _Epetra.SerialDenseSVD_ColDim(self)

    def AllocateWORK(self) -> "void":
        return _Epetra.SerialDenseSVD_AllocateWORK(self)

    def AllocateIWORK(self) -> "void":
        return _Epetra.SerialDenseSVD_AllocateIWORK(self)

    def InitPointers(self) -> "void":
        return _Epetra.SerialDenseSVD_InitPointers(self)

    def DeleteArrays(self) -> "void":
        return _Epetra.SerialDenseSVD_DeleteArrays(self)

    def ResetMatrix(self) -> "void":
        return _Epetra.SerialDenseSVD_ResetMatrix(self)

    def ResetVectors(self) -> "void":
        return _Epetra.SerialDenseSVD_ResetVectors(self)
    Transpose_ = property(_Epetra.SerialDenseSVD_Transpose__get, _Epetra.SerialDenseSVD_Transpose__set)
    Factored_ = property(_Epetra.SerialDenseSVD_Factored__get, _Epetra.SerialDenseSVD_Factored__set)
    Solved_ = property(_Epetra.SerialDenseSVD_Solved__get, _Epetra.SerialDenseSVD_Solved__set)
    Inverted_ = property(_Epetra.SerialDenseSVD_Inverted__get, _Epetra.SerialDenseSVD_Inverted__set)
    TRANS_ = property(_Epetra.SerialDenseSVD_TRANS__get, _Epetra.SerialDenseSVD_TRANS__set)
    M_ = property(_Epetra.SerialDenseSVD_M__get, _Epetra.SerialDenseSVD_M__set)
    N_ = property(_Epetra.SerialDenseSVD_N__get, _Epetra.SerialDenseSVD_N__set)
    Min_MN_ = property(_Epetra.SerialDenseSVD_Min_MN__get, _Epetra.SerialDenseSVD_Min_MN__set)
    NRHS_ = property(_Epetra.SerialDenseSVD_NRHS__get, _Epetra.SerialDenseSVD_NRHS__set)
    LDA_ = property(_Epetra.SerialDenseSVD_LDA__get, _Epetra.SerialDenseSVD_LDA__set)
    LDAI_ = property(_Epetra.SerialDenseSVD_LDAI__get, _Epetra.SerialDenseSVD_LDAI__set)
    LDB_ = property(_Epetra.SerialDenseSVD_LDB__get, _Epetra.SerialDenseSVD_LDB__set)
    LDX_ = property(_Epetra.SerialDenseSVD_LDX__get, _Epetra.SerialDenseSVD_LDX__set)
    INFO_ = property(_Epetra.SerialDenseSVD_INFO__get, _Epetra.SerialDenseSVD_INFO__set)
    LWORK_ = property(_Epetra.SerialDenseSVD_LWORK__get, _Epetra.SerialDenseSVD_LWORK__set)
    IWORK_ = property(_Epetra.SerialDenseSVD_IWORK__get, _Epetra.SerialDenseSVD_IWORK__set)
    ANORM_ = property(_Epetra.SerialDenseSVD_ANORM__get, _Epetra.SerialDenseSVD_ANORM__set)
    Matrix_ = property(_Epetra.SerialDenseSVD_Matrix__get, _Epetra.SerialDenseSVD_Matrix__set)
    LHS_ = property(_Epetra.SerialDenseSVD_LHS__get, _Epetra.SerialDenseSVD_LHS__set)
    RHS_ = property(_Epetra.SerialDenseSVD_RHS__get, _Epetra.SerialDenseSVD_RHS__set)
    Inverse_ = property(_Epetra.SerialDenseSVD_Inverse__get, _Epetra.SerialDenseSVD_Inverse__set)
    A_ = property(_Epetra.SerialDenseSVD_A__get, _Epetra.SerialDenseSVD_A__set)
    AI_ = property(_Epetra.SerialDenseSVD_AI__get, _Epetra.SerialDenseSVD_AI__set)
    WORK_ = property(_Epetra.SerialDenseSVD_WORK__get, _Epetra.SerialDenseSVD_WORK__set)
    U_ = property(_Epetra.SerialDenseSVD_U__get, _Epetra.SerialDenseSVD_U__set)
    S_ = property(_Epetra.SerialDenseSVD_S__get, _Epetra.SerialDenseSVD_S__set)
    Vt_ = property(_Epetra.SerialDenseSVD_Vt__get, _Epetra.SerialDenseSVD_Vt__set)
    B_ = property(_Epetra.SerialDenseSVD_B__get, _Epetra.SerialDenseSVD_B__set)
    X_ = property(_Epetra.SerialDenseSVD_X__get, _Epetra.SerialDenseSVD_X__set)
    UseTranspose_ = property(_Epetra.SerialDenseSVD_UseTranspose__get, _Epetra.SerialDenseSVD_UseTranspose__set)

# Register SerialDenseSVD in _Epetra:
_Epetra.SerialDenseSVD_swigregister(SerialDenseSVD)

class Comm(object):
    r"""
    Epetra_Comm:  The Epetra Communication Abstract Base Class. The Epetra_Comm class is an interface that encapsulates the general
       information and services needed for other Epetra classes to run on a
       parallel computer. An Epetra_Comm object is required for building all
       Epetra Map objects, which in turn are required for all other Epetra
       classes.

       Epetra_Comm has default implementations, via Epetra_SerialComm and
       Epetra_MpiComm, for both serial execution and MPI distributed memory
       execution.  It is meant to insulate the user from the specifics of
       communication that are not required for normal manipulation of linear
       algebra objects.  Most Epetra_Comm interfaces are similar to MPI
       interfaces, except that the type of data is not required as an argument
       since C++ can bind to the appropriate interface based on argument typing.

       Any implementation of the Epetra_Comm interface is also responsible for
       generating an Epetra_Distributor and Epetra_Directory object.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr

    def Clone(self, *args) -> "Epetra_Comm *":
        r"""
        Epetra_Comm clone constructor. The clone function will return a new heap-allocated Comm instance.
                   It is the responsibility of the caller to ensure that this new instance
                   is properly destroyed.
        """
        return _Epetra.Comm_Clone(self, *args)
    __swig_destroy__ = _Epetra.delete_Comm

    def Barrier(self, *args) -> "void":
        r""" Epetra_Comm Barrier function. Each processor must wait at the point the barrier is called until all processors have arrived."""
        return _Epetra.Comm_Barrier(self, *args)

    def MyPID(self, *args) -> "int":
        r"""
        Return my process ID. In MPI mode returns the rank of the calling process.  In serial mode
             returns 0.
        """
        return _Epetra.Comm_MyPID(self, *args)

    def NumProc(self, *args) -> "int":
        r"""
        Returns total number of processes. In MPI mode returns the size of the MPI communicator.  In serial mode
             returns 1.
        """
        return _Epetra.Comm_NumProc(self, *args)

    def CreateDistributor(self, *args) -> "Epetra_Distributor *":
        r""" Create a distributor object."""
        return _Epetra.Comm_CreateDistributor(self, *args)

    def CreateDirectory(self, *args) -> "Epetra_Directory *":
        r""" Create a directory object for the given Epetra_BlockMap."""
        return _Epetra.Comm_CreateDirectory(self, *args)

    def PrintInfo(self, *args) -> "void":
        r""" Print object to an output stream"""
        return _Epetra.Comm_PrintInfo(self, *args)

    def Broadcast(self, *args) -> "PyObject *":
        r"""
        Broadcast(self, numpy.ndarray myObj, int root)

        Argument myObj must be a numpy array, so that the Broadcast can be
        performed in-place.  Its scalar data type must be int, long, double or
        string.  In C++, this routine has an integer error return code.  In
        python, a non-zero return code is converted to an exception.
        """
        return _Epetra.Comm_Broadcast(self, *args)

    def GatherAll(self, *args) -> "PyObject *":
        r"""
        Argument myObj can be a numpy array or any sequence that can be
        converted to a numpy array.  Its scalar data type must be int, long or
        double.  The return argument is a numpy array of the same type.  In
        C++, this routine has an integer error return code.  In python, a
        non-zero return code is converted to an exception.
        """
        return _Epetra.Comm_GatherAll(self, *args)

    def SumAll(self, *args) -> "PyObject *":
        r"""
        Argument myObj can be a numpy array or any sequence that can be
        converted to a numpy array.  Its scalar data type must be int, long or
        double.  The return argument is a numpy array of the same type.  In
        C++, this routine has an integer error return code.  In python, a
        non-zero return code is converted to an exception.
        """
        return _Epetra.Comm_SumAll(self, *args)

    def MaxAll(self, *args) -> "PyObject *":
        r"""
        Argument myObj can be a numpy array or any sequence that can be
        converted to a numpy array.  Its scalar data type must be int, long or
        double.  The return argument is a numpy array of the same type.  In
        C++, this routine has an integer error return code.  In python, a
        non-zero return code is converted to an exception.
        """
        return _Epetra.Comm_MaxAll(self, *args)

    def MinAll(self, *args) -> "PyObject *":
        r"""
        Argument myObj can be a numpy array or any sequence that can be
        converted to a numpy array.  Its scalar data type must be int, long or
        double.  The return argument is a numpy array of the same type.  In
        C++, this routine has an integer error return code.  In python, a
        non-zero return code is converted to an exception.
        """
        return _Epetra.Comm_MinAll(self, *args)

    def ScanSum(self, *args) -> "PyObject *":
        r"""
        Argument myObj can be a numpy array or any sequence that can be
        converted to a numpy array.  Its scalar data type must be int, long or
        double.  The return argument is a numpy array of the same type.  In
        C++, this routine has an integer error return code.  In python, a
        non-zero return code is converted to an exception.
        """
        return _Epetra.Comm_ScanSum(self, *args)

# Register Comm in _Epetra:
_Epetra.Comm_swigregister(Comm)

class SerialComm(Object, Comm):
    r"""
    Epetra_SerialComm:  The Epetra Serial Communication Class. The Epetra_SerialComm class is an implementation of Epetra_Comm, providing the general
     information and services needed for other Epetra classes to run on a serial computer.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        *Overload 1:*
        Epetra_SerialComm Serial Constructor. Builds an instance of a serial communicator.  Even
           if the application is running in parallel via MPI, this communicator
           will execute in serial.  The access functions return the number of
           processors to be 1 and the processor ID to be 0.

        |

        *Overload 2:*
        Epetra_SerialComm Copy Constructor. Makes an exact copy of an existing Epetra_SerialComm instance.
        """
        _Epetra.SerialComm_swiginit(self, _Epetra.new_SerialComm(*args))

    def Clone(self, *args) -> "Epetra_Comm *":
        r""" Clone method."""
        return _Epetra.SerialComm_Clone(self, *args)
    __swig_destroy__ = _Epetra.delete_SerialComm

    def Barrier(self, *args) -> "void":
        r""" Epetra_SerialComm Barrier function. A no-op for a serial communicator."""
        return _Epetra.SerialComm_Barrier(self, *args)

    def MyPID(self, *args) -> "int":
        r"""
        Return my process ID. In MPI mode returns the rank of the calling process.  In serial mode
           returns 0.
        """
        return _Epetra.SerialComm_MyPID(self, *args)

    def NumProc(self, *args) -> "int":
        r""" Returns total number of processes (always returns 1 for SerialComm)."""
        return _Epetra.SerialComm_NumProc(self, *args)

    def CreateDistributor(self, *args) -> "Epetra_Distributor *":
        r""" Create a distributor object."""
        return _Epetra.SerialComm_CreateDistributor(self, *args)

    def CreateDirectory(self, *args) -> "Epetra_Directory *":
        r""" Create a directory object for the given Epetra_BlockMap."""
        return _Epetra.SerialComm_CreateDirectory(self, *args)

    def PrintInfo(self, *args) -> "void":
        r""" Print method that implements Epetra_Comm virtual PrintInfo method"""
        return _Epetra.SerialComm_PrintInfo(self, *args)

    def ReferenceCount(self, *args) -> "int":
        r""" Returns the reference count of SerialCommData. (Intended for testing purposes.)"""
        return _Epetra.SerialComm_ReferenceCount(self, *args)

    def DataPtr(self, *args) -> "Epetra_SerialCommData const *":
        r""" Returns a pointer to the SerialCommData instance this SerialComm uses. (Intended for developer use only for testing purposes.)"""
        return _Epetra.SerialComm_DataPtr(self, *args)

# Register SerialComm in _Epetra:
_Epetra.SerialComm_swigregister(SerialComm)

class Distributor(object):
    r"""
    Epetra_Distributor:  The Epetra Gather/Scatter Setup Base Class. The Epetra_Distributor class is an interface that encapsulates the general
     information and services needed for other Epetra classes to perform gather/scatter
     operations on a parallel computer.
     An Epetra_Distributor object is actually produced by calling a method in the Epetra_Comm class.

     Epetra_Distributor has default implementations, via Epetra_SerialDistributor and
     Epetra_MpiDistributor, for both serial execution and MPI
     distributed memory execution.  It is meant to insulate the user from
     the specifics of communication that are not required for normal
     manipulation of linear algebra objects..
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr

    def Clone(self, *args) -> "Epetra_Distributor *":
        r""" Epetra_Distributor clone constructor."""
        return _Epetra.Distributor_Clone(self, *args)

    def ReverseClone(self, *args) -> "Epetra_Distributor *":
        r"""
        Create and extract the reverse version of the distributor. This is not a const method since a reverse distributor might need to be created.
           This works like Clone, returning a new object the user must deallocate.
        """
        return _Epetra.Distributor_ReverseClone(self, *args)
    __swig_destroy__ = _Epetra.delete_Distributor

    def CreateFromSends(self, *args) -> "int":
        r"""
        Create Distributor object using list of process IDs to which we export Take a list of Process IDs and construct a plan for efficiently scattering to these processes.
             Return the number of IDs being sent to me.
           :type NumExportIDs: int
           :param NumExportIDs: In
                      Number of IDs that need to be sent from this processor.
           :type ExportPIDs: int
           :param ExportPIDs: In
                      List of processors that will get the exported IDs.
           :type Deterministic: boolean
           :param Deterministic: In
                      No op.
           :type NumRemoteIDs: int
           :param NumRemoteIDs: Out
                      Number of IDs this processor will be receiving.
        """
        return _Epetra.Distributor_CreateFromSends(self, *args)

    def CreateFromRecvs(self, *args) -> "int":
        return _Epetra.Distributor_CreateFromRecvs(self, *args)

    def DoWaits(self, *args) -> "int":
        r""" Wait on a set of posts"""
        return _Epetra.Distributor_DoWaits(self, *args)

    def DoReverseWaits(self, *args) -> "int":
        r""" Wait on a reverse set of posts"""
        return _Epetra.Distributor_DoReverseWaits(self, *args)

    def Do(self, *args) -> "int":
        r"""
        *Overload 1:*
        Execute plan on buffer of export objects in a single step

        |

        *Overload 2:*
        Execute plan on buffer of export objects in a single step (object size may vary)
        """
        return _Epetra.Distributor_Do(self, *args)

    def DoReverse(self, *args) -> "int":
        r"""
        *Overload 1:*
        Execute reverse of plan on buffer of export objects in a single step

        |

        *Overload 2:*
        Execute reverse of plan on buffer of export objects in a single step (object size may vary)
        """
        return _Epetra.Distributor_DoReverse(self, *args)

    def DoPosts(self, *args) -> "int":
        r"""
        *Overload 1:*
        Post buffer of export objects (can do other local work before executing Waits)

        |

        *Overload 2:*
        Post buffer of export objects (can do other local work before executing Waits)
        """
        return _Epetra.Distributor_DoPosts(self, *args)

    def DoReversePosts(self, *args) -> "int":
        r"""
        *Overload 1:*
        Do reverse post of buffer of export objects (can do other local work before executing Waits)

        |

        *Overload 2:*
        Do reverse post of buffer of export objects (can do other local work before executing Waits)
        """
        return _Epetra.Distributor_DoReversePosts(self, *args)

# Register Distributor in _Epetra:
_Epetra.Distributor_swigregister(Distributor)

class Epetra_SerialDistributor(Object, Distributor):
    r"""
    Epetra_SerialDistributor:  The Epetra Serial implementation of the Epetra_Distributor Gather/Scatter Setup Class. The Epetra_SerialDistributor class is an Serial implement of Epetra_Distributor that is essentially a trivial class
       since a serial machine is a trivial parallel machine.
     An Epetra_SerialDistributor object is actually produced by calling a method in the Epetra_SerialComm class.

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        *Overload 1:*
        Constructor.

        |

        *Overload 2:*
        Epetra_SerialDistributor Copy Constructor.
        """
        _Epetra.Epetra_SerialDistributor_swiginit(self, _Epetra.new_Epetra_SerialDistributor(*args))

    def Clone(self, *args) -> "Epetra_Distributor *":
        r""" Clone method"""
        return _Epetra.Epetra_SerialDistributor_Clone(self, *args)

    def ReverseClone(self, *args) -> "Epetra_Distributor *":
        r""" Create and extract the reverse version of the distributor. This is not implemented for SeriaDistributor."""
        return _Epetra.Epetra_SerialDistributor_ReverseClone(self, *args)
    __swig_destroy__ = _Epetra.delete_Epetra_SerialDistributor

    def CreateFromSends(self, *args) -> "int":
        return _Epetra.Epetra_SerialDistributor_CreateFromSends(self, *args)

    def CreateFromRecvs(self, *args) -> "int":
        return _Epetra.Epetra_SerialDistributor_CreateFromRecvs(self, *args)

    def DoWaits(self, *args) -> "int":
        return _Epetra.Epetra_SerialDistributor_DoWaits(self, *args)

    def DoReverseWaits(self, *args) -> "int":
        return _Epetra.Epetra_SerialDistributor_DoReverseWaits(self, *args)

    def Do(self, *args) -> "int":
        return _Epetra.Epetra_SerialDistributor_Do(self, *args)

    def DoReverse(self, *args) -> "int":
        return _Epetra.Epetra_SerialDistributor_DoReverse(self, *args)

    def DoPosts(self, *args) -> "int":
        return _Epetra.Epetra_SerialDistributor_DoPosts(self, *args)

    def DoReversePosts(self, *args) -> "int":
        return _Epetra.Epetra_SerialDistributor_DoReversePosts(self, *args)

# Register Epetra_SerialDistributor in _Epetra:
_Epetra.Epetra_SerialDistributor_swigregister(Epetra_SerialDistributor)


def PyComm():
  "PyComm() -> Epetra.SerialComm"
  return SerialComm();

class BlockMap(Object):
    r"""
    Epetra_BlockMap: A class for partitioning block element vectors and matrices. It is often the case that multiple matrix and vector objects have an identical distribution
     of elements on a parallel machine. The Epetra_BlockMap class keeps information that describes
     this distribution for matrices and vectors that have block elements.  The definition of an
     element can vary depending on the situation.  For vectors (and multi-vectors), an element
     is a span of one or more contiguous entries. For matrices, it is a span of one or more matrix rows.
     More generally, an element in the BlockMap class is an ordered list of points. (NOTE:
     Points do not have global ID's.)  Two additional definitions useful in understanding
     the BlockMap class follow:

     *  BlockMap - A distributed ordered list of elements.
     *  First Point - First ordered point in an element


     This class has a variety of constructors that can be separated into two categories:

     *  Fixed element size constructors:
          All map elements have an identical size.
          This corresponds to a block partitioning of matrices and vectors where the element
          size is the same for all elements. A common example is multiple degrees of freedom
          per mesh node in finite element computations where the number of degrees of
          freedom is the same for all nodes.
     *  Variable element size constructor:
          Map element sizes may vary and are individually defined via a list of element sizes.
          This is the most general case and corresponds to a variable block partitioning of the
          matrices and vectors. A common example is
          multiple degrees of freedom per mesh node in finite element computations where the
          number of degrees of freedom varies.  This happens, for example, if regions have differing
          material types or there are chemical reactions in the simulation.


     Epetra_BlockMap allows the storage and retrieval of the following information.  Depending on the
     constructor that is used, some of the information is defined by the user and some is
     determined by the constructor.  Once an Epetra_BlockMap is constructed any of the following can
     be obtained
     by calling a query function that has the same name as the attribute, e.g. to get the
     value of NumGlobalElements, you can call a function NumGlobalElements().  For attributes that
     are lists, the query functions return the list values in a user allocated array.


     *  NumGlobalElements - The total number of elements across all processors. If this parameter and
          NumMyElements are both passed in to the constructor, one of the three cases will apply:

          *  If NumGlobalElements = NumMyElements (and not equal to zero)
               the map is defined to be a local replicated
               map.  In this case, objects constructed using this map will be identically replicated across
         all processors in the communicator.
          *  If NumGlobalElements = -1 and NumMyElements is passed in then NumGlobalElements will
               be computed as the sum of NumMyElements across all processors.
          *  If neither of the above is true, NumGlobalElements will be checked against the sum of
               NumMyElements across all processors.  An error is issued if the comparison is not equal.

     *  NumMyElements - The number of elements owned by the calling processor.
     *  MyGlobalElements - A list of length NumMyElements that contains the global element IDs
          of the elements owned by the calling processor.
     *  ElementSize - The size of elements if the size of all elements is the same.
          This will be the case if the query function ConstantElementSize() returns true.
          Otherwise this value will be set to zero.
     *  ElementSizeList - A list of the element sizes for elements owned by the calling
          processor.  This list is always accessible, even if the element sizes are all one
          or of constant value.  However, in these cases, the ElementSizeList will not be
          generated unless a query for the list is called.
     *  IndexBase - The base integer value for indexed array references.  Typically this is 0
          for C/C++ and 1 for Fortran, but it can be set to any integer value.
     *  Comm - The Epetra_Comm communicator.  This communicator can in turn be queried for
          processor rank and size information.



     In addition to the information above that is passed in to or created by the Epetra_BlockMap constructor,
     the following attributes are computed and available via query to the user using the same scheme
     as above, e.g., use NumGlobalPoints() to get the value of NumGlobalPoints.


     *  NumGlobalPoints - The total number of points across all processors.
     *  NumMyPoints - The number of points on the calling processor.
     *  MinAllGID - The minimum global index value across all processors.
     *  MaxAllGID - The maximum global index value across all processors.
     *  MinMyGID - The minimum global index value on the calling processor.
     *  MaxMyGID - The maximum global index value on the calling processor.
     *  MinLID - The minimum local index value on the calling processor.
     *  MaxLID - The maximum local index value on the calling processor.
     *  MinElementSize - The minimum element size across all processors.
     *  MaxElementSize - The maximum element size across all processors.


     The following functions allow boolean tests for certain properties.


     *  ConstantElementSize() - Returns true if the element size for this map is the same
          for all elements.
     *  LinearMap() - Returns true if the elements are distributed linear across processors, i.e.,
          processor 0 gets the first n/p elements, processor 1 gets the next n/p elements, etc. where
          n is the number of elements and p is the number of processors.
     *  DistributedGlobal() - Returns true if the element space of the map spans more than one processor.
          This will be true in most cases, but will be false on in serial and for objects
          that are created via the derived Epetra_LocalMap class.


     Warning: A Epetra_Comm object is required for all Epetra_BlockMap constructors.

     **error handling**

     Most methods in Epetra_BlockMap return an integer error code.  If the error code is 0, then no error occurred.
     If > 0 then a warning error occurred.  If < 0 then a fatal error occurred.

     Epetra_BlockMap constructors will throw an exception of an error occurrs.  These exceptions will alway be negative integer values
     as follows:

     *  -1  NumGlobalElements < -1.  Should be >= -1 (Should be >= 0 for first BlockMap constructor).
     *  -2  NumMyElements < 0.  Should be >= 0.
     *  -3  ElementSize <= 0. Should be > 0.
     *  -4  Invalid NumGlobalElements.  Should equal sum of MyGlobalElements, or set to -1 to compute automatically.
     *  -5  Minimum global element index is less than index base.
     *  -99 Internal Epetra_BlockMap error.  Contact developer.


     For robust code, Epetra_BlockMap constructor calls should be caught using the try {...} catch {...} mechanism.  For example:

     try {

       Epetra_BlockMap * map = new Epetra_BlockMap(NumGlobalElements, ElementSize, IndexBase, Comm);
     }
     catch (int Error) {
       if (Error==-1) { // handle error }
       if (Error==-2) ...


     Notes: 
       {
       In the current implementation, Epetra_BlockMap is the base class for:

       *  Epetra_Map.
       *  Epetra_LocalBlockMap.

       }

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    __swig_destroy__ = _Epetra.delete_BlockMap

    def LID(self, *args) -> "int":
        return _Epetra.BlockMap_LID(self, *args)

    def GID(self, *args) -> "int":
        r""" Returns global ID of local ID, return IndexBase-1 if not found on this processor."""
        return _Epetra.BlockMap_GID(self, *args)

    def GID64(self, *args) -> "long long":
        return _Epetra.BlockMap_GID64(self, *args)

    def MyGID(self, *args) -> "bool":
        return _Epetra.BlockMap_MyGID(self, *args)

    def MyLID(self, *args) -> "bool":
        r""" Returns true if the LID passed in belongs to the calling processor in this map, otherwise returns false."""
        return _Epetra.BlockMap_MyLID(self, *args)

    def MinAllGID(self, *args) -> "int":
        r"""Returns the minimum global ID across the entire map."""
        return _Epetra.BlockMap_MinAllGID(self, *args)

    def MinAllGID64(self, *args) -> "long long":
        return _Epetra.BlockMap_MinAllGID64(self, *args)

    def MaxAllGID(self, *args) -> "int":
        r""" Returns the maximum global ID across the entire map."""
        return _Epetra.BlockMap_MaxAllGID(self, *args)

    def MaxAllGID64(self, *args) -> "long long":
        return _Epetra.BlockMap_MaxAllGID64(self, *args)

    def MinMyGID(self, *args) -> "int":
        r""" Returns the minimum global ID owned by this processor."""
        return _Epetra.BlockMap_MinMyGID(self, *args)

    def MinMyGID64(self, *args) -> "long long":
        return _Epetra.BlockMap_MinMyGID64(self, *args)

    def MaxMyGID(self, *args) -> "int":
        r""" Returns the maximum global ID owned by this processor."""
        return _Epetra.BlockMap_MaxMyGID(self, *args)

    def MaxMyGID64(self, *args) -> "long long":
        return _Epetra.BlockMap_MaxMyGID64(self, *args)

    def MinLID(self, *args) -> "int":
        r"""  The minimum local index value on the calling processor."""
        return _Epetra.BlockMap_MinLID(self, *args)

    def MaxLID(self, *args) -> "int":
        r""" The maximum local index value on the calling processor."""
        return _Epetra.BlockMap_MaxLID(self, *args)

    def NumGlobalElements(self, *args) -> "int":
        r""" Number of elements across all processors."""
        return _Epetra.BlockMap_NumGlobalElements(self, *args)

    def NumGlobalElements64(self, *args) -> "long long":
        return _Epetra.BlockMap_NumGlobalElements64(self, *args)

    def NumMyElements(self, *args) -> "int":
        r""" Number of elements on the calling processor."""
        return _Epetra.BlockMap_NumMyElements(self, *args)

    def MyGlobalElementsPtr(self, *args) -> "int":
        return _Epetra.BlockMap_MyGlobalElementsPtr(self, *args)

    def ElementSize(self, *args) -> "int":
        r"""
        *Overload 1:*
        Returns the size of elements in the map; only valid if map has constant element size.

        |

        *Overload 2:*
        Size of element for specified LID.
        """
        return _Epetra.BlockMap_ElementSize(self, *args)

    def FirstPointInElement(self, *args) -> "int":
        r"""
        Returns the requested entry in the FirstPointInElementList; see FirstPointInElementList() for details. This function provides similar functionality to FirstPointInElementList(), but for simple maps may avoid
             the explicit construction of the FirstPointInElementList array.  Returns -1 if LID is out-of-range.
        """
        return _Epetra.BlockMap_FirstPointInElement(self, *args)

    def IndexBase(self, *args) -> "int":
        r""" Index base for this map."""
        return _Epetra.BlockMap_IndexBase(self, *args)

    def IndexBase64(self, *args) -> "long long":
        return _Epetra.BlockMap_IndexBase64(self, *args)

    def NumGlobalPoints(self, *args) -> "int":
        r""" Number of global points for this map; equals the sum of all element sizes across all processors."""
        return _Epetra.BlockMap_NumGlobalPoints(self, *args)

    def NumGlobalPoints64(self, *args) -> "long long":
        return _Epetra.BlockMap_NumGlobalPoints64(self, *args)

    def NumMyPoints(self, *args) -> "int":
        r""" Number of local points for this map; equals the sum of all element sizes on the calling processor."""
        return _Epetra.BlockMap_NumMyPoints(self, *args)

    def MinMyElementSize(self, *args) -> "int":
        r""" Minimum element size on the calling processor."""
        return _Epetra.BlockMap_MinMyElementSize(self, *args)

    def MaxMyElementSize(self, *args) -> "int":
        r""" Maximum element size on the calling processor."""
        return _Epetra.BlockMap_MaxMyElementSize(self, *args)

    def MinElementSize(self, *args) -> "int":
        r""" Minimum element size across all processors."""
        return _Epetra.BlockMap_MinElementSize(self, *args)

    def MaxElementSize(self, *args) -> "int":
        r""" Maximum element size across all processors."""
        return _Epetra.BlockMap_MaxElementSize(self, *args)

    def UniqueGIDs(self, *args) -> "bool":
        r"""
        Returns true if map GIDs are 1-to-1. Certain operations involving Epetra_BlockMap and Epetra_Map objects are well-defined only if
             the map GIDs are uniquely present in the map.  In other words, if a GID occurs in the map, it occurs
             only once on a single processor and nowhere else.  This boolean test returns true if this property
             is true, otherwise it returns false.
        """
        return _Epetra.BlockMap_UniqueGIDs(self, *args)

    def GlobalIndicesInt(self, *args) -> "bool":
        r""" Returns true if map create with int NumGlobalElements"""
        return _Epetra.BlockMap_GlobalIndicesInt(self, *args)

    def GlobalIndicesLongLong(self, *args) -> "bool":
        r""" Returns true if map create with long long NumGlobalElements"""
        return _Epetra.BlockMap_GlobalIndicesLongLong(self, *args)

    def GlobalIndicesTypeValid(self, *args) -> "bool":
        return _Epetra.BlockMap_GlobalIndicesTypeValid(self, *args)

    def GlobalIndicesTypeMatch(self, *args) -> "bool":
        return _Epetra.BlockMap_GlobalIndicesTypeMatch(self, *args)

    def ConstantElementSize(self, *args) -> "bool":
        r""" Returns true if map has constant element size."""
        return _Epetra.BlockMap_ConstantElementSize(self, *args)

    def SameBlockMapDataAs(self, *args) -> "bool":
        r""" Returns true if maps share same block map data underneath. This is a very cheap check whether two maps are identical."""
        return _Epetra.BlockMap_SameBlockMapDataAs(self, *args)

    def SameAs(self, *args) -> "bool":
        r""" Returns true if *this* and Map are identical maps"""
        return _Epetra.BlockMap_SameAs(self, *args)

    def PointSameAs(self, *args) -> "bool":
        r"""
        Returns true if *this* and Map have identical point-wise structure If both maps have the same number of global points and the same point
           distribution across processors then this method returns true.
        """
        return _Epetra.BlockMap_PointSameAs(self, *args)

    def LinearMap(self, *args) -> "bool":
        r""" Returns true if the global ID space is contiguously divided (but not necessarily uniformly) across all processors."""
        return _Epetra.BlockMap_LinearMap(self, *args)

    def DistributedGlobal(self, *args) -> "bool":
        r""" Returns true if map is defined across more than one processor."""
        return _Epetra.BlockMap_DistributedGlobal(self, *args)

    def MyGlobalElements64(self, *args) -> "long long *":
        return _Epetra.BlockMap_MyGlobalElements64(self, *args)

    def Comm(self, *args) -> "Epetra_Comm const &":
        r""" Access function for Epetra_Comm communicator."""
        return _Epetra.BlockMap_Comm(self, *args)

    def IsOneToOne(self, *args) -> "bool":
        return _Epetra.BlockMap_IsOneToOne(self, *args)

    def RemoveEmptyProcesses(self, *args) -> "Epetra_BlockMap *":
        r"""
        Return a new BlockMap with processes with zero elements removed.

        Warning: This method is only for expert users.  Understanding
          how to use this method correctly requires some familiarity
          with semantics of MPI communicators.

        We make no promises of backwards compatibility for
          this method.  It may go away or change at any time.

        This method first computes a new communicator, which contains
        only those processes in this Map's communicator (the "original
        communicator") that have a nonzero number of elements in this
        BlockMap (the "original BlockMap").  It then returns a new BlockMap
        distributed over the new communicator.  The new BlockMap represents
        the same distribution as the original BlockMap, except that
        processes containing zero elements are not included in the new
        BlockMap or its communicator.  On processes not included in the new
        BlockMap or communicator, this method returns NULL.

        The returned BlockMap always has a distinct communicator from this
        BlockMap's original communicator.  The new communicator contains a
        subset of processes from the original communicator.  Even if
        the number of processes in the new communicator equals the
        number of processes in the original communicator, the new
        communicator is distinct.  (In an MPI implementation, the new
        communicator is created using MPI_Comm_split.)

        This method must be called collectively on the original
        communicator.  It leaves the original Map and communicator
        unchanged.

        This method was intended for applications such as algebraic
        multigrid or other multilevel preconditioners.  Construction
        of each level of the multilevel preconditioner typically
        requires constructing sparse matrices, which in turn requires
        all-reduces over all participating processes at that level.
        Matrix sizes at successively coarser levels shrink
        geometrically.  At the coarsest levels, some processes might
        be left with zero rows of the matrix, or the multigrid
        implementation might "rebalance" (redistribute the matrix) and
        intentionally leave some processes with zero rows.  Removing
        processes with zero rows makes the all-reduces and other
        communication operations cheaper.
        """
        return _Epetra.BlockMap_RemoveEmptyProcesses(self, *args)

    def ReplaceCommWithSubset(self, *args) -> "Epetra_BlockMap *":
        r"""
        Replace this BlockMap's communicator with a subset communicator.

        Warning: This method is only for expert users.  Understanding
          how to use this method correctly requires some familiarity
          with semantics of MPI communicators.

        We make no promises of backwards compatibility for
          this method.  It may go away or change at any time.

         This method must be called collectively on the original
        communicator.  It leaves the original BlockMap and communicator
        unchanged.

        Notes: This method differs from removeEmptyProcesses(), in that
          it does not assume that excluded processes have zero
          entries.  For example, one might wish to remove empty
          processes from the row BlockMap of a CrsGraph using
          removeEmptyProcesses(), and then apply the resulting subset
          communicator to the column, domain, and range Maps of the
          same graph.  For the latter three Maps, one would in general
          use this method instead of removeEmptyProcesses(), giving
          the new row BlockMap's communicator to this method.
        """
        return _Epetra.BlockMap_ReplaceCommWithSubset(self, *args)

    def __init__(self, *args):
        r"""

        __init__(self, int numGlobalElements, int elementSize, int indexBase,
             Comm comm) -> BlockMap

        BlockMap constructor with implicit local elements and constant element
        size.  Arguments are:

             numGlobalElements  - Total number of elements over all processors.
                                  Specify -1 to have the constructor compute
                                  the number of global elements
             elementSize        - The number of degrees of freedom associated
                                  with every element.
             indexBase          - The base integer value for indexed array
                                  references.  Typically this is 0 for C/C++ and 1
                                  for Fortran, but it can be set to any integer
                                  value.
             comm               - The Epetra.Comm communicator. This communicator
                                  can in turn be queried for processor rank and
                                  size information.
        __init__(self, NumGlobalElements, ElementSize, IndexBase, Comm) -> BlockMap
        __init__(self, NumGlobalElements, ElementSize, IndexBase, Comm) -> BlockMap
        __init__(self, int numGlobalElements, int numMyElements, int elementSize,
             int indexBase, Comm comm) -> BlockMap

        BlockMap constructor with specified number of local elements and
        constant element size.  Arguments are:

             numGlobalElements  - Total number of elements over all processors.
                                  Specify -1 to have the constructor compute
                                  the number of global elements
             numMyElements      - Number of local elements on this processor.
             elementSize        - The number of degrees of freedom associated
                                  with every element.
             indexBase          - The base integer value for indexed array
                                  references.  Typically this is 0 for C/C++ and 1
                                  for Fortran, but it can be set to any integer
                                  value.
             comm               - The Epetra.Comm communicator. This communicator
                                  can in turn be queried for processor rank and
                                  size information.
        __init__(self, NumGlobalElements, NumMyElements, ElementSize, IndexBase, Comm) -> BlockMap
        __init__(self, NumGlobalElements, NumMyElements, ElementSize, IndexBase, Comm) -> BlockMap
        __init__(self, int numGlobalElements, PySequence myGlobalElements,
             int elementSize, int indexBase, Comm comm) -> BlockMap

        BlockMap constructor with specified list of local elements and
        constant element size.  Arguments are:

             numGlobalElements  - Total number of elements over all processors.
                                  Specify -1 to have the constructor compute
                                  the number of global elements
             myGlobalElements   - A sequence of integers specifying the global
                                  element indexes on this processor.
             elementSize        - The number of degrees of freedom associated
                                  with every element.
             indexBase          - The base integer value for indexed array
                                  references.  Typically this is 0 for C/C++ and 1
                                  for Fortran, but it can be set to any integer
                                  value.
             comm               - The Epetra.Comm communicator. This communicator
                                  can in turn be queried for processor rank and
                                  size information.
        __init__(self, NumGlobalElements, NumMyElements, MyGlobalElements, ElementSize, IndexBase, Comm) -> BlockMap
        __init__(self, NumGlobalElements, NumMyElements, MyGlobalElements, ElementSize, IndexBase, Comm) -> BlockMap
        __init__(self, NumGlobalElements, NumMyElements, MyGlobalElements, ElementSizeList, IndexBase, Comm) -> BlockMap
        __init__(self, NumGlobalElements, NumMyElements, MyGlobalElements, ElementSizeList, IndexBase, Comm) -> BlockMap
        __init__(self, NumGlobal_Elements, NumMy_Elements, myGlobalElements, ElementSize, indexBase, comm, UserIsDistributedGlobal, UserMinAllGID, UserMaxAllGID) -> BlockMap
        __init__(self, NumGlobal_Elements, NumMy_Elements, myGlobalElements, ElementSize, indexBase, comm, UserIsDistributedGlobal, UserMinAllGID, UserMaxAllGID) -> BlockMap
        __init__(self, NumGlobal_Elements, NumMy_Elements, myGlobalElements, ElementSize, indexBase, comm, UserIsDistributedGlobal, UserMinAllGID, UserMaxAllGID) -> BlockMap
        __init__(self, BlockMap map) -> BlockMap

        BlockMap copy constructor.
        __init__(self, int numGlobalElements, PySequence myGlobalElements,
             PySequence elementsSizes, int indexBase, Comm comm) -> BlockMap

        BlockMap constructor with specified list of local elements and
        specified list of element sizes.  Arguments are:

             numGlobalElements  - Total number of elements over all processors.
                                  Specify -1 to have the constructor compute
                                  the number of global elements
             myGlobalElements   - A sequence of integers specifying the global
                                  element indexes on this processor.
             elementSizes       - A sequence of integers specifying the number of
                                  degrees of freedom associated with each element
                                  on this processor.
             indexBase          - The base integer value for indexed array
                                  references.  Typically this is 0 for C/C++ and 1
                                  for Fortran, but it can be set to any integer
                                  value.
             comm               - The Epetra.Comm communicator. This communicator
                                  can in turn be queried for processor rank and
                                  size information.
        """
        _Epetra.BlockMap_swiginit(self, _Epetra.new_BlockMap(*args))

    def RemoteIDList(self, *args) -> "PyObject *":
        r"""
        ``GIDList`` is a sequence of integer global IDs, and the return
        argument is the three-tuple ``(PIDList, LIDList, sizeList)``, which
        are ``numpy.ndarray`` objects of integers representing the processor
        IDs, local IDs and element sizes, respectively.
        """
        return _Epetra.BlockMap_RemoteIDList(self, *args)

    def FindLocalElementID(self, *args) -> "PyObject *":
        r"""
        Returns a tuple containing the local ID of the element that contains
        the given local pointID, and the offset of the point in that element.
        """
        return _Epetra.BlockMap_FindLocalElementID(self, *args)

    def MyGlobalElements(self, *args) -> "PyObject *":
        r"""
        Returns a numpy array of integers specifying the list of global IDs on
        the processor.
        """
        return _Epetra.BlockMap_MyGlobalElements(self, *args)

    def FirstPointInElementList(self, *args) -> "PyObject *":
        r"""
        Returns a numpy array of integer first local point numbers for all of
        the local elements.
        """
        return _Epetra.BlockMap_FirstPointInElementList(self, *args)

    def ElementSizeList(self, *args) -> "PyObject *":
        r"""Returns a numpy array of integer sizes for each local element."""
        return _Epetra.BlockMap_ElementSizeList(self, *args)

    def PointToElementList(self, *args) -> "PyObject *":
        r"""
        Returns a numpy array of integers such that for each local point, it
        indicates the local element ID that the point belongs to.
        """
        return _Epetra.BlockMap_PointToElementList(self, *args)

    def AsMap(self, *args) -> "Teuchos::RCP< Epetra_Map >":
        r"""
        Attempt to convert an Epetra.BlockMap to an Epetra.Map. If the
        BlockMap can be downcast, that is what will be done. If not, but the
        element size is one, a new Epetra.Map will be constructed from the
        BlockMap data.
        """
        return _Epetra.BlockMap_AsMap(self, *args)

# Register BlockMap in _Epetra:
_Epetra.BlockMap_swigregister(BlockMap)

class Map(BlockMap):
    r"""
    Epetra_Map: A class for partitioning vectors and matrices. It is often the case that multiple matrix and vector objects have an identical distribution
     of elements on a parallel machine. The Epetra_Map class keep information that describes
     this distribution for matrices and vectors.

     Epetra_Map allows the storage and retrieval of the following information.  Depending on the
     constructor that is used, some of the information is defined by the user and some is
     determined by the constructor.  Once a Epetra_Map is constructed any of the following attributes can
     be obtained
     by calling a query function that has the name as the attribute, e.g. to get the
     value of NumGlobalElements, you can call a function NumGlobalElements().  For attributes that
     are lists, the query functions return the list values in a user allocated array.


     *  NumGlobalElements - The total number of elements across all processors. If this parameter and
          NumMyElements are both passed into the constructor, one of the three cases will apply:

          *  If NumGlobalElements = NumMyElements (and not equal to zero)
               the map is defined to be a local replicated
               map.  In this case, objects constructed using this map will be identically replicated across
         all processors in the communicator.
          *  If NumGlobalElements = -1 and NumMyElements is passed in then NumGlobalElements will
               be computed as the sum of NumMyElements across all processors.
          *  If neither of the above is true, NumGlobalElements will be checked against the sum of
               NumMyElements across all processors.  An error is issued if the comparison is not equal.

     *  NumMyElements - The number of elements owned by the calling processor.
     *  MyGlobalElements - A list of length NumMyElements that contains the global element IDs
          of the elements owned by the calling processor.
     *  IndexBase - The base integer value for indexed array references.  Typically this is 0
          for C/C++ and 1 for Fortran, but it can be set to any integer value.
     *  Comm - The Epetra_Comm communicator.  This communicator can in turn be queried for
          processor rank and size information.



     In addition to the information above that is passed in to or created by the Epetra_Map constructor,
     the following attributes are computed and available via query to the user using the same scheme
     as above, e.g., use NumGlobalPoints() to get the value of NumGlobalPoints.


     *  NumGlobalPoints - The total number of points across all processors.
     *  NumMyPoints - The number of points on the calling processor.
     *  MinAllGID - The minimum global index value across all processors.
     *  MaxAllGID - The maximum global index value across all processors.
     *  MinMyGID - The minimum global index value on the calling processor.
     *  MaxMyGID - The maximum global index value on the calling processor.
     *  MinLID - The minimum local index value on the calling processor.
     *  MaxLID - The maximum local index value on the calling processor.


     The following functions allow boolean tests for certain properties.


     *  LinearMap() - Returns true if the elements are distributed linear across processors, i.e.,
          processor 0 gets the first n/p elements, processor 1 gets the next n/p elements, etc. where
          n is the number of elements and p is the number of processors.
     *  DistributedGlobal() - Returns true if the element space of the map spans more than one processor.
          This will be true in most cases, but will be false in serial cases and for objects
          that are created via the derived Epetra_LocalMap class.


     Warning: An Epetra_Comm object is required for all Epetra_Map constructors.

     Notes: In the current implementation, Epetra_BlockMap is the base class for Epetra_Map.

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""

        __init__(self, int numGlobalElements, int indexBase, Comm comm) -> Map

        Map constructor with implicit number of elements per processor.
        Arguments are:

             numGlobalElements  - Total number of elements over all processors.
                                  Specify -1 to have the constructor compute
                                  the number of global elements
             indexBase          - The base integer value for indexed array
                                  references.  Typically this is 0 for C/C++ and 1
                                  for Fortran, but it can be set to any integer
                                  value.
             comm               - The Epetra.Comm communicator. This communicator
                                  can in turn be queried for processor rank and
                                  size information.
        __init__(self, NumGlobalElements, IndexBase, Comm) -> Map
        __init__(self, NumGlobalElements, IndexBase, Comm) -> Map
        __init__(self, int numGlobalElements, int numMyElements, int indexBase,
             Comm comm) -> Map

        Map constructor with specified number of elements per processor.
        Arguments are:

             numGlobalElements  - Total number of elements over all processors.
                                  Specify -1 to have the constructor compute
                                  the number of global elements
             numMyElements      - Number of local elements on this processor.
             indexBase          - The base integer value for indexed array
                                  references.  Typically this is 0 for C/C++ and 1
                                  for Fortran, but it can be set to any integer
                                  value.
             comm               - The Epetra.Comm communicator. This communicator
                                  can in turn be queried for processor rank and
                                  size information.
        __init__(self, NumGlobalElements, NumMyElements, IndexBase, Comm) -> Map
        __init__(self, NumGlobalElements, NumMyElements, IndexBase, Comm) -> Map
        __init__(self, int numGlobalElements, PySequence myGlobalElements,
             int indexBase, Comm comm) -> Map

        Map constructor with specified list of global element IDs for each
        processor.  Arguments are:

             numGlobalElements  - Total number of elements over all processors.
                                  Specify -1 to have the constructor compute
                                  the number of global elements
             myGlobalElements   - A sequence of integers specifying the global
                                  element indexes on this processor.
             indexBase          - The base integer value for indexed array
                                  references.  Typically this is 0 for C/C++ and 1
                                  for Fortran, but it can be set to any integer
                                  value.
             comm               - The Epetra.Comm communicator. This communicator
                                  can in turn be queried for processor rank and
                                  size information.
        __init__(self, NumGlobalElements, NumMyElements, MyGlobalElements, IndexBase, Comm) -> Map
        __init__(self, NumGlobalElements, NumMyElements, MyGlobalElements, IndexBase, Comm) -> Map
        __init__(self, NumGlobal_Elements, NumMy_Elements, myGlobalElements, indexBase, comm, UserIsDistributedGlobal, UserMinAllGID, UserMaxAllGID) -> Map
        __init__(self, NumGlobal_Elements, NumMy_Elements, myGlobalElements, indexBase, comm, UserIsDistributedGlobal, UserMinAllGID, UserMaxAllGID) -> Map
        __init__(self, NumGlobal_Elements, NumMy_Elements, myGlobalElements, indexBase, comm, UserIsDistributedGlobal, UserMinAllGID, UserMaxAllGID) -> Map
        __init__(self, Map map) -> Map

        Map copy constructor.
        """
        _Epetra.Map_swiginit(self, _Epetra.new_Map(*args))
    __swig_destroy__ = _Epetra.delete_Map

    def RemoveEmptyProcesses(self, *args) -> "Epetra_Map *":
        r"""
        Return a new BlockMap with processes with zero elements removed.

        Warning: This method is only for expert users.  Understanding
          how to use this method correctly requires some familiarity
          with semantics of MPI communicators.

        We make no promises of backwards compatibility for
          this method.  It may go away or change at any time.

        This method first computes a new communicator, which contains
        only those processes in this Map's communicator (the "original
        communicator") that have a nonzero number of elements in this
        BlockMap (the "original BlockMap").  It then returns a new BlockMap
        distributed over the new communicator.  The new BlockMap represents
        the same distribution as the original BlockMap, except that
        processes containing zero elements are not included in the new
        BlockMap or its communicator.  On processes not included in the new
        BlockMap or communicator, this method returns NULL.

        The returned BlockMap always has a distinct communicator from this
        BlockMap's original communicator.  The new communicator contains a
        subset of processes from the original communicator.  Even if
        the number of processes in the new communicator equals the
        number of processes in the original communicator, the new
        communicator is distinct.  (In an MPI implementation, the new
        communicator is created using MPI_Comm_split.)

        This method must be called collectively on the original
        communicator.  It leaves the original Map and communicator
        unchanged.

        This method was intended for applications such as algebraic
        multigrid or other multilevel preconditioners.  Construction
        of each level of the multilevel preconditioner typically
        requires constructing sparse matrices, which in turn requires
        all-reduces over all participating processes at that level.
        Matrix sizes at successively coarser levels shrink
        geometrically.  At the coarsest levels, some processes might
        be left with zero rows of the matrix, or the multigrid
        implementation might "rebalance" (redistribute the matrix) and
        intentionally leave some processes with zero rows.  Removing
        processes with zero rows makes the all-reduces and other
        communication operations cheaper.
        """
        return _Epetra.Map_RemoveEmptyProcesses(self, *args)

    def ReplaceCommWithSubset(self, *args) -> "Epetra_Map *":
        r"""
        Replace this Map's communicator with a subset communicator.

        Warning: This method is only for expert users.  Understanding
          how to use this method correctly requires some familiarity
          with semantics of MPI communicators.

        We make no promises of backwards compatibility for
          this method.  It may go away or change at any time.

         This method must be called collectively on the original
        communicator.  It leaves the original BlockMap and communicator
        unchanged.

        Notes: This method differs from removeEmptyProcesses(), in that
          it does not assume that excluded processes have zero
          entries.  For example, one might wish to remove empty
          processes from the row Map of a CrsGraph using
          removeEmptyProcesses(), and then apply the resulting subset
          communicator to the column, domain, and range Maps of the
          same graph.  For the latter three Maps, one would in general
          use this method instead of removeEmptyProcesses(), giving
          the new row Map's communicator to this method.
        """
        return _Epetra.Map_ReplaceCommWithSubset(self, *args)

# Register Map in _Epetra:
_Epetra.Map_swigregister(Map)

class LocalMap(Map):
    r"""
    Epetra_LocalMap: A class for replicating vectors and matrices across multiple processors. Small matrix and vector objects are often replicated on distributed memory
     parallel machines. The Epetra_LocalMap class allows construction of these replicated
     local objects and keeps information that describes
     this distribution.

     Epetra_LocalMap allows the storage and retrieval of the following information.
     Once a Epetra_Map is constructed any of the following attributes can
     be obtained
     by calling a query function that has the name as the attribute, e.g. to get the
     value of NumGlobalPoints, you can call a function NumGlobalElements().
     For attributes that
     are lists, the query functions return the list values in a user allocated array.



     *  NumMyElements - The number of elements owned by the calling processor.
     *  IndexBase - The base integer value for indexed array references.  Typically this is 0
          for C/C++ and 1 for Fortran, but it can be set to any integer value.
     *  Comm - The Epetra_Comm communicator.  This communicator can in turn be queried for
          processor rank and size information.


     The Epetra_LocalMap class is actually a derived class of Epetra_Map.  Epetra_Map is in turn derived
     from Epetra_BlockMap.  As such,  Epetra_LocalMap has full access to all the functions in these other
     map classes.

     In particular, the following function allows a boolean test:


     *  DistributedGlobal() - Returns false for a Epetra_LocalMap object.


     Warning: A Epetra_Comm object is required for all Epetra_LocalMap constructors.

     In the current implementation, Epetra_Map is the base class for Epetra_LocalMap.

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        *Overload 1:*
        Epetra_LocalMap constructor for a user-defined replicate distribution of elements. Creates a map that puts NumMyElements on the calling processor. Each processor should
             pass in the same value for NumMyElements.

           :param In:
                       NumMyElements - Number of elements owned by the calling processor.

           :param In:
                       IndexBase - Minimum index value used for arrays that use this map.  Typically 0 for
           	    C/C++ and 1 for Fortran.

           :param In:
                       Comm - Epetra_Comm communicator containing information on the number of
           	    processors.

           :return: Pointer to a Epetra_Map object.


        |

        *Overload 2:*
        Epetra_LocalMap copy constructor.
        """
        _Epetra.LocalMap_swiginit(self, _Epetra.new_LocalMap(*args))
    __swig_destroy__ = _Epetra.delete_LocalMap

# Register LocalMap in _Epetra:
_Epetra.LocalMap_swigregister(LocalMap)

class Directory(object):
    r"""
    Epetra_Directory: This class is a pure virtual class whose interface allows Epetra_Map and Epetr_BlockMap objects to reference non-local elements. For Epetra_BlockMap objects, a Epetra_Directory object must be created by a call to
       the Epetra_Comm CreateDirectory method.  The Directory is needed to allow referencing
       of non-local elements.

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Epetra.delete_Directory

    def GetDirectoryEntries(self, *args) -> "int":
        return _Epetra.Directory_GetDirectoryEntries(self, *args)

    def GIDsAllUniquelyOwned(self, *args) -> "bool":
        r"""GIDsAllUniquelyOwned: returns true if all GIDs appear on just one processor. If any GIDs are owned by multiple processors, returns false."""
        return _Epetra.Directory_GIDsAllUniquelyOwned(self, *args)

# Register Directory in _Epetra:
_Epetra.Directory_swigregister(Directory)

class BasicDirectory(Directory):
    r"""
    Epetra_BasicDirectory: This class allows Epetra_Map objects to reference non-local elements. For Epetra_BlockMap objects, a Epetra_Directory object must be created to allow referencing
       of non-local elements.  The Epetra_BasicDirectory produces and contains a uniform linear
       Epetra_BlockMap and a ProcList_ allowing blocks of non-local elements to be accessed
       by dereferencing through the Epetra_BasicDirectory.

     This class currently has one constructor, taking a Epetra_BlockMap object.

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        *Overload 1:*
        Epetra_BasicDirectory constructor

        |

        *Overload 2:*
        Epetra_BasicDirectory copy constructor.
        """
        _Epetra.BasicDirectory_swiginit(self, _Epetra.new_BasicDirectory(*args))
    __swig_destroy__ = _Epetra.delete_BasicDirectory

    def GetDirectoryEntries(self, *args) -> "int":
        return _Epetra.BasicDirectory_GetDirectoryEntries(self, *args)

    def GIDsAllUniquelyOwned(self, *args) -> "bool":
        r"""GIDsAllUniquelyOwned: returns true if all GIDs appear on just one processor. If any GIDs are owned by multiple processors, returns false."""
        return _Epetra.BasicDirectory_GIDsAllUniquelyOwned(self, *args)

# Register BasicDirectory in _Epetra:
_Epetra.BasicDirectory_swigregister(BasicDirectory)

class Import(Object):
    r"""
    Epetra_Import: This class builds an import object for efficient importing of off-processor elements. Epetra_Import is used to construct a communication plan that can be called repeatedly by computational
       classes such the Epetra matrix, vector and multivector classes to efficiently obtain off-processor
       elements.

       This class currently has one constructor, taking two Epetra_Map or Epetra_BlockMap objects.
       The first map specifies the global IDs of elements that we want to import later. The
       second map specifies the global IDs that are owned by the calling processor.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        *Overload 1:*
         Constructs a Epetra_Import object from the source and target maps. This constructor builds an Epetra_Import object by comparing the GID lists of the source and
              target maps.
              :type TargetMap: :py:class:`Epetra_BlockMap`
              :param TargetMap: (In) Map containing the GIDs from which data should be imported to each processor from
                         the source map whenever an import operation is performed using this importer.
              :type SourceMap: :py:class:`Epetra_BlockMap`
              :param SourceMap: (In) Map containing the GIDs that should be used for importing data.

              Warning: Note that the SourceMap *must* have GIDs uniquely owned, each GID of the source map can occur only once.


          Builds an import object that will transfer objects built with SourceMap to objects built with TargetMap.

            A Epetra_Import object categorizes the elements of the target map into three sets as follows:

            *  All elements in the target map that have the same GID as the corresponding element of the source map,
                 starting with the first
                 element in the target map, going up to the first element that is different from the source map.  The number of
        	 these IDs is returned by NumSameIDs().
            *  All elements that are local to the processor, but are not part of the first set of elements.  These elements
                 have GIDs that are owned by the calling processor, but at least the first element of this list is permuted.
        	 Even if subsequent elements are not permuted, they are included in this list.  The number of permuted elements
        	 is returned by NumPermutedIDs().  The list of elements (local IDs) in the source map that are permuted can be
        	 found in the list PermuteFromLIDs().  The list of elements (local IDs) in the target map that are the new locations
        	 of the source elements can be found in the list PermuteToLIDs().
            *  All remaining elements of the target map correspond to global IDs that are owned by remote processors.  The number
                 of these elements is returned by NumRemoteIDs() and the list of these is returned by RemoteLIDs().


        Given the above information, the Epetra_Import constructor builds a list of elements that must be communicated to other
        processors as a result of import requests.  The number of exported elements (where multiple sends of the same element
        to different processors is counted) is returned by NumExportIDs().  The local IDs to be sent are returned by the list
        ExportLIDs().  The processors to which each of the elements will be sent in returned in a list of the same length by
        ExportPIDs().

        The total number of elements that will be sent by the calling processor is returned by NumSend().  The total number of
        elements that will be received is returned by NumRecv().


        The following example illustrates the basic concepts.

        Assume we have 3 processors and 9 global elements with each processor owning 3 elements as follows
         PE 0 Elements |  PE 1 Elements  |  PE 2 Elements
            0  1  2          3  4  5           6  7  8

        The above layout essentially defines the source map argument of the import object.

        This could correspond to a 9 by 9 matrix with the first three rows on PE 0, and so on.  Suppose that this matrix
        is periodic tridiagonal having the following sparsity pattern:


        PE 0 Rows:

          X  X  0  0  0  0  0  0  X
          X  X  X  0  0  0  0  0  0
          0  X  X  X  0  0  0  0  0

        PE 1 Rows:

          0  0  X  X  X  0  0  0  0
          0  0  0  X  X  X  0  0  0
          0  0  0  0  X  X  X  0  0

        PE 2 Rows:

          0  0  0  0  0  X  X  X  0
          0  0  0  0  0  0  X  X  X
          X  0  0  0  0  0  0  X  X


        To perform a matrix vector multiplication operation y = A*x (assuming that x has the same distribution as the
        rows of the matrix A) each processor will need to import elements of x that
        are not local.  To do this, we build a target map on each processor as follows:
            PE 0 Elements    |  PE 1 Elements    |  PE 2 Elements
            0  1  2  3  8       2  3  4  5  6       0  5  6  7  8

        The above list is the elements that will be needed to perform the matrix vector multiplication locally on each processor.
        Note that the ordering of the elements on each processor is not unique, but has been chosen for illustration.

        With these two maps passed into the Epetra_Import constructor, we get the following attribute definitions:

        On PE 0:

        NumSameIDs      = 3

        NumPermuteIDs   = 0
        PermuteToLIDs   = 0
        PermuteFromLIDs = 0

        NumRemoteIDs    = 2
        RemoteLIDs      = [3, 4]

        NumExportIDs    = 2
        ExportLIDs      = [0, 2]
        ExportPIDs      = [1, 2]

        NumSend         = 2
        NumRecv         = 2


        On PE 1:

        NumSameIDs      = 0

        NumPermuteIDs   = 3
        PermuteFromLIDs = [0, 1, 2]
        PermuteToLIDs   = [1, 2, 3]

        NumRemoteIDs    = 2
        RemoteLIDs      = [0, 4]

        NumExportIDs    = 2
        ExportLIDs      = [0, 2]
        ExportPIDs      = [0, 2]

        NumSend         = 2
        NumRecv         = 2


        On PE 2:

        NumSameIDs      = 0

        NumPermuteIDs   = 3
        PermuteFromLIDs = [0, 1, 2]
        PermuteToLIDs   = [2, 3, 4]

        NumRemoteIDs    = 2
        RemoteLIDs      = [0, 1]

        NumExportIDs    = 2
        ExportLIDs      = [0, 2]
        ExportPIDs      = [0, 1]

        NumSend         = 2
        NumRecv         = 2



        ** Using Epetra_Import Objects **

        Once a Epetra_Import object has been constructed, it can be used by any of the Epetra classes that support distributed global
        objects, namely Epetra_Vector, Epetra_MultiVector, Epetra_CrsGraph, Epetra_CrsMatrix and Epetra_VbrMatrix.
        All of these classes have Import and Export methods that will fill new objects whose distribution is described by
        the target map, taking elements from the source object whose distribution is described by the source map.  Details of usage
        for each class is given in the appropriate class documentation.

        Note that the reverse operation, an export, using this importer is also possible and appropriate in some instances.
        For example, if we compute y = A^Tx, the transpose matrix-multiplication operation, then we can use the importer we constructed
        in the above example to do an export operation to y, adding the contributions that come from multiple processors.


        |

        *Overload 2:*
         Expert-only import constructor. The additional RemotePIDs argument should be filled with the owning PIDs (from the SourceMap) of the remote GIDs
            in the TargetMap.  The normal Import constructor computes this for you with a call to RemoteIDList.  However in
            some cases (MakeImportExport) we already have this information.

            WARNING: THIS METHOD IS FOR INTERNAL USE ONLY.  USERS SHOULD NOT CALL THIS CONSTRUCTOR

        |

        *Overload 3:*
         Expert-only import constructor The RemotePIDs argument should be filled with the owning PIDs (from the SourceMap) of the remote GIDs
            in the TargetMap.  The normal Import constructor computes this for you with a call to RemoteIDList.  However in
            some cases (MakeImportExport) we already have this information.  We also require information on the Export PIDs/GIDs so
            we can use the Distributor's CreateFromSendsAndReceives method.
            WARNING: THIS METHOD IS FOR INTERNAL USE ONLY.  USERS SHOULD NOT CALL THIS CONSTRUCTOR

        |

        *Overload 4:*
         Epetra_Import copy constructor.

        |

        *Overload 5:*
         Epetra_Import pseudo-copy constructor.  Creates an Epetra_Import in the reverse direction of the Epetra_Export argument.
        """
        _Epetra.Import_swiginit(self, _Epetra.new_Import(*args))
    __swig_destroy__ = _Epetra.delete_Import

    def NumSameIDs(self, *args) -> "int":
        r""" Returns the number of elements that are identical between the source and target maps, up to the first different ID"""
        return _Epetra.Import_NumSameIDs(self, *args)

    def NumPermuteIDs(self, *args) -> "int":
        r""" Returns the number of elements that are local to the calling processor, but not part of the first NumSameIDs() elements."""
        return _Epetra.Import_NumPermuteIDs(self, *args)

    def NumRemoteIDs(self, *args) -> "int":
        r""" Returns the number of elements that are not on the calling processor."""
        return _Epetra.Import_NumRemoteIDs(self, *args)

    def NumExportIDs(self, *args) -> "int":
        r""" Returns the number of elements that must be sent by the calling processor to other processors."""
        return _Epetra.Import_NumExportIDs(self, *args)

    def NumSend(self, *args) -> "int":
        r""" Total number of elements to be sent."""
        return _Epetra.Import_NumSend(self, *args)

    def NumRecv(self, *args) -> "int":
        r""" Total number of elements to be received."""
        return _Epetra.Import_NumRecv(self, *args)

    def SourceMap(self, *args) -> "Epetra_BlockMap const &":
        r""" Returns the SourceMap used to construct this importer"""
        return _Epetra.Import_SourceMap(self, *args)

    def TargetMap(self, *args) -> "Epetra_BlockMap const &":
        r""" Returns the TargetMap used to construct this importer"""
        return _Epetra.Import_TargetMap(self, *args)

    def Distributor(self, *args) -> "Epetra_Distributor &":
        return _Epetra.Import_Distributor(self, *args)

    def DistributorPtr(self, *args) -> "Epetra_Distributor const *":
        return _Epetra.Import_DistributorPtr(self, *args)

    def PermuteFromLIDs(self, *args) -> "PyObject *":
        return _Epetra.Import_PermuteFromLIDs(self, *args)

    def PermuteToLIDs(self, *args) -> "PyObject *":
        return _Epetra.Import_PermuteToLIDs(self, *args)

    def RemoteLIDs(self, *args) -> "PyObject *":
        return _Epetra.Import_RemoteLIDs(self, *args)

    def ExportLIDs(self, *args) -> "PyObject *":
        return _Epetra.Import_ExportLIDs(self, *args)

    def ExportPIDs(self, *args) -> "PyObject *":
        return _Epetra.Import_ExportPIDs(self, *args)

# Register Import in _Epetra:
_Epetra.Import_swigregister(Import)

class Export(Object):
    r"""
    Epetra_Export: This class builds an export object for efficient exporting of off-processor elements. Epetra_Export is used to construct a communication plan that can be called repeatedly by computational
       classes such the Epetra matrix, vector and multivector classes to efficiently send data to a target processor.

       This class currently has one constructor, taking two Epetra_Map or Epetra_BlockMap objects.  The
       first map specifies the global IDs that are owned by the calling processor.  The second map specifies
       the global IDs of elements that we want to export to later.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        *Overload 1:*
         Constructs a Epetra_Export object from the source and target maps. This constructor builds an Epetra_Export object by comparing the GID lists of the source and
              target maps.
              :type SourceMap: :py:class:`Epetra_BlockMap`
              :param SourceMap: (In) Map containing the GIDs from which data should be exported from each processor to
                         the target map whenever an export operation is performed using this exporter.
              :type TargetMap: :py:class:`Epetra_BlockMap`
              :param TargetMap: (In) Map containing the GIDs that should be used for exporting data.

              Warning: Note that the TargetMap *must* have GIDs uniquely owned, each GID of the target map can occur only once.

        Builds an export object that will transfer objects built with SourceMap to objects built with TargetMap.

            A Epetra_Export object categorizes the elements of the target map into three sets as follows:

            *  All elements in the target map that have the same GID as the corresponding element of the source map,
                 starting with the first
                 element in the target map, going up to the first element that is different from the source map.  The number of
        	 these IDs is returned by NumSameIDs().
            *  All elements that are local to the processor, but are not part of the first set of elements.  These elements
                 have GIDs that are owned by the calling processor, but at least the first element of this list is permuted.
        	 Even if subsequent elements are not permuted, they are included in this list.  The number of permuted elements
        	 is returned by NumPermutedIDs().  The list of elements (local IDs) in the source map that are permuted can be
        	 found in the list PermuteFromLIDs().  The list of elements (local IDs) in the target map that are the new locations
        	 of the source elements can be found in the list PermuteToLIDs().
            *  All remaining elements of the target map correspond to global IDs that are owned by remote processors.  The number
                 of these elements is returned by NumRemoteIDs() and the list of these is returned by RemoteLIDs().


        Given the above information, the Epetra_Export constructor builds a list of elements that must be communicated to other
        processors as a result of export requests.  The number of exported elements (where multiple sends of the same element
        to different processors is counted) is returned by NumExportIDs().  The local IDs to be sent are returned by the list
        ExportLIDs().  The processors to which each of the elements will be sent in returned in a list of the same length by
        ExportPIDs().

        The total number of elements that will be sent by the calling processor is returned by NumSend().  The total number of
        elements that will be received is returned by NumRecv().


        The following example illustrates the basic concepts.

        Assume we have 3 processors and 9 global elements with each processor owning 3 elements as follows
         PE 0 Elements |  PE 1 Elements  |  PE 2 Elements
            0  1  2          3  4  5           6  7  8

        The above layout essentially defines the target map argument of the export object.

        This could correspond to a 9-entry forcing vector with the first three entries on PE 0, and so on.
        Suppose that the entries of this forcing vector are computed by integrating over linear "hat" functions:

        ^  ^  ^  ^  ^  ^  ^  ^  ^
         \/ \/ \/ \/ \/ \/ \/ \/
        \ /\ /\ /\ /\ /\ /\ /\
        +--+--+--+--+--+--+--+--+
        0  1  2  3  4  5  6  7  8



        In this case, PE 0 will make contributions to entries 0 through 3, PE 1 will make contributions to entries 2 through
        6 and PE 2 will make contributions to entries 5 through 8.  A convenient way to compute these contributions is to create
        a forcing vector with replicated entries for the shared contributions.  Specifically the following SourceMap works for
        this scenario:


            PE 0 Elements    |  PE 1 Elements    |  PE 2 Elements
             0  1  2  3         2  3  4  5  6        5  6  7  8

        A vector constructed using this SourceMap can be used to collect each processor's contributions to the forcing vector.
        Note that the ordering of the elements on each processor is not unique, but has been chosen for illustration.

        With these two maps passed into the Epetra_Export constructor, we get the following attribute definitions:

        On PE 0:

        NumSameIDs      = 3

        NumPermuteIDs   = 0
        PermuteToLIDs   = 0
        PermuteFromLIDs = 0

        NumRemoteIDs    = 1
        RemoteLIDs      = [2]

        NumExportIDs    = 1
        ExportLIDs      = [3]
        ExportPIDs      = [1]

        NumSend         = 1
        NumRecv         = 1


        On PE 1:

        NumSameIDs      = 0

        NumPermuteIDs   = 3
        PermuteToLIDs   = [0, 1, 2]
        PermuteFromLIDs = [1, 2, 3]

        NumRemoteIDs    = 2
        RemoteLIDs      = [0, 2]

        NumExportIDs    = 2
        ExportLIDs      = [0, 4]
        ExportPIDs      = [0, 2]

        NumSend         = 2
        NumRecv         = 2


        On PE 2:

        NumSameIDs      = 0

        NumPermuteIDs   = 3
        PermuteToLIDs   = [0, 1, 2]
        PermuteFromLIDs = [1, 2, 3]

        NumRemoteIDs    = 1
        RemoteLIDs      = [0]

        NumExportIDs    = 1
        ExportLIDs      = [0]
        ExportPIDs      = [1]

        NumSend         = 1
        NumRecv         = 1



        ** Using Epetra_Export Objects **

        Once a Epetra_Export object has been constructed, it can be used by any of the Epetra classes that support distributed global
        objects, namely Epetra_Vector, Epetra_MultiVector, Epetra_CrsGraph, Epetra_CrsMatrix and Epetra_VbrMatrix.
        All of these classes have Export and Export methods that will fill new objects whose distribution is described by
        the target map, taking elements from the source object whose distribution is described by the source map.  Details of usage
        for each class is given in the appropriate class documentation.

        In the above example, if x_integrate is constructed using the SourceMap and then filled with local contributions, and x_force
        is constructed using the target map, the following operation will fill x_force with the combined results of x_integrate:
        x_force.Export(x_integrate, exporter, Add);
        The third argument above tells the export operation to add results that come from multiple processors for the same GID.

        Epetra_Export objects can also be used by Import operations to perform the reverse operation.  For example, if x_force in the
        above example had boundary conditions that should be sent to processors that share a boundary element, the following operation
        would send replicated values to x_integrate:
        x_integrate.Import(x_force, exporter, Insert);
        At the end of this operation, x_integrate would have replicated values from x_force of entries 2 and 3 on PEs 0 and 1,
        and entries 5 and 6 on PEs 1 and 2.


        |

        *Overload 2:*
         Epetra_Export copy constructor.

        |

        *Overload 3:*
         Epetra_Export pseudo-copy constructor.  Creates an Epetra_Export in the reverse direction of the Epetra_Import argument.
        """
        _Epetra.Export_swiginit(self, _Epetra.new_Export(*args))
    __swig_destroy__ = _Epetra.delete_Export

    def NumSameIDs(self, *args) -> "int":
        r""" Returns the number of elements that are identical between the source and target maps, up to the first different ID"""
        return _Epetra.Export_NumSameIDs(self, *args)

    def NumPermuteIDs(self, *args) -> "int":
        r""" Returns the number of elements that are local to the calling processor, but not part of the first NumSameIDs() elements."""
        return _Epetra.Export_NumPermuteIDs(self, *args)

    def NumRemoteIDs(self, *args) -> "int":
        r""" Returns the number of elements that are not on the calling processor."""
        return _Epetra.Export_NumRemoteIDs(self, *args)

    def NumExportIDs(self, *args) -> "int":
        r""" Returns the number of elements that must be sent by the calling processor to other processors."""
        return _Epetra.Export_NumExportIDs(self, *args)

    def NumSend(self, *args) -> "int":
        r""" Total number of elements to be sent."""
        return _Epetra.Export_NumSend(self, *args)

    def NumRecv(self, *args) -> "int":
        r""" Total number of elements to be received."""
        return _Epetra.Export_NumRecv(self, *args)

    def SourceMap(self, *args) -> "Epetra_BlockMap const &":
        r""" Returns the SourceMap used to construct this exporter"""
        return _Epetra.Export_SourceMap(self, *args)

    def TargetMap(self, *args) -> "Epetra_BlockMap const &":
        r""" Returns the TargetMap used to construct this exporter"""
        return _Epetra.Export_TargetMap(self, *args)

    def Distributor(self, *args) -> "Epetra_Distributor &":
        return _Epetra.Export_Distributor(self, *args)

    def DistributorPtr(self, *args) -> "Epetra_Distributor const *":
        return _Epetra.Export_DistributorPtr(self, *args)

    def PermuteFromLIDs(self, *args) -> "PyObject *":
        return _Epetra.Export_PermuteFromLIDs(self, *args)

    def PermuteToLIDs(self, *args) -> "PyObject *":
        return _Epetra.Export_PermuteToLIDs(self, *args)

    def RemoteLIDs(self, *args) -> "PyObject *":
        return _Epetra.Export_RemoteLIDs(self, *args)

    def ExportLIDs(self, *args) -> "PyObject *":
        return _Epetra.Export_ExportLIDs(self, *args)

    def ExportPIDs(self, *args) -> "PyObject *":
        return _Epetra.Export_ExportPIDs(self, *args)

# Register Export in _Epetra:
_Epetra.Export_swigregister(Export)

class SrcDistObject(object):
    r"""
    Epetra_SrcDistObject: A class for supporting flexible source distributed objects for import/export operations. The Epetra_SrcDistObject is a base class for all Epetra distributed global objects that are potential
       source objects for the general Epetra_DistObject class.  It provides a way to send a very general distributed
       object as the potential source object for an import or export object.  For example, it is possible to pass
       an Epetra_RowMatrix object as the source object for an import/export where the target is an Epetra_CrsMatrix, or
       an Epetra_CrsGraph (where the RowMatrix values will be ignored).

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Epetra.delete_SrcDistObject

    def Map(self, *args) -> "Epetra_BlockMap const &":
        r""" Returns a reference to the Epetra_BlockMap for this object."""
        return _Epetra.SrcDistObject_Map(self, *args)

# Register SrcDistObject in _Epetra:
_Epetra.SrcDistObject_swigregister(SrcDistObject)

class DistObject(Object, SrcDistObject):
    r"""
     Epetra_DistObject: A class for constructing and using dense multi-vectors, vectors and matrices in parallel. The Epetra_DistObject is a base class for all Epetra distributed global objects.  It provides the basic
        mechanisms and interface specifications for importing and exporting operations using Epetra_Import and
        Epetra_Export objects.

    ** Distributed Global vs. Replicated Local.**


      *  Distributed Global objects - In most instances, a distributed object will be partitioned
           across multiple memory images associated with multiple processors.  In this case, there is
           a unique copy of each element and elements are spread across all processors specified by
           the Epetra_Comm communicator.
      *  Replicated Local Objects - Some algorithms use objects that are too small to
           be distributed across all processors, the Hessenberg matrix in a GMRES
           computation.  In other cases, such as with block iterative methods,  block dot product
           functions produce small
           dense matrices that are required by all processors.  Replicated local objectss handle
           these types of situation.


    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Epetra.delete_DistObject

    def Import(self, *args) -> "int":
        r"""
        *Overload 1:*
        Imports an Epetra_DistObject using the Epetra_Import object.
           :param In:
                      Source - Distributed object that will be imported into the "\e this" object.
           :param In:
                      Importer - A Epetra_Import object specifying the communication required.

           :param In:
                      CombineMode - A Epetra_CombineMode enumerated type specifying how results should be combined on the
           	   receiving processor.

           :rtype: int
           :return: Integer error code, set to 0 if successful.

        |

        *Overload 2:*
        Imports an Epetra_DistObject using the Epetra_Export object.
           :param In:
                      Source - Distributed object that will be imported into the "\e this" object.
           :param In:
                      Exporter - A Epetra_Export object specifying the communication required.

           :param In:
                      CombineMode - A Epetra_CombineMode enumerated type specifying how results should be combined on the
           	   receiving processor.

           :rtype: int
           :return: Integer error code, set to 0 if successful.
        """
        return _Epetra.DistObject_Import(self, *args)

    def Export(self, *args) -> "int":
        r"""
        *Overload 1:*
        Exports an Epetra_DistObject using the Epetra_Import object.
           :param In:
                      Source - Distributed object that will be exported to the "\e this" object.
           :param In:
                      Importer - A Epetra_Import object specifying the communication required.

           :param In:
                      CombineMode - A Epetra_CombineMode enumerated type specifying how results should be combined on the
           	   receiving processor.

           :rtype: int
           :return: Integer error code, set to 0 if successful.

        |

        *Overload 2:*
        Exports an Epetra_DistObject using the Epetra_Export object.
           :param In:
                      Source - Distributed object that will be exported to the "\e this" multivector.
           :param In:
                      Exporter - A Epetra_Export object specifying the communication required.

           :param In:
                      CombineMode - A Epetra_CombineMode enumerated type specifying how results should be combined on the
           	   receiving processor.

           :rtype: int
           :return: Integer error code, set to 0 if successful.
        """
        return _Epetra.DistObject_Export(self, *args)

    def Map(self, *args) -> "Epetra_BlockMap const &":
        r""" Returns the address of the Epetra_BlockMap for this multi-vector."""
        return _Epetra.DistObject_Map(self, *args)

    def Comm(self, *args) -> "Epetra_Comm const &":
        r""" Returns the address of the Epetra_Comm for this multi-vector."""
        return _Epetra.DistObject_Comm(self, *args)

    def DistributedGlobal(self, *args) -> "bool":
        r""" Returns true if this multi-vector is distributed global, i.e., not local replicated."""
        return _Epetra.DistObject_DistributedGlobal(self, *args)

# Register DistObject in _Epetra:
_Epetra.DistObject_swigregister(DistObject)

class MapColoring(DistObject):
    r"""
     Epetra_MapColoring: A class for coloring Epetra_Map and Epetra_BlockMap objects. This class allows the user to associate an integer value, i.e., a color, to each element of
        an existing Epetra_Map or Epetra_BlockMap object.  Colors may be assigned at construction, or
        via set methods.  Any elements that are not explicitly assigned a color are assigned the color
        0 (integer zero).

    This class has the following features:



     *  A color (arbitrary integer label) can be associated locally with each element of a map.
      Color assignment can be done

      *  all-at-once via the constructor, or
      *  via operator[] (using LIDs) one-at-a-time
      *  operator() (using GIDs) one-at-a-time
      *  or some combination of the above.


    Any element that is not explicitly colored takes on the default color.  The default
    color is implicitly zero, unless specified differently at the time of construction.

    *  Color information may be accessed in the following ways:

      *  By local element ID (LID) - Returns the color of a specified LID, where the LID is associated
           with the Epetra_Map or BlockMap that was passed in to the Epetra_MapColoring constructor.
      *  By global element ID (GID) - Returns the color of the specified GID.  There two methods
           for accessing GIDs, one assumes the request is for GIDs owned by the calling processor,
           the second allows arbitrary requested for GIDs, as long as the GID is defined on some processor
           for the Epetra_Map or Epetra_BlockMap.
      *  By color groups - Elements are grouped by color so that all elements of a given color can
           be accessed.
      *  Epetra_Map/Epetra_BlockMap pointers for a specified color -  This facilitates
         use of coloring with Epetra distributed objects that are distributed via the map
         that was colored.  For example, if users want to work with all rows of a matrix that have
         a certain color, they can create a map for that color and use it to access only those rows.



    *  The Epetra_MapColoring class implements the Epetra_DistObject interface.  Therefore, a map coloring
      can be computed for a map with a given distribution and then redistributed across the parallel machine.
      For example, it would be possible to compute a map coloring on a single processor (perhaps because the
      algorithm for computing the color assignment is too difficult to implement in parallel or because it
      is cheap to run and not worth parallelizing), and then re-distribute the coloring using an Epetra_Export
      or Epetra_Import object.


    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    __swig_destroy__ = _Epetra.delete_MapColoring

    def __call__(self, *args) -> "int const &":
        r"""
        *Overload 1:*
        GID element color assignment method, Note:  Valid only for GIDs owned by calling processor. Allows color assignment of specified GID *only* if the GID is owned by map on
             the calling processor. If you are unsure about the ownership of a GID, check by using the MyGID()
             method.  MyGID(GID) returns true if the GID is owned by the calling processor.
             :rtype: int
             :return: MapColor(GID).

        |

        *Overload 2:*
        GID element color assignment method, Note:  Valid only for GIDs owned by calling processor. Allows color assignment of specified GID *only* if the GID is owned by map on
             the calling processor. If you are unsure about the ownership, check by using the MyGID()
             method on the map object.
           :rtype: int
           :return: MapColor(GID).
        """
        return _Epetra.MapColoring___call__(self, *args)

    def NumColors(self, *args) -> "int":
        r""" Returns number of colors on the calling processor."""
        return _Epetra.MapColoring_NumColors(self, *args)

    def MaxNumColors(self, *args) -> "int":
        r""" Returns maximum over all processors of the number of colors."""
        return _Epetra.MapColoring_MaxNumColors(self, *args)

    def DefaultColor(self, *args) -> "int":
        r""" Returns default color."""
        return _Epetra.MapColoring_DefaultColor(self, *args)

    def NumElementsWithColor(self, *args) -> "int":
        r""" Returns number of map elements on calling processor having specified Color"""
        return _Epetra.MapColoring_NumElementsWithColor(self, *args)

    def GenerateMap(self, *args) -> "Epetra_Map *":
        r"""
        Generates an Epetra_Map of the GIDs associated with the specified color. This method will create an Epetra_Map such that on each processor the GIDs associated with
           the specified color will be part of the map on that processor.  Note that this
           method always generates an Epetra_Map, not an Epetra_BlockMap, even if the map associated
           with this map coloring is a block map.  Once the map is generated, the user is responsible for
           deleting it.
        """
        return _Epetra.MapColoring_GenerateMap(self, *args)

    def GenerateBlockMap(self, *args) -> "Epetra_BlockMap *":
        r"""
        Generates an Epetra_BlockMap of the GIDs associated with the specified color. This method will create an Epetra_BlockMap such that on each processor the GIDs associated with
           the specified color will be part of the map on that processor.  Note that this
           method will generate an Epetra_BlockMap such that each element as the same element size as the
           corresponding element of map associated with the map coloring.
           Once the map is generated, the user is responsible for
           deleting it.
        """
        return _Epetra.MapColoring_GenerateBlockMap(self, *args)

    def __init__(self, *args):
        _Epetra.MapColoring_swiginit(self, _Epetra.new_MapColoring(*args))

    def __getitem__(self, *args) -> "int":
        return _Epetra.MapColoring___getitem__(self, *args)

    def __setitem__(self, *args) -> "void":
        return _Epetra.MapColoring___setitem__(self, *args)

    def ListOfColors(self, *args) -> "PyObject *":
        return _Epetra.MapColoring_ListOfColors(self, *args)

    def ColorLIDList(self, *args) -> "PyObject *":
        return _Epetra.MapColoring_ColorLIDList(self, *args)

    def ElementColors(self, *args) -> "PyObject *":
        return _Epetra.MapColoring_ElementColors(self, *args)

# Register MapColoring in _Epetra:
_Epetra.MapColoring_swigregister(MapColoring)


def _extractNumPyArrayFromEpetraIntVector(*args) -> "PyObject *":
    return _Epetra._extractNumPyArrayFromEpetraIntVector(*args)
class IntVector(DistObject):
    r"""
     Epetra_IntVector: A class for constructing and using dense integer vectors on a parallel computer. The Epetra_IntVector class enables the construction and use of integer
         dense vectors in a distributed memory environment.  The distribution of the dense
        vector is determined in part by a Epetra_Comm object and a Epetra_Map (or Epetra_LocalMap
        or Epetra_BlockMap).


    ** Distributed Global vs. Replicated Local**

      *  Distributed Global Vectors - In most instances, a multi-vector will be partitioned
           across multiple memory images associated with multiple processors.  In this case, there is
           a unique copy of each element and elements are spread across all processors specified by
           the Epetra_Comm communicator.
      *  Replicated Local Vectors - Some algorithms use vectors that are too small to
           be distributed across all processors.  Replicated local vectors handle
           these types of situation.


    **Constructing Epetra_IntVectors**

    There are four Epetra_IntVector constructors.  The first is a basic constructor that allocates
    space and sets all values to zero, the second is a
    copy constructor. The third and fourth constructors work with user data.  These constructors have
    two data access modes:

      *  Copy mode - Allocates memory and makes a copy of the user-provided data. In this case, the
           user data is not needed after construction.
      *  View mode - Creates a "view" of the user data. In this case, the
           user data is required to remain intact for the life of the vector.


    Warning: View mode is *extremely* dangerous from a data hiding perspective.
    Therefore, we strongly encourage users to develop code using Copy mode first and
    only use the View mode in a secondary optimization phase.

    All Epetra_IntVector constructors require a map argument that describes the layout of elements
    on the parallel machine.  Specifically,
    ``map`` is a Epetra_Map, Epetra_LocalMap or Epetra_BlockMap object describing the desired
    memory layout for the vector.

    There are four different Epetra_IntVector constructors:

      *  Basic - All values are zero.
      *  Copy - Copy an existing vector.
      *  Copy from or make view of user int array.


    **Extracting Data from Epetra_IntVectors**

    Once a Epetra_IntVector is constructed, it is possible to extract a copy of the values or create
    a view of them.

    ExtractView functions are *extremely* dangerous from a data hiding perspective.
    For both ExtractView fuctions, there is a corresponding ExtractCopy function.  We
    strongly encourage users to develop code using ExtractCopy functions first and
    only use the ExtractView functions in a secondary optimization phase.

    There are two Extract functions:

      *  ExtractCopy - Copy values into a user-provided array.
      *  ExtractView - Set user-provided array to point to Epetra_IntVector data.



    A Epetra_Map, Epetra_LocalMap or Epetra_BlockMap object is required for all
      Epetra_IntVector constructors.

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    __swig_destroy__ = _Epetra.delete_IntVector

    def PutValue(self, *args) -> "int":
        r""" Set all elements of the vector to Value"""
        return _Epetra.IntVector_PutValue(self, *args)

    def ExtractCopy(self, *args) -> "int":
        r"""
        Put vector values into user-provided array.
           :param Out:
                      V - Pointer to memory space that will contain the vector values.

           :rtype: int
           :return: Integer error code, set to 0 if successful.
        """
        return _Epetra.IntVector_ExtractCopy(self, *args)

    def ExtractView(self, *args) -> "int":
        r"""
        Set user-provided address of V.
           :param Out:
                      V - Address of a pointer to that will be set to point to the values of the vector.

           :rtype: int
           :return: Integer error code, set to 0 if successful.
        """
        return _Epetra.IntVector_ExtractView(self, *args)

    def MaxValue(self, *args) -> "int":
        r"""
        Find maximum value
           :rtype: int
           :return: Maximum value across all processors.
        """
        return _Epetra.IntVector_MaxValue(self, *args)

    def MinValue(self, *args) -> "int":
        r"""
        Find minimum value
           :rtype: int
           :return: Minimum value across all processors.
        """
        return _Epetra.IntVector_MinValue(self, *args)

    def MyLength(self, *args) -> "int":
        r""" Returns the local vector length on the calling processor of vectors in the multi-vector."""
        return _Epetra.IntVector_MyLength(self, *args)

    def GlobalLength(self, *args) -> "int":
        r""" Returns the global vector length of vectors in the multi-vector."""
        return _Epetra.IntVector_GlobalLength(self, *args)

    def GlobalLength64(self, *args) -> "long long":
        return _Epetra.IntVector_GlobalLength64(self, *args)

    def __init__(self, *args):
        _Epetra.IntVector_swiginit(self, _Epetra.new_IntVector(*args))

    def __distarray__(self, *args) -> "PyObject *":
        return _Epetra.IntVector___distarray__(self, *args)

# Register IntVector in _Epetra:
_Epetra.IntVector_swigregister(IntVector)


def IntVector_getattr(self, name):
    if name == "array":
        a = _extractNumPyArrayFromEpetraIntVector(self)
        self.__dict__["array"] = a
        return a
    elif name == "shape":
        return self.array.shape
    elif name == "dtype":
        return self.array.dtype
    raise AttributeError("'%s' not an attribute of IntVector" % name)
def IntVector_setattr(self, name, value):
    if name == "array":
        raise AttributeError("Cannot change IntVector 'array' attribute")
    elif name == "shape":
        self.array.shape = value
    elif name == "dtype":
        raise AttributeError("Cannot change IntVector 'dtype' attribute")
    else:
        self.__dict__[name] = value
IntVector.__getattr__ = IntVector_getattr
IntVector.__setattr__ = IntVector_setattr
IntVector.__getitem__ = lambda self, i: self.array.__getitem__(i)
IntVector.__setitem__ = lambda self, i, v: self.array.__setitem__(i,v)
IntVector.__len__     = lambda self: self.array.__len__()
IntVector.__str__     = lambda self: self.array.__str__()
IntVector.copy        = lambda self: IntVector(self)
IntVector.ExtractCopy = lambda self: self.array.copy()
IntVector.ExtractView = lambda self: self.array
IntVector.Values      = lambda self: self.array
class_array_add_math(IntVector)
class_array_add_comp(IntVector)


def _extractNumPyArrayFromEpetraMultiVector(*args) -> "PyObject *":
    return _Epetra._extractNumPyArrayFromEpetraMultiVector(*args)
class MultiVector(DistObject, CompObject, BLAS):
    r"""
    Epetra_MultiVector: A class for constructing and using dense multi-vectors, vectors and matrices in parallel. The Epetra_MultiVector class enables the construction and use of real-valued,
     double-precision dense vectors, multi-vectors,
     and matrices in a distributed memory environment.  The dimensions and distribution of the dense
     multi-vectors is determined in part by a Epetra_Comm object, a Epetra_Map (or Epetra_LocalMap
     or Epetra_BlockMap) and the number of vectors passed to the constructors described below.

     There are several concepts that important for understanding the Epetra_MultiVector class:


     *   Multi-vectors, Vectors and Matrices.

     *  Vector - A list of real-valued, double-precision numbers.  Also a multi-vector with one vector.
     *  Multi-Vector - A collection of one or more vectors, all having the same length and distribution.
     *  (Dense) Matrix - A special form of multi-vector such that stride in memory between any
     two consecutive vectors in the multi-vector is the same for all vectors.  This is identical
     to a two-dimensional array in Fortran and plays an important part in high performance
     computations.

     *  Distributed Global vs. Replicated Local.

     *  Distributed Global Multi-vectors - In most instances, a multi-vector will be partitioned
     across multiple memory images associated with multiple processors.  In this case, there is
     a unique copy of each element and elements are spread across all processors specified by
     the Epetra_Comm communicator.
     *  Replicated Local Multi-vectors - Some algorithms use multi-vectors that are too small to
     be distributed across all processors, the Hessenberg matrix in a GMRES
     computation.  In other cases, such as with block iterative methods,  block dot product
     functions produce small
     dense matrices that are required by all processors.  Replicated local multi-vectors handle
     these types of situation.

     *  Multi-vector Functions vs. Dense Matrix Functions.

     *  Multi-vector functions - These functions operate simultaneously but independently
     on each vector in the multi-vector and produce individual results for each vector.
     *  Dense matrix functions - These functions operate on the multi-vector as a matrix,
     providing access to selected dense BLAS and LAPACK operations.



     **Constructing Epetra_MultiVectors**

     Except for the basic constructor and copy constructor, Epetra_MultiVector constructors
     have two data access modes:

     *  Copy mode - Allocates memory and makes a copy of the user-provided data. In this case, the
     user data is not needed after construction.
     *  View mode - Creates a "view" of the user data. In this case, the
     user data is required to remain intact for the life of the multi-vector.


     Warning: View mode is *extremely* dangerous from a data hiding perspective.
     Therefore, we strongly encourage users to develop code using Copy mode first and
     only use the View mode in a secondary optimization phase.

     All Epetra_MultiVector constructors require a map argument that describes the layout of elements
     on the parallel machine.  Specifically,
     ``map`` is a Epetra_Map, Epetra_LocalMap or Epetra_BlockMap object describing the desired
     memory layout for the multi-vector.

     There are six different Epetra_MultiVector constructors:

     *  Basic - All values are zero.
     *  Copy - Copy an existing multi-vector.
     *  Copy from or make view of two-dimensional Fortran style array.
     *  Copy from or make view of an array of pointers.
     *  Copy or make view of a list of vectors from another Epetra_MultiVector object.
     *  Copy or make view of a range of vectors from another Epetra_MultiVector object.


     **Extracting Data from Epetra_MultiVectors**

     Once a Epetra_MultiVector is constructed, it is possible to extract a copy of the values or create
     a view of them.

     ExtractView functions are *extremely* dangerous from a data hiding perspective.
     For both ExtractView fuctions, there is a corresponding ExtractCopy function.  We
     strongly encourage users to develop code using ExtractCopy functions first and
     only use the ExtractView functions in a secondary optimization phase.

     There are four Extract functions:

     *  ExtractCopy - Copy values into a user-provided two-dimensional array.
     *  ExtractCopy - Copy values into a user-provided array of pointers.
     *  ExtractView - Set user-provided two-dimensional array parameters
     to point to Epetra_MultiVector data.
     *  ExtractView - Set user-provided array of pointer parameters
     to point to Epetra_MultiVector data.


     **Vector, Matrix and Utility Functions**

     Once a Epetra_MultiVector is constructed, a variety of mathematical functions can be applied to
     the individual vectors.  Specifically:

     *  Dot Products.
     *  Vector Updates.
     *  *p* Norms.
     *  Weighted Norms.
     *  Minimum, Maximum and Average Values.


     In addition, a matrix-matrix multiply function supports a variety of operations on any viable
     combination of global distributed and local replicated multi-vectors using calls to DGEMM, a
     high performance kernel for matrix operations.  In the near future we will add support for calls
     to other selected BLAS and LAPACK functions.

     ** Counting Floating Point Operations **

     Each Epetra_MultiVector object keep track of the number
     of *serial* floating point operations performed using the specified object as the *this* argument
     to the function.  The Flops() function returns this number as a double precision number.  Using this
     information, in conjunction with the Epetra_Time class, one can get accurate parallel performance
     numbers.  The ResetFlops() function resets the floating point counter.

     A Epetra_Map, Epetra_LocalMap or Epetra_BlockMap object is required for all
     Epetra_MultiVector constructors.

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    __swig_destroy__ = _Epetra.delete_MultiVector

    def ReplaceGlobalValue(self, *args) -> "int":
        return _Epetra.MultiVector_ReplaceGlobalValue(self, *args)

    def SumIntoGlobalValue(self, *args) -> "int":
        return _Epetra.MultiVector_SumIntoGlobalValue(self, *args)

    def ReplaceMyValue(self, *args) -> "int":
        r"""
        *Overload 1:*
        Replace current value  at the specified (MyRow, VectorIndex) location with ScalarValue.
           Replaces the existing value for a single entry in the multivector.  The
           specified local row must correspond to a GID owned by the map of the multivector on the
           calling processor.  In other words, this method does not perform cross-processor communication.

           This method is intended for use with vectors based on an Epetra_Map.  If used
           on a vector based on a non-trivial Epetra_BlockMap, this will update only block
           row 0, i.e.

           Epetra_MultiVector::ReplaceMyValue  (  MyRow,  VectorIndex,  ScalarValue )  is
           equivalent to:
           Epetra_MultiVector::ReplaceMyValue  (  0, MyRow,  VectorIndex,  ScalarValue )


           :param In:
               MyRow - Row of Multivector to modify in local index space.
           :param In:
               VectorIndex - Vector within MultiVector that should to modify.
           :param In:
               ScalarValue - Value to add to existing value.

           :rtype: int
           :return: Integer error code, set to 0 if successful, set to 1 if MyRow not associated with calling processor
               set to -1 if VectorIndex >= NumVectors().

        |

        *Overload 2:*
        Replace current value at the specified (MyBlockRow, BlockRowOffset, VectorIndex) location with ScalarValue.
           Replaces the existing value for a single entry in the multivector.  The
           specified local block row and block row offset
           must correspond to a GID owned by the map of the multivector on the
           calling processor.  In other words, this method does not perform cross-processor communication.

           :param In:
               MyBlockRow - BlockRow of Multivector to modify in local index space.
           :param In:
               BlockRowOffset - Offset into BlockRow of Multivector to modify in local index space.
           :param In:
               VectorIndex - Vector within MultiVector that should to modify.
           :param In:
               ScalarValue - Value to add to existing value.

           :rtype: int
           :return: Integer error code, set to 0 if successful, set to 1 if MyRow not associated with calling processor
               set to -1 if VectorIndex >= NumVectors(), set to -2 if BlockRowOffset is out-of-range.
        """
        return _Epetra.MultiVector_ReplaceMyValue(self, *args)

    def SumIntoMyValue(self, *args) -> "int":
        r"""
        *Overload 1:*
        Adds ScalarValue to existing value at the specified (MyRow, VectorIndex) location.
           Sums the given value into the existing value for a single entry in the multivector.  The
           specified local row must correspond to a GID owned by the map of the multivector on the
           calling processor.  In other words, this method does not perform cross-processor communication.

           If the map associated with this multivector is an Epetra_BlockMap, only the first point entry associated
           with the local row will be modified.  To modify a different point entry, use the other version of
           this method

           :param In:
               MyRow - Row of Multivector to modify in local index space.
           :param In:
               VectorIndex - Vector within MultiVector that should to modify.
           :param In:
               ScalarValue - Value to add to existing value.

           :rtype: int
           :return: Integer error code, set to 0 if successful, set to 1 if MyRow not associated with calling processor
               set to -1 if VectorIndex >= NumVectors().

        |

        *Overload 2:*
        Adds ScalarValue to existing value at the specified (MyBlockRow, BlockRowOffset, VectorIndex) location.
           Sums the given value into the existing value for a single entry in the multivector.  The
           specified local block row and block row offset
           must correspond to a GID owned by the map of the multivector on the
           calling processor.  In other words, this method does not perform cross-processor communication.

           :param In:
               MyBlockRow - BlockRow of Multivector to modify in local index space.
           :param In:
               BlockRowOffset - Offset into BlockRow of Multivector to modify in local index space.
           :param In:
               VectorIndex - Vector within MultiVector that should to modify.
           :param In:
               ScalarValue - Value to add to existing value.

           :rtype: int
           :return: Integer error code, set to 0 if successful, set to 1 if MyRow not associated with calling processor
               set to -1 if VectorIndex >= NumVectors(), set to -2 if BlockRowOffset is out-of-range.
        """
        return _Epetra.MultiVector_SumIntoMyValue(self, *args)

    def PutScalar(self, *args) -> "int":
        r"""
        Initialize all values in a multi-vector with constant value.
           :param In:
               ScalarConstant - Value to use.

           :rtype: int
           :return: Integer error code, set to 0 if successful.
        """
        return _Epetra.MultiVector_PutScalar(self, *args)

    def Random(self, *args) -> "int":
        r"""
        Set multi-vector values to random numbers. MultiVector uses the random number generator provided by Epetra_Util.
           The multi-vector values will be set to random values on the interval (-1.0, 1.0).

           :rtype: int
           :return: Integer error code, set to 0 if successful.
        """
        return _Epetra.MultiVector_Random(self, *args)

    def Abs(self, *args) -> "int":
        r"""
        Puts element-wise absolute values of input Multi-vector in target.
           :param In:
               A - Input Multi-vector.
           :param Out:
               *this* will contain the absolute values of the entries of A.

           :rtype: int
           :return: Integer error code, set to 0 if successful.

           Note:  It is possible to use the same argument for A and *this*.
        """
        return _Epetra.MultiVector_Abs(self, *args)

    def Reciprocal(self, *args) -> "int":
        r"""
        Puts element-wise reciprocal values of input Multi-vector in target.
           :param In:
               A - Input Multi-vector.
           :param Out:
               *this* will contain the element-wise reciprocal values of the entries of A.

           :rtype: int
           :return: Integer error code, set to 0 if successful.  Returns 2 if some entry
               is too small, but not zero.  Returns 1 if some entry is zero.

           Note:  It is possible to use the same argument for A and *this*.  Also,
           if a given value of A is smaller than Epetra_DoubleMin (defined in Epetra_Epetra.h),
           but nonzero, then the return code is 2.  If an entry is zero, the return code
           is 1.  However, in all cases the reciprocal value is still used, even
           if a NaN is the result.
        """
        return _Epetra.MultiVector_Reciprocal(self, *args)

    def Scale(self, *args) -> "int":
        r"""
        *Overload 1:*
        Scale the current values of a multi-vector, *this* = ScalarValue**this*.
           :param In:
               ScalarValue - Scale value.
           :param Out:
               *This* - Multi-vector with scaled values.

           :rtype: int
           :return: Integer error code, set to 0 if successful.

        |

        *Overload 2:*
        Replace multi-vector values with scaled values of A, *this* = ScalarA*A.
           :param In:
               ScalarA - Scale value.
           :param In:
               A - Multi-vector to copy.
           :param Out:
               *This* - Multi-vector with values overwritten by scaled values of A.

           :rtype: int
           :return: Integer error code, set to 0 if successful.
        """
        return _Epetra.MultiVector_Scale(self, *args)

    def Update(self, *args) -> "int":
        r"""
        *Overload 1:*
        Update multi-vector values with scaled values of A, *this* = ScalarThis**this* + ScalarA*A.
           :param In:
               ScalarA - Scale value for A.
           :param In:
               A - Multi-vector to add.
           :param In:
               ScalarThis - Scale value for *this*.
           :param Out:
               *This* - Multi-vector with updatede values.

           :rtype: int
           :return: Integer error code, set to 0 if successful.

        |

        *Overload 2:*
        Update multi-vector with scaled values of A and B, *this* = ScalarThis**this* + ScalarA*A + ScalarB*B.
           :param In:
               ScalarA - Scale value for A.
           :param In:
               A - Multi-vector to add.
           :param In:
               ScalarB - Scale value for B.
           :param In:
               B - Multi-vector to add.
           :param In:
               ScalarThis - Scale value for *this*.
           :param Out:
               *This* - Multi-vector with updatede values.

           :rtype: int
           :return: Integer error code, set to 0 if successful.
        """
        return _Epetra.MultiVector_Update(self, *args)

    def Multiply(self, *args) -> "int":
        r"""
        *Overload 1:*
        Matrix-Matrix multiplication, *this* = ScalarThis**this* + ScalarAB*A*B. This function performs a variety of matrix-matrix multiply operations, interpreting
           the Epetra_MultiVectors (*this-aka* C , A and B) as 2D matrices.  Variations are due to
           the fact that A, B and C can be local replicated or global distributed
           Epetra_MultiVectors and that we may or may not operate with the transpose of
           A and B.  Possible cases are:

           Total of 32 case (2^5).
           Num
           OPERATIONS                        case  Notes
           1) C(local) = A^X(local) * B^X(local)  4   (X=Transpose or Not, No comm needed)
           2) C(local) = A^T(distr) * B  (distr)  1   (2D dot product, replicate C)
           3) C(distr) = A  (distr) * B^X(local)  2   (2D vector update, no comm needed)

           Note that the following operations are not meaningful for
           1D distributions:

           1) C(local) = A^T(distr) * B^T(distr)  1
           2) C(local) = A  (distr) * B^X(distr)  2
           3) C(distr) = A^X(local) * B^X(local)  4
           4) C(distr) = A^X(local) * B^X(distr)  4
           5) C(distr) = A^T(distr) * B^X(local)  2
           6) C(local) = A^X(distr) * B^X(local)  4
           7) C(distr) = A^X(distr) * B^X(local)  4
           8) C(local) = A^X(local) * B^X(distr)  4


           :param In:
               TransA - Operate with the transpose of A if = 'T', else no transpose if = 'N'.
           :param In:
               TransB - Operate with the transpose of B if = 'T', else no transpose if = 'N'.

           :param In:
               ScalarAB - Scalar to multiply with A*B.
           :param In:
               A - Multi-vector.
           :param In:
               B - Multi-vector.
           :param In:
               ScalarThis - Scalar to multiply with *this*.
           Warning: Map of the distributed multivectors must have unique GIDs (UniqueGIDs() must return true).

           :rtype: int
           :return: Integer error code, set to 0 if successful.

           {Each multi-vector A, B and *this* is checked if it has constant stride using the
           ConstantStride() query function.  If it does not have constant stride, a temporary
           copy is made and used for the computation.  This activity is transparent to the user,
           except that there is memory and computation overhead.  All temporary space is deleted
           prior to exit.}


        |

        *Overload 2:*
        Multiply a Epetra_MultiVector with another, element-by-element. This function supports diagonal matrix multiply.  A is usually a single vector
           while B and *this* may have one or more columns.  Note that B and *this* must
           have the same shape.  A can be one vector or have the same shape as B.  The actual
           computation is *this* = ScalarThis * *this* + ScalarAB * B @ A where @ denotes element-wise
           multiplication.
        """
        return _Epetra.MultiVector_Multiply(self, *args)

    def ReciprocalMultiply(self, *args) -> "int":
        r"""
        Multiply a Epetra_MultiVector by the reciprocal of another, element-by-element. This function supports diagonal matrix scaling.  A is usually a single vector
           while B and *this* may have one or more columns.  Note that B and *this* must
           have the same shape.  A can be one vector or have the same shape as B. The actual
           computation is *this* = ScalarThis * *this* + ScalarAB * B @ A where @ denotes element-wise
           division.
        """
        return _Epetra.MultiVector_ReciprocalMultiply(self, *args)

    def SetSeed(self, *args) -> "int":
        r"""
        Set seed for Random function.
           :param In:
               Seed - Should be an integer on the interval (0, 2^31-1).

           :rtype: int
           :return: Integer error code, set to 0 if successful.
        """
        return _Epetra.MultiVector_SetSeed(self, *args)

    def Seed(self, *args) -> "unsigned int":
        r"""
        Get seed from Random function.
           :rtype: int
           :return: Current random number seed.
        """
        return _Epetra.MultiVector_Seed(self, *args)

    def NumVectors(self, *args) -> "int":
        r""" Returns the number of vectors in the multi-vector."""
        return _Epetra.MultiVector_NumVectors(self, *args)

    def MyLength(self, *args) -> "int":
        r""" Returns the local vector length on the calling processor of vectors in the multi-vector."""
        return _Epetra.MultiVector_MyLength(self, *args)

    def GlobalLength(self, *args) -> "int":
        r""" Returns the global vector length of vectors in the multi-vector."""
        return _Epetra.MultiVector_GlobalLength(self, *args)

    def GlobalLength64(self, *args) -> "long long":
        r""" Returns the 64-bit global vector length of vectors in the multi-vector."""
        return _Epetra.MultiVector_GlobalLength64(self, *args)

    def Stride(self, *args) -> "int":
        r""" Returns the stride between  vectors in the multi-vector (only meaningful if ConstantStride() is true)."""
        return _Epetra.MultiVector_Stride(self, *args)

    def ConstantStride(self, *args) -> "bool":
        r""" Returns true if this multi-vector has constant stride between vectors."""
        return _Epetra.MultiVector_ConstantStride(self, *args)

    def ReplaceMap(self, *args) -> "int":
        r"""
        Replace map, only if new map has same point-structure as current map.
             return 0 if map is replaced, -1 if not.
        """
        return _Epetra.MultiVector_ReplaceMap(self, *args)

    def Values(self, *args) -> "double *":
        r""" Get pointer to MultiVector values"""
        return _Epetra.MultiVector_Values(self, *args)

    def Reduce(self, *args) -> "int":
        return _Epetra.MultiVector_Reduce(self, *args)

    def __init__(self, *args):
        _Epetra.MultiVector_swiginit(self, _Epetra.new_MultiVector(*args))

    def Dot(self, *args) -> "PyObject *":
        return _Epetra.MultiVector_Dot(self, *args)

    def Norm1(self, *args) -> "PyObject *":
        return _Epetra.MultiVector_Norm1(self, *args)

    def Norm2(self, *args) -> "PyObject *":
        return _Epetra.MultiVector_Norm2(self, *args)

    def NormInf(self, *args) -> "PyObject *":
        return _Epetra.MultiVector_NormInf(self, *args)

    def NormWeighted(self, *args) -> "PyObject *":
        return _Epetra.MultiVector_NormWeighted(self, *args)

    def MinValue(self, *args) -> "PyObject *":
        return _Epetra.MultiVector_MinValue(self, *args)

    def MaxValue(self, *args) -> "PyObject *":
        return _Epetra.MultiVector_MaxValue(self, *args)

    def MeanValue(self, *args) -> "PyObject *":
        return _Epetra.MultiVector_MeanValue(self, *args)

    def __call__(self, *args) -> "Epetra_Vector const &":
        return _Epetra.MultiVector___call__(self, *args)

    def __distarray__(self, *args) -> "PyObject *":
        return _Epetra.MultiVector___distarray__(self, *args)

# Register MultiVector in _Epetra:
_Epetra.MultiVector_swigregister(MultiVector)


def MultiVector_getattr(self, name):
    if name == "array":
        a = _extractNumPyArrayFromEpetraMultiVector(self)
        self.__dict__["array"] = a
        return a
    elif name == "shape":
        return self.array.shape
    elif name == "dtype":
        return self.array.dtype
    raise AttributeError("'%s' not an attribute of MultiVector" % name)
def MultiVector_setattr(self, name, value):
    if name == "array":
        raise AttributeError("Cannot change MultiVector 'array' attribute")
    elif name == "shape":
        self.array.shape = value
    elif name == "dtype":
        raise AttributeError("Cannot change MultiVector 'dtype' attribute")
    else:
        self.__dict__[name] = value
def MultiVector_getitem(self,i):
    if isinstance(i,int):
        return self.__call__(i)
    else:
        return self.array.__getitem__(i)
MultiVector.__getattr__ = MultiVector_getattr
MultiVector.__setattr__ = MultiVector_setattr
MultiVector.__getitem__ = MultiVector_getitem
MultiVector.__setitem__ = lambda self, i, v: self.array.__setitem__(i,v)
MultiVector.__len__     = lambda self: self.array.__len__()
MultiVector.__str__     = lambda self: self.array.__str__()
MultiVector.copy        = lambda self: MultiVector(self)
MultiVector.ExtractCopy = lambda self: self.array.copy()
MultiVector.ExtractView = lambda self: self.array
class_array_add_math(MultiVector)
class_array_add_comp(MultiVector)


def _extractNumPyArrayFromEpetraVector(*args) -> "PyObject *":
    return _Epetra._extractNumPyArrayFromEpetraVector(*args)
class Vector(MultiVector):
    r"""
     Epetra_Vector: A class for constructing and using dense vectors on a parallel computer. The Epetra_Vector class enables the construction and use of real-valued,
        double-precision dense vectors in a distributed memory environment.  The distribution of the dense
        vector is determined in part by a Epetra_Comm object and a Epetra_Map (or Epetra_LocalMap
        or Epetra_BlockMap).

        This class is derived from the Epetra_MultiVector class.  As such, it has full access
        to all of the functionality provided in the Epetra_MultiVector class.

    ** Distributed Global vs. Replicated Local**

      *  Distributed Global Vectors - In most instances, a multi-vector will be partitioned
           across multiple memory images associated with multiple processors.  In this case, there is
           a unique copy of each element and elements are spread across all processors specified by
           the Epetra_Comm communicator.
      *  Replicated Local Vectors - Some algorithms use vectors that are too small to
           be distributed across all processors.  Replicated local vectors handle
           these types of situation.


    **Constructing Epetra_Vectors**

    There are four Epetra_Vector constructors.  The first is a basic constructor that allocates
    space and sets all values to zero, the second is a
    copy constructor. The third and fourth constructors work with user data.  These constructors have
    two data access modes:

      *  Copy mode - Allocates memory and makes a copy of the user-provided data. In this case, the
           user data is not needed after construction.
      *  View mode - Creates a "view" of the user data. In this case, the
           user data is required to remain intact for the life of the vector.


    Warning: View mode is *extremely* dangerous from a data hiding perspective.
    Therefore, we strongly encourage users to develop code using Copy mode first and
    only use the View mode in a secondary optimization phase.

    All Epetra_Vector constructors require a map argument that describes the layout of elements
    on the parallel machine.  Specifically,
    ``map`` is a Epetra_Map, Epetra_LocalMap or Epetra_BlockMap object describing the desired
    memory layout for the vector.

    There are four different Epetra_Vector constructors:

      *  Basic - All values are zero.
      *  Copy - Copy an existing vector.
      *  Copy from or make view of user double array.
      *  Copy or make view of a vector from a Epetra_MultiVector object.


    **Extracting Data from Epetra_Vectors**

    Once a Epetra_Vector is constructed, it is possible to extract a copy of the values or create
    a view of them.

    ExtractView functions are *extremely* dangerous from a data hiding perspective.
    For both ExtractView fuctions, there is a corresponding ExtractCopy function.  We
    strongly encourage users to develop code using ExtractCopy functions first and
    only use the ExtractView functions in a secondary optimization phase.

    There are two Extract functions:

      *  ExtractCopy - Copy values into a user-provided array.
      *  ExtractView - Set user-provided array to point to Epetra_Vector data.


    **Vector and Utility Functions**

    Once a Epetra_Vector is constructed, a variety of mathematical functions can be applied to
    the vector.  Specifically:

      *  Dot Products.
      *  Vector Updates.
      *  *p* Norms.
      *  Weighted Norms.
      *  Minimum, Maximum and Average Values.


    The final useful function is Flops().  Each Epetra_Vector object keep track of the number
    of *serial* floating point operations performed using the specified object as the *this* argument
    to the function.  The Flops() function returns this number as a double precision number.  Using this
    information, in conjunction with the Epetra_Time class, one can get accurate parallel performance
    numbers.

    A Epetra_Map, Epetra_LocalMap or Epetra_BlockMap object is required for all
      Epetra_Vector constructors.

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    __swig_destroy__ = _Epetra.delete_Vector

    def __init__(self, *args):
        _Epetra.Vector_swiginit(self, _Epetra.new_Vector(*args))

    def ReplaceGlobalValues(self, *args) -> "int":
        return _Epetra.Vector_ReplaceGlobalValues(self, *args)

    def ReplaceMyValues(self, *args) -> "int":
        return _Epetra.Vector_ReplaceMyValues(self, *args)

    def SumIntoGlobalValues(self, *args) -> "int":
        return _Epetra.Vector_SumIntoGlobalValues(self, *args)

    def SumIntoMyValues(self, *args) -> "int":
        return _Epetra.Vector_SumIntoMyValues(self, *args)

    def __distarray__(self, *args) -> "PyObject *":
        return _Epetra.Vector___distarray__(self, *args)

# Register Vector in _Epetra:
_Epetra.Vector_swigregister(Vector)


def Vector_getattr(self, name):
    if name == "array":
        a = _extractNumPyArrayFromEpetraVector(self)
        self.__dict__["array"] = a
        return a
    elif name == "shape":
        return self.array.shape
    elif name == "dtype":
        return self.array.dtype
    raise AttributeError("'%s' not an attribute of Vector" % name)
def Vector_setattr(self, name, value):
    if name == "array":
        raise AttributeError("Cannot change Vector 'array' attribute")
    elif name == "shape":
        self.array.shape = value
    elif name == "dtype":
        raise AttributeError("Cannot change Vector 'dtype' attribute")
    else:
        self.__dict__[name] = value
Vector.__getattr__ = Vector_getattr
Vector.__setattr__ = Vector_setattr
Vector.__getitem__ = lambda self, i: self.array.__getitem__(i)
Vector.__setitem__ = lambda self, i, v: self.array.__setitem__(i,v)
Vector.__len__     = lambda self: self.array.__len__()
Vector.__str__     = lambda self: self.array.__str__()
Vector.copy        = lambda self: Vector(self)
Vector.ExtractCopy = lambda self: self.array.copy()
Vector.ExtractView = lambda self: self.array
class_array_add_math(Vector)
class_array_add_comp(Vector)


def _extractNumPyArrayFromEpetraFEVector(*args) -> "PyObject *":
    return _Epetra._extractNumPyArrayFromEpetraFEVector(*args)
class FEVector(MultiVector):
    r"""
    Epetra Finite-Element Vector. This class inherits Epetra_MultiVector
     and thus provides all Epetra_MultiVector functionality.

     The added functionality provided by Epetra_FEVector is the ability to
     perform finite-element style vector assembly. It accepts sub-vector
     contributions, such as those that would come from element-load vectors, etc.
     These sub-vectors need not be owned by the local processor. In other
     words, the user can assemble overlapping data (e.g., corresponding to shared
     finite-element nodes). When the user is finished assembling their vector
     data, they then call the method Epetra_FEVector::GlobalAssemble() which
     gathers the overlapping data (all non-local data that was input on each
     processor) into the data-distribution specified by the map with which the
     Epetra_FEVector was constructed.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    __swig_destroy__ = _Epetra.delete_FEVector

    def GlobalAssemble(self, *args) -> "int":
        r"""
        Gather any overlapping/shared data into the non-overlapping partitioning
             defined by the Map that was passed to this vector at construction time.
             Data imported from other processors is stored on the owning processor
             with a "sumInto" or accumulate operation.
             This is a collective method -- every processor must enter it before any
             will complete it.

             Optimization for power-users:
             The optional parameter 'reuse_map_and_exporter' defaults to false.
             By default, a map that describes the non-local data is re-created at
             each call to GlobalAssemble, along with an exporter used to do the
             communication.
             This is expensive. If you know that the layout of your nonlocal data has
             not changed since your previous call to GlobalAssemble, you can set this
             flag to true and it will reuse the previously created map and exporter
             rather than creating new ones.
        """
        return _Epetra.FEVector_GlobalAssemble(self, *args)

    def setIgnoreNonLocalEntries(self, *args) -> "void":
        r""" Set whether or not non-local data values should be ignored."""
        return _Epetra.FEVector_setIgnoreNonLocalEntries(self, *args)

    def __init__(self, *args):
        _Epetra.FEVector_swiginit(self, _Epetra.new_FEVector(*args))

    def ReplaceGlobalValues(self, *args) -> "int":
        return _Epetra.FEVector_ReplaceGlobalValues(self, *args)

    def SumIntoGlobalValues(self, *args) -> "int":
        return _Epetra.FEVector_SumIntoGlobalValues(self, *args)

    def __distarray__(self, *args) -> "PyObject *":
        return _Epetra.FEVector___distarray__(self, *args)

# Register FEVector in _Epetra:
_Epetra.FEVector_swigregister(FEVector)


def FEVector_getattr(self, name):
    if name == "array":
        a = _extractNumPyArrayFromEpetraFEVector(self)
        self.__dict__["array"] = a
        return a
    elif name == "shape":
        return self.array.shape
    elif name == "dtype":
        return self.array.dtype
    raise AttributeError("'%s' not an attribute of FEVector" % name)
def FEVector_setattr(self, name, value):
    if name == "array":
        raise AttributeError("Cannot change FEVector 'array' attribute")
    elif name == "shape":
        self.array.shape = value
    elif name == "dtype":
        raise AttributeError("Cannot change FEVector 'dtype' attribute")
    else:
        self.__dict__[name] = value
FEVector.__getattr__ = FEVector_getattr
FEVector.__setattr__ = FEVector_setattr
FEVector.__getitem__ = lambda self, i: self.array.__getitem__(i)
FEVector.__setitem__ = lambda self, i, v: self.array.__setitem__(i, v)
FEVector.__len__     = lambda self: self.array.__len__()
FEVector.__str__     = lambda self: self.array.__str__()
FEVector.copy        = lambda self: Vector(self)
FEVector.ExtractCopy = lambda self: self.array.copy()
FEVector.ExtractView = lambda self: self.array
class_array_add_math(FEVector)
class_array_add_comp(FEVector)


def strong_count(*args) -> "int":
    return _Epetra.strong_count(*args)

def weak_count(*args) -> "int":
    return _Epetra.weak_count(*args)

def total_count(*args) -> "int":
    return _Epetra.total_count(*args)
class CrsGraph(DistObject):
    r"""
     Epetra_CrsGraph: A class for constructing and using sparse compressed row graphs. Epetra_CrsGraph enables the piecewise construction and use of sparse matrix graphs (the integer structure without
        values) where entries are intended for row access.

        Epetra_CrsGraph is an attribute of all Epetra row-based matrix classes, defining their nonzero structure and also
        holding their Epetra_Map attributes.

    **Constructing Epetra_CrsGraph objects**

    Constructing Epetra_CrsGraph objects is a multi-step process.  The basic steps are as follows:

      *  Create Epetra_CrsGraph instance, including some initial storage,  via constructor. In
           addition to the copy constructor, Epetra_CrsGraph has four different constructors.  All four of these
              constructors have
        an argument, StaticProfile, which by default is set to false.  If it is set to true, then the
        profile (the number of indices per row as defined by NumIndicesPerRow) will be rigidly enforced.
        Although this takes away flexibility, it allows a single array to be allocated for all indices.
        This decreases memory fragmentation and improves performance across many operations. A more detailed
        discussion of the StaticProfile option is found below.

         *  User-provided row map, variable nonzero profile: This constructor is used to define the
              row distribution of the graph and specify a varying number of nonzero entries per row.
        It is best to use this constructor when the user will be inserting entries using global index
        values and wants every column index to be included in the graph.  Note that in this case, the
        column map will be built for the user when FillComplete() is called.  This constructor is also
        appropriate for when there is a large variation in the number of indices per row.  If this is not
        the case, the next constructor may be more convenient to use.
         *  User-provided row map, fixed nonzero profile: This constructor is used to define the
              row distribution of the graph and specify a fixed number of nonzero entries per row.
        It is best to use this constructor when the user will be inserting entries using global index
        values and wants every column index to be included in the graph.  Note that in this case, the
        column map will be built for the user when FillComplete() is called.  This constructor is also
        appropriate for when there is little or no variation in the number of indices per row.
         *  User-provided row map, user-provided column map and variable nonzero profile:
              This constructor is used to define the
              row *and* *column* distribution of the graph, and specify a varying number of nonzero entries per row.
        It is best to use this constructor when the user will be inserting entries and already knows which columns
        of the matrix should be included on each processor.  Note that in this case, the
        column map will *not* be built for the user when FillComplete() is called.  Also, if the user attempts to
        insert a column index whose GID is not part of the column map on that process, the index will be
        discarded.  This property can be used to "filter out" column entries that should be ignored.
        This constructor is also
        appropriate for when there is a large variation in the number of indices per row.  If this is not
        the case, the next constructor may be more convenient to use.
         *  User-provided row map, user-provided column map and fixed nonzero profile:
              This constructor is used to define the
              row *and* *column* distribution of the graph, and specify a fixed number of nonzero entries per row.
        It is best to use this constructor when the user will be inserting entries and already knows which columns
        of the matrix should be included on each processor.  Note that in this case, the
        column map will *not* be built for the user when FillComplete() is called.  Also, if the user attempts to
        insert a column index whose GID is not part of the column map on that process, the index will be
        discarded.  This constructor is also
        appropriate for when there is little or no variation in the number of indices per row.

      *  Enter row and column entry information via calls to the InsertGlobalIndices method.
      *  Complete construction via FillComplete call, which performs the following tasks:

         * Transforms indices to local index space (after this, IndicesAreLocal()==true)
         * Sorts column-indices within each row
         * Compresses out any redundant indices within rows
         * Computes global data such as num-nonzeros, maximum row-lengths, etc.

      *  (Optional) Optimize the graph storage via a call to OptimizeStorage.


    ** Performance Enhancement Issues **

    The Epetra_CrsGraph class attempts to address four basic types of situations, depending on the user's primary concern:


     *  Simple, flexible construction over minimal memory use or control of column indices:  In this case the user wants to provide only a row distribution
          of the graph and insert indices without worrying about memory allocation performance.  This type of user is best
          served by the constructor that requires only a row map, and a fixed number of indices per row.  In fact, setting NumIndicesPerRow=0
          is probably the best option.
     *  Stronger control over memory allocation performance and use over flexibility and simplicity:  In this case the user explicitly set
          StaticProfile to true and will provide values, either a single global int or an array of int's, for NumIndicesPerRow, such that
          the actual number of indices submitted to the graph will not exceed the estimates.  Because we know that NumIndicesPerRow will not
          be exceeded, we can pre-allocate all of the storage for the graph as a single array.  This is typically much more efficient.
     *  Explicit control over column indices:  In this case the user prescribes the column map.  Given the column map, any index that is
          submitted for entry into the graph will be included *only* if they are present in the list of GIDs for the column map on the
          processor that submits the index.  This feature allows the user to define a filter such that only certain columns will be kept.  The
          user also prescribes the local ordering via this technique, since the ordering of GIDs in the column map imposes the local
          ordering.
     *  Construction using local indices only:  In some situations, users may want to build a graph using local index values only.  In this
          case, the user must explicitly assign GIDs.  This is done by prescribing the column map, in the same way as the previous situation.


    Notes:

    * In all but the most advanced uses, users will typically *not* specify the column map.  In other words, graph entries will be submitted using
    GIDs not LIDs and all entries that are submitted are intended to be inserted into the graph.

    * If a user is not particularly worried about performance, or really needs the flexibility associated with the first situation, then there
    is no need to explicitly manage the NumIndicesPerRow values or set StaticProfile to true.  In this case, it is best to set NumIndicesPerRow to
    zero.

    *  Users who are concerned about performance should carefully manage NumIndicesPerRow and set StaticProfile to true.  This will give the best
    performance and use the least amount of memory.

    *  A compromise approach would be to not set StaticProfile to true, giving the user flexibility, but then calling OptimizeStorage() once FillComplete()
    has been called. This approach requires additional temporary memory because the graph will be copied into an efficient data structure and the old
    memory deleted.  However, once the copy has been made, the resulting data structure is as efficient as when StaticProfile is used.


    **Epetra_Map attributes**

    Epetra_CrsGraph objects have four Epetra_Map attributes.

    The Epetra_Map attributes can be obtained via these accessor methods:

     * RowMap() Describes the numbering and distribution of the rows of the graph. The row-map exists and is valid
     for the entire life of the graph, having been passed in as a constructor argument. The set of graph rows is defined
     by the row-map and may not be changed. Rows may not be inserted or deleted by the user. The only change that may be
     made is that the user can replace the row-map with a compatible row-map (which is the same except for re-numbering)
     by calling the ReplaceRowMap() method.
     * ColMap() Describes the set of column-indices that appear in the rows in each processor's portion of the graph.
     Unless provided by the user at construction time, a valid column-map doesn't exist until FillComplete() is called.
     * RangeMap() Describes the range of the matrix operator. e.g., for a matrix-vector product operation, the result
       vector's map must be compatible with the range-map of the matrix operator. The range-map is usually the same as
       the row-map. The range-map is set equal to the row-map at graph creation time, but may be specified by the user
       when FillComplete() is called.
     * DomainMap() Describes the domain of the matrix operator. The domain-map can be specified by the user when
     FillComplete() is called. Until then, it is set equal to the row-map.


    It is important to note that while the row-map and the range-map are often the same, the column-map and the domain-map
    are almost never the same. The set of entries in a distributed column-map almost always form overlapping sets, with
    entries being associated with more than one processor. A domain-map, on the other hand, must be a 1-to-1 map, with
    entries being associated with only a single processor.

    **Global versus Local indices**

    After creation and before FillComplete() has been called, the column-indices of the graph are in
    the global space as received from the user. One of the tasks performed by FillComplete() is to
    transform the indices to a local index space. The query methods IndicesAreGlobal() and IndicesAreLocal()
    return true or false depending on whether this transformation has been performed or not.

    Note the behavior of several graph methods:

     * InsertGlobalIndices() returns an error if IndicesAreLocal()==true or StorageOptimized()==true
     * InsertMyIndices() returns an error if IndicesAreGlobal()==true or StorageOptimized()==true
     * RemoveGlobalIndices() returns an error if IndicesAreLocal()==true or if graph was constructed in View mode
     * RemoveMyIndices() returns an error if IndicesAreGlobal()==true or if graph was constructed in View mode
     * ExtractGlobalRowCopy() works regardless of state of indices
     * ExtractMyRowCopy() returns an error if IndicesAreGlobal()==true
     * ExtractGlobalRowView() returns an error if IndicesAreLocal()==true
     * ExtractMyRowView() returns an error if IndicesAreGlobal()==true


    Note that even after a graph is constructed, it is possible to add or remove entries.  However,
    FillComplete must then be called again to restore the graph to a consistent state.

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    __swig_destroy__ = _Epetra.delete_CrsGraph

    def InsertGlobalIndices(self, *args) -> "int":
        r"""
        InsertGlobalIndices(self, int globalRow, PySequence indices) -> int

        Insert a sequence of global indices into the set of nonzero columns
        for the specified global row.  Argument indices can be a numpy array
        of integers or any python sequence that can be converted to a numpy
        array of integers.  The integers represent global IDs that are to be
        inserted into the graph.  An integer error/warning code is returned.
        InsertGlobalIndices(self, int globalRow, PySequence indices) -> int

        Insert a sequence of global indices into the set of nonzero columns
        for the specified global row.  Argument indices can be a numpy array
        of integers or any python sequence that can be converted to a numpy
        array of integers.  The integers represent global IDs that are to be
        inserted into the graph.  An integer error/warning code is returned.

        """
        return _Epetra.CrsGraph_InsertGlobalIndices(self, *args)

    def RemoveGlobalIndices(self, *args) -> "int":
        r"""
        *Overload 1:*
        Remove a list of elements from a specified global row of the graph.
           :param Row: - (In) Global row number of indices.
           :type NumIndices: int
           :param NumIndices: - (In) Number of Indices.
           :type Indices: int
           :param Indices: - (In) Global column indices to remove.

           :rtype: int
           :return: Integer error code, set to 0 if successful. Returns 1 if data is shared.


        |

        *Overload 2:*
        Remove all indices from a specified global row of the graph.
           :type Row: int
           :param Row: - (In) Global row number of indices.

           :rtype: int
           :return: Integer error code, set to 0 if successful. Returns 1 if data is shared.
        """
        return _Epetra.CrsGraph_RemoveGlobalIndices(self, *args)

    def InsertMyIndices(self, *args) -> "int":
        r"""
        InsertMyIndices(self, int localRow, PySequence indices) -> int

        Insert a sequence of local indices into the set of nonzero columns for
        the specified local row.  Argument indices can be a numpy array of
        integers or any python sequence that can be converted to a numpy array
        of integers.  The integers represent local IDs that are to be inserted
        into the graph.  An integer error/warning code is returned.

        """
        return _Epetra.CrsGraph_InsertMyIndices(self, *args)

    def RemoveMyIndices(self, *args) -> "int":
        r"""
        *Overload 1:*
        Remove a list of elements from a specified local row of the graph.
           :param Row: - (In) Local row number of indices.
           :type NumIndices: int
           :param NumIndices: - (In) Number of Indices.
           :type Indices: int
           :param Indices: - (In) Local column indices to remove.

           :rtype: int
           :return: Integer error code, set to 0 if successful. Returns 1 if data is shared.


        |

        *Overload 2:*
        Remove all indices from a specified local row of the graph.
           :type Row: int
           :param Row: - (In) Local row number of indices.

           :rtype: int
           :return: Integer error code, set to 0 if successful. Returns 1 if data is shared.
        """
        return _Epetra.CrsGraph_RemoveMyIndices(self, *args)

    def FillComplete(self, *args) -> "int":
        r"""
        *Overload 1:*
        Tranform to local index space.  Perform other operations to allow optimal matrix operations. This overloading of the FillComplete method assumes that the domain-map and range-map both equal
           the row-map, and simply calls FillComplete(RowMap(), RowMap()).
           :rtype: int
           :return: Integer error code, set to 0 if successful. Returns 1 if data is shared (i.e., if the underlying graph-data
               object has a reference-count greater than 1).


        |

        *Overload 2:*
        Transform to local index space using specified Domain/Range maps.  Perform other operations to allow optimal matrix operations. Performs this sequence of operations:

            * Transform indices to local index space
            * Sort column-indices within each row
            * Compress out any redundant indices within rows
            * Compute global data such as num-nonzeros, maximum row-lengths, etc.

           :rtype: int
           :return: Integer error code, set to 0 if successful. Returns 1 if data is shared (i.e., if the underlying graph-data
               object has a reference-count greater than 1).
        """
        return _Epetra.CrsGraph_FillComplete(self, *args)

    def OptimizeStorage(self, *args) -> "int":
        r"""
        Make consecutive row index sections contiguous, minimize internal storage used for constructing graph. After construction and during initialization (when indices are being added via InsertGlobalIndices() etc.), the column-
           indices for each row are held in a separate piece of allocated memory. This method moves the column-indices for all rows
           into one large contiguous array and eliminates internal storage that is not needed after graph construction. Calling this
           method can have a significant impact on memory costs and machine performance.

           If this object was constructed in View mode then this method can't make non-contiguous indices contiguous and will
           return a warning code of 1 if the viewed data isn't already contiguous.
           :rtype: int
           :return: Integer error code, set to 0 if successful.


        """
        return _Epetra.CrsGraph_OptimizeStorage(self, *args)

    def ExtractGlobalRowView(self, *args) -> "int":
        return _Epetra.CrsGraph_ExtractGlobalRowView(self, *args)

    def Filled(self, *args) -> "bool":
        r""" If FillComplete() has been called, this query returns true, otherwise it returns false."""
        return _Epetra.CrsGraph_Filled(self, *args)

    def StorageOptimized(self, *args) -> "bool":
        r""" If OptimizeStorage() has been called, this query returns true, otherwise it returns false."""
        return _Epetra.CrsGraph_StorageOptimized(self, *args)

    def IndicesAreGlobal(self, *args) -> "bool":
        r""" If column indices are in global range, this query returns true, otherwise it returns false."""
        return _Epetra.CrsGraph_IndicesAreGlobal(self, *args)

    def IndicesAreLocal(self, *args) -> "bool":
        r""" If column indices are in local range, this query returns true, otherwise it returns false."""
        return _Epetra.CrsGraph_IndicesAreLocal(self, *args)

    def LowerTriangular(self, *args) -> "bool":
        r"""
        If graph is lower triangular in local index space, this query returns true, otherwise it returns false.

        """
        return _Epetra.CrsGraph_LowerTriangular(self, *args)

    def UpperTriangular(self, *args) -> "bool":
        r"""
        If graph is upper triangular in local index space, this query returns true, otherwise it returns false.

        """
        return _Epetra.CrsGraph_UpperTriangular(self, *args)

    def NoDiagonal(self, *args) -> "bool":
        r"""
        If graph has no diagonal entries in global index space, this query returns true, otherwise it returns false.

        """
        return _Epetra.CrsGraph_NoDiagonal(self, *args)

    def MyGlobalRow(self, *args) -> "bool":
        return _Epetra.CrsGraph_MyGlobalRow(self, *args)

    def HaveColMap(self, *args) -> "bool":
        r""" Returns true if we have a well-defined ColMap, and returns false otherwise. """
        return _Epetra.CrsGraph_HaveColMap(self, *args)

    def NumMyRows(self, *args) -> "int":
        r""" Returns the number of matrix rows on this processor."""
        return _Epetra.CrsGraph_NumMyRows(self, *args)

    def NumGlobalRows(self, *args) -> "int":
        r""" Returns the number of matrix rows in global matrix."""
        return _Epetra.CrsGraph_NumGlobalRows(self, *args)

    def NumGlobalRows64(self, *args) -> "long long":
        return _Epetra.CrsGraph_NumGlobalRows64(self, *args)

    def NumMyCols(self, *args) -> "int":
        r"""
        Returns the number of entries in the set of column-indices that appear on this processor. The set of column-indices that appear on this processor is the union of column-indices that
           appear in all local rows. The size of this set isn't available until FillComplete() has been called.

        """
        return _Epetra.CrsGraph_NumMyCols(self, *args)

    def NumGlobalCols(self, *args) -> "int":
        r"""
        Returns the number of matrix columns in global matrix.

        """
        return _Epetra.CrsGraph_NumGlobalCols(self, *args)

    def NumGlobalCols64(self, *args) -> "long long":
        return _Epetra.CrsGraph_NumGlobalCols64(self, *args)

    def NumGlobalNonzeros(self, *args) -> "int":
        r"""
        Returns the number of indices in the global graph. Note that if the graph's maps are defined such that some nonzeros
                   appear on more than one processor, then those nonzeros will be
                   counted more than once. If the user wishes to assemble a graph from
                   overlapping data, they can use Epetra_FECrsGraph.

        """
        return _Epetra.CrsGraph_NumGlobalNonzeros(self, *args)

    def NumGlobalNonzeros64(self, *args) -> "long long":
        return _Epetra.CrsGraph_NumGlobalNonzeros64(self, *args)

    def NumGlobalDiagonals(self, *args) -> "int":
        r"""
        Returns the number of diagonal entries in the global graph, based on global row/column index comparisons.

        """
        return _Epetra.CrsGraph_NumGlobalDiagonals(self, *args)

    def NumGlobalDiagonals64(self, *args) -> "long long":
        return _Epetra.CrsGraph_NumGlobalDiagonals64(self, *args)

    def NumMyDiagonals(self, *args) -> "int":
        r"""
        Returns the number of diagonal entries in the local graph, based on global row/column index comparisons.

        """
        return _Epetra.CrsGraph_NumMyDiagonals(self, *args)

    def NumMyBlockRows(self, *args) -> "int":
        r""" Returns the number of block matrix rows on this processor."""
        return _Epetra.CrsGraph_NumMyBlockRows(self, *args)

    def NumGlobalBlockRows(self, *args) -> "int":
        r""" Returns the number of Block matrix rows in global matrix."""
        return _Epetra.CrsGraph_NumGlobalBlockRows(self, *args)

    def NumGlobalBlockRows64(self, *args) -> "long long":
        return _Epetra.CrsGraph_NumGlobalBlockRows64(self, *args)

    def NumMyBlockCols(self, *args) -> "int":
        r"""
        Returns the number of Block matrix columns on this processor.

        """
        return _Epetra.CrsGraph_NumMyBlockCols(self, *args)

    def NumGlobalBlockCols(self, *args) -> "int":
        r"""
        Returns the number of Block matrix columns in global matrix.

        """
        return _Epetra.CrsGraph_NumGlobalBlockCols(self, *args)

    def NumGlobalBlockCols64(self, *args) -> "long long":
        return _Epetra.CrsGraph_NumGlobalBlockCols64(self, *args)

    def NumMyBlockDiagonals(self, *args) -> "int":
        r"""
        Returns the number of Block diagonal entries in the local graph, based on global row/column index comparisons.

        """
        return _Epetra.CrsGraph_NumMyBlockDiagonals(self, *args)

    def NumGlobalBlockDiagonals(self, *args) -> "int":
        r"""
        Returns the number of Block diagonal entries in the global graph, based on global row/column index comparisons.

        """
        return _Epetra.CrsGraph_NumGlobalBlockDiagonals(self, *args)

    def NumGlobalBlockDiagonals64(self, *args) -> "long long":
        return _Epetra.CrsGraph_NumGlobalBlockDiagonals64(self, *args)

    def NumGlobalEntries(self, *args) -> "int":
        r"""
        Returns the number of entries in the global graph.

        """
        return _Epetra.CrsGraph_NumGlobalEntries(self, *args)

    def NumGlobalEntries64(self, *args) -> "long long":
        return _Epetra.CrsGraph_NumGlobalEntries64(self, *args)

    def NumMyEntries(self, *args) -> "int":
        r"""
        Returns the number of entries on this processor.

        """
        return _Epetra.CrsGraph_NumMyEntries(self, *args)

    def MaxRowDim(self, *args) -> "int":
        r"""
        Returns the max row dimension of block entries on the processor.

        """
        return _Epetra.CrsGraph_MaxRowDim(self, *args)

    def GlobalMaxRowDim(self, *args) -> "int":
        r"""
        Returns the max row dimension of block entries across all processors.

        """
        return _Epetra.CrsGraph_GlobalMaxRowDim(self, *args)

    def MaxColDim(self, *args) -> "int":
        r"""
        Returns the max column dimension of block entries on the processor.

        """
        return _Epetra.CrsGraph_MaxColDim(self, *args)

    def GlobalMaxColDim(self, *args) -> "int":
        r"""
        Returns the max column dimension of block entries across all processors.

        """
        return _Epetra.CrsGraph_GlobalMaxColDim(self, *args)

    def NumMyNonzeros(self, *args) -> "int":
        r"""
        Returns the number of indices in the local graph.

        """
        return _Epetra.CrsGraph_NumMyNonzeros(self, *args)

    def NumGlobalIndices(self, *args) -> "int":
        r""" Returns the current number of nonzero entries in specified global row on this processor."""
        return _Epetra.CrsGraph_NumGlobalIndices(self, *args)

    def NumAllocatedGlobalIndices(self, *args) -> "int":
        r""" Returns the allocated number of nonzero entries in specified global row on this processor."""
        return _Epetra.CrsGraph_NumAllocatedGlobalIndices(self, *args)

    def MaxNumIndices(self, *args) -> "int":
        r"""
        Returns the maximum number of nonzero entries across all rows on this processor.

        """
        return _Epetra.CrsGraph_MaxNumIndices(self, *args)

    def GlobalMaxNumIndices(self, *args) -> "int":
        r"""
        Returns the maximun number of nonzero entries across all rows across all processors.

        """
        return _Epetra.CrsGraph_GlobalMaxNumIndices(self, *args)

    def MaxNumNonzeros(self, *args) -> "int":
        r"""
        Returns the maximum number of nonzero points across all rows on this processor. For each entry in the graph, let i = the GRID of the entry and j = the CGID of the entry.  Then
             the entry size is the product of the rowmap elementsize of i and the colmap elementsize of i.
             Let ki = sum of all entry sizes for the entries in the ith row.
             For example,
                   if the ith block row had 5 block entries and the element size of each entry was 4-by-4, ki would be 80.
             Then this function returns the max over all ki for all row on this processor.


        """
        return _Epetra.CrsGraph_MaxNumNonzeros(self, *args)

    def GlobalMaxNumNonzeros(self, *args) -> "int":
        r"""
        Returns the maximun number of nonzero points across all rows across all processors. This function returns the max over all processor of MaxNumNonzeros().


        """
        return _Epetra.CrsGraph_GlobalMaxNumNonzeros(self, *args)

    def NumMyIndices(self, *args) -> "int":
        r""" Returns the current number of nonzero entries in specified local row on this processor."""
        return _Epetra.CrsGraph_NumMyIndices(self, *args)

    def NumAllocatedMyIndices(self, *args) -> "int":
        r""" Returns the allocated number of nonzero entries in specified local row on this processor."""
        return _Epetra.CrsGraph_NumAllocatedMyIndices(self, *args)

    def IndexBase(self, *args) -> "int":
        r""" Returns the index base for row and column indices for this graph. Index base for this map."""
        return _Epetra.CrsGraph_IndexBase(self, *args)

    def IndexBase64(self, *args) -> "long long":
        return _Epetra.CrsGraph_IndexBase64(self, *args)

    def RowMap(self, *args) -> "Epetra_BlockMap const &":
        r""" Returns the RowMap associated with this graph."""
        return _Epetra.CrsGraph_RowMap(self, *args)

    def ReplaceRowMap(self, *args) -> "int":
        r"""
        Replaces the current RowMap with the user-specified map object, but only
             if currentmap->PointSameAs(newmap) is true. This is a collective function.
             Returns 0 if map is replaced, -1 if not.


        """
        return _Epetra.CrsGraph_ReplaceRowMap(self, *args)

    def ReplaceColMap(self, *args) -> "int":
        r"""
        Replaces the current ColMap with the user-specified map object, but only
                   if no entries have been inserted into the graph yet (both IndicesAreLocal()
             and IndicesAreGlobal() are false) or currentmap->PointSameAs(newmap) is true.
             This is a collective function.
             Returns 0 if map is replaced, -1 if not.


        """
        return _Epetra.CrsGraph_ReplaceColMap(self, *args)

    def ReplaceDomainMapAndImporter(self, *args) -> "int":
        r"""
        Replaces the current DomainMap & Importer with the user-specified map object. Replaces the current DomainMap and Importer with the user-specified map object, but only
             if the matrix has been FillCompleted, Importer's TargetMap matches the ColMap
             and Importer's SourceMap matches the DomainMap (assuming the importer isn't null).  If an Importer
             is passed in, Epetra_CrsMatrix will copy it.
             Returns 0 if map/importer is replaced, -1 if not.


        """
        return _Epetra.CrsGraph_ReplaceDomainMapAndImporter(self, *args)

    def RemoveEmptyProcessesInPlace(self, *args) -> "int":
        r"""
        Remove processes owning zero rows from the Maps and their communicator. Remove processes owning zero rows from the Maps and their communicator.
            Warning: This method is ONLY for use by experts.

            We make NO promises of backwards compatibility.
            This method may change or disappear at any time.

            :param newMap: [in] This *must* be the result of calling
                the removeEmptyProcesses() method on the row BlockMap.  If it
                is not, this method's behavior is undefined.  This pointer
                will be null on excluded processes.
        """
        return _Epetra.CrsGraph_RemoveEmptyProcessesInPlace(self, *args)

    def ColMap(self, *args) -> "Epetra_BlockMap const &":
        r"""
        Returns the Column Map associated with this graph.

        """
        return _Epetra.CrsGraph_ColMap(self, *args)

    def DomainMap(self, *args) -> "Epetra_BlockMap const &":
        r"""
        Returns the DomainMap associated with this graph.

        """
        return _Epetra.CrsGraph_DomainMap(self, *args)

    def RangeMap(self, *args) -> "Epetra_BlockMap const &":
        r"""
        Returns the RangeMap associated with this graph.

        """
        return _Epetra.CrsGraph_RangeMap(self, *args)

    def Importer(self, *args) -> "Epetra_Import const *":
        r""" Returns the Importer associated with this graph."""
        return _Epetra.CrsGraph_Importer(self, *args)

    def Exporter(self, *args) -> "Epetra_Export const *":
        r""" Returns the Exporter associated with this graph."""
        return _Epetra.CrsGraph_Exporter(self, *args)

    def Comm(self, *args) -> "Epetra_Comm const &":
        r""" Returns a pointer to the Epetra_Comm communicator associated with this graph."""
        return _Epetra.CrsGraph_Comm(self, *args)

    def LRID(self, *args) -> "int":
        return _Epetra.CrsGraph_LRID(self, *args)

    def GRID(self, *args) -> "int":
        r""" Returns the global row index for give local row index, returns IndexBase-1 if we don't have this local row."""
        return _Epetra.CrsGraph_GRID(self, *args)

    def GRID64(self, *args) -> "long long":
        return _Epetra.CrsGraph_GRID64(self, *args)

    def LCID(self, *args) -> "int":
        return _Epetra.CrsGraph_LCID(self, *args)

    def GCID(self, *args) -> "int":
        r"""
        Returns the global column index for give local column index, returns IndexBase-1 if we don't have this local column.

        """
        return _Epetra.CrsGraph_GCID(self, *args)

    def GCID64(self, *args) -> "long long":
        return _Epetra.CrsGraph_GCID64(self, *args)

    def MyGRID(self, *args) -> "bool":
        return _Epetra.CrsGraph_MyGRID(self, *args)

    def MyLRID(self, *args) -> "bool":
        r""" Returns true if the LRID passed in belongs to the calling processor in this map, otherwise returns false."""
        return _Epetra.CrsGraph_MyLRID(self, *args)

    def MyGCID(self, *args) -> "bool":
        return _Epetra.CrsGraph_MyGCID(self, *args)

    def MyLCID(self, *args) -> "bool":
        r"""
        Returns true if the LRID passed in belongs to the calling processor in this map, otherwise returns false.

        """
        return _Epetra.CrsGraph_MyLCID(self, *args)

    def PrintGraphData(self, *args) -> "void":
        return _Epetra.CrsGraph_PrintGraphData(self, *args)

    def ImportMap(self, *args) -> "Epetra_BlockMap const &":
        r""" Use ColMap() instead."""
        return _Epetra.CrsGraph_ImportMap(self, *args)

    def TransformToLocal(self, *args) -> "int":
        r"""
        *Overload 1:*
        Use FillComplete() instead.

        |

        *Overload 2:*
        Use FillComplete(const Epetra_BlockMap& DomainMap, const Epetra_BlockMap& RangeMap) instead.
        """
        return _Epetra.CrsGraph_TransformToLocal(self, *args)

    def ReferenceCount(self, *args) -> "int":
        r""" Returns the reference count of CrsGraphData. (Intended for testing purposes.)"""
        return _Epetra.CrsGraph_ReferenceCount(self, *args)

    def DataPtr(self, *args) -> "Epetra_CrsGraphData const *":
        r""" Returns a pointer to the CrsGraphData instance this CrsGraph uses. (Intended for developer use only for testing purposes.)"""
        return _Epetra.CrsGraph_DataPtr(self, *args)

    def ExpertExtractIndexOffset(self, *args) -> "Epetra_IntSerialDenseVector &":
        r"""
        Returns a reference to the Epetra_IntSerialDenseVector used to hold the local IndexOffsets (CRS rowptr)
           Warning: This method is intended for experts only, its use may require user code modifications in future versions of Epetra.
        """
        return _Epetra.CrsGraph_ExpertExtractIndexOffset(self, *args)

    def ExpertExtractIndices(self, *args) -> "Epetra_IntSerialDenseVector &":
        r"""
        Returns a reference to the Epetra_IntSerialDenseVector used to hold the local All_Indices (CRS colind)
           Warning: This method is intended for experts only, its use may require user code modifications in future versions of Epetra.
        """
        return _Epetra.CrsGraph_ExpertExtractIndices(self, *args)

    def SortGhostsAssociatedWithEachProcessor(self, *args) -> "void":
        r"""
        Forces FillComplete() to locally order ghostnodes associated with each remote processor in ascending order. To be compliant with AztecOO, FillComplete() already locally orders ghostnodes such that
                   information received from processor k has a lower local numbering than information received
                   from processor j if k is less than j.  SortGhostsAssociatedWithEachProcessor(True) further
                   forces FillComplete() to locally number all ghostnodes received from processor k in ascending
                   order. That is, the local numbering of b is less than c if the global numbering of b is less
                   than c and if both b and c are owned by the same processor. This is done to be compliant with
                   some limited block features within ML. In particular, some ML features require that a block
                   structure of the matrix be maintained even within the ghost variables.
        """
        return _Epetra.CrsGraph_SortGhostsAssociatedWithEachProcessor(self, *args)

    def __init__(self, *args):
        r"""

        __init__(self, Epetra_DataAccess CV, BlockMap rowMap, int numIndicesPerRow,
            bool staticProfile=False) -> CrsGraph

          Constructor with implicit column map and constant indices per row.
          Arguments:

            CV                - Epetra.Copy or Epetra.View
            rowMap            - Map describing distribution of rows across processors
            numIndicesPerRow  - Integer number of indices per row
            staticProfile     - Static profile flag
        __init__(self, Epetra_DataAccess CV, BlockMap rowMap, BlockMap colMap,
            int numIndicesPerRow, bool staticProfile=False) -> CrsGraph

          Constructor with specified column map and constant indices per row.
          Arguments:

            CV                - Epetra.Copy or Epetra.View
            rowMap            - Map describing distribution of rows across processors
            colMap            - Map describing distribution of columns across processors
            numIndicesPerRow  - Integer number of indices per row
            staticProfile     - Static profile flag
        __init__(self, CrsGraph graph) -> CrsGraph

          Copy constructor.  Arguments:

            graph - Source graph for copy constructor
        __init__(self, Epetra_DataAccess CV, BlockMap rowMap, PySequence
            numIndicesPerRow, bool staticProfile=False) -> CrsGraph

          Constructor with implicit column map and variable indices per row.
          Arguments:

            CV                - Epetra.Copy or Epetra.View
            rowMap            - Map describing distribution of rows across processors
            numIndicesPerRow  - Sequence of integers representing the number of indices
                                per row
            staticProfile     - Static profile flag
        __init__(self, Epetra_DataAccess CV, BlockMap rowMap, BlockMap colMap,
            PySequence numIndicesPerRow, bool staticProfile=False) -> CrsGraph

          Constructor with specified column map and variable indices per row.
          Arguments:

            CV                - Epetra.Copy or Epetra.View
            rowMap            - Map describing distribution of rows across processors
            colMap            - Map describing distribution of columns across processors
            numIndicesPerRow  - Sequence of integers representing the number of indices
                                per row
            staticProfile     - Static profile flag
        """
        _Epetra.CrsGraph_swiginit(self, _Epetra.new_CrsGraph(*args))

    def ExtractGlobalRowCopy(self, *args) -> "PyObject *":
        return _Epetra.CrsGraph_ExtractGlobalRowCopy(self, *args)

    def __getitem__(self, *args) -> "int *":
        return _Epetra.CrsGraph___getitem__(self, *args)

    def ExtractMyRowCopy(self, *args) -> "PyObject *":
        return _Epetra.CrsGraph_ExtractMyRowCopy(self, *args)

# Register CrsGraph in _Epetra:
_Epetra.CrsGraph_swigregister(CrsGraph)

class OffsetIndex(Object):
    r"""
    Epetra_OffsetIndex: This class builds index for efficient mapping of data from one Epetra_CrsGraph based object to another. Epetra_OffsetIndex generates and index of offsets allowing direct access to data
    for Import/Export operations on Epetra_CrsGraph based objects such as Epetra_CrsMatrix.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        *Overload 1:*
        Constructs a Epetra_OffsetIndex object from the graphs and an importer.

        |

        *Overload 2:*
        Constructs a Epetra_OffsetIndex object from the graphs and an exporter.

        |

        *Overload 3:*
        Epetra_OffsetIndex copy constructor.
        """
        _Epetra.OffsetIndex_swiginit(self, _Epetra.new_OffsetIndex(*args))
    __swig_destroy__ = _Epetra.delete_OffsetIndex

    def SameOffsets(self, *args) -> "int **":
        r""" Accessor"""
        return _Epetra.OffsetIndex_SameOffsets(self, *args)

    def PermuteOffsets(self, *args) -> "int **":
        r""" Accessor"""
        return _Epetra.OffsetIndex_PermuteOffsets(self, *args)

    def RemoteOffsets(self, *args) -> "int **":
        r""" Accessor"""
        return _Epetra.OffsetIndex_RemoteOffsets(self, *args)
    NumSame_ = property(_Epetra.OffsetIndex_NumSame__get, _Epetra.OffsetIndex_NumSame__set)
    SameOffsets_ = property(_Epetra.OffsetIndex_SameOffsets__get, _Epetra.OffsetIndex_SameOffsets__set)
    NumPermute_ = property(_Epetra.OffsetIndex_NumPermute__get, _Epetra.OffsetIndex_NumPermute__set)
    PermuteOffsets_ = property(_Epetra.OffsetIndex_PermuteOffsets__get, _Epetra.OffsetIndex_PermuteOffsets__set)
    NumExport_ = property(_Epetra.OffsetIndex_NumExport__get, _Epetra.OffsetIndex_NumExport__set)
    NumRemote_ = property(_Epetra.OffsetIndex_NumRemote__get, _Epetra.OffsetIndex_NumRemote__set)
    RemoteOffsets_ = property(_Epetra.OffsetIndex_RemoteOffsets__get, _Epetra.OffsetIndex_RemoteOffsets__set)
    DataOwned_ = property(_Epetra.OffsetIndex_DataOwned__get, _Epetra.OffsetIndex_DataOwned__set)

# Register OffsetIndex in _Epetra:
_Epetra.OffsetIndex_swigregister(OffsetIndex)

class Operator(object):
    r"""

    For cross-language polymorphism to work in python, you must call this
    constructor::

        from PyTrilinos import Epetra
        class MyOperator(Epetra.Operator):
            def __init__(self):
                Epetra.Operator.__init__(self)

    Other than that, the Epetra.Operator class is much more forgiving than
    its C++ counterpart.  Often, you can override just the Label() and
    Apply() methods.

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    __swig_destroy__ = _Epetra.delete_Operator

    def SetUseTranspose(self, *args) -> "int":
        r"""
        If set true, transpose of this operator will be applied. This flag allows the transpose of the given operator to be used implicitly.  Setting this flag
               affects only the Apply() and ApplyInverse() methods.  If the implementation of this interface
        does not support transpose use, this method should return a value of -1.

           :param In:
           	   UseTranspose -If true, multiply by the transpose of operator, otherwise just use operator.

           :rtype: int
           :return: Integer error code, set to 0 if successful.  Set to -1 if this implementation does not support transpose.
        """
        return _Epetra.Operator_SetUseTranspose(self, *args)

    def Apply(self, *args) -> "int":
        r"""
        Apply(self, MultiVector x, MultiVector y) -> int

        In C++, the Apply() method is pure virtual, thus intended to be
        overridden by derived classes.  In python, cross-language polymorphism
        is supported, and you are expected to derive classes from this base
        class and redefine the Apply() method.  C++ code (e.g., AztecOO
        solvers) can call back to your Apply() method as needed.  You must
        support two arguments, labeled here MultiVector x and MultiVector y.
        These will be converted from Epetra_MultiVector C++ objects to
        numpy-hybrid Epetra.MultiVector objects before they are passed to you.
        Thus, it is legal to use slice indexing and other numpy features to
        compute y from x.

        If application of your operator is successful, return 0; else return
        some non-zero error code.

        It is strongly suggested that you prevent Apply() from raising any
        exceptions.  Accidental errors can be prevented by wrapping your code
        in a try block:

            try:
                # Your code goes here...
            except Exception, e:
                print 'A python exception was raised by method Apply:'
                print e
                return -1

        By returning a -1, you inform the calling routine that Apply() was
        unsuccessful.

        """
        return _Epetra.Operator_Apply(self, *args)

    def ApplyInverse(self, *args) -> "int":
        r"""
        ApplyInverse(self, MultiVector x, MultiVector y) -> int

        In C++, the ApplyInverse() method is pure virtual, thus intended to be
        overridden by derived classes.  In python, cross-language polymorphism
        is supported, and you are expected to derive classes from this base
        class and redefine the ApplyInverse() method.  C++ code (e.g., AztecOO
        solvers) can call back to your ApplyInverse() method as needed.  You
        must support two arguments, labeled here MultiVector x and MultiVector
        y.  These will be converted from Epetra_MultiVector C++ objects to
        numpy-hybrid Epetra.MultiVector objects before they are passed to you.
        Thus, it is legal to use slice indexing and other numpy features to
        compute y from x.

        If application of your operator is successful, return 0; else return
        some non-zero error code.

        It is strongly suggested that you prevent ApplyInverse() from raising
        any exceptions.  Accidental errors can be prevented by wrapping your
        code in a try block:

            try:
                # Your code goes here...
            except Exception, e:
                print 'A python exception was raised by method ApplyInverse:'
                print e
                return -1

        By returning a -1, you inform the calling routine that ApplyInverse()
        was unsuccessful.

        """
        return _Epetra.Operator_ApplyInverse(self, *args)

    def NormInf(self, *args) -> "double":
        r""" Returns the infinity norm of the global matrix."""
        return _Epetra.Operator_NormInf(self, *args)

    def Label(self, *args) -> "char const *":
        r""" Returns a character string describing the operator"""
        return _Epetra.Operator_Label(self, *args)

    def UseTranspose(self, *args) -> "bool":
        r""" Returns the current UseTranspose setting."""
        return _Epetra.Operator_UseTranspose(self, *args)

    def HasNormInf(self, *args) -> "bool":
        r""" Returns true if the *this* object can provide an approximate Inf-norm, false otherwise."""
        return _Epetra.Operator_HasNormInf(self, *args)

    def Comm(self, *args) -> "Epetra_Comm const &":
        r""" Returns a pointer to the Epetra_Comm communicator associated with this operator."""
        return _Epetra.Operator_Comm(self, *args)

    def OperatorDomainMap(self, *args) -> "Epetra_Map const &":
        r""" Returns the Epetra_Map object associated with the domain of this operator."""
        return _Epetra.Operator_OperatorDomainMap(self, *args)

    def OperatorRangeMap(self, *args) -> "Epetra_Map const &":
        r""" Returns the Epetra_Map object associated with the range of this operator."""
        return _Epetra.Operator_OperatorRangeMap(self, *args)

    def __init__(self, *args):
        r"""

        For cross-language polymorphism to work in python, you must call this
        constructor::

            from PyTrilinos import Epetra
            class MyOperator(Epetra.Operator):
                def __init__(self):
                    Epetra.Operator.__init__(self)

        Other than that, the Epetra.Operator class is much more forgiving than
        its C++ counterpart.  Often, you can override just the Label() and
        Apply() methods.

        """
        if self.__class__ == Operator:
            _self = None
        else:
            _self = self
        _Epetra.Operator_swiginit(self, _Epetra.new_Operator(_self, *args))
    def __disown__(self):
        self.this.disown()
        _Epetra.disown_Operator(self)
        return weakref.proxy(self)

# Register Operator in _Epetra:
_Epetra.Operator_swigregister(Operator)

class InvOperator(Operator):
    r"""
    Epetra_InvOperator: An implementation of the Epetra_Operator class that reverses the role of Apply() and ApplyInverse() methods. The Epetra_InvOperator class implements Epetra_Operator using another pre-constructed Epetra_Operator object.
       Once constructed, an Epetra_InvOperator can be used as the inverse of the input operator
       object as long as the appropriate Apply and ApplyInverse methods are implemented in the original Epetra_Operator object.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        Uses an Epetra_Operator instance to implement the Epetra_Operator interface. Facilitates the use of an Epetra_Operator instance as an inverse operator.
           :param In: - A fully-constructed Epetra_Operator object.
        """
        if self.__class__ == InvOperator:
            _self = None
        else:
            _self = self
        _Epetra.InvOperator_swiginit(self, _Epetra.new_InvOperator(_self, *args))
    __swig_destroy__ = _Epetra.delete_InvOperator

    def SetUseTranspose(self, *args) -> "int":
        r"""
        If set true, transpose of this operator will be applied. This flag allows the transpose of the given operator to be used implicitly.  Setting this flag
               affects only the Apply() and ApplyInverse() methods.  If the implementation of this interface
        does not support transpose use, this method should return a value of -1.

           :param In:
           	   UseTranspose_in - If true, multiply by the transpose of operator, otherwise just use operator.

           Warning: - This method has no effect and returns -1 as error code.
        """
        return _Epetra.InvOperator_SetUseTranspose(self, *args)

    def Apply(self, *args) -> "int":
        r"""
        Apply(self, MultiVector x, MultiVector y) -> int

        In C++, the Apply() method is pure virtual, thus intended to be
        overridden by derived classes.  In python, cross-language polymorphism
        is supported, and you are expected to derive classes from this base
        class and redefine the Apply() method.  C++ code (e.g., AztecOO
        solvers) can call back to your Apply() method as needed.  You must
        support two arguments, labeled here MultiVector x and MultiVector y.
        These will be converted from Epetra_MultiVector C++ objects to
        numpy-hybrid Epetra.MultiVector objects before they are passed to you.
        Thus, it is legal to use slice indexing and other numpy features to
        compute y from x.

        If application of your operator is successful, return 0; else return
        some non-zero error code.

        It is strongly suggested that you prevent Apply() from raising any
        exceptions.  Accidental errors can be prevented by wrapping your code
        in a try block:

            try:
                # Your code goes here...
            except Exception, e:
                print 'A python exception was raised by method Apply:'
                print e
                return -1

        By returning a -1, you inform the calling routine that Apply() was
        unsuccessful.

        """
        return _Epetra.InvOperator_Apply(self, *args)

    def ApplyInverse(self, *args) -> "int":
        r"""
        ApplyInverse(self, MultiVector x, MultiVector y) -> int

        In C++, the ApplyInverse() method is pure virtual, thus intended to be
        overridden by derived classes.  In python, cross-language polymorphism
        is supported, and you are expected to derive classes from this base
        class and redefine the ApplyInverse() method.  C++ code (e.g., AztecOO
        solvers) can call back to your ApplyInverse() method as needed.  You
        must support two arguments, labeled here MultiVector x and MultiVector
        y.  These will be converted from Epetra_MultiVector C++ objects to
        numpy-hybrid Epetra.MultiVector objects before they are passed to you.
        Thus, it is legal to use slice indexing and other numpy features to
        compute y from x.

        If application of your operator is successful, return 0; else return
        some non-zero error code.

        It is strongly suggested that you prevent ApplyInverse() from raising
        any exceptions.  Accidental errors can be prevented by wrapping your
        code in a try block:

            try:
                # Your code goes here...
            except Exception, e:
                print 'A python exception was raised by method ApplyInverse:'
                print e
                return -1

        By returning a -1, you inform the calling routine that ApplyInverse()
        was unsuccessful.

        """
        return _Epetra.InvOperator_ApplyInverse(self, *args)

    def NormInf(self, *args) -> "double":
        r""" Returns the infinity norm of the global matrix."""
        return _Epetra.InvOperator_NormInf(self, *args)

    def Label(self, *args) -> "char const *":
        r""" Returns a character std::string describing the operator"""
        return _Epetra.InvOperator_Label(self, *args)

    def Operator(self, *args) -> "Epetra_Operator *":
        r""" Returns a pointer to the Epetra_Operator operator object that was used to create this Epetra_InvOperator object."""
        return _Epetra.InvOperator_Operator(self, *args)

    def UseTranspose(self, *args) -> "bool":
        r""" Returns the current UseTranspose setting."""
        return _Epetra.InvOperator_UseTranspose(self, *args)

    def HasNormInf(self, *args) -> "bool":
        r""" Returns true if the *this* object can provide an approximate Inf-norm, false otherwise."""
        return _Epetra.InvOperator_HasNormInf(self, *args)

    def Comm(self, *args) -> "Epetra_Comm const &":
        r""" Returns a pointer to the Epetra_Comm communicator associated with this operator."""
        return _Epetra.InvOperator_Comm(self, *args)

    def OperatorDomainMap(self, *args) -> "Epetra_Map const &":
        r""" Returns the Epetra_BlockMap object associated with the domain of this matrix operator."""
        return _Epetra.InvOperator_OperatorDomainMap(self, *args)

    def OperatorRangeMap(self, *args) -> "Epetra_Map const &":
        r""" Returns the Epetra_BlockMap object associated with the range of this matrix operator."""
        return _Epetra.InvOperator_OperatorRangeMap(self, *args)
    def __disown__(self):
        self.this.disown()
        _Epetra.disown_InvOperator(self)
        return weakref.proxy(self)

# Register InvOperator in _Epetra:
_Epetra.InvOperator_swigregister(InvOperator)

class RowMatrix(Operator, SrcDistObject):
    r"""
    Epetra_RowMatrix: A pure virtual class for using real-valued double-precision row matrices. The Epetra_RowMatrix class is a pure virtual class (specifies interface only) that
       enable the use of real-valued double-precision sparse matrices
       where matrix entries are intended for row access.  It is currently implemented by both the
       Epetra_CrsMatrix and Epetra_VbrMatrix classes.


    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    __swig_destroy__ = _Epetra.delete_RowMatrix

    def NumMyRowEntries(self, *args) -> "int":
        r"""
        NumMyRowEntries(int myRow, numpy.ndarray numEntries) -> int

        In C++, numEntries in an int&.  In python, it is provided to you as a
        numpy array of length one so that you can set its value in-place using
        numEntries[0] = ....
        """
        return _Epetra.RowMatrix_NumMyRowEntries(self, *args)

    def MaxNumEntries(self, *args) -> "int":
        r""" Returns the maximum of NumMyRowEntries() over all rows."""
        return _Epetra.RowMatrix_MaxNumEntries(self, *args)

    def ExtractMyRowCopy(self, *args) -> "int":
        r"""
        ExtractMyRowCopy(int myRow, int length, numpy.ndarray numEntries,
            numpy.ndarray values, numpy.ndarray indices) -> int

        In C++, numEntries in an int&.  In python, it is provided to you as a
        numpy array of length one so that you can set its value in-place using
        numEntries[0] = ....

        Arguments values and indices are double* and int*, respectively, in
        C++.  In python, these are provided to you as numpy arrays of the
        given length, so that you may alter their entries in-place.
        """
        return _Epetra.RowMatrix_ExtractMyRowCopy(self, *args)

    def ExtractDiagonalCopy(self, *args) -> "int":
        r"""
        ExtractDiagonalCopy(Vector diagonal) -> int

        Argument diagonal is provided to you as a numpy-hybrid Epetra.Vector,
        giving you access to the numpy interface in addition to the
        Epetra_Vector C++ interface.
        """
        return _Epetra.RowMatrix_ExtractDiagonalCopy(self, *args)

    def Multiply(self, *args) -> "int":
        r"""
        Multiply(bool useTranspose, MultiVector x, MultiVector y) -> int

        In C++, arguments x and y are Epetra_MultiVectors.  In python, they
        are provided to you as numpy-hybrid Epetra.MultiVectors, giving you
        access to the numpy interface in addition to the Epetra_MultiVector
        C++ interface.
        """
        return _Epetra.RowMatrix_Multiply(self, *args)

    def Solve(self, *args) -> "int":
        r"""
        Solve((bool upper, bool trans, bool unitDiagonal, MultiVector x,
            MultiVector y) -> int

        In C++, arguments x and y are Epetra_MultiVectors.  In python, they
        are provided to you as numpy-hybrid Epetra.MultiVectors, giving you
        access to the numpy interface in addition to the Epetra_MultiVector
        C++ interface.
        """
        return _Epetra.RowMatrix_Solve(self, *args)

    def InvRowSums(self, *args) -> "int":
        r"""
        InvRowSums(Vector x) -> int

        Argument x is provided to you as a numpy-hybrid Epetra.Vector, giving
        you access to the numpy interface in addition to the Epetra_Vector C++
        interface.
        """
        return _Epetra.RowMatrix_InvRowSums(self, *args)

    def LeftScale(self, *args) -> "int":
        r"""
        LeftScale(Vector x) -> int

        Argument x is provided to you as a numpy-hybrid Epetra.Vector, giving
        you access to the numpy interface in addition to the Epetra_Vector C++
        interface.
        """
        return _Epetra.RowMatrix_LeftScale(self, *args)

    def InvColSums(self, *args) -> "int":
        r"""
        InvColSums(Vector x) -> int

        Argument x is provided to you as a numpy-hybrid Epetra.Vector, giving
        you access to the numpy interface in addition to the Epetra_Vector C++
        interface.
        """
        return _Epetra.RowMatrix_InvColSums(self, *args)

    def RightScale(self, *args) -> "int":
        r"""
        RightScale(Vector x) -> int

        Argument x is provided to you as a numpy-hybrid Epetra.Vector, giving
        you access to the numpy interface in addition to the Epetra_Vector C++
        interface.
        """
        return _Epetra.RowMatrix_RightScale(self, *args)

    def Filled(self, *args) -> "bool":
        r""" If FillComplete() has been called, this query returns true, otherwise it returns false."""
        return _Epetra.RowMatrix_Filled(self, *args)

    def NormInf(self, *args) -> "double":
        r""" Returns the infinity norm of the global matrix."""
        return _Epetra.RowMatrix_NormInf(self, *args)

    def NormOne(self, *args) -> "double":
        r""" Returns the one norm of the global matrix."""
        return _Epetra.RowMatrix_NormOne(self, *args)

    def NumGlobalNonzeros(self, *args) -> "int":
        r""" Returns the number of nonzero entries in the global matrix."""
        return _Epetra.RowMatrix_NumGlobalNonzeros(self, *args)

    def NumGlobalNonzeros64(self, *args) -> "long long":
        return _Epetra.RowMatrix_NumGlobalNonzeros64(self, *args)

    def NumGlobalRows(self, *args) -> "int":
        r""" Returns the number of global matrix rows."""
        return _Epetra.RowMatrix_NumGlobalRows(self, *args)

    def NumGlobalRows64(self, *args) -> "long long":
        return _Epetra.RowMatrix_NumGlobalRows64(self, *args)

    def NumGlobalCols(self, *args) -> "int":
        r""" Returns the number of global matrix columns."""
        return _Epetra.RowMatrix_NumGlobalCols(self, *args)

    def NumGlobalCols64(self, *args) -> "long long":
        return _Epetra.RowMatrix_NumGlobalCols64(self, *args)

    def NumGlobalDiagonals(self, *args) -> "int":
        r""" Returns the number of global nonzero diagonal entries, based on global row/column index comparisons."""
        return _Epetra.RowMatrix_NumGlobalDiagonals(self, *args)

    def NumGlobalDiagonals64(self, *args) -> "long long":
        return _Epetra.RowMatrix_NumGlobalDiagonals64(self, *args)

    def NumMyNonzeros(self, *args) -> "int":
        r""" Returns the number of nonzero entries in the calling processor's portion of the matrix."""
        return _Epetra.RowMatrix_NumMyNonzeros(self, *args)

    def NumMyRows(self, *args) -> "int":
        r""" Returns the number of matrix rows owned by the calling processor."""
        return _Epetra.RowMatrix_NumMyRows(self, *args)

    def NumMyCols(self, *args) -> "int":
        r""" Returns the number of matrix columns owned by the calling processor."""
        return _Epetra.RowMatrix_NumMyCols(self, *args)

    def NumMyDiagonals(self, *args) -> "int":
        r""" Returns the number of local nonzero diagonal entries, based on global row/column index comparisons."""
        return _Epetra.RowMatrix_NumMyDiagonals(self, *args)

    def LowerTriangular(self, *args) -> "bool":
        r""" If matrix is lower triangular in local index space, this query returns true, otherwise it returns false."""
        return _Epetra.RowMatrix_LowerTriangular(self, *args)

    def UpperTriangular(self, *args) -> "bool":
        r""" If matrix is upper triangular in local index space, this query returns true, otherwise it returns false."""
        return _Epetra.RowMatrix_UpperTriangular(self, *args)

    def RowMatrixRowMap(self, *args) -> "Epetra_Map const &":
        r""" Returns the Epetra_Map object associated with the rows of this matrix."""
        return _Epetra.RowMatrix_RowMatrixRowMap(self, *args)

    def RowMatrixColMap(self, *args) -> "Epetra_Map const &":
        r""" Returns the Epetra_Map object associated with the columns of this matrix."""
        return _Epetra.RowMatrix_RowMatrixColMap(self, *args)

    def RowMatrixImporter(self, *args) -> "Epetra_Import const *":
        r""" Returns the Epetra_Import object that contains the import operations for distributed operations."""
        return _Epetra.RowMatrix_RowMatrixImporter(self, *args)

    def __init__(self, *args):
        if self.__class__ == RowMatrix:
            _self = None
        else:
            _self = self
        _Epetra.RowMatrix_swiginit(self, _Epetra.new_RowMatrix(_self, *args))
    def __disown__(self):
        self.this.disown()
        _Epetra.disown_RowMatrix(self)
        return weakref.proxy(self)

# Register RowMatrix in _Epetra:
_Epetra.RowMatrix_swigregister(RowMatrix)

class BasicRowMatrix(CompObject, Object, RowMatrix):
    r"""
     Epetra_BasicRowMatrix: A class for simplifying the development of Epetra_RowMatrix adapters. The Epetra_BasicRowMatrix is an adapter class for Epetra_RowMatrix that implements most of the Epetra_RowMatrix
        methods using reasonable default implementations.  The Epetra_RowMatrix class has 39 pure virtual methods, requiring
        the adapter class to implement all of them.
        Epetra_BasicRowMatrix has only 4 pure virtual methods that must be implemented (See Epetra_JadMatrix for an example):

    *  ExtractMyRowCopy: Provide a row of values and indices for a specified local row.
    *  ExtractMyEntryView (const and non-const versions): Provide the memory address of the ith nonzero term stored on the
         calling processor, along with its corresponding local row and column index, where i goes from 0 to the NumMyNonzeros()-1.
         The order in which the nonzeros are traversed is not specified and is up to the adapter implementation.
    *  NumMyRowEntries: Provide the number of entries for a specified local row.


         An alternative is possible if you do not want to provide a non-trivial implementation of the ExtraMyEntryView
         methods (See Epetra_VbrRowMatrix for an example):

    *  Implement ExtractMyRowCopy and NumMyRowEntries as above.
    *  Implement ExtractMyEntryView (both versions) returning a -1 integer code with no other executable code.
    *  Implement the RightScale and LeftScale methods non-trivially.


    In addition, most adapters will probably re-implement the Multiply() method and perhaps the Solve() method, although one or the other
    may be implemented to return -1, signaling that there is no valid implementation.  By default, the Multiply() method is implemented using
    ExtractMyRowCopy, which can usual be improved upon.  By default Solve() and ApplyInverse() are implemented to return -1 (not implemented).

    All other implemented methods in Epetra_BasicRowMatrix should not exhibit a signficant performance degradation, either because they are relatively
    small and fast, or because they are not a significant portion of the runtime for most codes.  All methods are virtual, so they can be re-implemented
    by the adapter.

    In addition to implementing the above methods, an adapter must inherit the Epetra_BasicRowMatrix interface and call the Epetra_BasicRowMatrix
    constructor as part of the adapter constructor.  There are two constructors.  The first requires the user to pass in the RowMap and ColMap, both
    of which are Epetra_Map objects.  On each processor the RowMap (ColMap) must contain the global IDs (GIDs) of the rows (columns) that the processor cares about.
    The first constructor requires only these two maps, assuming that the RowMap will also serve as the DomainMap and RangeMap.  In this case, the
    RowMap must be 1-to-1, meaning that if a global ID appears on one processor, it appears only once on that processor and does not appear on any other
    processor.  For many sparse matrix data structures, it is the case that a given row is completely owned by one processor and that the global matrix
    is square.  The first constructor is for this situation.

    The second constructor allows the caller to specify all four maps.  In this case the DomainMap, the layout of multivectors/vectors that are in the
    domain of the matrix (the x vector if computing y = A*x), must be 1-to-1.  Also, the RangeMap, the layout of y must be 1-to-1.  The RowMap and ColMap
    do not need to be 1-to-1, but the GIDs must be found in the RangeMap and DomainMap, respectively.

    Note that Epetra_Operator is a base class for Epetra_RowMatrix, so any adapter
    for Epetra_BasicRowMatrix (or Epetra_RowMatrix) is also an adapter for Epetra_Operator.

    An example of how to provide an adapter for Epetra_BasicRowMatrix can be found by looking at Epetra_JadMatrix.

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        Epetra_BasicRowMatrix constructor.

            This constructor requires a valid Epetra_Comm object as its only argument.  The constructor will use Comm to build
            Epetra_Maps objects: RowMap, ColMap, DomainMap and RangeMap.  However, these will be zero-length (trivial) maps that
            *must* be reset by calling one of the two SetMap() methods listed below.
            :type Comm: :py:class:`Epetra_Comm`
            :param Comm: [in] An Epetra_Comm containing a valid Comm object.
        """
        if self.__class__ == BasicRowMatrix:
            _self = None
        else:
            _self = self
        _Epetra.BasicRowMatrix_swiginit(self, _Epetra.new_BasicRowMatrix(_self, *args))
    __swig_destroy__ = _Epetra.delete_BasicRowMatrix

    def SetMaps(self, *args) -> "void":
        r"""
        *Overload 1:*
        Set maps (Version 1); call this function or the next, but not both.

            This method takes a row and column map.  On each processor these maps describe the global rows and columns, resp,
            that the processor will care about.  Note that the ColMap does not have to be one-to-one.  In other words, a column ID can appear
            on more than one processor.  The RowMap *must* be 1-to-1.
            :type RowMap: :py:class:`Epetra_Map`
            :param RowMap: [in] An Epetra_Map containing on each processor a list of GIDs of rows that the processor cares about.
            :type ColMap: :py:class:`Epetra_Map`
            :param ColMap: [in] An Epetra_Map containing on each processor a list of GIDs of columns that the processor cares about.

            In this method, the domain and range maps are assumed to be the same as the row map.  Note that this requires that
            the global matrix be square.  If the matrix is not square, or the domain vectors or range vectors do not have the same layout
            as the rows, then the second constructor should be called.

        |

        *Overload 2:*
        Set maps (Version 2); call this function or the previous, but not both.

            This constructor takes a row, column, domain and range map.  On each processor these maps describe the global rows, columns, domain
            and range, resp, that the processor will care about.  The domain and range maps must be one-to-one, but note that the row and column
            maps do not have to be one-to-one.  In other words, a row ID can appear
            on more than one processor, as can a column ID.
            :type RowMap: :py:class:`Epetra_Map`
            :param RowMap: [in] An Epetra_Map containing on each processor a list of GIDs of rows that the processor cares about.
            :type ColMap: :py:class:`Epetra_Map`
            :param ColMap: [in] An Epetra_Map containing on each processor a list of GIDs of columns that the processor cares about.
            :type DomainMap: :py:class:`Epetra_Map`
            :param DomainMap: [in] An Epetra_Map describing the distribution of domain vectors and multivectors.
            :type RangeMap: :py:class:`Epetra_Map`
            :param RangeMap: [in] An Epetra_Map describing the distribution of range vectors and multivectors.
        """
        return _Epetra.BasicRowMatrix_SetMaps(self, *args)

    def ExtractMyRowCopy(self, *args) -> "int":
        r"""
        ExtractMyRowCopy(int myRow, int length, numpy.ndarray numEntries,
            numpy.ndarray values, numpy.ndarray indices) -> int

        In C++, numEntries in an int&.  In python, it is provided to you as a
        numpy array of length one so that you can set its value in-place using
        numEntries[0] = ....

        Arguments values and indices are double* and int*, respectively, in
        C++.  In python, these are provided to you as numpy arrays of the
        given length, so that you may alter their entries in-place.
        """
        return _Epetra.BasicRowMatrix_ExtractMyRowCopy(self, *args)

    def ExtractMyEntryView(self, *args) -> "int":
        r"""
        Returns a reference to the ith entry in the matrix, along with its row and column index.
           :type CurEntry: int
           :param CurEntry: (In) - Index of local entry (from 0 to NumMyNonzeros()-1) to extract.
           :type Value: float
           :param Value: (Out) - Extracted reference to current values.
           :type RowIndex: int
           :param RowIndex: (Out) - Row index for current entry.
           :type ColIndex: int
           :param ColIndex: (Out) - Column index for current entry.

           :rtype: int
           :return: Integer error code, set to 0 if successful, set to -1 if CurEntry not valid.
        """
        return _Epetra.BasicRowMatrix_ExtractMyEntryView(self, *args)

    def NumMyRowEntries(self, *args) -> "int":
        r"""
        NumMyRowEntries(int myRow, numpy.ndarray numEntries) -> int

        In C++, numEntries in an int&.  In python, it is provided to you as a
        numpy array of length one so that you can set its value in-place using
        numEntries[0] = ....
        """
        return _Epetra.BasicRowMatrix_NumMyRowEntries(self, *args)

    def Multiply(self, *args) -> "int":
        r"""
        Multiply(bool useTranspose, MultiVector x, MultiVector y) -> int

        In C++, arguments x and y are Epetra_MultiVectors.  In python, they
        are provided to you as numpy-hybrid Epetra.MultiVectors, giving you
        access to the numpy interface in addition to the Epetra_MultiVector
        C++ interface.
        """
        return _Epetra.BasicRowMatrix_Multiply(self, *args)

    def Solve(self, *args) -> "int":
        r"""
        Solve((bool upper, bool trans, bool unitDiagonal, MultiVector x,
            MultiVector y) -> int

        In C++, arguments x and y are Epetra_MultiVectors.  In python, they
        are provided to you as numpy-hybrid Epetra.MultiVectors, giving you
        access to the numpy interface in addition to the Epetra_MultiVector
        C++ interface.
        """
        return _Epetra.BasicRowMatrix_Solve(self, *args)

    def ExtractDiagonalCopy(self, *args) -> "int":
        r"""
        ExtractDiagonalCopy(Vector diagonal) -> int

        Argument diagonal is provided to you as a numpy-hybrid Epetra.Vector,
        giving you access to the numpy interface in addition to the
        Epetra_Vector C++ interface.
        """
        return _Epetra.BasicRowMatrix_ExtractDiagonalCopy(self, *args)

    def InvRowSums(self, *args) -> "int":
        r"""
        InvRowSums(Vector x) -> int

        Argument x is provided to you as a numpy-hybrid Epetra.Vector, giving
        you access to the numpy interface in addition to the Epetra_Vector C++
        interface.
        """
        return _Epetra.BasicRowMatrix_InvRowSums(self, *args)

    def LeftScale(self, *args) -> "int":
        r"""
        LeftScale(Vector x) -> int

        Argument x is provided to you as a numpy-hybrid Epetra.Vector, giving
        you access to the numpy interface in addition to the Epetra_Vector C++
        interface.
        """
        return _Epetra.BasicRowMatrix_LeftScale(self, *args)

    def InvColSums(self, *args) -> "int":
        r"""
        InvColSums(Vector x) -> int

        Argument x is provided to you as a numpy-hybrid Epetra.Vector, giving
        you access to the numpy interface in addition to the Epetra_Vector C++
        interface.
        """
        return _Epetra.BasicRowMatrix_InvColSums(self, *args)

    def RightScale(self, *args) -> "int":
        r"""
        RightScale(Vector x) -> int

        Argument x is provided to you as a numpy-hybrid Epetra.Vector, giving
        you access to the numpy interface in addition to the Epetra_Vector C++
        interface.
        """
        return _Epetra.BasicRowMatrix_RightScale(self, *args)

    def Filled(self, *args) -> "bool":
        r""" If FillComplete() has been called, this query returns true, otherwise it returns false, presently always returns true."""
        return _Epetra.BasicRowMatrix_Filled(self, *args)

    def LowerTriangular(self, *args) -> "bool":
        r""" If matrix is lower triangular, this query returns true, otherwise it returns false."""
        return _Epetra.BasicRowMatrix_LowerTriangular(self, *args)

    def UpperTriangular(self, *args) -> "bool":
        r""" If matrix is upper triangular, this query returns true, otherwise it returns false."""
        return _Epetra.BasicRowMatrix_UpperTriangular(self, *args)

    def NormInf(self, *args) -> "double":
        r"""
        Returns the infinity norm of the global matrix.

              Returns the quantity :math:`\| A \|_\infty` such that

              .. math::

                  \| A \|_\infty = \max_{1\lei\lem} \sum_{j=1}^n |a_{ij}|.

            Warning: This method is supported if and only if the Epetra_RowMatrix Object that was used to create this supports this method.
        """
        return _Epetra.BasicRowMatrix_NormInf(self, *args)

    def NormOne(self, *args) -> "double":
        r"""
        Returns the one norm of the global matrix.

              Returns the quantity :math:`\| A \|_1` such that

              .. math::

                  \| A \|_1= \max_{1\lej\len} \sum_{i=1}^m |a_{ij}|.

            Warning: This method is supported if and only if the Epetra_RowMatrix Object that was used to create this supports this method.
        """
        return _Epetra.BasicRowMatrix_NormOne(self, *args)

    def NumGlobalNonzeros(self, *args) -> "int":
        r"""
        Returns the number of nonzero entries in the global matrix.

              Note that if the data decomposition is defined such that some nonzeros
              appear on multiple processors, then those nonzeros will be counted
              multiple times.
        """
        return _Epetra.BasicRowMatrix_NumGlobalNonzeros(self, *args)

    def NumGlobalNonzeros64(self, *args) -> "long long":
        return _Epetra.BasicRowMatrix_NumGlobalNonzeros64(self, *args)

    def NumGlobalRows(self, *args) -> "int":
        r""" Returns the number of global matrix rows."""
        return _Epetra.BasicRowMatrix_NumGlobalRows(self, *args)

    def NumGlobalRows64(self, *args) -> "long long":
        return _Epetra.BasicRowMatrix_NumGlobalRows64(self, *args)

    def NumGlobalCols(self, *args) -> "int":
        r""" Returns the number of global matrix columns."""
        return _Epetra.BasicRowMatrix_NumGlobalCols(self, *args)

    def NumGlobalCols64(self, *args) -> "long long":
        return _Epetra.BasicRowMatrix_NumGlobalCols64(self, *args)

    def NumGlobalDiagonals(self, *args) -> "int":
        r""" Returns the number of global nonzero diagonal entries."""
        return _Epetra.BasicRowMatrix_NumGlobalDiagonals(self, *args)

    def NumGlobalDiagonals64(self, *args) -> "long long":
        return _Epetra.BasicRowMatrix_NumGlobalDiagonals64(self, *args)

    def NumMyNonzeros(self, *args) -> "int":
        r""" Returns the number of nonzero entries in the calling processor's portion of the matrix."""
        return _Epetra.BasicRowMatrix_NumMyNonzeros(self, *args)

    def NumMyRows(self, *args) -> "int":
        r""" Returns the number of matrix rows owned by the calling processor."""
        return _Epetra.BasicRowMatrix_NumMyRows(self, *args)

    def NumMyCols(self, *args) -> "int":
        r""" Returns the number of matrix columns owned by the calling processor."""
        return _Epetra.BasicRowMatrix_NumMyCols(self, *args)

    def NumMyDiagonals(self, *args) -> "int":
        r""" Returns the number of local nonzero diagonal entries."""
        return _Epetra.BasicRowMatrix_NumMyDiagonals(self, *args)

    def MaxNumEntries(self, *args) -> "int":
        r""" Returns the maximum number of nonzero entries across all rows on this processor."""
        return _Epetra.BasicRowMatrix_MaxNumEntries(self, *args)

    def OperatorDomainMap(self, *args) -> "Epetra_Map const &":
        r""" Returns the Epetra_Map object associated with the domain of this operator."""
        return _Epetra.BasicRowMatrix_OperatorDomainMap(self, *args)

    def OperatorRangeMap(self, *args) -> "Epetra_Map const &":
        r""" Returns the Epetra_Map object associated with the range of this operator (same as domain)."""
        return _Epetra.BasicRowMatrix_OperatorRangeMap(self, *args)

    def Map(self, *args) -> "Epetra_BlockMap const &":
        r""" Implement the Epetra_SrcDistObjec::Map() function."""
        return _Epetra.BasicRowMatrix_Map(self, *args)

    def RowMatrixRowMap(self, *args) -> "Epetra_Map const &":
        r""" Returns the Row Map object needed for implementing Epetra_RowMatrix."""
        return _Epetra.BasicRowMatrix_RowMatrixRowMap(self, *args)

    def RowMatrixColMap(self, *args) -> "Epetra_Map const &":
        r""" Returns the Column Map object needed for implementing Epetra_RowMatrix."""
        return _Epetra.BasicRowMatrix_RowMatrixColMap(self, *args)

    def RowMatrixImporter(self, *args) -> "Epetra_Import const *":
        r""" Returns the Epetra_Import object that contains the import operations for distributed operations."""
        return _Epetra.BasicRowMatrix_RowMatrixImporter(self, *args)

    def Comm(self, *args) -> "Epetra_Comm const &":
        r""" Returns a pointer to the Epetra_Comm communicator associated with this matrix."""
        return _Epetra.BasicRowMatrix_Comm(self, *args)

    def SetUseTranspose(self, *args) -> "int":
        r"""
        If set true, transpose of this operator will be applied. This flag allows the transpose of the given operator to be used implicitly.  Setting this flag
               affects only the Apply() and ApplyInverse() methods.  If the implementation of this interface
         does not support transpose use, this method should return a value of -1.

           :type use_transpose: boolean
           :param use_transpose: (In) - If true, multiply by the transpose of operator, otherwise just use operator.

           :rtype: int
           :return: Always returns 0.
        """
        return _Epetra.BasicRowMatrix_SetUseTranspose(self, *args)

    def Label(self, *args) -> "char const *":
        r""" Returns a character string describing the operator"""
        return _Epetra.BasicRowMatrix_Label(self, *args)

    def Apply(self, *args) -> "int":
        r"""
        Apply(self, MultiVector x, MultiVector y) -> int

        In C++, the Apply() method is pure virtual, thus intended to be
        overridden by derived classes.  In python, cross-language polymorphism
        is supported, and you are expected to derive classes from this base
        class and redefine the Apply() method.  C++ code (e.g., AztecOO
        solvers) can call back to your Apply() method as needed.  You must
        support two arguments, labeled here MultiVector x and MultiVector y.
        These will be converted from Epetra_MultiVector C++ objects to
        numpy-hybrid Epetra.MultiVector objects before they are passed to you.
        Thus, it is legal to use slice indexing and other numpy features to
        compute y from x.

        If application of your operator is successful, return 0; else return
        some non-zero error code.

        It is strongly suggested that you prevent Apply() from raising any
        exceptions.  Accidental errors can be prevented by wrapping your code
        in a try block:

            try:
                # Your code goes here...
            except Exception, e:
                print 'A python exception was raised by method Apply:'
                print e
                return -1

        By returning a -1, you inform the calling routine that Apply() was
        unsuccessful.

        """
        return _Epetra.BasicRowMatrix_Apply(self, *args)

    def ApplyInverse(self, *args) -> "int":
        r"""
        ApplyInverse(self, MultiVector x, MultiVector y) -> int

        In C++, the ApplyInverse() method is pure virtual, thus intended to be
        overridden by derived classes.  In python, cross-language polymorphism
        is supported, and you are expected to derive classes from this base
        class and redefine the ApplyInverse() method.  C++ code (e.g., AztecOO
        solvers) can call back to your ApplyInverse() method as needed.  You
        must support two arguments, labeled here MultiVector x and MultiVector
        y.  These will be converted from Epetra_MultiVector C++ objects to
        numpy-hybrid Epetra.MultiVector objects before they are passed to you.
        Thus, it is legal to use slice indexing and other numpy features to
        compute y from x.

        If application of your operator is successful, return 0; else return
        some non-zero error code.

        It is strongly suggested that you prevent ApplyInverse() from raising
        any exceptions.  Accidental errors can be prevented by wrapping your
        code in a try block:

            try:
                # Your code goes here...
            except Exception, e:
                print 'A python exception was raised by method ApplyInverse:'
                print e
                return -1

        By returning a -1, you inform the calling routine that ApplyInverse()
        was unsuccessful.

        """
        return _Epetra.BasicRowMatrix_ApplyInverse(self, *args)

    def HasNormInf(self, *args) -> "bool":
        r""" Returns true because this class can compute an Inf-norm."""
        return _Epetra.BasicRowMatrix_HasNormInf(self, *args)

    def UseTranspose(self, *args) -> "bool":
        r""" Returns the current UseTranspose setting."""
        return _Epetra.BasicRowMatrix_UseTranspose(self, *args)

    def Importer(self, *args) -> "Epetra_Import const *":
        r"""
        Returns the Epetra_Import object that contains the import operations for distributed operations, returns zero if none. If RowMatrixColMap!=OperatorDomainMap, then this method returns a pointer to an Epetra_Import object that imports objects
               from an OperatorDomainMap layout to a RowMatrixColMap layout.  This operation is needed for sparse matrix-vector
         multiplication, y = Ax, to gather x elements for local multiplication operations.

         If RowMatrixColMap==OperatorDomainMap, then the pointer will be returned as 0.

           :rtype: :py:class:`Epetra_Import`
           :return: Raw pointer to importer.  This importer will be valid as long as the Epetra_RowMatrix object is valid.
        """
        return _Epetra.BasicRowMatrix_Importer(self, *args)

    def Exporter(self, *args) -> "Epetra_Export const *":
        r"""
        Returns the Epetra_Export object that contains the export operations for distributed operations, returns zero if none. If RowMatrixRowMap!=OperatorRangeMap, then this method returns a pointer to an Epetra_Export object that exports objects
               from an RowMatrixRowMap layout to a OperatorRangeMap layout.  This operation is needed for sparse matrix-vector
         multiplication, y = Ax, to scatter-add y elements generated during local multiplication operations.

         If RowMatrixRowMap==OperatorRangeMap, then the pointer will be returned as 0.  For a typical Epetra_RowMatrix object,
         this pointer will be zero since it is often the case that RowMatrixRowMap==OperatorRangeMap.

           :rtype: :py:class:`Epetra_Export`
           :return: Raw pointer to exporter.  This exporter will be valid as long as the Epetra_RowMatrix object is valid.
        """
        return _Epetra.BasicRowMatrix_Exporter(self, *args)

    def ComputeStructureConstants(self, *args) -> "void":
        r""" Update the constants associated with the structure of the matrix: Call only if structure changes from the initial RowMatrix."""
        return _Epetra.BasicRowMatrix_ComputeStructureConstants(self, *args)

    def ComputeNumericConstants(self, *args) -> "void":
        r""" Update the constants associated with the values of the matrix: Call only if values changes from the initial RowMatrix."""
        return _Epetra.BasicRowMatrix_ComputeNumericConstants(self, *args)
    def __disown__(self):
        self.this.disown()
        _Epetra.disown_BasicRowMatrix(self)
        return weakref.proxy(self)

# Register BasicRowMatrix in _Epetra:
_Epetra.BasicRowMatrix_swigregister(BasicRowMatrix)

class CrsMatrix(DistObject, CompObject, BLAS, RowMatrix):
    r"""
     Epetra_CrsMatrix: A class for constructing and using real-valued double-precision sparse compressed row matrices. The Epetra_CrsMatrix class is a sparse compressed row matrix object. This matrix can be
      used in a parallel setting, with data distribution described by Epetra_Map attributes.
      The structure or graph of the matrix is defined by an Epetra_CrsGraph attribute.

     In addition to coefficient access, the primary operations provided by Epetra_CrsMatrix are matrix
     times vector and matrix times multi-vector multiplication.

     Epetra_CrsMatrix matrices can be square or rectangular.

    **Creating and filling Epetra_CrsMatrix objects**

    Constructing Epetra_CrsMatrix objects is a multi-step process.  The basic steps are as follows:

      *  Create Epetra_CrsMatrix instance, including storage, via one of the constructors:

         * Constructor that accepts one Epetra_Map object, a row-map defining the distribution of matrix rows.
         * Constructor that accepts two Epetra_Map objects. (The second map is a column-map, and describes the set
           of column-indices that appear in each processor's portion of the matrix. Generally these are
           overlapping sets -- column-indices may appear on more than one processor.)
         * Constructor that accepts an Epetra_CrsGraph object, defining the non-zero structure of the matrix.

      Note that the constructors which accept Epetra_Map arguments also accept an argument that gives an
      estimate of the number of nonzeros per row. This allows storage to be pre-allocated and can improve
      the performance of the data input methods. The estimate need not be accurate, as additional storage is
      allocated automatically when needed. However, a more accurate estimate helps performance by reducing
      the amount of extra memory allocation.
      *  Enter values via one or more Insert/Replace/SumInto functions.
      *  Complete construction by calling FillComplete.


    Note that, even after a matrix is constructed (FillComplete has been called), it is possible to update existing
    matrix entries.  It is *not* possible to create new entries.

    **Epetra_Map attributes**

    Epetra_CrsMatrix objects have four Epetra_Map attributes, which are held by the Epetra_CrsGraph attribute.

    The Epetra_Map attributes can be obtained via these accessor methods:

     * RowMap() Describes the numbering and distribution of the rows of the matrix. The row-map exists and is valid
     for the entire life of the matrix. The set of matrix rows is defined by the row-map and may not be changed. Rows
     may not be inserted or deleted by the user. The only change that may be made is that the user can replace the
     row-map with a compatible row-map (which is the same except for re-numbering) by calling the ReplaceRowMap() method.
     * ColMap() Describes the set of column-indices that appear in the rows in each processor's portion of the matrix.
     Unless provided by the user at construction time, a valid column-map doesn't exist until FillComplete() is called.
     * RangeMap() Describes the range of the matrix operator. e.g., for a matrix-vector product operation, the result
       vector's map must be compatible with the range-map of this matrix. The range-map is usually the same as the row-map.
       The range-map is set equal to the row-map at matrix creation time, but may be specified by the user when
       FillComplete() is called.
     * DomainMap() Describes the domain of the matrix operator. The domain-map can be specified by the user when
     FillComplete() is called. Until then, it is set equal to the row-map.


    It is important to note that while the row-map and the range-map are often the same, the column-map and the domain-map
    are almost never the same. The set of entries in a distributed column-map almost always form overlapping sets, with
    entries being associated with more than one processor. A domain-map, on the other hand, must be a 1-to-1 map, with
    entries being associated with only a single processor.

    **Local versus Global Indices**

    Epetra_CrsMatrix has query functions IndicesAreLocal() and IndicesAreGlobal(), which are used to determine whether the
    underlying Epetra_CrsGraph attribute's column-indices have been transformed into a local index space or not. (This
    transformation occurs when the method Epetra_CrsGraph::FillComplete() is called, which happens when the
    method Epetra_CrsMatrix::FillComplete() is called.) The state of the indices in the
    graph determines the behavior of many Epetra_CrsMatrix methods. If an Epetra_CrsMatrix instance is constructed using
    one of the constructors that does not accept a pre-existing Epetra_CrsGraph object, then an Epetra_CrsGraph attribute
    is created internally and its indices remain untransformed (IndicesAreGlobal()==true) until Epetra_CrsMatrix::FillComplete()
    is called. The query function Epetra_CrsMatrix::Filled() returns true if Epetra_CrsMatrix::FillComplete() has been
    called.

    Note the following method characteristics:


     * InsertGlobalValues() may only be used to insert new nonzeros in the matrix if indices are global.
     * SumIntoGlobalValues() may be used regardless of whether indices are global or local, but can only be used
      to update matrix locations that already exist; it can never be used to establish new nonzero locations.
     * ReplaceGlobalValues() may also be used only to update matrix locations that already exist, and works
      regardless of whether indices are local or global.
     * SumIntoMyValues() and ReplaceMyValues() may only be used if indices are local.
     * Multiply() may only be used after FillComplete() has been called.


    Most methods have preconditions documented, check documentation for specific methods not mentioned here.

    ** Counting Floating Point Operations **

    Each Epetra_CrsMatrix object keeps track of the number
    of *serial* floating point operations performed using the specified object as the *this* argument
    to the function.  The Flops() function returns this number as a double precision number.  Using this
    information, in conjunction with the Epetra_Time class, one can get accurate parallel performance
    numbers.  The ResetFlops() function resets the floating point counter.

    Warning: A Epetra_Map is required for the Epetra_CrsMatrix constructor.

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    __swig_destroy__ = _Epetra.delete_CrsMatrix

    def PutScalar(self, *args) -> "int":
        r"""
        Initialize all values in the matrix with constant value.
           :type ScalarConstant: float
           :param ScalarConstant: - (In) Value to use.

           :rtype: int
           :return: Integer error code, set to 0 if successful.

        """
        return _Epetra.CrsMatrix_PutScalar(self, *args)

    def Scale(self, *args) -> "int":
        r"""
        Multiply all values in the matrix by a constant value (in place: A <- ScalarConstant * A).
           :type ScalarConstant: float
           :param ScalarConstant: - (In) Value to use.

           :rtype: int
           :return: Integer error code, set to 0 if successful.

        """
        return _Epetra.CrsMatrix_Scale(self, *args)

    def ReplaceDiagonalValues(self, *args) -> "int":
        r"""
        Replaces diagonal values of the matrix with those in the user-provided vector. This routine is meant to allow replacement of **existing** diagonal values.
           If a diagonal value does not exist for a given row, the corresponding value in
           the input Epetra_Vector will be ignored and the return code will be set to 1.

           The Epetra_Map associated with the input Epetra_Vector must be compatible with
           the RowMap of the matrix.

           :type Diagonal: :py:class:`Epetra_Vector`
           :param Diagonal: - (In) New values to be placed in the main diagonal.

           :rtype: int
           :return: Integer error code, set to 0 if successful, set to 1 on the calling processor if one or more diagonal entries not present in matrix.

        """
        return _Epetra.CrsMatrix_ReplaceDiagonalValues(self, *args)

    def FillComplete(self, *args) -> "int":
        r"""
        *Overload 1:*
        Signal that data entry is complete.  Perform transformations to local index space.

        |

        *Overload 2:*
        Signal that data entry is complete.  Perform transformations to local index space.
        """
        return _Epetra.CrsMatrix_FillComplete(self, *args)

    def OptimizeStorage(self, *args) -> "int":
        r"""
        Make consecutive row index sections contiguous, minimize internal storage used for constructing graph. After construction and during initialization (when values are being added), the matrix coefficients
           for each row are managed as separate segments of memory. This method moves the values for all rows
           into one large contiguous array and eliminates internal storage that is not needed after matrix construction. Calling this
           method can have a significant impact on memory costs and machine performance.

           If this object was constructed in View mode then this method can't make non-contiguous values contiguous and will
           return a warning code of 1 if the viewed data isn't already contiguous.

           Notes: A call to this method will also call the OptimizeStorage method for the associated Epetra_CrsGraph object.  If
           the storage for this graph has already been optimized this additional call will have no effect.

           :rtype: int
           :return: Integer error code, set to 0 if successful.


        """
        return _Epetra.CrsMatrix_OptimizeStorage(self, *args)

    def MakeDataContiguous(self, *args) -> "int":
        r""" Eliminates memory that is used for construction.  Make consecutive row index sections contiguous."""
        return _Epetra.CrsMatrix_MakeDataContiguous(self, *args)

    def ExtractDiagonalCopy(self, *args) -> "int":
        r"""
        ExtractDiagonalCopy(Vector diagonal) -> int

        Argument diagonal is provided to you as a numpy-hybrid Epetra.Vector,
        giving you access to the numpy interface in addition to the
        Epetra_Vector C++ interface.
        """
        return _Epetra.CrsMatrix_ExtractDiagonalCopy(self, *args)

    def Multiply(self, *args) -> "int":
        r"""
        Multiply(bool useTranspose, MultiVector x, MultiVector y) -> int

        In C++, arguments x and y are Epetra_MultiVectors.  In python, they
        are provided to you as numpy-hybrid Epetra.MultiVectors, giving you
        access to the numpy interface in addition to the Epetra_MultiVector
        C++ interface.
        """
        return _Epetra.CrsMatrix_Multiply(self, *args)

    def Multiply1(self, *args) -> "int":
        return _Epetra.CrsMatrix_Multiply1(self, *args)

    def Solve(self, *args) -> "int":
        r"""
        Solve((bool upper, bool trans, bool unitDiagonal, MultiVector x,
            MultiVector y) -> int

        In C++, arguments x and y are Epetra_MultiVectors.  In python, they
        are provided to you as numpy-hybrid Epetra.MultiVectors, giving you
        access to the numpy interface in addition to the Epetra_MultiVector
        C++ interface.
        """
        return _Epetra.CrsMatrix_Solve(self, *args)

    def InvRowSums(self, *args) -> "int":
        r"""
        InvRowSums(Vector x) -> int

        Argument x is provided to you as a numpy-hybrid Epetra.Vector, giving
        you access to the numpy interface in addition to the Epetra_Vector C++
        interface.
        """
        return _Epetra.CrsMatrix_InvRowSums(self, *args)

    def InvRowMaxs(self, *args) -> "int":
        r"""
        Computes the inverse of the max of absolute values of the rows of the Epetra_CrsMatrix, results returned in x. The vector x will return such that x[i] will contain the inverse of max of the absolute values of the entries in the ith
                 row of the *this* matrix.
                       Warning: This method will not work when multiple processors contain partial sums for individual entries.
           :type x: :py:class:`Epetra_Vector`
           :param x: - (Out) An Epetra_Vector containing the inverse of the row maxs of the *this* matrix.
           When rows are fully replicated on multiple processors, it is assumed that the distribution of x is
                       the same as the rows (RowMap())of *this*.  When each row of *this* is uniquely owned, the distribution of
           x can be that of the RowMap() or the RangeMap().

           :rtype: int
           :return: Integer error code, set to 0 if successful.

        """
        return _Epetra.CrsMatrix_InvRowMaxs(self, *args)

    def LeftScale(self, *args) -> "int":
        r"""
        LeftScale(Vector x) -> int

        Argument x is provided to you as a numpy-hybrid Epetra.Vector, giving
        you access to the numpy interface in addition to the Epetra_Vector C++
        interface.
        """
        return _Epetra.CrsMatrix_LeftScale(self, *args)

    def InvColSums(self, *args) -> "int":
        r"""
        InvColSums(Vector x) -> int

        Argument x is provided to you as a numpy-hybrid Epetra.Vector, giving
        you access to the numpy interface in addition to the Epetra_Vector C++
        interface.
        """
        return _Epetra.CrsMatrix_InvColSums(self, *args)

    def InvColMaxs(self, *args) -> "int":
        r"""
        Computes the max of absolute values of the columns of the Epetra_CrsMatrix, results returned in x. The vector x will return such that x[j] will contain the inverse of max of the absolute values of the entries
           in the jth row of the *this* matrix.
                       Warning: This method will not work when multiple processors contain partial sums for individual entries.
           :type x: :py:class:`Epetra_Vector`
           :param x: - (Out) An Epetra_Vector containing the column maxs of the *this* matrix.
                       When columns are fully replicated on multiple processors, it is assumed that the distribution of x is
                       the same as the columns (ColMap()) of *this*.  When each column of *this* is
                       uniquely owned, the distribution of x can be that of the ColMap() or the DomainMap().

           :rtype: int
           :return: Integer error code, set to 0 if successful.

        """
        return _Epetra.CrsMatrix_InvColMaxs(self, *args)

    def RightScale(self, *args) -> "int":
        r"""
        RightScale(Vector x) -> int

        Argument x is provided to you as a numpy-hybrid Epetra.Vector, giving
        you access to the numpy interface in addition to the Epetra_Vector C++
        interface.
        """
        return _Epetra.CrsMatrix_RightScale(self, *args)

    def Filled(self, *args) -> "bool":
        r""" If FillComplete() has been called, this query returns true, otherwise it returns false."""
        return _Epetra.CrsMatrix_Filled(self, *args)

    def StorageOptimized(self, *args) -> "bool":
        r""" If OptimizeStorage() has been called, this query returns true, otherwise it returns false."""
        return _Epetra.CrsMatrix_StorageOptimized(self, *args)

    def IndicesAreGlobal(self, *args) -> "bool":
        r""" If matrix indices has not been transformed to local, this query returns true, otherwise it returns false."""
        return _Epetra.CrsMatrix_IndicesAreGlobal(self, *args)

    def IndicesAreLocal(self, *args) -> "bool":
        r""" If matrix indices has been transformed to local, this query returns true, otherwise it returns false."""
        return _Epetra.CrsMatrix_IndicesAreLocal(self, *args)

    def IndicesAreContiguous(self, *args) -> "bool":
        r""" If matrix indices are packed into single array (done in OptimizeStorage()) return true, otherwise false."""
        return _Epetra.CrsMatrix_IndicesAreContiguous(self, *args)

    def LowerTriangular(self, *args) -> "bool":
        r""" If matrix is lower triangular in local index space, this query returns true, otherwise it returns false."""
        return _Epetra.CrsMatrix_LowerTriangular(self, *args)

    def UpperTriangular(self, *args) -> "bool":
        r""" If matrix is upper triangular in local index space, this query returns true, otherwise it returns false."""
        return _Epetra.CrsMatrix_UpperTriangular(self, *args)

    def NoDiagonal(self, *args) -> "bool":
        r""" If matrix has no diagonal entries in global index space, this query returns true, otherwise it returns false."""
        return _Epetra.CrsMatrix_NoDiagonal(self, *args)

    def NormInf(self, *args) -> "double":
        r""" Returns the infinity norm of the global matrix."""
        return _Epetra.CrsMatrix_NormInf(self, *args)

    def NormOne(self, *args) -> "double":
        r""" Returns the one norm of the global matrix."""
        return _Epetra.CrsMatrix_NormOne(self, *args)

    def NormFrobenius(self, *args) -> "double":
        r""" Returns the frobenius norm of the global matrix."""
        return _Epetra.CrsMatrix_NormFrobenius(self, *args)

    def NumGlobalNonzeros(self, *args) -> "int":
        r""" Returns the number of nonzero entries in the global matrix."""
        return _Epetra.CrsMatrix_NumGlobalNonzeros(self, *args)

    def NumGlobalNonzeros64(self, *args) -> "long long":
        return _Epetra.CrsMatrix_NumGlobalNonzeros64(self, *args)

    def NumGlobalRows(self, *args) -> "int":
        r""" Returns the number of global matrix rows."""
        return _Epetra.CrsMatrix_NumGlobalRows(self, *args)

    def NumGlobalRows64(self, *args) -> "long long":
        return _Epetra.CrsMatrix_NumGlobalRows64(self, *args)

    def NumGlobalCols(self, *args) -> "int":
        r""" Returns the number of global matrix columns."""
        return _Epetra.CrsMatrix_NumGlobalCols(self, *args)

    def NumGlobalCols64(self, *args) -> "long long":
        return _Epetra.CrsMatrix_NumGlobalCols64(self, *args)

    def NumGlobalDiagonals(self, *args) -> "int":
        r""" Returns the number of global nonzero diagonal entries, based on global row/column index comparisons."""
        return _Epetra.CrsMatrix_NumGlobalDiagonals(self, *args)

    def NumGlobalDiagonals64(self, *args) -> "long long":
        return _Epetra.CrsMatrix_NumGlobalDiagonals64(self, *args)

    def NumMyNonzeros(self, *args) -> "int":
        r""" Returns the number of nonzero entries in the calling processor's portion of the matrix."""
        return _Epetra.CrsMatrix_NumMyNonzeros(self, *args)

    def NumMyRows(self, *args) -> "int":
        r""" Returns the number of matrix rows owned by the calling processor."""
        return _Epetra.CrsMatrix_NumMyRows(self, *args)

    def NumMyCols(self, *args) -> "int":
        r"""
        Returns the number of entries in the set of column-indices that appear on this processor. The set of column-indices that appear on this processor is the union of column-indices that
           appear in all local rows. The size of this set isn't available until FillComplete() has been called.

        """
        return _Epetra.CrsMatrix_NumMyCols(self, *args)

    def NumMyDiagonals(self, *args) -> "int":
        r"""
        Returns the number of local nonzero diagonal entries, based on global row/column index comparisons.

        """
        return _Epetra.CrsMatrix_NumMyDiagonals(self, *args)

    def NumGlobalEntries(self, *args) -> "int":
        r""" Returns the current number of nonzero entries in specified global row on this processor."""
        return _Epetra.CrsMatrix_NumGlobalEntries(self, *args)

    def NumAllocatedGlobalEntries(self, *args) -> "int":
        r""" Returns the allocated number of nonzero entries in specified global row on this processor."""
        return _Epetra.CrsMatrix_NumAllocatedGlobalEntries(self, *args)

    def MaxNumEntries(self, *args) -> "int":
        r"""
        Returns the maximum number of nonzero entries across all rows on this processor.

        """
        return _Epetra.CrsMatrix_MaxNumEntries(self, *args)

    def GlobalMaxNumEntries(self, *args) -> "int":
        r"""
        Returns the maximum number of nonzero entries across all rows on all processors.

        """
        return _Epetra.CrsMatrix_GlobalMaxNumEntries(self, *args)

    def NumMyEntries(self, *args) -> "int":
        r""" Returns the current number of nonzero entries in specified local row on this processor."""
        return _Epetra.CrsMatrix_NumMyEntries(self, *args)

    def NumAllocatedMyEntries(self, *args) -> "int":
        r""" Returns the allocated number of nonzero entries in specified local row on this processor."""
        return _Epetra.CrsMatrix_NumAllocatedMyEntries(self, *args)

    def IndexBase(self, *args) -> "int":
        r""" Returns the index base for row and column indices for this graph. Index base for this map."""
        return _Epetra.CrsMatrix_IndexBase(self, *args)

    def IndexBase64(self, *args) -> "long long":
        return _Epetra.CrsMatrix_IndexBase64(self, *args)

    def StaticGraph(self, *args) -> "bool":
        r""" Returns true if the graph associated with this matrix was pre-constructed and therefore not changeable."""
        return _Epetra.CrsMatrix_StaticGraph(self, *args)

    def Graph(self, *args) -> "Epetra_CrsGraph const &":
        r""" Returns a reference to the Epetra_CrsGraph object associated with this matrix."""
        return _Epetra.CrsMatrix_Graph(self, *args)

    def RowMap(self, *args) -> "Epetra_Map const &":
        r""" Returns the Epetra_Map object associated with the rows of this matrix."""
        return _Epetra.CrsMatrix_RowMap(self, *args)

    def ReplaceRowMap(self, *args) -> "int":
        r"""
        Replaces the current RowMap with the user-specified map object. Replaces the current RowMap with the user-specified map object, but only
             if currentmap->PointSameAs(newmap) is true. This is a collective function.
             Returns 0 if map is replaced, -1 if not.


        """
        return _Epetra.CrsMatrix_ReplaceRowMap(self, *args)

    def HaveColMap(self, *args) -> "bool":
        r""" Returns true if we have a well-defined ColMap, and returns false otherwise. """
        return _Epetra.CrsMatrix_HaveColMap(self, *args)

    def ReplaceColMap(self, *args) -> "int":
        r"""
        Replaces the current ColMap with the user-specified map object. Replaces the current ColMap with the user-specified map object, but only
             if no entries have been inserted into the matrix (both IndicesAreLocal()
             and IndicesAreGlobal() are false) or currentmap->PointSameAs(newmap) is true.
             This is a collective function.
             Returns 0 if map is replaced, -1 if not.


        """
        return _Epetra.CrsMatrix_ReplaceColMap(self, *args)

    def ReplaceDomainMapAndImporter(self, *args) -> "int":
        r"""
        Replaces the current DomainMap & Importer with the user-specified map object. Replaces the current DomainMap and Importer with the user-specified map object, but only
             if the matrix has been FillCompleted, Importer's TargetMap matches the ColMap
             and Importer's SourceMap matches the DomainMap (assuming the importer isn't null).  If an Importer
             is passed in, Epetra_CrsMatrix will copy it.

             Returns 0 if map/importer is replaced, -1 if not.


        """
        return _Epetra.CrsMatrix_ReplaceDomainMapAndImporter(self, *args)

    def RemoveEmptyProcessesInPlace(self, *args) -> "int":
        r"""
        Remove processes owning zero rows from the Maps and their communicator. Remove processes owning zero rows from the Maps and their communicator.
            Warning: This method is ONLY for use by experts.

            We make NO promises of backwards compatibility.
            This method may change or disappear at any time.

            :param newMap: [in] This *must* be the result of calling
                the removeEmptyProcesses() method on the row Map.  If it
                is not, this method's behavior is undefined.  This pointer
                will be null on excluded processes.
        """
        return _Epetra.CrsMatrix_RemoveEmptyProcessesInPlace(self, *args)

    def ColMap(self, *args) -> "Epetra_Map const &":
        r"""
        Returns the Epetra_Map object that describes the set of column-indices that appear in each processor's locally owned matrix rows.Note that if the matrix was constructed with only a row-map, then until FillComplete() is called, this method returns
           a column-map that is a copy of the row-map. That 'initial' column-map is replaced with a computed column-map (that
           contains the set of column-indices appearing in each processor's local portion of the matrix) when FillComplete() is
           called.


        """
        return _Epetra.CrsMatrix_ColMap(self, *args)

    def DomainMap(self, *args) -> "Epetra_Map const &":
        r"""
        Returns the Epetra_Map object associated with the domain of this matrix operator.

        """
        return _Epetra.CrsMatrix_DomainMap(self, *args)

    def RangeMap(self, *args) -> "Epetra_Map const &":
        r"""
        Returns the Epetra_Map object associated with the range of this matrix operator.

        """
        return _Epetra.CrsMatrix_RangeMap(self, *args)

    def Importer(self, *args) -> "Epetra_Import const *":
        r""" Returns the Epetra_Import object that contains the import operations for distributed operations."""
        return _Epetra.CrsMatrix_Importer(self, *args)

    def Exporter(self, *args) -> "Epetra_Export const *":
        r""" Returns the Epetra_Export object that contains the export operations for distributed operations."""
        return _Epetra.CrsMatrix_Exporter(self, *args)

    def Comm(self, *args) -> "Epetra_Comm const &":
        r""" Returns a pointer to the Epetra_Comm communicator associated with this matrix."""
        return _Epetra.CrsMatrix_Comm(self, *args)

    def LRID(self, *args) -> "int":
        return _Epetra.CrsMatrix_LRID(self, *args)

    def GRID(self, *args) -> "int":
        r""" Returns the global row index for give local row index, returns IndexBase-1 if we don't have this local row."""
        return _Epetra.CrsMatrix_GRID(self, *args)

    def GRID64(self, *args) -> "long long":
        return _Epetra.CrsMatrix_GRID64(self, *args)

    def LCID(self, *args) -> "int":
        return _Epetra.CrsMatrix_LCID(self, *args)

    def GCID(self, *args) -> "int":
        r"""
        Returns the global column index for give local column index, returns IndexBase-1 if we don't have this local column.

        """
        return _Epetra.CrsMatrix_GCID(self, *args)

    def GCID64(self, *args) -> "long long":
        return _Epetra.CrsMatrix_GCID64(self, *args)

    def MyGRID(self, *args) -> "bool":
        return _Epetra.CrsMatrix_MyGRID(self, *args)

    def MyLRID(self, *args) -> "bool":
        r""" Returns true if the LRID passed in belongs to the calling processor in this map, otherwise returns false."""
        return _Epetra.CrsMatrix_MyLRID(self, *args)

    def MyGCID(self, *args) -> "bool":
        return _Epetra.CrsMatrix_MyGCID(self, *args)

    def MyLCID(self, *args) -> "bool":
        r"""
        Returns true if the LRID passed in belongs to the calling processor in this map, otherwise returns false.

        """
        return _Epetra.CrsMatrix_MyLCID(self, *args)

    def MyGlobalRow(self, *args) -> "bool":
        return _Epetra.CrsMatrix_MyGlobalRow(self, *args)

    def Label(self, *args) -> "char const *":
        r""" Returns a character string describing the operator"""
        return _Epetra.CrsMatrix_Label(self, *args)

    def SetUseTranspose(self, *args) -> "int":
        r"""
        If set true, transpose of this operator will be applied. This flag allows the transpose of the given operator to be used implicitly.  Setting this flag
           affects only the Apply() and ApplyInverse() methods.  If the implementation of this interface
           does not support transpose use, this method should return a value of -1.

           :param UseTranspose: - (In) If true, multiply by the transpose of operator, otherwise just use operator.

           :rtype: int
           :return: Always returns 0.
        """
        return _Epetra.CrsMatrix_SetUseTranspose(self, *args)

    def Apply(self, *args) -> "int":
        r"""
        Apply(self, MultiVector x, MultiVector y) -> int

        In C++, the Apply() method is pure virtual, thus intended to be
        overridden by derived classes.  In python, cross-language polymorphism
        is supported, and you are expected to derive classes from this base
        class and redefine the Apply() method.  C++ code (e.g., AztecOO
        solvers) can call back to your Apply() method as needed.  You must
        support two arguments, labeled here MultiVector x and MultiVector y.
        These will be converted from Epetra_MultiVector C++ objects to
        numpy-hybrid Epetra.MultiVector objects before they are passed to you.
        Thus, it is legal to use slice indexing and other numpy features to
        compute y from x.

        If application of your operator is successful, return 0; else return
        some non-zero error code.

        It is strongly suggested that you prevent Apply() from raising any
        exceptions.  Accidental errors can be prevented by wrapping your code
        in a try block:

            try:
                # Your code goes here...
            except Exception, e:
                print 'A python exception was raised by method Apply:'
                print e
                return -1

        By returning a -1, you inform the calling routine that Apply() was
        unsuccessful.

        """
        return _Epetra.CrsMatrix_Apply(self, *args)

    def ApplyInverse(self, *args) -> "int":
        r"""
        ApplyInverse(self, MultiVector x, MultiVector y) -> int

        In C++, the ApplyInverse() method is pure virtual, thus intended to be
        overridden by derived classes.  In python, cross-language polymorphism
        is supported, and you are expected to derive classes from this base
        class and redefine the ApplyInverse() method.  C++ code (e.g., AztecOO
        solvers) can call back to your ApplyInverse() method as needed.  You
        must support two arguments, labeled here MultiVector x and MultiVector
        y.  These will be converted from Epetra_MultiVector C++ objects to
        numpy-hybrid Epetra.MultiVector objects before they are passed to you.
        Thus, it is legal to use slice indexing and other numpy features to
        compute y from x.

        If application of your operator is successful, return 0; else return
        some non-zero error code.

        It is strongly suggested that you prevent ApplyInverse() from raising
        any exceptions.  Accidental errors can be prevented by wrapping your
        code in a try block:

            try:
                # Your code goes here...
            except Exception, e:
                print 'A python exception was raised by method ApplyInverse:'
                print e
                return -1

        By returning a -1, you inform the calling routine that ApplyInverse()
        was unsuccessful.

        """
        return _Epetra.CrsMatrix_ApplyInverse(self, *args)

    def HasNormInf(self, *args) -> "bool":
        r""" Returns true because this class can compute an Inf-norm."""
        return _Epetra.CrsMatrix_HasNormInf(self, *args)

    def UseTranspose(self, *args) -> "bool":
        r""" Returns the current UseTranspose setting."""
        return _Epetra.CrsMatrix_UseTranspose(self, *args)

    def OperatorDomainMap(self, *args) -> "Epetra_Map const &":
        r""" Returns the Epetra_Map object associated with the domain of this matrix operator."""
        return _Epetra.CrsMatrix_OperatorDomainMap(self, *args)

    def OperatorRangeMap(self, *args) -> "Epetra_Map const &":
        r""" Returns the Epetra_Map object associated with the range of this matrix operator."""
        return _Epetra.CrsMatrix_OperatorRangeMap(self, *args)

    def NumMyRowEntries(self, *args) -> "int":
        r"""
        NumMyRowEntries(int myRow, numpy.ndarray numEntries) -> int

        In C++, numEntries in an int&.  In python, it is provided to you as a
        numpy array of length one so that you can set its value in-place using
        numEntries[0] = ....
        """
        return _Epetra.CrsMatrix_NumMyRowEntries(self, *args)

    def Map(self, *args) -> "Epetra_BlockMap const &":
        r""" Map() method inherited from Epetra_DistObject"""
        return _Epetra.CrsMatrix_Map(self, *args)

    def RowMatrixRowMap(self, *args) -> "Epetra_Map const &":
        r""" Returns the Epetra_Map object associated with the rows of this matrix."""
        return _Epetra.CrsMatrix_RowMatrixRowMap(self, *args)

    def RowMatrixColMap(self, *args) -> "Epetra_Map const &":
        r""" Returns the Epetra_Map object associated with columns of this matrix."""
        return _Epetra.CrsMatrix_RowMatrixColMap(self, *args)

    def RowMatrixImporter(self, *args) -> "Epetra_Import const *":
        r""" Returns the Epetra_Import object that contains the import operations for distributed operations."""
        return _Epetra.CrsMatrix_RowMatrixImporter(self, *args)

    def ExpertExtractIndexOffset(self, *args) -> "Epetra_IntSerialDenseVector &":
        r"""
        Returns a reference to the Epetra_IntSerialDenseVector used to hold the local IndexOffsets (CRS rowptr)
              Warning: This method is intended for experts only, its use may require user code modifications in future versions of Epetra.
        """
        return _Epetra.CrsMatrix_ExpertExtractIndexOffset(self, *args)

    def ExpertExtractIndices(self, *args) -> "Epetra_IntSerialDenseVector &":
        r"""
        Returns a reference to the Epetra_IntSerialDenseVector used to hold the local All_Indices (CRS colind)
              Warning: This method is intended for experts only, its use may require user code modifications in future versions of Epetra.
        """
        return _Epetra.CrsMatrix_ExpertExtractIndices(self, *args)

    def ExpertExtractValues(self, *args) -> "double *&":
        r"""
        Returns a reference to the double* used to hold the values array
              Warning: This method is intended for experts only, its use may require user code modifications in future versions of Epetra.
        """
        return _Epetra.CrsMatrix_ExpertExtractValues(self, *args)

    def ExpertStaticFillComplete(self, *args) -> "int":
        r"""
        Performs a FillComplete on an object that aready has filled CRS data Performs a lightweight FillComplete on an object that already has filled IndexOffsets, All_Indices and All_Values.
             This routine is needed to support the EpetraExt::MatrixMatrix::Multiply and should not be called by users.
              Warning: Epetra_CrsMatrix will assume ownership of the Importer/Exporter you pass in.  You should not deallocate it afterwards.
              This method is intended for expert developer use only, and should never be called by user code.
        """
        return _Epetra.CrsMatrix_ExpertStaticFillComplete(self, *args)

    def ExpertMakeUniqueCrsGraphData(self, *args) -> "int":
        r"""
        Makes sure this matrix has a unique CrsGraphData object This routine is needed to support the EpetraExt::MatrixMatrix::Multiply and should not be called by users.
             Warning: This method is intended for expert developer use only, and should never be called by user code.
        """
        return _Epetra.CrsMatrix_ExpertMakeUniqueCrsGraphData(self, *args)

    def SortGhostsAssociatedWithEachProcessor(self, *args) -> "int":
        r"""
        Forces FillComplete() to locally order ghostnodes associated with each remote processor in ascending order. To be compliant with AztecOO, FillComplete() already locally orders ghostnodes such that
             information received from processor k has a lower local numbering than information received
             from processor j if k is less than j.  SortGhostsAssociatedWithEachProcessor(True) further
             forces FillComplete() to locally number all ghostnodes received from processor k in ascending
             order. That is, the local numbering of b is less than c if the global numbering of b is less
             than c and if both b and c are owned by the same processor. This is done to be compliant with
             some limited block features within ML. In particular, some ML features require that a block
             structure of the matrix be maintained even within the ghost variables. Always returns 0.
        """
        return _Epetra.CrsMatrix_SortGhostsAssociatedWithEachProcessor(self, *args)

    def ImportMap(self, *args) -> "Epetra_Map const &":
        r""" Use ColMap() instead."""
        return _Epetra.CrsMatrix_ImportMap(self, *args)

    def TransformToLocal(self, *args) -> "int":
        r"""
        *Overload 1:*
        Use FillComplete() instead.

        |

        *Overload 2:*
        Use FillComplete(const Epetra_Map& DomainMap, const Epetra_Map& RangeMap) instead.
        """
        return _Epetra.CrsMatrix_TransformToLocal(self, *args)

    def FusedImport(self, *args) -> "void":
        return _Epetra.CrsMatrix_FusedImport(self, *args)

    def FusedExport(self, *args) -> "void":
        return _Epetra.CrsMatrix_FusedExport(self, *args)

    def InsertGlobalValues(self, *args) -> "int":
        r"""
        InsertGlobalValues(self, int globalRow, PySequence values, PySequence
            indices) -> int

          Arguments:

            globalRow - global row index
            values    - a sequence of doubles that represent the values to insert
            indices   - a sequence of integers that represent the indices to insert
        InsertGlobalValues(self, PySequence rows, PySequence cols, PySequence
            values) -> int

          Arguments:

            rows    - a sequence of integers that represent the row indices to insert
            cols    - a sequence of integers that represent the column indices to
                      insert
            values  - a sequence of doubles that represent the values to insert

        """
        return _Epetra.CrsMatrix_InsertGlobalValues(self, *args)

    def ReplaceGlobalValues(self, *args) -> "int":
        r"""
        ReplaceGlobalValues(self, int globalRow, PySequence values, PySequence
            indices) -> int

          Arguments:

            globalRow - global row index
            values    - a sequence of doubles that represent the values to replace
            indices   - a sequence of integers that represent the indices to replace
        ReplaceGlobalValues(self, PySequence rows, PySequence cols, PySequence
            values) -> int

          Arguments:

            rows    - a sequence of integers that represent the row indices to replace
            cols    - a sequence of integers that represent the column indices to
                      replace
            values  - a sequence of doubles that represent the values to replace

        """
        return _Epetra.CrsMatrix_ReplaceGlobalValues(self, *args)

    def SumIntoGlobalValues(self, *args) -> "int":
        r"""
        SumIntoGlobalValues(self, int globalRow, PySequence values, PySequence
            indices) -> int

          Arguments:

            globalRow - global row index
            values    - a sequence of doubles that represent the values to sum into
            indices   - a sequence of integers that represent the indices to sum into
        SumIntoGlobalValues(self, PySequence rows, PySequence cols, PySequence
            values) -> int

          Arguments:

            rows    - a sequence of integers that represent the row indices to sum into
            cols    - a sequence of integers that represent the column indices to
                      sum into
            values  - a sequence of doubles that represent the values to sum into

        """
        return _Epetra.CrsMatrix_SumIntoGlobalValues(self, *args)

    def InsertMyValues(self, *args) -> "int":
        r"""
        InsertMyValues(self, MyRow, NumEntries, Values, Indices) -> intInsertMyValues(self, int myRow, PySequence values, PySequence indices) -> int

          Arguments:

            myRow     - local row index
            values    - a sequence of doubles that represent the values to insert
            indices   - a sequence of integers that represent the indices to insert
        InsertMyValues(self, PySequence rows, PySequence cols, PySequence
            values) -> int

          Arguments:

            rows    - a sequence of integers that represent the row indices to insert
            cols    - a sequence of integers that represent the column indices to
                      insert
            values  - a sequence of doubles that represent the values to insert

        """
        return _Epetra.CrsMatrix_InsertMyValues(self, *args)

    def ReplaceMyValues(self, *args) -> "int":
        r"""
        ReplaceMyValues(self, MyRow, NumEntries, Values, Indices) -> intReplaceMyValues(self, int myRow, PySequence values, PySequence indices) -> int

          Arguments:

            myRow     - local row index
            values    - a sequence of doubles that represent the values to replace
            indices   - a sequence of integers that represent the indices to replace
        ReplaceMyValues(self, PySequence rows, PySequence cols, PySequence
            values) -> int

          Arguments:

            rows    - a sequence of integers that represent the row indices to replace
            cols    - a sequence of integers that represent the column indices to
                      replace
            values  - a sequence of doubles that represent the values to replace

        """
        return _Epetra.CrsMatrix_ReplaceMyValues(self, *args)

    def SumIntoMyValues(self, *args) -> "int":
        return _Epetra.CrsMatrix_SumIntoMyValues(self, *args)

    def __init__(self, *args):
        r"""
        __init__(self, Epetra_DataAccess CV, Map rowMap, int numEntriesPerRow, 
            bool staticProfile=False) -> CrsMatrix

          CrsMatrix constructor with implicit column map and constant number
          of entries per row.  Arguments:

            CV                - Epetra.Copy or Epetra.View
            rowMap            - describes distribution of rows across processors
            numEntriesPerRow  - constant number of entries per row
            staticProfile     - static profile flag
        __init__(self, Epetra_DataAccess CV, Map rowMap, Map colMap, int numEntriesPerRow, 
            bool staticProfile=False) -> CrsMatrix

          CrsMatrix constructor with specified column map and constant number
          of entries per row.  Arguments:

            CV                - Epetra.Copy or Epetra.View
            rowMap            - describes distribution of rows across processors
            colMap            - describes distribution of columns across processors
            numEntriesPerRow  - constant number of entries per row
            staticProfile     - static profile flag
        __init__(self, Epetra_DataAccess CV, CrsGraph graph) -> CrsMatrix

          CrsMatrix constructor with CrsGraph.  Arguments:

            CV     - Epetra.Copy or Epetra.View
            graph  - CrsGraph describing structure of matrix

        __init__(self, SourceMatrix, RowImporter, DomainMap=None, RangeMap=None, RestrictCommunicator=False) -> CrsMatrix
        __init__(self, SourceMatrix, RowImporter, DomainImporter, DomainMap, RangeMap, RestrictCommunicator) -> CrsMatrix
        __init__(self, SourceMatrix, RowExporter, DomainMap=None, RangeMap=None, RestrictCommunicator=False) -> CrsMatrix
        __init__(self, SourceMatrix, RowExporter, DomainExporter, DomainMap, RangeMap, RestrictCommunicator) -> CrsMatrix__init__(self, CrsMatrix matrix) -> CrsMatrix

          CrsMatrix copy constructor.  Argument:

            matrix  - source CrsMatrix
        __init__(self, Epetra_DataAccess CV, Map rowMap, PySequence numEntriesPerRow, 
            bool staticProfile=False) -> CrsMatrix

          CrsMatrix constructor with implicit column map and variable number
          of entries per row.  Arguments:

            CV                - Epetra.Copy or Epetra.View
            rowMap            - describes distribution of rows across processors
            numEntriesPerRow  - variable number of entries per row
            staticProfile     - static profile flag
        __init__(self, Epetra_DataAccess CV, Map rowMap, Map colMap, PySequence
            numEntriesPerRow, bool staticProfile=False) -> CrsMatrix

          CrsMatrix constructor with specified column map and variable number
          of entries per row.  Arguments:

            CV                - Epetra.Copy or Epetra.View
            rowMap            - describes distribution of rows across processors
            colMap            - describes distribution of columns across processors
            numEntriesPerRow  - variable number of entries per row
            staticProfile     - static profile flag

        """
        _Epetra.CrsMatrix_swiginit(self, _Epetra.new_CrsMatrix(*args))

    def ExtractGlobalRowCopy(self, *args) -> "PyObject *":
        r"""
        ExtractGlobalRowCopy(self, int globalRow) -> (numpy.ndarray,numpy.ndarray)

          Returns a two-tuple of numpy arrays of the same size; the first is
          an array of integers that represent the nonzero columns on the
          matrix; the second is an array of doubles that represent the values
          of the matrix entries.  The input argument is a global row index.
        """
        return _Epetra.CrsMatrix_ExtractGlobalRowCopy(self, *args)

    def ExtractMyRowCopy(self, *args) -> "PyObject *":
        r"""
        ExtractMyRowCopy(self, int myRow) -> (numpy.ndarray,numpy.ndarray)

          Returns a two-tuple of numpy arrays of the same size; the first is
          an array of integers that represent the nonzero columns on the
          matrix; the second is an array of doubles that represent the values
          of the matrix entries.  The input argument is a local row index.
        """
        return _Epetra.CrsMatrix_ExtractMyRowCopy(self, *args)

    def __setitem__(self, *args) -> "PyObject *":
        r"""
        __setitem__(self, PyTuple index, double val)

        The __setitem__() method is called when square-bracket indexing is
        used to set a value of the matrix.  For example, the last line of::

            comm = Epetra.SerialComm()
            m = Epetra.CrsMatrix(9,0,comm)
            m[0,0] = 3.14

        calls::

            m.__setitem__((0,0), 3.14)

        Thus, argument 'index' is a tuple filled with whatever indices you
        give the square-bracket operator when setting.  For __setitem__(),
        this raises an IndexError unless 'index' is a two-tuple of integers.
        Argument 'val' must be convertible to a double.  Under the covers,
        __setitem__() calls ReplaceGlobalValues() or InsertGlobalValues() as
        necessary, so the indices are expected to be global IDs.  Note that if
        you use __setitem__() to insert a new matrix element, you will need to
        call FillComplete() again, whether or not you have called it before.

        """
        return _Epetra.CrsMatrix___setitem__(self, *args)

    def __getitem__(self, *args) -> "PyObject *":
        r"""

        __getitem__(self, PyTuple index) -> double
        __getitem__(self, int row) -> numpy.ndarray

        The __getitem__() method is called when square-bracket indexing is
        used to get a value from the matrix.  For example, the last two lines
        of::

            comm = Epetra.SerialComm()
            m = Epetra.CrsMatrix(9,0,comm)
            m.InsertGlobalValues(0, [0.0, 1.0, 2.0], [0,1,2])
            diag = m[0,0]
            row  = m[0]

        call::

            m.__getitem__((0,0))
            m.__getitem__(0)

        The __getitem__() method behaves according to the following table:

                            FillComplete()    #    
            Index               called      procs  Return value
            --------------  --------------  -----  ---------------------------
            single integer       true        any   numpy array of doubles
            single integer       false        1    numpy array of doubles
            single integer       false       >1    raise IndexError
            two integers         either      any   double

        You should provide global IDs as the integer indices if FillComplete()
        has been called.  If not, you should provide local IDs.  If you
        reference a matrix element that is off-processor, __getitem__() will
        raise an IndexError.

        Under the covers, __getitem__() will call ExtractGlobalRowView() if
        FillComplete() has been called, or ExtractMyRowView() if it has not.
        If either of these return a non-zero return code, this is converted to
        a python RuntimeError.  The resulting data is copied to the output
        array.

        """
        return _Epetra.CrsMatrix___getitem__(self, *args)

# Register CrsMatrix in _Epetra:
_Epetra.CrsMatrix_swigregister(CrsMatrix)

class FECrsMatrix(CrsMatrix):
    r"""
     Epetra Finite-Element CrsMatrix. This class provides the ability to
        input finite-element style sub-matrix data, including sub-matrices with
        non-local rows (which could correspond to shared finite-element nodes for
        example). This class inherits Epetra_CrsMatrix, and so all Epetra_CrsMatrix
        functionality is also available.

        It is intended that this class will be used as follows:

        *  Construct with either a map or graph that describes a (non-overlapping)
        data distribution.
        *  Input data, including non-local data, using the methods
        InsertGlobalValues(), SumIntoGlobalValues() and/or ReplaceGlobalValues().
        *  Call the method GlobalAssemble(), which gathers all non-local data
        onto the owning processors as determined by the map provided at
        construction. Users should note that the GlobalAssemble() method has an
        optional argument which determines whether GlobalAssemble() in turn calls
        FillComplete() after the data-exchange has occurred. If not explicitly
        supplied, this argument defaults to true.
    NOTE***: When GlobalAssemble() calls FillComplete(), it passes the
        arguments 'DomainMap()' and 'RangeMap()', which are the map attributes
        held by the base-class CrsMatrix and its graph. If a rectangular matrix
        is being assembled, the correct domain-map and range-map must be passed to
        GlobalAssemble (there are two overloadings of this method) -- otherwise, it
        has no way of knowing what these maps should really be.


        Sub-matrix data, which is assumed to be a rectangular 'table' of
        coefficients accompanied by 'scatter-indices', can be provided in three
        forms:

        * Fortran-style packed 1-D array.
        * C-style double-pointer, or list-of-rows.
        * Epetra_SerialDenseMatrix object.

        In all cases, a "format" parameter specifies whether the data is laid out
        in row-major or column-major order (i.e., whether coefficients for a row
        lie contiguously or whether coefficients for a column lie contiguously).
        See the documentation for the methods SumIntoGlobalValues() and
        ReplaceGlobalValues().

        Important notes:

        *  Since Epetra_FECrsMatrix inherits Epetra_CrsMatrix, the semantics of
        the Insert/SumInto/Replace methods are the same as they are on
        Epetra_CrsMatrix, which is:

        * InsertGlobalValues() inserts values into the matrix only if the graph
        has not yet been finalized (FillComplete() has not yet been called). For
        non-local values, the call to InsertGlobalValues() may succeed but the
        GlobalAssemble() method may then fail because the non-local data is not
        actually inserted in the underlying matrix until GlobalAssemble() is called.
        * SumIntoGlobalValues() and ReplaceGlobalValues() only work for values
        that already exist in the matrix. In other words, these methods can not be
        used to put new values into the matrix.


    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        *Overload 1:*
        Constructor.

        |

        *Overload 2:*
        Constructor.

        |

        *Overload 3:*
        Constructor.

        |

        *Overload 4:*
        Constructor.

        |

        *Overload 5:*
        Constructor.

        |

        *Overload 6:*
        Constructor.

        |

        *Overload 7:*
        Copy Constructor.
        """
        _Epetra.FECrsMatrix_swiginit(self, _Epetra.new_FECrsMatrix(*args))
    __swig_destroy__ = _Epetra.delete_FECrsMatrix
    ROW_MAJOR = _Epetra.FECrsMatrix_ROW_MAJOR
    COLUMN_MAJOR = _Epetra.FECrsMatrix_COLUMN_MAJOR

    def GlobalAssemble(self, *args) -> "int":
        r"""
        *Overload 1:*
         Gather any overlapping/shared data into the non-overlapping partitioning
              defined by the Map that was passed to this matrix at construction time.
              Data imported from other processors is stored on the owning processor
              with a "sumInto" or accumulate operation.
              This is a collective method -- every processor must enter it before any
              will complete it.

        NOTE***: When GlobalAssemble() calls FillComplete(), it passes the
              arguments 'DomainMap()' and 'RangeMap()', which are the map attributes
              held by the base-class CrsMatrix and its graph. If a rectangular matrix
              is being assembled, the domain-map and range-map must be specified by
              calling the other overloading of this method. Otherwise, GlobalAssemble()
              has no way of knowing what these maps should really be.


              :type callFillComplete: boolean, optional
              :param callFillComplete: option argument, defaults to true.
                    Determines whether GlobalAssemble() internally calls the
                    FillComplete() method on this matrix.

              :rtype: int
              :return: error-code 0 if successful, non-zero if some error occurs

        |

        *Overload 2:*
         Gather any overlapping/shared data into the non-overlapping partitioning
              defined by the Map that was passed to this matrix at construction time.
              Data imported from other processors is stored on the owning processor
              with a "sumInto" or accumulate operation.
              This is a collective method -- every processor must enter it before any
              will complete it.

        NOTE***: When GlobalAssemble() (the other overloading of this method)
              calls FillComplete(), it passes the arguments 'DomainMap()' and
              'RangeMap()', which are the map attributes already held by the base-class
              CrsMatrix and its graph. If a rectangular matrix is being assembled, the
              domain-map and range-map must be specified. Otherwise, GlobalAssemble()
              has no way of knowing what these maps should really be.


              :type domain_map: :py:class:`Epetra_Map`
              :param domain_map: user-supplied domain map for this matrix

              :type range_map: :py:class:`Epetra_Map`
              :param range_map: user-supplied range map for this matrix

              :type callFillComplete: boolean, optional
              :param callFillComplete: option argument, defaults to true.
                    Determines whether GlobalAssemble() internally calls the
                    FillComplete() method on this matrix.

              :rtype: int
              :return: error-code 0 if successful, non-zero if some error occurs
        """
        return _Epetra.FECrsMatrix_GlobalAssemble(self, *args)

    def setIgnoreNonLocalEntries(self, *args) -> "void":
        r"""
        Set whether or not non-local data values should be ignored. By default,
              non-local data values are NOT ignored.
        """
        return _Epetra.FECrsMatrix_setIgnoreNonLocalEntries(self, *args)

    def __setitem__(self, *args) -> "void":
        return _Epetra.FECrsMatrix___setitem__(self, *args)

    def __getitem__(self, *args) -> "PyObject *":
        return _Epetra.FECrsMatrix___getitem__(self, *args)

    def InsertGlobalValues(self, *args) -> "int":
        return _Epetra.FECrsMatrix_InsertGlobalValues(self, *args)

    def InsertGlobalValue(self, *args) -> "int":
        return _Epetra.FECrsMatrix_InsertGlobalValue(self, *args)

# Register FECrsMatrix in _Epetra:
_Epetra.FECrsMatrix_swigregister(FECrsMatrix)

class CrsSingletonFilter(object):
    r"""
     Epetra_CrsSingletonFilter: A class for explicitly eliminating matrix rows and columns. The Epetra_CrsSingletonFilter class takes an existing Epetra_LinearProblem object, analyzes
        it structure and explicitly eliminates singleton rows and columns from the matrix and appropriately
        modifies the RHS and LHS of the linear problem.  The result of this process is a reduced system of equations
        that is itself an Epetra_LinearProblem object.  The reduced system can then be solved using any solver that
        is understands an Epetra_LinearProblem.  The solution for the full system is obtained by calling ComputeFullSolution().

        Singleton rows are defined to be rows that have a single nonzero entry in the matrix.  The equation associated with
        this row can be explicitly eliminated because it involved only one variable.  For example if row i has a single nonzero
        value in column j, call it A(i,j), we can explicitly solve for x(j) = b(i)/A(i,j), where b(i) is the ith entry of the RHS
        and x(j) is the jth entry of the LHS.

        Singleton columns are defined to be columns that have a single nonzero entry in the matrix.  The variable associated
        with this column is fully dependent, meaning that the solution for all other variables does not depend on it.  If this
        entry is A(i,j) then the ith row and jth column can be removed from the system and x(j) can be solved after the solution
        for all other variables is determined.

        By removing singleton rows and columns, we can often produce a reduced system that is smaller and far less dense, and in
        general having better numerical properties.

        The basic procedure for using this class is as follows:

    *  Construct full problem: Construct and Epetra_LinearProblem containing the "full" matrix, RHS and LHS.  This is
         done outside of Epetra_CrsSingletonFilter class.
         Presumably, you have some reason to believe that this system may contain singletons.
    *  Construct an Epetra_CrsSingletonFilter instance:  Constructor needs no arguments.
    *  Analyze matrix: Invoke the Analyze() method, passing in the Epetra_RowMatrix object from your full linear
         problem mentioned in the first step above.
    *  Go/No Go decision to construct reduced problem:
         Query the results of the Analyze method using the SingletonsDetected() method.  This method
         returns "true" if there were singletons found in the matrix.  You can also query any of the other methods
         in the Filter Statistics section to determine if you want to proceed with the construction of the reduced system.
    *  Construct reduced problem:
         If, in the previous step, you determine that you want to proceed with the construction of the reduced problem,
         you should next call the ConstructReducedProblem() method, passing in the full linear problem object from the first
         step.  This method will use the information from the Analyze() method to construct a reduce problem that has
         explicitly eliminated the singleton rows, solved for the corresponding LHS values and updated the RHS.  This
         step will also remove singleton columns from the reduced system.  Once the solution of the reduced problem is
         is computed (via any solver that understands an Epetra_LinearProblem), you should call the ComputeFullSolution()
         method to compute the LHS values assocaited with the singleton columns.
    *  Solve reduced problem: Obtain a pointer to the reduced problem using the ReducedProblem() method.
         Using the solver of your choice, solve the reduced system.
    *  Compute solution to full problem:  Once the solution the reduced problem is determined, the ComputeFullSolution()
         method will place the reduced solution values into the appropriate locations of the full solution LHS and then
         compute the values associated with column singletons.  At this point, you have a complete solution to the original
         full problem.
    *  Solve a subsequent full problem that differs from the original problem only in values: It is often the case that the
         structure of a problem will be the same for a sequence of linear problems.  In this case, the UpdateReducedProblem()
         method can be useful.  After going through the above process one time, if you have a linear problem that is structural
         *identical* to the previous problem, you can minimize memory and time costs by using the UpdateReducedProblem()
         method, passing in the subsequent problem.  Once you have called the UpdateReducedProblem() method, you can then
         solve the reduce problem problem as you wish, and then compute the full solution as before.  The pointer generated
         by ReducedProblem() will not change when UpdateReducedProblem() is called.

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r""" Epetra_CrsSingletonFilter default constructor."""
        _Epetra.CrsSingletonFilter_swiginit(self, _Epetra.new_CrsSingletonFilter(*args))
    __swig_destroy__ = _Epetra.delete_CrsSingletonFilter

    def Analyze(self, *args) -> "int":
        r"""
        Analyze the input matrix, removing row/column pairs that have singletons. Analyzes the user's input matrix to determine rows and columns that should be explicitly
             eliminated to create the reduced system.  Look for rows and columns that have single entries.
             These rows/columns
             can easily be removed from the problem.
             The results of calling this method are two MapColoring objects accessible via RowMapColors() and
             ColMapColors() accessor methods.  All rows/columns that would be eliminated in the reduced system
             have a color of 1 in the corresponding RowMapColors/ColMapColors object.  All kept rows/cols have a
             color of 0.
        """
        return _Epetra.CrsSingletonFilter_Analyze(self, *args)

    def SingletonsDetected(self, *args) -> "bool":
        r""" Returns true if singletons were detected in this matrix (must be called after Analyze() to be effective)."""
        return _Epetra.CrsSingletonFilter_SingletonsDetected(self, *args)

    def ConstructReducedProblem(self, *args) -> "int":
        r"""
        Return a reduced linear problem based on results of Analyze(). Creates a new Epetra_LinearProblem object based on the results of the Analyze phase.  A pointer
             to the reduced problem is obtained via a call to ReducedProblem().

           :rtype: int
           :return: Error code, set to 0 if no error.
        """
        return _Epetra.CrsSingletonFilter_ConstructReducedProblem(self, *args)

    def UpdateReducedProblem(self, *args) -> "int":
        r"""
        Update a reduced linear problem using new values. Updates an existing Epetra_LinearProblem object using new matrix, LHS and RHS values.  The matrix
             structure must be *identical* to the matrix that was used to construct the original reduced problem.

           :rtype: int
           :return: Error code, set to 0 if no error.
        """
        return _Epetra.CrsSingletonFilter_UpdateReducedProblem(self, *args)

    def ComputeFullSolution(self, *args) -> "int":
        r"""
        Compute a solution for the full problem using the solution of the reduced problem, put in LHS of FullProblem(). After solving the reduced linear system, this method can be called to compute the
             solution to the original problem, assuming the solution for the reduced system is valid. The solution of the
             unreduced, original problem will be in the LHS of the original Epetra_LinearProblem.
        """
        return _Epetra.CrsSingletonFilter_ComputeFullSolution(self, *args)

    def NumRowSingletons(self, *args) -> "int":
        r""" Return number of rows that contain a single entry, returns -1 if Analysis not performed yet."""
        return _Epetra.CrsSingletonFilter_NumRowSingletons(self, *args)

    def NumColSingletons(self, *args) -> "int":
        r""" Return number of columns that contain a single entry that are *not* associated with singleton row, returns -1 if Analysis not performed yet."""
        return _Epetra.CrsSingletonFilter_NumColSingletons(self, *args)

    def NumSingletons(self, *args) -> "int":
        r"""
        Return total number of singletons detected, returns -1 if Analysis not performed yet. Return total number of singletons detected across all processors.  This method will not return a
             valid result until after the Analyze() method is called.  The dimension of the reduced system can
             be computed by subtracting this number from dimension of full system.
             Warning: This method returns -1 if Analyze() method has not been called.
        """
        return _Epetra.CrsSingletonFilter_NumSingletons(self, *args)

    def RatioOfDimensions(self, *args) -> "double":
        r""" Returns ratio of reduced system to full system dimensions, returns -1.0 if reduced problem not constructed."""
        return _Epetra.CrsSingletonFilter_RatioOfDimensions(self, *args)

    def RatioOfNonzeros(self, *args) -> "double":
        r""" Returns ratio of reduced system to full system nonzero count, returns -1.0 if reduced problem not constructed."""
        return _Epetra.CrsSingletonFilter_RatioOfNonzeros(self, *args)

    def FullProblem(self, *args) -> "Epetra_LinearProblem *":
        r""" Returns pointer to the original unreduced Epetra_LinearProblem."""
        return _Epetra.CrsSingletonFilter_FullProblem(self, *args)

    def ReducedProblem(self, *args) -> "Epetra_LinearProblem *":
        r""" Returns pointer to the derived reduced Epetra_LinearProblem."""
        return _Epetra.CrsSingletonFilter_ReducedProblem(self, *args)

    def FullMatrix(self, *args) -> "Epetra_RowMatrix *":
        r""" Returns pointer to Epetra_CrsMatrix from full problem."""
        return _Epetra.CrsSingletonFilter_FullMatrix(self, *args)

    def ReducedMatrix(self, *args) -> "Epetra_CrsMatrix *":
        r""" Returns pointer to Epetra_CrsMatrix from full problem."""
        return _Epetra.CrsSingletonFilter_ReducedMatrix(self, *args)

    def RowMapColors(self, *args) -> "Epetra_MapColoring *":
        r""" Returns pointer to Epetra_MapColoring object: color 0 rows are part of reduced system."""
        return _Epetra.CrsSingletonFilter_RowMapColors(self, *args)

    def ColMapColors(self, *args) -> "Epetra_MapColoring *":
        r""" Returns pointer to Epetra_MapColoring object: color 0 columns are part of reduced system."""
        return _Epetra.CrsSingletonFilter_ColMapColors(self, *args)

    def ReducedMatrixRowMap(self, *args) -> "Epetra_Map *":
        r""" Returns pointer to Epetra_Map describing the reduced system row distribution."""
        return _Epetra.CrsSingletonFilter_ReducedMatrixRowMap(self, *args)

    def ReducedMatrixColMap(self, *args) -> "Epetra_Map *":
        r""" Returns pointer to Epetra_Map describing the reduced system column distribution."""
        return _Epetra.CrsSingletonFilter_ReducedMatrixColMap(self, *args)

    def ReducedMatrixDomainMap(self, *args) -> "Epetra_Map *":
        r""" Returns pointer to Epetra_Map describing the domain map for the reduced system."""
        return _Epetra.CrsSingletonFilter_ReducedMatrixDomainMap(self, *args)

    def ReducedMatrixRangeMap(self, *args) -> "Epetra_Map *":
        r""" Returns pointer to Epetra_Map describing the range map for the reduced system."""
        return _Epetra.CrsSingletonFilter_ReducedMatrixRangeMap(self, *args)

# Register CrsSingletonFilter in _Epetra:
_Epetra.CrsSingletonFilter_swigregister(CrsSingletonFilter)

class VbrMatrix(DistObject, CompObject, BLAS, RowMatrix):
    r"""
     Epetra_VbrMatrix: A class for the construction and use of real-valued double-precision variable block-row sparse matrices. The Epetra_VbrMatrix class is a sparse variable block row matrix object. This matrix can be
      used in a parallel setting, with data distribution described by Epetra_Map attributes.
      The structure or graph of the matrix is defined by an Epetra_CrsGraph attribute.

     In addition to coefficient access, the primary operations provided by Epetra_VbrMatrix are matrix
     times vector and matrix times multi-vector multiplication.


    **Creating and filling Epetra_VbrMatrix objects**

    Constructing Epetra_VbrMatrix objects is a multi-step process.  The basic steps are as follows:

      *  Create Epetra_VbrMatrix instance via one of the constructors:

         * Constructor that accepts one Epetra_Map object, a row-map defining the distribution of matrix rows.
         * Constructor that accepts two Epetra_Map objects. (The second map is a column-map, and describes the set
           of column-indices that appear in each processor's portion of the matrix. Generally these are
           overlapping sets -- column-indices may appear on more than one processor.)
         * Constructor that accepts an Epetra_CrsGraph object, defining the non-zero structure of the matrix.

      *  Input coefficient values (more detail on this below).
      *  Complete construction by calling FillComplete.


    Note that even after FillComplete() has been called, it is possible to update existing matrix
    entries but it is *not* possible to create new entries.



    **Using Epetra_VbrMatrix as an Epetra_RowMatrix**

    Although Epetra_VbrMatrix does inherit from Epetra_RowMatrix,
    a design flaw in the inheritance structure of Epetra prohibits the use of
    an Epetra_VbrMatrix object as an Epetra_RowMatrix in some important situations.  Therefore we recommend the
    use of the Epetra_VbrRowMatrix class to wrap an Epetra_VbrMatrix object for use as an Epetra_RowMatrix.  The
    Epetra_VbrRowMatrix object does not duplicate data in the Epetra_VbrMatrix object, but uses it to satisfy the
    Epetra_RowMatrix interface.

    **Epetra_Map attributes**

    Epetra_VbrMatrix objects have four Epetra_Map attributes, which are held by the Epetra_CrsGraph attribute.

    The Epetra_Map attributes can be obtained via these accessor methods:

     * RowMap() Describes the numbering and distribution of the rows of the matrix. The row-map exists and is valid
     for the entire life of the matrix. The set of matrix rows is defined by the row-map and may not be changed. Rows
     may not be inserted or deleted by the user. The only change that may be made is that the user can replace the
     row-map with a compatible row-map (which is the same except for re-numbering) by calling the ReplaceRowMap() method.
     * ColMap() Describes the set of column-indices that appear in the rows in each processor's portion of the matrix.
     Unless provided by the user at construction time, a valid column-map doesn't exist until FillComplete() is called.
     * RangeMap() Describes the range of the matrix operator. e.g., for a matrix-vector product operation, the result
       vector's map must be compatible with the range-map of this matrix. The range-map is usually the same as the row-map.
       The range-map is set equal to the row-map at matrix creation time, but may be specified by the user when
       FillComplete() is called.
     * DomainMap() Describes the domain of the matrix operator. The domain-map can be specified by the user when
     FillComplete() is called. Until then, it is set equal to the row-map.


    It is important to note that while the row-map and the range-map are often the same, the column-map and the domain-map
    are almost never the same. The set of entries in a distributed column-map almost always form overlapping sets, with
    entries being associated with more than one processor. A domain-map, on the other hand, must be a 1-to-1 map, with
    entries being associated with only a single processor.

    **Local versus Global Indices**

    Epetra_VbrMatrix has query functions IndicesAreLocal() and IndicesAreGlobal(), which are used to determine whether the
    underlying Epetra_CrsGraph attribute's column-indices have been transformed into a local index space or not. (This
    transformation occurs when the method Epetra_CrsGraph::FillComplete() is called, which happens when
    the method Epetra_VbrMatrix::FillComplete() is called.) The state of the indices in the
    graph determines the behavior of many Epetra_VbrMatrix methods. If an Epetra_VbrMatrix instance is constructed using
    one of the constructors that does not accept a pre-existing Epetra_CrsGraph object, then an Epetra_CrsGraph attribute
    is created internally and its indices remain untransformed (IndicesAreGlobal()==true) until Epetra_VbrMatrix::FillComplete()
    is called. The query function Epetra_VbrMatrix::Filled() returns true if Epetra_VbrMatrix::FillComplete() has been
    called.

    **Inputting coefficient values**

    The process for inputting block-entry coefficients is as follows:

    * Indicate that values for a specified row are about to be provided by calling one of these methods
      which specify a block-row and a list of block-column-indices:

      * BeginInsertGlobalValues()
      * BeginInsertMyValues()
      * BeginReplaceGlobalValues()
      * BeginReplaceMyValues()
      * BeginSumIntoGlobalValues()
      * BeginSumIntoMyValues()

    * Loop over the list of block-column-indices and pass each block-entry to the matrix using the
      method SubmitBlockEntry().
    * Complete the process for the specified block-row by calling the method EndSubmitEntries().


    Note that the 'GlobalValues' methods have the precondition that IndicesAreGlobal() must be true, and
    the 'MyValues' methods have the precondition that IndicesAreLocal() must be true. Furthermore, the
    'SumInto' and 'Replace' methods may only be used to update matrix entries which already exist, and
    the 'Insert' methods may only be used if IndicesAreContiguous() is false.

    ** Counting Floating Point Operations **

    Each Epetra_VbrMatrix object keeps track of the number of *serial* floating point operations
    performed using the specified object as the *this* argument to the function.  The Flops()
    function returns this number as a double precision number.  Using this information, in
    conjunction with the Epetra_Time class, one can get accurate parallel performance
    numbers.  The ResetFlops() function resets the floating point counter.

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    __swig_destroy__ = _Epetra.delete_VbrMatrix

    def PutScalar(self, *args) -> "int":
        r"""
        Initialize all values in graph of the matrix with constant value.
           :param In:
                      ScalarConstant - Value to use.

           :rtype: int
           :return: Integer error code, set to 0 if successful.
        """
        return _Epetra.VbrMatrix_PutScalar(self, *args)

    def Scale(self, *args) -> "int":
        r"""
        Multiply all values in the matrix by a constant value (in place: A <- ScalarConstant * A).
           :param In:
                      ScalarConstant - Value to use.

           :rtype: int
           :return: Integer error code, set to 0 if successful.
        """
        return _Epetra.VbrMatrix_Scale(self, *args)

    def DirectSubmitBlockEntry(self, *args) -> "int":
        r"""
        Submit a block-entry directly into the matrix (without using a begin/end sequence) Experimental method which allows submitting a block-entry without first
             calling BeginInsertGlobalValues. This method copies the input data directly
             into the matrix storage.
             The block-entry is specified by global block-row and block-col indices.
        """
        return _Epetra.VbrMatrix_DirectSubmitBlockEntry(self, *args)

    def BeginInsertGlobalValues(self, *args) -> "int":
        r"""
        Initiate insertion of a list of elements in a given global row of the matrix, values are inserted via SubmitEntry().
           :param In:
                      BlockRow - Block Row number (in global coordinates) to put elements.
           :param In:
                      NumBlockEntries - Number of entries.
           :param In:
                      Indices - Global column indices corresponding to values.

           :rtype: int
           :return: Integer error code, set to 0 if successful.
        """
        return _Epetra.VbrMatrix_BeginInsertGlobalValues(self, *args)

    def BeginInsertMyValues(self, *args) -> "int":
        r"""
        Initiate insertion of a list of elements in a given local row of the matrix, values are inserted via SubmitEntry().
           :param In:
                      BlockRow - Block Row number (in local coordinates) to put elements.
           :param In:
                      NumBlockEntries - Number of entries.
           :param In:
                      Indices - Local column indices corresponding to values.

           :rtype: int
           :return: Integer error code, set to 0 if successful.
        """
        return _Epetra.VbrMatrix_BeginInsertMyValues(self, *args)

    def BeginReplaceGlobalValues(self, *args) -> "int":
        r"""
        Initiate replacement of current values with this list of entries for a given global row of the matrix, values are replaced via SubmitEntry()
           :param In:
                      Row - Block Row number (in global coordinates) to put elements.
           :param In:
                      NumBlockEntries - Number of entries.
           :param In:
                      Indices - Global column indices corresponding to values.

           :rtype: int
           :return: Integer error code, set to 0 if successful.
        """
        return _Epetra.VbrMatrix_BeginReplaceGlobalValues(self, *args)

    def BeginReplaceMyValues(self, *args) -> "int":
        r"""
        Initiate replacement of current values with this list of entries for a given local row of the matrix, values are replaced via SubmitEntry()
           :param In:
                      Row - Block Row number (in local coordinates) to put elements.
           :param In:
                      NumBlockEntries - Number of entries.
           :param In:
                      Indices - Local column indices corresponding to values.

           :rtype: int
           :return: Integer error code, set to 0 if successful.
        """
        return _Epetra.VbrMatrix_BeginReplaceMyValues(self, *args)

    def BeginSumIntoGlobalValues(self, *args) -> "int":
        r"""
        Initiate summing into current values with this list of entries for a given global row of the matrix, values are replaced via SubmitEntry()
           :param In:
                      Row - Block Row number (in global coordinates) to put elements.
           :param In:
                      NumBlockEntries - Number of entries.
           :param In:
                      Indices - Global column indices corresponding to values.

           :rtype: int
           :return: Integer error code, set to 0 if successful.
        """
        return _Epetra.VbrMatrix_BeginSumIntoGlobalValues(self, *args)

    def BeginSumIntoMyValues(self, *args) -> "int":
        r"""
        Initiate summing into current values with this list of entries for a given local row of the matrix, values are replaced via SubmitEntry()
           :param In:
                      Row - Block Row number (in local coordinates) to put elements.
           :param In:
                      NumBlockEntries - Number of entries.
           :param In:
                      Indices - Local column indices corresponding to values.

           :rtype: int
           :return: Integer error code, set to 0 if successful.
        """
        return _Epetra.VbrMatrix_BeginSumIntoMyValues(self, *args)

    def SubmitBlockEntry(self, *args) -> "int":
        r"""
        *Overload 1:*
        Submit a block entry to the indicated block row and column specified in the Begin routine.

        |

        *Overload 2:*
        Submit a block entry to the indicated block row and column specified in the Begin routine.
        """
        return _Epetra.VbrMatrix_SubmitBlockEntry(self, *args)

    def EndSubmitEntries(self, *args) -> "int":
        r"""
        Completes processing of all data passed in for the current block row. This function completes the processing of all block entries submitted via SubmitBlockEntry().
               It also checks to make sure that SubmitBlockEntry was called the correct number of times as
         specified by the Begin routine that initiated the entry process.
        """
        return _Epetra.VbrMatrix_EndSubmitEntries(self, *args)

    def ReplaceDiagonalValues(self, *args) -> "int":
        r"""
        Replaces diagonal values of the with those in the user-provided vector. This routine is meant to allow replacement of **existing** diagonal values.
               If a diagonal value does not exist for a given row, the corresponding value in
         the input Epetra_Vector will be ignored and the return code will be set to 1.

         The Epetra_Map associated with the input Epetra_Vector must be compatible with
         the RowMap of the matrix.

           :type Diagonal: :py:class:`Epetra_Vector`
           :param Diagonal: (In) - New values to be placed in the main diagonal.

           :rtype: int
           :return: Integer error code, set to 0 if successful, 1 of one or more diagonal entries not present in matrix.
        """
        return _Epetra.VbrMatrix_ReplaceDiagonalValues(self, *args)

    def FillComplete(self, *args) -> "int":
        r"""
        *Overload 1:*
        Signal that data entry is complete, perform transformations to local index space.

        |

        *Overload 2:*
        Signal that data entry is complete, perform transformations to local index space.
        """
        return _Epetra.VbrMatrix_FillComplete(self, *args)

    def Filled(self, *args) -> "bool":
        r""" If FillComplete() has been called, this query returns true, otherwise it returns false."""
        return _Epetra.VbrMatrix_Filled(self, *args)

    def ExtractGlobalBlockRowPointers(self, *args) -> "int":
        r"""
        Copy the block indices into user-provided array, set pointers for rest of data for specified global block row.
             This function provides the lightest weight approach to accessing a global block row when the matrix may be
             be stored in local or global index space.  In other words, this function will always work because the block
             indices are returned in user-provided space.  All other array arguments are independent of whether or not
             indices are local or global.  Other than the BlockIndices array, all other array argument are returned as
             pointers to internal data.

           :param In:
                      BlockRow - Global block row to extract.
           :param In:
                MaxNumBlockEntries - Length of user-provided BlockIndices array.
           :param Out:
                RowDim - Number of equations in the requested block row.
           :param Out:
                NumBlockEntries - Number of nonzero entries actually extracted.
           :param Out:
                BlockIndices - Extracted global column indices for the corresponding block entries.
           :param Out:
                Values - Pointer to list of pointers to block entries. Note that the actual values are not copied.

           :rtype: int
           :return: Integer error code, set to 0 if successful.
        """
        return _Epetra.VbrMatrix_ExtractGlobalBlockRowPointers(self, *args)

    def ExtractMyBlockRowPointers(self, *args) -> "int":
        r"""
        Copy the block indices into user-provided array, set pointers for rest of data for specified local block row.
             This function provides the lightest weight approach to accessing a local block row when the matrix may be
             be stored in local or global index space.  In other words, this function will always work because the block
             indices are returned in user-provided space.  All other array arguments are independent of whether or not
             indices are local or global.  Other than the BlockIndices array, all other array argument are returned as
             pointers to internal data.

           :param In:
                      BlockRow - Local block row to extract.
           :param In:
                MaxNumBlockEntries - Length of user-provided BlockIndices array.
           :param Out:
                RowDim - Number of equations in the requested block row.
           :param Out:
                NumBlockEntries - Number of nonzero entries actually extracted.
           :param Out:
                BlockIndices - Extracted local column indices for the corresponding block entries.
           :param Out:
                Values - Pointer to list of pointers to block entries. Note that the actual values are not copied.

           :rtype: int
           :return: Integer error code, set to 0 if successful.
        """
        return _Epetra.VbrMatrix_ExtractMyBlockRowPointers(self, *args)

    def BeginExtractGlobalBlockRowCopy(self, *args) -> "int":
        r"""
        Initiates a copy of the specified global row in user-provided arrays.
           :param In:
                      BlockRow - Global block row to extract.
           :param In:
                MaxNumBlockEntries - Length of user-provided BlockIndices, ColDims, and LDAs arrays.
           :param Out:
                RowDim - Number of equations in the requested block row.
           :param Out:
                NumBlockEntries - Number of nonzero entries actually extracted.
           :param Out:
                BlockIndices - Extracted global column indices for the corresponding block entries.
           :param Out:
                ColDim - List of column dimensions for each corresponding block entry that will be extracted.

           :rtype: int
           :return: Integer error code, set to 0 if successful.
        """
        return _Epetra.VbrMatrix_BeginExtractGlobalBlockRowCopy(self, *args)

    def BeginExtractMyBlockRowCopy(self, *args) -> "int":
        r"""
        Initiates a copy of the specified local row in user-provided arrays.
           :param In:
                      BlockRow - Local block row to extract.
           :param In:
                MaxNumBlockEntries - Length of user-provided BlockIndices, ColDims, and LDAs arrays.
           :param Out:
                RowDim - Number of equations in the requested block row.
           :param Out:
                NumBlockEntries - Number of nonzero entries actually extracted.
           :param Out:
                BlockIndices - Extracted local column indices for the corresponding block entries.
           :param Out:
                ColDim - List of column dimensions for each corresponding block entry that will be extracted.

           :rtype: int
           :return: Integer error code, set to 0 if successful.
        """
        return _Epetra.VbrMatrix_BeginExtractMyBlockRowCopy(self, *args)

    def ExtractEntryCopy(self, *args) -> "int":
        r"""
        Extract a copy of an entry from the block row specified by one of the BeginExtract routines. Once BeginExtractGlobalBlockRowCopy() or BeginExtractMyBlockRowCopy() is called, you can extract
               the block entries of specified block row one-entry-at-a-time.  The entries will be extracted
         in an order corresponding to the BlockIndices list that was returned by the BeginExtract routine.

           :param In:
                      SizeOfValues - Amount of memory associated with Values.  This must be at least as big as
                               LDA*NumCol, where NumCol is the column dimension of the block entry being copied
           :param InOut:
                      Values - Starting location where the block entry will be copied.
           :param In:
                      LDA - Specifies the stride that will be used when copying columns into Values.
           :param In:
                      SumInto - If set to true, the block entry values will be summed into existing values.
        """
        return _Epetra.VbrMatrix_ExtractEntryCopy(self, *args)

    def BeginExtractGlobalBlockRowView(self, *args) -> "int":
        r"""
        Initiates a view of the specified global row, only works if matrix indices are in global mode.
           :param In:
                      BlockRow - Global block row to view.
           :param Out:
                RowDim - Number of equations in the requested block row.
           :param Out:
                NumBlockEntries - Number of nonzero entries to be viewed.
           :param Out:
                BlockIndices - Pointer to global column indices for the corresponding block entries.

           :rtype: int
           :return: Integer error code, set to 0 if successful.
        """
        return _Epetra.VbrMatrix_BeginExtractGlobalBlockRowView(self, *args)

    def BeginExtractMyBlockRowView(self, *args) -> "int":
        r"""
        Initiates a view of the specified local row, only works if matrix indices are in local mode.
           :param In:
                      BlockRow - Local block row to view.
           :param Out:
                RowDim - Number of equations in the requested block row.
           :param Out:
                NumBlockEntries - Number of nonzero entries to be viewed.
           :param Out:
                BlockIndices - Pointer to local column indices for the corresponding block entries.

           :rtype: int
           :return: Integer error code, set to 0 if successful.
        """
        return _Epetra.VbrMatrix_BeginExtractMyBlockRowView(self, *args)

    def ExtractEntryView(self, *args) -> "int":
        r"""
        Returns a pointer to the current block entry. After a call to BeginExtractGlobal() or BlockRowViewBeginExtractMyBlockRowView(),
               ExtractEntryView() can be called up to NumBlockEntries times to get each block entry in the
         specified block row.
           :param InOut:
                      entry - A pointer that will be set to the current block entry.
        """
        return _Epetra.VbrMatrix_ExtractEntryView(self, *args)

    def ExtractGlobalBlockRowView(self, *args) -> "int":
        r"""
        Initiates a view of the specified global row, only works if matrix indices are in global mode.
           :param In:
                      BlockRow - Global block row to view.
           :param Out:
                RowDim - Number of equations in the requested block row.
           :param Out:
                NumBlockEntries - Number of nonzero entries to be viewed.
           :param Out:
                BlockIndices - Pointer to global column indices for the corresponding block entries.
           :param Out:
                Values - Pointer to an array of pointers to the block entries in the specified block row.

           :rtype: int
           :return: Integer error code, set to 0 if successful.
        """
        return _Epetra.VbrMatrix_ExtractGlobalBlockRowView(self, *args)

    def ExtractMyBlockRowView(self, *args) -> "int":
        r"""
        Initiates a view of the specified local row, only works if matrix indices are in local mode.
           :param In:
                      BlockRow - Local block row to view.
           :param Out:
                RowDim - Number of equations in the requested block row.
           :param Out:
                NumBlockEntries - Number of nonzero entries to be viewed.
           :param Out:
                BlockIndices - Pointer to local column indices for the corresponding block entries.
           :param Out:
                Values - Pointer to an array of pointers to the block entries in the specified block row.

           :rtype: int
           :return: Integer error code, set to 0 if successful.
        """
        return _Epetra.VbrMatrix_ExtractMyBlockRowView(self, *args)

    def ExtractDiagonalCopy(self, *args) -> "int":
        r"""
        ExtractDiagonalCopy(Vector diagonal) -> int

        Argument diagonal is provided to you as a numpy-hybrid Epetra.Vector,
        giving you access to the numpy interface in addition to the
        Epetra_Vector C++ interface.
        """
        return _Epetra.VbrMatrix_ExtractDiagonalCopy(self, *args)

    def BeginExtractBlockDiagonalCopy(self, *args) -> "int":
        r"""
        Initiates a copy of the block diagonal entries to user-provided arrays.
           :param In:
                MaxNumBlockDiagonalEntries - Length of user-provided RowColDims array.
           :param Out:
                NumBlockDiagonalEntries - Number of block diagonal entries that can actually be extracted.
           :param Out:
                RowColDim - List  of row and column dimension for corresponding block diagonal entries.

           :rtype: int
           :return: Integer error code, set to 0 if successful.
        """
        return _Epetra.VbrMatrix_BeginExtractBlockDiagonalCopy(self, *args)

    def ExtractBlockDiagonalEntryCopy(self, *args) -> "int":
        r"""
        Extract a copy of a block diagonal entry from the matrix. Once BeginExtractBlockDiagonalCopy() is called, you can extract
               the block diagonal entries one-entry-at-a-time.  The entries will be extracted
         in ascending order.

           :param In:
                      SizeOfValues - Amount of memory associated with Values.  This must be at least as big as
                               LDA*NumCol, where NumCol is the column dimension of the block entry being copied
           :param InOut:
                      Values - Starting location where the block entry will be copied.
           :param In:
                      LDA - Specifies the stride that will be used when copying columns into Values.
           :param In:
                      SumInto - If set to true, the block entry values will be summed into existing values.
        """
        return _Epetra.VbrMatrix_ExtractBlockDiagonalEntryCopy(self, *args)

    def BeginExtractBlockDiagonalView(self, *args) -> "int":
        r"""
        Initiates a view of the block diagonal entries.
           :param Out:
                NumBlockDiagonalEntries - Number of block diagonal entries that can be viewed.
           :param Out:
                RowColDim - Pointer to list  of row and column dimension for corresponding block diagonal entries.

           :rtype: int
           :return: Integer error code, set to 0 if successful.
        """
        return _Epetra.VbrMatrix_BeginExtractBlockDiagonalView(self, *args)

    def ExtractBlockDiagonalEntryView(self, *args) -> "int":
        r"""
        Extract a view of a block diagonal entry from the matrix. Once BeginExtractBlockDiagonalView() is called, you can extract a view of
               the block diagonal entries one-entry-at-a-time.  The views will be extracted
         in ascending order.

           :param Out:
                      Values - Pointer to internal copy of block entry.
           :param Out:
                      LDA - Column stride of Values.
        """
        return _Epetra.VbrMatrix_ExtractBlockDiagonalEntryView(self, *args)

    def Multiply1(self, *args) -> "int":
        r"""
        Returns the result of a Epetra_VbrMatrix multiplied by a Epetra_Vector x in y.
           :param In:
                TransA - If true, multiply by the transpose of matrix, otherwise just use matrix.
           :param In:
                x - A Epetra_Vector to multiply by.
           :param Out:
                y - A Epetra_Vector containing result.

           :rtype: int
           :return: Integer error code, set to 0 if successful.
        """
        return _Epetra.VbrMatrix_Multiply1(self, *args)

    def Multiply(self, *args) -> "int":
        r"""
        Multiply(bool useTranspose, MultiVector x, MultiVector y) -> int

        In C++, arguments x and y are Epetra_MultiVectors.  In python, they
        are provided to you as numpy-hybrid Epetra.MultiVectors, giving you
        access to the numpy interface in addition to the Epetra_MultiVector
        C++ interface.
        """
        return _Epetra.VbrMatrix_Multiply(self, *args)

    def Solve(self, *args) -> "int":
        r"""
        Solve((bool upper, bool trans, bool unitDiagonal, MultiVector x,
            MultiVector y) -> int

        In C++, arguments x and y are Epetra_MultiVectors.  In python, they
        are provided to you as numpy-hybrid Epetra.MultiVectors, giving you
        access to the numpy interface in addition to the Epetra_MultiVector
        C++ interface.
        """
        return _Epetra.VbrMatrix_Solve(self, *args)

    def InvRowSums(self, *args) -> "int":
        r"""
        InvRowSums(Vector x) -> int

        Argument x is provided to you as a numpy-hybrid Epetra.Vector, giving
        you access to the numpy interface in addition to the Epetra_Vector C++
        interface.
        """
        return _Epetra.VbrMatrix_InvRowSums(self, *args)

    def LeftScale(self, *args) -> "int":
        r"""
        LeftScale(Vector x) -> int

        Argument x is provided to you as a numpy-hybrid Epetra.Vector, giving
        you access to the numpy interface in addition to the Epetra_Vector C++
        interface.
        """
        return _Epetra.VbrMatrix_LeftScale(self, *args)

    def InvColSums(self, *args) -> "int":
        r"""
        InvColSums(Vector x) -> int

        Argument x is provided to you as a numpy-hybrid Epetra.Vector, giving
        you access to the numpy interface in addition to the Epetra_Vector C++
        interface.
        """
        return _Epetra.VbrMatrix_InvColSums(self, *args)

    def RightScale(self, *args) -> "int":
        r"""
        RightScale(Vector x) -> int

        Argument x is provided to you as a numpy-hybrid Epetra.Vector, giving
        you access to the numpy interface in addition to the Epetra_Vector C++
        interface.
        """
        return _Epetra.VbrMatrix_RightScale(self, *args)

    def OptimizeStorage(self, *args) -> "int":
        r""" Eliminates memory that is used for construction.  Make consecutive row index sections contiguous."""
        return _Epetra.VbrMatrix_OptimizeStorage(self, *args)

    def StorageOptimized(self, *args) -> "bool":
        r""" If OptimizeStorage() has been called, this query returns true, otherwise it returns false."""
        return _Epetra.VbrMatrix_StorageOptimized(self, *args)

    def IndicesAreGlobal(self, *args) -> "bool":
        r""" If matrix indices has not been transformed to local, this query returns true, otherwise it returns false."""
        return _Epetra.VbrMatrix_IndicesAreGlobal(self, *args)

    def IndicesAreLocal(self, *args) -> "bool":
        r""" If matrix indices has been transformed to local, this query returns true, otherwise it returns false."""
        return _Epetra.VbrMatrix_IndicesAreLocal(self, *args)

    def IndicesAreContiguous(self, *args) -> "bool":
        r""" If matrix indices are packed into single array (done in OptimizeStorage()) return true, otherwise false."""
        return _Epetra.VbrMatrix_IndicesAreContiguous(self, *args)

    def LowerTriangular(self, *args) -> "bool":
        r""" If matrix is lower triangular in local index space, this query returns true, otherwise it returns false."""
        return _Epetra.VbrMatrix_LowerTriangular(self, *args)

    def UpperTriangular(self, *args) -> "bool":
        r""" If matrix is upper triangular in local index space, this query returns true, otherwise it returns false."""
        return _Epetra.VbrMatrix_UpperTriangular(self, *args)

    def NoDiagonal(self, *args) -> "bool":
        r""" If matrix has no diagonal entries based on global row/column index comparisons, this query returns true, otherwise it returns false."""
        return _Epetra.VbrMatrix_NoDiagonal(self, *args)

    def NormInf(self, *args) -> "double":
        r""" Returns the infinity norm of the global matrix."""
        return _Epetra.VbrMatrix_NormInf(self, *args)

    def NormOne(self, *args) -> "double":
        r""" Returns the one norm of the global matrix."""
        return _Epetra.VbrMatrix_NormOne(self, *args)

    def NormFrobenius(self, *args) -> "double":
        r""" Returns the frobenius norm of the global matrix."""
        return _Epetra.VbrMatrix_NormFrobenius(self, *args)

    def MaxRowDim(self, *args) -> "int":
        r""" Returns the maximum row dimension of all block entries on this processor."""
        return _Epetra.VbrMatrix_MaxRowDim(self, *args)

    def MaxColDim(self, *args) -> "int":
        r""" Returns the maximum column dimension of all block entries on this processor."""
        return _Epetra.VbrMatrix_MaxColDim(self, *args)

    def GlobalMaxRowDim(self, *args) -> "int":
        r""" Returns the maximum row dimension of all block entries across all processors."""
        return _Epetra.VbrMatrix_GlobalMaxRowDim(self, *args)

    def GlobalMaxColDim(self, *args) -> "int":
        r""" Returns the maximum column dimension of all block entries across all processors."""
        return _Epetra.VbrMatrix_GlobalMaxColDim(self, *args)

    def NumMyRows(self, *args) -> "int":
        r""" Returns the number of matrix rows owned by the calling processor."""
        return _Epetra.VbrMatrix_NumMyRows(self, *args)

    def NumMyCols(self, *args) -> "int":
        r""" Returns the number of matrix columns owned by the calling processor."""
        return _Epetra.VbrMatrix_NumMyCols(self, *args)

    def NumMyNonzeros(self, *args) -> "int":
        r""" Returns the number of nonzero entriesowned by the calling processor ."""
        return _Epetra.VbrMatrix_NumMyNonzeros(self, *args)

    def NumGlobalRows(self, *args) -> "int":
        r""" Returns the number of global matrix rows."""
        return _Epetra.VbrMatrix_NumGlobalRows(self, *args)

    def NumGlobalRows64(self, *args) -> "long long":
        return _Epetra.VbrMatrix_NumGlobalRows64(self, *args)

    def NumGlobalCols(self, *args) -> "int":
        r""" Returns the number of global matrix columns."""
        return _Epetra.VbrMatrix_NumGlobalCols(self, *args)

    def NumGlobalCols64(self, *args) -> "long long":
        return _Epetra.VbrMatrix_NumGlobalCols64(self, *args)

    def NumGlobalNonzeros(self, *args) -> "int":
        r""" Returns the number of nonzero entries in the global matrix."""
        return _Epetra.VbrMatrix_NumGlobalNonzeros(self, *args)

    def NumGlobalNonzeros64(self, *args) -> "long long":
        return _Epetra.VbrMatrix_NumGlobalNonzeros64(self, *args)

    def NumMyBlockRows(self, *args) -> "int":
        r""" Returns the number of Block matrix rows owned by the calling processor."""
        return _Epetra.VbrMatrix_NumMyBlockRows(self, *args)

    def NumMyBlockCols(self, *args) -> "int":
        r""" Returns the number of Block matrix columns owned by the calling processor."""
        return _Epetra.VbrMatrix_NumMyBlockCols(self, *args)

    def NumMyBlockDiagonals(self, *args) -> "int":
        r""" Returns the number of local nonzero block diagonal entries, based on global row/column index comparisons."""
        return _Epetra.VbrMatrix_NumMyBlockDiagonals(self, *args)

    def NumMyDiagonals(self, *args) -> "int":
        r""" Returns the number of local nonzero diagonal entries, based on global row/column index comparisons."""
        return _Epetra.VbrMatrix_NumMyDiagonals(self, *args)

    def NumGlobalBlockRows(self, *args) -> "int":
        r""" Returns the number of global Block matrix rows."""
        return _Epetra.VbrMatrix_NumGlobalBlockRows(self, *args)

    def NumGlobalBlockRows64(self, *args) -> "long long":
        return _Epetra.VbrMatrix_NumGlobalBlockRows64(self, *args)

    def NumGlobalBlockCols(self, *args) -> "int":
        r""" Returns the number of global Block matrix columns."""
        return _Epetra.VbrMatrix_NumGlobalBlockCols(self, *args)

    def NumGlobalBlockCols64(self, *args) -> "long long":
        return _Epetra.VbrMatrix_NumGlobalBlockCols64(self, *args)

    def NumGlobalBlockEntries64(self, *args) -> "long long":
        return _Epetra.VbrMatrix_NumGlobalBlockEntries64(self, *args)

    def NumGlobalBlockDiagonals(self, *args) -> "int":
        r""" Returns the number of global nonzero block diagonal entries, based on global row/column index comparisions."""
        return _Epetra.VbrMatrix_NumGlobalBlockDiagonals(self, *args)

    def NumGlobalBlockDiagonals64(self, *args) -> "long long":
        return _Epetra.VbrMatrix_NumGlobalBlockDiagonals64(self, *args)

    def NumGlobalDiagonals(self, *args) -> "int":
        r""" Returns the number of global nonzero diagonal entries, based on global row/column index comparisions."""
        return _Epetra.VbrMatrix_NumGlobalDiagonals(self, *args)

    def NumGlobalDiagonals64(self, *args) -> "long long":
        return _Epetra.VbrMatrix_NumGlobalDiagonals64(self, *args)

    def NumGlobalBlockEntries(self, *args) -> "int":
        r"""
        *Overload 1:*
        Returns the number of nonzero block entries in the global matrix.

        |

        *Overload 2:*
        Returns the current number of nonzero Block entries in specified global row on this processor.
        """
        return _Epetra.VbrMatrix_NumGlobalBlockEntries(self, *args)

    def NumAllocatedGlobalBlockEntries(self, *args) -> "int":
        r""" Returns the allocated number of nonzero Block entries in specified global row on this processor."""
        return _Epetra.VbrMatrix_NumAllocatedGlobalBlockEntries(self, *args)

    def MaxNumBlockEntries(self, *args) -> "int":
        r""" Returns the maximum number of nonzero entries across all rows on this processor."""
        return _Epetra.VbrMatrix_MaxNumBlockEntries(self, *args)

    def GlobalMaxNumBlockEntries(self, *args) -> "int":
        r""" Returns the maximum number of nonzero entries across all rows on this processor."""
        return _Epetra.VbrMatrix_GlobalMaxNumBlockEntries(self, *args)

    def NumMyBlockEntries(self, *args) -> "int":
        r"""
        *Overload 1:*
        Returns the number of nonzero block entries in the calling processor's portion of the matrix.

        |

        *Overload 2:*
        Returns the current number of nonzero Block entries in specified local row on this processor.
        """
        return _Epetra.VbrMatrix_NumMyBlockEntries(self, *args)

    def NumAllocatedMyBlockEntries(self, *args) -> "int":
        r""" Returns the allocated number of nonzero Block entries in specified local row on this processor."""
        return _Epetra.VbrMatrix_NumAllocatedMyBlockEntries(self, *args)

    def MaxNumNonzeros(self, *args) -> "int":
        r"""
        Returns the maximum number of nonzero entries across all block rows on this processor. Let ki = the number of nonzero values in the ith block row of the VbrMatrix object.  For example,
               if the ith block row had 5 block entries and the size of each entry was 4-by-4, ki would be 80.
         Then this function return the max over all ki for all row on this processor.
        """
        return _Epetra.VbrMatrix_MaxNumNonzeros(self, *args)

    def GlobalMaxNumNonzeros(self, *args) -> "int":
        r""" Returns the maximum number of nonzero entries across all block rows on *all* processors. This function returns the max over all processor of MaxNumNonzeros()."""
        return _Epetra.VbrMatrix_GlobalMaxNumNonzeros(self, *args)

    def IndexBase(self, *args) -> "int":
        r""" Returns the index base for row and column indices for this graph. Index base for this map."""
        return _Epetra.VbrMatrix_IndexBase(self, *args)

    def IndexBase64(self, *args) -> "long long":
        return _Epetra.VbrMatrix_IndexBase64(self, *args)

    def Graph(self, *args) -> "Epetra_CrsGraph const &":
        r""" Returns a pointer to the Epetra_CrsGraph object associated with this matrix."""
        return _Epetra.VbrMatrix_Graph(self, *args)

    def Importer(self, *args) -> "Epetra_Import const *":
        r""" Returns the Epetra_Import object that contains the import operations for distributed operations."""
        return _Epetra.VbrMatrix_Importer(self, *args)

    def Exporter(self, *args) -> "Epetra_Export const *":
        r""" Returns the Epetra_Export object that contains the export operations for distributed operations."""
        return _Epetra.VbrMatrix_Exporter(self, *args)

    def DomainMap(self, *args) -> "Epetra_BlockMap const &":
        r""" Returns the Epetra_BlockMap object associated with the domain of this matrix operator."""
        return _Epetra.VbrMatrix_DomainMap(self, *args)

    def RangeMap(self, *args) -> "Epetra_BlockMap const &":
        r""" Returns the Epetra_BlockMap object associated with the range of this matrix operator."""
        return _Epetra.VbrMatrix_RangeMap(self, *args)

    def RowMap(self, *args) -> "Epetra_BlockMap const &":
        r""" Returns the RowMap object as an Epetra_BlockMap (the Epetra_Map base class) needed for implementing Epetra_RowMatrix."""
        return _Epetra.VbrMatrix_RowMap(self, *args)

    def ColMap(self, *args) -> "Epetra_BlockMap const &":
        r""" Returns the ColMap as an Epetra_BlockMap (the Epetra_Map base class) needed for implementing Epetra_RowMatrix."""
        return _Epetra.VbrMatrix_ColMap(self, *args)

    def Comm(self, *args) -> "Epetra_Comm const &":
        r""" Fills a matrix with rows from a source matrix based on the specified importer. Returns a pointer to the Epetra_Comm communicator associated with this matrix."""
        return _Epetra.VbrMatrix_Comm(self, *args)

    def LRID(self, *args) -> "int":
        return _Epetra.VbrMatrix_LRID(self, *args)

    def GRID(self, *args) -> "int":
        r""" Returns the global row index for give local row index, returns IndexBase-1 if we don't have this local row."""
        return _Epetra.VbrMatrix_GRID(self, *args)

    def GRID64(self, *args) -> "long long":
        return _Epetra.VbrMatrix_GRID64(self, *args)

    def LCID(self, *args) -> "int":
        return _Epetra.VbrMatrix_LCID(self, *args)

    def GCID(self, *args) -> "int":
        r""" Returns the global column index for give local column index, returns IndexBase-1 if we don't have this local column."""
        return _Epetra.VbrMatrix_GCID(self, *args)

    def GCID64(self, *args) -> "long long":
        return _Epetra.VbrMatrix_GCID64(self, *args)

    def MyGRID(self, *args) -> "bool":
        return _Epetra.VbrMatrix_MyGRID(self, *args)

    def MyLRID(self, *args) -> "bool":
        r""" Returns true if the LRID passed in belongs to the calling processor in this map, otherwise returns false."""
        return _Epetra.VbrMatrix_MyLRID(self, *args)

    def MyGCID(self, *args) -> "bool":
        return _Epetra.VbrMatrix_MyGCID(self, *args)

    def MyLCID(self, *args) -> "bool":
        r""" Returns true if the LRID passed in belongs to the calling processor in this map, otherwise returns false."""
        return _Epetra.VbrMatrix_MyLCID(self, *args)

    def MyGlobalBlockRow(self, *args) -> "bool":
        return _Epetra.VbrMatrix_MyGlobalBlockRow(self, *args)

    def Label(self, *args) -> "char const *":
        r""" Returns a character string describing the operator"""
        return _Epetra.VbrMatrix_Label(self, *args)

    def SetUseTranspose(self, *args) -> "int":
        r"""
        If set true, transpose of this operator will be applied. This flag allows the transpose of the given operator to be used implicitly.  Setting this flag
               affects only the Apply() and ApplyInverse() methods.  If the implementation of this interface
         does not support transpose use, this method should return a value of -1.

           :param In:
                UseTranspose -If true, multiply by the transpose of operator, otherwise just use operator.

           :rtype: int
           :return: Always returns 0.
        """
        return _Epetra.VbrMatrix_SetUseTranspose(self, *args)

    def Apply(self, *args) -> "int":
        r"""
        Apply(self, MultiVector x, MultiVector y) -> int

        In C++, the Apply() method is pure virtual, thus intended to be
        overridden by derived classes.  In python, cross-language polymorphism
        is supported, and you are expected to derive classes from this base
        class and redefine the Apply() method.  C++ code (e.g., AztecOO
        solvers) can call back to your Apply() method as needed.  You must
        support two arguments, labeled here MultiVector x and MultiVector y.
        These will be converted from Epetra_MultiVector C++ objects to
        numpy-hybrid Epetra.MultiVector objects before they are passed to you.
        Thus, it is legal to use slice indexing and other numpy features to
        compute y from x.

        If application of your operator is successful, return 0; else return
        some non-zero error code.

        It is strongly suggested that you prevent Apply() from raising any
        exceptions.  Accidental errors can be prevented by wrapping your code
        in a try block:

            try:
                # Your code goes here...
            except Exception, e:
                print 'A python exception was raised by method Apply:'
                print e
                return -1

        By returning a -1, you inform the calling routine that Apply() was
        unsuccessful.

        """
        return _Epetra.VbrMatrix_Apply(self, *args)

    def ApplyInverse(self, *args) -> "int":
        r"""
        ApplyInverse(self, MultiVector x, MultiVector y) -> int

        In C++, the ApplyInverse() method is pure virtual, thus intended to be
        overridden by derived classes.  In python, cross-language polymorphism
        is supported, and you are expected to derive classes from this base
        class and redefine the ApplyInverse() method.  C++ code (e.g., AztecOO
        solvers) can call back to your ApplyInverse() method as needed.  You
        must support two arguments, labeled here MultiVector x and MultiVector
        y.  These will be converted from Epetra_MultiVector C++ objects to
        numpy-hybrid Epetra.MultiVector objects before they are passed to you.
        Thus, it is legal to use slice indexing and other numpy features to
        compute y from x.

        If application of your operator is successful, return 0; else return
        some non-zero error code.

        It is strongly suggested that you prevent ApplyInverse() from raising
        any exceptions.  Accidental errors can be prevented by wrapping your
        code in a try block:

            try:
                # Your code goes here...
            except Exception, e:
                print 'A python exception was raised by method ApplyInverse:'
                print e
                return -1

        By returning a -1, you inform the calling routine that ApplyInverse()
        was unsuccessful.

        """
        return _Epetra.VbrMatrix_ApplyInverse(self, *args)

    def HasNormInf(self, *args) -> "bool":
        r""" Returns true because this class can compute an Inf-norm."""
        return _Epetra.VbrMatrix_HasNormInf(self, *args)

    def UseTranspose(self, *args) -> "bool":
        r""" Returns the current UseTranspose setting."""
        return _Epetra.VbrMatrix_UseTranspose(self, *args)

    def OperatorDomainMap(self, *args) -> "Epetra_Map const &":
        r""" Returns the Epetra_Map object associated with the domain of this matrix operator."""
        return _Epetra.VbrMatrix_OperatorDomainMap(self, *args)

    def OperatorRangeMap(self, *args) -> "Epetra_Map const &":
        r""" Returns the Epetra_Map object associated with the range of this matrix operator."""
        return _Epetra.VbrMatrix_OperatorRangeMap(self, *args)

    def ExtractGlobalRowCopy(self, *args) -> "int":
        r"""
        Returns a copy of the specified global row in user-provided arrays.
           :param In:
                      GlobalRow - Global row to extract.
           :param In:
                Length - Length of Values and Indices.
           :param Out:
                NumEntries - Number of nonzero entries extracted.
           :param Out:
                Values - Extracted values for this row.
           :param Out:
                Indices - Extracted global column indices for the corresponding values.

           :rtype: int
           :return: Integer error code, set to 0 if successful.
        """
        return _Epetra.VbrMatrix_ExtractGlobalRowCopy(self, *args)

    def ExtractMyRowCopy(self, *args) -> "int":
        r"""
        ExtractMyRowCopy(int myRow, int length, numpy.ndarray numEntries,
            numpy.ndarray values, numpy.ndarray indices) -> int

        In C++, numEntries in an int&.  In python, it is provided to you as a
        numpy array of length one so that you can set its value in-place using
        numEntries[0] = ....

        Arguments values and indices are double* and int*, respectively, in
        C++.  In python, these are provided to you as numpy arrays of the
        given length, so that you may alter their entries in-place.
        """
        return _Epetra.VbrMatrix_ExtractMyRowCopy(self, *args)

    def NumMyRowEntries(self, *args) -> "int":
        r"""
        NumMyRowEntries(int myRow, numpy.ndarray numEntries) -> int

        In C++, numEntries in an int&.  In python, it is provided to you as a
        numpy array of length one so that you can set its value in-place using
        numEntries[0] = ....
        """
        return _Epetra.VbrMatrix_NumMyRowEntries(self, *args)

    def MaxNumEntries(self, *args) -> "int":
        r""" Returns the maximum of NumMyRowEntries() over all rows."""
        return _Epetra.VbrMatrix_MaxNumEntries(self, *args)

    def Map(self, *args) -> "Epetra_BlockMap const &":
        r""" Map() method inherited from Epetra_DistObject"""
        return _Epetra.VbrMatrix_Map(self, *args)

    def RowMatrixRowMap(self, *args) -> "Epetra_Map const &":
        r""" Returns the EpetraMap object associated with the rows of this matrix."""
        return _Epetra.VbrMatrix_RowMatrixRowMap(self, *args)

    def RowMatrixColMap(self, *args) -> "Epetra_Map const &":
        r""" Returns the Epetra_Map object associated with columns of this matrix."""
        return _Epetra.VbrMatrix_RowMatrixColMap(self, *args)

    def RowMatrixImporter(self, *args) -> "Epetra_Import const *":
        r""" Returns the Epetra_Import object that contains the import operations for distributed operations."""
        return _Epetra.VbrMatrix_RowMatrixImporter(self, *args)

    def BlockImportMap(self, *args) -> "Epetra_BlockMap const &":
        r""" Use BlockColMap() instead."""
        return _Epetra.VbrMatrix_BlockImportMap(self, *args)

    def TransformToLocal(self, *args) -> "int":
        r"""
        *Overload 1:*
        Use FillComplete() instead.

        |

        *Overload 2:*
        Use FillComplete(const Epetra_BlockMap& DomainMap, const Epetra_BlockMap& RangeMap) instead.
        """
        return _Epetra.VbrMatrix_TransformToLocal(self, *args)

    def __init__(self, *args):
        r"""

        __init__(self, Epetra_DataAccess CV, BlockMap rowMap, int
            numBlockEntriesPerRow) -> VbrMatrix

          VbrMatrix constructor with implicit column map and constant number
          of block entries per row.

        __init__(self, Epetra_DataAccess CV, BlockMap rowMap, BlockMap colMap,
            int numBlockEntriesPerRow) -> VbrMatrix

          VbrMatrix constructor with specified column map and constant number
          of block entries per row.


        __init__(self, Epetra_DataAccess CV, CrsGraph graph) -> VbrMatrix

          CrsGraph constructor.

        __init__(self, VbrMatrix matrix) -> VbrMatrix

          Copy constructor.

        __init__(self, Epetra_DataAccess CV, BlockMap rowMap, PySequence
            numBlockEntriesPerRow) -> VbrMatrix

          VbrMatrix constructor with implicit column map and variable number
          of block entries per row.


        __init__(self, Epetra_DataAccess CV, BlockMap rowMap, BlockMap colMap,
            PySequence numBlockEntriesPerRow) -> VbrMatrix

          VbrMatrix constructor with specified column map and variable number
          of block entries per row.


        """
        _Epetra.VbrMatrix_swiginit(self, _Epetra.new_VbrMatrix(*args))

# Register VbrMatrix in _Epetra:
_Epetra.VbrMatrix_swigregister(VbrMatrix)

class FEVbrMatrix(VbrMatrix):
    r"""
    Epetra Finite-Element VbrMatrix. This class provides the ability to
       input finite-element style sub-matrix data, including sub-matrices with
       non-local rows (which could correspond to shared finite-element nodes for
       example). This class inherits Epetra_VbrMatrix, and so all Epetra_VbrMatrix
       functionality is also available.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        *Overload 1:*
        Epetra_FEVbrMatrix constuctor with variable number of indices per row. Creates a Epetra_FEVbrMatrix object and allocates storage.

           :param In:
                      CV - A Epetra_DataAccess enumerated type set to Copy or View.
           :param In:
                      RowMap - A Epetra_BlockMap listing the block rows that this processor
           	   will contribute to.
           :param In:
                      NumBlockEntriesPerRow - An integer array of length NumRows
           	   such that NumBlockEntriesPerRow[i] indicates the (approximate)
           	   number of Block entries in the ith row.

        |

        *Overload 2:*
        Epetra_FEVbrMatrix constuctor with fixed number of indices per row. Creates a Epetra_FEVbrMatrix object and allocates storage.

           :param In:
                      CV - A Epetra_DataAccess enumerated type set to Copy or View.
           :param In:
                      RowMap - An Epetra_BlockMap listing the block rows that this
           	   processor will contribute to.
           :param In:
                      NumBlockEntriesPerRow - An integer that indicates the (approximate)
           	   number of Block entries in the each Block row.
           	   Note that it is possible to use 0 for this value and let fill occur
           	   during the insertion phase.

        |

        *Overload 3:*
        Epetra_FEVbrMatrix constuctor with variable number of indices per row. Creates a Epetra_FEVbrMatrix object and allocates storage.

           :param In:
                      CV - A Epetra_DataAccess enumerated type set to Copy or View.
           :param In:
                      RowMap - A Epetra_BlockMap listing the block rows that this processor
           	   will contribute to.
           :param In:
                      ColMap - A Epetra_BlockMap listing the block columns to be contained
           	   on this processor.
           :param In:
                      NumBlockEntriesPerRow - An integer array of length NumRows
           	   such that NumBlockEntriesPerRow[i] indicates the (approximate)
           	   number of Block entries in the ith row.

        |

        *Overload 4:*
        Epetra_FEVbrMatrix constuctor with fixed number of indices per row. Creates a Epetra_FEVbrMatrix object and allocates storage.

           :param In:
                      CV - A Epetra_DataAccess enumerated type set to Copy or View.
           :param In:
                      RowMap - An Epetra_BlockMap listing the block rows that this
           	   processor will contribute to.
           :param In:
                      ColMap - An Epetra_BlockMap listing the block columns to be contained
           	   on this processor.
           :param In:
                      NumBlockEntriesPerRow - An integer that indicates the (approximate)
           	   number of Block entries in the each Block row.
           	   Note that it is possible to use 0 for this value and let fill occur
           	   during the insertion phase.

        |

        *Overload 5:*
        Constructor with pre-constructed Graph.

        |

        *Overload 6:*
        Copy Constructor.
        """
        _Epetra.FEVbrMatrix_swiginit(self, _Epetra.new_FEVbrMatrix(*args))
    __swig_destroy__ = _Epetra.delete_FEVbrMatrix

    def PutScalar(self, *args) -> "int":
        r"""
        Initialize all values in graph of the matrix with constant value.
           :param In:
                      ScalarConstant - Value to use.

           :rtype: int
           :return: Integer error code, set to 0 if successful.
        """
        return _Epetra.FEVbrMatrix_PutScalar(self, *args)

    def BeginInsertGlobalValues(self, *args) -> "int":
        r"""
        Initiate insertion of a list of elements in a given global row of the matrix, values are inserted via SubmitEntry().
           :param In:
                      BlockRow - Block Row number (in global coordinates) to put elements.
           :param In:
                      NumBlockEntries - Number of entries.
           :param In:
                      Indices - Global column indices corresponding to values.

           :rtype: int
           :return: Integer error code, set to 0 if successful.
        """
        return _Epetra.FEVbrMatrix_BeginInsertGlobalValues(self, *args)

    def BeginReplaceGlobalValues(self, *args) -> "int":
        r"""
        Initiate replacement of current values with this list of entries for a given global row of the matrix, values are replaced via SubmitEntry()
           :param In:
                      Row - Block Row number (in global coordinates) to put elements.
           :param In:
                      NumBlockEntries - Number of entries.
           :param In:
                      Indices - Global column indices corresponding to values.

           :rtype: int
           :return: Integer error code, set to 0 if successful.
        """
        return _Epetra.FEVbrMatrix_BeginReplaceGlobalValues(self, *args)

    def BeginSumIntoGlobalValues(self, *args) -> "int":
        r"""
        Initiate summing into current values with this list of entries for a given global row of the matrix, values are replaced via SubmitEntry()
           :param In:
                      Row - Block Row number (in global coordinates) to put elements.
           :param In:
                      NumBlockEntries - Number of entries.
           :param In:
                      Indices - Global column indices corresponding to values.

           :rtype: int
           :return: Integer error code, set to 0 if successful.
        """
        return _Epetra.FEVbrMatrix_BeginSumIntoGlobalValues(self, *args)

    def SubmitBlockEntry(self, *args) -> "int":
        r"""
        *Overload 1:*
        Submit a block entry to the indicated block row and column specified in the Begin routine.

        |

        *Overload 2:*
        Submit a block entry to the indicated block row and column specified in the Begin routine.
        """
        return _Epetra.FEVbrMatrix_SubmitBlockEntry(self, *args)

    def EndSubmitEntries(self, *args) -> "int":
        r"""
        Completes processing of all data passed in for the current block row. This function completes the processing of all block entries submitted via SubmitBlockEntry().
               It also checks to make sure that SubmitBlockEntry was called the correct number of times as
        specified by the Begin routine that initiated the entry process.
        """
        return _Epetra.FEVbrMatrix_EndSubmitEntries(self, *args)

    def GlobalAssemble(self, *args) -> "int":
        return _Epetra.FEVbrMatrix_GlobalAssemble(self, *args)

# Register FEVbrMatrix in _Epetra:
_Epetra.FEVbrMatrix_swigregister(FEVbrMatrix)

class JadMatrix(BasicRowMatrix):
    r"""
    Epetra_JadMatrix: A class for constructing matrix objects optimized for common kernels. The Epetra_JadMatrix class takes an existing Epetra_RowMatrix ojbect, analyzes it and
       builds a jagged diagonal equivalent of it. Once constructed, it is also possible to
       update the values of the matrix with values from another Epetra_RowMatrix that has
       the identical structure.

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r""" Epetra_JadMatrix constuctor."""
        _Epetra.JadMatrix_swiginit(self, _Epetra.new_JadMatrix(*args))
    __swig_destroy__ = _Epetra.delete_JadMatrix

    def UpdateValues(self, *args) -> "int":
        r""" Update values using a matrix with identical structure."""
        return _Epetra.JadMatrix_UpdateValues(self, *args)

    def ExtractMyRowCopy(self, *args) -> "int":
        r"""
        ExtractMyRowCopy(int myRow, int length, numpy.ndarray numEntries,
            numpy.ndarray values, numpy.ndarray indices) -> int

        In C++, numEntries in an int&.  In python, it is provided to you as a
        numpy array of length one so that you can set its value in-place using
        numEntries[0] = ....

        Arguments values and indices are double* and int*, respectively, in
        C++.  In python, these are provided to you as numpy arrays of the
        given length, so that you may alter their entries in-place.
        """
        return _Epetra.JadMatrix_ExtractMyRowCopy(self, *args)

    def NumMyRowEntries(self, *args) -> "int":
        r"""
        NumMyRowEntries(int myRow, numpy.ndarray numEntries) -> int

        In C++, numEntries in an int&.  In python, it is provided to you as a
        numpy array of length one so that you can set its value in-place using
        numEntries[0] = ....
        """
        return _Epetra.JadMatrix_NumMyRowEntries(self, *args)

    def Multiply(self, *args) -> "int":
        r"""
        Multiply(bool useTranspose, MultiVector x, MultiVector y) -> int

        In C++, arguments x and y are Epetra_MultiVectors.  In python, they
        are provided to you as numpy-hybrid Epetra.MultiVectors, giving you
        access to the numpy interface in addition to the Epetra_MultiVector
        C++ interface.
        """
        return _Epetra.JadMatrix_Multiply(self, *args)

    def Solve(self, *args) -> "int":
        r"""
        Solve((bool upper, bool trans, bool unitDiagonal, MultiVector x,
            MultiVector y) -> int

        In C++, arguments x and y are Epetra_MultiVectors.  In python, they
        are provided to you as numpy-hybrid Epetra.MultiVectors, giving you
        access to the numpy interface in addition to the Epetra_MultiVector
        C++ interface.
        """
        return _Epetra.JadMatrix_Solve(self, *args)

# Register JadMatrix in _Epetra:
_Epetra.JadMatrix_swigregister(JadMatrix)

easy = _Epetra.easy
moderate = _Epetra.moderate
hard = _Epetra.hard
unsure = _Epetra.unsure
class Epetra_LinearProblem(object):
    r"""
    Epetra_LinearProblem:  The Epetra Linear Problem Class. The Epetra_LinearProblem class is a wrapper that encapsulates the
     general information needed for solving a linear system of equations.
     Currently it accepts a Epetra matrix, initial guess and RHS and
     returns the solution.
     the elapsed time for each calling processor.
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        *Overload 1:*
         Epetra_LinearProblem Default Constructor. Creates an empty Epetra_LinearProblem instance. The operator A, left-hand-side X
             and right-hand-side B must be set use the SetOperator(), SetLHS() and SetRHS()
             methods respectively.

        |

        *Overload 2:*
         Epetra_LinearProblem Constructor to pass in an operator as a matrix. Creates a Epetra_LinearProblem instance where the operator is passed in as a matrix.

        |

        *Overload 3:*
         Epetra_LinearProblem Constructor to pass in a basic Epetra_Operator. Creates a Epetra_LinearProblem instance for the case where an operator is not necessarily a matrix.

        |

        *Overload 4:*
        Epetra_LinearProblem Copy Constructor. Makes copy of an existing Epetra_LinearProblem instance.
        """
        _Epetra.Epetra_LinearProblem_swiginit(self, _Epetra.new_Epetra_LinearProblem(*args))
    __swig_destroy__ = _Epetra.delete_Epetra_LinearProblem

    def CheckInput(self, *args) -> "int":
        r"""
        Check input parameters for existence and size consistency. Returns 0 if all input parameters are valid.  Returns +1 if operator is not a matrix.
             This is not necessarily an error, but no scaling can be done if the user passes in an
             Epetra_Operator that is not an Epetra_Matrix
        """
        return _Epetra.Epetra_LinearProblem_CheckInput(self, *args)

    def AssertSymmetric(self, *args) -> "void":
        return _Epetra.Epetra_LinearProblem_AssertSymmetric(self, *args)

    def SetPDL(self, *args) -> "void":
        r"""
        Set problem difficulty level. Sets Aztec options and parameters based on a definition of easy moderate or hard problem.
             Relieves the user from explicitly setting a large number of individual parameter values.
             This function can be used in conjunction with the SetOptions() and SetParams() functions.
        """
        return _Epetra.Epetra_LinearProblem_SetPDL(self, *args)

    def SetOperator(self, *args) -> "void":
        r"""
        *Overload 1:*
        Set Operator A of linear problem AX = B using an Epetra_RowMatrix. Sets a pointer to a Epetra_RowMatrix.  No copy of the operator is made.

        |

        *Overload 2:*
        Set Operator A of linear problem AX = B using an Epetra_Operator. Sets a pointer to a Epetra_Operator.  No copy of the operator is made.
        """
        return _Epetra.Epetra_LinearProblem_SetOperator(self, *args)

    def SetLHS(self, *args) -> "void":
        r""" Set left-hand-side X of linear problem AX = B. Sets a pointer to a Epetra_MultiVector.  No copy of the object is made."""
        return _Epetra.Epetra_LinearProblem_SetLHS(self, *args)

    def SetRHS(self, *args) -> "void":
        r""" Set right-hand-side B of linear problem AX = B. Sets a pointer to a Epetra_MultiVector.  No copy of the object is made."""
        return _Epetra.Epetra_LinearProblem_SetRHS(self, *args)

    def LeftScale(self, *args) -> "int":
        r"""
        Perform left scaling of a linear problem. Applies the scaling vector D to the left side of the matrix A() and
           to the right hand side B().  Note that the operator must be an Epetra_RowMatrix,
             not just an Epetra_Operator (the base class of Epetra_RowMatrix).
           :param In:
                      D - Vector containing scaling values.  D[i] will be applied
                          to the ith row of A() and B().
           :rtype: int
           :return: Integer error code, set to 0 if successful. Return -1 if operator is not a matrix.
        """
        return _Epetra.Epetra_LinearProblem_LeftScale(self, *args)

    def RightScale(self, *args) -> "int":
        r"""
        Perform right scaling of a linear problem. Applies the scaling vector D to the right side of the matrix A().
             Apply the inverse of D to the initial guess.  Note that the operator must be an Epetra_RowMatrix,
             not just an Epetra_Operator (the base class of Epetra_RowMatrix).
           :param In:
                      D - Vector containing scaling values.  D[i] will be applied
                          to the ith row of A().  1/D[i] will be applied to the
                          ith row of B().
           :rtype: int
           :return: Integer error code, set to 0 if successful. Return -1 if operator is not a matrix.
        """
        return _Epetra.Epetra_LinearProblem_RightScale(self, *args)

    def GetOperator(self, *args) -> "Epetra_Operator *":
        r""" Get a pointer to the operator A."""
        return _Epetra.Epetra_LinearProblem_GetOperator(self, *args)

    def GetMatrix(self, *args) -> "Epetra_RowMatrix *":
        r""" Get a pointer to the matrix A."""
        return _Epetra.Epetra_LinearProblem_GetMatrix(self, *args)

    def GetLHS(self, *args) -> "Epetra_MultiVector *":
        r""" Get a pointer to the left-hand-side X."""
        return _Epetra.Epetra_LinearProblem_GetLHS(self, *args)

    def GetRHS(self, *args) -> "Epetra_MultiVector *":
        r""" Get a pointer to the right-hand-side B."""
        return _Epetra.Epetra_LinearProblem_GetRHS(self, *args)

    def GetPDL(self, *args) -> "ProblemDifficultyLevel":
        r""" Get problem difficulty level."""
        return _Epetra.Epetra_LinearProblem_GetPDL(self, *args)

    def IsOperatorSymmetric(self, *args) -> "bool":
        r""" Get operator symmetry bool."""
        return _Epetra.Epetra_LinearProblem_IsOperatorSymmetric(self, *args)

# Register Epetra_LinearProblem in _Epetra:
_Epetra.Epetra_LinearProblem_swigregister(Epetra_LinearProblem)

class LinearProblem(Epetra_LinearProblem):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        _Epetra.LinearProblem_swiginit(self, _Epetra.new_LinearProblem(*args))
    __swig_destroy__ = _Epetra.delete_LinearProblem

    def CheckInput(self, *args) -> "int":
        r"""
        Check input parameters for existence and size consistency. Returns 0 if all input parameters are valid.  Returns +1 if operator is not a matrix.
             This is not necessarily an error, but no scaling can be done if the user passes in an
             Epetra_Operator that is not an Epetra_Matrix
        """
        return _Epetra.LinearProblem_CheckInput(self, *args)

    def AssertSymmetric(self, *args) -> "void":
        return _Epetra.LinearProblem_AssertSymmetric(self, *args)

    def SetPDL(self, *args) -> "void":
        r"""
        Set problem difficulty level. Sets Aztec options and parameters based on a definition of easy moderate or hard problem.
             Relieves the user from explicitly setting a large number of individual parameter values.
             This function can be used in conjunction with the SetOptions() and SetParams() functions.
        """
        return _Epetra.LinearProblem_SetPDL(self, *args)

    def SetOperator(self, *args) -> "void":
        return _Epetra.LinearProblem_SetOperator(self, *args)

    def SetLHS(self, *args) -> "void":
        return _Epetra.LinearProblem_SetLHS(self, *args)

    def SetRHS(self, *args) -> "void":
        return _Epetra.LinearProblem_SetRHS(self, *args)

    def LeftScale(self, *args) -> "int":
        r"""
        Perform left scaling of a linear problem. Applies the scaling vector D to the left side of the matrix A() and
           to the right hand side B().  Note that the operator must be an Epetra_RowMatrix,
             not just an Epetra_Operator (the base class of Epetra_RowMatrix).
           :param In:
                      D - Vector containing scaling values.  D[i] will be applied
                          to the ith row of A() and B().
           :rtype: int
           :return: Integer error code, set to 0 if successful. Return -1 if operator is not a matrix.
        """
        return _Epetra.LinearProblem_LeftScale(self, *args)

    def RightScale(self, *args) -> "int":
        r"""
        Perform right scaling of a linear problem. Applies the scaling vector D to the right side of the matrix A().
             Apply the inverse of D to the initial guess.  Note that the operator must be an Epetra_RowMatrix,
             not just an Epetra_Operator (the base class of Epetra_RowMatrix).
           :param In:
                      D - Vector containing scaling values.  D[i] will be applied
                          to the ith row of A().  1/D[i] will be applied to the
                          ith row of B().
           :rtype: int
           :return: Integer error code, set to 0 if successful. Return -1 if operator is not a matrix.
        """
        return _Epetra.LinearProblem_RightScale(self, *args)

    def GetMatrix(self, *args) -> "Teuchos::RCP< Epetra_RowMatrix >":
        return _Epetra.LinearProblem_GetMatrix(self, *args)

    def GetOperator(self, *args) -> "Teuchos::RCP< Epetra_Operator >":
        return _Epetra.LinearProblem_GetOperator(self, *args)

    def GetLHS(self, *args) -> "Teuchos::RCP< Epetra_MultiVector >":
        return _Epetra.LinearProblem_GetLHS(self, *args)

    def GetRHS(self, *args) -> "Teuchos::RCP< Epetra_MultiVector >":
        return _Epetra.LinearProblem_GetRHS(self, *args)

    def GetPDL(self, *args) -> "ProblemDifficultyLevel":
        r""" Get problem difficulty level."""
        return _Epetra.LinearProblem_GetPDL(self, *args)

    def IsOperatorSymmetric(self, *args) -> "bool":
        r""" Get operator symmetry bool."""
        return _Epetra.LinearProblem_IsOperatorSymmetric(self, *args)

# Register LinearProblem in _Epetra:
_Epetra.LinearProblem_swigregister(LinearProblem)

class Util(object):
    r"""
    Epetra Util Wrapper Class.

    The Epetra.Util class is a collection of useful functions that cut
    across a broad set of other classes.  A random number generator is
    provided, along with methods to set and retrieve the random-number
    seed.

    The random number generator is a multiplicative linear congruential
    generator, with multiplier 16807 and modulus 2^31 - 1. It is based on
    the algorithm described in 'Random Number Generators: Good Ones Are
    Hard To Find', S. K. Park and K. W. Miller, Communications of the ACM,
    vol. 31, no. 10, pp. 1192-1201.

    The C++ Sort() method is not supported in python.

    A static function is provided for creating a new Epetra.Map object
    with 1-to-1 ownership of entries from an existing map which may have
    entries that appear on multiple processors.

    Epetra.Util is a serial interface only.  This is appropriate since the
    standard utilities are only specified for serial execution (or shared
    memory parallel).
    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args):
        r"""
        Epetra Util Wrapper Class.

        The Epetra.Util class is a collection of useful functions that cut
        across a broad set of other classes.  A random number generator is
        provided, along with methods to set and retrieve the random-number
        seed.

        The random number generator is a multiplicative linear congruential
        generator, with multiplier 16807 and modulus 2^31 - 1. It is based on
        the algorithm described in 'Random Number Generators: Good Ones Are
        Hard To Find', S. K. Park and K. W. Miller, Communications of the ACM,
        vol. 31, no. 10, pp. 1192-1201.

        The C++ Sort() method is not supported in python.

        A static function is provided for creating a new Epetra.Map object
        with 1-to-1 ownership of entries from an existing map which may have
        entries that appear on multiple processors.

        Epetra.Util is a serial interface only.  This is appropriate since the
        standard utilities are only specified for serial execution (or shared
        memory parallel).
        """
        _Epetra.Util_swiginit(self, _Epetra.new_Util(*args))
    __swig_destroy__ = _Epetra.delete_Util

    def RandomInt(self, *args) -> "unsigned int":
        r""" Returns a random integer on the interval (0, 2^31-1)"""
        return _Epetra.Util_RandomInt(self, *args)

    def RandomDouble(self, *args) -> "double":
        r""" Returns a random double on the interval (-1.0,1.0)"""
        return _Epetra.Util_RandomDouble(self, *args)

    def Seed(self, *args) -> "unsigned int":
        r"""
        Get seed from Random function.
           :rtype: int
           :return: Current random number seed.
        """
        return _Epetra.Util_Seed(self, *args)

    def SetSeed(self, *args) -> "int":
        r"""
        Set seed for Random function.
           :param In:
               Seed - An integer on the interval [1, 2^31-2]

           :rtype: int
           :return: Integer error code, set to 0 if successful.
        """
        return _Epetra.Util_SetSeed(self, *args)

    @staticmethod
    def Create_Root_Map(*args) -> "Epetra_Map":
        r"""
        Epetra_Util Create_Root_Map function Function to create a new Epetra_Map object with all GIDs sent to the root processor
             which is zero by default.  All all processors will have no GIDs.  This root map can then
             be used to create an importer or exporter that will migrate all data to the root processor.

             If root is set to -1 then the user map will be replicated completely on all processors.
        """
        return _Epetra.Util_Create_Root_Map(*args)

    @staticmethod
    def Create_OneToOne_Map(*args) -> "Epetra_Map":
        r"""
        Epetra_Util Create_OneToOne_Map function Function to create a new Epetra_Map object with 1-to-1 ownership of
           entries from an existing map which may have entries that appear on
           multiple processors.
        """
        return _Epetra.Util_Create_OneToOne_Map(*args)

    @staticmethod
    def Create_OneToOne_BlockMap(*args) -> "Epetra_BlockMap":
        r"""
        Epetra_Util Create_OneToOne_Map function Function to create a new Epetra_Map object with 1-to-1 ownership of
           entries from an existing map which may have entries that appear on
           multiple processors.
        """
        return _Epetra.Util_Create_OneToOne_BlockMap(*args)

    @staticmethod
    def Create_OneToOne_BlockMap64(*args) -> "Epetra_BlockMap":
        r"""
        Epetra_Util Create_OneToOne_Map function for long long ordinals Function to create a new Epetra_Map object with 1-to-1 ownership of
             entries from an existing map which may have entries that appear on
             multiple processors.
        """
        return _Epetra.Util_Create_OneToOne_BlockMap64(*args)

    @staticmethod
    def SortCrsEntries(*args) -> "int":
        r"""
        *Overload 1:*
        Epetra_Util SortCrsEntries function

        |

        *Overload 2:*
        Epetra_Util SortCrsEntries function
        """
        return _Epetra.Util_SortCrsEntries(*args)

    @staticmethod
    def SortAndMergeCrsEntries(*args) -> "int":
        r"""
        *Overload 1:*
        Epetra_Util SortAndMergeCrsEntries function

        |

        *Overload 2:*
        Epetra_Util SortAndMergeCrsEntries function
        """
        return _Epetra.Util_SortAndMergeCrsEntries(*args)

    @staticmethod
    def GetPidGidPairs(*args) -> "int":
        return _Epetra.Util_GetPidGidPairs(*args)

    @staticmethod
    def GetPids(*args) -> "int":
        r""" Epetra_Util GetPids function Like GetPidGidPairs, but just gets the PIDs, ordered by the columnmap"""
        return _Epetra.Util_GetPids(*args)

    @staticmethod
    def GetRemotePIDs(*args) -> "int":
        r""" Epetra_Util GetRemotePIDs Gets a list of remote PIDs from an importer in the order corresponding to the RemoteLIDs"""
        return _Epetra.Util_GetRemotePIDs(*args)

    @staticmethod
    def Chop(*args) -> "double":
        r""" Epetra_Util Chop method.  Return zero if input Value is less than ChopValue"""
        return _Epetra.Util_Chop(*args)

# Register Util in _Epetra:
_Epetra.Util_swigregister(Util)

def Util_Create_Root_Map(*args) -> "Epetra_Map":
    r"""
    Epetra_Util Create_Root_Map function Function to create a new Epetra_Map object with all GIDs sent to the root processor
         which is zero by default.  All all processors will have no GIDs.  This root map can then
         be used to create an importer or exporter that will migrate all data to the root processor.

         If root is set to -1 then the user map will be replicated completely on all processors.
    """
    return _Epetra.Util_Create_Root_Map(*args)

def Util_Create_OneToOne_Map(*args) -> "Epetra_Map":
    r"""
    Epetra_Util Create_OneToOne_Map function Function to create a new Epetra_Map object with 1-to-1 ownership of
       entries from an existing map which may have entries that appear on
       multiple processors.
    """
    return _Epetra.Util_Create_OneToOne_Map(*args)

def Util_Create_OneToOne_BlockMap(*args) -> "Epetra_BlockMap":
    r"""
    Epetra_Util Create_OneToOne_Map function Function to create a new Epetra_Map object with 1-to-1 ownership of
       entries from an existing map which may have entries that appear on
       multiple processors.
    """
    return _Epetra.Util_Create_OneToOne_BlockMap(*args)

def Util_Create_OneToOne_BlockMap64(*args) -> "Epetra_BlockMap":
    r"""
    Epetra_Util Create_OneToOne_Map function for long long ordinals Function to create a new Epetra_Map object with 1-to-1 ownership of
         entries from an existing map which may have entries that appear on
         multiple processors.
    """
    return _Epetra.Util_Create_OneToOne_BlockMap64(*args)

def Util_SortCrsEntries(*args) -> "int":
    r"""
    *Overload 1:*
    Epetra_Util SortCrsEntries function

    |

    *Overload 2:*
    Epetra_Util SortCrsEntries function
    """
    return _Epetra.Util_SortCrsEntries(*args)

def Util_SortAndMergeCrsEntries(*args) -> "int":
    r"""
    *Overload 1:*
    Epetra_Util SortAndMergeCrsEntries function

    |

    *Overload 2:*
    Epetra_Util SortAndMergeCrsEntries function
    """
    return _Epetra.Util_SortAndMergeCrsEntries(*args)

def Util_GetPidGidPairs(*args) -> "int":
    return _Epetra.Util_GetPidGidPairs(*args)

def Util_GetPids(*args) -> "int":
    r""" Epetra_Util GetPids function Like GetPidGidPairs, but just gets the PIDs, ordered by the columnmap"""
    return _Epetra.Util_GetPids(*args)

def Util_GetRemotePIDs(*args) -> "int":
    r""" Epetra_Util GetRemotePIDs Gets a list of remote PIDs from an importer in the order corresponding to the RemoteLIDs"""
    return _Epetra.Util_GetRemotePIDs(*args)

def Util_Chop(*args) -> "double":
    r""" Epetra_Util Chop method.  Return zero if input Value is less than ChopValue"""
    return _Epetra.Util_Chop(*args)
Util.chopVal_ = _Epetra.cvar.Util_chopVal_


def Epetra_Util_binary_search(*args) -> "int":
    return _Epetra.Epetra_Util_binary_search(*args)

def Epetra_Util_binary_search_aux(*args) -> "int":
    return _Epetra.Epetra_Util_binary_search_aux(*args)

def Epetra_Util_ExtractHbData(*args) -> "int":
    r"""
    Harwell-Boeing data extraction routine This routine will extract data from an existing Epetra_Crs Matrix, and
       optionally from related rhs and lhs objects in a form that is compatible with
       software that requires the Harwell-Boeing data format. The matrix must be passed
       in, but the RHS and LHS arguments may be set to zero (either or both of them).
       For each of the LHS or RHS arguments, if non-trivial and contain more than one vector, the
       vectors must have strided access.  If both LHS and RHS are non-trivial, they must have the
       same number of vectors.  If the input objects are distributed, the returned matrices will
       contain the local part of the matrix and vectors only.

       :type A: :py:class:`Epetra_CrsMatrix`
       :param A: (In) Epetra_CrsMatrix.
       :type LHS: :py:class:`Epetra_MultiVector`
       :param LHS: (In) Left hand side multivector.  Set to zero if none not available or needed.
       :type RHS: :py:class:`Epetra_MultiVector`
       :param RHS: (In) Right hand side multivector.  Set to zero if none not available or needed.
       :type M: int
       :param M: (Out) Local row dimension of matrix.
       :type N: int
       :param N: (Out) Local column dimension of matrix.
       :type nz: int
       :param nz: (Out) Number of nonzero entries in matrix.
       :type ptr: int
       :param ptr: (Out) Offsets into ind and val arrays pointing to start of each row's data.
       :type ind: int
       :param ind: (Out) Column indices of the matrix, in compressed form.
       :type val: float
       :param val: (Out) Matrix values, in compressed form corresponding to the ind array.
       :type Nrhs: int
       :param Nrhs: (Out) Number of right/left hand sides found (if any) in RHS and LHS.
       :type rhs: float
       :param rhs: (Out) Fortran-style 2D array of RHS values.
       :type ldrhs: int
       :param ldrhs: (Out) Stride between columns of rhs.
       :type lhs: float
       :param lhs: (Out) Fortran-style 2D array of LHS values.
       :type ldrhs: int
       :param ldrhs: (Out) Stride between columns of lhs.
    """
    return _Epetra.Epetra_Util_ExtractHbData(*args)


